// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.8.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __POISSON2D_5_H
#define __POISSON2D_5_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Poisson2D_5 {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 21;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[3] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][2];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][2];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[11] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][2];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][3];
      offset = offset + 4*mesh.noEdges();
      dofs[15] = offset + 6*cell.id() + 0;
      dofs[16] = offset + 6*cell.id() + 1;
      dofs[17] = offset + 6*cell.id() + 2;
      dofs[18] = offset + 6*cell.id() + 3;
      dofs[19] = offset + 6*cell.id() + 4;
      dofs[20] = offset + 6*cell.id() + 5;
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(8.000000000000000e-01, 2.000000000000000e-01);
      points[4] = map(6.000000000000000e-01, 4.000000000000000e-01);
      points[5] = map(4.000000000000000e-01, 6.000000000000000e-01);
      points[6] = map(2.000000000000000e-01, 8.000000000000000e-01);
      points[7] = map(0.000000000000000e+00, 8.000000000000000e-01);
      points[8] = map(0.000000000000000e+00, 6.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 4.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 2.000000000000000e-01);
      points[11] = map(2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(4.000000000000000e-01, 0.000000000000000e+00);
      points[13] = map(6.000000000000000e-01, 0.000000000000000e+00);
      points[14] = map(8.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(2.000000000000000e-01, 2.000000000000000e-01);
      points[16] = map(4.000000000000000e-01, 2.000000000000000e-01);
      points[17] = map(6.000000000000000e-01, 2.000000000000000e-01);
      points[18] = map(2.000000000000000e-01, 4.000000000000000e-01);
      points[19] = map(4.000000000000000e-01, 4.000000000000000e-01);
      points[20] = map(2.000000000000000e-01, 6.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
    }

  private:

    unsigned int* tensordims;

  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 21;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[3] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][2];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][2];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[11] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][2];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][3];
      offset = offset + 4*mesh.noEdges();
      dofs[15] = offset + 6*cell.id() + 0;
      dofs[16] = offset + 6*cell.id() + 1;
      dofs[17] = offset + 6*cell.id() + 2;
      dofs[18] = offset + 6*cell.id() + 3;
      dofs[19] = offset + 6*cell.id() + 4;
      dofs[20] = offset + 6*cell.id() + 5;
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(8.000000000000000e-01, 2.000000000000000e-01);
      points[4] = map(6.000000000000000e-01, 4.000000000000000e-01);
      points[5] = map(4.000000000000000e-01, 6.000000000000000e-01);
      points[6] = map(2.000000000000000e-01, 8.000000000000000e-01);
      points[7] = map(0.000000000000000e+00, 8.000000000000000e-01);
      points[8] = map(0.000000000000000e+00, 6.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 4.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 2.000000000000000e-01);
      points[11] = map(2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(4.000000000000000e-01, 0.000000000000000e+00);
      points[13] = map(6.000000000000000e-01, 0.000000000000000e+00);
      points[14] = map(8.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(2.000000000000000e-01, 2.000000000000000e-01);
      points[16] = map(4.000000000000000e-01, 2.000000000000000e-01);
      points[17] = map(6.000000000000000e-01, 2.000000000000000e-01);
      points[18] = map(2.000000000000000e-01, 4.000000000000000e-01);
      points[19] = map(4.000000000000000e-01, 4.000000000000000e-01);
      points[20] = map(2.000000000000000e-01, 6.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0_0 = map.det*(map.g00*map.g00 + map.g01*map.g01);
    real G0_0_1 = map.det*(map.g00*map.g10 + map.g01*map.g11);
    real G0_1_0 = map.det*(map.g10*map.g00 + map.g11*map.g01);
    real G0_1_1 = map.det*(map.g10*map.g10 + map.g11*map.g11);

    // Compute element tensor
    block[0] = 3.424065806878294e-01*G0_0_0 + 3.424065806878294e-01*G0_0_1 + 3.424065806878294e-01*G0_1_0 + 3.424065806878294e-01*G0_1_1;
    block[1] = -4.099840167548521e-02*G0_0_0 - 4.099840167548524e-02*G0_1_0;
    block[2] = -4.099840167548425e-02*G0_0_1 - 4.099840167548437e-02*G0_1_1;
    block[3] = -4.081927910052983e-02*G0_0_0 - 4.081927910052963e-02*G0_0_1 - 4.081927910052985e-02*G0_1_0 - 4.081927910052979e-02*G0_1_1;
    block[4] = -3.797743055555435e-02*G0_0_0 - 3.797743055555556e-02*G0_0_1 - 3.797743055555439e-02*G0_1_0 - 3.797743055555543e-02*G0_1_1;
    block[5] = -3.797743055555617e-02*G0_0_0 - 3.797743055555525e-02*G0_0_1 - 3.797743055555588e-02*G0_1_0 - 3.797743055555516e-02*G0_1_1;
    block[6] = -4.081927910052702e-02*G0_0_0 - 4.081927910052793e-02*G0_0_1 - 4.081927910052731e-02*G0_1_0 - 4.081927910052799e-02*G0_1_1;
    block[7] = 4.081927910052703e-02*G0_0_0 + 2.023740630511445e-01*G0_0_1 + 4.081927910052731e-02*G0_1_0 + 2.023740630511447e-01*G0_1_1;
    block[8] = -6.966834766313765e-02*G0_0_0 - 4.499593529541423e-01*G0_0_1 - 6.966834766313793e-02*G0_1_0 - 4.499593529541425e-01*G0_1_1;
    block[9] = -1.584545855379262e-02*G0_0_0 + 5.942046957671926e-01*G0_0_1 - 1.584545855379269e-02*G0_1_0 + 5.942046957671928e-01*G0_1_1;
    block[10] = 2.022879464285713e-01*G0_0_0 - 6.480275848765403e-01*G0_0_1 + 2.022879464285712e-01*G0_1_0 - 6.480275848765402e-01*G0_1_1;
    block[11] = -6.480275848765409e-01*G0_0_0 + 2.022879464285707e-01*G0_0_1 - 6.480275848765407e-01*G0_1_0 + 2.022879464285709e-01*G0_1_1;
    block[12] = 5.942046957671940e-01*G0_0_0 - 1.584545855379204e-02*G0_0_1 + 5.942046957671935e-01*G0_1_0 - 1.584545855379215e-02*G0_1_1;
    block[13] = -4.499593529541432e-01*G0_0_0 - 6.966834766313920e-02*G0_0_1 - 4.499593529541430e-01*G0_1_0 - 6.966834766313955e-02*G0_1_1;
    block[14] = 2.023740630511460e-01*G0_0_0 + 4.081927910053006e-02*G0_0_1 + 2.023740630511460e-01*G0_1_0 + 4.081927910053022e-02*G0_1_1;
    block[15] = -2.152915564373899e-01*G0_0_0 - 2.152915564373900e-01*G0_0_1 - 2.152915564373895e-01*G0_1_0 - 2.152915564373903e-01*G0_1_1;
    block[16] = -5.382288910934691e-02*G0_0_0 - 5.382288910934632e-02*G0_0_1 - 5.382288910934748e-02*G0_1_0 - 5.382288910934582e-02*G0_1_1;
    block[17] = 1.076457782186951e-01*G0_0_0 + 1.076457782186941e-01*G0_0_1 + 1.076457782186954e-01*G0_1_0 + 1.076457782186943e-01*G0_1_1;
    block[18] = -5.382288910934677e-02*G0_0_0 - 5.382288910934564e-02*G0_0_1 - 5.382288910934628e-02*G0_1_0 - 5.382288910934570e-02*G0_1_1;
    block[19] = 1.076457782186939e-01*G0_0_0 + 1.076457782186938e-01*G0_0_1 + 1.076457782186935e-01*G0_1_0 + 1.076457782186933e-01*G0_1_1;
    block[20] = 1.076457782186938e-01*G0_0_0 + 1.076457782186933e-01*G0_0_1 + 1.076457782186938e-01*G0_1_0 + 1.076457782186934e-01*G0_1_1;
    block[21] = -4.099840167548521e-02*G0_0_0 - 4.099840167548525e-02*G0_0_1;
    block[22] = 3.424065806878293e-01*G0_0_0;
    block[23] = 4.099840167548488e-02*G0_0_1;
    block[24] = 2.022879464285698e-01*G0_0_0 + 8.503155313051103e-01*G0_0_1;
    block[25] = -1.584545855379122e-02*G0_0_0 - 6.100501543209855e-01*G0_0_1;
    block[26] = -6.966834766313947e-02*G0_0_0 + 3.802910052910045e-01*G0_0_1;
    block[27] = 4.081927910052885e-02*G0_0_0 - 1.615547839506172e-01*G0_0_1;
    block[28] = -4.081927910052884e-02*G0_0_0;
    block[29] = -3.797743055555515e-02*G0_0_0;
    block[30] = -3.797743055555601e-02*G0_0_0;
    block[31] = -4.081927910052859e-02*G0_0_0;
    block[32] = 2.023740630511465e-01*G0_0_0 + 1.615547839506165e-01*G0_0_1;
    block[33] = -4.499593529541443e-01*G0_0_0 - 3.802910052910035e-01*G0_0_1;
    block[34] = 5.942046957671945e-01*G0_0_0 + 6.100501543209849e-01*G0_0_1;
    block[35] = -6.480275848765408e-01*G0_0_0 - 8.503155313051103e-01*G0_0_1;
    block[36] = 1.076457782186938e-01*G0_0_0;
    block[37] = -5.382288910934679e-02*G0_0_0;
    block[38] = -2.152915564373883e-01*G0_0_0;
    block[39] = 1.076457782186954e-01*G0_0_0;
    block[40] = -5.382288910934806e-02*G0_0_0;
    block[41] = 1.076457782186947e-01*G0_0_0;
    block[42] = -4.099840167548425e-02*G0_1_0 - 4.099840167548437e-02*G0_1_1;
    block[43] = 4.099840167548487e-02*G0_1_0;
    block[44] = 3.424065806878295e-01*G0_1_1;
    block[45] = -1.615547839506165e-01*G0_1_0 + 4.081927910052926e-02*G0_1_1;
    block[46] = 3.802910052910036e-01*G0_1_0 - 6.966834766313962e-02*G0_1_1;
    block[47] = -6.100501543209851e-01*G0_1_0 - 1.584545855379101e-02*G0_1_1;
    block[48] = 8.503155313051117e-01*G0_1_0 + 2.022879464285704e-01*G0_1_1;
    block[49] = -8.503155313051117e-01*G0_1_0 - 6.480275848765411e-01*G0_1_1;
    block[50] = 6.100501543209853e-01*G0_1_0 + 5.942046957671929e-01*G0_1_1;
    block[51] = -3.802910052910039e-01*G0_1_0 - 4.499593529541417e-01*G0_1_1;
    block[52] = 1.615547839506165e-01*G0_1_0 + 2.023740630511443e-01*G0_1_1;
    block[53] = -4.081927910052818e-02*G0_1_1;
    block[54] = -3.797743055555532e-02*G0_1_1;
    block[55] = -3.797743055555497e-02*G0_1_1;
    block[56] = -4.081927910052892e-02*G0_1_1;
    block[57] = 1.076457782186939e-01*G0_1_1;
    block[58] = 1.076457782186951e-01*G0_1_1;
    block[59] = 1.076457782186941e-01*G0_1_1;
    block[60] = -5.382288910934951e-02*G0_1_1;
    block[61] = -5.382288910934826e-02*G0_1_1;
    block[62] = -2.152915564373862e-01*G0_1_1;
    block[63] = -4.081927910052983e-02*G0_0_0 - 4.081927910052986e-02*G0_0_1 - 4.081927910052963e-02*G0_1_0 - 4.081927910052979e-02*G0_1_1;
    block[64] = 2.022879464285698e-01*G0_0_0 + 8.503155313051102e-01*G0_1_0;
    block[65] = -1.615547839506165e-01*G0_0_1 + 4.081927910052925e-02*G0_1_1;
    block[66] = 1.989293981481470e+00*G0_0_0 + 1.280984760802461e+00*G0_0_1 + 1.280984760802461e+00*G0_1_0 + 2.561969521604925e+00*G0_1_1;
    block[67] = -9.063774526014059e-01*G0_0_0 + 7.965787588183392e-01*G0_0_1 - 5.296172288359746e-01*G0_1_0 - 1.395089285714280e+00*G0_1_1;
    block[68] = 8.181079144620748e-01*G0_0_0 - 4.822530864197527e-01*G0_0_1 + 2.325148809523778e-01*G0_1_0 + 8.956128747795387e-01*G0_1_1;
    block[69] = -3.401606591710746e-01*G0_0_0 + 3.293960813492032e-01*G0_0_1 - 7.104621362433827e-02*G0_1_0 - 3.401606591710762e-01*G0_1_1;
    block[70] = 3.401606591710746e-01*G0_0_0 + 7.104621362433790e-02*G0_0_1 + 7.104621362433826e-02*G0_1_0;
    block[71] = 1.722332451499119e-01*G0_0_0 + 3.014081790123571e-02*G0_0_1 + 3.014081790123732e-02*G0_1_0;
    block[72] = 1.313278494268066e-01*G0_0_0 + 3.014081790123366e-02*G0_0_1 + 3.014081790123211e-02*G0_1_0;
    block[73] = 1.420924272486759e-01*G0_0_0 + 7.104621362433942e-02*G0_0_1 + 7.104621362434022e-02*G0_1_0;
    block[74] = 1.980682319224008e-01*G0_0_0 + 2.691144455467353e-01*G0_0_1 + 2.691144455467386e-01*G0_1_0 + 3.401606591710744e-01*G0_1_1;
    block[75] = -3.595368992504428e-01*G0_0_0 - 6.630979938271563e-01*G0_0_1 - 6.630979938271616e-01*G0_1_0 - 8.956128747795363e-01*G0_1_1;
    block[76] = 2.863377700617293e-01*G0_0_0 + 8.654720568783028e-01*G0_0_1 + 8.654720568783054e-01*G0_1_0 + 1.395089285714279e+00*G0_1_1;
    block[77] = -2.863377700617274e-01*G0_0_0 - 1.280984760802461e+00*G0_0_1 - 1.280984760802463e+00*G0_1_0 - 2.561969521604924e+00*G0_1_1;
    block[78] = -6.674038249559060e-01*G0_0_0 - 2.626556988536168e-01*G0_0_1 - 2.626556988536190e-01*G0_1_0;
    block[79] = 1.356336805555554e+00*G0_0_0 + 5.726755401234562e-01*G0_0_1 + 5.726755401234594e-01*G0_1_0;
    block[80] = -2.820319389329794e+00*G0_0_0 - 1.662050815696644e+00*G0_0_1 - 1.662050815696642e+00*G0_1_0;
    block[81] = -4.198185350529082e-01*G0_0_0 - 7.319912918870945e-02*G0_0_1 - 7.319912918870990e-02*G0_1_0;
    block[82] = 1.194868138227508e+00*G0_0_0 + 5.726755401234556e-01*G0_0_1 + 5.726755401234528e-01*G0_1_0;
    block[83] = -9.903411596119855e-01*G0_0_0 - 2.626556988536141e-01*G0_0_1 - 2.626556988536145e-01*G0_1_0;
    block[84] = -3.797743055555435e-02*G0_0_0 - 3.797743055555439e-02*G0_0_1 - 3.797743055555557e-02*G0_1_0 - 3.797743055555543e-02*G0_1_1;
    block[85] = -1.584545855379122e-02*G0_0_0 - 6.100501543209855e-01*G0_1_0;
    block[86] = 3.802910052910037e-01*G0_0_1 - 6.966834766313959e-02*G0_1_1;
    block[87] = -9.063774526014059e-01*G0_0_0 - 5.296172288359746e-01*G0_0_1 + 7.965787588183390e-01*G0_1_0 - 1.395089285714280e+00*G0_1_1;
    block[88] = 3.074363425925910e+00*G0_0_0 + 1.175491898148140e+00*G0_0_1 + 1.175491898148140e+00*G0_1_0 + 3.694403108465592e+00*G0_1_1;
    block[89] = -1.804143242945316e+00*G0_0_0 + 6.996975584215155e-01*G0_0_1 - 3.509252369929422e-01*G0_1_0 - 1.804143242945320e+00*G0_1_1;
    block[90] = 8.956128747795369e-01*G0_0_0 - 4.822530864197510e-01*G0_0_1 + 2.325148809523782e-01*G0_1_0 + 8.181079144620771e-01*G0_1_1;
    block[91] = -8.956128747795373e-01*G0_0_0 - 2.325148809523805e-01*G0_0_1 - 2.325148809523785e-01*G0_1_0 + 7.104621362433763e-02*G0_1_1;
    block[92] = -2.195973875661379e-01*G0_0_0 - 6.243455136684385e-02*G0_0_1 - 6.243455136684591e-02*G0_1_0 - 1.722332451499059e-02*G0_1_1;
    block[93] = -2.971023478835940e-01*G0_0_0 - 1.485511739417971e-01*G0_0_1 - 1.485511739417943e-01*G0_1_0 - 1.722332451499207e-02*G0_1_1;
    block[94] = 1.313278494268069e-01*G0_0_0 + 1.011870315255713e-01*G0_0_1 + 1.011870315255695e-01*G0_1_0 + 7.104621362433880e-02*G0_1_1;
    block[95] = 1.119516093474378e-01*G0_0_0 + 1.420924272486754e-01*G0_0_1 + 1.420924272486749e-01*G0_1_0 + 1.722332451499083e-01*G0_1_1;
    block[96] = -1.119516093474380e-01*G0_0_0 - 1.571628361992946e-01*G0_0_1 - 1.571628361992905e-01*G0_1_0 - 2.195973875661371e-01*G0_1_1;
    block[97] = 1.033399470899451e-01*G0_0_0 + 1.334807649911812e-01*G0_0_1 + 1.334807649911791e-01*G0_1_0 + 2.669615299823618e-01*G0_1_1;
    block[98] = -4.951705798059945e-02*G0_0_0 + 5.296172288359746e-01*G0_0_1 + 5.296172288359774e-01*G0_1_0 + 1.395089285714279e+00*G0_1_1;
    block[99] = -3.444664902998180e-01*G0_0_0 - 4.478064373897621e-01*G0_0_1 - 4.478064373897627e-01*G0_1_0 - 5.166997354497249e-01*G0_1_1;
    block[100] = 3.875248015872929e-01*G0_0_0 + 8.590133101851806e-01*G0_0_1 + 8.590133101851778e-01*G0_1_0 + 1.011870315255729e+00*G0_1_1;
    block[101] = 7.319912918871251e-01*G0_0_0 - 1.308972663139321e+00*G0_0_1 - 1.308972663139323e+00*G0_1_0 - 3.961364638447956e+00*G0_1_1;
    block[102] = 1.033399470899460e+00*G0_0_0 + 3.746073082010477e-01*G0_0_1 + 3.746073082010498e-01*G0_1_0 + 4.305831128746818e-02*G0_1_1;
    block[103] = -3.810660548941777e+00*G0_0_0 - 1.401548032407401e+00*G0_0_1 - 1.401548032407396e+00*G0_1_0 + 1.011870315255732e+00*G0_1_1;
    block[104] = 2.023740630511453e+00*G0_0_0 + 4.133597883597905e-01*G0_0_1 + 4.133597883597881e-01*G0_1_0 - 5.166997354497292e-01*G0_1_1;
    block[105] = -3.797743055555617e-02*G0_0_0 - 3.797743055555587e-02*G0_0_1 - 3.797743055555525e-02*G0_1_0 - 3.797743055555516e-02*G0_1_1;
    block[106] = -6.966834766313948e-02*G0_0_0 + 3.802910052910045e-01*G0_1_0;
    block[107] = -6.100501543209851e-01*G0_0_1 - 1.584545855379101e-02*G0_1_1;
    block[108] = 8.181079144620745e-01*G0_0_0 + 2.325148809523778e-01*G0_0_1 - 4.822530864197526e-01*G0_1_0 + 8.956128747795387e-01*G0_1_1;
    block[109] = -1.804143242945315e+00*G0_0_0 - 3.509252369929423e-01*G0_0_1 + 6.996975584215154e-01*G0_1_0 - 1.804143242945320e+00*G0_1_1;
    block[110] = 3.694403108465590e+00*G0_0_0 + 1.175491898148141e+00*G0_0_1 + 1.175491898148141e+00*G0_1_0 + 3.074363425925913e+00*G0_1_1;
    block[111] = -1.395089285714280e+00*G0_0_0 + 7.965787588183380e-01*G0_0_1 - 5.296172288359750e-01*G0_1_0 - 9.063774526014069e-01*G0_1_1;
    block[112] = 1.395089285714280e+00*G0_0_0 + 5.296172288359773e-01*G0_0_1 + 5.296172288359751e-01*G0_1_0 - 4.951705798059892e-02*G0_1_1;
    block[113] = 2.669615299823639e-01*G0_0_0 + 1.334807649911821e-01*G0_0_1 + 1.334807649911841e-01*G0_1_0 + 1.033399470899455e-01*G0_1_1;
    block[114] = -2.195973875661370e-01*G0_0_0 - 1.571628361992941e-01*G0_0_1 - 1.571628361992948e-01*G0_1_0 - 1.119516093474403e-01*G0_1_1;
    block[115] = 1.722332451499113e-01*G0_0_0 + 1.420924272486772e-01*G0_0_1 + 1.420924272486785e-01*G0_1_0 + 1.119516093474411e-01*G0_1_1;
    block[116] = 7.104621362433999e-02*G0_0_0 + 1.011870315255713e-01*G0_0_1 + 1.011870315255724e-01*G0_1_0 + 1.313278494268066e-01*G0_1_1;
    block[117] = -1.722332451499100e-02*G0_0_0 - 1.485511739417978e-01*G0_0_1 - 1.485511739417985e-01*G0_1_0 - 2.971023478835964e-01*G0_1_1;
    block[118] = -1.722332451499257e-02*G0_0_0 - 6.243455136684492e-02*G0_0_1 - 6.243455136684232e-02*G0_1_0 - 2.195973875661371e-01*G0_1_1;
    block[119] = 7.104621362433873e-02*G0_0_0 - 2.325148809523781e-01*G0_0_1 - 2.325148809523813e-01*G0_1_0 - 8.956128747795382e-01*G0_1_1;
    block[120] = -5.166997354497377e-01*G0_0_0 - 4.478064373897706e-01*G0_0_1 - 4.478064373897721e-01*G0_1_0 - 3.444664902998231e-01*G0_1_1;
    block[121] = 4.305831128748049e-02*G0_0_0 + 3.746073082010544e-01*G0_0_1 + 3.746073082010556e-01*G0_1_0 + 1.033399470899462e+00*G0_1_1;
    block[122] = -5.166997354497299e-01*G0_0_0 + 4.133597883597885e-01*G0_0_1 + 4.133597883597905e-01*G0_1_0 + 2.023740630511458e+00*G0_1_1;
    block[123] = 1.011870315255732e+00*G0_0_0 + 8.590133101851897e-01*G0_0_1 + 8.590133101851825e-01*G0_1_0 + 3.875248015873047e-01*G0_1_1;
    block[124] = 1.011870315255722e+00*G0_0_0 - 1.401548032407399e+00*G0_0_1 - 1.401548032407402e+00*G0_1_0 - 3.810660548941781e+00*G0_1_1;
    block[125] = -3.961364638447954e+00*G0_0_0 - 1.308972663139330e+00*G0_0_1 - 1.308972663139326e+00*G0_1_0 + 7.319912918871181e-01*G0_1_1;
    block[126] = -4.081927910052702e-02*G0_0_0 - 4.081927910052732e-02*G0_0_1 - 4.081927910052792e-02*G0_1_0 - 4.081927910052798e-02*G0_1_1;
    block[127] = 4.081927910052885e-02*G0_0_0 - 1.615547839506172e-01*G0_1_0;
    block[128] = 8.503155313051116e-01*G0_0_1 + 2.022879464285704e-01*G0_1_1;
    block[129] = -3.401606591710746e-01*G0_0_0 - 7.104621362433827e-02*G0_0_1 + 3.293960813492033e-01*G0_1_0 - 3.401606591710762e-01*G0_1_1;
    block[130] = 8.956128747795370e-01*G0_0_0 + 2.325148809523782e-01*G0_0_1 - 4.822530864197510e-01*G0_1_0 + 8.181079144620770e-01*G0_1_1;
    block[131] = -1.395089285714280e+00*G0_0_0 - 5.296172288359750e-01*G0_0_1 + 7.965787588183381e-01*G0_1_0 - 9.063774526014068e-01*G0_1_1;
    block[132] = 2.561969521604929e+00*G0_0_0 + 1.280984760802464e+00*G0_0_1 + 1.280984760802464e+00*G0_1_0 + 1.989293981481471e+00*G0_1_1;
    block[133] = -2.561969521604930e+00*G0_0_0 - 1.280984760802466e+00*G0_0_1 - 1.280984760802464e+00*G0_1_0 - 2.863377700617283e-01*G0_1_1;
    block[134] = 1.395089285714280e+00*G0_0_0 + 8.654720568783008e-01*G0_0_1 + 8.654720568783030e-01*G0_1_0 + 2.863377700617262e-01*G0_1_1;
    block[135] = -8.956128747795369e-01*G0_0_0 - 6.630979938271530e-01*G0_0_1 - 6.630979938271564e-01*G0_1_0 - 3.595368992504363e-01*G0_1_1;
    block[136] = 3.401606591710727e-01*G0_0_0 + 2.691144455467317e-01*G0_0_1 + 2.691144455467338e-01*G0_1_0 + 1.980682319223950e-01*G0_1_1;
    block[137] = 7.104621362434047e-02*G0_0_1 + 7.104621362433676e-02*G0_1_0 + 1.420924272486772e-01*G0_1_1;
    block[138] = 3.014081790123480e-02*G0_0_1 + 3.014081790123598e-02*G0_1_0 + 1.313278494268077e-01*G0_1_1;
    block[139] = 3.014081790123567e-02*G0_0_1 + 3.014081790123283e-02*G0_1_0 + 1.722332451499104e-01*G0_1_1;
    block[140] = 7.104621362433906e-02*G0_0_1 + 7.104621362433985e-02*G0_1_0 + 3.401606591710762e-01*G0_1_1;
    block[141] = -2.626556988536157e-01*G0_0_1 - 2.626556988536108e-01*G0_1_0 - 6.674038249559059e-01*G0_1_1;
    block[142] = -7.319912918871108e-02*G0_0_1 - 7.319912918871338e-02*G0_1_0 - 4.198185350529074e-01*G0_1_1;
    block[143] = -2.626556988536155e-01*G0_0_1 - 2.626556988536131e-01*G0_1_0 - 9.903411596119884e-01*G0_1_1;
    block[144] = 5.726755401234486e-01*G0_0_1 + 5.726755401234513e-01*G0_1_0 + 1.356336805555548e+00*G0_1_1;
    block[145] = 5.726755401234529e-01*G0_0_1 + 5.726755401234559e-01*G0_1_0 + 1.194868138227507e+00*G0_1_1;
    block[146] = -1.662050815696635e+00*G0_0_1 - 1.662050815696640e+00*G0_1_0 - 2.820319389329789e+00*G0_1_1;
    block[147] = 4.081927910052703e-02*G0_0_0 + 4.081927910052731e-02*G0_0_1 + 2.023740630511444e-01*G0_1_0 + 2.023740630511447e-01*G0_1_1;
    block[148] = -4.081927910052884e-02*G0_0_0;
    block[149] = -8.503155313051117e-01*G0_0_1 - 6.480275848765411e-01*G0_1_1;
    block[150] = 3.401606591710746e-01*G0_0_0 + 7.104621362433826e-02*G0_0_1 + 7.104621362433791e-02*G0_1_0;
    block[151] = -8.956128747795375e-01*G0_0_0 - 2.325148809523785e-01*G0_0_1 - 2.325148809523805e-01*G0_1_0 + 7.104621362433761e-02*G0_1_1;
    block[152] = 1.395089285714280e+00*G0_0_0 + 5.296172288359751e-01*G0_0_1 + 5.296172288359774e-01*G0_1_0 - 4.951705798059887e-02*G0_1_1;
    block[153] = -2.561969521604930e+00*G0_0_0 - 1.280984760802464e+00*G0_0_1 - 1.280984760802466e+00*G0_1_0 - 2.863377700617283e-01*G0_1_1;
    block[154] = 2.561969521604931e+00*G0_0_0 + 1.280984760802466e+00*G0_0_1 + 1.280984760802466e+00*G0_1_0 + 1.989293981481474e+00*G0_1_1;
    block[155] = -1.395089285714281e+00*G0_0_0 - 8.654720568783013e-01*G0_0_1 - 2.191668044532620e+00*G0_1_0 - 2.568428268298048e+00*G0_1_1;
    block[156] = 8.956128747795373e-01*G0_0_0 + 6.630979938271531e-01*G0_0_1 + 1.377865961199289e+00*G0_1_0 + 1.963458994708984e+00*G0_1_1;
    block[157] = -3.401606591710730e-01*G0_0_0 - 2.691144455467318e-01*G0_0_1 - 6.695567405202791e-01*G0_1_0 - 9.386711860670128e-01*G0_1_1;
    block[158] = -7.104621362434062e-02*G0_0_1 - 7.104621362433722e-02*G0_1_0 + 1.980682319223959e-01*G0_1_1;
    block[159] = -3.014081790123477e-02*G0_0_1 - 3.014081790123389e-02*G0_1_0 + 1.119516093474421e-01*G0_1_1;
    block[160] = -3.014081790123597e-02*G0_0_1 - 3.014081790123516e-02*G0_1_0 + 7.104621362433697e-02*G0_1_1;
    block[161] = -7.104621362433905e-02*G0_0_1 - 7.104621362433826e-02*G0_1_0;
    block[162] = 2.626556988536162e-01*G0_0_1 + 2.626556988536126e-01*G0_1_0 - 4.650297619047578e-01*G0_1_1;
    block[163] = 7.319912918871095e-02*G0_0_1 + 7.319912918871264e-02*G0_1_0 - 2.734202766754843e-01*G0_1_1;
    block[164] = 2.626556988536161e-01*G0_0_1 + 2.626556988536165e-01*G0_1_0 - 1.420924272486737e-01*G0_1_1;
    block[165] = -5.726755401234488e-01*G0_0_1 - 5.726755401234531e-01*G0_1_0 + 4.951705798060216e-02*G0_1_1;
    block[166] = -5.726755401234528e-01*G0_0_1 - 5.726755401234565e-01*G0_1_0 + 2.109857253086402e-01*G0_1_1;
    block[167] = 1.662050815696635e+00*G0_0_1 + 1.662050815696642e+00*G0_1_0 + 5.037822420634881e-01*G0_1_1;
    block[168] = -6.966834766313765e-02*G0_0_0 - 6.966834766313793e-02*G0_0_1 - 4.499593529541423e-01*G0_1_0 - 4.499593529541425e-01*G0_1_1;
    block[169] = -3.797743055555516e-02*G0_0_0;
    block[170] = 6.100501543209854e-01*G0_0_1 + 5.942046957671929e-01*G0_1_1;
    block[171] = 1.722332451499119e-01*G0_0_0 + 3.014081790123733e-02*G0_0_1 + 3.014081790123574e-02*G0_1_0;
    block[172] = -2.195973875661380e-01*G0_0_0 - 6.243455136684591e-02*G0_0_1 - 6.243455136684380e-02*G0_1_0 - 1.722332451499062e-02*G0_1_1;
    block[173] = 2.669615299823639e-01*G0_0_0 + 1.334807649911841e-01*G0_0_1 + 1.334807649911820e-01*G0_1_0 + 1.033399470899456e-01*G0_1_1;
    block[174] = 1.395089285714280e+00*G0_0_0 + 8.654720568783029e-01*G0_0_1 + 8.654720568783008e-01*G0_1_0 + 2.863377700617262e-01*G0_1_1;
    block[175] = -1.395089285714281e+00*G0_0_0 - 2.191668044532620e+00*G0_0_1 - 8.654720568783012e-01*G0_1_0 - 2.568428268298048e+00*G0_1_1;
    block[176] = 3.694403108465596e+00*G0_0_0 + 2.518911210317449e+00*G0_0_1 + 2.518911210317449e+00*G0_1_0 + 4.417782738095221e+00*G0_1_1;
    block[177] = -1.804143242945319e+00*G0_0_0 - 1.453218005952371e+00*G0_0_1 - 2.503840801366831e+00*G0_1_0 - 3.957058807319207e+00*G0_1_1;
    block[178] = 8.181079144620762e-01*G0_0_0 + 5.855930335096939e-01*G0_0_1 + 1.300361000881828e+00*G0_1_0 + 1.963458994708985e+00*G0_1_1;
    block[179] = 7.104621362433686e-02*G0_0_0 + 3.035610945767204e-01*G0_0_1 + 3.035610945767182e-01*G0_1_0 - 3.595368992504386e-01*G0_1_1;
    block[180] = -1.722332451499217e-02*G0_0_0 + 4.521122685185022e-02*G0_0_1 + 4.521122685185056e-02*G0_1_0 - 1.119516093474419e-01*G0_1_1;
    block[181] = -1.722332451499030e-02*G0_0_0 + 1.313278494268086e-01*G0_0_1 + 1.313278494268084e-01*G0_1_0 - 1.722332451498960e-02*G0_1_1;
    block[182] = 7.104621362433812e-02*G0_0_0 - 3.014081790123611e-02*G0_0_1 - 3.014081790123541e-02*G0_1_0;
    block[183] = -5.166997354497305e-01*G0_0_0 - 9.300595238095226e-01*G0_0_1 - 9.300595238095188e-01*G0_1_0 + 6.803213183421500e-01*G0_1_1;
    block[184] = 4.305831128747738e-02*G0_0_0 - 3.315489969135771e-01*G0_0_1 - 3.315489969135799e-01*G0_1_0 + 3.272431657848299e-01*G0_1_1;
    block[185] = -5.166997354497359e-01*G0_0_0 - 6.889329805996444e-02*G0_0_1 - 6.889329805996675e-02*G0_1_0 + 3.444664902998033e-02*G0_1_1;
    block[186] = 1.011870315255724e+00*G0_0_0 + 2.413418347663128e+00*G0_0_1 + 2.413418347663128e+00*G0_1_0 + 4.305831128741999e-03*G0_1_1;
    block[187] = 1.011870315255734e+00*G0_0_0 + 1.528570050705441e-01*G0_0_1 + 1.528570050705489e-01*G0_1_0 - 3.186315035273328e-01*G0_1_1;
    block[188] = -3.961364638447959e+00*G0_0_0 - 2.652391975308626e+00*G0_0_1 - 2.652391975308631e+00*G0_1_0 - 6.114280202821805e-01*G0_1_1;
    block[189] = -1.584545855379261e-02*G0_0_0 - 1.584545855379269e-02*G0_0_1 + 5.942046957671925e-01*G0_1_0 + 5.942046957671928e-01*G0_1_1;
    block[190] = -3.797743055555600e-02*G0_0_0;
    block[191] = -3.802910052910039e-01*G0_0_1 - 4.499593529541417e-01*G0_1_1;
    block[192] = 1.313278494268066e-01*G0_0_0 + 3.014081790123211e-02*G0_0_1 + 3.014081790123364e-02*G0_1_0;
    block[193] = -2.971023478835940e-01*G0_0_0 - 1.485511739417943e-01*G0_0_1 - 1.485511739417970e-01*G0_1_0 - 1.722332451499205e-02*G0_1_1;
    block[194] = -2.195973875661371e-01*G0_0_0 - 1.571628361992949e-01*G0_0_1 - 1.571628361992941e-01*G0_1_0 - 1.119516093474403e-01*G0_1_1;
    block[195] = -8.956128747795368e-01*G0_0_0 - 6.630979938271564e-01*G0_0_1 - 6.630979938271530e-01*G0_1_0 - 3.595368992504364e-01*G0_1_1;
    block[196] = 8.956128747795373e-01*G0_0_0 + 1.377865961199289e+00*G0_0_1 + 6.630979938271533e-01*G0_1_0 + 1.963458994708984e+00*G0_1_1;
    block[197] = -1.804143242945319e+00*G0_0_0 - 2.503840801366831e+00*G0_0_1 - 1.453218005952371e+00*G0_1_0 - 3.957058807319207e+00*G0_1_1;
    block[198] = 3.074363425925910e+00*G0_0_0 + 1.898871527777765e+00*G0_0_1 + 1.898871527777765e+00*G0_1_0 + 4.417782738095219e+00*G0_1_1;
    block[199] = -9.063774526014037e-01*G0_0_0 - 3.767602237654269e-01*G0_0_1 - 1.702956211419746e+00*G0_1_0 - 2.568428268298047e+00*G0_1_1;
    block[200] = -4.951705798059703e-02*G0_0_0 - 5.791342868165748e-01*G0_0_1 - 5.791342868165757e-01*G0_1_0 + 2.863377700617263e-01*G0_1_1;
    block[201] = 1.033399470899444e-01*G0_0_0 - 3.014081790123533e-02*G0_0_1 - 3.014081790123372e-02*G0_1_0 + 1.033399470899460e-01*G0_1_1;
    block[202] = -1.119516093474404e-01*G0_0_0 + 4.521122685185237e-02*G0_0_1 + 4.521122685185061e-02*G0_1_0 - 1.722332451499261e-02*G0_1_1;
    block[203] = 1.119516093474418e-01*G0_0_0 - 3.014081790123248e-02*G0_0_1 - 3.014081790123358e-02*G0_1_0;
    block[204] = 7.319912918871164e-01*G0_0_0 + 2.040963955026442e+00*G0_0_1 + 2.040963955026446e+00*G0_1_0 - 6.114280202821872e-01*G0_1_1;
    block[205] = 3.875248015873033e-01*G0_0_0 - 4.714885085978788e-01*G0_0_1 - 4.714885085978803e-01*G0_1_0 - 3.186315035273335e-01*G0_1_1;
    block[206] = -3.444664902998216e-01*G0_0_0 + 1.033399470899426e-01*G0_0_1 + 1.033399470899480e-01*G0_1_0 + 3.444664902998380e-02*G0_1_1;
    block[207] = -3.810660548941774e+00*G0_0_0 - 2.409112516534374e+00*G0_0_1 - 2.409112516534379e+00*G0_1_0 + 4.305831128755433e-03*G0_1_1;
    block[208] = 1.033399470899457e+00*G0_0_0 + 6.587921626984083e-01*G0_0_1 + 6.587921626984081e-01*G0_1_0 + 3.272431657848276e-01*G0_1_1;
    block[209] = 2.023740630511456e+00*G0_0_0 + 1.610380842151662e+00*G0_0_1 + 1.610380842151666e+00*G0_1_0 + 6.803213183421434e-01*G0_1_1;
    block[210] = 2.022879464285713e-01*G0_0_0 + 2.022879464285712e-01*G0_0_1 - 6.480275848765403e-01*G0_1_0 - 6.480275848765402e-01*G0_1_1;
    block[211] = -4.081927910052859e-02*G0_0_0;
    block[212] = 1.615547839506165e-01*G0_0_1 + 2.023740630511443e-01*G0_1_1;
    block[213] = 1.420924272486759e-01*G0_0_0 + 7.104621362434022e-02*G0_0_1 + 7.104621362433941e-02*G0_1_0;
    block[214] = 1.313278494268069e-01*G0_0_0 + 1.011870315255695e-01*G0_0_1 + 1.011870315255713e-01*G0_1_0 + 7.104621362433880e-02*G0_1_1;
    block[215] = 1.722332451499113e-01*G0_0_0 + 1.420924272486785e-01*G0_0_1 + 1.420924272486772e-01*G0_1_0 + 1.119516093474412e-01*G0_1_1;
    block[216] = 3.401606591710727e-01*G0_0_0 + 2.691144455467338e-01*G0_0_1 + 2.691144455467317e-01*G0_1_0 + 1.980682319223950e-01*G0_1_1;
    block[217] = -3.401606591710729e-01*G0_0_0 - 6.695567405202791e-01*G0_0_1 - 2.691144455467318e-01*G0_1_0 - 9.386711860670128e-01*G0_1_1;
    block[218] = 8.181079144620761e-01*G0_0_0 + 1.300361000881828e+00*G0_0_1 + 5.855930335096939e-01*G0_1_0 + 1.963458994708985e+00*G0_1_1;
    block[219] = -9.063774526014037e-01*G0_0_0 - 1.702956211419745e+00*G0_0_1 - 3.767602237654269e-01*G0_1_0 - 2.568428268298047e+00*G0_1_1;
    block[220] = 1.989293981481474e+00*G0_0_0 + 7.083092206790089e-01*G0_0_1 + 7.083092206790090e-01*G0_1_0 + 1.989293981481471e+00*G0_1_1;
    block[221] = -2.863377700617282e-01*G0_0_0 + 9.946469907407374e-01*G0_0_1 + 9.946469907407364e-01*G0_1_0 - 2.863377700617267e-01*G0_1_1;
    block[222] = 2.863377700617273e-01*G0_0_0 - 5.791342868165783e-01*G0_0_1 - 5.791342868165769e-01*G0_1_0 - 4.951705798059926e-02*G0_1_1;
    block[223] = -3.595368992504386e-01*G0_0_0 + 3.035610945767201e-01*G0_0_1 + 3.035610945767194e-01*G0_1_0 + 7.104621362433965e-02*G0_1_1;
    block[224] = 1.980682319223970e-01*G0_0_0 - 7.104621362433954e-02*G0_0_1 - 7.104621362433935e-02*G0_1_0;
    block[225] = -2.820319389329797e+00*G0_0_0 - 1.158268573633151e+00*G0_0_1 - 1.158268573633152e+00*G0_1_0 + 5.037822420634928e-01*G0_1_1;
    block[226] = 1.356336805555551e+00*G0_0_0 + 7.836612654320982e-01*G0_0_1 + 7.836612654320955e-01*G0_1_0 + 2.109857253086388e-01*G0_1_1;
    block[227] = -6.674038249559063e-01*G0_0_0 - 4.047481261022909e-01*G0_0_1 - 4.047481261022923e-01*G0_1_0 - 1.420924272486773e-01*G0_1_1;
    block[228] = 1.194868138227507e+00*G0_0_0 + 6.221925981040500e-01*G0_0_1 + 6.221925981040519e-01*G0_1_0 + 4.951705798059501e-02*G0_1_1;
    block[229] = -4.198185350529078e-01*G0_0_0 - 3.466194058641979e-01*G0_0_1 - 3.466194058641953e-01*G0_1_0 - 2.734202766754810e-01*G0_1_1;
    block[230] = -9.903411596119875e-01*G0_0_0 - 7.276854607583708e-01*G0_0_1 - 7.276854607583714e-01*G0_1_0 - 4.650297619047565e-01*G0_1_1;
    block[231] = -6.480275848765409e-01*G0_0_0 - 6.480275848765407e-01*G0_0_1 + 2.022879464285707e-01*G0_1_0 + 2.022879464285709e-01*G0_1_1;
    block[232] = 2.023740630511465e-01*G0_0_0 + 1.615547839506165e-01*G0_1_0;
    block[233] = -4.081927910052818e-02*G0_1_1;
    block[234] = 1.980682319224008e-01*G0_0_0 + 2.691144455467387e-01*G0_0_1 + 2.691144455467353e-01*G0_1_0 + 3.401606591710744e-01*G0_1_1;
    block[235] = 1.119516093474378e-01*G0_0_0 + 1.420924272486748e-01*G0_0_1 + 1.420924272486753e-01*G0_1_0 + 1.722332451499084e-01*G0_1_1;
    block[236] = 7.104621362433999e-02*G0_0_0 + 1.011870315255725e-01*G0_0_1 + 1.011870315255713e-01*G0_1_0 + 1.313278494268067e-01*G0_1_1;
    block[237] = 7.104621362433676e-02*G0_0_1 + 7.104621362434045e-02*G0_1_0 + 1.420924272486772e-01*G0_1_1;
    block[238] = -7.104621362433722e-02*G0_0_1 - 7.104621362434062e-02*G0_1_0 + 1.980682319223959e-01*G0_1_1;
    block[239] = 7.104621362433688e-02*G0_0_0 + 3.035610945767181e-01*G0_0_1 + 3.035610945767204e-01*G0_1_0 - 3.595368992504387e-01*G0_1_1;
    block[240] = -4.951705798059706e-02*G0_0_0 - 5.791342868165756e-01*G0_0_1 - 5.791342868165748e-01*G0_1_0 + 2.863377700617262e-01*G0_1_1;
    block[241] = -2.863377700617283e-01*G0_0_0 + 9.946469907407364e-01*G0_0_1 + 9.946469907407374e-01*G0_1_0 - 2.863377700617268e-01*G0_1_1;
    block[242] = 1.989293981481473e+00*G0_0_0 + 7.083092206790083e-01*G0_0_1 + 7.083092206790083e-01*G0_1_0 + 1.989293981481473e+00*G0_1_1;
    block[243] = -2.568428268298050e+00*G0_0_0 - 3.767602237654302e-01*G0_0_1 - 1.702956211419745e+00*G0_1_0 - 9.063774526014081e-01*G0_1_1;
    block[244] = 1.963458994708987e+00*G0_0_0 + 5.855930335096996e-01*G0_0_1 + 1.300361000881828e+00*G0_1_0 + 8.181079144620798e-01*G0_1_1;
    block[245] = -9.386711860670163e-01*G0_0_0 - 2.691144455467394e-01*G0_0_1 - 6.695567405202794e-01*G0_1_0 - 3.401606591710738e-01*G0_1_1;
    block[246] = 5.037822420634915e-01*G0_0_0 - 1.158268573633148e+00*G0_0_1 - 1.158268573633153e+00*G0_1_0 - 2.820319389329791e+00*G0_1_1;
    block[247] = 4.951705798060148e-02*G0_0_0 + 6.221925981040516e-01*G0_0_1 + 6.221925981040543e-01*G0_1_0 + 1.194868138227509e+00*G0_1_1;
    block[248] = -4.650297619047649e-01*G0_0_0 - 7.276854607583739e-01*G0_0_1 - 7.276854607583758e-01*G0_1_0 - 9.903411596119900e-01*G0_1_1;
    block[249] = 2.109857253086367e-01*G0_0_0 + 7.836612654320912e-01*G0_0_1 + 7.836612654320922e-01*G0_1_0 + 1.356336805555548e+00*G0_1_1;
    block[250] = -2.734202766754778e-01*G0_0_0 - 3.466194058641934e-01*G0_0_1 - 3.466194058641916e-01*G0_1_0 - 4.198185350529061e-01*G0_1_1;
    block[251] = -1.420924272486769e-01*G0_0_0 - 4.047481261022890e-01*G0_0_1 - 4.047481261022919e-01*G0_1_0 - 6.674038249559062e-01*G0_1_1;
    block[252] = 5.942046957671940e-01*G0_0_0 + 5.942046957671935e-01*G0_0_1 - 1.584545855379203e-02*G0_1_0 - 1.584545855379215e-02*G0_1_1;
    block[253] = -4.499593529541443e-01*G0_0_0 - 3.802910052910034e-01*G0_1_0;
    block[254] = -3.797743055555532e-02*G0_1_1;
    block[255] = -3.595368992504427e-01*G0_0_0 - 6.630979938271616e-01*G0_0_1 - 6.630979938271563e-01*G0_1_0 - 8.956128747795363e-01*G0_1_1;
    block[256] = -1.119516093474380e-01*G0_0_0 - 1.571628361992905e-01*G0_0_1 - 1.571628361992946e-01*G0_1_0 - 2.195973875661371e-01*G0_1_1;
    block[257] = -1.722332451499101e-02*G0_0_0 - 1.485511739417985e-01*G0_0_1 - 1.485511739417978e-01*G0_1_0 - 2.971023478835962e-01*G0_1_1;
    block[258] = 3.014081790123598e-02*G0_0_1 + 3.014081790123480e-02*G0_1_0 + 1.313278494268076e-01*G0_1_1;
    block[259] = -3.014081790123389e-02*G0_0_1 - 3.014081790123476e-02*G0_1_0 + 1.119516093474421e-01*G0_1_1;
    block[260] = -1.722332451499217e-02*G0_0_0 + 4.521122685185058e-02*G0_0_1 + 4.521122685185022e-02*G0_1_0 - 1.119516093474418e-01*G0_1_1;
    block[261] = 1.033399470899444e-01*G0_0_0 - 3.014081790123371e-02*G0_0_1 - 3.014081790123536e-02*G0_1_0 + 1.033399470899461e-01*G0_1_1;
    block[262] = 2.863377700617273e-01*G0_0_0 - 5.791342868165769e-01*G0_0_1 - 5.791342868165783e-01*G0_1_0 - 4.951705798059915e-02*G0_1_1;
    block[263] = -2.568428268298050e+00*G0_0_0 - 1.702956211419745e+00*G0_0_1 - 3.767602237654302e-01*G0_1_0 - 9.063774526014081e-01*G0_1_1;
    block[264] = 4.417782738095220e+00*G0_0_0 + 1.898871527777770e+00*G0_0_1 + 1.898871527777771e+00*G0_1_0 + 3.074363425925915e+00*G0_1_1;
    block[265] = -3.957058807319209e+00*G0_0_0 - 1.453218005952380e+00*G0_0_1 - 2.503840801366832e+00*G0_1_0 - 1.804143242945321e+00*G0_1_1;
    block[266] = 1.963458994708988e+00*G0_0_0 + 6.630979938271623e-01*G0_0_1 + 1.377865961199289e+00*G0_1_0 + 8.956128747795363e-01*G0_1_1;
    block[267] = -6.114280202821839e-01*G0_0_0 + 2.040963955026442e+00*G0_0_1 + 2.040963955026452e+00*G0_1_0 + 7.319912918871250e-01*G0_1_1;
    block[268] = 4.305831128741261e-03*G0_0_0 - 2.409112516534380e+00*G0_0_1 - 2.409112516534386e+00*G0_1_0 - 3.810660548941786e+00*G0_1_1;
    block[269] = 6.803213183421573e-01*G0_0_0 + 1.610380842151671e+00*G0_0_1 + 1.610380842151670e+00*G0_1_0 + 2.023740630511460e+00*G0_1_1;
    block[270] = -3.186315035273292e-01*G0_0_0 - 4.714885085978781e-01*G0_0_1 - 4.714885085978808e-01*G0_1_0 + 3.875248015872980e-01*G0_1_1;
    block[271] = 3.272431657848233e-01*G0_0_0 + 6.587921626984072e-01*G0_0_1 + 6.587921626984099e-01*G0_1_0 + 1.033399470899466e+00*G0_1_1;
    block[272] = 3.444664902998314e-02*G0_0_0 + 1.033399470899460e-01*G0_0_1 + 1.033399470899477e-01*G0_1_0 - 3.444664902998195e-01*G0_1_1;
    block[273] = -4.499593529541433e-01*G0_0_0 - 4.499593529541429e-01*G0_0_1 - 6.966834766313920e-02*G0_1_0 - 6.966834766313955e-02*G0_1_1;
    block[274] = 5.942046957671945e-01*G0_0_0 + 6.100501543209849e-01*G0_1_0;
    block[275] = -3.797743055555495e-02*G0_1_1;
    block[276] = 2.863377700617293e-01*G0_0_0 + 8.654720568783056e-01*G0_0_1 + 8.654720568783025e-01*G0_1_0 + 1.395089285714279e+00*G0_1_1;
    block[277] = 1.033399470899451e-01*G0_0_0 + 1.334807649911793e-01*G0_0_1 + 1.334807649911812e-01*G0_1_0 + 2.669615299823619e-01*G0_1_1;
    block[278] = -1.722332451499258e-02*G0_0_0 - 6.243455136684237e-02*G0_0_1 - 6.243455136684491e-02*G0_1_0 - 2.195973875661370e-01*G0_1_1;
    block[279] = 3.014081790123283e-02*G0_0_1 + 3.014081790123567e-02*G0_1_0 + 1.722332451499105e-01*G0_1_1;
    block[280] = -3.014081790123521e-02*G0_0_1 - 3.014081790123597e-02*G0_1_0 + 7.104621362433697e-02*G0_1_1;
    block[281] = -1.722332451499030e-02*G0_0_0 + 1.313278494268083e-01*G0_0_1 + 1.313278494268086e-01*G0_1_0 - 1.722332451498962e-02*G0_1_1;
    block[282] = -1.119516093474404e-01*G0_0_0 + 4.521122685185060e-02*G0_0_1 + 4.521122685185236e-02*G0_1_0 - 1.722332451499260e-02*G0_1_1;
    block[283] = -3.595368992504386e-01*G0_0_0 + 3.035610945767194e-01*G0_0_1 + 3.035610945767201e-01*G0_1_0 + 7.104621362433965e-02*G0_1_1;
    block[284] = 1.963458994708987e+00*G0_0_0 + 1.300361000881829e+00*G0_0_1 + 5.855930335096996e-01*G0_1_0 + 8.181079144620798e-01*G0_1_1;
    block[285] = -3.957058807319209e+00*G0_0_0 - 2.503840801366833e+00*G0_0_1 - 1.453218005952380e+00*G0_1_0 - 1.804143242945321e+00*G0_1_1;
    block[286] = 4.417782738095220e+00*G0_0_0 + 2.518911210317453e+00*G0_0_1 + 2.518911210317453e+00*G0_1_0 + 3.694403108465595e+00*G0_1_1;
    block[287] = -2.568428268298050e+00*G0_0_0 - 8.654720568783064e-01*G0_0_1 - 2.191668044532619e+00*G0_1_0 - 1.395089285714279e+00*G0_1_1;
    block[288] = 6.803213183421474e-01*G0_0_0 - 9.300595238095184e-01*G0_0_1 - 9.300595238095234e-01*G0_1_0 - 5.166997354497372e-01*G0_1_1;
    block[289] = 4.305831128753878e-03*G0_0_0 + 2.413418347663133e+00*G0_0_1 + 2.413418347663133e+00*G0_1_0 + 1.011870315255735e+00*G0_1_1;
    block[290] = -6.114280202821908e-01*G0_0_0 - 2.652391975308634e+00*G0_0_1 - 2.652391975308634e+00*G0_1_0 - 3.961364638447960e+00*G0_1_1;
    block[291] = 3.272431657848264e-01*G0_0_0 - 3.315489969135811e-01*G0_0_1 - 3.315489969135826e-01*G0_1_0 + 4.305831128747798e-02*G0_1_1;
    block[292] = -3.186315035273314e-01*G0_0_0 + 1.528570050705465e-01*G0_0_1 + 1.528570050705490e-01*G0_1_0 + 1.011870315255728e+00*G0_1_1;
    block[293] = 3.444664902998290e-02*G0_0_0 - 6.889329805996396e-02*G0_0_1 - 6.889329805996310e-02*G0_1_0 - 5.166997354497331e-01*G0_1_1;
    block[294] = 2.023740630511460e-01*G0_0_0 + 2.023740630511460e-01*G0_0_1 + 4.081927910053007e-02*G0_1_0 + 4.081927910053023e-02*G0_1_1;
    block[295] = -6.480275848765407e-01*G0_0_0 - 8.503155313051103e-01*G0_1_0;
    block[296] = -4.081927910052893e-02*G0_1_1;
    block[297] = -2.863377700617273e-01*G0_0_0 - 1.280984760802463e+00*G0_0_1 - 1.280984760802461e+00*G0_1_0 - 2.561969521604925e+00*G0_1_1;
    block[298] = -4.951705798059952e-02*G0_0_0 + 5.296172288359774e-01*G0_0_1 + 5.296172288359746e-01*G0_1_0 + 1.395089285714279e+00*G0_1_1;
    block[299] = 7.104621362433876e-02*G0_0_0 - 2.325148809523813e-01*G0_0_1 - 2.325148809523782e-01*G0_1_0 - 8.956128747795384e-01*G0_1_1;
    block[300] = 7.104621362433980e-02*G0_0_1 + 7.104621362433906e-02*G0_1_0 + 3.401606591710763e-01*G0_1_1;
    block[301] = -7.104621362433826e-02*G0_0_1 - 7.104621362433905e-02*G0_1_0;
    block[302] = 7.104621362433812e-02*G0_0_0 - 3.014081790123534e-02*G0_0_1 - 3.014081790123611e-02*G0_1_0;
    block[303] = 1.119516093474418e-01*G0_0_0 - 3.014081790123361e-02*G0_0_1 - 3.014081790123249e-02*G0_1_0;
    block[304] = 1.980682319223969e-01*G0_0_0 - 7.104621362433931e-02*G0_0_1 - 7.104621362433954e-02*G0_1_0;
    block[305] = -9.386711860670163e-01*G0_0_0 - 6.695567405202794e-01*G0_0_1 - 2.691144455467394e-01*G0_1_0 - 3.401606591710738e-01*G0_1_1;
    block[306] = 1.963458994708988e+00*G0_0_0 + 1.377865961199289e+00*G0_0_1 + 6.630979938271623e-01*G0_1_0 + 8.956128747795364e-01*G0_1_1;
    block[307] = -2.568428268298050e+00*G0_0_0 - 2.191668044532619e+00*G0_0_1 - 8.654720568783065e-01*G0_1_0 - 1.395089285714279e+00*G0_1_1;
    block[308] = 1.989293981481472e+00*G0_0_0 + 1.280984760802464e+00*G0_0_1 + 1.280984760802464e+00*G0_1_0 + 2.561969521604924e+00*G0_1_1;
    block[309] = -4.650297619047585e-01*G0_0_0 + 2.626556988536152e-01*G0_0_1 + 2.626556988536182e-01*G0_1_0;
    block[310] = 4.951705798059762e-02*G0_0_0 - 5.726755401234581e-01*G0_0_1 - 5.726755401234587e-01*G0_1_0;
    block[311] = 5.037822420634912e-01*G0_0_0 + 1.662050815696643e+00*G0_0_1 + 1.662050815696642e+00*G0_1_0;
    block[312] = -2.734202766754830e-01*G0_0_0 + 7.319912918871194e-02*G0_0_1 + 7.319912918870930e-02*G0_1_0;
    block[313] = 2.109857253086409e-01*G0_0_0 - 5.726755401234518e-01*G0_0_1 - 5.726755401234518e-01*G0_1_0;
    block[314] = -1.420924272486769e-01*G0_0_0 + 2.626556988536137e-01*G0_0_1 + 2.626556988536136e-01*G0_1_0;
    block[315] = -2.152915564373899e-01*G0_0_0 - 2.152915564373895e-01*G0_0_1 - 2.152915564373900e-01*G0_1_0 - 2.152915564373903e-01*G0_1_1;
    block[316] = 1.076457782186939e-01*G0_0_0;
    block[317] = 1.076457782186939e-01*G0_1_1;
    block[318] = -6.674038249559061e-01*G0_0_0 - 2.626556988536190e-01*G0_0_1 - 2.626556988536167e-01*G0_1_0;
    block[319] = -3.444664902998179e-01*G0_0_0 - 4.478064373897627e-01*G0_0_1 - 4.478064373897619e-01*G0_1_0 - 5.166997354497249e-01*G0_1_1;
    block[320] = -5.166997354497377e-01*G0_0_0 - 4.478064373897722e-01*G0_0_1 - 4.478064373897706e-01*G0_1_0 - 3.444664902998232e-01*G0_1_1;
    block[321] = -2.626556988536108e-01*G0_0_1 - 2.626556988536157e-01*G0_1_0 - 6.674038249559059e-01*G0_1_1;
    block[322] = 2.626556988536126e-01*G0_0_1 + 2.626556988536163e-01*G0_1_0 - 4.650297619047579e-01*G0_1_1;
    block[323] = -5.166997354497305e-01*G0_0_0 - 9.300595238095186e-01*G0_0_1 - 9.300595238095226e-01*G0_1_0 + 6.803213183421500e-01*G0_1_1;
    block[324] = 7.319912918871164e-01*G0_0_0 + 2.040963955026446e+00*G0_0_1 + 2.040963955026442e+00*G0_1_0 - 6.114280202821878e-01*G0_1_1;
    block[325] = -2.820319389329796e+00*G0_0_0 - 1.158268573633152e+00*G0_0_1 - 1.158268573633151e+00*G0_1_0 + 5.037822420634923e-01*G0_1_1;
    block[326] = 5.037822420634915e-01*G0_0_0 - 1.158268573633152e+00*G0_0_1 - 1.158268573633148e+00*G0_1_0 - 2.820319389329792e+00*G0_1_1;
    block[327] = -6.114280202821837e-01*G0_0_0 + 2.040963955026452e+00*G0_0_1 + 2.040963955026442e+00*G0_1_0 + 7.319912918871249e-01*G0_1_1;
    block[328] = 6.803213183421472e-01*G0_0_0 - 9.300595238095232e-01*G0_0_1 - 9.300595238095186e-01*G0_1_0 - 5.166997354497371e-01*G0_1_1;
    block[329] = -4.650297619047584e-01*G0_0_0 + 2.626556988536182e-01*G0_0_1 + 2.626556988536152e-01*G0_1_0;
    block[330] = 7.061563051146364e+00*G0_0_0 + 3.100198412698399e+00*G0_0_1 + 3.100198412698399e+00*G0_1_0 + 7.061563051146349e+00*G0_1_1;
    block[331] = -6.329571759259240e+00*G0_0_0 - 3.057140101410925e+00*G0_0_1 - 3.057140101410923e+00*G0_1_0 - 1.808449074074062e+00*G0_1_1;
    block[332] = 2.755731922398581e+00*G0_0_0 + 1.377865961199288e+00*G0_0_1 + 1.377865961199294e+00*G0_1_0 + 1.033399470899464e+00*G0_1_1;
    block[333] = -1.808449074074063e+00*G0_0_0 - 3.057140101410920e+00*G0_0_1 - 3.057140101410910e+00*G0_1_0 - 6.329571759259228e+00*G0_1_1;
    block[334] = 1.420924272486760e+00*G0_0_0 + 1.463982583774244e+00*G0_0_1 + 1.463982583774226e+00*G0_1_0 + 1.420924272486759e+00*G0_1_1;
    block[335] = 1.033399470899469e+00*G0_0_0 + 1.377865961199286e+00*G0_0_1 + 1.377865961199294e+00*G0_1_0 + 2.755731922398576e+00*G0_1_1;
    block[336] = -5.382288910934688e-02*G0_0_0 - 5.382288910934748e-02*G0_0_1 - 5.382288910934634e-02*G0_1_0 - 5.382288910934584e-02*G0_1_1;
    block[337] = -5.382288910934675e-02*G0_0_0;
    block[338] = 1.076457782186951e-01*G0_1_1;
    block[339] = 1.356336805555554e+00*G0_0_0 + 5.726755401234594e-01*G0_0_1 + 5.726755401234561e-01*G0_1_0;
    block[340] = 3.875248015872925e-01*G0_0_0 + 8.590133101851778e-01*G0_0_1 + 8.590133101851806e-01*G0_1_0 + 1.011870315255729e+00*G0_1_1;
    block[341] = 4.305831128748049e-02*G0_0_0 + 3.746073082010556e-01*G0_0_1 + 3.746073082010543e-01*G0_1_0 + 1.033399470899462e+00*G0_1_1;
    block[342] = -7.319912918871341e-02*G0_0_1 - 7.319912918871108e-02*G0_1_0 - 4.198185350529074e-01*G0_1_1;
    block[343] = 7.319912918871263e-02*G0_0_1 + 7.319912918871094e-02*G0_1_0 - 2.734202766754843e-01*G0_1_1;
    block[344] = 4.305831128747739e-02*G0_0_0 - 3.315489969135799e-01*G0_0_1 - 3.315489969135771e-01*G0_1_0 + 3.272431657848299e-01*G0_1_1;
    block[345] = 3.875248015873033e-01*G0_0_0 - 4.714885085978804e-01*G0_0_1 - 4.714885085978787e-01*G0_1_0 - 3.186315035273336e-01*G0_1_1;
    block[346] = 1.356336805555551e+00*G0_0_0 + 7.836612654320956e-01*G0_0_1 + 7.836612654320982e-01*G0_1_0 + 2.109857253086388e-01*G0_1_1;
    block[347] = 4.951705798060151e-02*G0_0_0 + 6.221925981040544e-01*G0_0_1 + 6.221925981040518e-01*G0_1_0 + 1.194868138227509e+00*G0_1_1;
    block[348] = 4.305831128740928e-03*G0_0_0 - 2.409112516534386e+00*G0_0_1 - 2.409112516534381e+00*G0_1_0 - 3.810660548941786e+00*G0_1_1;
    block[349] = 4.305831128753863e-03*G0_0_0 + 2.413418347663133e+00*G0_0_1 + 2.413418347663132e+00*G0_1_0 + 1.011870315255735e+00*G0_1_1;
    block[350] = 4.951705798059745e-02*G0_0_0 - 5.726755401234587e-01*G0_0_1 - 5.726755401234582e-01*G0_1_0;
    block[351] = -6.329571759259241e+00*G0_0_0 - 3.057140101410923e+00*G0_0_1 - 3.057140101410925e+00*G0_1_0 - 1.808449074074062e+00*G0_1_1;
    block[352] = 9.946469907407376e+00*G0_0_0 + 4.973234953703687e+00*G0_0_1 + 4.973234953703687e+00*G0_1_0 + 8.654720568783032e+00*G0_1_1;
    block[353] = -6.329571759259244e+00*G0_0_0 - 3.272431657848315e+00*G0_0_1 - 3.272431657848318e+00*G0_1_0 - 2.023740630511465e+00*G0_1_1;
    block[354] = -3.875248015873104e-01*G0_0_0 + 2.551204943783053e+00*G0_0_1 + 2.551204943783052e+00*G0_1_0 - 3.875248015873103e-01*G0_1_1;
    block[355] = -3.875248015872840e-01*G0_0_0 - 2.938729745370352e+00*G0_0_1 - 2.938729745370352e+00*G0_1_0 - 5.877459490740705e+00*G0_1_1;
    block[356] = -8.611662257495747e-02*G0_0_0 - 4.305831128747446e-02*G0_0_1 - 4.305831128747808e-02*G0_1_0 + 1.420924272486765e+00*G0_1_1;
    block[357] = 1.076457782186951e-01*G0_0_0 + 1.076457782186955e-01*G0_0_1 + 1.076457782186941e-01*G0_1_0 + 1.076457782186943e-01*G0_1_1;
    block[358] = -2.152915564373883e-01*G0_0_0;
    block[359] = 1.076457782186941e-01*G0_1_1;
    block[360] = -2.820319389329794e+00*G0_0_0 - 1.662050815696642e+00*G0_0_1 - 1.662050815696644e+00*G0_1_0;
    block[361] = 7.319912918871251e-01*G0_0_0 - 1.308972663139324e+00*G0_0_1 - 1.308972663139321e+00*G0_1_0 - 3.961364638447955e+00*G0_1_1;
    block[362] = -5.166997354497298e-01*G0_0_0 + 4.133597883597904e-01*G0_0_1 + 4.133597883597884e-01*G0_1_0 + 2.023740630511458e+00*G0_1_1;
    block[363] = -2.626556988536131e-01*G0_0_1 - 2.626556988536155e-01*G0_1_0 - 9.903411596119884e-01*G0_1_1;
    block[364] = 2.626556988536164e-01*G0_0_1 + 2.626556988536161e-01*G0_1_0 - 1.420924272486737e-01*G0_1_1;
    block[365] = -5.166997354497359e-01*G0_0_0 - 6.889329805996676e-02*G0_0_1 - 6.889329805996441e-02*G0_1_0 + 3.444664902998033e-02*G0_1_1;
    block[366] = -3.444664902998216e-01*G0_0_0 + 1.033399470899480e-01*G0_0_1 + 1.033399470899426e-01*G0_1_0 + 3.444664902998379e-02*G0_1_1;
    block[367] = -6.674038249559063e-01*G0_0_0 - 4.047481261022923e-01*G0_0_1 - 4.047481261022910e-01*G0_1_0 - 1.420924272486773e-01*G0_1_1;
    block[368] = -4.650297619047650e-01*G0_0_0 - 7.276854607583756e-01*G0_0_1 - 7.276854607583738e-01*G0_1_0 - 9.903411596119900e-01*G0_1_1;
    block[369] = 6.803213183421574e-01*G0_0_0 + 1.610380842151671e+00*G0_0_1 + 1.610380842151671e+00*G0_1_0 + 2.023740630511460e+00*G0_1_1;
    block[370] = -6.114280202821909e-01*G0_0_0 - 2.652391975308634e+00*G0_0_1 - 2.652391975308634e+00*G0_1_0 - 3.961364638447960e+00*G0_1_1;
    block[371] = 5.037822420634913e-01*G0_0_0 + 1.662050815696642e+00*G0_0_1 + 1.662050815696642e+00*G0_1_0;
    block[372] = 2.755731922398582e+00*G0_0_0 + 1.377865961199294e+00*G0_0_1 + 1.377865961199288e+00*G0_1_0 + 1.033399470899464e+00*G0_1_1;
    block[373] = -6.329571759259244e+00*G0_0_0 - 3.272431657848318e+00*G0_0_1 - 3.272431657848315e+00*G0_1_0 - 2.023740630511465e+00*G0_1_1;
    block[374] = 7.061563051146366e+00*G0_0_0 + 3.961364638447962e+00*G0_0_1 + 3.961364638447962e+00*G0_1_0 + 7.922729276895920e+00*G0_1_1;
    block[375] = 1.420924272486773e+00*G0_0_0 - 4.305831128747567e-02*G0_0_1 - 4.305831128746600e-02*G0_1_0 - 8.611662257494708e-02*G0_1_1;
    block[376] = -1.808449074074077e+00*G0_0_0 + 1.248691027336851e+00*G0_0_1 + 1.248691027336845e+00*G0_1_0 - 2.023740630511462e+00*G0_1_1;
    block[377] = 1.033399470899464e+00*G0_0_0 - 3.444664902998253e-01*G0_0_1 - 3.444664902998246e-01*G0_1_0 + 1.033399470899464e+00*G0_1_1;
    block[378] = -5.382288910934679e-02*G0_0_0 - 5.382288910934634e-02*G0_0_1 - 5.382288910934566e-02*G0_1_0 - 5.382288910934575e-02*G0_1_1;
    block[379] = 1.076457782186954e-01*G0_0_0;
    block[380] = -5.382288910934951e-02*G0_1_1;
    block[381] = -4.198185350529082e-01*G0_0_0 - 7.319912918870991e-02*G0_0_1 - 7.319912918870937e-02*G0_1_0;
    block[382] = 1.033399470899460e+00*G0_0_0 + 3.746073082010498e-01*G0_0_1 + 3.746073082010476e-01*G0_1_0 + 4.305831128746818e-02*G0_1_1;
    block[383] = 1.011870315255732e+00*G0_0_0 + 8.590133101851826e-01*G0_0_1 + 8.590133101851894e-01*G0_1_0 + 3.875248015873046e-01*G0_1_1;
    block[384] = 5.726755401234513e-01*G0_0_1 + 5.726755401234485e-01*G0_1_0 + 1.356336805555548e+00*G0_1_1;
    block[385] = -5.726755401234532e-01*G0_0_1 - 5.726755401234489e-01*G0_1_0 + 4.951705798060227e-02*G0_1_1;
    block[386] = 1.011870315255724e+00*G0_0_0 + 2.413418347663129e+00*G0_0_1 + 2.413418347663128e+00*G0_1_0 + 4.305831128742055e-03*G0_1_1;
    block[387] = -3.810660548941774e+00*G0_0_0 - 2.409112516534379e+00*G0_0_1 - 2.409112516534374e+00*G0_1_0 + 4.305831128755433e-03*G0_1_1;
    block[388] = 1.194868138227507e+00*G0_0_0 + 6.221925981040519e-01*G0_0_1 + 6.221925981040499e-01*G0_1_0 + 4.951705798059505e-02*G0_1_1;
    block[389] = 2.109857253086369e-01*G0_0_0 + 7.836612654320922e-01*G0_0_1 + 7.836612654320912e-01*G0_1_0 + 1.356336805555548e+00*G0_1_1;
    block[390] = -3.186315035273292e-01*G0_0_0 - 4.714885085978809e-01*G0_0_1 - 4.714885085978778e-01*G0_1_0 + 3.875248015872980e-01*G0_1_1;
    block[391] = 3.272431657848263e-01*G0_0_0 - 3.315489969135826e-01*G0_0_1 - 3.315489969135812e-01*G0_1_0 + 4.305831128747799e-02*G0_1_1;
    block[392] = -2.734202766754830e-01*G0_0_0 + 7.319912918870931e-02*G0_0_1 + 7.319912918871202e-02*G0_1_0;
    block[393] = -1.808449074074063e+00*G0_0_0 - 3.057140101410910e+00*G0_0_1 - 3.057140101410920e+00*G0_1_0 - 6.329571759259228e+00*G0_1_1;
    block[394] = -3.875248015873101e-01*G0_0_0 + 2.551204943783052e+00*G0_0_1 + 2.551204943783053e+00*G0_1_0 - 3.875248015873103e-01*G0_1_1;
    block[395] = 1.420924272486773e+00*G0_0_0 - 4.305831128746600e-02*G0_0_1 - 4.305831128747573e-02*G0_1_0 - 8.611662257494702e-02*G0_1_1;
    block[396] = 8.654720568783022e+00*G0_0_0 + 4.973234953703669e+00*G0_0_1 + 4.973234953703669e+00*G0_1_0 + 9.946469907407367e+00*G0_1_1;
    block[397] = -5.877459490740702e+00*G0_0_0 - 2.938729745370354e+00*G0_0_1 - 2.938729745370338e+00*G0_1_0 - 3.875248015872931e-01*G0_1_1;
    block[398] = -2.023740630511459e+00*G0_0_0 - 3.272431657848303e+00*G0_0_1 - 3.272431657848319e+00*G0_1_0 - 6.329571759259231e+00*G0_1_1;
    block[399] = 1.076457782186939e-01*G0_0_0 + 1.076457782186935e-01*G0_0_1 + 1.076457782186938e-01*G0_1_0 + 1.076457782186933e-01*G0_1_1;
    block[400] = -5.382288910934808e-02*G0_0_0;
    block[401] = -5.382288910934826e-02*G0_1_1;
    block[402] = 1.194868138227508e+00*G0_0_0 + 5.726755401234528e-01*G0_0_1 + 5.726755401234555e-01*G0_1_0;
    block[403] = -3.810660548941777e+00*G0_0_0 - 1.401548032407396e+00*G0_0_1 - 1.401548032407401e+00*G0_1_0 + 1.011870315255732e+00*G0_1_1;
    block[404] = 1.011870315255723e+00*G0_0_0 - 1.401548032407402e+00*G0_0_1 - 1.401548032407399e+00*G0_1_0 - 3.810660548941781e+00*G0_1_1;
    block[405] = 5.726755401234560e-01*G0_0_1 + 5.726755401234529e-01*G0_1_0 + 1.194868138227507e+00*G0_1_1;
    block[406] = -5.726755401234563e-01*G0_0_1 - 5.726755401234528e-01*G0_1_0 + 2.109857253086402e-01*G0_1_1;
    block[407] = 1.011870315255734e+00*G0_0_0 + 1.528570050705490e-01*G0_0_1 + 1.528570050705439e-01*G0_1_0 - 3.186315035273328e-01*G0_1_1;
    block[408] = 1.033399470899457e+00*G0_0_0 + 6.587921626984083e-01*G0_0_1 + 6.587921626984083e-01*G0_1_0 + 3.272431657848276e-01*G0_1_1;
    block[409] = -4.198185350529078e-01*G0_0_0 - 3.466194058641953e-01*G0_0_1 - 3.466194058641979e-01*G0_1_0 - 2.734202766754811e-01*G0_1_1;
    block[410] = -2.734202766754777e-01*G0_0_0 - 3.466194058641916e-01*G0_0_1 - 3.466194058641934e-01*G0_1_0 - 4.198185350529061e-01*G0_1_1;
    block[411] = 3.272431657848233e-01*G0_0_0 + 6.587921626984099e-01*G0_0_1 + 6.587921626984072e-01*G0_1_0 + 1.033399470899466e+00*G0_1_1;
    block[412] = -3.186315035273315e-01*G0_0_0 + 1.528570050705491e-01*G0_0_1 + 1.528570050705465e-01*G0_1_0 + 1.011870315255728e+00*G0_1_1;
    block[413] = 2.109857253086408e-01*G0_0_0 - 5.726755401234518e-01*G0_0_1 - 5.726755401234517e-01*G0_1_0;
    block[414] = 1.420924272486760e+00*G0_0_0 + 1.463982583774226e+00*G0_0_1 + 1.463982583774244e+00*G0_1_0 + 1.420924272486759e+00*G0_1_1;
    block[415] = -3.875248015872840e-01*G0_0_0 - 2.938729745370352e+00*G0_0_1 - 2.938729745370352e+00*G0_1_0 - 5.877459490740705e+00*G0_1_1;
    block[416] = -1.808449074074076e+00*G0_0_0 + 1.248691027336846e+00*G0_0_1 + 1.248691027336850e+00*G0_1_0 - 2.023740630511462e+00*G0_1_1;
    block[417] = -5.877459490740702e+00*G0_0_0 - 2.938729745370339e+00*G0_0_1 - 2.938729745370354e+00*G0_1_0 - 3.875248015872929e-01*G0_1_1;
    block[418] = 8.654720568783022e+00*G0_0_0 + 3.681485615079345e+00*G0_0_1 + 3.681485615079345e+00*G0_1_0 + 8.654720568783022e+00*G0_1_1;
    block[419] = -2.023740630511454e+00*G0_0_0 + 1.248691027336849e+00*G0_0_1 + 1.248691027336857e+00*G0_1_0 - 1.808449074074064e+00*G0_1_1;
    block[420] = 1.076457782186938e-01*G0_0_0 + 1.076457782186938e-01*G0_0_1 + 1.076457782186933e-01*G0_1_0 + 1.076457782186934e-01*G0_1_1;
    block[421] = 1.076457782186947e-01*G0_0_0;
    block[422] = -2.152915564373862e-01*G0_1_1;
    block[423] = -9.903411596119855e-01*G0_0_0 - 2.626556988536145e-01*G0_0_1 - 2.626556988536141e-01*G0_1_0;
    block[424] = 2.023740630511453e+00*G0_0_0 + 4.133597883597881e-01*G0_0_1 + 4.133597883597904e-01*G0_1_0 - 5.166997354497292e-01*G0_1_1;
    block[425] = -3.961364638447955e+00*G0_0_0 - 1.308972663139326e+00*G0_0_1 - 1.308972663139330e+00*G0_1_0 + 7.319912918871180e-01*G0_1_1;
    block[426] = -1.662050815696640e+00*G0_0_1 - 1.662050815696635e+00*G0_1_0 - 2.820319389329789e+00*G0_1_1;
    block[427] = 1.662050815696642e+00*G0_0_1 + 1.662050815696635e+00*G0_1_0 + 5.037822420634880e-01*G0_1_1;
    block[428] = -3.961364638447959e+00*G0_0_0 - 2.652391975308631e+00*G0_0_1 - 2.652391975308626e+00*G0_1_0 - 6.114280202821805e-01*G0_1_1;
    block[429] = 2.023740630511456e+00*G0_0_0 + 1.610380842151666e+00*G0_0_1 + 1.610380842151662e+00*G0_1_0 + 6.803213183421433e-01*G0_1_1;
    block[430] = -9.903411596119875e-01*G0_0_0 - 7.276854607583713e-01*G0_0_1 - 7.276854607583709e-01*G0_1_0 - 4.650297619047566e-01*G0_1_1;
    block[431] = -1.420924272486769e-01*G0_0_0 - 4.047481261022919e-01*G0_0_1 - 4.047481261022891e-01*G0_1_0 - 6.674038249559063e-01*G0_1_1;
    block[432] = 3.444664902998314e-02*G0_0_0 + 1.033399470899477e-01*G0_0_1 + 1.033399470899460e-01*G0_1_0 - 3.444664902998197e-01*G0_1_1;
    block[433] = 3.444664902998290e-02*G0_0_0 - 6.889329805996310e-02*G0_0_1 - 6.889329805996391e-02*G0_1_0 - 5.166997354497331e-01*G0_1_1;
    block[434] = -1.420924272486769e-01*G0_0_0 + 2.626556988536136e-01*G0_0_1 + 2.626556988536137e-01*G0_1_0;
    block[435] = 1.033399470899469e+00*G0_0_0 + 1.377865961199294e+00*G0_0_1 + 1.377865961199286e+00*G0_1_0 + 2.755731922398576e+00*G0_1_1;
    block[436] = -8.611662257495747e-02*G0_0_0 - 4.305831128747817e-02*G0_0_1 - 4.305831128747430e-02*G0_1_0 + 1.420924272486765e+00*G0_1_1;
    block[437] = 1.033399470899464e+00*G0_0_0 - 3.444664902998245e-01*G0_0_1 - 3.444664902998253e-01*G0_1_0 + 1.033399470899464e+00*G0_1_1;
    block[438] = -2.023740630511459e+00*G0_0_0 - 3.272431657848319e+00*G0_0_1 - 3.272431657848303e+00*G0_1_0 - 6.329571759259231e+00*G0_1_1;
    block[439] = -2.023740630511453e+00*G0_0_0 + 1.248691027336857e+00*G0_0_1 + 1.248691027336849e+00*G0_1_0 - 1.808449074074064e+00*G0_1_1;
    block[440] = 7.922729276895914e+00*G0_0_0 + 3.961364638447957e+00*G0_0_1 + 3.961364638447957e+00*G0_1_0 + 7.061563051146347e+00*G0_1_1;
  }

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 21;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[3] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][2];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][2];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[11] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][2];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][3];
      offset = offset + 4*mesh.noEdges();
      dofs[15] = offset + 6*cell.id() + 0;
      dofs[16] = offset + 6*cell.id() + 1;
      dofs[17] = offset + 6*cell.id() + 2;
      dofs[18] = offset + 6*cell.id() + 3;
      dofs[19] = offset + 6*cell.id() + 4;
      dofs[20] = offset + 6*cell.id() + 5;
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(8.000000000000000e-01, 2.000000000000000e-01);
      points[4] = map(6.000000000000000e-01, 4.000000000000000e-01);
      points[5] = map(4.000000000000000e-01, 6.000000000000000e-01);
      points[6] = map(2.000000000000000e-01, 8.000000000000000e-01);
      points[7] = map(0.000000000000000e+00, 8.000000000000000e-01);
      points[8] = map(0.000000000000000e+00, 6.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 4.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 2.000000000000000e-01);
      points[11] = map(2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(4.000000000000000e-01, 0.000000000000000e+00);
      points[13] = map(6.000000000000000e-01, 0.000000000000000e+00);
      points[14] = map(8.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(2.000000000000000e-01, 2.000000000000000e-01);
      points[16] = map(4.000000000000000e-01, 2.000000000000000e-01);
      points[17] = map(6.000000000000000e-01, 2.000000000000000e-01);
      points[18] = map(2.000000000000000e-01, 4.000000000000000e-01);
      points[19] = map(4.000000000000000e-01, 4.000000000000000e-01);
      points[20] = map(2.000000000000000e-01, 6.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 21;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[3] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][2];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][2];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[11] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][2];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering[alignment][3];
      offset = offset + 4*mesh.noEdges();
      dofs[15] = offset + 6*cell.id() + 0;
      dofs[16] = offset + 6*cell.id() + 1;
      dofs[17] = offset + 6*cell.id() + 2;
      dofs[18] = offset + 6*cell.id() + 3;
      dofs[19] = offset + 6*cell.id() + 4;
      dofs[20] = offset + 6*cell.id() + 5;
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(8.000000000000000e-01, 2.000000000000000e-01);
      points[4] = map(6.000000000000000e-01, 4.000000000000000e-01);
      points[5] = map(4.000000000000000e-01, 6.000000000000000e-01);
      points[6] = map(2.000000000000000e-01, 8.000000000000000e-01);
      points[7] = map(0.000000000000000e+00, 8.000000000000000e-01);
      points[8] = map(0.000000000000000e+00, 6.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 4.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 2.000000000000000e-01);
      points[11] = map(2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(4.000000000000000e-01, 0.000000000000000e+00);
      points[13] = map(6.000000000000000e-01, 0.000000000000000e+00);
      points[14] = map(8.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(2.000000000000000e-01, 2.000000000000000e-01);
      points[16] = map(4.000000000000000e-01, 2.000000000000000e-01);
      points[17] = map(6.000000000000000e-01, 2.000000000000000e-01);
      points[18] = map(2.000000000000000e-01, 4.000000000000000e-01);
      points[19] = map(4.000000000000000e-01, 4.000000000000000e-01);
      points[20] = map(2.000000000000000e-01, 6.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0) : dolfin::LinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0 = map.det*c[0][0];
    real G0_1 = map.det*c[0][1];
    real G0_2 = map.det*c[0][2];
    real G0_3 = map.det*c[0][3];
    real G0_4 = map.det*c[0][4];
    real G0_5 = map.det*c[0][5];
    real G0_6 = map.det*c[0][6];
    real G0_7 = map.det*c[0][7];
    real G0_8 = map.det*c[0][8];
    real G0_9 = map.det*c[0][9];
    real G0_10 = map.det*c[0][10];
    real G0_11 = map.det*c[0][11];
    real G0_12 = map.det*c[0][12];
    real G0_13 = map.det*c[0][13];
    real G0_14 = map.det*c[0][14];
    real G0_15 = map.det*c[0][15];
    real G0_16 = map.det*c[0][16];
    real G0_17 = map.det*c[0][17];
    real G0_18 = map.det*c[0][18];
    real G0_19 = map.det*c[0][19];
    real G0_20 = map.det*c[0][20];

    // Compute element tensor
    block[0] = 1.389452561327610e-03*G0_0 + 1.238774567767669e-04*G0_1 + 1.238774567767667e-04*G0_2 + 3.636470107824415e-04*G0_3 + 2.072018131045970e-04*G0_4 + 2.072018131045990e-04*G0_5 + 3.636470107824400e-04*G0_6 - 2.296443268665531e-05*G0_7 + 4.626811267436416e-04*G0_8 - 9.582431457431776e-04*G0_9 + 1.181363486051024e-03*G0_10 + 1.181363486051025e-03*G0_11 - 9.582431457431749e-04*G0_12 + 4.626811267436394e-04*G0_13 - 2.296443268665226e-05*G0_14 + 8.924813612313880e-04*G0_15 - 9.746835918711232e-04*G0_16 + 8.794333881139758e-04*G0_17 - 9.746835918711256e-04*G0_18 + 6.497890612474170e-04*G0_19 + 8.794333881139740e-04*G0_20;
    block[1] = 1.238774567767669e-04*G0_0 + 1.389452561327610e-03*G0_1 + 1.238774567767669e-04*G0_2 + 1.181363486051025e-03*G0_3 - 9.582431457431766e-04*G0_4 + 4.626811267436436e-04*G0_5 - 2.296443268665343e-05*G0_6 + 3.636470107824412e-04*G0_7 + 2.072018131045969e-04*G0_8 + 2.072018131045993e-04*G0_9 + 3.636470107824393e-04*G0_10 - 2.296443268665588e-05*G0_11 + 4.626811267436471e-04*G0_12 - 9.582431457431827e-04*G0_13 + 1.181363486051034e-03*G0_14 + 8.794333881139788e-04*G0_15 - 9.746835918711270e-04*G0_16 + 8.924813612313986e-04*G0_17 + 6.497890612474135e-04*G0_18 - 9.746835918711223e-04*G0_19 + 8.794333881139830e-04*G0_20;
    block[2] = 1.238774567767667e-04*G0_0 + 1.238774567767669e-04*G0_1 + 1.389452561327609e-03*G0_2 - 2.296443268665531e-05*G0_3 + 4.626811267436427e-04*G0_4 - 9.582431457431784e-04*G0_5 + 1.181363486051026e-03*G0_6 + 1.181363486051026e-03*G0_7 - 9.582431457431775e-04*G0_8 + 4.626811267436410e-04*G0_9 - 2.296443268665522e-05*G0_10 + 3.636470107824399e-04*G0_11 + 2.072018131045994e-04*G0_12 + 2.072018131045969e-04*G0_13 + 3.636470107824412e-04*G0_14 + 8.794333881139737e-04*G0_15 + 6.497890612474173e-04*G0_16 + 8.794333881139768e-04*G0_17 - 9.746835918711287e-04*G0_18 - 9.746835918711252e-04*G0_19 + 8.924813612313906e-04*G0_20;
    block[3] = 3.636470107824415e-04*G0_0 + 1.181363486051025e-03*G0_1 - 2.296443268665531e-05*G0_2 + 1.470506570333010e-02*G0_3 - 9.583736254743529e-03*G0_4 + 7.704828125835334e-03*G0_5 - 3.969845820974427e-03*G0_6 - 2.482376885588771e-03*G0_7 - 4.566790591096720e-05*G0_8 - 1.448325016033392e-03*G0_9 - 4.110111531986686e-04*G0_10 - 2.482376885588783e-03*G0_11 + 5.760680131340070e-03*G0_12 - 7.352532851665069e-03*G0_13 + 7.352532851665065e-03*G0_14 + 7.828783870450867e-04*G0_15 - 3.816532136844791e-03*G0_16 + 1.024265889717318e-02*G0_17 - 1.370037177328890e-03*G0_18 + 9.785979838062138e-05*G0_19 - 2.805314220244868e-03*G0_20;
    block[4] = 2.072018131045970e-04*G0_0 - 9.582431457431766e-04*G0_1 + 4.626811267436427e-04*G0_2 - 9.583736254743529e-03*G0_3 + 2.207717051467129e-02*G0_4 - 1.347855623029281e-02*G0_5 + 7.704828125835330e-03*G0_6 + 5.760680131340041e-03*G0_7 - 1.356989204211462e-03*G0_8 + 2.818362193362278e-03*G0_9 - 1.448325016033391e-03*G0_10 - 4.566790591095870e-05*G0_11 - 1.356989204211485e-03*G0_12 + 2.948841924536486e-03*G0_13 - 7.352532851665063e-03*G0_14 + 3.131513548180327e-03*G0_15 - 5.480148709315563e-03*G0_16 - 1.435277042915993e-03*G0_17 - 5.871587902838066e-04*G0_18 + 5.284429112554296e-03*G0_19 + 5.088709515793022e-03*G0_20;
    block[5] = 2.072018131045990e-04*G0_0 + 4.626811267436436e-04*G0_1 - 9.582431457431785e-04*G0_2 + 7.704828125835336e-03*G0_3 - 1.347855623029281e-02*G0_4 + 2.207717051467127e-02*G0_5 - 9.583736254743517e-03*G0_6 - 7.352532851665036e-03*G0_7 + 2.948841924536456e-03*G0_8 - 1.356989204211462e-03*G0_9 - 4.566790591097049e-05*G0_10 - 1.448325016033404e-03*G0_11 + 2.818362193362299e-03*G0_12 - 1.356989204211486e-03*G0_13 + 5.760680131340063e-03*G0_14 + 3.131513548180318e-03*G0_15 - 5.871587902838054e-04*G0_16 + 5.088709515793026e-03*G0_17 - 5.480148709315560e-03*G0_18 + 5.284429112554294e-03*G0_19 - 1.435277042915974e-03*G0_20;
    block[6] = 3.636470107824400e-04*G0_0 - 2.296443268665348e-05*G0_1 + 1.181363486051026e-03*G0_2 - 3.969845820974427e-03*G0_3 + 7.704828125835330e-03*G0_4 - 9.583736254743517e-03*G0_5 + 1.470506570333010e-02*G0_6 + 7.352532851665041e-03*G0_7 - 7.352532851665042e-03*G0_8 + 5.760680131340049e-03*G0_9 - 2.482376885588774e-03*G0_10 - 4.110111531986670e-04*G0_11 - 1.448325016033403e-03*G0_12 - 4.566790591095773e-05*G0_13 - 2.482376885588778e-03*G0_14 + 7.828783870450759e-04*G0_15 - 1.370037177328891e-03*G0_16 - 2.805314220244872e-03*G0_17 - 3.816532136844775e-03*G0_18 + 9.785979838062921e-05*G0_19 + 1.024265889717314e-02*G0_20;
    block[7] = -2.296443268665529e-05*G0_0 + 3.636470107824412e-04*G0_1 + 1.181363486051026e-03*G0_2 - 2.482376885588771e-03*G0_3 + 5.760680131340041e-03*G0_4 - 7.352532851665035e-03*G0_5 + 7.352532851665041e-03*G0_6 + 1.470506570333008e-02*G0_7 - 9.583736254743524e-03*G0_8 + 7.704828125835333e-03*G0_9 - 3.969845820974424e-03*G0_10 - 2.482376885588778e-03*G0_11 - 4.566790591096257e-05*G0_12 - 1.448325016033397e-03*G0_13 - 4.110111531986651e-04*G0_14 - 2.805314220244876e-03*G0_15 - 1.370037177328895e-03*G0_16 + 7.828783870450882e-04*G0_17 + 9.785979838063427e-05*G0_18 - 3.816532136844777e-03*G0_19 + 1.024265889717314e-02*G0_20;
    block[8] = 4.626811267436416e-04*G0_0 + 2.072018131045969e-04*G0_1 - 9.582431457431776e-04*G0_2 - 4.566790591096720e-05*G0_3 - 1.356989204211462e-03*G0_4 + 2.948841924536455e-03*G0_5 - 7.352532851665042e-03*G0_6 - 9.583736254743524e-03*G0_7 + 2.207717051467125e-02*G0_8 - 1.347855623029280e-02*G0_9 + 7.704828125835324e-03*G0_10 + 5.760680131340050e-03*G0_11 - 1.356989204211469e-03*G0_12 + 2.818362193362284e-03*G0_13 - 1.448325016033399e-03*G0_14 + 5.088709515793030e-03*G0_15 - 5.871587902838028e-04*G0_16 + 3.131513548180305e-03*G0_17 + 5.284429112554280e-03*G0_18 - 5.480148709315538e-03*G0_19 - 1.435277042915990e-03*G0_20;
    block[9] = -9.582431457431774e-04*G0_0 + 2.072018131045992e-04*G0_1 + 4.626811267436411e-04*G0_2 - 1.448325016033392e-03*G0_3 + 2.818362193362278e-03*G0_4 - 1.356989204211461e-03*G0_5 + 5.760680131340049e-03*G0_6 + 7.704828125835333e-03*G0_7 - 1.347855623029280e-02*G0_8 + 2.207717051467125e-02*G0_9 - 9.583736254743510e-03*G0_10 - 7.352532851665042e-03*G0_11 + 2.948841924536464e-03*G0_12 - 1.356989204211471e-03*G0_13 - 4.566790591096051e-05*G0_14 - 1.435277042915982e-03*G0_15 - 5.480148709315571e-03*G0_16 + 3.131513548180340e-03*G0_17 + 5.284429112554303e-03*G0_18 - 5.871587902838283e-04*G0_19 + 5.088709515793030e-03*G0_20;
    block[10] = 1.181363486051024e-03*G0_0 + 3.636470107824393e-04*G0_1 - 2.296443268665521e-05*G0_2 - 4.110111531986686e-04*G0_3 - 1.448325016033391e-03*G0_4 - 4.566790591097076e-05*G0_5 - 2.482376885588773e-03*G0_6 - 3.969845820974424e-03*G0_7 + 7.704828125835324e-03*G0_8 - 9.583736254743510e-03*G0_9 + 1.470506570333008e-02*G0_10 + 7.352532851665039e-03*G0_11 - 7.352532851665038e-03*G0_12 + 5.760680131340044e-03*G0_13 - 2.482376885588772e-03*G0_14 + 1.024265889717313e-02*G0_15 - 3.816532136844761e-03*G0_16 + 7.828783870450748e-04*G0_17 + 9.785979838062820e-05*G0_18 - 1.370037177328881e-03*G0_19 - 2.805314220244871e-03*G0_20;
    block[11] = 1.181363486051025e-03*G0_0 - 2.296443268665588e-05*G0_1 + 3.636470107824398e-04*G0_2 - 2.482376885588783e-03*G0_3 - 4.566790591095859e-05*G0_4 - 1.448325016033404e-03*G0_5 - 4.110111531986670e-04*G0_6 - 2.482376885588778e-03*G0_7 + 5.760680131340050e-03*G0_8 - 7.352532851665043e-03*G0_9 + 7.352532851665040e-03*G0_10 + 1.470506570333011e-02*G0_11 - 9.583736254743529e-03*G0_12 + 7.704828125835342e-03*G0_13 - 3.969845820974436e-03*G0_14 + 1.024265889717313e-02*G0_15 + 9.785979838065351e-05*G0_16 - 2.805314220244898e-03*G0_17 - 3.816532136844784e-03*G0_18 - 1.370037177328875e-03*G0_19 + 7.828783870450734e-04*G0_20;
    block[12] = -9.582431457431747e-04*G0_0 + 4.626811267436472e-04*G0_1 + 2.072018131045993e-04*G0_2 + 5.760680131340069e-03*G0_3 - 1.356989204211485e-03*G0_4 + 2.818362193362299e-03*G0_5 - 1.448325016033403e-03*G0_6 - 4.566790591096265e-05*G0_7 - 1.356989204211469e-03*G0_8 + 2.948841924536464e-03*G0_9 - 7.352532851665037e-03*G0_10 - 9.583736254743529e-03*G0_11 + 2.207717051467130e-02*G0_12 - 1.347855623029283e-02*G0_13 + 7.704828125835362e-03*G0_14 - 1.435277042915954e-03*G0_15 + 5.284429112554269e-03*G0_16 + 5.088709515793082e-03*G0_17 - 5.480148709315561e-03*G0_18 - 5.871587902838410e-04*G0_19 + 3.131513548180335e-03*G0_20;
    block[13] = 4.626811267436394e-04*G0_0 - 9.582431457431827e-04*G0_1 + 2.072018131045969e-04*G0_2 - 7.352532851665069e-03*G0_3 + 2.948841924536486e-03*G0_4 - 1.356989204211487e-03*G0_5 - 4.566790591095773e-05*G0_6 - 1.448325016033397e-03*G0_7 + 2.818362193362284e-03*G0_8 - 1.356989204211469e-03*G0_9 + 5.760680131340044e-03*G0_10 + 7.704828125835341e-03*G0_11 - 1.347855623029283e-02*G0_12 + 2.207717051467131e-02*G0_13 - 9.583736254743560e-03*G0_14 + 5.088709515793008e-03*G0_15 + 5.284429112554326e-03*G0_16 - 1.435277042916034e-03*G0_17 - 5.871587902838187e-04*G0_18 - 5.480148709315538e-03*G0_19 + 3.131513548180314e-03*G0_20;
    block[14] = -2.296443268665225e-05*G0_0 + 1.181363486051034e-03*G0_1 + 3.636470107824412e-04*G0_2 + 7.352532851665067e-03*G0_3 - 7.352532851665064e-03*G0_4 + 5.760680131340063e-03*G0_5 - 2.482376885588778e-03*G0_6 - 4.110111531986652e-04*G0_7 - 1.448325016033399e-03*G0_8 - 4.566790591096062e-05*G0_9 - 2.482376885588772e-03*G0_10 - 3.969845820974436e-03*G0_11 + 7.704828125835362e-03*G0_12 - 9.583736254743560e-03*G0_13 + 1.470506570333013e-02*G0_14 - 2.805314220244861e-03*G0_15 + 9.785979838061871e-05*G0_16 + 1.024265889717318e-02*G0_17 - 1.370037177328888e-03*G0_18 - 3.816532136844781e-03*G0_19 + 7.828783870450921e-04*G0_20;
    block[15] = 8.924813612313880e-04*G0_0 + 8.794333881139787e-04*G0_1 + 8.794333881139737e-04*G0_2 + 7.828783870450872e-04*G0_3 + 3.131513548180327e-03*G0_4 + 3.131513548180318e-03*G0_5 + 7.828783870450762e-04*G0_6 - 2.805314220244875e-03*G0_7 + 5.088709515793031e-03*G0_8 - 1.435277042915981e-03*G0_9 + 1.024265889717313e-02*G0_10 + 1.024265889717313e-02*G0_11 - 1.435277042915956e-03*G0_12 + 5.088709515793009e-03*G0_13 - 2.805314220244861e-03*G0_14 + 7.045905483405726e-02*G0_15 - 1.565756774090156e-02*G0_16 + 1.174317580567625e-02*G0_17 - 1.565756774090161e-02*G0_18 + 3.914391935225382e-03*G0_19 + 1.174317580567621e-02*G0_20;
    block[16] = -9.746835918711232e-04*G0_0 - 9.746835918711270e-04*G0_1 + 6.497890612474173e-04*G0_2 - 3.816532136844791e-03*G0_3 - 5.480148709315562e-03*G0_4 - 5.871587902838053e-04*G0_5 - 1.370037177328891e-03*G0_6 - 1.370037177328895e-03*G0_7 - 5.871587902838017e-04*G0_8 - 5.480148709315572e-03*G0_9 - 3.816532136844761e-03*G0_10 + 9.785979838065346e-05*G0_11 + 5.284429112554271e-03*G0_12 + 5.284429112554323e-03*G0_13 + 9.785979838061871e-05*G0_14 - 1.565756774090156e-02*G0_15 + 7.633064273689541e-02*G0_16 - 1.565756774090166e-02*G0_17 - 1.174317580567622e-02*G0_18 - 1.174317580567617e-02*G0_19 + 3.914391935225399e-03*G0_20;
    block[17] = 8.794333881139758e-04*G0_0 + 8.924813612313984e-04*G0_1 + 8.794333881139768e-04*G0_2 + 1.024265889717319e-02*G0_3 - 1.435277042915993e-03*G0_4 + 5.088709515793026e-03*G0_5 - 2.805314220244872e-03*G0_6 + 7.828783870450879e-04*G0_7 + 3.131513548180305e-03*G0_8 + 3.131513548180341e-03*G0_9 + 7.828783870450748e-04*G0_10 - 2.805314220244898e-03*G0_11 + 5.088709515793082e-03*G0_12 - 1.435277042916038e-03*G0_13 + 1.024265889717318e-02*G0_14 + 1.174317580567625e-02*G0_15 - 1.565756774090166e-02*G0_16 + 7.045905483405736e-02*G0_17 + 3.914391935225399e-03*G0_18 - 1.565756774090162e-02*G0_19 + 1.174317580567623e-02*G0_20;
    block[18] = -9.746835918711256e-04*G0_0 + 6.497890612474135e-04*G0_1 - 9.746835918711287e-04*G0_2 - 1.370037177328890e-03*G0_3 - 5.871587902838063e-04*G0_4 - 5.480148709315560e-03*G0_5 - 3.816532136844775e-03*G0_6 + 9.785979838063303e-05*G0_7 + 5.284429112554282e-03*G0_8 + 5.284429112554301e-03*G0_9 + 9.785979838062863e-05*G0_10 - 3.816532136844784e-03*G0_11 - 5.480148709315561e-03*G0_12 - 5.871587902838182e-04*G0_13 - 1.370037177328888e-03*G0_14 - 1.565756774090160e-02*G0_15 - 1.174317580567622e-02*G0_16 + 3.914391935225399e-03*G0_17 + 7.633064273689541e-02*G0_18 - 1.174317580567615e-02*G0_19 - 1.565756774090164e-02*G0_20;
    block[19] = 6.497890612474170e-04*G0_0 - 9.746835918711223e-04*G0_1 - 9.746835918711252e-04*G0_2 + 9.785979838062127e-05*G0_3 + 5.284429112554298e-03*G0_4 + 5.284429112554293e-03*G0_5 + 9.785979838062940e-05*G0_6 - 3.816532136844776e-03*G0_7 - 5.480148709315536e-03*G0_8 - 5.871587902838293e-04*G0_9 - 1.370037177328880e-03*G0_10 - 1.370037177328875e-03*G0_11 - 5.871587902838409e-04*G0_12 - 5.480148709315538e-03*G0_13 - 3.816532136844782e-03*G0_14 + 3.914391935225381e-03*G0_15 - 1.174317580567616e-02*G0_16 - 1.565756774090162e-02*G0_17 - 1.174317580567615e-02*G0_18 + 7.633064273689529e-02*G0_19 - 1.565756774090162e-02*G0_20;
    block[20] = 8.794333881139740e-04*G0_0 + 8.794333881139830e-04*G0_1 + 8.924813612313905e-04*G0_2 - 2.805314220244867e-03*G0_3 + 5.088709515793021e-03*G0_4 - 1.435277042915973e-03*G0_5 + 1.024265889717314e-02*G0_6 + 1.024265889717314e-02*G0_7 - 1.435277042915990e-03*G0_8 + 5.088709515793030e-03*G0_9 - 2.805314220244872e-03*G0_10 + 7.828783870450734e-04*G0_11 + 3.131513548180335e-03*G0_12 + 3.131513548180314e-03*G0_13 + 7.828783870450917e-04*G0_14 + 1.174317580567621e-02*G0_15 + 3.914391935225399e-03*G0_16 + 1.174317580567623e-02*G0_17 - 1.565756774090164e-02*G0_18 - 1.565756774090162e-02*G0_19 + 7.045905483405727e-02*G0_20;
  }

};

} }

#endif
