// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.8.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __NSECONTINUITY_H
#define __NSECONTINUITY_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace NSEContinuity {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
    }

  private:

    unsigned int* tensordims;

  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0_0 = map.det*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G0_0_1 = map.det*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G0_0_2 = map.det*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G0_1_0 = map.det*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G0_1_1 = map.det*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G0_1_2 = map.det*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G0_2_0 = map.det*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G0_2_1 = map.det*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G0_2_2 = map.det*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);

    // Compute element tensor
    block[0] = 1.666666666666664e-01*G0_0_0 + 1.666666666666664e-01*G0_0_1 + 1.666666666666664e-01*G0_0_2 + 1.666666666666664e-01*G0_1_0 + 1.666666666666665e-01*G0_1_1 + 1.666666666666665e-01*G0_1_2 + 1.666666666666664e-01*G0_2_0 + 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G0_2_2;
    block[1] = -1.666666666666664e-01*G0_0_0 - 1.666666666666664e-01*G0_1_0 - 1.666666666666664e-01*G0_2_0;
    block[2] = -1.666666666666664e-01*G0_0_1 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_2_1;
    block[3] = -1.666666666666664e-01*G0_0_2 - 1.666666666666665e-01*G0_1_2 - 1.666666666666665e-01*G0_2_2;
    block[4] = -1.666666666666664e-01*G0_0_0 - 1.666666666666664e-01*G0_0_1 - 1.666666666666664e-01*G0_0_2;
    block[5] = 1.666666666666664e-01*G0_0_0;
    block[6] = 1.666666666666664e-01*G0_0_1;
    block[7] = 1.666666666666664e-01*G0_0_2;
    block[8] = -1.666666666666664e-01*G0_1_0 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_1_2;
    block[9] = 1.666666666666664e-01*G0_1_0;
    block[10] = 1.666666666666665e-01*G0_1_1;
    block[11] = 1.666666666666665e-01*G0_1_2;
    block[12] = -1.666666666666664e-01*G0_2_0 - 1.666666666666665e-01*G0_2_1 - 1.666666666666665e-01*G0_2_2;
    block[13] = 1.666666666666664e-01*G0_2_0;
    block[14] = 1.666666666666665e-01*G0_2_1;
    block[15] = 1.666666666666665e-01*G0_2_2;

  }

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_1 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_1() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_1()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_2 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_2() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_2()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = 3*cell.id() + 0;
      dofs[1] = 3*cell.id() + 1;
      dofs[2] = 3*cell.id() + 2;
      int offset = 3*mesh.noCells();
      dofs[3] = offset + 3*cell.id() + 0;
      dofs[4] = offset + 3*cell.id() + 1;
      dofs[5] = offset + 3*cell.id() + 2;
      offset = offset + 3*mesh.noCells();
      dofs[6] = offset + 3*cell.id() + 0;
      dofs[7] = offset + 3*cell.id() + 1;
      dofs[8] = offset + 3*cell.id() + 2;
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[1] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[2] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 1;
      components[2] = 2;
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0, Function& w1, Function& w2, const real& c0) : dolfin::LinearForm(3), c0(c0)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
    add(w1, new FunctionElement_1());
    add(w2, new FunctionElement_2());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0_0_0 = map.det*c[1][0]*map.g00;
    real G0_0_0_1 = map.det*c[1][1]*map.g00;
    real G0_0_0_2 = map.det*c[1][2]*map.g00;
    real G0_0_0_3 = map.det*c[1][3]*map.g00;
    real G0_0_1_0 = map.det*c[1][0]*map.g10;
    real G0_0_1_1 = map.det*c[1][1]*map.g10;
    real G0_0_1_2 = map.det*c[1][2]*map.g10;
    real G0_0_1_3 = map.det*c[1][3]*map.g10;
    real G0_0_2_0 = map.det*c[1][0]*map.g20;
    real G0_0_2_1 = map.det*c[1][1]*map.g20;
    real G0_0_2_2 = map.det*c[1][2]*map.g20;
    real G0_0_2_3 = map.det*c[1][3]*map.g20;
    real G0_1_0_4 = map.det*c[1][4]*map.g01;
    real G0_1_0_5 = map.det*c[1][5]*map.g01;
    real G0_1_0_6 = map.det*c[1][6]*map.g01;
    real G0_1_0_7 = map.det*c[1][7]*map.g01;
    real G0_1_1_4 = map.det*c[1][4]*map.g11;
    real G0_1_1_5 = map.det*c[1][5]*map.g11;
    real G0_1_1_6 = map.det*c[1][6]*map.g11;
    real G0_1_1_7 = map.det*c[1][7]*map.g11;
    real G0_1_2_4 = map.det*c[1][4]*map.g21;
    real G0_1_2_5 = map.det*c[1][5]*map.g21;
    real G0_1_2_6 = map.det*c[1][6]*map.g21;
    real G0_1_2_7 = map.det*c[1][7]*map.g21;
    real G0_2_0_8 = map.det*c[1][8]*map.g02;
    real G0_2_0_9 = map.det*c[1][9]*map.g02;
    real G0_2_0_10 = map.det*c[1][10]*map.g02;
    real G0_2_0_11 = map.det*c[1][11]*map.g02;
    real G0_2_1_8 = map.det*c[1][8]*map.g12;
    real G0_2_1_9 = map.det*c[1][9]*map.g12;
    real G0_2_1_10 = map.det*c[1][10]*map.g12;
    real G0_2_1_11 = map.det*c[1][11]*map.g12;
    real G0_2_2_8 = map.det*c[1][8]*map.g22;
    real G0_2_2_9 = map.det*c[1][9]*map.g22;
    real G0_2_2_10 = map.det*c[1][10]*map.g22;
    real G0_2_2_11 = map.det*c[1][11]*map.g22;
    real G1_0_0_0_0_0_0 = map.det*c[2][0]*c[0][0]*map.g00*map.g00;
    real G1_0_0_0_0_0_1 = map.det*c[2][0]*c[0][0]*map.g00*map.g10;
    real G1_0_0_0_0_0_2 = map.det*c[2][0]*c[0][0]*map.g00*map.g20;
    real G1_0_0_0_0_1_0 = map.det*c[2][0]*c[0][1]*map.g00*map.g00;
    real G1_0_0_0_0_2_1 = map.det*c[2][0]*c[0][2]*map.g00*map.g10;
    real G1_0_0_0_0_3_2 = map.det*c[2][0]*c[0][3]*map.g00*map.g20;
    real G1_0_0_1_0_0_0 = map.det*c[2][0]*c[0][0]*map.g10*map.g00;
    real G1_0_0_1_0_0_1 = map.det*c[2][0]*c[0][0]*map.g10*map.g10;
    real G1_0_0_1_0_0_2 = map.det*c[2][0]*c[0][0]*map.g10*map.g20;
    real G1_0_0_1_0_1_0 = map.det*c[2][0]*c[0][1]*map.g10*map.g00;
    real G1_0_0_1_0_2_1 = map.det*c[2][0]*c[0][2]*map.g10*map.g10;
    real G1_0_0_1_0_3_2 = map.det*c[2][0]*c[0][3]*map.g10*map.g20;
    real G1_0_0_2_0_0_0 = map.det*c[2][0]*c[0][0]*map.g20*map.g00;
    real G1_0_0_2_0_0_1 = map.det*c[2][0]*c[0][0]*map.g20*map.g10;
    real G1_0_0_2_0_0_2 = map.det*c[2][0]*c[0][0]*map.g20*map.g20;
    real G1_0_0_2_0_1_0 = map.det*c[2][0]*c[0][1]*map.g20*map.g00;
    real G1_0_0_2_0_2_1 = map.det*c[2][0]*c[0][2]*map.g20*map.g10;
    real G1_0_0_2_0_3_2 = map.det*c[2][0]*c[0][3]*map.g20*map.g20;
    real G1_0_1_0_1_0_0 = map.det*c[2][1]*c[0][0]*map.g00*map.g01;
    real G1_0_1_0_1_0_1 = map.det*c[2][1]*c[0][0]*map.g00*map.g11;
    real G1_0_1_0_1_0_2 = map.det*c[2][1]*c[0][0]*map.g00*map.g21;
    real G1_0_1_0_1_1_0 = map.det*c[2][1]*c[0][1]*map.g00*map.g01;
    real G1_0_1_0_1_2_1 = map.det*c[2][1]*c[0][2]*map.g00*map.g11;
    real G1_0_1_0_1_3_2 = map.det*c[2][1]*c[0][3]*map.g00*map.g21;
    real G1_0_1_1_1_0_0 = map.det*c[2][1]*c[0][0]*map.g10*map.g01;
    real G1_0_1_1_1_0_1 = map.det*c[2][1]*c[0][0]*map.g10*map.g11;
    real G1_0_1_1_1_0_2 = map.det*c[2][1]*c[0][0]*map.g10*map.g21;
    real G1_0_1_1_1_1_0 = map.det*c[2][1]*c[0][1]*map.g10*map.g01;
    real G1_0_1_1_1_2_1 = map.det*c[2][1]*c[0][2]*map.g10*map.g11;
    real G1_0_1_1_1_3_2 = map.det*c[2][1]*c[0][3]*map.g10*map.g21;
    real G1_0_1_2_1_0_0 = map.det*c[2][1]*c[0][0]*map.g20*map.g01;
    real G1_0_1_2_1_0_1 = map.det*c[2][1]*c[0][0]*map.g20*map.g11;
    real G1_0_1_2_1_0_2 = map.det*c[2][1]*c[0][0]*map.g20*map.g21;
    real G1_0_1_2_1_1_0 = map.det*c[2][1]*c[0][1]*map.g20*map.g01;
    real G1_0_1_2_1_2_1 = map.det*c[2][1]*c[0][2]*map.g20*map.g11;
    real G1_0_1_2_1_3_2 = map.det*c[2][1]*c[0][3]*map.g20*map.g21;
    real G1_0_2_0_2_0_0 = map.det*c[2][2]*c[0][0]*map.g00*map.g02;
    real G1_0_2_0_2_0_1 = map.det*c[2][2]*c[0][0]*map.g00*map.g12;
    real G1_0_2_0_2_0_2 = map.det*c[2][2]*c[0][0]*map.g00*map.g22;
    real G1_0_2_0_2_1_0 = map.det*c[2][2]*c[0][1]*map.g00*map.g02;
    real G1_0_2_0_2_2_1 = map.det*c[2][2]*c[0][2]*map.g00*map.g12;
    real G1_0_2_0_2_3_2 = map.det*c[2][2]*c[0][3]*map.g00*map.g22;
    real G1_0_2_1_2_0_0 = map.det*c[2][2]*c[0][0]*map.g10*map.g02;
    real G1_0_2_1_2_0_1 = map.det*c[2][2]*c[0][0]*map.g10*map.g12;
    real G1_0_2_1_2_0_2 = map.det*c[2][2]*c[0][0]*map.g10*map.g22;
    real G1_0_2_1_2_1_0 = map.det*c[2][2]*c[0][1]*map.g10*map.g02;
    real G1_0_2_1_2_2_1 = map.det*c[2][2]*c[0][2]*map.g10*map.g12;
    real G1_0_2_1_2_3_2 = map.det*c[2][2]*c[0][3]*map.g10*map.g22;
    real G1_0_2_2_2_0_0 = map.det*c[2][2]*c[0][0]*map.g20*map.g02;
    real G1_0_2_2_2_0_1 = map.det*c[2][2]*c[0][0]*map.g20*map.g12;
    real G1_0_2_2_2_0_2 = map.det*c[2][2]*c[0][0]*map.g20*map.g22;
    real G1_0_2_2_2_1_0 = map.det*c[2][2]*c[0][1]*map.g20*map.g02;
    real G1_0_2_2_2_2_1 = map.det*c[2][2]*c[0][2]*map.g20*map.g12;
    real G1_0_2_2_2_3_2 = map.det*c[2][2]*c[0][3]*map.g20*map.g22;
    real G1_1_0_0_0_4_0 = map.det*c[2][0]*c[0][4]*map.g01*map.g00;
    real G1_1_0_0_0_4_1 = map.det*c[2][0]*c[0][4]*map.g01*map.g10;
    real G1_1_0_0_0_4_2 = map.det*c[2][0]*c[0][4]*map.g01*map.g20;
    real G1_1_0_0_0_5_0 = map.det*c[2][0]*c[0][5]*map.g01*map.g00;
    real G1_1_0_0_0_6_1 = map.det*c[2][0]*c[0][6]*map.g01*map.g10;
    real G1_1_0_0_0_7_2 = map.det*c[2][0]*c[0][7]*map.g01*map.g20;
    real G1_1_0_1_0_4_0 = map.det*c[2][0]*c[0][4]*map.g11*map.g00;
    real G1_1_0_1_0_4_1 = map.det*c[2][0]*c[0][4]*map.g11*map.g10;
    real G1_1_0_1_0_4_2 = map.det*c[2][0]*c[0][4]*map.g11*map.g20;
    real G1_1_0_1_0_5_0 = map.det*c[2][0]*c[0][5]*map.g11*map.g00;
    real G1_1_0_1_0_6_1 = map.det*c[2][0]*c[0][6]*map.g11*map.g10;
    real G1_1_0_1_0_7_2 = map.det*c[2][0]*c[0][7]*map.g11*map.g20;
    real G1_1_0_2_0_4_0 = map.det*c[2][0]*c[0][4]*map.g21*map.g00;
    real G1_1_0_2_0_4_1 = map.det*c[2][0]*c[0][4]*map.g21*map.g10;
    real G1_1_0_2_0_4_2 = map.det*c[2][0]*c[0][4]*map.g21*map.g20;
    real G1_1_0_2_0_5_0 = map.det*c[2][0]*c[0][5]*map.g21*map.g00;
    real G1_1_0_2_0_6_1 = map.det*c[2][0]*c[0][6]*map.g21*map.g10;
    real G1_1_0_2_0_7_2 = map.det*c[2][0]*c[0][7]*map.g21*map.g20;
    real G1_1_1_0_1_4_0 = map.det*c[2][1]*c[0][4]*map.g01*map.g01;
    real G1_1_1_0_1_4_1 = map.det*c[2][1]*c[0][4]*map.g01*map.g11;
    real G1_1_1_0_1_4_2 = map.det*c[2][1]*c[0][4]*map.g01*map.g21;
    real G1_1_1_0_1_5_0 = map.det*c[2][1]*c[0][5]*map.g01*map.g01;
    real G1_1_1_0_1_6_1 = map.det*c[2][1]*c[0][6]*map.g01*map.g11;
    real G1_1_1_0_1_7_2 = map.det*c[2][1]*c[0][7]*map.g01*map.g21;
    real G1_1_1_1_1_4_0 = map.det*c[2][1]*c[0][4]*map.g11*map.g01;
    real G1_1_1_1_1_4_1 = map.det*c[2][1]*c[0][4]*map.g11*map.g11;
    real G1_1_1_1_1_4_2 = map.det*c[2][1]*c[0][4]*map.g11*map.g21;
    real G1_1_1_1_1_5_0 = map.det*c[2][1]*c[0][5]*map.g11*map.g01;
    real G1_1_1_1_1_6_1 = map.det*c[2][1]*c[0][6]*map.g11*map.g11;
    real G1_1_1_1_1_7_2 = map.det*c[2][1]*c[0][7]*map.g11*map.g21;
    real G1_1_1_2_1_4_0 = map.det*c[2][1]*c[0][4]*map.g21*map.g01;
    real G1_1_1_2_1_4_1 = map.det*c[2][1]*c[0][4]*map.g21*map.g11;
    real G1_1_1_2_1_4_2 = map.det*c[2][1]*c[0][4]*map.g21*map.g21;
    real G1_1_1_2_1_5_0 = map.det*c[2][1]*c[0][5]*map.g21*map.g01;
    real G1_1_1_2_1_6_1 = map.det*c[2][1]*c[0][6]*map.g21*map.g11;
    real G1_1_1_2_1_7_2 = map.det*c[2][1]*c[0][7]*map.g21*map.g21;
    real G1_1_2_0_2_4_0 = map.det*c[2][2]*c[0][4]*map.g01*map.g02;
    real G1_1_2_0_2_4_1 = map.det*c[2][2]*c[0][4]*map.g01*map.g12;
    real G1_1_2_0_2_4_2 = map.det*c[2][2]*c[0][4]*map.g01*map.g22;
    real G1_1_2_0_2_5_0 = map.det*c[2][2]*c[0][5]*map.g01*map.g02;
    real G1_1_2_0_2_6_1 = map.det*c[2][2]*c[0][6]*map.g01*map.g12;
    real G1_1_2_0_2_7_2 = map.det*c[2][2]*c[0][7]*map.g01*map.g22;
    real G1_1_2_1_2_4_0 = map.det*c[2][2]*c[0][4]*map.g11*map.g02;
    real G1_1_2_1_2_4_1 = map.det*c[2][2]*c[0][4]*map.g11*map.g12;
    real G1_1_2_1_2_4_2 = map.det*c[2][2]*c[0][4]*map.g11*map.g22;
    real G1_1_2_1_2_5_0 = map.det*c[2][2]*c[0][5]*map.g11*map.g02;
    real G1_1_2_1_2_6_1 = map.det*c[2][2]*c[0][6]*map.g11*map.g12;
    real G1_1_2_1_2_7_2 = map.det*c[2][2]*c[0][7]*map.g11*map.g22;
    real G1_1_2_2_2_4_0 = map.det*c[2][2]*c[0][4]*map.g21*map.g02;
    real G1_1_2_2_2_4_1 = map.det*c[2][2]*c[0][4]*map.g21*map.g12;
    real G1_1_2_2_2_4_2 = map.det*c[2][2]*c[0][4]*map.g21*map.g22;
    real G1_1_2_2_2_5_0 = map.det*c[2][2]*c[0][5]*map.g21*map.g02;
    real G1_1_2_2_2_6_1 = map.det*c[2][2]*c[0][6]*map.g21*map.g12;
    real G1_1_2_2_2_7_2 = map.det*c[2][2]*c[0][7]*map.g21*map.g22;
    real G1_2_0_0_0_8_0 = map.det*c[2][0]*c[0][8]*map.g02*map.g00;
    real G1_2_0_0_0_8_1 = map.det*c[2][0]*c[0][8]*map.g02*map.g10;
    real G1_2_0_0_0_8_2 = map.det*c[2][0]*c[0][8]*map.g02*map.g20;
    real G1_2_0_0_0_9_0 = map.det*c[2][0]*c[0][9]*map.g02*map.g00;
    real G1_2_0_0_0_10_1 = map.det*c[2][0]*c[0][10]*map.g02*map.g10;
    real G1_2_0_0_0_11_2 = map.det*c[2][0]*c[0][11]*map.g02*map.g20;
    real G1_2_0_1_0_8_0 = map.det*c[2][0]*c[0][8]*map.g12*map.g00;
    real G1_2_0_1_0_8_1 = map.det*c[2][0]*c[0][8]*map.g12*map.g10;
    real G1_2_0_1_0_8_2 = map.det*c[2][0]*c[0][8]*map.g12*map.g20;
    real G1_2_0_1_0_9_0 = map.det*c[2][0]*c[0][9]*map.g12*map.g00;
    real G1_2_0_1_0_10_1 = map.det*c[2][0]*c[0][10]*map.g12*map.g10;
    real G1_2_0_1_0_11_2 = map.det*c[2][0]*c[0][11]*map.g12*map.g20;
    real G1_2_0_2_0_8_0 = map.det*c[2][0]*c[0][8]*map.g22*map.g00;
    real G1_2_0_2_0_8_1 = map.det*c[2][0]*c[0][8]*map.g22*map.g10;
    real G1_2_0_2_0_8_2 = map.det*c[2][0]*c[0][8]*map.g22*map.g20;
    real G1_2_0_2_0_9_0 = map.det*c[2][0]*c[0][9]*map.g22*map.g00;
    real G1_2_0_2_0_10_1 = map.det*c[2][0]*c[0][10]*map.g22*map.g10;
    real G1_2_0_2_0_11_2 = map.det*c[2][0]*c[0][11]*map.g22*map.g20;
    real G1_2_1_0_1_8_0 = map.det*c[2][1]*c[0][8]*map.g02*map.g01;
    real G1_2_1_0_1_8_1 = map.det*c[2][1]*c[0][8]*map.g02*map.g11;
    real G1_2_1_0_1_8_2 = map.det*c[2][1]*c[0][8]*map.g02*map.g21;
    real G1_2_1_0_1_9_0 = map.det*c[2][1]*c[0][9]*map.g02*map.g01;
    real G1_2_1_0_1_10_1 = map.det*c[2][1]*c[0][10]*map.g02*map.g11;
    real G1_2_1_0_1_11_2 = map.det*c[2][1]*c[0][11]*map.g02*map.g21;
    real G1_2_1_1_1_8_0 = map.det*c[2][1]*c[0][8]*map.g12*map.g01;
    real G1_2_1_1_1_8_1 = map.det*c[2][1]*c[0][8]*map.g12*map.g11;
    real G1_2_1_1_1_8_2 = map.det*c[2][1]*c[0][8]*map.g12*map.g21;
    real G1_2_1_1_1_9_0 = map.det*c[2][1]*c[0][9]*map.g12*map.g01;
    real G1_2_1_1_1_10_1 = map.det*c[2][1]*c[0][10]*map.g12*map.g11;
    real G1_2_1_1_1_11_2 = map.det*c[2][1]*c[0][11]*map.g12*map.g21;
    real G1_2_1_2_1_8_0 = map.det*c[2][1]*c[0][8]*map.g22*map.g01;
    real G1_2_1_2_1_8_1 = map.det*c[2][1]*c[0][8]*map.g22*map.g11;
    real G1_2_1_2_1_8_2 = map.det*c[2][1]*c[0][8]*map.g22*map.g21;
    real G1_2_1_2_1_9_0 = map.det*c[2][1]*c[0][9]*map.g22*map.g01;
    real G1_2_1_2_1_10_1 = map.det*c[2][1]*c[0][10]*map.g22*map.g11;
    real G1_2_1_2_1_11_2 = map.det*c[2][1]*c[0][11]*map.g22*map.g21;
    real G1_2_2_0_2_8_0 = map.det*c[2][2]*c[0][8]*map.g02*map.g02;
    real G1_2_2_0_2_8_1 = map.det*c[2][2]*c[0][8]*map.g02*map.g12;
    real G1_2_2_0_2_8_2 = map.det*c[2][2]*c[0][8]*map.g02*map.g22;
    real G1_2_2_0_2_9_0 = map.det*c[2][2]*c[0][9]*map.g02*map.g02;
    real G1_2_2_0_2_10_1 = map.det*c[2][2]*c[0][10]*map.g02*map.g12;
    real G1_2_2_0_2_11_2 = map.det*c[2][2]*c[0][11]*map.g02*map.g22;
    real G1_2_2_1_2_8_0 = map.det*c[2][2]*c[0][8]*map.g12*map.g02;
    real G1_2_2_1_2_8_1 = map.det*c[2][2]*c[0][8]*map.g12*map.g12;
    real G1_2_2_1_2_8_2 = map.det*c[2][2]*c[0][8]*map.g12*map.g22;
    real G1_2_2_1_2_9_0 = map.det*c[2][2]*c[0][9]*map.g12*map.g02;
    real G1_2_2_1_2_10_1 = map.det*c[2][2]*c[0][10]*map.g12*map.g12;
    real G1_2_2_1_2_11_2 = map.det*c[2][2]*c[0][11]*map.g12*map.g22;
    real G1_2_2_2_2_8_0 = map.det*c[2][2]*c[0][8]*map.g22*map.g02;
    real G1_2_2_2_2_8_1 = map.det*c[2][2]*c[0][8]*map.g22*map.g12;
    real G1_2_2_2_2_8_2 = map.det*c[2][2]*c[0][8]*map.g22*map.g22;
    real G1_2_2_2_2_9_0 = map.det*c[2][2]*c[0][9]*map.g22*map.g02;
    real G1_2_2_2_2_10_1 = map.det*c[2][2]*c[0][10]*map.g22*map.g12;
    real G1_2_2_2_2_11_2 = map.det*c[2][2]*c[0][11]*map.g22*map.g22;
    real G2_0_0_0 = map.det*(1.0/c0)*c[0][0]*map.g00;
    real G2_0_0_1 = map.det*(1.0/c0)*c[0][0]*map.g10;
    real G2_0_0_2 = map.det*(1.0/c0)*c[0][0]*map.g20;
    real G2_0_1_0 = map.det*(1.0/c0)*c[0][1]*map.g00;
    real G2_0_2_1 = map.det*(1.0/c0)*c[0][2]*map.g10;
    real G2_0_3_2 = map.det*(1.0/c0)*c[0][3]*map.g20;
    real G2_1_4_0 = map.det*(1.0/c0)*c[0][4]*map.g01;
    real G2_1_4_1 = map.det*(1.0/c0)*c[0][4]*map.g11;
    real G2_1_4_2 = map.det*(1.0/c0)*c[0][4]*map.g21;
    real G2_1_5_0 = map.det*(1.0/c0)*c[0][5]*map.g01;
    real G2_1_6_1 = map.det*(1.0/c0)*c[0][6]*map.g11;
    real G2_1_7_2 = map.det*(1.0/c0)*c[0][7]*map.g21;
    real G2_2_8_0 = map.det*(1.0/c0)*c[0][8]*map.g02;
    real G2_2_8_1 = map.det*(1.0/c0)*c[0][8]*map.g12;
    real G2_2_8_2 = map.det*(1.0/c0)*c[0][8]*map.g22;
    real G2_2_9_0 = map.det*(1.0/c0)*c[0][9]*map.g02;
    real G2_2_10_1 = map.det*(1.0/c0)*c[0][10]*map.g12;
    real G2_2_11_2 = map.det*(1.0/c0)*c[0][11]*map.g22;

    // Compute element tensor
    block[0] = -4.166666666666662e-02*G0_0_0_0 - 4.166666666666660e-02*G0_0_0_1 - 4.166666666666661e-02*G0_0_0_2 - 4.166666666666661e-02*G0_0_0_3 - 4.166666666666662e-02*G0_0_1_0 - 4.166666666666661e-02*G0_0_1_1 - 4.166666666666662e-02*G0_0_1_2 - 4.166666666666662e-02*G0_0_1_3 - 4.166666666666662e-02*G0_0_2_0 - 4.166666666666661e-02*G0_0_2_1 - 4.166666666666662e-02*G0_0_2_2 - 4.166666666666662e-02*G0_0_2_3 - 4.166666666666661e-02*G0_1_0_4 - 4.166666666666661e-02*G0_1_0_5 - 4.166666666666661e-02*G0_1_0_6 - 4.166666666666661e-02*G0_1_0_7 - 4.166666666666662e-02*G0_1_1_4 - 4.166666666666662e-02*G0_1_1_5 - 4.166666666666662e-02*G0_1_1_6 - 4.166666666666662e-02*G0_1_1_7 - 4.166666666666662e-02*G0_1_2_4 - 4.166666666666662e-02*G0_1_2_5 - 4.166666666666662e-02*G0_1_2_6 - 4.166666666666662e-02*G0_1_2_7 - 4.166666666666661e-02*G0_2_0_8 - 4.166666666666661e-02*G0_2_0_9 - 4.166666666666661e-02*G0_2_0_10 - 4.166666666666661e-02*G0_2_0_11 - 4.166666666666662e-02*G0_2_1_8 - 4.166666666666662e-02*G0_2_1_9 - 4.166666666666662e-02*G0_2_1_10 - 4.166666666666662e-02*G0_2_1_11 - 4.166666666666662e-02*G0_2_2_8 - 4.166666666666662e-02*G0_2_2_9 - 4.166666666666662e-02*G0_2_2_10 - 4.166666666666662e-02*G0_2_2_11 - 1.666666666666664e-01*G1_0_0_0_0_0_0 - 1.666666666666664e-01*G1_0_0_0_0_0_1 - 1.666666666666664e-01*G1_0_0_0_0_0_2 + 1.666666666666664e-01*G1_0_0_0_0_1_0 + 1.666666666666664e-01*G1_0_0_0_0_2_1 + 1.666666666666664e-01*G1_0_0_0_0_3_2 - 1.666666666666664e-01*G1_0_0_1_0_0_0 - 1.666666666666665e-01*G1_0_0_1_0_0_1 - 1.666666666666664e-01*G1_0_0_1_0_0_2 + 1.666666666666664e-01*G1_0_0_1_0_1_0 + 1.666666666666665e-01*G1_0_0_1_0_2_1 + 1.666666666666665e-01*G1_0_0_1_0_3_2 - 1.666666666666664e-01*G1_0_0_2_0_0_0 - 1.666666666666665e-01*G1_0_0_2_0_0_1 - 1.666666666666664e-01*G1_0_0_2_0_0_2 + 1.666666666666664e-01*G1_0_0_2_0_1_0 + 1.666666666666665e-01*G1_0_0_2_0_2_1 + 1.666666666666665e-01*G1_0_0_2_0_3_2 - 1.666666666666664e-01*G1_0_1_0_1_0_0 - 1.666666666666664e-01*G1_0_1_0_1_0_1 - 1.666666666666664e-01*G1_0_1_0_1_0_2 + 1.666666666666664e-01*G1_0_1_0_1_1_0 + 1.666666666666664e-01*G1_0_1_0_1_2_1 + 1.666666666666664e-01*G1_0_1_0_1_3_2 - 1.666666666666664e-01*G1_0_1_1_1_0_0 - 1.666666666666665e-01*G1_0_1_1_1_0_1 - 1.666666666666664e-01*G1_0_1_1_1_0_2 + 1.666666666666664e-01*G1_0_1_1_1_1_0 + 1.666666666666665e-01*G1_0_1_1_1_2_1 + 1.666666666666665e-01*G1_0_1_1_1_3_2 - 1.666666666666664e-01*G1_0_1_2_1_0_0 - 1.666666666666665e-01*G1_0_1_2_1_0_1 - 1.666666666666664e-01*G1_0_1_2_1_0_2 + 1.666666666666664e-01*G1_0_1_2_1_1_0 + 1.666666666666665e-01*G1_0_1_2_1_2_1 + 1.666666666666665e-01*G1_0_1_2_1_3_2 - 1.666666666666664e-01*G1_0_2_0_2_0_0 - 1.666666666666664e-01*G1_0_2_0_2_0_1 - 1.666666666666664e-01*G1_0_2_0_2_0_2 + 1.666666666666664e-01*G1_0_2_0_2_1_0 + 1.666666666666664e-01*G1_0_2_0_2_2_1 + 1.666666666666664e-01*G1_0_2_0_2_3_2 - 1.666666666666664e-01*G1_0_2_1_2_0_0 - 1.666666666666665e-01*G1_0_2_1_2_0_1 - 1.666666666666664e-01*G1_0_2_1_2_0_2 + 1.666666666666664e-01*G1_0_2_1_2_1_0 + 1.666666666666665e-01*G1_0_2_1_2_2_1 + 1.666666666666665e-01*G1_0_2_1_2_3_2 - 1.666666666666664e-01*G1_0_2_2_2_0_0 - 1.666666666666665e-01*G1_0_2_2_2_0_1 - 1.666666666666664e-01*G1_0_2_2_2_0_2 + 1.666666666666664e-01*G1_0_2_2_2_1_0 + 1.666666666666665e-01*G1_0_2_2_2_2_1 + 1.666666666666665e-01*G1_0_2_2_2_3_2 - 1.666666666666664e-01*G1_1_0_0_0_4_0 - 1.666666666666664e-01*G1_1_0_0_0_4_1 - 1.666666666666664e-01*G1_1_0_0_0_4_2 + 1.666666666666664e-01*G1_1_0_0_0_5_0 + 1.666666666666664e-01*G1_1_0_0_0_6_1 + 1.666666666666664e-01*G1_1_0_0_0_7_2 - 1.666666666666664e-01*G1_1_0_1_0_4_0 - 1.666666666666665e-01*G1_1_0_1_0_4_1 - 1.666666666666665e-01*G1_1_0_1_0_4_2 + 1.666666666666664e-01*G1_1_0_1_0_5_0 + 1.666666666666665e-01*G1_1_0_1_0_6_1 + 1.666666666666665e-01*G1_1_0_1_0_7_2 - 1.666666666666664e-01*G1_1_0_2_0_4_0 - 1.666666666666665e-01*G1_1_0_2_0_4_1 - 1.666666666666665e-01*G1_1_0_2_0_4_2 + 1.666666666666664e-01*G1_1_0_2_0_5_0 + 1.666666666666665e-01*G1_1_0_2_0_6_1 + 1.666666666666665e-01*G1_1_0_2_0_7_2 - 1.666666666666664e-01*G1_1_1_0_1_4_0 - 1.666666666666664e-01*G1_1_1_0_1_4_1 - 1.666666666666664e-01*G1_1_1_0_1_4_2 + 1.666666666666664e-01*G1_1_1_0_1_5_0 + 1.666666666666664e-01*G1_1_1_0_1_6_1 + 1.666666666666664e-01*G1_1_1_0_1_7_2 - 1.666666666666664e-01*G1_1_1_1_1_4_0 - 1.666666666666665e-01*G1_1_1_1_1_4_1 - 1.666666666666665e-01*G1_1_1_1_1_4_2 + 1.666666666666664e-01*G1_1_1_1_1_5_0 + 1.666666666666665e-01*G1_1_1_1_1_6_1 + 1.666666666666665e-01*G1_1_1_1_1_7_2 - 1.666666666666664e-01*G1_1_1_2_1_4_0 - 1.666666666666665e-01*G1_1_1_2_1_4_1 - 1.666666666666665e-01*G1_1_1_2_1_4_2 + 1.666666666666664e-01*G1_1_1_2_1_5_0 + 1.666666666666665e-01*G1_1_1_2_1_6_1 + 1.666666666666665e-01*G1_1_1_2_1_7_2 - 1.666666666666664e-01*G1_1_2_0_2_4_0 - 1.666666666666664e-01*G1_1_2_0_2_4_1 - 1.666666666666664e-01*G1_1_2_0_2_4_2 + 1.666666666666664e-01*G1_1_2_0_2_5_0 + 1.666666666666664e-01*G1_1_2_0_2_6_1 + 1.666666666666664e-01*G1_1_2_0_2_7_2 - 1.666666666666664e-01*G1_1_2_1_2_4_0 - 1.666666666666665e-01*G1_1_2_1_2_4_1 - 1.666666666666665e-01*G1_1_2_1_2_4_2 + 1.666666666666664e-01*G1_1_2_1_2_5_0 + 1.666666666666665e-01*G1_1_2_1_2_6_1 + 1.666666666666665e-01*G1_1_2_1_2_7_2 - 1.666666666666664e-01*G1_1_2_2_2_4_0 - 1.666666666666665e-01*G1_1_2_2_2_4_1 - 1.666666666666665e-01*G1_1_2_2_2_4_2 + 1.666666666666664e-01*G1_1_2_2_2_5_0 + 1.666666666666665e-01*G1_1_2_2_2_6_1 + 1.666666666666665e-01*G1_1_2_2_2_7_2 - 1.666666666666664e-01*G1_2_0_0_0_8_0 - 1.666666666666664e-01*G1_2_0_0_0_8_1 - 1.666666666666664e-01*G1_2_0_0_0_8_2 + 1.666666666666664e-01*G1_2_0_0_0_9_0 + 1.666666666666664e-01*G1_2_0_0_0_10_1 + 1.666666666666664e-01*G1_2_0_0_0_11_2 - 1.666666666666664e-01*G1_2_0_1_0_8_0 - 1.666666666666665e-01*G1_2_0_1_0_8_1 - 1.666666666666665e-01*G1_2_0_1_0_8_2 + 1.666666666666664e-01*G1_2_0_1_0_9_0 + 1.666666666666665e-01*G1_2_0_1_0_10_1 + 1.666666666666665e-01*G1_2_0_1_0_11_2 - 1.666666666666664e-01*G1_2_0_2_0_8_0 - 1.666666666666665e-01*G1_2_0_2_0_8_1 - 1.666666666666665e-01*G1_2_0_2_0_8_2 + 1.666666666666664e-01*G1_2_0_2_0_9_0 + 1.666666666666665e-01*G1_2_0_2_0_10_1 + 1.666666666666665e-01*G1_2_0_2_0_11_2 - 1.666666666666664e-01*G1_2_1_0_1_8_0 - 1.666666666666664e-01*G1_2_1_0_1_8_1 - 1.666666666666664e-01*G1_2_1_0_1_8_2 + 1.666666666666664e-01*G1_2_1_0_1_9_0 + 1.666666666666664e-01*G1_2_1_0_1_10_1 + 1.666666666666664e-01*G1_2_1_0_1_11_2 - 1.666666666666664e-01*G1_2_1_1_1_8_0 - 1.666666666666665e-01*G1_2_1_1_1_8_1 - 1.666666666666665e-01*G1_2_1_1_1_8_2 + 1.666666666666664e-01*G1_2_1_1_1_9_0 + 1.666666666666665e-01*G1_2_1_1_1_10_1 + 1.666666666666665e-01*G1_2_1_1_1_11_2 - 1.666666666666664e-01*G1_2_1_2_1_8_0 - 1.666666666666665e-01*G1_2_1_2_1_8_1 - 1.666666666666665e-01*G1_2_1_2_1_8_2 + 1.666666666666664e-01*G1_2_1_2_1_9_0 + 1.666666666666665e-01*G1_2_1_2_1_10_1 + 1.666666666666665e-01*G1_2_1_2_1_11_2 - 1.666666666666664e-01*G1_2_2_0_2_8_0 - 1.666666666666664e-01*G1_2_2_0_2_8_1 - 1.666666666666664e-01*G1_2_2_0_2_8_2 + 1.666666666666664e-01*G1_2_2_0_2_9_0 + 1.666666666666664e-01*G1_2_2_0_2_10_1 + 1.666666666666664e-01*G1_2_2_0_2_11_2 - 1.666666666666664e-01*G1_2_2_1_2_8_0 - 1.666666666666665e-01*G1_2_2_1_2_8_1 - 1.666666666666665e-01*G1_2_2_1_2_8_2 + 1.666666666666664e-01*G1_2_2_1_2_9_0 + 1.666666666666665e-01*G1_2_2_1_2_10_1 + 1.666666666666665e-01*G1_2_2_1_2_11_2 - 1.666666666666664e-01*G1_2_2_2_2_8_0 - 1.666666666666665e-01*G1_2_2_2_2_8_1 - 1.666666666666665e-01*G1_2_2_2_2_8_2 + 1.666666666666664e-01*G1_2_2_2_2_9_0 + 1.666666666666665e-01*G1_2_2_2_2_10_1 + 1.666666666666665e-01*G1_2_2_2_2_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;
    block[1] = 4.166666666666662e-02*G0_0_0_0 + 4.166666666666660e-02*G0_0_0_1 + 4.166666666666661e-02*G0_0_0_2 + 4.166666666666661e-02*G0_0_0_3 + 4.166666666666661e-02*G0_1_0_4 + 4.166666666666661e-02*G0_1_0_5 + 4.166666666666661e-02*G0_1_0_6 + 4.166666666666661e-02*G0_1_0_7 + 4.166666666666661e-02*G0_2_0_8 + 4.166666666666661e-02*G0_2_0_9 + 4.166666666666661e-02*G0_2_0_10 + 4.166666666666661e-02*G0_2_0_11 + 1.666666666666664e-01*G1_0_0_0_0_0_0 + 1.666666666666664e-01*G1_0_0_0_0_0_1 + 1.666666666666664e-01*G1_0_0_0_0_0_2 - 1.666666666666664e-01*G1_0_0_0_0_1_0 - 1.666666666666664e-01*G1_0_0_0_0_2_1 - 1.666666666666664e-01*G1_0_0_0_0_3_2 + 1.666666666666664e-01*G1_0_1_0_1_0_0 + 1.666666666666664e-01*G1_0_1_0_1_0_1 + 1.666666666666664e-01*G1_0_1_0_1_0_2 - 1.666666666666664e-01*G1_0_1_0_1_1_0 - 1.666666666666664e-01*G1_0_1_0_1_2_1 - 1.666666666666664e-01*G1_0_1_0_1_3_2 + 1.666666666666664e-01*G1_0_2_0_2_0_0 + 1.666666666666664e-01*G1_0_2_0_2_0_1 + 1.666666666666664e-01*G1_0_2_0_2_0_2 - 1.666666666666664e-01*G1_0_2_0_2_1_0 - 1.666666666666664e-01*G1_0_2_0_2_2_1 - 1.666666666666664e-01*G1_0_2_0_2_3_2 + 1.666666666666664e-01*G1_1_0_0_0_4_0 + 1.666666666666664e-01*G1_1_0_0_0_4_1 + 1.666666666666664e-01*G1_1_0_0_0_4_2 - 1.666666666666664e-01*G1_1_0_0_0_5_0 - 1.666666666666664e-01*G1_1_0_0_0_6_1 - 1.666666666666664e-01*G1_1_0_0_0_7_2 + 1.666666666666664e-01*G1_1_1_0_1_4_0 + 1.666666666666664e-01*G1_1_1_0_1_4_1 + 1.666666666666664e-01*G1_1_1_0_1_4_2 - 1.666666666666664e-01*G1_1_1_0_1_5_0 - 1.666666666666664e-01*G1_1_1_0_1_6_1 - 1.666666666666664e-01*G1_1_1_0_1_7_2 + 1.666666666666664e-01*G1_1_2_0_2_4_0 + 1.666666666666664e-01*G1_1_2_0_2_4_1 + 1.666666666666664e-01*G1_1_2_0_2_4_2 - 1.666666666666664e-01*G1_1_2_0_2_5_0 - 1.666666666666664e-01*G1_1_2_0_2_6_1 - 1.666666666666664e-01*G1_1_2_0_2_7_2 + 1.666666666666664e-01*G1_2_0_0_0_8_0 + 1.666666666666664e-01*G1_2_0_0_0_8_1 + 1.666666666666664e-01*G1_2_0_0_0_8_2 - 1.666666666666664e-01*G1_2_0_0_0_9_0 - 1.666666666666664e-01*G1_2_0_0_0_10_1 - 1.666666666666664e-01*G1_2_0_0_0_11_2 + 1.666666666666664e-01*G1_2_1_0_1_8_0 + 1.666666666666664e-01*G1_2_1_0_1_8_1 + 1.666666666666664e-01*G1_2_1_0_1_8_2 - 1.666666666666664e-01*G1_2_1_0_1_9_0 - 1.666666666666664e-01*G1_2_1_0_1_10_1 - 1.666666666666664e-01*G1_2_1_0_1_11_2 + 1.666666666666664e-01*G1_2_2_0_2_8_0 + 1.666666666666664e-01*G1_2_2_0_2_8_1 + 1.666666666666664e-01*G1_2_2_0_2_8_2 - 1.666666666666664e-01*G1_2_2_0_2_9_0 - 1.666666666666664e-01*G1_2_2_0_2_10_1 - 1.666666666666664e-01*G1_2_2_0_2_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;
    block[2] = 4.166666666666662e-02*G0_0_1_0 + 4.166666666666661e-02*G0_0_1_1 + 4.166666666666662e-02*G0_0_1_2 + 4.166666666666662e-02*G0_0_1_3 + 4.166666666666662e-02*G0_1_1_4 + 4.166666666666662e-02*G0_1_1_5 + 4.166666666666662e-02*G0_1_1_6 + 4.166666666666662e-02*G0_1_1_7 + 4.166666666666662e-02*G0_2_1_8 + 4.166666666666662e-02*G0_2_1_9 + 4.166666666666662e-02*G0_2_1_10 + 4.166666666666662e-02*G0_2_1_11 + 1.666666666666664e-01*G1_0_0_1_0_0_0 + 1.666666666666665e-01*G1_0_0_1_0_0_1 + 1.666666666666664e-01*G1_0_0_1_0_0_2 - 1.666666666666664e-01*G1_0_0_1_0_1_0 - 1.666666666666665e-01*G1_0_0_1_0_2_1 - 1.666666666666665e-01*G1_0_0_1_0_3_2 + 1.666666666666664e-01*G1_0_1_1_1_0_0 + 1.666666666666665e-01*G1_0_1_1_1_0_1 + 1.666666666666664e-01*G1_0_1_1_1_0_2 - 1.666666666666664e-01*G1_0_1_1_1_1_0 - 1.666666666666665e-01*G1_0_1_1_1_2_1 - 1.666666666666665e-01*G1_0_1_1_1_3_2 + 1.666666666666664e-01*G1_0_2_1_2_0_0 + 1.666666666666665e-01*G1_0_2_1_2_0_1 + 1.666666666666664e-01*G1_0_2_1_2_0_2 - 1.666666666666664e-01*G1_0_2_1_2_1_0 - 1.666666666666665e-01*G1_0_2_1_2_2_1 - 1.666666666666665e-01*G1_0_2_1_2_3_2 + 1.666666666666664e-01*G1_1_0_1_0_4_0 + 1.666666666666665e-01*G1_1_0_1_0_4_1 + 1.666666666666665e-01*G1_1_0_1_0_4_2 - 1.666666666666664e-01*G1_1_0_1_0_5_0 - 1.666666666666665e-01*G1_1_0_1_0_6_1 - 1.666666666666665e-01*G1_1_0_1_0_7_2 + 1.666666666666664e-01*G1_1_1_1_1_4_0 + 1.666666666666665e-01*G1_1_1_1_1_4_1 + 1.666666666666665e-01*G1_1_1_1_1_4_2 - 1.666666666666664e-01*G1_1_1_1_1_5_0 - 1.666666666666665e-01*G1_1_1_1_1_6_1 - 1.666666666666665e-01*G1_1_1_1_1_7_2 + 1.666666666666664e-01*G1_1_2_1_2_4_0 + 1.666666666666665e-01*G1_1_2_1_2_4_1 + 1.666666666666665e-01*G1_1_2_1_2_4_2 - 1.666666666666664e-01*G1_1_2_1_2_5_0 - 1.666666666666665e-01*G1_1_2_1_2_6_1 - 1.666666666666665e-01*G1_1_2_1_2_7_2 + 1.666666666666664e-01*G1_2_0_1_0_8_0 + 1.666666666666665e-01*G1_2_0_1_0_8_1 + 1.666666666666665e-01*G1_2_0_1_0_8_2 - 1.666666666666664e-01*G1_2_0_1_0_9_0 - 1.666666666666665e-01*G1_2_0_1_0_10_1 - 1.666666666666665e-01*G1_2_0_1_0_11_2 + 1.666666666666664e-01*G1_2_1_1_1_8_0 + 1.666666666666665e-01*G1_2_1_1_1_8_1 + 1.666666666666665e-01*G1_2_1_1_1_8_2 - 1.666666666666664e-01*G1_2_1_1_1_9_0 - 1.666666666666665e-01*G1_2_1_1_1_10_1 - 1.666666666666665e-01*G1_2_1_1_1_11_2 + 1.666666666666664e-01*G1_2_2_1_2_8_0 + 1.666666666666665e-01*G1_2_2_1_2_8_1 + 1.666666666666665e-01*G1_2_2_1_2_8_2 - 1.666666666666664e-01*G1_2_2_1_2_9_0 - 1.666666666666665e-01*G1_2_2_1_2_10_1 - 1.666666666666665e-01*G1_2_2_1_2_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;
    block[3] = 4.166666666666662e-02*G0_0_2_0 + 4.166666666666661e-02*G0_0_2_1 + 4.166666666666662e-02*G0_0_2_2 + 4.166666666666662e-02*G0_0_2_3 + 4.166666666666662e-02*G0_1_2_4 + 4.166666666666662e-02*G0_1_2_5 + 4.166666666666662e-02*G0_1_2_6 + 4.166666666666662e-02*G0_1_2_7 + 4.166666666666662e-02*G0_2_2_8 + 4.166666666666662e-02*G0_2_2_9 + 4.166666666666662e-02*G0_2_2_10 + 4.166666666666662e-02*G0_2_2_11 + 1.666666666666664e-01*G1_0_0_2_0_0_0 + 1.666666666666665e-01*G1_0_0_2_0_0_1 + 1.666666666666664e-01*G1_0_0_2_0_0_2 - 1.666666666666664e-01*G1_0_0_2_0_1_0 - 1.666666666666665e-01*G1_0_0_2_0_2_1 - 1.666666666666665e-01*G1_0_0_2_0_3_2 + 1.666666666666664e-01*G1_0_1_2_1_0_0 + 1.666666666666665e-01*G1_0_1_2_1_0_1 + 1.666666666666664e-01*G1_0_1_2_1_0_2 - 1.666666666666664e-01*G1_0_1_2_1_1_0 - 1.666666666666665e-01*G1_0_1_2_1_2_1 - 1.666666666666665e-01*G1_0_1_2_1_3_2 + 1.666666666666664e-01*G1_0_2_2_2_0_0 + 1.666666666666665e-01*G1_0_2_2_2_0_1 + 1.666666666666664e-01*G1_0_2_2_2_0_2 - 1.666666666666664e-01*G1_0_2_2_2_1_0 - 1.666666666666665e-01*G1_0_2_2_2_2_1 - 1.666666666666665e-01*G1_0_2_2_2_3_2 + 1.666666666666664e-01*G1_1_0_2_0_4_0 + 1.666666666666665e-01*G1_1_0_2_0_4_1 + 1.666666666666665e-01*G1_1_0_2_0_4_2 - 1.666666666666664e-01*G1_1_0_2_0_5_0 - 1.666666666666665e-01*G1_1_0_2_0_6_1 - 1.666666666666665e-01*G1_1_0_2_0_7_2 + 1.666666666666664e-01*G1_1_1_2_1_4_0 + 1.666666666666665e-01*G1_1_1_2_1_4_1 + 1.666666666666665e-01*G1_1_1_2_1_4_2 - 1.666666666666664e-01*G1_1_1_2_1_5_0 - 1.666666666666665e-01*G1_1_1_2_1_6_1 - 1.666666666666665e-01*G1_1_1_2_1_7_2 + 1.666666666666664e-01*G1_1_2_2_2_4_0 + 1.666666666666665e-01*G1_1_2_2_2_4_1 + 1.666666666666665e-01*G1_1_2_2_2_4_2 - 1.666666666666664e-01*G1_1_2_2_2_5_0 - 1.666666666666665e-01*G1_1_2_2_2_6_1 - 1.666666666666665e-01*G1_1_2_2_2_7_2 + 1.666666666666664e-01*G1_2_0_2_0_8_0 + 1.666666666666665e-01*G1_2_0_2_0_8_1 + 1.666666666666665e-01*G1_2_0_2_0_8_2 - 1.666666666666664e-01*G1_2_0_2_0_9_0 - 1.666666666666665e-01*G1_2_0_2_0_10_1 - 1.666666666666665e-01*G1_2_0_2_0_11_2 + 1.666666666666664e-01*G1_2_1_2_1_8_0 + 1.666666666666665e-01*G1_2_1_2_1_8_1 + 1.666666666666665e-01*G1_2_1_2_1_8_2 - 1.666666666666664e-01*G1_2_1_2_1_9_0 - 1.666666666666665e-01*G1_2_1_2_1_10_1 - 1.666666666666665e-01*G1_2_1_2_1_11_2 + 1.666666666666664e-01*G1_2_2_2_2_8_0 + 1.666666666666665e-01*G1_2_2_2_2_8_1 + 1.666666666666665e-01*G1_2_2_2_2_8_2 - 1.666666666666664e-01*G1_2_2_2_2_9_0 - 1.666666666666665e-01*G1_2_2_2_2_10_1 - 1.666666666666665e-01*G1_2_2_2_2_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;

  }
        
private:

  const real& c0;

};

} }

#endif
