// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.8.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __POISSON3D_4_H
#define __POISSON3D_4_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Poisson3D_4 {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 35;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }

  private:

    unsigned int* tensordims;

  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 35;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0_0 = map.det*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G0_0_1 = map.det*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G0_0_2 = map.det*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G0_1_0 = map.det*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G0_1_1 = map.det*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G0_1_2 = map.det*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G0_2_0 = map.det*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G0_2_1 = map.det*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G0_2_2 = map.det*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);

    // Compute element tensor
    block[0] = 3.791887125220451e-02*G0_0_0 + 3.791887125220450e-02*G0_0_1 + 3.791887125220451e-02*G0_0_2 + 3.791887125220450e-02*G0_1_0 + 3.791887125220451e-02*G0_1_1 + 3.791887125220450e-02*G0_1_2 + 3.791887125220451e-02*G0_2_0 + 3.791887125220450e-02*G0_2_1 + 3.791887125220449e-02*G0_2_2;
    block[1] = 5.114638447971782e-03*G0_0_0 + 5.114638447971778e-03*G0_1_0 + 5.114638447971779e-03*G0_2_0;
    block[2] = 5.114638447971768e-03*G0_0_1 + 5.114638447971769e-03*G0_1_1 + 5.114638447971768e-03*G0_2_1;
    block[3] = 5.114638447971775e-03*G0_0_2 + 5.114638447971776e-03*G0_1_2 + 5.114638447971779e-03*G0_2_2;
    block[4] = 7.760141093474320e-03*G0_0_0 + 7.760141093474397e-03*G0_0_1 + 7.760141093474343e-03*G0_1_0 + 7.760141093474406e-03*G0_1_1 + 7.760141093474335e-03*G0_2_0 + 7.760141093474403e-03*G0_2_1;
    block[5] = 5.114638447971781e-03*G0_0_0 + 5.114638447971696e-03*G0_0_1 + 5.114638447971792e-03*G0_1_0 + 5.114638447971714e-03*G0_1_1 + 5.114638447971775e-03*G0_2_0 + 5.114638447971697e-03*G0_2_1;
    block[6] = 7.760141093474424e-03*G0_0_0 + 7.760141093474450e-03*G0_0_1 + 7.760141093474424e-03*G0_1_0 + 7.760141093474446e-03*G0_1_1 + 7.760141093474423e-03*G0_2_0 + 7.760141093474448e-03*G0_2_1;
    block[7] = -7.760141093474441e-03*G0_0_0 - 2.539682539682538e-02*G0_0_1 - 7.760141093474443e-03*G0_0_2 - 7.760141093474441e-03*G0_1_0 - 2.539682539682539e-02*G0_1_1 - 7.760141093474443e-03*G0_1_2 - 7.760141093474439e-03*G0_2_0 - 2.539682539682538e-02*G0_2_1 - 7.760141093474443e-03*G0_2_2;
    block[8] = 2.028218694885360e-02*G0_0_0 + 5.291005291005280e-02*G0_0_1 + 2.028218694885359e-02*G0_0_2 + 2.028218694885360e-02*G0_1_0 + 5.291005291005279e-02*G0_1_1 + 2.028218694885359e-02*G0_1_2 + 2.028218694885360e-02*G0_2_0 + 5.291005291005281e-02*G0_2_1 + 2.028218694885360e-02*G0_2_2;
    block[9] = -2.469135802469131e-02*G0_0_0 - 7.054673721340370e-02*G0_0_1 - 2.469135802469132e-02*G0_0_2 - 2.469135802469133e-02*G0_1_0 - 7.054673721340372e-02*G0_1_1 - 2.469135802469134e-02*G0_1_2 - 2.469135802469132e-02*G0_2_0 - 7.054673721340370e-02*G0_2_1 - 2.469135802469134e-02*G0_2_2;
    block[10] = -7.054673721340374e-02*G0_0_0 - 2.469135802469129e-02*G0_0_1 - 2.469135802469129e-02*G0_0_2 - 7.054673721340371e-02*G0_1_0 - 2.469135802469130e-02*G0_1_1 - 2.469135802469131e-02*G0_1_2 - 7.054673721340371e-02*G0_2_0 - 2.469135802469130e-02*G0_2_1 - 2.469135802469131e-02*G0_2_2;
    block[11] = 5.291005291005282e-02*G0_0_0 + 2.028218694885358e-02*G0_0_1 + 2.028218694885359e-02*G0_0_2 + 5.291005291005280e-02*G0_1_0 + 2.028218694885360e-02*G0_1_1 + 2.028218694885360e-02*G0_1_2 + 5.291005291005280e-02*G0_2_0 + 2.028218694885358e-02*G0_2_1 + 2.028218694885358e-02*G0_2_2;
    block[12] = -2.539682539682539e-02*G0_0_0 - 7.760141093474400e-03*G0_0_1 - 7.760141093474397e-03*G0_0_2 - 2.539682539682537e-02*G0_1_0 - 7.760141093474410e-03*G0_1_1 - 7.760141093474405e-03*G0_1_2 - 2.539682539682537e-02*G0_2_0 - 7.760141093474402e-03*G0_2_1 - 7.760141093474401e-03*G0_2_2;
    block[13] = -2.469135802469133e-02*G0_0_0 - 2.469135802469135e-02*G0_0_1 - 7.054673721340372e-02*G0_0_2 - 2.469135802469136e-02*G0_1_0 - 2.469135802469138e-02*G0_1_1 - 7.054673721340372e-02*G0_1_2 - 2.469135802469135e-02*G0_2_0 - 2.469135802469137e-02*G0_2_1 - 7.054673721340371e-02*G0_2_2;
    block[14] = 2.028218694885359e-02*G0_0_0 + 2.028218694885359e-02*G0_0_1 + 5.291005291005281e-02*G0_0_2 + 2.028218694885360e-02*G0_1_0 + 2.028218694885360e-02*G0_1_1 + 5.291005291005280e-02*G0_1_2 + 2.028218694885361e-02*G0_2_0 + 2.028218694885361e-02*G0_2_1 + 5.291005291005280e-02*G0_2_2;
    block[15] = -7.760141093474402e-03*G0_0_0 - 7.760141093474399e-03*G0_0_1 - 2.539682539682532e-02*G0_0_2 - 7.760141093474416e-03*G0_1_0 - 7.760141093474415e-03*G0_1_1 - 2.539682539682531e-02*G0_1_2 - 7.760141093474414e-03*G0_2_0 - 7.760141093474410e-03*G0_2_1 - 2.539682539682531e-02*G0_2_2;
    block[16] = 7.760141093474363e-03*G0_0_0 + 7.760141093474386e-03*G0_0_2 + 7.760141093474378e-03*G0_1_0 + 7.760141093474397e-03*G0_1_2 + 7.760141093474367e-03*G0_2_0 + 7.760141093474389e-03*G0_2_2;
    block[17] = 5.114638447971824e-03*G0_0_0 + 5.114638447971828e-03*G0_0_2 + 5.114638447971808e-03*G0_1_0 + 5.114638447971815e-03*G0_1_2 + 5.114638447971818e-03*G0_2_0 + 5.114638447971818e-03*G0_2_2;
    block[18] = 7.760141093474417e-03*G0_0_0 + 7.760141093474416e-03*G0_0_2 + 7.760141093474431e-03*G0_1_0 + 7.760141093474431e-03*G0_1_2 + 7.760141093474430e-03*G0_2_0 + 7.760141093474428e-03*G0_2_2;
    block[19] = 7.760141093474443e-03*G0_0_1 + 7.760141093474418e-03*G0_0_2 + 7.760141093474438e-03*G0_1_1 + 7.760141093474418e-03*G0_1_2 + 7.760141093474445e-03*G0_2_1 + 7.760141093474415e-03*G0_2_2;
    block[20] = 5.114638447971796e-03*G0_0_1 + 5.114638447971804e-03*G0_0_2 + 5.114638447971793e-03*G0_1_1 + 5.114638447971805e-03*G0_1_2 + 5.114638447971794e-03*G0_2_1 + 5.114638447971813e-03*G0_2_2;
    block[21] = 7.760141093474416e-03*G0_0_1 + 7.760141093474426e-03*G0_0_2 + 7.760141093474429e-03*G0_1_1 + 7.760141093474436e-03*G0_1_2 + 7.760141093474427e-03*G0_2_1 + 7.760141093474425e-03*G0_2_2;
    block[22] = 1.834215167548491e-02*G0_0_0 + 1.834215167548489e-02*G0_0_1 + 1.834215167548485e-02*G0_0_2 + 1.834215167548491e-02*G0_1_0 + 1.834215167548488e-02*G0_1_1 + 1.834215167548486e-02*G0_1_2 + 1.834215167548490e-02*G0_2_0 + 1.834215167548488e-02*G0_2_1 + 1.834215167548485e-02*G0_2_2;
    block[23] = 1.834215167548501e-02*G0_0_0 + 1.834215167548503e-02*G0_0_1 + 1.834215167548501e-02*G0_0_2 + 1.834215167548502e-02*G0_1_0 + 1.834215167548503e-02*G0_1_1 + 1.834215167548501e-02*G0_1_2 + 1.834215167548502e-02*G0_2_0 + 1.834215167548503e-02*G0_2_1 + 1.834215167548502e-02*G0_2_2;
    block[24] = 1.834215167548505e-02*G0_0_0 + 1.834215167548498e-02*G0_0_1 + 1.834215167548504e-02*G0_0_2 + 1.834215167548505e-02*G0_1_0 + 1.834215167548501e-02*G0_1_1 + 1.834215167548505e-02*G0_1_2 + 1.834215167548505e-02*G0_2_0 + 1.834215167548498e-02*G0_2_1 + 1.834215167548503e-02*G0_2_2;
    block[25] = -1.834215167548505e-02*G0_0_0 - 2.539682539682541e-02*G0_0_1 - 2.539682539682538e-02*G0_0_2 - 1.834215167548505e-02*G0_1_0 - 2.539682539682540e-02*G0_1_1 - 2.539682539682538e-02*G0_1_2 - 1.834215167548505e-02*G0_2_0 - 2.539682539682539e-02*G0_2_1 - 2.539682539682540e-02*G0_2_2;
    block[26] = -1.834215167548502e-02*G0_0_0 - 2.539682539682539e-02*G0_0_1 - 2.539682539682538e-02*G0_0_2 - 1.834215167548504e-02*G0_1_0 - 2.539682539682540e-02*G0_1_1 - 2.539682539682539e-02*G0_1_2 - 1.834215167548503e-02*G0_2_0 - 2.539682539682541e-02*G0_2_1 - 2.539682539682538e-02*G0_2_2;
    block[27] = 4.938271604938265e-02*G0_0_0 + 4.232804232804228e-02*G0_0_1 + 4.232804232804228e-02*G0_0_2 + 4.938271604938263e-02*G0_1_0 + 4.232804232804232e-02*G0_1_1 + 4.232804232804230e-02*G0_1_2 + 4.938271604938262e-02*G0_2_0 + 4.232804232804230e-02*G0_2_1 + 4.232804232804230e-02*G0_2_2;
    block[28] = -2.539682539682540e-02*G0_0_0 - 1.834215167548504e-02*G0_0_1 - 2.539682539682537e-02*G0_0_2 - 2.539682539682539e-02*G0_1_0 - 1.834215167548504e-02*G0_1_1 - 2.539682539682540e-02*G0_1_2 - 2.539682539682541e-02*G0_2_0 - 1.834215167548505e-02*G0_2_1 - 2.539682539682539e-02*G0_2_2;
    block[29] = -2.539682539682527e-02*G0_0_0 - 1.834215167548492e-02*G0_0_1 - 2.539682539682536e-02*G0_0_2 - 2.539682539682532e-02*G0_1_0 - 1.834215167548491e-02*G0_1_1 - 2.539682539682537e-02*G0_1_2 - 2.539682539682528e-02*G0_2_0 - 1.834215167548490e-02*G0_2_1 - 2.539682539682536e-02*G0_2_2;
    block[30] = 4.232804232804224e-02*G0_0_0 + 4.938271604938264e-02*G0_0_1 + 4.232804232804225e-02*G0_0_2 + 4.232804232804230e-02*G0_1_0 + 4.938271604938266e-02*G0_1_1 + 4.232804232804228e-02*G0_1_2 + 4.232804232804226e-02*G0_2_0 + 4.938271604938263e-02*G0_2_1 + 4.232804232804228e-02*G0_2_2;
    block[31] = 4.232804232804215e-02*G0_0_0 + 4.232804232804217e-02*G0_0_1 + 4.938271604938260e-02*G0_0_2 + 4.232804232804221e-02*G0_1_0 + 4.232804232804220e-02*G0_1_1 + 4.938271604938261e-02*G0_1_2 + 4.232804232804220e-02*G0_2_0 + 4.232804232804221e-02*G0_2_1 + 4.938271604938258e-02*G0_2_2;
    block[32] = -2.539682539682518e-02*G0_0_0 - 2.539682539682529e-02*G0_0_1 - 1.834215167548484e-02*G0_0_2 - 2.539682539682523e-02*G0_1_0 - 2.539682539682533e-02*G0_1_1 - 1.834215167548486e-02*G0_1_2 - 2.539682539682521e-02*G0_2_0 - 2.539682539682529e-02*G0_2_1 - 1.834215167548484e-02*G0_2_2;
    block[33] = -2.539682539682536e-02*G0_0_0 - 2.539682539682531e-02*G0_0_1 - 1.834215167548502e-02*G0_0_2 - 2.539682539682538e-02*G0_1_0 - 2.539682539682530e-02*G0_1_1 - 1.834215167548504e-02*G0_1_2 - 2.539682539682536e-02*G0_2_0 - 2.539682539682531e-02*G0_2_1 - 1.834215167548501e-02*G0_2_2;
    block[34] = -6.772486772486758e-02*G0_0_0 - 6.772486772486760e-02*G0_0_1 - 6.772486772486760e-02*G0_0_2 - 6.772486772486756e-02*G0_1_0 - 6.772486772486766e-02*G0_1_1 - 6.772486772486760e-02*G0_1_2 - 6.772486772486755e-02*G0_2_0 - 6.772486772486759e-02*G0_2_1 - 6.772486772486758e-02*G0_2_2;
    block[35] = 5.114638447971783e-03*G0_0_0 + 5.114638447971778e-03*G0_0_1 + 5.114638447971780e-03*G0_0_2;
    block[36] = 3.791887125220453e-02*G0_0_0;
    block[37] = -5.114638447971764e-03*G0_0_1;
    block[38] = -5.114638447971778e-03*G0_0_2;
    block[39] = -2.469135802469135e-02*G0_0_0 + 4.585537918871242e-02*G0_0_1;
    block[40] = 2.028218694885364e-02*G0_0_0 - 3.262786596119922e-02*G0_0_1;
    block[41] = -7.760141093474361e-03*G0_0_0 + 1.763668430335099e-02*G0_0_1;
    block[42] = 7.760141093474368e-03*G0_0_0 + 7.760141093474364e-03*G0_0_2;
    block[43] = 5.114638447971868e-03*G0_0_0 + 5.114638447971861e-03*G0_0_2;
    block[44] = 7.760141093474302e-03*G0_0_0 + 7.760141093474305e-03*G0_0_2;
    block[45] = -2.539682539682534e-02*G0_0_0 - 1.763668430335101e-02*G0_0_1 - 1.763668430335101e-02*G0_0_2;
    block[46] = 5.291005291005282e-02*G0_0_0 + 3.262786596119927e-02*G0_0_1 + 3.262786596119927e-02*G0_0_2;
    block[47] = -7.054673721340374e-02*G0_0_0 - 4.585537918871244e-02*G0_0_1 - 4.585537918871243e-02*G0_0_2;
    block[48] = 7.760141093474348e-03*G0_0_0 + 7.760141093474350e-03*G0_0_1;
    block[49] = 5.114638447971777e-03*G0_0_0 + 5.114638447971772e-03*G0_0_1;
    block[50] = 7.760141093474410e-03*G0_0_0 + 7.760141093474397e-03*G0_0_1;
    block[51] = -2.469135802469136e-02*G0_0_0 + 4.585537918871239e-02*G0_0_2;
    block[52] = 2.028218694885363e-02*G0_0_0 - 3.262786596119921e-02*G0_0_2;
    block[53] = -7.760141093474400e-03*G0_0_0 + 1.763668430335096e-02*G0_0_2;
    block[54] = -7.760141093474393e-03*G0_0_1 - 7.760141093474355e-03*G0_0_2;
    block[55] = -5.114638447971798e-03*G0_0_1 - 5.114638447971795e-03*G0_0_2;
    block[56] = -7.760141093474403e-03*G0_0_1 - 7.760141093474412e-03*G0_0_2;
    block[57] = 4.938271604938274e-02*G0_0_0 + 7.054673721340325e-03*G0_0_1 + 7.054673721340358e-03*G0_0_2;
    block[58] = -1.834215167548493e-02*G0_0_0 + 7.054673721340498e-03*G0_0_1 + 7.054673721340488e-03*G0_0_2;
    block[59] = -1.834215167548492e-02*G0_0_0 + 7.054673721340538e-03*G0_0_1 + 7.054673721340521e-03*G0_0_2;
    block[60] = 1.834215167548493e-02*G0_0_0;
    block[61] = 1.834215167548493e-02*G0_0_0;
    block[62] = 1.834215167548489e-02*G0_0_0;
    block[63] = -2.539682539682542e-02*G0_0_0 - 7.054673721340481e-03*G0_0_1;
    block[64] = 4.232804232804233e-02*G0_0_0 - 7.054673721340371e-03*G0_0_1;
    block[65] = -2.539682539682531e-02*G0_0_0 - 7.054673721340400e-03*G0_0_1;
    block[66] = -2.539682539682521e-02*G0_0_0 - 7.054673721340324e-03*G0_0_2;
    block[67] = 4.232804232804225e-02*G0_0_0 - 7.054673721340393e-03*G0_0_2;
    block[68] = -2.539682539682549e-02*G0_0_0 - 7.054673721340517e-03*G0_0_2;
    block[69] = -6.772486772486767e-02*G0_0_0;
    block[70] = 5.114638447971768e-03*G0_1_0 + 5.114638447971769e-03*G0_1_1 + 5.114638447971766e-03*G0_1_2;
    block[71] = -5.114638447971764e-03*G0_1_0;
    block[72] = 3.791887125220457e-02*G0_1_1;
    block[73] = -5.114638447971789e-03*G0_1_2;
    block[74] = 1.763668430335083e-02*G0_1_0 - 7.760141093474483e-03*G0_1_1;
    block[75] = -3.262786596119916e-02*G0_1_0 + 2.028218694885364e-02*G0_1_1;
    block[76] = 4.585537918871242e-02*G0_1_0 - 2.469135802469137e-02*G0_1_1;
    block[77] = -4.585537918871243e-02*G0_1_0 - 7.054673721340381e-02*G0_1_1 - 4.585537918871243e-02*G0_1_2;
    block[78] = 3.262786596119924e-02*G0_1_0 + 5.291005291005283e-02*G0_1_1 + 3.262786596119924e-02*G0_1_2;
    block[79] = -1.763668430335090e-02*G0_1_0 - 2.539682539682534e-02*G0_1_1 - 1.763668430335091e-02*G0_1_2;
    block[80] = 7.760141093474462e-03*G0_1_1 + 7.760141093474447e-03*G0_1_2;
    block[81] = 5.114638447971783e-03*G0_1_1 + 5.114638447971788e-03*G0_1_2;
    block[82] = 7.760141093474499e-03*G0_1_1 + 7.760141093474487e-03*G0_1_2;
    block[83] = 7.760141093474453e-03*G0_1_0 + 7.760141093474444e-03*G0_1_1;
    block[84] = 5.114638447971735e-03*G0_1_0 + 5.114638447971738e-03*G0_1_1;
    block[85] = 7.760141093474478e-03*G0_1_0 + 7.760141093474461e-03*G0_1_1;
    block[86] = -7.760141093474503e-03*G0_1_0 - 7.760141093474473e-03*G0_1_2;
    block[87] = -5.114638447971725e-03*G0_1_0 - 5.114638447971736e-03*G0_1_2;
    block[88] = -7.760141093474480e-03*G0_1_0 - 7.760141093474454e-03*G0_1_2;
    block[89] = -2.469135802469142e-02*G0_1_1 + 4.585537918871241e-02*G0_1_2;
    block[90] = 2.028218694885363e-02*G0_1_1 - 3.262786596119927e-02*G0_1_2;
    block[91] = -7.760141093474485e-03*G0_1_1 + 1.763668430335090e-02*G0_1_2;
    block[92] = 7.054673721340456e-03*G0_1_0 - 1.834215167548509e-02*G0_1_1 + 7.054673721340307e-03*G0_1_2;
    block[93] = 7.054673721340362e-03*G0_1_0 - 1.834215167548499e-02*G0_1_1 + 7.054673721340441e-03*G0_1_2;
    block[94] = 7.054673721340305e-03*G0_1_0 + 4.938271604938275e-02*G0_1_1 + 7.054673721340413e-03*G0_1_2;
    block[95] = -7.054673721340321e-03*G0_1_0 + 4.232804232804237e-02*G0_1_1;
    block[96] = -7.054673721340359e-03*G0_1_0 - 2.539682539682534e-02*G0_1_1;
    block[97] = -7.054673721340388e-03*G0_1_0 - 2.539682539682542e-02*G0_1_1;
    block[98] = 1.834215167548498e-02*G0_1_1;
    block[99] = 1.834215167548505e-02*G0_1_1;
    block[100] = 1.834215167548503e-02*G0_1_1;
    block[101] = -2.539682539682539e-02*G0_1_1 - 7.054673721340343e-03*G0_1_2;
    block[102] = -2.539682539682547e-02*G0_1_1 - 7.054673721340326e-03*G0_1_2;
    block[103] = 4.232804232804238e-02*G0_1_1 - 7.054673721340373e-03*G0_1_2;
    block[104] = -6.772486772486780e-02*G0_1_1;
    block[105] = 5.114638447971775e-03*G0_2_0 + 5.114638447971777e-03*G0_2_1 + 5.114638447971779e-03*G0_2_2;
    block[106] = -5.114638447971780e-03*G0_2_0;
    block[107] = -5.114638447971789e-03*G0_2_1;
    block[108] = 3.791887125220460e-02*G0_2_2;
    block[109] = -7.760141093474442e-03*G0_2_0 - 7.760141093474429e-03*G0_2_1;
    block[110] = -5.114638447971758e-03*G0_2_0 - 5.114638447971768e-03*G0_2_1;
    block[111] = -7.760141093474436e-03*G0_2_0 - 7.760141093474417e-03*G0_2_1;
    block[112] = 7.760141093474446e-03*G0_2_0 + 7.760141093474453e-03*G0_2_2;
    block[113] = 5.114638447971760e-03*G0_2_0 + 5.114638447971749e-03*G0_2_2;
    block[114] = 7.760141093474390e-03*G0_2_0 + 7.760141093474388e-03*G0_2_2;
    block[115] = 7.760141093474387e-03*G0_2_1 + 7.760141093474405e-03*G0_2_2;
    block[116] = 5.114638447971749e-03*G0_2_1 + 5.114638447971741e-03*G0_2_2;
    block[117] = 7.760141093474421e-03*G0_2_1 + 7.760141093474433e-03*G0_2_2;
    block[118] = -1.763668430335100e-02*G0_2_0 - 1.763668430335102e-02*G0_2_1 - 2.539682539682539e-02*G0_2_2;
    block[119] = 3.262786596119934e-02*G0_2_0 + 3.262786596119933e-02*G0_2_1 + 5.291005291005290e-02*G0_2_2;
    block[120] = -4.585537918871254e-02*G0_2_0 - 4.585537918871252e-02*G0_2_1 - 7.054673721340389e-02*G0_2_2;
    block[121] = 1.763668430335091e-02*G0_2_0 - 7.760141093474437e-03*G0_2_2;
    block[122] = -3.262786596119927e-02*G0_2_0 + 2.028218694885358e-02*G0_2_2;
    block[123] = 4.585537918871255e-02*G0_2_0 - 2.469135802469130e-02*G0_2_2;
    block[124] = 1.763668430335100e-02*G0_2_1 - 7.760141093474458e-03*G0_2_2;
    block[125] = -3.262786596119931e-02*G0_2_1 + 2.028218694885365e-02*G0_2_2;
    block[126] = 4.585537918871255e-02*G0_2_1 - 2.469135802469133e-02*G0_2_2;
    block[127] = 7.054673721340337e-03*G0_2_0 + 7.054673721340280e-03*G0_2_1 - 1.834215167548503e-02*G0_2_2;
    block[128] = 7.054673721340447e-03*G0_2_0 + 7.054673721340467e-03*G0_2_1 + 4.938271604938269e-02*G0_2_2;
    block[129] = 7.054673721340403e-03*G0_2_0 + 7.054673721340385e-03*G0_2_1 - 1.834215167548500e-02*G0_2_2;
    block[130] = -7.054673721340411e-03*G0_2_0 - 2.539682539682538e-02*G0_2_2;
    block[131] = -7.054673721340426e-03*G0_2_0 + 4.232804232804221e-02*G0_2_2;
    block[132] = -7.054673721340375e-03*G0_2_0 - 2.539682539682530e-02*G0_2_2;
    block[133] = -7.054673721340478e-03*G0_2_1 + 4.232804232804216e-02*G0_2_2;
    block[134] = -7.054673721340273e-03*G0_2_1 - 2.539682539682528e-02*G0_2_2;
    block[135] = -7.054673721340406e-03*G0_2_1 - 2.539682539682530e-02*G0_2_2;
    block[136] = 1.834215167548491e-02*G0_2_2;
    block[137] = 1.834215167548504e-02*G0_2_2;
    block[138] = 1.834215167548494e-02*G0_2_2;
    block[139] = -6.772486772486759e-02*G0_2_2;
    block[140] = 7.760141093474320e-03*G0_0_0 + 7.760141093474341e-03*G0_0_1 + 7.760141093474334e-03*G0_0_2 + 7.760141093474398e-03*G0_1_0 + 7.760141093474409e-03*G0_1_1 + 7.760141093474403e-03*G0_1_2;
    block[141] = -2.469135802469134e-02*G0_0_0 + 4.585537918871243e-02*G0_1_0;
    block[142] = 1.763668430335083e-02*G0_0_1 - 7.760141093474483e-03*G0_1_1;
    block[143] = -7.760141093474442e-03*G0_0_2 - 7.760141093474429e-03*G0_1_2;
    block[144] = 2.031746031746025e-01*G0_0_0 + 7.901234567901202e-02*G0_0_1 + 7.901234567901202e-02*G0_1_0 + 1.580246913580244e-01*G0_1_1;
    block[145] = -1.185185185185182e-01*G0_0_0 + 4.232804232804198e-02*G0_0_1 - 3.104056437389754e-02*G0_1_0 - 9.029982363315700e-02*G0_1_1;
    block[146] = 4.514991181657823e-02*G0_0_0 - 3.386243386243370e-02*G0_0_1 + 1.128747795414460e-02*G0_1_0 + 4.514991181657860e-02*G0_1_1;
    block[147] = -4.514991181657827e-02*G0_0_0 - 1.128747795414449e-02*G0_0_1 - 4.514991181657832e-02*G0_0_2 - 1.128747795414461e-02*G0_1_0 - 1.128747795414464e-02*G0_1_2;
    block[148] = -1.693121693121701e-02*G0_0_0 - 2.821869488536261e-03*G0_0_1 - 1.693121693121696e-02*G0_0_2 - 2.821869488536073e-03*G0_1_0 - 2.821869488536041e-03*G0_1_2;
    block[149] = -2.257495590828907e-02*G0_0_0 - 1.128747795414446e-02*G0_0_1 - 2.257495590828913e-02*G0_0_2 - 1.128747795414467e-02*G0_1_0 - 1.128747795414472e-02*G0_1_2;
    block[150] = -2.257495590828900e-02*G0_0_0 - 3.386243386243364e-02*G0_0_1 - 3.386243386243366e-02*G0_0_2 - 3.386243386243372e-02*G0_1_0 - 4.514991181657839e-02*G0_1_1 - 4.514991181657843e-02*G0_1_2;
    block[151] = 1.693121693121671e-02*G0_0_0 + 5.925925925925900e-02*G0_0_1 + 5.925925925925900e-02*G0_0_2 + 5.925925925925905e-02*G0_1_0 + 9.029982363315672e-02*G0_1_1 + 9.029982363315672e-02*G0_1_2;
    block[152] = 2.257495590828925e-02*G0_0_0 - 7.901234567901211e-02*G0_0_1 - 7.901234567901208e-02*G0_0_2 - 7.901234567901212e-02*G0_1_0 - 1.580246913580244e-01*G0_1_1 - 1.580246913580244e-01*G0_1_2;
    block[153] = -1.128747795414459e-02*G0_0_0 - 1.128747795414458e-02*G0_0_1 - 1.128747795414465e-02*G0_1_0 - 1.128747795414463e-02*G0_1_1;
    block[154] = -2.821869488536061e-03*G0_0_0 - 2.821869488536086e-03*G0_0_1 - 2.821869488536068e-03*G0_1_0 - 2.821869488536099e-03*G0_1_1;
    block[155] = -1.128747795414463e-02*G0_0_0 - 1.128747795414461e-02*G0_0_1 - 1.128747795414467e-02*G0_1_0 - 1.128747795414465e-02*G0_1_1;
    block[156] = 1.015873015873013e-01*G0_0_0 + 7.901234567901200e-02*G0_0_2 + 7.901234567901216e-02*G0_1_0 + 1.580246913580243e-01*G0_1_2;
    block[157] = -4.232804232804217e-02*G0_0_0 - 5.925925925925905e-02*G0_0_2 - 3.104056437389760e-02*G0_1_0 - 9.029982363315672e-02*G0_1_2;
    block[158] = 1.128747795414462e-02*G0_0_0 + 3.386243386243384e-02*G0_0_2 + 1.128747795414467e-02*G0_1_0 + 4.514991181657844e-02*G0_1_2;
    block[159] = 3.386243386243384e-02*G0_0_1 + 4.514991181657826e-02*G0_0_2 + 1.128747795414470e-02*G0_1_1 + 1.128747795414462e-02*G0_1_2;
    block[160] = 1.410934744268066e-02*G0_0_1 + 1.693121693121692e-02*G0_0_2 + 2.821869488535994e-03*G0_1_1 + 2.821869488536102e-03*G0_1_2;
    block[161] = 1.128747795414467e-02*G0_0_1 + 2.257495590828924e-02*G0_0_2 + 1.128747795414471e-02*G0_1_1 + 1.128747795414467e-02*G0_1_2;
    block[162] = -6.772486772486801e-02*G0_0_0 + 1.015873015873011e-01*G0_0_1 + 2.031746031746021e-01*G0_0_2 + 1.128747795414453e-02*G0_1_0 + 1.128747795414458e-01*G0_1_1 + 1.128747795414457e-01*G0_1_2;
    block[163] = 2.257495590828912e-02*G0_0_0 - 3.386243386243366e-02*G0_0_1 - 6.772486772486765e-02*G0_0_2 + 1.128747795414455e-02*G0_1_0 - 2.257495590828904e-02*G0_1_1 - 2.257495590828929e-02*G0_1_2;
    block[164] = 6.772486772486754e-02*G0_0_0 - 3.386243386243422e-02*G0_0_1 - 6.772486772486781e-02*G0_0_2 + 1.128747795414458e-02*G0_1_0 - 2.257495590828935e-02*G0_1_1 - 2.257495590828917e-02*G0_1_2;
    block[165] = -6.772486772486755e-02*G0_0_0 - 1.128747795414459e-02*G0_0_1 - 1.128747795414460e-02*G0_1_0;
    block[166] = -2.257495590828920e-02*G0_0_0 - 1.128747795414464e-02*G0_0_1 - 1.128747795414460e-02*G0_1_0;
    block[167] = -2.257495590828912e-02*G0_0_0 - 1.128747795414472e-02*G0_0_1 - 1.128747795414457e-02*G0_1_0;
    block[168] = 4.514991181657826e-02*G0_0_0 + 3.386243386243373e-02*G0_0_1 + 3.386243386243368e-02*G0_1_0 + 2.257495590828911e-02*G0_1_1;
    block[169] = -1.354497354497352e-01*G0_0_0 - 1.015873015873012e-01*G0_0_1 - 1.015873015873014e-01*G0_1_0 - 1.128747795414461e-01*G0_1_1;
    block[170] = 4.514991181657842e-02*G0_0_0 + 3.386243386243395e-02*G0_0_1 + 3.386243386243382e-02*G0_1_0 + 2.257495590828928e-02*G0_1_1;
    block[171] = 9.029982363315656e-02*G0_0_0 + 3.386243386243357e-02*G0_0_1 + 6.772486772486742e-02*G0_0_2 + 3.386243386243386e-02*G0_1_0 + 2.257495590828925e-02*G0_1_2;
    block[172] = -2.708994708994700e-01*G0_0_0 - 1.015873015873009e-01*G0_0_1 - 2.031746031746022e-01*G0_0_2 - 1.015873015873012e-01*G0_1_0 - 1.128747795414459e-01*G0_1_2;
    block[173] = 1.354497354497352e-01*G0_0_0 + 3.386243386243384e-02*G0_0_1 + 6.772486772486788e-02*G0_0_2 + 3.386243386243364e-02*G0_1_0 + 2.257495590828925e-02*G0_1_2;
    block[174] = 9.029982363315717e-02*G0_0_0;
    block[175] = 5.114638447971782e-03*G0_0_0 + 5.114638447971792e-03*G0_0_1 + 5.114638447971775e-03*G0_0_2 + 5.114638447971697e-03*G0_1_0 + 5.114638447971714e-03*G0_1_1 + 5.114638447971697e-03*G0_1_2;
    block[176] = 2.028218694885364e-02*G0_0_0 - 3.262786596119922e-02*G0_1_0;
    block[177] = -3.262786596119916e-02*G0_0_1 + 2.028218694885364e-02*G0_1_1;
    block[178] = -5.114638447971762e-03*G0_0_2 - 5.114638447971768e-03*G0_1_2;
    block[179] = -1.185185185185182e-01*G0_0_0 - 3.104056437389754e-02*G0_0_1 + 4.232804232804198e-02*G0_1_0 - 9.029982363315700e-02*G0_1_1;
    block[180] = 2.497354497354492e-01*G0_0_0 + 8.253968253968241e-02*G0_0_1 + 8.253968253968241e-02*G0_1_0 + 2.497354497354493e-01*G0_1_1;
    block[181] = -9.029982363315668e-02*G0_0_0 + 4.232804232804220e-02*G0_0_1 - 3.104056437389776e-02*G0_1_0 - 1.185185185185185e-01*G0_1_1;
    block[182] = 9.029982363315672e-02*G0_0_0 + 3.104056437389754e-02*G0_0_1 + 9.029982363315675e-02*G0_0_2 + 3.104056437389774e-02*G0_1_0 - 1.128747795414468e-02*G0_1_1 + 3.104056437389773e-02*G0_1_2;
    block[183] = 2.116402116402102e-02*G0_0_0 + 1.058201058201059e-02*G0_0_1 + 2.116402116402104e-02*G0_0_2 + 1.058201058201038e-02*G0_1_0 - 2.821869488536167e-03*G0_1_1 + 1.058201058201041e-02*G0_1_2;
    block[184] = -1.693121693121686e-02*G0_0_0 - 1.410934744268076e-02*G0_0_1 - 1.693121693121677e-02*G0_0_2 - 1.410934744268053e-02*G0_1_0 - 1.128747795414447e-02*G0_1_1 - 1.410934744268046e-02*G0_1_2;
    block[185] = -1.128747795414465e-02*G0_0_0 - 1.410934744268078e-02*G0_0_1 - 1.410934744268072e-02*G0_0_2 - 1.410934744268060e-02*G0_1_0 - 1.693121693121675e-02*G0_1_1 - 1.693121693121668e-02*G0_1_2;
    block[186] = -2.821869488536040e-03*G0_0_0 + 1.058201058201063e-02*G0_0_1 + 1.058201058201063e-02*G0_0_2 + 1.058201058201051e-02*G0_1_0 + 2.116402116402110e-02*G0_1_1 + 2.116402116402109e-02*G0_1_2;
    block[187] = -1.128747795414471e-02*G0_0_0 + 3.104056437389756e-02*G0_0_1 + 3.104056437389754e-02*G0_0_2 + 3.104056437389761e-02*G0_1_0 + 9.029982363315700e-02*G0_1_1 + 9.029982363315697e-02*G0_1_2;
    block[188] = -2.821869488536118e-03*G0_0_0 - 2.821869488536149e-03*G0_0_1 - 2.821869488536074e-03*G0_1_0 - 2.821869488536148e-03*G0_1_1;
    block[189] = -9.171075837742355e-03*G0_0_0 - 9.171075837742361e-03*G0_0_1 - 9.171075837742402e-03*G0_1_0 - 9.171075837742395e-03*G0_1_1;
    block[190] = -2.821869488536263e-03*G0_0_0 - 2.821869488536285e-03*G0_0_1 - 2.821869488536155e-03*G0_1_0 - 2.821869488536185e-03*G0_1_1;
    block[191] = -4.232804232804221e-02*G0_0_0 - 3.104056437389755e-02*G0_0_2 - 5.925925925925928e-02*G0_1_0 - 9.029982363315692e-02*G0_1_2;
    block[192] = -1.340388007054683e-02*G0_0_0 - 1.058201058201062e-02*G0_0_2 - 1.058201058201056e-02*G0_1_0 - 2.116402116402109e-02*G0_1_2;
    block[193] = 2.821869488536298e-03*G0_0_0 + 1.410934744268082e-02*G0_0_2 + 2.821869488536181e-03*G0_1_0 + 1.693121693121688e-02*G0_1_2;
    block[194] = -5.925925925925910e-02*G0_0_1 - 9.029982363315670e-02*G0_0_2 - 4.232804232804232e-02*G0_1_1 - 3.104056437389776e-02*G0_1_2;
    block[195] = -1.058201058201059e-02*G0_0_1 - 2.116402116402118e-02*G0_0_2 - 1.340388007054666e-02*G0_1_1 - 1.058201058201054e-02*G0_1_2;
    block[196] = 2.821869488536251e-03*G0_0_1 + 1.693121693121700e-02*G0_0_2 + 2.821869488536134e-03*G0_1_1 + 1.410934744268074e-02*G0_1_2;
    block[197] = 1.185185185185185e-01*G0_0_0 - 4.232804232804211e-02*G0_0_1 + 5.079365079365089e-02*G0_0_2 + 9.312169312169291e-02*G0_1_0 - 8.465608465608472e-02*G0_1_1 + 1.862433862433856e-01*G0_1_2;
    block[198] = -1.693121693121689e-02*G0_0_0 - 1.975308641975318e-02*G0_0_1 - 8.465608465608454e-02*G0_0_2 - 1.975308641975307e-02*G0_1_0 - 1.693121693121703e-02*G0_1_1 - 8.465608465608440e-02*G0_1_2;
    block[199] = -8.465608465608435e-02*G0_0_0 + 9.312169312169327e-02*G0_0_1 + 1.862433862433862e-01*G0_0_2 - 4.232804232804226e-02*G0_1_0 + 1.185185185185185e-01*G0_1_1 + 5.079365079365075e-02*G0_1_2;
    block[200] = 8.465608465608435e-02*G0_0_0 + 4.232804232804242e-02*G0_0_1 + 4.232804232804226e-02*G0_1_0 + 2.257495590828942e-02*G0_1_1;
    block[201] = 1.693121693121692e-02*G0_0_0 + 1.975308641975300e-02*G0_0_1 + 1.975308641975310e-02*G0_1_0 + 2.257495590828913e-02*G0_1_1;
    block[202] = 1.693121693121682e-02*G0_0_0 + 1.975308641975287e-02*G0_0_1 + 1.975308641975301e-02*G0_1_0 + 2.257495590828907e-02*G0_1_1;
    block[203] = 2.257495590828914e-02*G0_0_0 + 1.975308641975312e-02*G0_0_1 + 1.975308641975293e-02*G0_1_0 + 1.693121693121694e-02*G0_1_1;
    block[204] = 2.257495590828928e-02*G0_0_0 + 4.232804232804219e-02*G0_0_1 + 4.232804232804242e-02*G0_1_0 + 8.465608465608480e-02*G0_1_1;
    block[205] = 2.257495590828906e-02*G0_0_0 + 1.975308641975311e-02*G0_0_1 + 1.975308641975295e-02*G0_1_0 + 1.693121693121695e-02*G0_1_1;
    block[206] = 6.772486772486735e-02*G0_0_0 + 6.490299823633121e-02*G0_0_1 + 8.465608465608419e-02*G0_0_2 + 6.490299823633093e-02*G0_1_0 + 6.772486772486710e-02*G0_1_1 + 8.465608465608400e-02*G0_1_2;
    block[207] = 6.772486772486770e-02*G0_0_0 - 9.312169312169309e-02*G0_0_1 - 5.079365079365081e-02*G0_0_2 - 9.312169312169238e-02*G0_1_0 - 2.708994708994704e-01*G0_1_1 - 1.862433862433855e-01*G0_1_2;
    block[208] = -2.708994708994701e-01*G0_0_0 - 9.312169312169263e-02*G0_0_1 - 1.862433862433862e-01*G0_0_2 - 9.312169312169279e-02*G0_1_0 + 6.772486772486817e-02*G0_1_1 - 5.079365079365084e-02*G0_1_2;
    block[209] = -1.354497354497352e-01*G0_0_0 - 1.128747795414465e-01*G0_0_1 - 1.128747795414459e-01*G0_1_0 - 1.354497354497356e-01*G0_1_1;
    block[210] = 7.760141093474424e-03*G0_0_0 + 7.760141093474424e-03*G0_0_1 + 7.760141093474424e-03*G0_0_2 + 7.760141093474452e-03*G0_1_0 + 7.760141093474446e-03*G0_1_1 + 7.760141093474447e-03*G0_1_2;
    block[211] = -7.760141093474361e-03*G0_0_0 + 1.763668430335099e-02*G0_1_0;
    block[212] = 4.585537918871242e-02*G0_0_1 - 2.469135802469137e-02*G0_1_1;
    block[213] = -7.760141093474436e-03*G0_0_2 - 7.760141093474417e-03*G0_1_2;
    block[214] = 4.514991181657824e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 - 3.386243386243370e-02*G0_1_0 + 4.514991181657860e-02*G0_1_1;
    block[215] = -9.029982363315670e-02*G0_0_0 - 3.104056437389776e-02*G0_0_1 + 4.232804232804219e-02*G0_1_0 - 1.185185185185185e-01*G0_1_1;
    block[216] = 1.580246913580245e-01*G0_0_0 + 7.901234567901239e-02*G0_0_1 + 7.901234567901239e-02*G0_1_0 + 2.031746031746031e-01*G0_1_1;
    block[217] = -1.580246913580245e-01*G0_0_0 - 7.901234567901221e-02*G0_0_1 - 1.580246913580245e-01*G0_0_2 - 7.901234567901241e-02*G0_1_0 + 2.257495590828926e-02*G0_1_1 - 7.901234567901243e-02*G0_1_2;
    block[218] = 9.029982363315703e-02*G0_0_0 + 5.925925925925916e-02*G0_0_1 + 9.029982363315704e-02*G0_0_2 + 5.925925925925937e-02*G0_1_0 + 1.693121693121684e-02*G0_1_1 + 5.925925925925938e-02*G0_1_2;
    block[219] = -4.514991181657849e-02*G0_0_0 - 3.386243386243382e-02*G0_0_1 - 4.514991181657856e-02*G0_0_2 - 3.386243386243395e-02*G0_1_0 - 2.257495590828921e-02*G0_1_1 - 3.386243386243400e-02*G0_1_2;
    block[220] = -1.128747795414468e-02*G0_0_1 - 1.128747795414475e-02*G0_0_2 - 1.128747795414466e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 - 2.257495590828941e-02*G0_1_2;
    block[221] = -2.821869488536122e-03*G0_0_1 - 2.821869488536110e-03*G0_0_2 - 2.821869488536105e-03*G0_1_0 - 1.693121693121688e-02*G0_1_1 - 1.693121693121685e-02*G0_1_2;
    block[222] = -1.128747795414458e-02*G0_0_1 - 1.128747795414459e-02*G0_0_2 - 1.128747795414467e-02*G0_1_0 - 4.514991181657860e-02*G0_1_1 - 4.514991181657859e-02*G0_1_2;
    block[223] = -1.128747795414470e-02*G0_0_0 - 1.128747795414467e-02*G0_0_1 - 1.128747795414474e-02*G0_1_0 - 1.128747795414468e-02*G0_1_1;
    block[224] = -2.821869488536240e-03*G0_0_0 - 2.821869488536247e-03*G0_0_1 - 2.821869488536170e-03*G0_1_0 - 2.821869488536187e-03*G0_1_1;
    block[225] = -1.128747795414461e-02*G0_0_0 - 1.128747795414460e-02*G0_0_1 - 1.128747795414475e-02*G0_1_0 - 1.128747795414472e-02*G0_1_1;
    block[226] = 1.128747795414454e-02*G0_0_0 + 1.128747795414460e-02*G0_0_2 + 3.386243386243394e-02*G0_1_0 + 4.514991181657857e-02*G0_1_2;
    block[227] = 2.821869488536235e-03*G0_0_0 + 2.821869488536204e-03*G0_0_2 + 1.410934744268073e-02*G0_1_0 + 1.693121693121686e-02*G0_1_2;
    block[228] = 1.128747795414461e-02*G0_0_0 + 1.128747795414466e-02*G0_0_2 + 1.128747795414475e-02*G0_1_0 + 2.257495590828936e-02*G0_1_2;
    block[229] = 7.901234567901223e-02*G0_0_1 + 1.580246913580245e-01*G0_0_2 + 1.015873015873016e-01*G0_1_1 + 7.901234567901239e-02*G0_1_2;
    block[230] = -3.104056437389777e-02*G0_0_1 - 9.029982363315701e-02*G0_0_2 - 4.232804232804249e-02*G0_1_1 - 5.925925925925937e-02*G0_1_2;
    block[231] = 1.128747795414463e-02*G0_0_1 + 4.514991181657845e-02*G0_0_2 + 1.128747795414478e-02*G0_1_1 + 3.386243386243396e-02*G0_1_2;
    block[232] = -2.257495590828921e-02*G0_0_0 + 1.128747795414440e-02*G0_0_1 - 2.257495590828942e-02*G0_0_2 - 3.386243386243388e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 6.772486772486758e-02*G0_1_2;
    block[233] = -2.257495590828917e-02*G0_0_0 + 1.128747795414482e-02*G0_0_1 - 2.257495590828922e-02*G0_0_2 - 3.386243386243375e-02*G0_1_0 + 2.257495590828944e-02*G0_1_1 - 6.772486772486776e-02*G0_1_2;
    block[234] = 1.128747795414458e-01*G0_0_0 + 1.128747795414439e-02*G0_0_1 + 1.128747795414460e-01*G0_0_2 + 1.015873015873014e-01*G0_1_0 - 6.772486772486794e-02*G0_1_1 + 2.031746031746029e-01*G0_1_2;
    block[235] = -1.128747795414458e-01*G0_0_0 - 1.015873015873017e-01*G0_0_1 - 1.015873015873015e-01*G0_1_0 - 1.354497354497356e-01*G0_1_1;
    block[236] = 2.257495590828916e-02*G0_0_0 + 3.386243386243400e-02*G0_0_1 + 3.386243386243372e-02*G0_1_0 + 4.514991181657863e-02*G0_1_1;
    block[237] = 2.257495590828932e-02*G0_0_0 + 3.386243386243400e-02*G0_0_1 + 3.386243386243390e-02*G0_1_0 + 4.514991181657859e-02*G0_1_1;
    block[238] = -1.128747795414480e-02*G0_0_1 - 1.128747795414452e-02*G0_1_0 - 2.257495590828940e-02*G0_1_1;
    block[239] = -1.128747795414457e-02*G0_0_1 - 1.128747795414468e-02*G0_1_0 - 6.772486772486784e-02*G0_1_1;
    block[240] = -1.128747795414464e-02*G0_0_1 - 1.128747795414451e-02*G0_1_0 - 2.257495590828929e-02*G0_1_1;
    block[241] = 3.386243386243414e-02*G0_0_1 + 2.257495590828944e-02*G0_0_2 + 3.386243386243398e-02*G0_1_0 + 9.029982363315722e-02*G0_1_1 + 6.772486772486781e-02*G0_1_2;
    block[242] = 3.386243386243380e-02*G0_0_1 + 2.257495590828923e-02*G0_0_2 + 3.386243386243368e-02*G0_1_0 + 1.354497354497353e-01*G0_1_1 + 6.772486772486738e-02*G0_1_2;
    block[243] = -1.015873015873018e-01*G0_0_1 - 1.128747795414457e-01*G0_0_2 - 1.015873015873016e-01*G0_1_0 - 2.708994708994710e-01*G0_1_1 - 2.031746031746026e-01*G0_1_2;
    block[244] = 9.029982363315753e-02*G0_1_1;
    block[245] = -7.760141093474439e-03*G0_0_0 - 7.760141093474439e-03*G0_0_1 - 7.760141093474439e-03*G0_0_2 - 2.539682539682538e-02*G0_1_0 - 2.539682539682539e-02*G0_1_1 - 2.539682539682538e-02*G0_1_2 - 7.760141093474443e-03*G0_2_0 - 7.760141093474443e-03*G0_2_1 - 7.760141093474443e-03*G0_2_2;
    block[246] = 7.760141093474368e-03*G0_0_0 + 7.760141093474366e-03*G0_2_0;
    block[247] = -4.585537918871244e-02*G0_0_1 - 7.054673721340381e-02*G0_1_1 - 4.585537918871243e-02*G0_2_1;
    block[248] = 7.760141093474448e-03*G0_0_2 + 7.760141093474453e-03*G0_2_2;
    block[249] = -4.514991181657827e-02*G0_0_0 - 1.128747795414461e-02*G0_0_1 - 1.128747795414449e-02*G0_1_0 - 4.514991181657832e-02*G0_2_0 - 1.128747795414464e-02*G0_2_1;
    block[250] = 9.029982363315674e-02*G0_0_0 + 3.104056437389774e-02*G0_0_1 + 3.104056437389754e-02*G0_1_0 - 1.128747795414468e-02*G0_1_1 + 9.029982363315676e-02*G0_2_0 + 3.104056437389773e-02*G0_2_1;
    block[251] = -1.580246913580245e-01*G0_0_0 - 7.901234567901241e-02*G0_0_1 - 7.901234567901219e-02*G0_1_0 + 2.257495590828926e-02*G0_1_1 - 1.580246913580245e-01*G0_2_0 - 7.901234567901244e-02*G0_2_1;
    block[252] = 1.580246913580246e-01*G0_0_0 + 7.901234567901225e-02*G0_0_1 + 1.580246913580246e-01*G0_0_2 + 7.901234567901223e-02*G0_1_0 + 2.031746031746030e-01*G0_1_1 + 7.901234567901226e-02*G0_1_2 + 1.580246913580246e-01*G0_2_0 + 7.901234567901227e-02*G0_2_1 + 1.580246913580246e-01*G0_2_2;
    block[253] = -9.029982363315708e-02*G0_0_0 - 5.925925925925920e-02*G0_0_1 - 9.029982363315710e-02*G0_0_2 - 1.326278659611991e-01*G0_1_0 - 2.201058201058198e-01*G0_1_1 - 1.326278659611991e-01*G0_1_2 - 9.029982363315711e-02*G0_2_0 - 5.925925925925923e-02*G0_2_1 - 9.029982363315714e-02*G0_2_2;
    block[254] = 4.514991181657857e-02*G0_0_0 + 3.386243386243387e-02*G0_0_1 + 4.514991181657865e-02*G0_0_2 + 7.901234567901221e-02*G0_1_0 + 1.128747795414461e-01*G0_1_1 + 7.901234567901223e-02*G0_1_2 + 4.514991181657861e-02*G0_2_0 + 3.386243386243389e-02*G0_2_1 + 4.514991181657868e-02*G0_2_2;
    block[255] = 1.128747795414472e-02*G0_0_1 + 1.128747795414479e-02*G0_0_2 + 1.128747795414466e-02*G0_1_0 - 2.257495590828925e-02*G0_1_1 - 2.257495590828922e-02*G0_1_2 + 1.128747795414474e-02*G0_2_1 + 1.128747795414480e-02*G0_2_2;
    block[256] = 2.821869488536100e-03*G0_0_1 + 2.821869488536086e-03*G0_0_2 + 2.821869488536061e-03*G0_1_0 - 1.128747795414470e-02*G0_1_1 - 1.128747795414470e-02*G0_1_2 + 2.821869488536114e-03*G0_2_1 + 2.821869488536097e-03*G0_2_2;
    block[257] = 1.128747795414460e-02*G0_0_1 + 1.128747795414461e-02*G0_0_2 + 1.128747795414468e-02*G0_1_0 + 1.128747795414463e-02*G0_2_1 + 1.128747795414463e-02*G0_2_2;
    block[258] = 1.128747795414474e-02*G0_0_0 + 1.128747795414471e-02*G0_0_1 - 2.257495590828926e-02*G0_1_0 - 2.257495590828922e-02*G0_1_1 + 1.128747795414465e-02*G0_1_2 + 1.128747795414476e-02*G0_2_0 + 1.128747795414473e-02*G0_2_1;
    block[259] = 2.821869488536217e-03*G0_0_0 + 2.821869488536226e-03*G0_0_1 - 1.128747795414450e-02*G0_1_0 - 1.128747795414452e-02*G0_1_1 + 2.821869488536132e-03*G0_1_2 + 2.821869488536204e-03*G0_2_0 + 2.821869488536213e-03*G0_2_1;
    block[260] = 1.128747795414460e-02*G0_0_0 + 1.128747795414459e-02*G0_0_1 + 1.128747795414457e-02*G0_1_2 + 1.128747795414460e-02*G0_2_0 + 1.128747795414459e-02*G0_2_1;
    block[261] = -1.128747795414456e-02*G0_0_0 - 1.128747795414462e-02*G0_0_2 - 1.128747795414457e-02*G0_2_0 - 1.128747795414464e-02*G0_2_2;
    block[262] = -2.821869488536227e-03*G0_0_0 - 2.821869488536191e-03*G0_0_2 - 2.821869488536200e-03*G0_2_0 - 2.821869488536156e-03*G0_2_2;
    block[263] = -1.128747795414461e-02*G0_0_0 - 1.128747795414466e-02*G0_0_2 - 1.128747795414460e-02*G0_2_0 - 1.128747795414466e-02*G0_2_2;
    block[264] = -7.901234567901226e-02*G0_0_1 - 1.580246913580245e-01*G0_0_2 + 2.257495590828931e-02*G0_1_1 - 7.901234567901216e-02*G0_1_2 - 7.901234567901229e-02*G0_2_1 - 1.580246913580245e-01*G0_2_2;
    block[265] = 3.104056437389775e-02*G0_0_1 + 9.029982363315703e-02*G0_0_2 - 1.128747795414462e-02*G0_1_1 + 3.104056437389775e-02*G0_1_2 + 3.104056437389773e-02*G0_2_1 + 9.029982363315699e-02*G0_2_2;
    block[266] = -1.128747795414463e-02*G0_0_1 - 4.514991181657847e-02*G0_0_2 - 1.128747795414454e-02*G0_1_2 - 1.128747795414463e-02*G0_2_1 - 4.514991181657847e-02*G0_2_2;
    block[267] = 2.257495590828921e-02*G0_0_0 - 1.128747795414442e-02*G0_0_1 + 2.257495590828937e-02*G0_0_2 - 1.128747795414475e-02*G0_1_0 - 1.128747795414459e-02*G0_1_2 + 2.257495590828922e-02*G0_2_0 - 1.128747795414445e-02*G0_2_1 + 2.257495590828933e-02*G0_2_2;
    block[268] = 2.257495590828916e-02*G0_0_0 - 1.128747795414480e-02*G0_0_1 + 2.257495590828920e-02*G0_0_2 - 1.128747795414450e-02*G0_1_0 - 1.128747795414460e-02*G0_1_2 + 2.257495590828917e-02*G0_2_0 - 1.128747795414474e-02*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[269] = -1.128747795414459e-01*G0_0_0 - 1.128747795414448e-02*G0_0_1 - 1.128747795414461e-01*G0_0_2 - 1.128747795414453e-02*G0_1_0 - 4.514991181657858e-02*G0_1_1 - 1.128747795414476e-02*G0_1_2 - 1.128747795414459e-01*G0_2_0 - 1.128747795414449e-02*G0_2_1 - 1.128747795414461e-01*G0_2_2;
    block[270] = 1.128747795414459e-01*G0_0_0 + 1.015873015873017e-01*G0_0_1 + 1.128747795414456e-02*G0_1_0 - 6.772486772486766e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 1.128747795414460e-01*G0_2_0 + 1.015873015873018e-01*G0_2_1;
    block[271] = -2.257495590828914e-02*G0_0_0 - 3.386243386243394e-02*G0_0_1 + 1.128747795414450e-02*G0_1_0 + 2.257495590828912e-02*G0_1_1 - 3.386243386243401e-02*G0_1_2 - 2.257495590828916e-02*G0_2_0 - 3.386243386243393e-02*G0_2_1;
    block[272] = -2.257495590828941e-02*G0_0_0 - 3.386243386243409e-02*G0_0_1 + 1.128747795414465e-02*G0_1_0 + 6.772486772486763e-02*G0_1_1 - 3.386243386243373e-02*G0_1_2 - 2.257495590828944e-02*G0_2_0 - 3.386243386243416e-02*G0_2_1;
    block[273] = 1.128747795414478e-02*G0_0_1 + 1.128747795414460e-02*G0_1_0 + 1.128747795414440e-02*G0_1_2 + 1.128747795414473e-02*G0_2_1;
    block[274] = 1.128747795414460e-02*G0_0_1 + 1.128747795414451e-02*G0_1_0 + 1.128747795414477e-02*G0_1_2 + 1.128747795414462e-02*G0_2_1;
    block[275] = 1.128747795414460e-02*G0_0_1 + 1.128747795414460e-02*G0_1_0 - 4.514991181657842e-02*G0_1_1 + 1.128747795414476e-02*G0_1_2 + 1.128747795414465e-02*G0_2_1;
    block[276] = -3.386243386243423e-02*G0_0_1 - 2.257495590828952e-02*G0_0_2 - 3.386243386243384e-02*G0_1_0 + 6.772486772486767e-02*G0_1_1 + 1.128747795414447e-02*G0_1_2 - 3.386243386243424e-02*G0_2_1 - 2.257495590828948e-02*G0_2_2;
    block[277] = -3.386243386243377e-02*G0_0_1 - 2.257495590828918e-02*G0_0_2 - 3.386243386243386e-02*G0_1_0 + 2.257495590828949e-02*G0_1_1 + 1.128747795414461e-02*G0_1_2 - 3.386243386243378e-02*G0_2_1 - 2.257495590828912e-02*G0_2_2;
    block[278] = 1.015873015873018e-01*G0_0_1 + 1.128747795414458e-01*G0_0_2 + 1.015873015873016e-01*G0_1_0 - 6.772486772486774e-02*G0_1_1 + 1.128747795414470e-02*G0_1_2 + 1.015873015873019e-01*G0_2_1 + 1.128747795414458e-01*G0_2_2;
    block[279] = 9.029982363315697e-02*G0_1_1;
    block[280] = 2.028218694885360e-02*G0_0_0 + 2.028218694885360e-02*G0_0_1 + 2.028218694885360e-02*G0_0_2 + 5.291005291005280e-02*G0_1_0 + 5.291005291005280e-02*G0_1_1 + 5.291005291005281e-02*G0_1_2 + 2.028218694885359e-02*G0_2_0 + 2.028218694885359e-02*G0_2_1 + 2.028218694885360e-02*G0_2_2;
    block[281] = 5.114638447971865e-03*G0_0_0 + 5.114638447971860e-03*G0_2_0;
    block[282] = 3.262786596119924e-02*G0_0_1 + 5.291005291005283e-02*G0_1_1 + 3.262786596119925e-02*G0_2_1;
    block[283] = 5.114638447971760e-03*G0_0_2 + 5.114638447971749e-03*G0_2_2;
    block[284] = -1.693121693121700e-02*G0_0_0 - 2.821869488536073e-03*G0_0_1 - 2.821869488536266e-03*G0_1_0 - 1.693121693121697e-02*G0_2_0 - 2.821869488536041e-03*G0_2_1;
    block[285] = 2.116402116402102e-02*G0_0_0 + 1.058201058201038e-02*G0_0_1 + 1.058201058201059e-02*G0_1_0 - 2.821869488536165e-03*G0_1_1 + 2.116402116402103e-02*G0_2_0 + 1.058201058201041e-02*G0_2_1;
    block[286] = 9.029982363315703e-02*G0_0_0 + 5.925925925925937e-02*G0_0_1 + 5.925925925925915e-02*G0_1_0 + 1.693121693121683e-02*G0_1_1 + 9.029982363315704e-02*G0_2_0 + 5.925925925925938e-02*G0_2_1;
    block[287] = -9.029982363315707e-02*G0_0_0 - 1.326278659611991e-01*G0_0_1 - 9.029982363315711e-02*G0_0_2 - 5.925925925925920e-02*G0_1_0 - 2.201058201058199e-01*G0_1_1 - 5.925925925925923e-02*G0_1_2 - 9.029982363315710e-02*G0_2_0 - 1.326278659611991e-01*G0_2_1 - 9.029982363315714e-02*G0_2_2;
    block[288] = 2.497354497354496e-01*G0_0_0 + 1.671957671957669e-01*G0_0_1 + 2.497354497354495e-01*G0_0_2 + 1.671957671957669e-01*G0_1_0 + 3.343915343915339e-01*G0_1_1 + 1.671957671957669e-01*G0_1_2 + 2.497354497354496e-01*G0_2_0 + 1.671957671957669e-01*G0_2_1 + 2.497354497354496e-01*G0_2_2;
    block[289] = -1.185185185185184e-01*G0_0_0 - 8.747795414462066e-02*G0_0_1 - 1.185185185185184e-01*G0_0_2 - 1.608465608465605e-01*G0_1_0 - 2.201058201058197e-01*G0_1_1 - 1.608465608465605e-01*G0_1_2 - 1.185185185185184e-01*G0_2_0 - 8.747795414462063e-02*G0_2_1 - 1.185185185185185e-01*G0_2_2;
    block[290] = -1.128747795414457e-02*G0_0_0 - 4.232804232804238e-02*G0_0_1 - 4.232804232804241e-02*G0_0_2 - 4.232804232804223e-02*G0_1_0 + 1.693121693121700e-02*G0_1_1 + 1.693121693121698e-02*G0_1_2 - 1.128747795414456e-02*G0_2_0 - 4.232804232804242e-02*G0_2_1 - 4.232804232804243e-02*G0_2_2;
    block[291] = -2.821869488536125e-03*G0_0_0 - 1.340388007054667e-02*G0_0_1 - 1.340388007054667e-02*G0_0_2 - 1.340388007054662e-02*G0_1_0 - 2.821869488536041e-03*G0_1_1 - 2.821869488536031e-03*G0_1_2 - 2.821869488536139e-03*G0_2_0 - 1.340388007054665e-02*G0_2_1 - 1.340388007054666e-02*G0_2_2;
    block[292] = -1.128747795414476e-02*G0_0_0 + 2.821869488536104e-03*G0_0_1 + 2.821869488536102e-03*G0_0_2 + 2.821869488536034e-03*G0_1_0 - 1.128747795414474e-02*G0_2_0 + 2.821869488536072e-03*G0_2_1 + 2.821869488536072e-03*G0_2_2;
    block[293] = -4.232804232804241e-02*G0_0_0 - 4.232804232804237e-02*G0_0_1 - 1.128747795414465e-02*G0_0_2 + 1.693121693121697e-02*G0_1_0 + 1.693121693121693e-02*G0_1_1 - 4.232804232804226e-02*G0_1_2 - 4.232804232804242e-02*G0_2_0 - 4.232804232804239e-02*G0_2_1 - 1.128747795414464e-02*G0_2_2;
    block[294] = -1.340388007054674e-02*G0_0_0 - 1.340388007054677e-02*G0_0_1 - 2.821869488536168e-03*G0_0_2 - 2.821869488536234e-03*G0_1_0 - 2.821869488536224e-03*G0_1_1 - 1.340388007054673e-02*G0_1_2 - 1.340388007054673e-02*G0_2_0 - 1.340388007054675e-02*G0_2_1 - 2.821869488536168e-03*G0_2_2;
    block[295] = 2.821869488536208e-03*G0_0_0 + 2.821869488536226e-03*G0_0_1 - 1.128747795414459e-02*G0_0_2 + 2.821869488536179e-03*G0_1_2 + 2.821869488536190e-03*G0_2_0 + 2.821869488536210e-03*G0_2_1 - 1.128747795414458e-02*G0_2_2;
    block[296] = -2.821869488536241e-03*G0_0_0 - 2.821869488536088e-03*G0_0_2 - 2.821869488536205e-03*G0_2_0 - 2.821869488536058e-03*G0_2_2;
    block[297] = -9.171075837742322e-03*G0_0_0 - 9.171075837742421e-03*G0_0_2 - 9.171075837742350e-03*G0_2_0 - 9.171075837742458e-03*G0_2_2;
    block[298] = -2.821869488536197e-03*G0_0_0 - 2.821869488536176e-03*G0_0_2 - 2.821869488536180e-03*G0_2_0 - 2.821869488536138e-03*G0_2_2;
    block[299] = 5.925925925925933e-02*G0_0_1 + 9.029982363315703e-02*G0_0_2 + 1.693121693121691e-02*G0_1_1 + 5.925925925925912e-02*G0_1_2 + 5.925925925925934e-02*G0_2_1 + 9.029982363315706e-02*G0_2_2;
    block[300] = 1.058201058201047e-02*G0_0_1 + 2.116402116402099e-02*G0_0_2 - 2.821869488536224e-03*G0_1_1 + 1.058201058201050e-02*G0_1_2 + 1.058201058201048e-02*G0_2_1 + 2.116402116402096e-02*G0_2_2;
    block[301] = -2.821869488536192e-03*G0_0_1 - 1.693121693121696e-02*G0_0_2 - 2.821869488536189e-03*G0_1_2 - 2.821869488536175e-03*G0_2_1 - 1.693121693121690e-02*G0_2_2;
    block[302] = 1.693121693121705e-02*G0_0_0 - 2.821869488536171e-03*G0_0_1 + 1.693121693121681e-02*G0_0_2 - 2.821869488536157e-03*G0_1_0 - 2.821869488536226e-03*G0_1_2 + 1.693121693121704e-02*G0_2_0 - 2.821869488536145e-03*G0_2_1 + 1.693121693121689e-02*G0_2_2;
    block[303] = 1.693121693121668e-02*G0_0_0 - 2.821869488536165e-03*G0_0_1 + 1.693121693121685e-02*G0_0_2 - 2.821869488536275e-03*G0_1_0 - 2.821869488536280e-03*G0_1_2 + 1.693121693121668e-02*G0_2_0 - 2.821869488536189e-03*G0_2_1 + 1.693121693121676e-02*G0_2_2;
    block[304] = 8.465608465608471e-02*G0_0_0 + 4.232804232804230e-02*G0_0_1 + 8.465608465608471e-02*G0_0_2 + 4.232804232804219e-02*G0_1_0 + 2.257495590828920e-02*G0_1_1 + 4.232804232804230e-02*G0_1_2 + 8.465608465608469e-02*G0_2_0 + 4.232804232804229e-02*G0_2_1 + 8.465608465608475e-02*G0_2_2;
    block[305] = -8.465608465608468e-02*G0_0_0 - 1.777777777777779e-01*G0_0_1 - 2.708994708994705e-01*G0_0_2 - 4.232804232804222e-02*G0_1_0 - 1.693121693121682e-02*G0_1_1 - 1.777777777777773e-01*G0_1_2 - 8.465608465608468e-02*G0_2_0 - 1.777777777777779e-01*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[306] = -1.693121693121670e-02*G0_0_0 + 2.821869488536281e-03*G0_0_1 + 6.772486772486766e-02*G0_0_2 + 2.821869488536276e-03*G0_1_0 + 5.643738977072450e-03*G0_1_1 + 2.821869488536324e-03*G0_1_2 - 1.693121693121672e-02*G0_2_0 + 2.821869488536264e-03*G0_2_1 + 6.772486772486762e-02*G0_2_2;
    block[307] = 1.185185185185186e-01*G0_0_0 + 1.608465608465609e-01*G0_0_1 + 6.772486772486773e-02*G0_0_2 + 2.539682539682521e-02*G0_1_0 - 1.693121693121704e-02*G0_1_1 + 1.608465608465604e-01*G0_1_2 + 1.185185185185186e-01*G0_2_0 + 1.608465608465609e-01*G0_2_1 + 6.772486772486776e-02*G0_2_2;
    block[308] = 2.257495590828911e-02*G0_0_0 + 2.821869488536168e-03*G0_0_1 + 2.257495590828933e-02*G0_0_2 + 2.821869488536178e-03*G0_1_0 + 2.821869488536313e-03*G0_1_2 + 2.257495590828913e-02*G0_2_0 + 2.821869488536190e-03*G0_2_1 + 2.257495590828928e-02*G0_2_2;
    block[309] = 2.257495590828930e-02*G0_0_0 + 2.821869488536014e-03*G0_0_1 + 2.257495590828905e-02*G0_0_2 + 2.821869488536228e-03*G0_1_0 + 2.821869488535944e-03*G0_1_2 + 2.257495590828925e-02*G0_2_0 + 2.821869488535989e-03*G0_2_1 + 2.257495590828906e-02*G0_2_2;
    block[310] = 2.257495590828929e-02*G0_0_0 - 1.975308641975309e-02*G0_0_1 + 2.257495590828928e-02*G0_0_2 - 1.975308641975308e-02*G0_1_0 + 2.257495590828919e-02*G0_1_1 - 1.975308641975325e-02*G0_1_2 + 2.257495590828934e-02*G0_2_0 - 1.975308641975307e-02*G0_2_1 + 2.257495590828931e-02*G0_2_2;
    block[311] = 6.772486772486748e-02*G0_0_0 + 1.608465608465609e-01*G0_0_1 + 1.185185185185184e-01*G0_0_2 + 1.608465608465603e-01*G0_1_0 - 1.693121693121719e-02*G0_1_1 + 2.539682539682525e-02*G0_1_2 + 6.772486772486751e-02*G0_2_0 + 1.608465608465609e-01*G0_2_1 + 1.185185185185184e-01*G0_2_2;
    block[312] = 6.772486772486792e-02*G0_0_0 + 2.821869488536179e-03*G0_0_1 - 1.693121693121685e-02*G0_0_2 + 2.821869488536334e-03*G0_1_0 + 5.643738977072064e-03*G0_1_1 + 2.821869488536236e-03*G0_1_2 + 6.772486772486787e-02*G0_2_0 + 2.821869488536134e-03*G0_2_1 - 1.693121693121694e-02*G0_2_2;
    block[313] = -2.708994708994706e-01*G0_0_0 - 1.777777777777778e-01*G0_0_1 - 8.465608465608455e-02*G0_0_2 - 1.777777777777775e-01*G0_1_0 - 1.693121693121655e-02*G0_1_1 - 4.232804232804227e-02*G0_1_2 - 2.708994708994707e-01*G0_2_0 - 1.777777777777778e-01*G0_2_1 - 8.465608465608457e-02*G0_2_2;
    block[314] = -1.354497354497356e-01*G0_0_0 - 2.257495590828905e-02*G0_0_1 - 1.354497354497352e-01*G0_0_2 - 2.257495590828903e-02*G0_1_0 - 4.514991181657838e-02*G0_1_1 - 2.257495590828894e-02*G0_1_2 - 1.354497354497356e-01*G0_2_0 - 2.257495590828904e-02*G0_2_1 - 1.354497354497352e-01*G0_2_2;
    block[315] = -2.469135802469131e-02*G0_0_0 - 2.469135802469134e-02*G0_0_1 - 2.469135802469133e-02*G0_0_2 - 7.054673721340370e-02*G0_1_0 - 7.054673721340370e-02*G0_1_1 - 7.054673721340370e-02*G0_1_2 - 2.469135802469132e-02*G0_2_0 - 2.469135802469134e-02*G0_2_1 - 2.469135802469134e-02*G0_2_2;
    block[316] = 7.760141093474305e-03*G0_0_0 + 7.760141093474302e-03*G0_2_0;
    block[317] = -1.763668430335090e-02*G0_0_1 - 2.539682539682534e-02*G0_1_1 - 1.763668430335091e-02*G0_2_1;
    block[318] = 7.760141093474386e-03*G0_0_2 + 7.760141093474388e-03*G0_2_2;
    block[319] = -2.257495590828907e-02*G0_0_0 - 1.128747795414467e-02*G0_0_1 - 1.128747795414446e-02*G0_1_0 - 2.257495590828912e-02*G0_2_0 - 1.128747795414472e-02*G0_2_1;
    block[320] = -1.693121693121686e-02*G0_0_0 - 1.410934744268053e-02*G0_0_1 - 1.410934744268076e-02*G0_1_0 - 1.128747795414446e-02*G0_1_1 - 1.693121693121677e-02*G0_2_0 - 1.410934744268046e-02*G0_2_1;
    block[321] = -4.514991181657849e-02*G0_0_0 - 3.386243386243395e-02*G0_0_1 - 3.386243386243382e-02*G0_1_0 - 2.257495590828922e-02*G0_1_1 - 4.514991181657856e-02*G0_2_0 - 3.386243386243400e-02*G0_2_1;
    block[322] = 4.514991181657857e-02*G0_0_0 + 7.901234567901221e-02*G0_0_1 + 4.514991181657860e-02*G0_0_2 + 3.386243386243387e-02*G0_1_0 + 1.128747795414461e-01*G0_1_1 + 3.386243386243389e-02*G0_1_2 + 4.514991181657865e-02*G0_2_0 + 7.901234567901223e-02*G0_2_1 + 4.514991181657868e-02*G0_2_2;
    block[323] = -1.185185185185184e-01*G0_0_0 - 1.608465608465605e-01*G0_0_1 - 1.185185185185184e-01*G0_0_2 - 8.747795414462066e-02*G0_1_0 - 2.201058201058196e-01*G0_1_1 - 8.747795414462063e-02*G0_1_2 - 1.185185185185184e-01*G0_2_0 - 1.608465608465605e-01*G0_2_1 - 1.185185185185185e-01*G0_2_2;
    block[324] = 2.031746031746029e-01*G0_0_0 + 1.241622574955906e-01*G0_0_1 + 2.031746031746029e-01*G0_0_2 + 1.241622574955906e-01*G0_1_0 + 2.031746031746028e-01*G0_1_1 + 1.241622574955906e-01*G0_1_2 + 2.031746031746029e-01*G0_2_0 + 1.241622574955906e-01*G0_2_1 + 2.031746031746030e-01*G0_2_2;
    block[325] = 2.257495590828914e-02*G0_0_0 + 1.015873015873015e-01*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 1.015873015873013e-01*G0_1_0 + 2.257495590828914e-02*G0_1_1 + 2.257495590828915e-02*G0_1_2 + 2.257495590828915e-02*G0_2_0 + 1.015873015873015e-01*G0_2_1 + 1.015873015873016e-01*G0_2_2;
    block[326] = 1.693121693121687e-02*G0_0_0 - 4.232804232804233e-02*G0_0_1 - 4.232804232804232e-02*G0_0_2 - 4.232804232804227e-02*G0_1_0 - 1.128747795414466e-02*G0_1_1 - 1.128747795414467e-02*G0_1_2 + 1.693121693121689e-02*G0_2_0 - 4.232804232804230e-02*G0_2_1 - 4.232804232804229e-02*G0_2_2;
    block[327] = -2.257495590828907e-02*G0_0_0 + 1.128747795414472e-02*G0_0_1 + 1.128747795414472e-02*G0_0_2 + 1.128747795414469e-02*G0_1_0 - 2.257495590828907e-02*G0_2_0 + 1.128747795414477e-02*G0_2_1 + 1.128747795414477e-02*G0_2_2;
    block[328] = 1.015873015873016e-01*G0_0_0 + 1.015873015873015e-01*G0_0_1 + 2.257495590828929e-02*G0_0_2 + 2.257495590828924e-02*G0_1_0 + 2.257495590828927e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 1.015873015873016e-01*G0_2_0 + 1.015873015873015e-01*G0_2_1 + 2.257495590828930e-02*G0_2_2;
    block[329] = -4.232804232804231e-02*G0_0_0 - 4.232804232804229e-02*G0_0_1 + 1.693121693121686e-02*G0_0_2 - 1.128747795414460e-02*G0_1_0 - 1.128747795414460e-02*G0_1_1 - 4.232804232804226e-02*G0_1_2 - 4.232804232804231e-02*G0_2_0 - 4.232804232804231e-02*G0_2_1 + 1.693121693121686e-02*G0_2_2;
    block[330] = 1.128747795414465e-02*G0_0_0 + 1.128747795414464e-02*G0_0_1 - 2.257495590828917e-02*G0_0_2 + 1.128747795414454e-02*G0_1_2 + 1.128747795414467e-02*G0_2_0 + 1.128747795414466e-02*G0_2_1 - 2.257495590828917e-02*G0_2_2;
    block[331] = -1.128747795414462e-02*G0_0_0 - 1.128747795414471e-02*G0_0_2 - 1.128747795414466e-02*G0_2_0 - 1.128747795414476e-02*G0_2_2;
    block[332] = -2.821869488536107e-03*G0_0_0 - 2.821869488536129e-03*G0_0_2 - 2.821869488536075e-03*G0_2_0 - 2.821869488536079e-03*G0_2_2;
    block[333] = -1.128747795414471e-02*G0_0_0 - 1.128747795414466e-02*G0_0_2 - 1.128747795414473e-02*G0_2_0 - 1.128747795414469e-02*G0_2_2;
    block[334] = -3.386243386243395e-02*G0_0_1 - 4.514991181657847e-02*G0_0_2 - 2.257495590828925e-02*G0_1_1 - 3.386243386243379e-02*G0_1_2 - 3.386243386243399e-02*G0_2_1 - 4.514991181657854e-02*G0_2_2;
    block[335] = -1.410934744268070e-02*G0_0_1 - 1.693121693121695e-02*G0_0_2 - 1.128747795414461e-02*G0_1_1 - 1.410934744268079e-02*G0_1_2 - 1.410934744268073e-02*G0_2_1 - 1.693121693121694e-02*G0_2_2;
    block[336] = -1.128747795414470e-02*G0_0_1 - 2.257495590828925e-02*G0_0_2 - 1.128747795414462e-02*G0_1_2 - 1.128747795414472e-02*G0_2_1 - 2.257495590828928e-02*G0_2_2;
    block[337] = -2.257495590828915e-02*G0_0_0 - 1.128747795414447e-02*G0_0_1 - 2.257495590828903e-02*G0_0_2 - 1.128747795414442e-02*G0_1_0 - 1.128747795414439e-02*G0_1_2 - 2.257495590828907e-02*G0_2_0 - 1.128747795414448e-02*G0_2_1 - 2.257495590828902e-02*G0_2_2;
    block[338] = -2.257495590828918e-02*G0_0_0 - 1.128747795414455e-02*G0_0_1 - 2.257495590828913e-02*G0_0_2 - 1.128747795414460e-02*G0_1_0 - 1.128747795414452e-02*G0_1_2 - 2.257495590828925e-02*G0_2_0 - 1.128747795414456e-02*G0_2_1 - 2.257495590828916e-02*G0_2_2;
    block[339] = -6.772486772486777e-02*G0_0_0 - 5.643738977072309e-02*G0_0_1 - 6.772486772486767e-02*G0_0_2 - 5.643738977072312e-02*G0_1_0 - 4.514991181657842e-02*G0_1_1 - 5.643738977072310e-02*G0_1_2 - 6.772486772486787e-02*G0_2_0 - 5.643738977072309e-02*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[340] = 6.772486772486780e-02*G0_0_0 + 1.015873015873017e-01*G0_0_1 + 1.354497354497353e-01*G0_0_2 + 5.643738977072312e-02*G0_1_0 + 6.772486772486766e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 6.772486772486788e-02*G0_2_0 + 1.015873015873017e-01*G0_2_1 + 1.354497354497354e-01*G0_2_2;
    block[341] = 2.257495590828922e-02*G0_0_0 + 5.643738977072303e-02*G0_0_1 + 9.029982363315693e-02*G0_0_2 + 1.128747795414462e-02*G0_1_0 + 2.257495590828920e-02*G0_1_1 + 5.643738977072303e-02*G0_1_2 + 2.257495590828929e-02*G0_2_0 + 5.643738977072305e-02*G0_2_1 + 9.029982363315693e-02*G0_2_2;
    block[342] = -6.772486772486785e-02*G0_0_0 - 1.693121693121692e-01*G0_0_1 - 2.708994708994706e-01*G0_0_2 - 7.901234567901222e-02*G0_1_0 - 6.772486772486765e-02*G0_1_1 - 1.693121693121690e-01*G0_1_2 - 6.772486772486785e-02*G0_2_0 - 1.693121693121692e-01*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[343] = 4.514991181657837e-02*G0_0_0 + 1.128747795414455e-02*G0_0_1 + 4.514991181657844e-02*G0_0_2 + 1.128747795414460e-02*G0_1_0 + 1.128747795414463e-02*G0_1_2 + 4.514991181657832e-02*G0_2_0 + 1.128747795414456e-02*G0_2_1 + 4.514991181657847e-02*G0_2_2;
    block[344] = 4.514991181657847e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 + 4.514991181657844e-02*G0_0_2 + 1.128747795414456e-02*G0_1_0 + 1.128747795414466e-02*G0_1_2 + 4.514991181657848e-02*G0_2_0 + 1.128747795414462e-02*G0_2_1 + 4.514991181657838e-02*G0_2_2;
    block[345] = -1.354497354497355e-01*G0_0_0 - 3.386243386243394e-02*G0_0_1 - 1.354497354497353e-01*G0_0_2 - 3.386243386243384e-02*G0_1_0 - 4.514991181657845e-02*G0_1_1 - 3.386243386243378e-02*G0_1_2 - 1.354497354497354e-01*G0_2_0 - 3.386243386243389e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[346] = -2.708994708994702e-01*G0_0_0 - 1.693121693121691e-01*G0_0_1 - 6.772486772486754e-02*G0_0_2 - 1.693121693121689e-01*G0_1_0 - 6.772486772486738e-02*G0_1_1 - 7.901234567901212e-02*G0_1_2 - 2.708994708994703e-01*G0_2_0 - 1.693121693121691e-01*G0_2_1 - 6.772486772486755e-02*G0_2_2;
    block[347] = 9.029982363315646e-02*G0_0_0 + 5.643738977072284e-02*G0_0_1 + 2.257495590828903e-02*G0_0_2 + 5.643738977072279e-02*G0_1_0 + 2.257495590828922e-02*G0_1_1 + 1.128747795414438e-02*G0_1_2 + 9.029982363315650e-02*G0_2_0 + 5.643738977072275e-02*G0_2_1 + 2.257495590828903e-02*G0_2_2;
    block[348] = 1.354497354497353e-01*G0_0_0 + 1.015873015873015e-01*G0_0_1 + 6.772486772486758e-02*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 6.772486772486741e-02*G0_1_1 + 5.643738977072305e-02*G0_1_2 + 1.354497354497353e-01*G0_2_0 + 1.015873015873015e-01*G0_2_1 + 6.772486772486758e-02*G0_2_2;
    block[349] = 9.029982363315696e-02*G0_0_0 + 9.029982363315685e-02*G0_0_1 + 9.029982363315667e-02*G0_0_2 + 9.029982363315664e-02*G0_1_0 + 9.029982363315688e-02*G0_1_1 + 9.029982363315668e-02*G0_1_2 + 9.029982363315693e-02*G0_2_0 + 9.029982363315685e-02*G0_2_1 + 9.029982363315671e-02*G0_2_2;
    block[350] = -7.054673721340374e-02*G0_0_0 - 7.054673721340371e-02*G0_0_1 - 7.054673721340371e-02*G0_0_2 - 2.469135802469129e-02*G0_1_0 - 2.469135802469131e-02*G0_1_1 - 2.469135802469131e-02*G0_1_2 - 2.469135802469129e-02*G0_2_0 - 2.469135802469131e-02*G0_2_1 - 2.469135802469131e-02*G0_2_2;
    block[351] = -2.539682539682534e-02*G0_0_0 - 1.763668430335101e-02*G0_1_0 - 1.763668430335102e-02*G0_2_0;
    block[352] = 7.760141093474462e-03*G0_1_1 + 7.760141093474449e-03*G0_2_1;
    block[353] = 7.760141093474387e-03*G0_1_2 + 7.760141093474405e-03*G0_2_2;
    block[354] = -2.257495590828900e-02*G0_0_0 - 3.386243386243372e-02*G0_0_1 - 3.386243386243364e-02*G0_1_0 - 4.514991181657839e-02*G0_1_1 - 3.386243386243366e-02*G0_2_0 - 4.514991181657843e-02*G0_2_1;
    block[355] = -1.128747795414466e-02*G0_0_0 - 1.410934744268060e-02*G0_0_1 - 1.410934744268077e-02*G0_1_0 - 1.693121693121674e-02*G0_1_1 - 1.410934744268072e-02*G0_2_0 - 1.693121693121668e-02*G0_2_1;
    block[356] = -1.128747795414467e-02*G0_0_1 - 1.128747795414468e-02*G0_1_0 - 2.257495590828937e-02*G0_1_1 - 1.128747795414474e-02*G0_2_0 - 2.257495590828941e-02*G0_2_1;
    block[357] = 1.128747795414466e-02*G0_0_1 + 1.128747795414472e-02*G0_1_0 - 2.257495590828925e-02*G0_1_1 + 1.128747795414474e-02*G0_1_2 + 1.128747795414479e-02*G0_2_0 - 2.257495590828922e-02*G0_2_1 + 1.128747795414480e-02*G0_2_2;
    block[358] = -1.128747795414457e-02*G0_0_0 - 4.232804232804223e-02*G0_0_1 - 1.128747795414456e-02*G0_0_2 - 4.232804232804238e-02*G0_1_0 + 1.693121693121700e-02*G0_1_1 - 4.232804232804242e-02*G0_1_2 - 4.232804232804241e-02*G0_2_0 + 1.693121693121698e-02*G0_2_1 - 4.232804232804243e-02*G0_2_2;
    block[359] = 2.257495590828914e-02*G0_0_0 + 1.015873015873013e-01*G0_0_1 + 2.257495590828915e-02*G0_0_2 + 1.015873015873015e-01*G0_1_0 + 2.257495590828914e-02*G0_1_1 + 1.015873015873015e-01*G0_1_2 + 1.015873015873015e-01*G0_2_0 + 2.257495590828915e-02*G0_2_1 + 1.015873015873016e-01*G0_2_2;
    block[360] = 2.031746031746027e-01*G0_0_0 + 1.241622574955904e-01*G0_0_1 + 1.241622574955905e-01*G0_0_2 + 1.241622574955904e-01*G0_1_0 + 2.031746031746029e-01*G0_1_1 + 2.031746031746029e-01*G0_1_2 + 1.241622574955905e-01*G0_2_0 + 2.031746031746029e-01*G0_2_1 + 2.031746031746028e-01*G0_2_2;
    block[361] = -2.201058201058195e-01*G0_0_0 - 8.747795414462062e-02*G0_0_1 - 8.747795414462062e-02*G0_0_2 - 1.608465608465604e-01*G0_1_0 - 1.185185185185184e-01*G0_1_1 - 1.185185185185183e-01*G0_1_2 - 1.608465608465605e-01*G0_2_0 - 1.185185185185184e-01*G0_2_1 - 1.185185185185183e-01*G0_2_2;
    block[362] = 1.128747795414460e-01*G0_0_0 + 3.386243386243374e-02*G0_0_1 + 3.386243386243375e-02*G0_0_2 + 7.901234567901221e-02*G0_1_0 + 4.514991181657849e-02*G0_1_1 + 4.514991181657849e-02*G0_1_2 + 7.901234567901222e-02*G0_2_0 + 4.514991181657853e-02*G0_2_1 + 4.514991181657852e-02*G0_2_2;
    block[363] = 2.257495590828913e-02*G0_0_0 + 2.257495590828918e-02*G0_0_1 + 1.015873015873013e-01*G0_0_2 + 1.015873015873016e-01*G0_1_0 + 1.015873015873016e-01*G0_1_1 + 2.257495590828924e-02*G0_1_2 + 1.015873015873016e-01*G0_2_0 + 1.015873015873016e-01*G0_2_1 + 2.257495590828923e-02*G0_2_2;
    block[364] = -1.128747795414456e-02*G0_0_0 - 1.128747795414456e-02*G0_0_1 - 4.232804232804224e-02*G0_0_2 - 4.232804232804232e-02*G0_1_0 - 4.232804232804230e-02*G0_1_1 + 1.693121693121686e-02*G0_1_2 - 4.232804232804232e-02*G0_2_0 - 4.232804232804230e-02*G0_2_1 + 1.693121693121689e-02*G0_2_2;
    block[365] = 1.128747795414453e-02*G0_0_2 + 1.128747795414467e-02*G0_1_0 + 1.128747795414467e-02*G0_1_1 - 2.257495590828917e-02*G0_1_2 + 1.128747795414468e-02*G0_2_0 + 1.128747795414468e-02*G0_2_1 - 2.257495590828920e-02*G0_2_2;
    block[366] = -2.257495590828908e-02*G0_0_0 - 3.386243386243371e-02*G0_0_2 - 3.386243386243377e-02*G0_1_0 - 4.514991181657844e-02*G0_1_2 - 3.386243386243378e-02*G0_2_0 - 4.514991181657847e-02*G0_2_2;
    block[367] = -1.128747795414468e-02*G0_0_0 - 1.410934744268082e-02*G0_0_2 - 1.410934744268076e-02*G0_1_0 - 1.693121693121687e-02*G0_1_2 - 1.410934744268072e-02*G0_2_0 - 1.693121693121681e-02*G0_2_2;
    block[368] = -1.128747795414464e-02*G0_0_2 - 1.128747795414476e-02*G0_1_0 - 2.257495590828931e-02*G0_1_2 - 1.128747795414477e-02*G0_2_0 - 2.257495590828934e-02*G0_2_2;
    block[369] = -1.128747795414473e-02*G0_1_1 - 1.128747795414469e-02*G0_1_2 - 1.128747795414477e-02*G0_2_1 - 1.128747795414476e-02*G0_2_2;
    block[370] = -2.821869488536061e-03*G0_1_1 - 2.821869488536140e-03*G0_1_2 - 2.821869488536066e-03*G0_2_1 - 2.821869488536119e-03*G0_2_2;
    block[371] = -1.128747795414474e-02*G0_1_1 - 1.128747795414469e-02*G0_1_2 - 1.128747795414476e-02*G0_2_1 - 1.128747795414474e-02*G0_2_2;
    block[372] = -4.514991181657830e-02*G0_0_0 - 5.643738977072276e-02*G0_0_1 - 5.643738977072270e-02*G0_0_2 - 5.643738977072311e-02*G0_1_0 - 6.772486772486745e-02*G0_1_1 - 6.772486772486747e-02*G0_1_2 - 5.643738977072302e-02*G0_2_0 - 6.772486772486738e-02*G0_2_1 - 6.772486772486741e-02*G0_2_2;
    block[373] = -1.128747795414477e-02*G0_0_1 - 1.128747795414468e-02*G0_0_2 - 1.128747795414470e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 - 2.257495590828931e-02*G0_1_2 - 1.128747795414471e-02*G0_2_0 - 2.257495590828933e-02*G0_2_1 - 2.257495590828925e-02*G0_2_2;
    block[374] = -1.128747795414455e-02*G0_0_1 - 1.128747795414467e-02*G0_0_2 - 1.128747795414468e-02*G0_1_0 - 2.257495590828934e-02*G0_1_1 - 2.257495590828930e-02*G0_1_2 - 1.128747795414476e-02*G0_2_0 - 2.257495590828932e-02*G0_2_1 - 2.257495590828934e-02*G0_2_2;
    block[375] = 1.128747795414454e-02*G0_0_1 + 1.128747795414453e-02*G0_0_2 + 1.128747795414470e-02*G0_1_0 + 4.514991181657867e-02*G0_1_1 + 4.514991181657855e-02*G0_1_2 + 1.128747795414479e-02*G0_2_0 + 4.514991181657871e-02*G0_2_1 + 4.514991181657856e-02*G0_2_2;
    block[376] = 1.128747795414454e-02*G0_0_1 + 1.128747795414460e-02*G0_0_2 + 1.128747795414474e-02*G0_1_0 + 4.514991181657840e-02*G0_1_1 + 4.514991181657852e-02*G0_1_2 + 1.128747795414475e-02*G0_2_0 + 4.514991181657842e-02*G0_2_1 + 4.514991181657859e-02*G0_2_2;
    block[377] = -4.514991181657831e-02*G0_0_0 - 3.386243386243368e-02*G0_0_1 - 3.386243386243372e-02*G0_0_2 - 3.386243386243402e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 1.354497354497352e-01*G0_1_2 - 3.386243386243405e-02*G0_2_0 - 1.354497354497354e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[378] = 2.257495590828925e-02*G0_0_0 + 1.128747795414477e-02*G0_0_1 + 5.643738977072302e-02*G0_0_2 + 5.643738977072306e-02*G0_1_0 + 2.257495590828932e-02*G0_1_1 + 9.029982363315690e-02*G0_1_2 + 5.643738977072301e-02*G0_2_0 + 2.257495590828930e-02*G0_2_1 + 9.029982363315697e-02*G0_2_2;
    block[379] = 6.772486772486745e-02*G0_0_0 + 5.643738977072276e-02*G0_0_1 + 1.015873015873014e-01*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 6.772486772486755e-02*G0_1_1 + 1.354497354497352e-01*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 6.772486772486752e-02*G0_2_1 + 1.354497354497351e-01*G0_2_2;
    block[380] = -6.772486772486754e-02*G0_0_0 - 7.901234567901218e-02*G0_0_1 - 1.693121693121689e-01*G0_0_2 - 1.693121693121692e-01*G0_1_0 - 6.772486772486763e-02*G0_1_1 - 2.708994708994705e-01*G0_1_2 - 1.693121693121691e-01*G0_2_0 - 6.772486772486765e-02*G0_2_1 - 2.708994708994704e-01*G0_2_2;
    block[381] = -6.772486772486744e-02*G0_0_0 - 1.693121693121687e-01*G0_0_1 - 7.901234567901212e-02*G0_0_2 - 1.693121693121689e-01*G0_1_0 - 2.708994708994705e-01*G0_1_1 - 6.772486772486760e-02*G0_1_2 - 1.693121693121689e-01*G0_2_0 - 2.708994708994705e-01*G0_2_1 - 6.772486772486755e-02*G0_2_2;
    block[382] = 6.772486772486733e-02*G0_0_0 + 1.015873015873012e-01*G0_0_1 + 5.643738977072264e-02*G0_0_2 + 1.015873015873011e-01*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 6.772486772486744e-02*G0_1_2 + 1.015873015873011e-01*G0_2_0 + 1.354497354497349e-01*G0_2_1 + 6.772486772486737e-02*G0_2_2;
    block[383] = 2.257495590828919e-02*G0_0_0 + 5.643738977072289e-02*G0_0_1 + 1.128747795414464e-02*G0_0_2 + 5.643738977072316e-02*G0_1_0 + 9.029982363315700e-02*G0_1_1 + 2.257495590828922e-02*G0_1_2 + 5.643738977072312e-02*G0_2_0 + 9.029982363315703e-02*G0_2_1 + 2.257495590828926e-02*G0_2_2;
    block[384] = 9.029982363315658e-02*G0_0_0 + 9.029982363315674e-02*G0_0_1 + 9.029982363315681e-02*G0_0_2 + 9.029982363315710e-02*G0_1_0 + 9.029982363315682e-02*G0_1_1 + 9.029982363315690e-02*G0_1_2 + 9.029982363315703e-02*G0_2_0 + 9.029982363315679e-02*G0_2_1 + 9.029982363315681e-02*G0_2_2;
    block[385] = 5.291005291005283e-02*G0_0_0 + 5.291005291005279e-02*G0_0_1 + 5.291005291005280e-02*G0_0_2 + 2.028218694885358e-02*G0_1_0 + 2.028218694885360e-02*G0_1_1 + 2.028218694885358e-02*G0_1_2 + 2.028218694885358e-02*G0_2_0 + 2.028218694885360e-02*G0_2_1 + 2.028218694885358e-02*G0_2_2;
    block[386] = 5.291005291005282e-02*G0_0_0 + 3.262786596119927e-02*G0_1_0 + 3.262786596119927e-02*G0_2_0;
    block[387] = 5.114638447971782e-03*G0_1_1 + 5.114638447971790e-03*G0_2_1;
    block[388] = 5.114638447971749e-03*G0_1_2 + 5.114638447971742e-03*G0_2_2;
    block[389] = 1.693121693121671e-02*G0_0_0 + 5.925925925925905e-02*G0_0_1 + 5.925925925925901e-02*G0_1_0 + 9.029982363315672e-02*G0_1_1 + 5.925925925925900e-02*G0_2_0 + 9.029982363315671e-02*G0_2_1;
    block[390] = -2.821869488536040e-03*G0_0_0 + 1.058201058201050e-02*G0_0_1 + 1.058201058201063e-02*G0_1_0 + 2.116402116402112e-02*G0_1_1 + 1.058201058201063e-02*G0_2_0 + 2.116402116402110e-02*G0_2_1;
    block[391] = -2.821869488536106e-03*G0_0_1 - 2.821869488536122e-03*G0_1_0 - 1.693121693121687e-02*G0_1_1 - 2.821869488536108e-03*G0_2_0 - 1.693121693121686e-02*G0_2_1;
    block[392] = 2.821869488536061e-03*G0_0_1 + 2.821869488536102e-03*G0_1_0 - 1.128747795414470e-02*G0_1_1 + 2.821869488536114e-03*G0_1_2 + 2.821869488536085e-03*G0_2_0 - 1.128747795414471e-02*G0_2_1 + 2.821869488536100e-03*G0_2_2;
    block[393] = -2.821869488536125e-03*G0_0_0 - 1.340388007054661e-02*G0_0_1 - 2.821869488536138e-03*G0_0_2 - 1.340388007054667e-02*G0_1_0 - 2.821869488536042e-03*G0_1_1 - 1.340388007054665e-02*G0_1_2 - 1.340388007054667e-02*G0_2_0 - 2.821869488536031e-03*G0_2_1 - 1.340388007054666e-02*G0_2_2;
    block[394] = 1.693121693121689e-02*G0_0_0 - 4.232804232804227e-02*G0_0_1 + 1.693121693121689e-02*G0_0_2 - 4.232804232804233e-02*G0_1_0 - 1.128747795414466e-02*G0_1_1 - 4.232804232804230e-02*G0_1_2 - 4.232804232804232e-02*G0_2_0 - 1.128747795414467e-02*G0_2_1 - 4.232804232804230e-02*G0_2_2;
    block[395] = -2.201058201058196e-01*G0_0_0 - 1.608465608465604e-01*G0_0_1 - 1.608465608465604e-01*G0_0_2 - 8.747795414462062e-02*G0_1_0 - 1.185185185185184e-01*G0_1_1 - 1.185185185185184e-01*G0_1_2 - 8.747795414462062e-02*G0_2_0 - 1.185185185185183e-01*G0_2_1 - 1.185185185185183e-01*G0_2_2;
    block[396] = 3.343915343915336e-01*G0_0_0 + 1.671957671957669e-01*G0_0_1 + 1.671957671957670e-01*G0_0_2 + 1.671957671957669e-01*G0_1_0 + 2.497354497354494e-01*G0_1_1 + 2.497354497354495e-01*G0_1_2 + 1.671957671957670e-01*G0_2_0 + 2.497354497354495e-01*G0_2_1 + 2.497354497354494e-01*G0_2_2;
    block[397] = -2.201058201058196e-01*G0_0_0 - 5.925925925925909e-02*G0_0_1 - 5.925925925925910e-02*G0_0_2 - 1.326278659611991e-01*G0_1_0 - 9.029982363315690e-02*G0_1_1 - 9.029982363315689e-02*G0_1_2 - 1.326278659611991e-01*G0_2_0 - 9.029982363315689e-02*G0_2_1 - 9.029982363315688e-02*G0_2_2;
    block[398] = 1.693121693121695e-02*G0_0_0 + 1.693121693121690e-02*G0_0_1 - 4.232804232804224e-02*G0_0_2 - 4.232804232804235e-02*G0_1_0 - 4.232804232804237e-02*G0_1_1 - 1.128747795414467e-02*G0_1_2 - 4.232804232804234e-02*G0_2_0 - 4.232804232804237e-02*G0_2_1 - 1.128747795414468e-02*G0_2_2;
    block[399] = -2.821869488536218e-03*G0_0_0 - 2.821869488536219e-03*G0_0_1 - 1.340388007054672e-02*G0_0_2 - 1.340388007054675e-02*G0_1_0 - 1.340388007054675e-02*G0_1_1 - 2.821869488536142e-03*G0_1_2 - 1.340388007054674e-02*G0_2_0 - 1.340388007054674e-02*G0_2_1 - 2.821869488536142e-03*G0_2_2;
    block[400] = 2.821869488536189e-03*G0_0_2 + 2.821869488536169e-03*G0_1_0 + 2.821869488536162e-03*G0_1_1 - 1.128747795414459e-02*G0_1_2 + 2.821869488536155e-03*G0_2_0 + 2.821869488536149e-03*G0_2_1 - 1.128747795414458e-02*G0_2_2;
    block[401] = 1.693121693121676e-02*G0_0_0 + 5.925925925925906e-02*G0_0_2 + 5.925925925925912e-02*G0_1_0 + 9.029982363315681e-02*G0_1_2 + 5.925925925925911e-02*G0_2_0 + 9.029982363315679e-02*G0_2_2;
    block[402] = -2.821869488536038e-03*G0_0_0 + 1.058201058201063e-02*G0_0_2 + 1.058201058201070e-02*G0_1_0 + 2.116402116402120e-02*G0_1_2 + 1.058201058201067e-02*G0_2_0 + 2.116402116402115e-02*G0_2_2;
    block[403] = -2.821869488536128e-03*G0_0_2 - 2.821869488536122e-03*G0_1_0 - 1.693121693121686e-02*G0_1_2 - 2.821869488536108e-03*G0_2_0 - 1.693121693121682e-02*G0_2_2;
    block[404] = -2.821869488536155e-03*G0_1_1 - 2.821869488536137e-03*G0_1_2 - 2.821869488536138e-03*G0_2_1 - 2.821869488536123e-03*G0_2_2;
    block[405] = -9.171075837742548e-03*G0_1_1 - 9.171075837742591e-03*G0_1_2 - 9.171075837742555e-03*G0_2_1 - 9.171075837742598e-03*G0_2_2;
    block[406] = -2.821869488536125e-03*G0_1_1 - 2.821869488536080e-03*G0_1_2 - 2.821869488536111e-03*G0_2_1 - 2.821869488536053e-03*G0_2_2;
    block[407] = 2.257495590828922e-02*G0_0_0 + 4.232804232804203e-02*G0_0_1 + 4.232804232804200e-02*G0_0_2 + 4.232804232804238e-02*G0_1_0 + 8.465608465608458e-02*G0_1_1 + 8.465608465608443e-02*G0_1_2 + 4.232804232804227e-02*G0_2_0 + 8.465608465608450e-02*G0_2_1 + 8.465608465608439e-02*G0_2_2;
    block[408] = -2.821869488535929e-03*G0_0_1 - 2.821869488536051e-03*G0_0_2 - 2.821869488536137e-03*G0_1_0 + 1.693121693121710e-02*G0_1_1 + 1.693121693121697e-02*G0_1_2 - 2.821869488536156e-03*G0_2_0 + 1.693121693121707e-02*G0_2_1 + 1.693121693121687e-02*G0_2_2;
    block[409] = -2.821869488536187e-03*G0_0_1 - 2.821869488536082e-03*G0_0_2 - 2.821869488536328e-03*G0_1_0 + 1.693121693121678e-02*G0_1_1 + 1.693121693121690e-02*G0_1_2 - 2.821869488536275e-03*G0_2_0 + 1.693121693121680e-02*G0_2_1 + 1.693121693121698e-02*G0_2_2;
    block[410] = 2.821869488536158e-03*G0_0_1 + 2.821869488536208e-03*G0_0_2 + 2.821869488536281e-03*G0_1_0 + 2.257495590828918e-02*G0_1_1 + 2.257495590828926e-02*G0_1_2 + 2.821869488536226e-03*G0_2_0 + 2.257495590828917e-02*G0_2_1 + 2.257495590828926e-02*G0_2_2;
    block[411] = 2.821869488536317e-03*G0_0_1 + 2.821869488536209e-03*G0_0_2 + 2.821869488536095e-03*G0_1_0 + 2.257495590828924e-02*G0_1_1 + 2.257495590828918e-02*G0_1_2 + 2.821869488536112e-03*G0_2_0 + 2.257495590828925e-02*G0_2_1 + 2.257495590828913e-02*G0_2_2;
    block[412] = 2.257495590828913e-02*G0_0_0 - 1.975308641975308e-02*G0_0_1 - 1.975308641975308e-02*G0_0_2 - 1.975308641975314e-02*G0_1_0 + 2.257495590828933e-02*G0_1_1 + 2.257495590828917e-02*G0_1_2 - 1.975308641975309e-02*G0_2_0 + 2.257495590828932e-02*G0_2_1 + 2.257495590828918e-02*G0_2_2;
    block[413] = 5.643738977072249e-03*G0_0_0 + 2.821869488535940e-03*G0_0_1 + 2.821869488536135e-03*G0_0_2 + 2.821869488536041e-03*G0_1_0 - 1.693121693121709e-02*G0_1_1 + 6.772486772486758e-02*G0_1_2 + 2.821869488536059e-03*G0_2_0 - 1.693121693121706e-02*G0_2_1 + 6.772486772486751e-02*G0_2_2;
    block[414] = -1.693121693121678e-02*G0_0_0 - 4.232804232804203e-02*G0_0_1 - 1.777777777777775e-01*G0_0_2 - 1.777777777777775e-01*G0_1_0 - 8.465608465608464e-02*G0_1_1 - 2.708994708994705e-01*G0_1_2 - 1.777777777777775e-01*G0_2_0 - 8.465608465608455e-02*G0_2_1 - 2.708994708994705e-01*G0_2_2;
    block[415] = -1.693121693121696e-02*G0_0_0 + 2.539682539682537e-02*G0_0_1 + 1.608465608465604e-01*G0_0_2 + 1.608465608465607e-01*G0_1_0 + 1.185185185185183e-01*G0_1_1 + 6.772486772486769e-02*G0_1_2 + 1.608465608465608e-01*G0_2_0 + 1.185185185185184e-01*G0_2_1 + 6.772486772486770e-02*G0_2_2;
    block[416] = -1.693121693121683e-02*G0_0_0 + 1.608465608465603e-01*G0_0_1 + 2.539682539682542e-02*G0_0_2 + 1.608465608465607e-01*G0_1_0 + 6.772486772486755e-02*G0_1_1 + 1.185185185185182e-01*G0_1_2 + 1.608465608465607e-01*G0_2_0 + 6.772486772486754e-02*G0_2_1 + 1.185185185185182e-01*G0_2_2;
    block[417] = -1.693121693121679e-02*G0_0_0 - 1.777777777777774e-01*G0_0_1 - 4.232804232804194e-02*G0_0_2 - 1.777777777777773e-01*G0_1_0 - 2.708994708994703e-01*G0_1_1 - 8.465608465608440e-02*G0_1_2 - 1.777777777777773e-01*G0_2_0 - 2.708994708994703e-01*G0_2_1 - 8.465608465608437e-02*G0_2_2;
    block[418] = 5.643738977072184e-03*G0_0_0 + 2.821869488536154e-03*G0_0_1 + 2.821869488536088e-03*G0_0_2 + 2.821869488536050e-03*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 1.693121693121698e-02*G0_1_2 + 2.821869488536047e-03*G0_2_0 + 6.772486772486765e-02*G0_2_1 - 1.693121693121705e-02*G0_2_2;
    block[419] = -4.514991181657836e-02*G0_0_0 - 2.257495590828914e-02*G0_0_1 - 2.257495590828934e-02*G0_0_2 - 2.257495590828920e-02*G0_1_0 - 1.354497354497350e-01*G0_1_1 - 1.354497354497351e-01*G0_1_2 - 2.257495590828913e-02*G0_2_0 - 1.354497354497351e-01*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[420] = -2.539682539682540e-02*G0_0_0 - 2.539682539682537e-02*G0_0_1 - 2.539682539682537e-02*G0_0_2 - 7.760141093474398e-03*G0_1_0 - 7.760141093474408e-03*G0_1_1 - 7.760141093474404e-03*G0_1_2 - 7.760141093474397e-03*G0_2_0 - 7.760141093474407e-03*G0_2_1 - 7.760141093474403e-03*G0_2_2;
    block[421] = -7.054673721340374e-02*G0_0_0 - 4.585537918871244e-02*G0_1_0 - 4.585537918871243e-02*G0_2_0;
    block[422] = 7.760141093474499e-03*G0_1_1 + 7.760141093474487e-03*G0_2_1;
    block[423] = 7.760141093474421e-03*G0_1_2 + 7.760141093474433e-03*G0_2_2;
    block[424] = 2.257495590828925e-02*G0_0_0 - 7.901234567901212e-02*G0_0_1 - 7.901234567901211e-02*G0_1_0 - 1.580246913580244e-01*G0_1_1 - 7.901234567901209e-02*G0_2_0 - 1.580246913580244e-01*G0_2_1;
    block[425] = -1.128747795414470e-02*G0_0_0 + 3.104056437389761e-02*G0_0_1 + 3.104056437389756e-02*G0_1_0 + 9.029982363315703e-02*G0_1_1 + 3.104056437389754e-02*G0_2_0 + 9.029982363315699e-02*G0_2_1;
    block[426] = -1.128747795414467e-02*G0_0_1 - 1.128747795414458e-02*G0_1_0 - 4.514991181657860e-02*G0_1_1 - 1.128747795414459e-02*G0_2_0 - 4.514991181657859e-02*G0_2_1;
    block[427] = 1.128747795414468e-02*G0_0_1 + 1.128747795414460e-02*G0_1_0 + 1.128747795414463e-02*G0_1_2 + 1.128747795414461e-02*G0_2_0 + 1.128747795414463e-02*G0_2_2;
    block[428] = -1.128747795414475e-02*G0_0_0 + 2.821869488536030e-03*G0_0_1 - 1.128747795414474e-02*G0_0_2 + 2.821869488536102e-03*G0_1_0 + 2.821869488536071e-03*G0_1_2 + 2.821869488536101e-03*G0_2_0 + 2.821869488536070e-03*G0_2_2;
    block[429] = -2.257495590828907e-02*G0_0_0 + 1.128747795414470e-02*G0_0_1 - 2.257495590828907e-02*G0_0_2 + 1.128747795414472e-02*G0_1_0 + 1.128747795414477e-02*G0_1_2 + 1.128747795414472e-02*G0_2_0 + 1.128747795414477e-02*G0_2_2;
    block[430] = 1.128747795414460e-01*G0_0_0 + 7.901234567901222e-02*G0_0_1 + 7.901234567901221e-02*G0_0_2 + 3.386243386243374e-02*G0_1_0 + 4.514991181657848e-02*G0_1_1 + 4.514991181657852e-02*G0_1_2 + 3.386243386243374e-02*G0_2_0 + 4.514991181657849e-02*G0_2_1 + 4.514991181657852e-02*G0_2_2;
    block[431] = -2.201058201058197e-01*G0_0_0 - 1.326278659611991e-01*G0_0_1 - 1.326278659611991e-01*G0_0_2 - 5.925925925925909e-02*G0_1_0 - 9.029982363315689e-02*G0_1_1 - 9.029982363315689e-02*G0_1_2 - 5.925925925925911e-02*G0_2_0 - 9.029982363315689e-02*G0_2_1 - 9.029982363315689e-02*G0_2_2;
    block[432] = 2.031746031746028e-01*G0_0_0 + 7.901234567901216e-02*G0_0_1 + 7.901234567901216e-02*G0_0_2 + 7.901234567901215e-02*G0_1_0 + 1.580246913580246e-01*G0_1_1 + 1.580246913580245e-01*G0_1_2 + 7.901234567901216e-02*G0_2_0 + 1.580246913580245e-01*G0_2_1 + 1.580246913580245e-01*G0_2_2;
    block[433] = -2.257495590828915e-02*G0_0_0 - 2.257495590828913e-02*G0_0_1 + 1.128747795414464e-02*G0_0_2 + 1.128747795414472e-02*G0_1_0 + 1.128747795414470e-02*G0_1_1 + 1.128747795414472e-02*G0_2_0 + 1.128747795414469e-02*G0_2_1;
    block[434] = -1.128747795414457e-02*G0_0_0 - 1.128747795414457e-02*G0_0_1 + 2.821869488536151e-03*G0_0_2 + 2.821869488536049e-03*G0_1_0 + 2.821869488536081e-03*G0_1_1 + 2.821869488536036e-03*G0_2_0 + 2.821869488536067e-03*G0_2_1;
    block[435] = 1.128747795414458e-02*G0_0_2 + 1.128747795414467e-02*G0_1_0 + 1.128747795414466e-02*G0_1_1 + 1.128747795414467e-02*G0_2_0 + 1.128747795414466e-02*G0_2_1;
    block[436] = 2.257495590828932e-02*G0_0_0 - 7.901234567901211e-02*G0_0_2 - 7.901234567901226e-02*G0_1_0 - 1.580246913580244e-01*G0_1_2 - 7.901234567901223e-02*G0_2_0 - 1.580246913580244e-01*G0_2_2;
    block[437] = -1.128747795414469e-02*G0_0_0 + 3.104056437389756e-02*G0_0_2 + 3.104056437389757e-02*G0_1_0 + 9.029982363315667e-02*G0_1_2 + 3.104056437389757e-02*G0_2_0 + 9.029982363315667e-02*G0_2_2;
    block[438] = -1.128747795414458e-02*G0_0_2 - 1.128747795414468e-02*G0_1_0 - 4.514991181657844e-02*G0_1_2 - 1.128747795414468e-02*G0_2_0 - 4.514991181657848e-02*G0_2_2;
    block[439] = -1.128747795414471e-02*G0_1_1 - 1.128747795414460e-02*G0_1_2 - 1.128747795414470e-02*G0_2_1 - 1.128747795414461e-02*G0_2_2;
    block[440] = -2.821869488535983e-03*G0_1_1 - 2.821869488536115e-03*G0_1_2 - 2.821869488535981e-03*G0_2_1 - 2.821869488536101e-03*G0_2_2;
    block[441] = -1.128747795414472e-02*G0_1_1 - 1.128747795414465e-02*G0_1_2 - 1.128747795414472e-02*G0_2_1 - 1.128747795414468e-02*G0_2_2;
    block[442] = -4.514991181657855e-02*G0_0_0 - 1.128747795414450e-02*G0_0_1 - 1.128747795414451e-02*G0_0_2 - 1.128747795414458e-02*G0_1_0 - 1.128747795414460e-01*G0_1_1 - 1.128747795414458e-01*G0_1_2 - 1.128747795414458e-02*G0_2_0 - 1.128747795414459e-01*G0_2_1 - 1.128747795414458e-01*G0_2_2;
    block[443] = -1.128747795414479e-02*G0_0_1 - 1.128747795414475e-02*G0_0_2 - 1.128747795414456e-02*G0_1_0 + 2.257495590828900e-02*G0_1_1 + 2.257495590828923e-02*G0_1_2 - 1.128747795414455e-02*G0_2_0 + 2.257495590828899e-02*G0_2_1 + 2.257495590828927e-02*G0_2_2;
    block[444] = -1.128747795414475e-02*G0_0_1 - 1.128747795414478e-02*G0_0_2 - 1.128747795414457e-02*G0_1_0 + 2.257495590828940e-02*G0_1_1 + 2.257495590828922e-02*G0_1_2 - 1.128747795414458e-02*G0_2_0 + 2.257495590828936e-02*G0_2_1 + 2.257495590828918e-02*G0_2_2;
    block[445] = 1.128747795414472e-02*G0_0_1 + 1.128747795414469e-02*G0_0_2 + 1.128747795414459e-02*G0_1_0 + 1.128747795414460e-02*G0_2_0;
    block[446] = 1.128747795414451e-02*G0_0_1 + 1.128747795414451e-02*G0_0_2 + 1.128747795414461e-02*G0_1_0 + 1.128747795414460e-02*G0_2_0;
    block[447] = -4.514991181657842e-02*G0_0_0 + 1.128747795414450e-02*G0_0_1 + 1.128747795414458e-02*G0_0_2 + 1.128747795414452e-02*G0_1_0 + 1.128747795414450e-02*G0_2_0;
    block[448] = 2.257495590828927e-02*G0_0_0 + 1.128747795414477e-02*G0_0_1 - 3.386243386243384e-02*G0_0_2 - 3.386243386243361e-02*G0_1_0 - 2.257495590828907e-02*G0_1_1 - 3.386243386243361e-02*G0_2_0 - 2.257495590828907e-02*G0_2_1;
    block[449] = -6.772486772486763e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 1.015873015873016e-01*G0_1_0 + 1.128747795414462e-01*G0_1_1 + 1.015873015873016e-01*G0_2_0 + 1.128747795414462e-01*G0_2_1;
    block[450] = 6.772486772486762e-02*G0_0_0 + 1.128747795414463e-02*G0_0_1 - 3.386243386243386e-02*G0_0_2 - 3.386243386243402e-02*G0_1_0 - 2.257495590828945e-02*G0_1_1 - 3.386243386243401e-02*G0_2_0 - 2.257495590828949e-02*G0_2_1;
    block[451] = 6.772486772486744e-02*G0_0_0 - 3.386243386243398e-02*G0_0_1 + 1.128747795414446e-02*G0_0_2 - 3.386243386243404e-02*G0_1_0 - 2.257495590828939e-02*G0_1_2 - 3.386243386243402e-02*G0_2_0 - 2.257495590828936e-02*G0_2_2;
    block[452] = -6.772486772486763e-02*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.128747795414454e-02*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 1.128747795414460e-01*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 1.128747795414460e-01*G0_2_2;
    block[453] = 2.257495590828945e-02*G0_0_0 - 3.386243386243363e-02*G0_0_1 + 1.128747795414479e-02*G0_0_2 - 3.386243386243368e-02*G0_1_0 - 2.257495590828928e-02*G0_1_2 - 3.386243386243366e-02*G0_2_0 - 2.257495590828924e-02*G0_2_2;
    block[454] = 9.029982363315703e-02*G0_0_0;
    block[455] = -2.469135802469133e-02*G0_0_0 - 2.469135802469135e-02*G0_0_1 - 2.469135802469135e-02*G0_0_2 - 2.469135802469135e-02*G0_1_0 - 2.469135802469138e-02*G0_1_1 - 2.469135802469137e-02*G0_1_2 - 7.054673721340372e-02*G0_2_0 - 7.054673721340372e-02*G0_2_1 - 7.054673721340372e-02*G0_2_2;
    block[456] = 7.760141093474348e-03*G0_0_0 + 7.760141093474350e-03*G0_1_0;
    block[457] = 7.760141093474453e-03*G0_0_1 + 7.760141093474448e-03*G0_1_1;
    block[458] = -1.763668430335100e-02*G0_0_2 - 1.763668430335101e-02*G0_1_2 - 2.539682539682540e-02*G0_2_2;
    block[459] = -1.128747795414459e-02*G0_0_0 - 1.128747795414465e-02*G0_0_1 - 1.128747795414458e-02*G0_1_0 - 1.128747795414463e-02*G0_1_1;
    block[460] = -2.821869488536119e-03*G0_0_0 - 2.821869488536076e-03*G0_0_1 - 2.821869488536148e-03*G0_1_0 - 2.821869488536147e-03*G0_1_1;
    block[461] = -1.128747795414471e-02*G0_0_0 - 1.128747795414474e-02*G0_0_1 - 1.128747795414468e-02*G0_1_0 - 1.128747795414469e-02*G0_1_1;
    block[462] = 1.128747795414474e-02*G0_0_0 - 2.257495590828926e-02*G0_0_1 + 1.128747795414476e-02*G0_0_2 + 1.128747795414472e-02*G0_1_0 - 2.257495590828922e-02*G0_1_1 + 1.128747795414473e-02*G0_1_2 + 1.128747795414465e-02*G0_2_1;
    block[463] = -4.232804232804241e-02*G0_0_0 + 1.693121693121697e-02*G0_0_1 - 4.232804232804242e-02*G0_0_2 - 4.232804232804237e-02*G0_1_0 + 1.693121693121692e-02*G0_1_1 - 4.232804232804239e-02*G0_1_2 - 1.128747795414464e-02*G0_2_0 - 4.232804232804225e-02*G0_2_1 - 1.128747795414464e-02*G0_2_2;
    block[464] = 1.015873015873016e-01*G0_0_0 + 2.257495590828924e-02*G0_0_1 + 1.015873015873016e-01*G0_0_2 + 1.015873015873015e-01*G0_1_0 + 2.257495590828926e-02*G0_1_1 + 1.015873015873015e-01*G0_1_2 + 2.257495590828928e-02*G0_2_0 + 1.015873015873014e-01*G0_2_1 + 2.257495590828929e-02*G0_2_2;
    block[465] = 2.257495590828913e-02*G0_0_0 + 1.015873015873016e-01*G0_0_1 + 1.015873015873016e-01*G0_0_2 + 2.257495590828917e-02*G0_1_0 + 1.015873015873016e-01*G0_1_1 + 1.015873015873016e-01*G0_1_2 + 1.015873015873013e-01*G0_2_0 + 2.257495590828924e-02*G0_2_1 + 2.257495590828923e-02*G0_2_2;
    block[466] = 1.693121693121694e-02*G0_0_0 - 4.232804232804235e-02*G0_0_1 - 4.232804232804234e-02*G0_0_2 + 1.693121693121690e-02*G0_1_0 - 4.232804232804237e-02*G0_1_1 - 4.232804232804237e-02*G0_1_2 - 4.232804232804224e-02*G0_2_0 - 1.128747795414467e-02*G0_2_1 - 1.128747795414467e-02*G0_2_2;
    block[467] = -2.257495590828915e-02*G0_0_0 + 1.128747795414472e-02*G0_0_1 + 1.128747795414472e-02*G0_0_2 - 2.257495590828913e-02*G0_1_0 + 1.128747795414470e-02*G0_1_1 + 1.128747795414469e-02*G0_1_2 + 1.128747795414465e-02*G0_2_0;
    block[468] = 2.031746031746031e-01*G0_0_0 + 2.031746031746031e-01*G0_0_1 + 1.241622574955908e-01*G0_0_2 + 2.031746031746032e-01*G0_1_0 + 2.031746031746031e-01*G0_1_1 + 1.241622574955909e-01*G0_1_2 + 1.241622574955908e-01*G0_2_0 + 1.241622574955909e-01*G0_2_1 + 2.031746031746028e-01*G0_2_2;
    block[469] = -1.185185185185185e-01*G0_0_0 - 1.185185185185184e-01*G0_0_1 - 1.608465608465608e-01*G0_0_2 - 1.185185185185185e-01*G0_1_0 - 1.185185185185184e-01*G0_1_1 - 1.608465608465608e-01*G0_1_2 - 8.747795414462077e-02*G0_2_0 - 8.747795414462077e-02*G0_2_1 - 2.201058201058199e-01*G0_2_2;
    block[470] = 4.514991181657846e-02*G0_0_0 + 4.514991181657844e-02*G0_0_1 + 7.901234567901229e-02*G0_0_2 + 4.514991181657846e-02*G0_1_0 + 4.514991181657844e-02*G0_1_1 + 7.901234567901230e-02*G0_1_2 + 3.386243386243381e-02*G0_2_0 + 3.386243386243380e-02*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[471] = -2.257495590828926e-02*G0_0_0 - 1.128747795414470e-02*G0_0_2 - 2.257495590828923e-02*G0_1_0 - 1.128747795414468e-02*G0_1_2 - 1.128747795414462e-02*G0_2_0;
    block[472] = -1.693121693121688e-02*G0_0_0 - 1.410934744268073e-02*G0_0_2 - 1.693121693121690e-02*G0_1_0 - 1.410934744268073e-02*G0_1_2 - 1.410934744268082e-02*G0_2_0 - 1.128747795414466e-02*G0_2_2;
    block[473] = -4.514991181657858e-02*G0_0_0 - 3.386243386243389e-02*G0_0_2 - 4.514991181657858e-02*G0_1_0 - 3.386243386243390e-02*G0_1_2 - 3.386243386243389e-02*G0_2_0 - 2.257495590828925e-02*G0_2_2;
    block[474] = -2.257495590828939e-02*G0_0_1 - 1.128747795414469e-02*G0_0_2 - 2.257495590828936e-02*G0_1_1 - 1.128747795414466e-02*G0_1_2 - 1.128747795414473e-02*G0_2_1;
    block[475] = -1.693121693121690e-02*G0_0_1 - 1.410934744268084e-02*G0_0_2 - 1.693121693121688e-02*G0_1_1 - 1.410934744268085e-02*G0_1_2 - 1.410934744268081e-02*G0_2_1 - 1.128747795414470e-02*G0_2_2;
    block[476] = -4.514991181657856e-02*G0_0_1 - 3.386243386243391e-02*G0_0_2 - 4.514991181657856e-02*G0_1_1 - 3.386243386243391e-02*G0_1_2 - 3.386243386243386e-02*G0_2_1 - 2.257495590828925e-02*G0_2_2;
    block[477] = -2.257495590828919e-02*G0_0_0 - 2.257495590828913e-02*G0_0_1 - 1.128747795414458e-02*G0_0_2 - 2.257495590828922e-02*G0_1_0 - 2.257495590828907e-02*G0_1_1 - 1.128747795414461e-02*G0_1_2 - 1.128747795414435e-02*G0_2_0 - 1.128747795414454e-02*G0_2_1;
    block[478] = -6.772486772486776e-02*G0_0_0 - 6.772486772486766e-02*G0_0_1 - 5.643738977072306e-02*G0_0_2 - 6.772486772486776e-02*G0_1_0 - 6.772486772486769e-02*G0_1_1 - 5.643738977072308e-02*G0_1_2 - 5.643738977072316e-02*G0_2_0 - 5.643738977072314e-02*G0_2_1 - 4.514991181657850e-02*G0_2_2;
    block[479] = -2.257495590828944e-02*G0_0_0 - 2.257495590828932e-02*G0_0_1 - 1.128747795414470e-02*G0_0_2 - 2.257495590828942e-02*G0_1_0 - 2.257495590828939e-02*G0_1_1 - 1.128747795414472e-02*G0_1_2 - 1.128747795414482e-02*G0_2_0 - 1.128747795414452e-02*G0_2_1;
    block[480] = 2.257495590828944e-02*G0_0_0 + 9.029982363315707e-02*G0_0_1 + 5.643738977072320e-02*G0_0_2 + 2.257495590828942e-02*G0_1_0 + 9.029982363315711e-02*G0_1_1 + 5.643738977072316e-02*G0_1_2 + 1.128747795414482e-02*G0_2_0 + 5.643738977072314e-02*G0_2_1 + 2.257495590828929e-02*G0_2_2;
    block[481] = 6.772486772486780e-02*G0_0_0 + 1.354497354497353e-01*G0_0_1 + 1.015873015873016e-01*G0_0_2 + 6.772486772486780e-02*G0_1_0 + 1.354497354497353e-01*G0_1_1 + 1.015873015873016e-01*G0_1_2 + 5.643738977072318e-02*G0_2_0 + 1.015873015873016e-01*G0_2_1 + 6.772486772486770e-02*G0_2_2;
    block[482] = -6.772486772486783e-02*G0_0_0 - 2.708994708994708e-01*G0_0_1 - 1.693121693121693e-01*G0_0_2 - 6.772486772486787e-02*G0_1_0 - 2.708994708994707e-01*G0_1_1 - 1.693121693121693e-01*G0_1_2 - 7.901234567901222e-02*G0_2_0 - 1.693121693121692e-01*G0_2_1 - 6.772486772486774e-02*G0_2_2;
    block[483] = 1.354497354497353e-01*G0_0_0 + 6.772486772486763e-02*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 1.354497354497353e-01*G0_1_0 + 6.772486772486766e-02*G0_1_1 + 1.015873015873015e-01*G0_1_2 + 1.015873015873015e-01*G0_2_0 + 5.643738977072313e-02*G0_2_1 + 6.772486772486766e-02*G0_2_2;
    block[484] = 9.029982363315689e-02*G0_0_0 + 2.257495590828926e-02*G0_0_1 + 5.643738977072305e-02*G0_0_2 + 9.029982363315686e-02*G0_1_0 + 2.257495590828922e-02*G0_1_1 + 5.643738977072306e-02*G0_1_2 + 5.643738977072296e-02*G0_2_0 + 1.128747795414458e-02*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[485] = -2.708994708994708e-01*G0_0_0 - 6.772486772486766e-02*G0_0_1 - 1.693121693121692e-01*G0_0_2 - 2.708994708994708e-01*G0_1_0 - 6.772486772486780e-02*G0_1_1 - 1.693121693121691e-01*G0_1_2 - 1.693121693121692e-01*G0_2_0 - 7.901234567901216e-02*G0_2_1 - 6.772486772486766e-02*G0_2_2;
    block[486] = -1.354497354497353e-01*G0_0_0 - 1.354497354497354e-01*G0_0_1 - 3.386243386243382e-02*G0_0_2 - 1.354497354497353e-01*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 3.386243386243389e-02*G0_1_2 - 3.386243386243380e-02*G0_2_0 - 3.386243386243378e-02*G0_2_1 - 4.514991181657836e-02*G0_2_2;
    block[487] = 4.514991181657829e-02*G0_0_0 + 4.514991181657835e-02*G0_0_1 + 1.128747795414459e-02*G0_0_2 + 4.514991181657827e-02*G0_1_0 + 4.514991181657846e-02*G0_1_1 + 1.128747795414462e-02*G0_1_2 + 1.128747795414451e-02*G0_2_0 + 1.128747795414452e-02*G0_2_1;
    block[488] = 4.514991181657851e-02*G0_0_0 + 4.514991181657860e-02*G0_0_1 + 1.128747795414467e-02*G0_0_2 + 4.514991181657851e-02*G0_1_0 + 4.514991181657848e-02*G0_1_1 + 1.128747795414469e-02*G0_1_2 + 1.128747795414451e-02*G0_2_0 + 1.128747795414458e-02*G0_2_1;
    block[489] = 9.029982363315701e-02*G0_0_0 + 9.029982363315683e-02*G0_0_1 + 9.029982363315688e-02*G0_0_2 + 9.029982363315708e-02*G0_1_0 + 9.029982363315696e-02*G0_1_1 + 9.029982363315697e-02*G0_1_2 + 9.029982363315663e-02*G0_2_0 + 9.029982363315665e-02*G0_2_1 + 9.029982363315686e-02*G0_2_2;
    block[490] = 2.028218694885359e-02*G0_0_0 + 2.028218694885360e-02*G0_0_1 + 2.028218694885361e-02*G0_0_2 + 2.028218694885359e-02*G0_1_0 + 2.028218694885360e-02*G0_1_1 + 2.028218694885361e-02*G0_1_2 + 5.291005291005281e-02*G0_2_0 + 5.291005291005280e-02*G0_2_1 + 5.291005291005280e-02*G0_2_2;
    block[491] = 5.114638447971775e-03*G0_0_0 + 5.114638447971772e-03*G0_1_0;
    block[492] = 5.114638447971738e-03*G0_0_1 + 5.114638447971738e-03*G0_1_1;
    block[493] = 3.262786596119934e-02*G0_0_2 + 3.262786596119933e-02*G0_1_2 + 5.291005291005290e-02*G0_2_2;
    block[494] = -2.821869488536060e-03*G0_0_0 - 2.821869488536068e-03*G0_0_1 - 2.821869488536088e-03*G0_1_0 - 2.821869488536099e-03*G0_1_1;
    block[495] = -9.171075837742355e-03*G0_0_0 - 9.171075837742402e-03*G0_0_1 - 9.171075837742359e-03*G0_1_0 - 9.171075837742395e-03*G0_1_1;
    block[496] = -2.821869488536239e-03*G0_0_0 - 2.821869488536172e-03*G0_0_1 - 2.821869488536247e-03*G0_1_0 - 2.821869488536188e-03*G0_1_1;
    block[497] = 2.821869488536216e-03*G0_0_0 - 1.128747795414451e-02*G0_0_1 + 2.821869488536204e-03*G0_0_2 + 2.821869488536227e-03*G0_1_0 - 1.128747795414451e-02*G0_1_1 + 2.821869488536212e-03*G0_1_2 + 2.821869488536127e-03*G0_2_1;
    block[498] = -1.340388007054674e-02*G0_0_0 - 2.821869488536233e-03*G0_0_1 - 1.340388007054672e-02*G0_0_2 - 1.340388007054677e-02*G0_1_0 - 2.821869488536222e-03*G0_1_1 - 1.340388007054675e-02*G0_1_2 - 2.821869488536167e-03*G0_2_0 - 1.340388007054674e-02*G0_2_1 - 2.821869488536166e-03*G0_2_2;
    block[499] = -4.232804232804231e-02*G0_0_0 - 1.128747795414460e-02*G0_0_1 - 4.232804232804231e-02*G0_0_2 - 4.232804232804228e-02*G0_1_0 - 1.128747795414460e-02*G0_1_1 - 4.232804232804231e-02*G0_1_2 + 1.693121693121687e-02*G0_2_0 - 4.232804232804226e-02*G0_2_1 + 1.693121693121686e-02*G0_2_2;
    block[500] = -1.128747795414456e-02*G0_0_0 - 4.232804232804232e-02*G0_0_1 - 4.232804232804231e-02*G0_0_2 - 1.128747795414456e-02*G0_1_0 - 4.232804232804230e-02*G0_1_1 - 4.232804232804230e-02*G0_1_2 - 4.232804232804224e-02*G0_2_0 + 1.693121693121686e-02*G0_2_1 + 1.693121693121689e-02*G0_2_2;
    block[501] = -2.821869488536214e-03*G0_0_0 - 1.340388007054675e-02*G0_0_1 - 1.340388007054674e-02*G0_0_2 - 2.821869488536220e-03*G0_1_0 - 1.340388007054675e-02*G0_1_1 - 1.340388007054673e-02*G0_1_2 - 1.340388007054672e-02*G0_2_0 - 2.821869488536144e-03*G0_2_1 - 2.821869488536143e-03*G0_2_2;
    block[502] = -1.128747795414457e-02*G0_0_0 + 2.821869488536050e-03*G0_0_1 + 2.821869488536034e-03*G0_0_2 - 1.128747795414456e-02*G0_1_0 + 2.821869488536081e-03*G0_1_1 + 2.821869488536066e-03*G0_1_2 + 2.821869488536151e-03*G0_2_0;
    block[503] = -1.185185185185185e-01*G0_0_0 - 1.185185185185184e-01*G0_0_1 - 8.747795414462077e-02*G0_0_2 - 1.185185185185184e-01*G0_1_0 - 1.185185185185184e-01*G0_1_1 - 8.747795414462076e-02*G0_1_2 - 1.608465608465608e-01*G0_2_0 - 1.608465608465608e-01*G0_2_1 - 2.201058201058199e-01*G0_2_2;
    block[504] = 2.497354497354495e-01*G0_0_0 + 2.497354497354496e-01*G0_0_1 + 1.671957671957671e-01*G0_0_2 + 2.497354497354495e-01*G0_1_0 + 2.497354497354495e-01*G0_1_1 + 1.671957671957670e-01*G0_1_2 + 1.671957671957671e-01*G0_2_0 + 1.671957671957670e-01*G0_2_1 + 3.343915343915341e-01*G0_2_2;
    block[505] = -9.029982363315706e-02*G0_0_0 - 9.029982363315706e-02*G0_0_1 - 1.326278659611992e-01*G0_0_2 - 9.029982363315703e-02*G0_1_0 - 9.029982363315703e-02*G0_1_1 - 1.326278659611992e-01*G0_1_2 - 5.925925925925917e-02*G0_2_0 - 5.925925925925914e-02*G0_2_1 - 2.201058201058200e-01*G0_2_2;
    block[506] = -1.693121693121677e-02*G0_0_0 - 2.821869488536075e-03*G0_0_2 - 1.693121693121682e-02*G0_1_0 - 2.821869488536107e-03*G0_1_2 - 2.821869488536161e-03*G0_2_0;
    block[507] = 2.116402116402080e-02*G0_0_0 + 1.058201058201035e-02*G0_0_2 + 2.116402116402090e-02*G0_1_0 + 1.058201058201039e-02*G0_1_2 + 1.058201058201067e-02*G0_2_0 - 2.821869488536007e-03*G0_2_2;
    block[508] = 9.029982363315713e-02*G0_0_0 + 5.925925925925932e-02*G0_0_2 + 9.029982363315710e-02*G0_1_0 + 5.925925925925933e-02*G0_1_2 + 5.925925925925927e-02*G0_2_0 + 1.693121693121690e-02*G0_2_2;
    block[509] = -1.693121693121689e-02*G0_0_1 - 2.821869488536248e-03*G0_0_2 - 1.693121693121686e-02*G0_1_1 - 2.821869488536258e-03*G0_1_2 - 2.821869488536093e-03*G0_2_1;
    block[510] = 2.116402116402112e-02*G0_0_1 + 1.058201058201069e-02*G0_0_2 + 2.116402116402112e-02*G0_1_1 + 1.058201058201071e-02*G0_1_2 + 1.058201058201060e-02*G0_2_1 - 2.821869488536084e-03*G0_2_2;
    block[511] = 9.029982363315711e-02*G0_0_1 + 5.925925925925939e-02*G0_0_2 + 9.029982363315710e-02*G0_1_1 + 5.925925925925934e-02*G0_1_2 + 5.925925925925923e-02*G0_2_1 + 1.693121693121691e-02*G0_2_2;
    block[512] = 1.693121693121676e-02*G0_0_0 + 1.693121693121668e-02*G0_0_1 - 2.821869488535987e-03*G0_0_2 + 1.693121693121678e-02*G0_1_0 + 1.693121693121664e-02*G0_1_1 - 2.821869488536043e-03*G0_1_2 - 2.821869488536241e-03*G0_2_0 - 2.821869488536174e-03*G0_2_1;
    block[513] = 8.465608465608483e-02*G0_0_0 + 8.465608465608447e-02*G0_0_1 + 4.232804232804217e-02*G0_0_2 + 8.465608465608478e-02*G0_1_0 + 8.465608465608454e-02*G0_1_1 + 4.232804232804221e-02*G0_1_2 + 4.232804232804240e-02*G0_2_0 + 4.232804232804242e-02*G0_2_1 + 2.257495590828939e-02*G0_2_2;
    block[514] = 1.693121693121695e-02*G0_0_0 + 1.693121693121713e-02*G0_0_1 - 2.821869488536124e-03*G0_0_2 + 1.693121693121699e-02*G0_1_0 + 1.693121693121716e-02*G0_1_1 - 2.821869488536110e-03*G0_1_2 - 2.821869488536084e-03*G0_2_0 - 2.821869488536244e-03*G0_2_1;
    block[515] = -1.693121693121696e-02*G0_0_0 + 6.772486772486762e-02*G0_0_1 + 2.821869488536096e-03*G0_0_2 - 1.693121693121701e-02*G0_1_0 + 6.772486772486766e-02*G0_1_1 + 2.821869488536102e-03*G0_1_2 + 2.821869488536075e-03*G0_2_0 + 2.821869488536197e-03*G0_2_1 + 5.643738977072292e-03*G0_2_2;
    block[516] = -8.465608465608479e-02*G0_0_0 - 2.708994708994705e-01*G0_0_1 - 1.777777777777777e-01*G0_0_2 - 8.465608465608475e-02*G0_1_0 - 2.708994708994705e-01*G0_1_1 - 1.777777777777778e-01*G0_1_2 - 4.232804232804239e-02*G0_2_0 - 1.777777777777777e-01*G0_2_1 - 1.693121693121698e-02*G0_2_2;
    block[517] = 1.185185185185184e-01*G0_0_0 + 6.772486772486760e-02*G0_0_1 + 1.608465608465607e-01*G0_0_2 + 1.185185185185183e-01*G0_1_0 + 6.772486772486756e-02*G0_1_1 + 1.608465608465607e-01*G0_1_2 + 2.539682539682526e-02*G0_2_0 + 1.608465608465606e-01*G0_2_1 - 1.693121693121687e-02*G0_2_2;
    block[518] = -2.708994708994704e-01*G0_0_0 - 8.465608465608447e-02*G0_0_1 - 1.777777777777777e-01*G0_0_2 - 2.708994708994705e-01*G0_1_0 - 8.465608465608451e-02*G0_1_1 - 1.777777777777778e-01*G0_1_2 - 1.777777777777776e-01*G0_2_0 - 4.232804232804238e-02*G0_2_1 - 1.693121693121688e-02*G0_2_2;
    block[519] = 6.772486772486755e-02*G0_0_0 - 1.693121693121678e-02*G0_0_1 + 2.821869488536449e-03*G0_0_2 + 6.772486772486758e-02*G0_1_0 - 1.693121693121675e-02*G0_1_1 + 2.821869488536413e-03*G0_1_2 + 2.821869488536295e-03*G0_2_0 + 2.821869488536115e-03*G0_2_1 + 5.643738977072270e-03*G0_2_2;
    block[520] = 6.772486772486765e-02*G0_0_0 + 1.185185185185184e-01*G0_0_1 + 1.608465608465607e-01*G0_0_2 + 6.772486772486765e-02*G0_1_0 + 1.185185185185184e-01*G0_1_1 + 1.608465608465607e-01*G0_1_2 + 1.608465608465607e-01*G0_2_0 + 2.539682539682523e-02*G0_2_1 - 1.693121693121687e-02*G0_2_2;
    block[521] = 2.257495590828922e-02*G0_0_0 + 2.257495590828924e-02*G0_0_1 - 1.975308641975311e-02*G0_0_2 + 2.257495590828923e-02*G0_1_0 + 2.257495590828921e-02*G0_1_1 - 1.975308641975312e-02*G0_1_2 - 1.975308641975309e-02*G0_2_0 - 1.975308641975308e-02*G0_2_1 + 2.257495590828908e-02*G0_2_2;
    block[522] = 2.257495590828919e-02*G0_0_0 + 2.257495590828914e-02*G0_0_1 + 2.821869488535976e-03*G0_0_2 + 2.257495590828921e-02*G0_1_0 + 2.257495590828914e-02*G0_1_1 + 2.821869488536032e-03*G0_1_2 + 2.821869488536272e-03*G0_2_0 + 2.821869488536189e-03*G0_2_1;
    block[523] = 2.257495590828914e-02*G0_0_0 + 2.257495590828929e-02*G0_0_1 + 2.821869488536122e-03*G0_0_2 + 2.257495590828917e-02*G0_1_0 + 2.257495590828934e-02*G0_1_1 + 2.821869488536107e-03*G0_1_2 + 2.821869488536261e-03*G0_2_0 + 2.821869488536244e-03*G0_2_1;
    block[524] = -1.354497354497353e-01*G0_0_0 - 1.354497354497355e-01*G0_0_1 - 2.257495590828907e-02*G0_0_2 - 1.354497354497353e-01*G0_1_0 - 1.354497354497355e-01*G0_1_1 - 2.257495590828911e-02*G0_1_2 - 2.257495590828909e-02*G0_2_0 - 2.257495590828897e-02*G0_2_1 - 4.514991181657840e-02*G0_2_2;
    block[525] = -7.760141093474401e-03*G0_0_0 - 7.760141093474417e-03*G0_0_1 - 7.760141093474414e-03*G0_0_2 - 7.760141093474399e-03*G0_1_0 - 7.760141093474415e-03*G0_1_1 - 7.760141093474410e-03*G0_1_2 - 2.539682539682531e-02*G0_2_0 - 2.539682539682531e-02*G0_2_1 - 2.539682539682531e-02*G0_2_2;
    block[526] = 7.760141093474409e-03*G0_0_0 + 7.760141093474397e-03*G0_1_0;
    block[527] = 7.760141093474478e-03*G0_0_1 + 7.760141093474462e-03*G0_1_1;
    block[528] = -4.585537918871253e-02*G0_0_2 - 4.585537918871252e-02*G0_1_2 - 7.054673721340389e-02*G0_2_2;
    block[529] = -1.128747795414463e-02*G0_0_0 - 1.128747795414467e-02*G0_0_1 - 1.128747795414461e-02*G0_1_0 - 1.128747795414465e-02*G0_1_1;
    block[530] = -2.821869488536263e-03*G0_0_0 - 2.821869488536155e-03*G0_0_1 - 2.821869488536285e-03*G0_1_0 - 2.821869488536184e-03*G0_1_1;
    block[531] = -1.128747795414461e-02*G0_0_0 - 1.128747795414475e-02*G0_0_1 - 1.128747795414459e-02*G0_1_0 - 1.128747795414472e-02*G0_1_1;
    block[532] = 1.128747795414460e-02*G0_0_0 + 1.128747795414460e-02*G0_0_2 + 1.128747795414459e-02*G0_1_0 + 1.128747795414459e-02*G0_1_2 + 1.128747795414457e-02*G0_2_1;
    block[533] = 2.821869488536208e-03*G0_0_0 + 2.821869488536191e-03*G0_0_2 + 2.821869488536226e-03*G0_1_0 + 2.821869488536210e-03*G0_1_2 - 1.128747795414459e-02*G0_2_0 + 2.821869488536184e-03*G0_2_1 - 1.128747795414458e-02*G0_2_2;
    block[534] = 1.128747795414465e-02*G0_0_0 + 1.128747795414467e-02*G0_0_2 + 1.128747795414464e-02*G0_1_0 + 1.128747795414466e-02*G0_1_2 - 2.257495590828918e-02*G0_2_0 + 1.128747795414454e-02*G0_2_1 - 2.257495590828918e-02*G0_2_2;
    block[535] = 1.128747795414467e-02*G0_0_1 + 1.128747795414468e-02*G0_0_2 + 1.128747795414467e-02*G0_1_1 + 1.128747795414468e-02*G0_1_2 + 1.128747795414454e-02*G0_2_0 - 2.257495590828918e-02*G0_2_1 - 2.257495590828921e-02*G0_2_2;
    block[536] = 2.821869488536168e-03*G0_0_1 + 2.821869488536155e-03*G0_0_2 + 2.821869488536162e-03*G0_1_1 + 2.821869488536148e-03*G0_1_2 + 2.821869488536189e-03*G0_2_0 - 1.128747795414459e-02*G0_2_1 - 1.128747795414459e-02*G0_2_2;
    block[537] = 1.128747795414467e-02*G0_0_1 + 1.128747795414467e-02*G0_0_2 + 1.128747795414466e-02*G0_1_1 + 1.128747795414466e-02*G0_1_2 + 1.128747795414459e-02*G0_2_0;
    block[538] = 4.514991181657846e-02*G0_0_0 + 4.514991181657846e-02*G0_0_1 + 3.386243386243381e-02*G0_0_2 + 4.514991181657844e-02*G0_1_0 + 4.514991181657844e-02*G0_1_1 + 3.386243386243380e-02*G0_1_2 + 7.901234567901229e-02*G0_2_0 + 7.901234567901230e-02*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[539] = -9.029982363315706e-02*G0_0_0 - 9.029982363315704e-02*G0_0_1 - 5.925925925925917e-02*G0_0_2 - 9.029982363315706e-02*G0_1_0 - 9.029982363315703e-02*G0_1_1 - 5.925925925925915e-02*G0_1_2 - 1.326278659611992e-01*G0_2_0 - 1.326278659611992e-01*G0_2_1 - 2.201058201058200e-01*G0_2_2;
    block[540] = 1.580246913580249e-01*G0_0_0 + 1.580246913580248e-01*G0_0_1 + 7.901234567901226e-02*G0_0_2 + 1.580246913580248e-01*G0_1_0 + 1.580246913580247e-01*G0_1_1 + 7.901234567901225e-02*G0_1_2 + 7.901234567901227e-02*G0_2_0 + 7.901234567901225e-02*G0_2_1 + 2.031746031746028e-01*G0_2_2;
    block[541] = -4.514991181657849e-02*G0_0_0 - 1.128747795414461e-02*G0_0_2 - 4.514991181657843e-02*G0_1_0 - 1.128747795414461e-02*G0_1_2 - 1.128747795414455e-02*G0_2_0;
    block[542] = 9.029982363315707e-02*G0_0_0 + 3.104056437389777e-02*G0_0_2 + 9.029982363315703e-02*G0_1_0 + 3.104056437389779e-02*G0_1_2 + 3.104056437389762e-02*G0_2_0 - 1.128747795414475e-02*G0_2_2;
    block[543] = -1.580246913580249e-01*G0_0_0 - 7.901234567901252e-02*G0_0_2 - 1.580246913580248e-01*G0_1_0 - 7.901234567901247e-02*G0_1_2 - 7.901234567901230e-02*G0_2_0 + 2.257495590828928e-02*G0_2_2;
    block[544] = -4.514991181657864e-02*G0_0_1 - 1.128747795414459e-02*G0_0_2 - 4.514991181657858e-02*G0_1_1 - 1.128747795414457e-02*G0_1_2 - 1.128747795414465e-02*G0_2_1;
    block[545] = 9.029982363315726e-02*G0_0_1 + 3.104056437389778e-02*G0_0_2 + 9.029982363315722e-02*G0_1_1 + 3.104056437389777e-02*G0_1_2 + 3.104056437389773e-02*G0_2_1 - 1.128747795414468e-02*G0_2_2;
    block[546] = -1.580246913580249e-01*G0_0_1 - 7.901234567901252e-02*G0_0_2 - 1.580246913580248e-01*G0_1_1 - 7.901234567901248e-02*G0_1_2 - 7.901234567901230e-02*G0_2_1 + 2.257495590828926e-02*G0_2_2;
    block[547] = 2.257495590828942e-02*G0_0_0 + 2.257495590828948e-02*G0_0_1 - 1.128747795414460e-02*G0_0_2 + 2.257495590828935e-02*G0_1_0 + 2.257495590828951e-02*G0_1_1 - 1.128747795414460e-02*G0_1_2 - 1.128747795414465e-02*G0_2_0 - 1.128747795414453e-02*G0_2_1;
    block[548] = -1.128747795414462e-01*G0_0_0 - 1.128747795414463e-01*G0_0_1 - 1.128747795414429e-02*G0_0_2 - 1.128747795414461e-01*G0_1_0 - 1.128747795414462e-01*G0_1_1 - 1.128747795414429e-02*G0_1_2 - 1.128747795414467e-02*G0_2_0 - 1.128747795414471e-02*G0_2_1 - 4.514991181657859e-02*G0_2_2;
    block[549] = 2.257495590828930e-02*G0_0_0 + 2.257495590828944e-02*G0_0_1 - 1.128747795414467e-02*G0_0_2 + 2.257495590828930e-02*G0_1_0 + 2.257495590828934e-02*G0_1_1 - 1.128747795414470e-02*G0_1_2 - 1.128747795414464e-02*G0_2_0 - 1.128747795414464e-02*G0_2_1;
    block[550] = -2.257495590828924e-02*G0_0_0 - 3.386243386243395e-02*G0_0_2 - 2.257495590828924e-02*G0_1_0 - 3.386243386243395e-02*G0_1_2 + 1.128747795414467e-02*G0_2_0 - 3.386243386243384e-02*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[551] = 1.128747795414461e-01*G0_0_0 + 1.015873015873018e-01*G0_0_2 + 1.128747795414460e-01*G0_1_0 + 1.015873015873018e-01*G0_1_2 + 1.128747795414463e-02*G0_2_0 + 1.015873015873014e-01*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[552] = -2.257495590828932e-02*G0_0_0 - 3.386243386243400e-02*G0_0_2 - 2.257495590828927e-02*G0_1_0 - 3.386243386243399e-02*G0_1_2 + 1.128747795414474e-02*G0_2_0 - 3.386243386243380e-02*G0_2_1 + 6.772486772486760e-02*G0_2_2;
    block[553] = 1.128747795414463e-01*G0_0_1 + 1.015873015873019e-01*G0_0_2 + 1.128747795414463e-01*G0_1_1 + 1.015873015873019e-01*G0_1_2 + 1.015873015873015e-01*G0_2_0 + 1.128747795414471e-02*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[554] = -2.257495590828939e-02*G0_0_1 - 3.386243386243402e-02*G0_0_2 - 2.257495590828942e-02*G0_1_1 - 3.386243386243402e-02*G0_1_2 - 3.386243386243398e-02*G0_2_0 + 1.128747795414457e-02*G0_2_1 + 2.257495590828923e-02*G0_2_2;
    block[555] = -2.257495590828938e-02*G0_0_1 - 3.386243386243407e-02*G0_0_2 - 2.257495590828939e-02*G0_1_1 - 3.386243386243409e-02*G0_1_2 - 3.386243386243373e-02*G0_2_0 + 1.128747795414475e-02*G0_2_1 + 6.772486772486759e-02*G0_2_2;
    block[556] = 1.128747795414470e-02*G0_0_2 + 1.128747795414471e-02*G0_1_2 + 1.128747795414460e-02*G0_2_0 + 1.128747795414459e-02*G0_2_1 - 4.514991181657831e-02*G0_2_2;
    block[557] = 1.128747795414467e-02*G0_0_2 + 1.128747795414468e-02*G0_1_2 + 1.128747795414444e-02*G0_2_0 + 1.128747795414462e-02*G0_2_1;
    block[558] = 1.128747795414464e-02*G0_0_2 + 1.128747795414467e-02*G0_1_2 + 1.128747795414465e-02*G0_2_0 + 1.128747795414454e-02*G0_2_1;
    block[559] = 9.029982363315682e-02*G0_2_2;
    block[560] = 7.760141093474361e-03*G0_0_0 + 7.760141093474381e-03*G0_0_1 + 7.760141093474367e-03*G0_0_2 + 7.760141093474386e-03*G0_2_0 + 7.760141093474398e-03*G0_2_1 + 7.760141093474390e-03*G0_2_2;
    block[561] = -2.469135802469136e-02*G0_0_0 + 4.585537918871239e-02*G0_2_0;
    block[562] = -7.760141093474500e-03*G0_0_1 - 7.760141093474473e-03*G0_2_1;
    block[563] = 1.763668430335091e-02*G0_0_2 - 7.760141093474437e-03*G0_2_2;
    block[564] = 1.015873015873013e-01*G0_0_0 + 7.901234567901216e-02*G0_0_1 + 7.901234567901200e-02*G0_2_0 + 1.580246913580243e-01*G0_2_1;
    block[565] = -4.232804232804221e-02*G0_0_0 - 5.925925925925928e-02*G0_0_1 - 3.104056437389755e-02*G0_2_0 - 9.029982363315692e-02*G0_2_1;
    block[566] = 1.128747795414454e-02*G0_0_0 + 3.386243386243393e-02*G0_0_1 + 1.128747795414460e-02*G0_2_0 + 4.514991181657856e-02*G0_2_1;
    block[567] = -1.128747795414455e-02*G0_0_0 - 1.128747795414457e-02*G0_0_2 - 1.128747795414462e-02*G0_2_0 - 1.128747795414464e-02*G0_2_2;
    block[568] = -2.821869488536241e-03*G0_0_0 - 2.821869488536204e-03*G0_0_2 - 2.821869488536089e-03*G0_2_0 - 2.821869488536058e-03*G0_2_2;
    block[569] = -1.128747795414462e-02*G0_0_0 - 1.128747795414465e-02*G0_0_2 - 1.128747795414471e-02*G0_2_0 - 1.128747795414476e-02*G0_2_2;
    block[570] = -2.257495590828908e-02*G0_0_0 - 3.386243386243377e-02*G0_0_1 - 3.386243386243379e-02*G0_0_2 - 3.386243386243371e-02*G0_2_0 - 4.514991181657843e-02*G0_2_1 - 4.514991181657847e-02*G0_2_2;
    block[571] = 1.693121693121676e-02*G0_0_0 + 5.925925925925912e-02*G0_0_1 + 5.925925925925911e-02*G0_0_2 + 5.925925925925905e-02*G0_2_0 + 9.029982363315679e-02*G0_2_1 + 9.029982363315679e-02*G0_2_2;
    block[572] = 2.257495590828933e-02*G0_0_0 - 7.901234567901226e-02*G0_0_1 - 7.901234567901223e-02*G0_0_2 - 7.901234567901208e-02*G0_2_0 - 1.580246913580244e-01*G0_2_1 - 1.580246913580243e-01*G0_2_2;
    block[573] = -2.257495590828926e-02*G0_0_0 - 2.257495590828923e-02*G0_0_1 - 1.128747795414462e-02*G0_0_2 - 1.128747795414470e-02*G0_2_0 - 1.128747795414468e-02*G0_2_1;
    block[574] = -1.693121693121678e-02*G0_0_0 - 1.693121693121684e-02*G0_0_1 - 2.821869488536166e-03*G0_0_2 - 2.821869488536075e-03*G0_2_0 - 2.821869488536107e-03*G0_2_1;
    block[575] = -4.514991181657849e-02*G0_0_0 - 4.514991181657843e-02*G0_0_1 - 1.128747795414455e-02*G0_0_2 - 1.128747795414461e-02*G0_2_0 - 1.128747795414461e-02*G0_2_1;
    block[576] = 2.031746031746028e-01*G0_0_0 + 7.901234567901216e-02*G0_0_2 + 7.901234567901216e-02*G0_2_0 + 1.580246913580242e-01*G0_2_2;
    block[577] = -1.185185185185183e-01*G0_0_0 + 4.232804232804221e-02*G0_0_2 - 3.104056437389753e-02*G0_2_0 - 9.029982363315657e-02*G0_2_2;
    block[578] = 4.514991181657847e-02*G0_0_0 - 3.386243386243366e-02*G0_0_2 + 1.128747795414462e-02*G0_2_0 + 4.514991181657838e-02*G0_2_2;
    block[579] = 2.257495590828929e-02*G0_0_1 + 1.128747795414456e-02*G0_0_2 + 1.128747795414470e-02*G0_2_1 + 1.128747795414462e-02*G0_2_2;
    block[580] = 1.693121693121675e-02*G0_0_1 + 1.410934744268070e-02*G0_0_2 + 2.821869488536018e-03*G0_2_1 + 2.821869488536110e-03*G0_2_2;
    block[581] = 4.514991181657855e-02*G0_0_1 + 3.386243386243395e-02*G0_0_2 + 1.128747795414466e-02*G0_2_1 + 1.128747795414465e-02*G0_2_2;
    block[582] = -6.772486772486784e-02*G0_0_0 + 2.031746031746025e-01*G0_0_1 + 1.015873015873012e-01*G0_0_2 + 1.128747795414453e-02*G0_2_0 + 1.128747795414458e-01*G0_2_1 + 1.128747795414457e-01*G0_2_2;
    block[583] = 6.772486772486751e-02*G0_0_0 - 6.772486772486751e-02*G0_0_1 - 3.386243386243410e-02*G0_0_2 + 1.128747795414452e-02*G0_2_0 - 2.257495590828903e-02*G0_2_1 - 2.257495590828925e-02*G0_2_2;
    block[584] = 2.257495590828912e-02*G0_0_0 - 6.772486772486792e-02*G0_0_1 - 3.386243386243388e-02*G0_0_2 + 1.128747795414461e-02*G0_2_0 - 2.257495590828934e-02*G0_2_1 - 2.257495590828916e-02*G0_2_2;
    block[585] = -2.257495590828917e-02*G0_0_0 - 1.128747795414454e-02*G0_0_2 - 1.128747795414463e-02*G0_2_0;
    block[586] = -6.772486772486765e-02*G0_0_0 - 1.128747795414491e-02*G0_0_2 - 1.128747795414457e-02*G0_2_0;
    block[587] = -2.257495590828901e-02*G0_0_0 - 1.128747795414441e-02*G0_0_2 - 1.128747795414454e-02*G0_2_0;
    block[588] = 1.354497354497351e-01*G0_0_0 + 6.772486772486758e-02*G0_0_1 + 3.386243386243352e-02*G0_0_2 + 3.386243386243361e-02*G0_2_0 + 2.257495590828911e-02*G0_2_1;
    block[589] = -2.708994708994704e-01*G0_0_0 - 2.031746031746027e-01*G0_0_1 - 1.015873015873012e-01*G0_0_2 - 1.015873015873015e-01*G0_2_0 - 1.128747795414461e-01*G0_2_1;
    block[590] = 9.029982363315690e-02*G0_0_0 + 6.772486772486774e-02*G0_0_1 + 3.386243386243397e-02*G0_0_2 + 3.386243386243397e-02*G0_2_0 + 2.257495590828936e-02*G0_2_1;
    block[591] = 4.514991181657847e-02*G0_0_0 + 3.386243386243382e-02*G0_0_2 + 3.386243386243396e-02*G0_2_0 + 2.257495590828929e-02*G0_2_2;
    block[592] = -1.354497354497352e-01*G0_0_0 - 1.015873015873013e-01*G0_0_2 - 1.015873015873013e-01*G0_2_0 - 1.128747795414458e-01*G0_2_2;
    block[593] = 4.514991181657844e-02*G0_0_0 + 3.386243386243393e-02*G0_0_2 + 3.386243386243366e-02*G0_2_0 + 2.257495590828922e-02*G0_2_2;
    block[594] = 9.029982363315700e-02*G0_0_0;
    block[595] = 5.114638447971824e-03*G0_0_0 + 5.114638447971809e-03*G0_0_1 + 5.114638447971818e-03*G0_0_2 + 5.114638447971828e-03*G0_2_0 + 5.114638447971814e-03*G0_2_1 + 5.114638447971818e-03*G0_2_2;
    block[596] = 2.028218694885363e-02*G0_0_0 - 3.262786596119921e-02*G0_2_0;
    block[597] = -5.114638447971724e-03*G0_0_1 - 5.114638447971736e-03*G0_2_1;
    block[598] = -3.262786596119927e-02*G0_0_2 + 2.028218694885358e-02*G0_2_2;
    block[599] = -4.232804232804217e-02*G0_0_0 - 3.104056437389760e-02*G0_0_1 - 5.925925925925905e-02*G0_2_0 - 9.029982363315671e-02*G0_2_1;
    block[600] = -1.340388007054683e-02*G0_0_0 - 1.058201058201056e-02*G0_0_1 - 1.058201058201062e-02*G0_2_0 - 2.116402116402109e-02*G0_2_1;
    block[601] = 2.821869488536236e-03*G0_0_0 + 1.410934744268072e-02*G0_0_1 + 2.821869488536204e-03*G0_2_0 + 1.693121693121687e-02*G0_2_1;
    block[602] = -2.821869488536228e-03*G0_0_0 - 2.821869488536200e-03*G0_0_2 - 2.821869488536191e-03*G0_2_0 - 2.821869488536156e-03*G0_2_2;
    block[603] = -9.171075837742322e-03*G0_0_0 - 9.171075837742350e-03*G0_0_2 - 9.171075837742421e-03*G0_2_0 - 9.171075837742458e-03*G0_2_2;
    block[604] = -2.821869488536105e-03*G0_0_0 - 2.821869488536076e-03*G0_0_2 - 2.821869488536128e-03*G0_2_0 - 2.821869488536077e-03*G0_2_2;
    block[605] = -1.128747795414468e-02*G0_0_0 - 1.410934744268076e-02*G0_0_1 - 1.410934744268072e-02*G0_0_2 - 1.410934744268082e-02*G0_2_0 - 1.693121693121687e-02*G0_2_1 - 1.693121693121681e-02*G0_2_2;
    block[606] = -2.821869488536038e-03*G0_0_0 + 1.058201058201070e-02*G0_0_1 + 1.058201058201067e-02*G0_0_2 + 1.058201058201063e-02*G0_2_0 + 2.116402116402121e-02*G0_2_1 + 2.116402116402116e-02*G0_2_2;
    block[607] = -1.128747795414469e-02*G0_0_0 + 3.104056437389757e-02*G0_0_1 + 3.104056437389757e-02*G0_0_2 + 3.104056437389756e-02*G0_2_0 + 9.029982363315665e-02*G0_2_1 + 9.029982363315667e-02*G0_2_2;
    block[608] = -1.693121693121688e-02*G0_0_0 - 1.693121693121690e-02*G0_0_1 - 1.410934744268083e-02*G0_0_2 - 1.410934744268073e-02*G0_2_0 - 1.410934744268073e-02*G0_2_1 - 1.128747795414467e-02*G0_2_2;
    block[609] = 2.116402116402080e-02*G0_0_0 + 2.116402116402091e-02*G0_0_1 + 1.058201058201067e-02*G0_0_2 + 1.058201058201035e-02*G0_2_0 + 1.058201058201039e-02*G0_2_1 - 2.821869488536007e-03*G0_2_2;
    block[610] = 9.029982363315707e-02*G0_0_0 + 9.029982363315703e-02*G0_0_1 + 3.104056437389761e-02*G0_0_2 + 3.104056437389778e-02*G0_2_0 + 3.104056437389779e-02*G0_2_1 - 1.128747795414475e-02*G0_2_2;
    block[611] = -1.185185185185183e-01*G0_0_0 - 3.104056437389753e-02*G0_0_2 + 4.232804232804221e-02*G0_2_0 - 9.029982363315657e-02*G0_2_2;
    block[612] = 2.497354497354493e-01*G0_0_0 + 8.253968253968230e-02*G0_0_2 + 8.253968253968230e-02*G0_2_0 + 2.497354497354490e-01*G0_2_2;
    block[613] = -9.029982363315697e-02*G0_0_0 + 4.232804232804213e-02*G0_0_2 - 3.104056437389772e-02*G0_2_0 - 1.185185185185183e-01*G0_2_2;
    block[614] = 1.693121693121682e-02*G0_0_1 + 2.821869488536214e-03*G0_0_2 + 1.410934744268066e-02*G0_2_1 + 2.821869488536176e-03*G0_2_2;
    block[615] = -2.116402116402078e-02*G0_0_1 - 1.058201058201042e-02*G0_0_2 - 1.058201058201031e-02*G0_2_1 - 1.340388007054661e-02*G0_2_2;
    block[616] = -9.029982363315701e-02*G0_0_1 - 5.925925925925931e-02*G0_0_2 - 3.104056437389771e-02*G0_2_1 - 4.232804232804228e-02*G0_2_2;
    block[617] = 1.185185185185184e-01*G0_0_0 + 5.079365079365087e-02*G0_0_1 - 4.232804232804215e-02*G0_0_2 + 9.312169312169290e-02*G0_2_0 + 1.862433862433858e-01*G0_2_1 - 8.465608465608439e-02*G0_2_2;
    block[618] = -8.465608465608422e-02*G0_0_0 + 1.862433862433859e-01*G0_0_1 + 9.312169312169340e-02*G0_0_2 - 4.232804232804196e-02*G0_2_0 + 5.079365079365070e-02*G0_2_1 + 1.185185185185185e-01*G0_2_2;
    block[619] = -1.693121693121667e-02*G0_0_0 - 8.465608465608424e-02*G0_0_1 - 1.975308641975301e-02*G0_0_2 - 1.975308641975292e-02*G0_2_0 - 8.465608465608426e-02*G0_2_1 - 1.693121693121684e-02*G0_2_2;
    block[620] = 1.693121693121670e-02*G0_0_0 + 1.975308641975279e-02*G0_0_2 + 1.975308641975292e-02*G0_2_0 + 2.257495590828906e-02*G0_2_2;
    block[621] = 8.465608465608425e-02*G0_0_0 + 4.232804232804267e-02*G0_0_2 + 4.232804232804192e-02*G0_2_0 + 2.257495590828942e-02*G0_2_2;
    block[622] = 1.693121693121661e-02*G0_0_0 + 1.975308641975267e-02*G0_0_2 + 1.975308641975282e-02*G0_2_0 + 2.257495590828901e-02*G0_2_2;
    block[623] = -2.708994708994702e-01*G0_0_0 - 1.862433862433859e-01*G0_0_1 - 9.312169312169238e-02*G0_0_2 - 9.312169312169270e-02*G0_2_0 - 5.079365079365065e-02*G0_2_1 + 6.772486772486809e-02*G0_2_2;
    block[624] = 6.772486772486772e-02*G0_0_0 - 5.079365079365075e-02*G0_0_1 - 9.312169312169298e-02*G0_0_2 - 9.312169312169266e-02*G0_2_0 - 1.862433862433856e-01*G0_2_1 - 2.708994708994701e-01*G0_2_2;
    block[625] = 6.772486772486748e-02*G0_0_0 + 8.465608465608411e-02*G0_0_1 + 6.490299823633099e-02*G0_0_2 + 6.490299823633128e-02*G0_2_0 + 8.465608465608397e-02*G0_2_1 + 6.772486772486706e-02*G0_2_2;
    block[626] = 2.257495590828910e-02*G0_0_0 + 1.975308641975310e-02*G0_0_2 + 1.975308641975301e-02*G0_2_0 + 1.693121693121684e-02*G0_2_2;
    block[627] = 2.257495590828916e-02*G0_0_0 + 4.232804232804221e-02*G0_0_2 + 4.232804232804219e-02*G0_2_0 + 8.465608465608451e-02*G0_2_2;
    block[628] = 2.257495590828916e-02*G0_0_0 + 1.975308641975299e-02*G0_0_2 + 1.975308641975304e-02*G0_2_0 + 1.693121693121680e-02*G0_2_2;
    block[629] = -1.354497354497350e-01*G0_0_0 - 1.128747795414465e-01*G0_0_2 - 1.128747795414457e-01*G0_2_0 - 1.354497354497355e-01*G0_2_2;
    block[630] = 7.760141093474417e-03*G0_0_0 + 7.760141093474432e-03*G0_0_1 + 7.760141093474429e-03*G0_0_2 + 7.760141093474419e-03*G0_2_0 + 7.760141093474431e-03*G0_2_1 + 7.760141093474426e-03*G0_2_2;
    block[631] = -7.760141093474400e-03*G0_0_0 + 1.763668430335096e-02*G0_2_0;
    block[632] = -7.760141093474480e-03*G0_0_1 - 7.760141093474454e-03*G0_2_1;
    block[633] = 4.585537918871255e-02*G0_0_2 - 2.469135802469129e-02*G0_2_2;
    block[634] = 1.128747795414462e-02*G0_0_0 + 1.128747795414467e-02*G0_0_1 + 3.386243386243384e-02*G0_2_0 + 4.514991181657844e-02*G0_2_1;
    block[635] = 2.821869488536297e-03*G0_0_0 + 2.821869488536181e-03*G0_0_1 + 1.410934744268082e-02*G0_2_0 + 1.693121693121688e-02*G0_2_1;
    block[636] = 1.128747795414461e-02*G0_0_0 + 1.128747795414475e-02*G0_0_1 + 1.128747795414466e-02*G0_2_0 + 2.257495590828936e-02*G0_2_1;
    block[637] = -1.128747795414461e-02*G0_0_0 - 1.128747795414460e-02*G0_0_2 - 1.128747795414466e-02*G0_2_0 - 1.128747795414466e-02*G0_2_2;
    block[638] = -2.821869488536198e-03*G0_0_0 - 2.821869488536181e-03*G0_0_2 - 2.821869488536175e-03*G0_2_0 - 2.821869488536137e-03*G0_2_2;
    block[639] = -1.128747795414471e-02*G0_0_0 - 1.128747795414473e-02*G0_0_2 - 1.128747795414466e-02*G0_2_0 - 1.128747795414469e-02*G0_2_2;
    block[640] = -1.128747795414476e-02*G0_0_1 - 1.128747795414477e-02*G0_0_2 - 1.128747795414464e-02*G0_2_0 - 2.257495590828930e-02*G0_2_1 - 2.257495590828934e-02*G0_2_2;
    block[641] = -2.821869488536121e-03*G0_0_1 - 2.821869488536107e-03*G0_0_2 - 2.821869488536125e-03*G0_2_0 - 1.693121693121686e-02*G0_2_1 - 1.693121693121682e-02*G0_2_2;
    block[642] = -1.128747795414468e-02*G0_0_1 - 1.128747795414468e-02*G0_0_2 - 1.128747795414458e-02*G0_2_0 - 4.514991181657844e-02*G0_2_1 - 4.514991181657848e-02*G0_2_2;
    block[643] = -4.514991181657858e-02*G0_0_0 - 4.514991181657858e-02*G0_0_1 - 3.386243386243389e-02*G0_0_2 - 3.386243386243389e-02*G0_2_0 - 3.386243386243391e-02*G0_2_1 - 2.257495590828925e-02*G0_2_2;
    block[644] = 9.029982363315713e-02*G0_0_0 + 9.029982363315711e-02*G0_0_1 + 5.925925925925927e-02*G0_0_2 + 5.925925925925932e-02*G0_2_0 + 5.925925925925933e-02*G0_2_1 + 1.693121693121690e-02*G0_2_2;
    block[645] = -1.580246913580249e-01*G0_0_0 - 1.580246913580248e-01*G0_0_1 - 7.901234567901230e-02*G0_0_2 - 7.901234567901252e-02*G0_2_0 - 7.901234567901247e-02*G0_2_1 + 2.257495590828928e-02*G0_2_2;
    block[646] = 4.514991181657847e-02*G0_0_0 + 1.128747795414462e-02*G0_0_2 - 3.386243386243366e-02*G0_2_0 + 4.514991181657838e-02*G0_2_2;
    block[647] = -9.029982363315700e-02*G0_0_0 - 3.104056437389772e-02*G0_0_2 + 4.232804232804213e-02*G0_2_0 - 1.185185185185183e-01*G0_2_2;
    block[648] = 1.580246913580249e-01*G0_0_0 + 7.901234567901252e-02*G0_0_2 + 7.901234567901252e-02*G0_2_0 + 2.031746031746031e-01*G0_2_2;
    block[649] = 4.514991181657865e-02*G0_0_1 + 1.128747795414459e-02*G0_0_2 + 3.386243386243400e-02*G0_2_1 + 1.128747795414466e-02*G0_2_2;
    block[650] = -9.029982363315732e-02*G0_0_1 - 3.104056437389781e-02*G0_0_2 - 5.925925925925954e-02*G0_2_1 - 4.232804232804249e-02*G0_2_2;
    block[651] = 1.580246913580249e-01*G0_0_1 + 7.901234567901248e-02*G0_0_2 + 7.901234567901254e-02*G0_2_1 + 1.015873015873017e-01*G0_2_2;
    block[652] = -2.257495590828919e-02*G0_0_0 - 2.257495590828937e-02*G0_0_1 + 1.128747795414468e-02*G0_0_2 - 3.386243386243385e-02*G0_2_0 - 6.772486772486762e-02*G0_2_1 + 6.772486772486766e-02*G0_2_2;
    block[653] = 1.128747795414461e-01*G0_0_0 + 1.128747795414464e-01*G0_0_1 + 1.128747795414435e-02*G0_0_2 + 1.015873015873015e-01*G0_2_0 + 2.031746031746031e-01*G0_2_1 - 6.772486772486785e-02*G0_2_2;
    block[654] = -2.257495590828937e-02*G0_0_0 - 2.257495590828941e-02*G0_0_1 + 1.128747795414469e-02*G0_0_2 - 3.386243386243394e-02*G0_2_0 - 6.772486772486791e-02*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[655] = 2.257495590828931e-02*G0_0_0 + 3.386243386243399e-02*G0_0_2 + 3.386243386243391e-02*G0_2_0 + 4.514991181657856e-02*G0_2_2;
    block[656] = -1.128747795414460e-01*G0_0_0 - 1.015873015873019e-01*G0_0_2 - 1.015873015873014e-01*G0_2_0 - 1.354497354497355e-01*G0_2_2;
    block[657] = 2.257495590828933e-02*G0_0_0 + 3.386243386243410e-02*G0_0_2 + 3.386243386243387e-02*G0_2_0 + 4.514991181657856e-02*G0_2_2;
    block[658] = -1.128747795414464e-01*G0_0_1 - 1.015873015873020e-01*G0_0_2 - 1.015873015873014e-01*G0_2_0 - 2.031746031746031e-01*G0_2_1 - 2.708994708994710e-01*G0_2_2;
    block[659] = 2.257495590828928e-02*G0_0_1 + 3.386243386243391e-02*G0_0_2 + 3.386243386243353e-02*G0_2_0 + 6.772486772486752e-02*G0_2_1 + 1.354497354497352e-01*G0_2_2;
    block[660] = 2.257495590828945e-02*G0_0_1 + 3.386243386243422e-02*G0_0_2 + 3.386243386243400e-02*G0_2_0 + 6.772486772486794e-02*G0_2_1 + 9.029982363315719e-02*G0_2_2;
    block[661] = -1.128747795414469e-02*G0_0_2 - 1.128747795414448e-02*G0_2_0 - 2.257495590828918e-02*G0_2_2;
    block[662] = -1.128747795414475e-02*G0_0_2 - 1.128747795414467e-02*G0_2_0 - 6.772486772486774e-02*G0_2_2;
    block[663] = -1.128747795414465e-02*G0_0_2 - 1.128747795414461e-02*G0_2_0 - 2.257495590828916e-02*G0_2_2;
    block[664] = 9.029982363315710e-02*G0_2_2;
    block[665] = 7.760141093474442e-03*G0_1_0 + 7.760141093474438e-03*G0_1_1 + 7.760141093474443e-03*G0_1_2 + 7.760141093474415e-03*G0_2_0 + 7.760141093474416e-03*G0_2_1 + 7.760141093474415e-03*G0_2_2;
    block[666] = -7.760141093474393e-03*G0_1_0 - 7.760141093474355e-03*G0_2_0;
    block[667] = -2.469135802469142e-02*G0_1_1 + 4.585537918871241e-02*G0_2_1;
    block[668] = 1.763668430335101e-02*G0_1_2 - 7.760141093474456e-03*G0_2_2;
    block[669] = 3.386243386243385e-02*G0_1_0 + 1.128747795414469e-02*G0_1_1 + 4.514991181657826e-02*G0_2_0 + 1.128747795414462e-02*G0_2_1;
    block[670] = -5.925925925925910e-02*G0_1_0 - 4.232804232804232e-02*G0_1_1 - 9.029982363315670e-02*G0_2_0 - 3.104056437389776e-02*G0_2_1;
    block[671] = 7.901234567901223e-02*G0_1_0 + 1.015873015873016e-01*G0_1_1 + 1.580246913580245e-01*G0_2_0 + 7.901234567901239e-02*G0_2_1;
    block[672] = -7.901234567901226e-02*G0_1_0 + 2.257495590828929e-02*G0_1_1 - 7.901234567901229e-02*G0_1_2 - 1.580246913580245e-01*G0_2_0 - 7.901234567901218e-02*G0_2_1 - 1.580246913580245e-01*G0_2_2;
    block[673] = 5.925925925925934e-02*G0_1_0 + 1.693121693121692e-02*G0_1_1 + 5.925925925925934e-02*G0_1_2 + 9.029982363315703e-02*G0_2_0 + 5.925925925925911e-02*G0_2_1 + 9.029982363315706e-02*G0_2_2;
    block[674] = -3.386243386243395e-02*G0_1_0 - 2.257495590828925e-02*G0_1_1 - 3.386243386243399e-02*G0_1_2 - 4.514991181657847e-02*G0_2_0 - 3.386243386243379e-02*G0_2_1 - 4.514991181657854e-02*G0_2_2;
    block[675] = -1.128747795414473e-02*G0_1_1 - 1.128747795414477e-02*G0_1_2 - 1.128747795414469e-02*G0_2_1 - 1.128747795414475e-02*G0_2_2;
    block[676] = -2.821869488536154e-03*G0_1_1 - 2.821869488536136e-03*G0_1_2 - 2.821869488536138e-03*G0_2_1 - 2.821869488536123e-03*G0_2_2;
    block[677] = -1.128747795414471e-02*G0_1_1 - 1.128747795414470e-02*G0_1_2 - 1.128747795414460e-02*G0_2_1 - 1.128747795414461e-02*G0_2_2;
    block[678] = -2.257495590828938e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 - 1.128747795414474e-02*G0_1_2 - 1.128747795414469e-02*G0_2_0 - 1.128747795414466e-02*G0_2_1;
    block[679] = -1.693121693121689e-02*G0_1_0 - 1.693121693121687e-02*G0_1_1 - 2.821869488536091e-03*G0_1_2 - 2.821869488536247e-03*G0_2_0 - 2.821869488536256e-03*G0_2_1;
    block[680] = -4.514991181657864e-02*G0_1_0 - 4.514991181657859e-02*G0_1_1 - 1.128747795414465e-02*G0_1_2 - 1.128747795414459e-02*G0_2_0 - 1.128747795414457e-02*G0_2_1;
    block[681] = 2.257495590828929e-02*G0_1_0 + 1.128747795414470e-02*G0_1_2 + 1.128747795414456e-02*G0_2_0 + 1.128747795414462e-02*G0_2_2;
    block[682] = 1.693121693121683e-02*G0_1_0 + 1.410934744268066e-02*G0_1_2 + 2.821869488536214e-03*G0_2_0 + 2.821869488536176e-03*G0_2_2;
    block[683] = 4.514991181657864e-02*G0_1_0 + 3.386243386243400e-02*G0_1_2 + 1.128747795414459e-02*G0_2_0 + 1.128747795414466e-02*G0_2_2;
    block[684] = 2.031746031746031e-01*G0_1_1 + 7.901234567901225e-02*G0_1_2 + 7.901234567901223e-02*G0_2_1 + 1.580246913580244e-01*G0_2_2;
    block[685] = -1.185185185185186e-01*G0_1_1 + 4.232804232804223e-02*G0_1_2 - 3.104056437389772e-02*G0_2_1 - 9.029982363315696e-02*G0_2_2;
    block[686] = 4.514991181657867e-02*G0_1_1 - 3.386243386243369e-02*G0_1_2 + 1.128747795414461e-02*G0_2_1 + 4.514991181657846e-02*G0_2_2;
    block[687] = -6.772486772486783e-02*G0_1_0 + 2.257495590828913e-02*G0_1_1 - 3.386243386243379e-02*G0_1_2 - 2.257495590828924e-02*G0_2_0 + 1.128747795414443e-02*G0_2_1 - 2.257495590828938e-02*G0_2_2;
    block[688] = -6.772486772486758e-02*G0_1_0 + 6.772486772486785e-02*G0_1_1 - 3.386243386243402e-02*G0_1_2 - 2.257495590828913e-02*G0_2_0 + 1.128747795414479e-02*G0_2_1 - 2.257495590828924e-02*G0_2_2;
    block[689] = 2.031746031746028e-01*G0_1_0 - 6.772486772486792e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 1.128747795414458e-01*G0_2_0 + 1.128747795414441e-02*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[690] = -2.031746031746028e-01*G0_1_0 - 2.708994708994709e-01*G0_1_1 - 1.015873015873016e-01*G0_1_2 - 1.128747795414458e-01*G0_2_0 - 1.015873015873017e-01*G0_2_1;
    block[691] = 6.772486772486756e-02*G0_1_0 + 1.354497354497355e-01*G0_1_1 + 3.386243386243360e-02*G0_1_2 + 2.257495590828912e-02*G0_2_0 + 3.386243386243397e-02*G0_2_1;
    block[692] = 6.772486772486783e-02*G0_1_0 + 9.029982363315719e-02*G0_1_1 + 3.386243386243411e-02*G0_1_2 + 2.257495590828938e-02*G0_2_0 + 3.386243386243403e-02*G0_2_1;
    block[693] = -6.772486772486787e-02*G0_1_1 - 1.128747795414475e-02*G0_1_2 - 1.128747795414477e-02*G0_2_1;
    block[694] = -2.257495590828920e-02*G0_1_1 - 1.128747795414453e-02*G0_1_2 - 1.128747795414460e-02*G0_2_1;
    block[695] = -2.257495590828926e-02*G0_1_1 - 1.128747795414446e-02*G0_1_2 - 1.128747795414465e-02*G0_2_1;
    block[696] = 4.514991181657869e-02*G0_1_1 + 3.386243386243390e-02*G0_1_2 + 3.386243386243416e-02*G0_2_1 + 2.257495590828944e-02*G0_2_2;
    block[697] = 4.514991181657847e-02*G0_1_1 + 3.386243386243366e-02*G0_1_2 + 3.386243386243382e-02*G0_2_1 + 2.257495590828918e-02*G0_2_2;
    block[698] = -1.354497354497356e-01*G0_1_1 - 1.015873015873012e-01*G0_1_2 - 1.015873015873018e-01*G0_2_1 - 1.128747795414457e-01*G0_2_2;
    block[699] = 9.029982363315747e-02*G0_1_1;
    block[700] = 5.114638447971797e-03*G0_1_0 + 5.114638447971793e-03*G0_1_1 + 5.114638447971795e-03*G0_1_2 + 5.114638447971806e-03*G0_2_0 + 5.114638447971806e-03*G0_2_1 + 5.114638447971814e-03*G0_2_2;
    block[701] = -5.114638447971796e-03*G0_1_0 - 5.114638447971795e-03*G0_2_0;
    block[702] = 2.028218694885363e-02*G0_1_1 - 3.262786596119927e-02*G0_2_1;
    block[703] = -3.262786596119931e-02*G0_1_2 + 2.028218694885365e-02*G0_2_2;
    block[704] = 1.410934744268066e-02*G0_1_0 + 2.821869488535994e-03*G0_1_1 + 1.693121693121692e-02*G0_2_0 + 2.821869488536102e-03*G0_2_1;
    block[705] = -1.058201058201059e-02*G0_1_0 - 1.340388007054666e-02*G0_1_1 - 2.116402116402117e-02*G0_2_0 - 1.058201058201054e-02*G0_2_1;
    block[706] = -3.104056437389777e-02*G0_1_0 - 4.232804232804249e-02*G0_1_1 - 9.029982363315701e-02*G0_2_0 - 5.925925925925937e-02*G0_2_1;
    block[707] = 3.104056437389775e-02*G0_1_0 - 1.128747795414462e-02*G0_1_1 + 3.104056437389773e-02*G0_1_2 + 9.029982363315700e-02*G0_2_0 + 3.104056437389775e-02*G0_2_1 + 9.029982363315697e-02*G0_2_2;
    block[708] = 1.058201058201047e-02*G0_1_0 - 2.821869488536227e-03*G0_1_1 + 1.058201058201047e-02*G0_1_2 + 2.116402116402099e-02*G0_2_0 + 1.058201058201051e-02*G0_2_1 + 2.116402116402097e-02*G0_2_2;
    block[709] = -1.410934744268070e-02*G0_1_0 - 1.128747795414461e-02*G0_1_1 - 1.410934744268072e-02*G0_1_2 - 1.693121693121694e-02*G0_2_0 - 1.410934744268079e-02*G0_2_1 - 1.693121693121694e-02*G0_2_2;
    block[710] = -2.821869488536061e-03*G0_1_1 - 2.821869488536067e-03*G0_1_2 - 2.821869488536140e-03*G0_2_1 - 2.821869488536119e-03*G0_2_2;
    block[711] = -9.171075837742546e-03*G0_1_1 - 9.171075837742555e-03*G0_1_2 - 9.171075837742591e-03*G0_2_1 - 9.171075837742598e-03*G0_2_2;
    block[712] = -2.821869488535983e-03*G0_1_1 - 2.821869488535981e-03*G0_1_2 - 2.821869488536115e-03*G0_2_1 - 2.821869488536100e-03*G0_2_2;
    block[713] = -1.693121693121690e-02*G0_1_0 - 1.693121693121688e-02*G0_1_1 - 1.410934744268081e-02*G0_1_2 - 1.410934744268084e-02*G0_2_0 - 1.410934744268084e-02*G0_2_1 - 1.128747795414470e-02*G0_2_2;
    block[714] = 2.116402116402112e-02*G0_1_0 + 2.116402116402112e-02*G0_1_1 + 1.058201058201060e-02*G0_1_2 + 1.058201058201069e-02*G0_2_0 + 1.058201058201072e-02*G0_2_1 - 2.821869488536084e-03*G0_2_2;
    block[715] = 9.029982363315728e-02*G0_1_0 + 9.029982363315722e-02*G0_1_1 + 3.104056437389773e-02*G0_1_2 + 3.104056437389777e-02*G0_2_0 + 3.104056437389777e-02*G0_2_1 - 1.128747795414469e-02*G0_2_2;
    block[716] = 1.693121693121675e-02*G0_1_0 + 2.821869488536017e-03*G0_1_2 + 1.410934744268071e-02*G0_2_0 + 2.821869488536110e-03*G0_2_2;
    block[717] = -2.116402116402078e-02*G0_1_0 - 1.058201058201032e-02*G0_1_2 - 1.058201058201042e-02*G0_2_0 - 1.340388007054661e-02*G0_2_2;
    block[718] = -9.029982363315732e-02*G0_1_0 - 5.925925925925954e-02*G0_1_2 - 3.104056437389781e-02*G0_2_0 - 4.232804232804248e-02*G0_2_2;
    block[719] = -1.185185185185186e-01*G0_1_1 - 3.104056437389772e-02*G0_1_2 + 4.232804232804222e-02*G0_2_1 - 9.029982363315696e-02*G0_2_2;
    block[720] = 2.497354497354499e-01*G0_1_1 + 8.253968253968264e-02*G0_1_2 + 8.253968253968264e-02*G0_2_1 + 2.497354497354499e-01*G0_2_2;
    block[721] = -9.029982363315729e-02*G0_1_1 + 4.232804232804197e-02*G0_1_2 - 3.104056437389778e-02*G0_2_1 - 1.185185185185186e-01*G0_2_2;
    block[722] = -8.465608465608421e-02*G0_1_0 - 1.693121693121672e-02*G0_1_1 - 1.975308641975311e-02*G0_1_2 - 8.465608465608437e-02*G0_2_0 - 1.975308641975287e-02*G0_2_1 - 1.693121693121682e-02*G0_2_2;
    block[723] = 1.862433862433857e-01*G0_1_0 - 8.465608465608492e-02*G0_1_1 + 9.312169312169329e-02*G0_1_2 + 5.079365079365045e-02*G0_2_0 - 4.232804232804256e-02*G0_2_1 + 1.185185185185185e-01*G0_2_2;
    block[724] = 5.079365079365090e-02*G0_1_0 + 1.185185185185188e-01*G0_1_1 - 4.232804232804234e-02*G0_1_2 + 1.862433862433862e-01*G0_2_0 + 9.312169312169336e-02*G0_2_1 - 8.465608465608464e-02*G0_2_2;
    block[725] = -5.079365079365086e-02*G0_1_0 + 6.772486772486776e-02*G0_1_1 - 9.312169312169304e-02*G0_1_2 - 1.862433862433862e-01*G0_2_0 - 9.312169312169305e-02*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[726] = -1.862433862433857e-01*G0_1_0 - 2.708994708994710e-01*G0_1_1 - 9.312169312169286e-02*G0_1_2 - 5.079365079365051e-02*G0_2_0 - 9.312169312169333e-02*G0_2_1 + 6.772486772486751e-02*G0_2_2;
    block[727] = 8.465608465608476e-02*G0_1_0 + 6.772486772486770e-02*G0_1_1 + 6.490299823633160e-02*G0_1_2 + 8.465608465608483e-02*G0_2_0 + 6.490299823633168e-02*G0_2_1 + 6.772486772486801e-02*G0_2_2;
    block[728] = 8.465608465608496e-02*G0_1_1 + 4.232804232804253e-02*G0_1_2 + 4.232804232804253e-02*G0_2_1 + 2.257495590828914e-02*G0_2_2;
    block[729] = 1.693121693121662e-02*G0_1_1 + 1.975308641975277e-02*G0_1_2 + 1.975308641975285e-02*G0_2_1 + 2.257495590828921e-02*G0_2_2;
    block[730] = 1.693121693121719e-02*G0_1_1 + 1.975308641975313e-02*G0_1_2 + 1.975308641975334e-02*G0_2_1 + 2.257495590828942e-02*G0_2_2;
    block[731] = 2.257495590828918e-02*G0_1_1 + 1.975308641975327e-02*G0_1_2 + 1.975308641975305e-02*G0_2_1 + 1.693121693121699e-02*G0_2_2;
    block[732] = 2.257495590828920e-02*G0_1_1 + 1.975308641975318e-02*G0_1_2 + 1.975308641975316e-02*G0_2_1 + 1.693121693121696e-02*G0_2_2;
    block[733] = 2.257495590828937e-02*G0_1_1 + 4.232804232804227e-02*G0_1_2 + 4.232804232804238e-02*G0_2_1 + 8.465608465608442e-02*G0_2_2;
    block[734] = -1.354497354497360e-01*G0_1_1 - 1.128747795414465e-01*G0_1_2 - 1.128747795414467e-01*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[735] = 7.760141093474414e-03*G0_1_0 + 7.760141093474431e-03*G0_1_1 + 7.760141093474427e-03*G0_1_2 + 7.760141093474426e-03*G0_2_0 + 7.760141093474435e-03*G0_2_1 + 7.760141093474424e-03*G0_2_2;
    block[736] = -7.760141093474403e-03*G0_1_0 - 7.760141093474411e-03*G0_2_0;
    block[737] = -7.760141093474485e-03*G0_1_1 + 1.763668430335090e-02*G0_2_1;
    block[738] = 4.585537918871255e-02*G0_1_2 - 2.469135802469133e-02*G0_2_2;
    block[739] = 1.128747795414467e-02*G0_1_0 + 1.128747795414471e-02*G0_1_1 + 2.257495590828924e-02*G0_2_0 + 1.128747795414466e-02*G0_2_1;
    block[740] = 2.821869488536250e-03*G0_1_0 + 2.821869488536134e-03*G0_1_1 + 1.693121693121700e-02*G0_2_0 + 1.410934744268074e-02*G0_2_1;
    block[741] = 1.128747795414463e-02*G0_1_0 + 1.128747795414478e-02*G0_1_1 + 4.514991181657844e-02*G0_2_0 + 3.386243386243396e-02*G0_2_1;
    block[742] = -1.128747795414463e-02*G0_1_0 - 1.128747795414463e-02*G0_1_2 - 4.514991181657847e-02*G0_2_0 - 1.128747795414454e-02*G0_2_1 - 4.514991181657847e-02*G0_2_2;
    block[743] = -2.821869488536194e-03*G0_1_0 - 2.821869488536175e-03*G0_1_2 - 1.693121693121696e-02*G0_2_0 - 2.821869488536193e-03*G0_2_1 - 1.693121693121692e-02*G0_2_2;
    block[744] = -1.128747795414470e-02*G0_1_0 - 1.128747795414472e-02*G0_1_2 - 2.257495590828925e-02*G0_2_0 - 1.128747795414462e-02*G0_2_1 - 2.257495590828927e-02*G0_2_2;
    block[745] = -1.128747795414474e-02*G0_1_1 - 1.128747795414476e-02*G0_1_2 - 1.128747795414469e-02*G0_2_1 - 1.128747795414474e-02*G0_2_2;
    block[746] = -2.821869488536126e-03*G0_1_1 - 2.821869488536112e-03*G0_1_2 - 2.821869488536082e-03*G0_2_1 - 2.821869488536056e-03*G0_2_2;
    block[747] = -1.128747795414471e-02*G0_1_1 - 1.128747795414472e-02*G0_1_2 - 1.128747795414465e-02*G0_2_1 - 1.128747795414468e-02*G0_2_2;
    block[748] = -4.514991181657856e-02*G0_1_0 - 4.514991181657855e-02*G0_1_1 - 3.386243386243386e-02*G0_1_2 - 3.386243386243391e-02*G0_2_0 - 3.386243386243391e-02*G0_2_1 - 2.257495590828925e-02*G0_2_2;
    block[749] = 9.029982363315711e-02*G0_1_0 + 9.029982363315708e-02*G0_1_1 + 5.925925925925923e-02*G0_1_2 + 5.925925925925939e-02*G0_2_0 + 5.925925925925933e-02*G0_2_1 + 1.693121693121692e-02*G0_2_2;
    block[750] = -1.580246913580249e-01*G0_1_0 - 1.580246913580248e-01*G0_1_1 - 7.901234567901229e-02*G0_1_2 - 7.901234567901252e-02*G0_2_0 - 7.901234567901248e-02*G0_2_1 + 2.257495590828926e-02*G0_2_2;
    block[751] = 4.514991181657855e-02*G0_1_0 + 1.128747795414466e-02*G0_1_2 + 3.386243386243395e-02*G0_2_0 + 1.128747795414465e-02*G0_2_2;
    block[752] = -9.029982363315701e-02*G0_1_0 - 3.104056437389771e-02*G0_1_2 - 5.925925925925931e-02*G0_2_0 - 4.232804232804228e-02*G0_2_2;
    block[753] = 1.580246913580249e-01*G0_1_0 + 7.901234567901254e-02*G0_1_2 + 7.901234567901250e-02*G0_2_0 + 1.015873015873017e-01*G0_2_2;
    block[754] = 4.514991181657867e-02*G0_1_1 + 1.128747795414461e-02*G0_1_2 - 3.386243386243368e-02*G0_2_1 + 4.514991181657847e-02*G0_2_2;
    block[755] = -9.029982363315726e-02*G0_1_1 - 3.104056437389778e-02*G0_1_2 + 4.232804232804198e-02*G0_2_1 - 1.185185185185186e-01*G0_2_2;
    block[756] = 1.580246913580249e-01*G0_1_1 + 7.901234567901251e-02*G0_1_2 + 7.901234567901251e-02*G0_2_1 + 2.031746031746033e-01*G0_2_2;
    block[757] = -2.257495590828926e-02*G0_1_0 - 2.257495590828927e-02*G0_1_1 + 1.128747795414471e-02*G0_1_2 - 6.772486772486770e-02*G0_2_0 - 3.386243386243382e-02*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[758] = 1.128747795414461e-01*G0_1_0 + 1.128747795414463e-01*G0_1_1 + 1.128747795414431e-02*G0_1_2 + 2.031746031746030e-01*G0_2_0 + 1.015873015873016e-01*G0_2_1 - 6.772486772486791e-02*G0_2_2;
    block[759] = -2.257495590828930e-02*G0_1_0 - 2.257495590828946e-02*G0_1_1 + 1.128747795414467e-02*G0_1_2 - 6.772486772486785e-02*G0_2_0 - 3.386243386243414e-02*G0_2_1 + 6.772486772486765e-02*G0_2_2;
    block[760] = 2.257495590828925e-02*G0_1_0 + 3.386243386243393e-02*G0_1_2 + 6.772486772486778e-02*G0_2_0 + 3.386243386243370e-02*G0_2_1 + 1.354497354497354e-01*G0_2_2;
    block[761] = -1.128747795414461e-01*G0_1_0 - 1.015873015873018e-01*G0_1_2 - 2.031746031746030e-01*G0_2_0 - 1.015873015873012e-01*G0_2_1 - 2.708994708994709e-01*G0_2_2;
    block[762] = 2.257495590828933e-02*G0_1_0 + 3.386243386243409e-02*G0_1_2 + 6.772486772486776e-02*G0_2_0 + 3.386243386243381e-02*G0_2_1 + 9.029982363315703e-02*G0_2_2;
    block[763] = -1.128747795414464e-01*G0_1_1 - 1.015873015873020e-01*G0_1_2 - 1.015873015873016e-01*G0_2_1 - 1.354497354497356e-01*G0_2_2;
    block[764] = 2.257495590828919e-02*G0_1_1 + 3.386243386243390e-02*G0_1_2 + 3.386243386243371e-02*G0_2_1 + 4.514991181657831e-02*G0_2_2;
    block[765] = 2.257495590828942e-02*G0_1_1 + 3.386243386243417e-02*G0_1_2 + 3.386243386243411e-02*G0_2_1 + 4.514991181657872e-02*G0_2_2;
    block[766] = -1.128747795414469e-02*G0_1_2 - 1.128747795414453e-02*G0_2_1 - 2.257495590828918e-02*G0_2_2;
    block[767] = -1.128747795414478e-02*G0_1_2 - 1.128747795414474e-02*G0_2_1 - 2.257495590828937e-02*G0_2_2;
    block[768] = -1.128747795414464e-02*G0_1_2 - 1.128747795414463e-02*G0_2_1 - 6.772486772486751e-02*G0_2_2;
    block[769] = 9.029982363315703e-02*G0_2_2;
    block[770] = 1.834215167548491e-02*G0_0_0 + 1.834215167548491e-02*G0_0_1 + 1.834215167548490e-02*G0_0_2 + 1.834215167548489e-02*G0_1_0 + 1.834215167548489e-02*G0_1_1 + 1.834215167548488e-02*G0_1_2 + 1.834215167548485e-02*G0_2_0 + 1.834215167548486e-02*G0_2_1 + 1.834215167548484e-02*G0_2_2;
    block[771] = 4.938271604938274e-02*G0_0_0 + 7.054673721340324e-03*G0_1_0 + 7.054673721340361e-03*G0_2_0;
    block[772] = 7.054673721340456e-03*G0_0_1 - 1.834215167548509e-02*G0_1_1 + 7.054673721340307e-03*G0_2_1;
    block[773] = 7.054673721340337e-03*G0_0_2 + 7.054673721340280e-03*G0_1_2 - 1.834215167548503e-02*G0_2_2;
    block[774] = -6.772486772486801e-02*G0_0_0 + 1.128747795414453e-02*G0_0_1 + 1.015873015873011e-01*G0_1_0 + 1.128747795414458e-01*G0_1_1 + 2.031746031746022e-01*G0_2_0 + 1.128747795414457e-01*G0_2_1;
    block[775] = 1.185185185185185e-01*G0_0_0 + 9.312169312169294e-02*G0_0_1 - 4.232804232804212e-02*G0_1_0 - 8.465608465608467e-02*G0_1_1 + 5.079365079365089e-02*G0_2_0 + 1.862433862433856e-01*G0_2_1;
    block[776] = -2.257495590828921e-02*G0_0_0 - 3.386243386243388e-02*G0_0_1 + 1.128747795414440e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 2.257495590828942e-02*G0_2_0 - 6.772486772486758e-02*G0_2_1;
    block[777] = 2.257495590828920e-02*G0_0_0 - 1.128747795414476e-02*G0_0_1 + 2.257495590828921e-02*G0_0_2 - 1.128747795414442e-02*G0_1_0 - 1.128747795414444e-02*G0_1_2 + 2.257495590828937e-02*G0_2_0 - 1.128747795414459e-02*G0_2_1 + 2.257495590828933e-02*G0_2_2;
    block[778] = 1.693121693121705e-02*G0_0_0 - 2.821869488536150e-03*G0_0_1 + 1.693121693121703e-02*G0_0_2 - 2.821869488536171e-03*G0_1_0 - 2.821869488536145e-03*G0_1_2 + 1.693121693121681e-02*G0_2_0 - 2.821869488536221e-03*G0_2_1 + 1.693121693121689e-02*G0_2_2;
    block[779] = -2.257495590828914e-02*G0_0_0 - 1.128747795414443e-02*G0_0_1 - 2.257495590828907e-02*G0_0_2 - 1.128747795414447e-02*G0_1_0 - 1.128747795414448e-02*G0_1_2 - 2.257495590828903e-02*G0_2_0 - 1.128747795414438e-02*G0_2_1 - 2.257495590828903e-02*G0_2_2;
    block[780] = -4.514991181657830e-02*G0_0_0 - 5.643738977072312e-02*G0_0_1 - 5.643738977072300e-02*G0_0_2 - 5.643738977072276e-02*G0_1_0 - 6.772486772486745e-02*G0_1_1 - 6.772486772486740e-02*G0_1_2 - 5.643738977072268e-02*G0_2_0 - 6.772486772486745e-02*G0_2_1 - 6.772486772486741e-02*G0_2_2;
    block[781] = 2.257495590828922e-02*G0_0_0 + 4.232804232804238e-02*G0_0_1 + 4.232804232804227e-02*G0_0_2 + 4.232804232804203e-02*G0_1_0 + 8.465608465608458e-02*G0_1_1 + 8.465608465608450e-02*G0_1_2 + 4.232804232804200e-02*G0_2_0 + 8.465608465608442e-02*G0_2_1 + 8.465608465608436e-02*G0_2_2;
    block[782] = -4.514991181657856e-02*G0_0_0 - 1.128747795414458e-02*G0_0_1 - 1.128747795414458e-02*G0_0_2 - 1.128747795414451e-02*G0_1_0 - 1.128747795414460e-01*G0_1_1 - 1.128747795414459e-01*G0_1_2 - 1.128747795414451e-02*G0_2_0 - 1.128747795414458e-01*G0_2_1 - 1.128747795414458e-01*G0_2_2;
    block[783] = -2.257495590828919e-02*G0_0_0 - 2.257495590828921e-02*G0_0_1 - 1.128747795414435e-02*G0_0_2 - 2.257495590828913e-02*G0_1_0 - 2.257495590828907e-02*G0_1_1 - 1.128747795414454e-02*G0_1_2 - 1.128747795414459e-02*G0_2_0 - 1.128747795414461e-02*G0_2_1;
    block[784] = 1.693121693121676e-02*G0_0_0 + 1.693121693121678e-02*G0_0_1 - 2.821869488536246e-03*G0_0_2 + 1.693121693121668e-02*G0_1_0 + 1.693121693121665e-02*G0_1_1 - 2.821869488536170e-03*G0_1_2 - 2.821869488535988e-03*G0_2_0 - 2.821869488536042e-03*G0_2_1;
    block[785] = 2.257495590828942e-02*G0_0_0 + 2.257495590828935e-02*G0_0_1 - 1.128747795414465e-02*G0_0_2 + 2.257495590828949e-02*G0_1_0 + 2.257495590828951e-02*G0_1_1 - 1.128747795414453e-02*G0_1_2 - 1.128747795414460e-02*G0_2_0 - 1.128747795414460e-02*G0_2_1;
    block[786] = -6.772486772486784e-02*G0_0_0 + 1.128747795414453e-02*G0_0_2 + 2.031746031746025e-01*G0_1_0 + 1.128747795414458e-01*G0_1_2 + 1.015873015873012e-01*G0_2_0 + 1.128747795414457e-01*G0_2_2;
    block[787] = 1.185185185185184e-01*G0_0_0 + 9.312169312169291e-02*G0_0_2 + 5.079365079365087e-02*G0_1_0 + 1.862433862433858e-01*G0_1_2 - 4.232804232804215e-02*G0_2_0 - 8.465608465608439e-02*G0_2_2;
    block[788] = -2.257495590828919e-02*G0_0_0 - 3.386243386243386e-02*G0_0_2 - 2.257495590828937e-02*G0_1_0 - 6.772486772486760e-02*G0_1_2 + 1.128747795414468e-02*G0_2_0 + 6.772486772486765e-02*G0_2_2;
    block[789] = -6.772486772486783e-02*G0_0_1 - 2.257495590828924e-02*G0_0_2 + 2.257495590828913e-02*G0_1_1 + 1.128747795414443e-02*G0_1_2 - 3.386243386243378e-02*G0_2_1 - 2.257495590828938e-02*G0_2_2;
    block[790] = -8.465608465608421e-02*G0_0_1 - 8.465608465608437e-02*G0_0_2 - 1.693121693121672e-02*G0_1_1 - 1.975308641975287e-02*G0_1_2 - 1.975308641975311e-02*G0_2_1 - 1.693121693121682e-02*G0_2_2;
    block[791] = -2.257495590828926e-02*G0_0_1 - 6.772486772486769e-02*G0_0_2 - 2.257495590828927e-02*G0_1_1 - 3.386243386243382e-02*G0_1_2 + 1.128747795414471e-02*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[792] = 6.320987654320979e-01*G0_0_0 + 2.708994708994698e-01*G0_0_1 + 2.708994708994700e-01*G0_0_2 + 2.708994708994699e-01*G0_1_0 + 5.417989417989401e-01*G0_1_1 + 2.708994708994697e-01*G0_1_2 + 2.708994708994700e-01*G0_2_0 + 2.708994708994697e-01*G0_2_1 + 5.417989417989397e-01*G0_2_2;
    block[793] = -1.354497354497347e-01*G0_0_0 + 6.772486772486781e-02*G0_0_1 + 2.257495590828929e-01*G0_0_2 - 6.772486772486723e-02*G0_1_0 + 6.772486772486787e-02*G0_1_2 - 4.514991181657833e-02*G0_2_0 - 6.772486772486749e-02*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[794] = -1.354497354497350e-01*G0_0_0 + 2.257495590828931e-01*G0_0_1 + 6.772486772486803e-02*G0_0_2 - 4.514991181657838e-02*G0_1_0 - 1.354497354497355e-01*G0_1_1 - 6.772486772486770e-02*G0_1_2 - 6.772486772486758e-02*G0_2_0 + 6.772486772486755e-02*G0_2_1;
    block[795] = 1.354497354497350e-01*G0_0_0 + 4.514991181657893e-02*G0_0_1 + 6.772486772486729e-02*G0_0_2 + 4.514991181657838e-02*G0_1_0 + 2.257495590828897e-02*G0_1_2 + 6.772486772486756e-02*G0_2_0 + 2.257495590828947e-02*G0_2_1;
    block[796] = 1.354497354497347e-01*G0_0_0 + 6.772486772486733e-02*G0_0_1 + 4.514991181657902e-02*G0_0_2 + 6.772486772486710e-02*G0_1_0 + 2.257495590828943e-02*G0_1_2 + 4.514991181657827e-02*G0_2_0 + 2.257495590828900e-02*G0_2_1;
    block[797] = 9.029982363315602e-02*G0_0_0 + 4.514991181657812e-02*G0_0_1 + 4.514991181657774e-02*G0_0_2 + 4.514991181657802e-02*G0_1_0 + 2.257495590828880e-02*G0_1_2 + 4.514991181657824e-02*G0_2_0 + 2.257495590828891e-02*G0_2_1;
    block[798] = -1.354497354497353e-01*G0_0_0 - 6.772486772486777e-02*G0_0_1 + 4.514991181657885e-02*G0_0_2 - 6.772486772486758e-02*G0_1_0 + 6.772486772486799e-02*G0_1_2 + 4.514991181657811e-02*G0_2_0 + 6.772486772486756e-02*G0_2_1;
    block[799] = 4.514991181657926e-02*G0_0_0 - 2.708994708994699e-01*G0_0_1 - 1.354497354497352e-01*G0_0_2 - 2.708994708994699e-01*G0_1_0 - 5.417989417989402e-01*G0_1_1 - 2.708994708994701e-01*G0_1_2 - 1.354497354497349e-01*G0_2_0 - 2.708994708994700e-01*G0_2_1;
    block[800] = 4.514991181657800e-02*G0_0_0 + 9.029982363315614e-02*G0_0_1 + 4.514991181657797e-02*G0_0_2 + 9.029982363315650e-02*G0_1_0 + 1.354497354497347e-01*G0_1_1 + 6.772486772486706e-02*G0_1_2 + 4.514991181657832e-02*G0_2_0 + 6.772486772486770e-02*G0_2_1;
    block[801] = 4.514991181657792e-02*G0_0_0 + 4.514991181657821e-02*G0_0_1 + 9.029982363315617e-02*G0_0_2 + 4.514991181657824e-02*G0_1_0 + 6.772486772486747e-02*G0_1_2 + 9.029982363315625e-02*G0_2_0 + 6.772486772486710e-02*G0_2_1 + 1.354497354497347e-01*G0_2_2;
    block[802] = 4.514991181657926e-02*G0_0_0 - 1.354497354497352e-01*G0_0_1 - 2.708994708994701e-01*G0_0_2 - 1.354497354497348e-01*G0_1_0 - 2.708994708994698e-01*G0_1_2 - 2.708994708994694e-01*G0_2_0 - 2.708994708994700e-01*G0_2_1 - 5.417989417989398e-01*G0_2_2;
    block[803] = -1.354497354497354e-01*G0_0_0 + 4.514991181657876e-02*G0_0_1 - 6.772486772486801e-02*G0_0_2 + 4.514991181657835e-02*G0_1_0 + 6.772486772486783e-02*G0_1_2 - 6.772486772486758e-02*G0_2_0 + 6.772486772486799e-02*G0_2_1;
    block[804] = -7.223985890652539e-01*G0_0_0 - 3.160493827160490e-01*G0_0_1 - 3.160493827160489e-01*G0_0_2 - 3.160493827160477e-01*G0_1_0 - 1.354497354497350e-01*G0_1_2 - 3.160493827160482e-01*G0_2_0 - 1.354497354497350e-01*G0_2_1;
    block[805] = 1.834215167548501e-02*G0_0_0 + 1.834215167548502e-02*G0_0_1 + 1.834215167548502e-02*G0_0_2 + 1.834215167548502e-02*G0_1_0 + 1.834215167548503e-02*G0_1_1 + 1.834215167548503e-02*G0_1_2 + 1.834215167548501e-02*G0_2_0 + 1.834215167548501e-02*G0_2_1 + 1.834215167548502e-02*G0_2_2;
    block[806] = -1.834215167548493e-02*G0_0_0 + 7.054673721340494e-03*G0_1_0 + 7.054673721340488e-03*G0_2_0;
    block[807] = 7.054673721340362e-03*G0_0_1 - 1.834215167548498e-02*G0_1_1 + 7.054673721340439e-03*G0_2_1;
    block[808] = 7.054673721340445e-03*G0_0_2 + 7.054673721340471e-03*G0_1_2 + 4.938271604938270e-02*G0_2_2;
    block[809] = 2.257495590828912e-02*G0_0_0 + 1.128747795414455e-02*G0_0_1 - 3.386243386243366e-02*G0_1_0 - 2.257495590828904e-02*G0_1_1 - 6.772486772486766e-02*G0_2_0 - 2.257495590828928e-02*G0_2_1;
    block[810] = -1.693121693121689e-02*G0_0_0 - 1.975308641975307e-02*G0_0_1 - 1.975308641975318e-02*G0_1_0 - 1.693121693121703e-02*G0_1_1 - 8.465608465608453e-02*G0_2_0 - 8.465608465608440e-02*G0_2_1;
    block[811] = -2.257495590828917e-02*G0_0_0 - 3.386243386243376e-02*G0_0_1 + 1.128747795414482e-02*G0_1_0 + 2.257495590828943e-02*G0_1_1 - 2.257495590828922e-02*G0_2_0 - 6.772486772486776e-02*G0_2_1;
    block[812] = 2.257495590828916e-02*G0_0_0 - 1.128747795414451e-02*G0_0_1 + 2.257495590828917e-02*G0_0_2 - 1.128747795414480e-02*G0_1_0 - 1.128747795414474e-02*G0_1_2 + 2.257495590828920e-02*G0_2_0 - 1.128747795414460e-02*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[813] = 1.693121693121668e-02*G0_0_0 - 2.821869488536273e-03*G0_0_1 + 1.693121693121669e-02*G0_0_2 - 2.821869488536165e-03*G0_1_0 - 2.821869488536190e-03*G0_1_2 + 1.693121693121685e-02*G0_2_0 - 2.821869488536276e-03*G0_2_1 + 1.693121693121677e-02*G0_2_2;
    block[814] = -2.257495590828918e-02*G0_0_0 - 1.128747795414459e-02*G0_0_1 - 2.257495590828925e-02*G0_0_2 - 1.128747795414455e-02*G0_1_0 - 1.128747795414456e-02*G0_1_2 - 2.257495590828911e-02*G0_2_0 - 1.128747795414452e-02*G0_2_1 - 2.257495590828915e-02*G0_2_2;
    block[815] = -1.128747795414470e-02*G0_0_1 - 1.128747795414471e-02*G0_0_2 - 1.128747795414476e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 - 2.257495590828933e-02*G0_1_2 - 1.128747795414467e-02*G0_2_0 - 2.257495590828932e-02*G0_2_1 - 2.257495590828925e-02*G0_2_2;
    block[816] = -2.821869488536137e-03*G0_0_1 - 2.821869488536156e-03*G0_0_2 - 2.821869488535929e-03*G0_1_0 + 1.693121693121711e-02*G0_1_1 + 1.693121693121707e-02*G0_1_2 - 2.821869488536047e-03*G0_2_0 + 1.693121693121697e-02*G0_2_1 + 1.693121693121687e-02*G0_2_2;
    block[817] = -1.128747795414456e-02*G0_0_1 - 1.128747795414455e-02*G0_0_2 - 1.128747795414479e-02*G0_1_0 + 2.257495590828899e-02*G0_1_1 + 2.257495590828899e-02*G0_1_2 - 1.128747795414475e-02*G0_2_0 + 2.257495590828923e-02*G0_2_1 + 2.257495590828927e-02*G0_2_2;
    block[818] = -6.772486772486777e-02*G0_0_0 - 6.772486772486776e-02*G0_0_1 - 5.643738977072316e-02*G0_0_2 - 6.772486772486766e-02*G0_1_0 - 6.772486772486769e-02*G0_1_1 - 5.643738977072313e-02*G0_1_2 - 5.643738977072306e-02*G0_2_0 - 5.643738977072307e-02*G0_2_1 - 4.514991181657850e-02*G0_2_2;
    block[819] = 8.465608465608483e-02*G0_0_0 + 8.465608465608479e-02*G0_0_1 + 4.232804232804240e-02*G0_0_2 + 8.465608465608447e-02*G0_1_0 + 8.465608465608454e-02*G0_1_1 + 4.232804232804241e-02*G0_1_2 + 4.232804232804217e-02*G0_2_0 + 4.232804232804221e-02*G0_2_1 + 2.257495590828939e-02*G0_2_2;
    block[820] = -1.128747795414462e-01*G0_0_0 - 1.128747795414461e-01*G0_0_1 - 1.128747795414466e-02*G0_0_2 - 1.128747795414463e-01*G0_1_0 - 1.128747795414462e-01*G0_1_1 - 1.128747795414471e-02*G0_1_2 - 1.128747795414429e-02*G0_2_0 - 1.128747795414429e-02*G0_2_1 - 4.514991181657858e-02*G0_2_2;
    block[821] = 6.772486772486754e-02*G0_0_0 + 1.128747795414452e-02*G0_0_2 - 6.772486772486751e-02*G0_1_0 - 2.257495590828903e-02*G0_1_2 - 3.386243386243410e-02*G0_2_0 - 2.257495590828925e-02*G0_2_2;
    block[822] = -8.465608465608422e-02*G0_0_0 - 4.232804232804196e-02*G0_0_2 + 1.862433862433859e-01*G0_1_0 + 5.079365079365070e-02*G0_1_2 + 9.312169312169338e-02*G0_2_0 + 1.185185185185185e-01*G0_2_2;
    block[823] = 1.128747795414461e-01*G0_0_0 + 1.015873015873015e-01*G0_0_2 + 1.128747795414464e-01*G0_1_0 + 2.031746031746031e-01*G0_1_2 + 1.128747795414435e-02*G0_2_0 - 6.772486772486785e-02*G0_2_2;
    block[824] = -6.772486772486756e-02*G0_0_1 - 2.257495590828914e-02*G0_0_2 + 6.772486772486787e-02*G0_1_1 + 1.128747795414479e-02*G0_1_2 - 3.386243386243402e-02*G0_2_1 - 2.257495590828924e-02*G0_2_2;
    block[825] = 1.862433862433857e-01*G0_0_1 + 5.079365079365045e-02*G0_0_2 - 8.465608465608492e-02*G0_1_1 - 4.232804232804255e-02*G0_1_2 + 9.312169312169329e-02*G0_2_1 + 1.185185185185185e-01*G0_2_2;
    block[826] = 1.128747795414461e-01*G0_0_1 + 2.031746031746030e-01*G0_0_2 + 1.128747795414463e-01*G0_1_1 + 1.015873015873016e-01*G0_1_2 + 1.128747795414431e-02*G0_2_1 - 6.772486772486791e-02*G0_2_2;
    block[827] = -1.354497354497347e-01*G0_0_0 - 6.772486772486723e-02*G0_0_1 - 4.514991181657833e-02*G0_0_2 + 6.772486772486781e-02*G0_1_0 - 6.772486772486749e-02*G0_1_2 + 2.257495590828929e-01*G0_2_0 + 6.772486772486787e-02*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[828] = 5.417989417989407e-01*G0_0_0 + 2.708994708994708e-01*G0_0_1 + 2.708994708994705e-01*G0_0_2 + 2.708994708994709e-01*G0_1_0 + 5.417989417989416e-01*G0_1_1 + 2.708994708994708e-01*G0_1_2 + 2.708994708994705e-01*G0_2_0 + 2.708994708994708e-01*G0_2_1 + 6.320987654320985e-01*G0_2_2;
    block[829] = 6.772486772486745e-02*G0_0_1 - 6.772486772486772e-02*G0_0_2 - 6.772486772486778e-02*G0_1_0 - 1.354497354497356e-01*G0_1_1 - 4.514991181657844e-02*G0_1_2 + 6.772486772486777e-02*G0_2_0 + 2.257495590828928e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[830] = 6.772486772486767e-02*G0_0_1 - 6.772486772486719e-02*G0_0_2 + 6.772486772486773e-02*G0_1_0 + 4.514991181657872e-02*G0_1_2 - 6.772486772486776e-02*G0_2_0 + 4.514991181657874e-02*G0_2_1 - 1.354497354497352e-01*G0_2_2;
    block[831] = -5.417989417989407e-01*G0_0_0 - 2.708994708994703e-01*G0_0_1 - 2.708994708994708e-01*G0_0_2 - 2.708994708994706e-01*G0_1_0 - 1.354497354497352e-01*G0_1_2 - 2.708994708994704e-01*G0_2_0 - 1.354497354497355e-01*G0_2_1 + 4.514991181657886e-02*G0_2_2;
    block[832] = 1.354497354497352e-01*G0_0_0 + 6.772486772486755e-02*G0_0_1 + 9.029982363315710e-02*G0_0_2 + 6.772486772486701e-02*G0_1_0 + 4.514991181657813e-02*G0_1_2 + 9.029982363315621e-02*G0_2_0 + 4.514991181657833e-02*G0_2_1 + 4.514991181657814e-02*G0_2_2;
    block[833] = -2.708994708994709e-01*G0_0_1 - 1.354497354497355e-01*G0_0_2 - 2.708994708994705e-01*G0_1_0 - 5.417989417989415e-01*G0_1_1 - 2.708994708994705e-01*G0_1_2 - 1.354497354497356e-01*G0_2_0 - 2.708994708994707e-01*G0_2_1 + 4.514991181657890e-02*G0_2_2;
    block[834] = 6.772486772486704e-02*G0_0_1 + 4.514991181657803e-02*G0_0_2 + 6.772486772486766e-02*G0_1_0 - 6.772486772486781e-02*G0_1_2 + 4.514991181657894e-02*G0_2_0 - 6.772486772486799e-02*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[835] = 6.772486772486783e-02*G0_0_1 + 4.514991181657878e-02*G0_0_2 + 6.772486772486748e-02*G0_1_0 + 1.354497354497348e-01*G0_1_1 + 9.029982363315670e-02*G0_1_2 + 4.514991181657826e-02*G0_2_0 + 9.029982363315628e-02*G0_2_1 + 4.514991181657815e-02*G0_2_2;
    block[836] = 2.257495590828916e-02*G0_0_1 + 4.514991181657822e-02*G0_0_2 + 2.257495590828919e-02*G0_1_0 + 4.514991181657807e-02*G0_1_2 + 4.514991181657820e-02*G0_2_0 + 4.514991181657835e-02*G0_2_1 + 9.029982363315650e-02*G0_2_2;
    block[837] = 2.257495590828914e-02*G0_0_1 + 4.514991181657830e-02*G0_0_2 + 2.257495590828915e-02*G0_1_0 + 6.772486772486745e-02*G0_1_2 + 4.514991181657867e-02*G0_2_0 + 6.772486772486754e-02*G0_2_1 + 1.354497354497350e-01*G0_2_2;
    block[838] = 2.257495590828943e-02*G0_0_1 + 6.772486772486765e-02*G0_0_2 + 2.257495590828940e-02*G0_1_0 + 4.514991181657842e-02*G0_1_2 + 6.772486772486769e-02*G0_2_0 + 4.514991181657873e-02*G0_2_1 + 1.354497354497350e-01*G0_2_2;
    block[839] = -1.354497354497353e-01*G0_0_1 - 3.160493827160489e-01*G0_0_2 - 1.354497354497350e-01*G0_1_0 - 3.160493827160488e-01*G0_1_2 - 3.160493827160493e-01*G0_2_0 - 3.160493827160490e-01*G0_2_1 - 7.223985890652550e-01*G0_2_2;
    block[840] = 1.834215167548505e-02*G0_0_0 + 1.834215167548505e-02*G0_0_1 + 1.834215167548505e-02*G0_0_2 + 1.834215167548498e-02*G0_1_0 + 1.834215167548501e-02*G0_1_1 + 1.834215167548498e-02*G0_1_2 + 1.834215167548504e-02*G0_2_0 + 1.834215167548505e-02*G0_2_1 + 1.834215167548503e-02*G0_2_2;
    block[841] = -1.834215167548492e-02*G0_0_0 + 7.054673721340536e-03*G0_1_0 + 7.054673721340520e-03*G0_2_0;
    block[842] = 7.054673721340307e-03*G0_0_1 + 4.938271604938275e-02*G0_1_1 + 7.054673721340413e-03*G0_2_1;
    block[843] = 7.054673721340398e-03*G0_0_2 + 7.054673721340385e-03*G0_1_2 - 1.834215167548500e-02*G0_2_2;
    block[844] = 6.772486772486754e-02*G0_0_0 + 1.128747795414458e-02*G0_0_1 - 3.386243386243422e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 - 6.772486772486781e-02*G0_2_0 - 2.257495590828917e-02*G0_2_1;
    block[845] = -8.465608465608435e-02*G0_0_0 - 4.232804232804226e-02*G0_0_1 + 9.312169312169327e-02*G0_1_0 + 1.185185185185185e-01*G0_1_1 + 1.862433862433862e-01*G0_2_0 + 5.079365079365075e-02*G0_2_1;
    block[846] = 1.128747795414458e-01*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.128747795414439e-02*G0_1_0 - 6.772486772486794e-02*G0_1_1 + 1.128747795414460e-01*G0_2_0 + 2.031746031746029e-01*G0_2_1;
    block[847] = -1.128747795414459e-01*G0_0_0 - 1.128747795414453e-02*G0_0_1 - 1.128747795414459e-01*G0_0_2 - 1.128747795414448e-02*G0_1_0 - 4.514991181657858e-02*G0_1_1 - 1.128747795414449e-02*G0_1_2 - 1.128747795414461e-01*G0_2_0 - 1.128747795414476e-02*G0_2_1 - 1.128747795414461e-01*G0_2_2;
    block[848] = 8.465608465608469e-02*G0_0_0 + 4.232804232804220e-02*G0_0_1 + 8.465608465608468e-02*G0_0_2 + 4.232804232804230e-02*G0_1_0 + 2.257495590828920e-02*G0_1_1 + 4.232804232804229e-02*G0_1_2 + 8.465608465608471e-02*G0_2_0 + 4.232804232804231e-02*G0_2_1 + 8.465608465608475e-02*G0_2_2;
    block[849] = -6.772486772486777e-02*G0_0_0 - 5.643738977072312e-02*G0_0_1 - 6.772486772486787e-02*G0_0_2 - 5.643738977072308e-02*G0_1_0 - 4.514991181657842e-02*G0_1_1 - 5.643738977072308e-02*G0_1_2 - 6.772486772486769e-02*G0_2_0 - 5.643738977072312e-02*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[850] = -1.128747795414468e-02*G0_0_1 - 1.128747795414476e-02*G0_0_2 - 1.128747795414457e-02*G0_1_0 - 2.257495590828934e-02*G0_1_1 - 2.257495590828933e-02*G0_1_2 - 1.128747795414467e-02*G0_2_0 - 2.257495590828930e-02*G0_2_1 - 2.257495590828934e-02*G0_2_2;
    block[851] = -2.821869488536328e-03*G0_0_1 - 2.821869488536274e-03*G0_0_2 - 2.821869488536187e-03*G0_1_0 + 1.693121693121678e-02*G0_1_1 + 1.693121693121679e-02*G0_1_2 - 2.821869488536078e-03*G0_2_0 + 1.693121693121690e-02*G0_2_1 + 1.693121693121698e-02*G0_2_2;
    block[852] = -1.128747795414457e-02*G0_0_1 - 1.128747795414458e-02*G0_0_2 - 1.128747795414474e-02*G0_1_0 + 2.257495590828940e-02*G0_1_1 + 2.257495590828936e-02*G0_1_2 - 1.128747795414478e-02*G0_2_0 + 2.257495590828922e-02*G0_2_1 + 2.257495590828918e-02*G0_2_2;
    block[853] = -2.257495590828943e-02*G0_0_0 - 2.257495590828942e-02*G0_0_1 - 1.128747795414481e-02*G0_0_2 - 2.257495590828932e-02*G0_1_0 - 2.257495590828939e-02*G0_1_1 - 1.128747795414453e-02*G0_1_2 - 1.128747795414470e-02*G0_2_0 - 1.128747795414472e-02*G0_2_1;
    block[854] = 1.693121693121695e-02*G0_0_0 + 1.693121693121699e-02*G0_0_1 - 2.821869488536084e-03*G0_0_2 + 1.693121693121713e-02*G0_1_0 + 1.693121693121716e-02*G0_1_1 - 2.821869488536247e-03*G0_1_2 - 2.821869488536123e-03*G0_2_0 - 2.821869488536109e-03*G0_2_1;
    block[855] = 2.257495590828930e-02*G0_0_0 + 2.257495590828930e-02*G0_0_1 - 1.128747795414464e-02*G0_0_2 + 2.257495590828944e-02*G0_1_0 + 2.257495590828934e-02*G0_1_1 - 1.128747795414465e-02*G0_1_2 - 1.128747795414467e-02*G0_2_0 - 1.128747795414470e-02*G0_2_1;
    block[856] = 2.257495590828913e-02*G0_0_0 + 1.128747795414461e-02*G0_0_2 - 6.772486772486795e-02*G0_1_0 - 2.257495590828934e-02*G0_1_2 - 3.386243386243389e-02*G0_2_0 - 2.257495590828915e-02*G0_2_2;
    block[857] = -1.693121693121667e-02*G0_0_0 - 1.975308641975292e-02*G0_0_2 - 8.465608465608424e-02*G0_1_0 - 8.465608465608428e-02*G0_1_2 - 1.975308641975301e-02*G0_2_0 - 1.693121693121684e-02*G0_2_2;
    block[858] = -2.257495590828937e-02*G0_0_0 - 3.386243386243393e-02*G0_0_2 - 2.257495590828941e-02*G0_1_0 - 6.772486772486791e-02*G0_1_2 + 1.128747795414469e-02*G0_2_0 + 2.257495590828925e-02*G0_2_2;
    block[859] = 2.031746031746028e-01*G0_0_1 + 1.128747795414458e-01*G0_0_2 - 6.772486772486792e-02*G0_1_1 + 1.128747795414441e-02*G0_1_2 + 1.015873015873014e-01*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[860] = 5.079365079365090e-02*G0_0_1 + 1.862433862433863e-01*G0_0_2 + 1.185185185185188e-01*G0_1_1 + 9.312169312169333e-02*G0_1_2 - 4.232804232804234e-02*G0_2_1 - 8.465608465608464e-02*G0_2_2;
    block[861] = -2.257495590828930e-02*G0_0_1 - 6.772486772486785e-02*G0_0_2 - 2.257495590828945e-02*G0_1_1 - 3.386243386243416e-02*G0_1_2 + 1.128747795414467e-02*G0_2_1 + 6.772486772486766e-02*G0_2_2;
    block[862] = -1.354497354497350e-01*G0_0_0 - 4.514991181657838e-02*G0_0_1 - 6.772486772486758e-02*G0_0_2 + 2.257495590828931e-01*G0_1_0 - 1.354497354497354e-01*G0_1_1 + 6.772486772486756e-02*G0_1_2 + 6.772486772486805e-02*G0_2_0 - 6.772486772486770e-02*G0_2_1;
    block[863] = -6.772486772486778e-02*G0_0_1 + 6.772486772486777e-02*G0_0_2 + 6.772486772486745e-02*G0_1_0 - 1.354497354497356e-01*G0_1_1 + 2.257495590828928e-01*G0_1_2 - 6.772486772486772e-02*G0_2_0 - 4.514991181657844e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[864] = 5.417989417989413e-01*G0_0_0 + 2.708994708994710e-01*G0_0_1 + 2.708994708994706e-01*G0_0_2 + 2.708994708994710e-01*G0_1_0 + 6.320987654320993e-01*G0_1_1 + 2.708994708994710e-01*G0_1_2 + 2.708994708994706e-01*G0_2_0 + 2.708994708994710e-01*G0_2_1 + 5.417989417989414e-01*G0_2_2;
    block[865] = -5.417989417989412e-01*G0_0_0 - 2.708994708994709e-01*G0_0_1 - 2.708994708994710e-01*G0_0_2 - 2.708994708994710e-01*G0_1_0 + 4.514991181657881e-02*G0_1_1 - 1.354497354497357e-01*G0_1_2 - 2.708994708994706e-01*G0_2_0 - 1.354497354497353e-01*G0_2_1;
    block[866] = -6.772486772486783e-02*G0_0_1 + 6.772486772486759e-02*G0_0_2 - 6.772486772486745e-02*G0_1_0 - 1.354497354497359e-01*G0_1_1 + 4.514991181657869e-02*G0_1_2 + 6.772486772486772e-02*G0_2_0 + 4.514991181657850e-02*G0_2_1;
    block[867] = 1.354497354497359e-01*G0_0_0 + 9.029982363315735e-02*G0_0_1 + 6.772486772486819e-02*G0_0_2 + 9.029982363315707e-02*G0_1_0 + 4.514991181657843e-02*G0_1_1 + 4.514991181657867e-02*G0_1_2 + 6.772486772486785e-02*G0_2_0 + 4.514991181657855e-02*G0_2_1;
    block[868] = 6.772486772486774e-02*G0_0_1 + 2.257495590828918e-02*G0_0_2 + 6.772486772486708e-02*G0_1_0 + 1.354497354497355e-01*G0_1_1 + 4.514991181657835e-02*G0_1_2 + 2.257495590828914e-02*G0_2_0 + 4.514991181657835e-02*G0_2_1;
    block[869] = 4.514991181657805e-02*G0_0_1 + 2.257495590828909e-02*G0_0_2 + 4.514991181657876e-02*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 6.772486772486740e-02*G0_1_2 + 2.257495590828928e-02*G0_2_0 + 6.772486772486748e-02*G0_2_1;
    block[870] = 4.514991181657876e-02*G0_0_1 + 2.257495590828954e-02*G0_0_2 + 4.514991181657856e-02*G0_1_0 + 9.029982363315719e-02*G0_1_1 + 4.514991181657889e-02*G0_1_2 + 2.257495590828930e-02*G0_2_0 + 4.514991181657863e-02*G0_2_1;
    block[871] = 4.514991181657881e-02*G0_0_1 + 6.772486772486798e-02*G0_0_2 + 4.514991181657816e-02*G0_1_0 + 4.514991181657849e-02*G0_1_1 + 9.029982363315664e-02*G0_1_2 + 6.772486772486754e-02*G0_2_0 + 9.029982363315701e-02*G0_2_1 + 1.354497354497353e-01*G0_2_2;
    block[872] = 4.514991181657846e-02*G0_0_1 + 6.772486772486741e-02*G0_0_2 + 4.514991181657921e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 6.772486772486759e-02*G0_1_2 + 6.772486772486794e-02*G0_2_0 - 6.772486772486784e-02*G0_2_1;
    block[873] = -1.354497354497355e-01*G0_0_1 - 2.708994708994703e-01*G0_0_2 - 1.354497354497355e-01*G0_1_0 + 4.514991181657891e-02*G0_1_1 - 2.708994708994710e-01*G0_1_2 - 2.708994708994709e-01*G0_2_0 - 2.708994708994706e-01*G0_2_1 - 5.417989417989411e-01*G0_2_2;
    block[874] = -3.160493827160493e-01*G0_0_1 - 1.354497354497356e-01*G0_0_2 - 3.160493827160501e-01*G0_1_0 - 7.223985890652564e-01*G0_1_1 - 3.160493827160495e-01*G0_1_2 - 1.354497354497359e-01*G0_2_0 - 3.160493827160494e-01*G0_2_1;
    block[875] = -1.834215167548505e-02*G0_0_0 - 1.834215167548505e-02*G0_0_1 - 1.834215167548505e-02*G0_0_2 - 2.539682539682541e-02*G0_1_0 - 2.539682539682539e-02*G0_1_1 - 2.539682539682540e-02*G0_1_2 - 2.539682539682538e-02*G0_2_0 - 2.539682539682538e-02*G0_2_1 - 2.539682539682540e-02*G0_2_2;
    block[876] = 1.834215167548493e-02*G0_0_0;
    block[877] = -7.054673721340321e-03*G0_0_1 + 4.232804232804237e-02*G0_1_1;
    block[878] = -7.054673721340411e-03*G0_0_2 - 2.539682539682538e-02*G0_2_2;
    block[879] = -6.772486772486756e-02*G0_0_0 - 1.128747795414460e-02*G0_0_1 - 1.128747795414460e-02*G0_1_0;
    block[880] = 8.465608465608435e-02*G0_0_0 + 4.232804232804226e-02*G0_0_1 + 4.232804232804242e-02*G0_1_0 + 2.257495590828942e-02*G0_1_1;
    block[881] = -1.128747795414458e-01*G0_0_0 - 1.015873015873014e-01*G0_0_1 - 1.015873015873017e-01*G0_1_0 - 1.354497354497356e-01*G0_1_1;
    block[882] = 1.128747795414459e-01*G0_0_0 + 1.128747795414455e-02*G0_0_1 + 1.128747795414460e-01*G0_0_2 + 1.015873015873017e-01*G0_1_0 - 6.772486772486766e-02*G0_1_1 + 1.015873015873018e-01*G0_1_2 + 1.015873015873014e-01*G0_2_1;
    block[883] = -8.465608465608468e-02*G0_0_0 - 4.232804232804222e-02*G0_0_1 - 8.465608465608468e-02*G0_0_2 - 1.777777777777778e-01*G0_1_0 - 1.693121693121682e-02*G0_1_1 - 1.777777777777779e-01*G0_1_2 - 2.708994708994705e-01*G0_2_0 - 1.777777777777773e-01*G0_2_1 - 2.708994708994705e-01*G0_2_2;
    block[884] = 6.772486772486780e-02*G0_0_0 + 5.643738977072312e-02*G0_0_1 + 6.772486772486790e-02*G0_0_2 + 1.015873015873017e-01*G0_1_0 + 6.772486772486766e-02*G0_1_1 + 1.015873015873017e-01*G0_1_2 + 1.354497354497353e-01*G0_2_0 + 1.015873015873014e-01*G0_2_1 + 1.354497354497354e-01*G0_2_2;
    block[885] = 1.128747795414470e-02*G0_0_1 + 1.128747795414478e-02*G0_0_2 + 1.128747795414454e-02*G0_1_0 + 4.514991181657867e-02*G0_1_1 + 4.514991181657872e-02*G0_1_2 + 1.128747795414453e-02*G0_2_0 + 4.514991181657855e-02*G0_2_1 + 4.514991181657856e-02*G0_2_2;
    block[886] = 2.821869488536281e-03*G0_0_1 + 2.821869488536226e-03*G0_0_2 + 2.821869488536148e-03*G0_1_0 + 2.257495590828918e-02*G0_1_1 + 2.257495590828917e-02*G0_1_2 + 2.821869488536208e-03*G0_2_0 + 2.257495590828926e-02*G0_2_1 + 2.257495590828926e-02*G0_2_2;
    block[887] = 1.128747795414459e-02*G0_0_1 + 1.128747795414460e-02*G0_0_2 + 1.128747795414473e-02*G0_1_0 + 1.128747795414469e-02*G0_2_0;
    block[888] = 2.257495590828944e-02*G0_0_0 + 2.257495590828943e-02*G0_0_1 + 1.128747795414482e-02*G0_0_2 + 9.029982363315710e-02*G0_1_0 + 9.029982363315713e-02*G0_1_1 + 5.643738977072315e-02*G0_1_2 + 5.643738977072320e-02*G0_2_0 + 5.643738977072315e-02*G0_2_1 + 2.257495590828929e-02*G0_2_2;
    block[889] = -1.693121693121696e-02*G0_0_0 - 1.693121693121701e-02*G0_0_1 + 2.821869488536075e-03*G0_0_2 + 6.772486772486759e-02*G0_1_0 + 6.772486772486766e-02*G0_1_1 + 2.821869488536191e-03*G0_1_2 + 2.821869488536097e-03*G0_2_0 + 2.821869488536098e-03*G0_2_1 + 5.643738977072298e-03*G0_2_2;
    block[890] = -2.257495590828924e-02*G0_0_0 - 2.257495590828924e-02*G0_0_1 + 1.128747795414467e-02*G0_0_2 - 3.386243386243386e-02*G0_1_2 - 3.386243386243395e-02*G0_2_0 - 3.386243386243396e-02*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[891] = -2.257495590828918e-02*G0_0_0 - 1.128747795414463e-02*G0_0_2 - 1.128747795414454e-02*G0_2_0;
    block[892] = 1.693121693121670e-02*G0_0_0 + 1.975308641975292e-02*G0_0_2 + 1.975308641975279e-02*G0_2_0 + 2.257495590828906e-02*G0_2_2;
    block[893] = 2.257495590828931e-02*G0_0_0 + 3.386243386243391e-02*G0_0_2 + 3.386243386243399e-02*G0_2_0 + 4.514991181657856e-02*G0_2_2;
    block[894] = -2.031746031746028e-01*G0_0_1 - 1.128747795414458e-01*G0_0_2 - 2.708994708994709e-01*G0_1_1 - 1.015873015873017e-01*G0_1_2 - 1.015873015873016e-01*G0_2_1;
    block[895] = -5.079365079365086e-02*G0_0_1 - 1.862433862433862e-01*G0_0_2 + 6.772486772486776e-02*G0_1_1 - 9.312169312169305e-02*G0_1_2 - 9.312169312169304e-02*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[896] = 2.257495590828925e-02*G0_0_1 + 6.772486772486778e-02*G0_0_2 + 3.386243386243370e-02*G0_1_2 + 3.386243386243393e-02*G0_2_1 + 1.354497354497354e-01*G0_2_2;
    block[897] = 1.354497354497350e-01*G0_0_0 + 4.514991181657838e-02*G0_0_1 + 6.772486772486756e-02*G0_0_2 + 4.514991181657894e-02*G0_1_0 + 2.257495590828947e-02*G0_1_2 + 6.772486772486729e-02*G0_2_0 + 2.257495590828897e-02*G0_2_1;
    block[898] = 6.772486772486772e-02*G0_0_1 - 6.772486772486774e-02*G0_0_2 + 6.772486772486766e-02*G0_1_0 + 4.514991181657876e-02*G0_1_2 - 6.772486772486717e-02*G0_2_0 + 4.514991181657872e-02*G0_2_1 - 1.354497354497352e-01*G0_2_2;
    block[899] = -5.417989417989412e-01*G0_0_0 - 2.708994708994710e-01*G0_0_1 - 2.708994708994706e-01*G0_0_2 - 2.708994708994709e-01*G0_1_0 + 4.514991181657883e-02*G0_1_1 - 1.354497354497353e-01*G0_1_2 - 2.708994708994710e-01*G0_2_0 - 1.354497354497357e-01*G0_2_1;
    block[900] = 5.417989417989412e-01*G0_0_0 + 2.708994708994708e-01*G0_0_1 + 2.708994708994709e-01*G0_0_2 + 2.708994708994708e-01*G0_1_0 + 6.320987654320989e-01*G0_1_1 + 2.708994708994710e-01*G0_1_2 + 2.708994708994709e-01*G0_2_0 + 2.708994708994710e-01*G0_2_1 + 5.417989417989411e-01*G0_2_2;
    block[901] = 6.772486772486783e-02*G0_0_1 - 6.772486772486759e-02*G0_0_2 - 6.772486772486755e-02*G0_1_0 - 1.354497354497353e-01*G0_1_1 + 9.029982363315724e-02*G0_1_2 + 6.772486772486727e-02*G0_2_0 + 9.029982363315696e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[902] = -1.354497354497358e-01*G0_0_0 - 9.029982363315725e-02*G0_0_1 - 6.772486772486817e-02*G0_0_2 - 3.611992945326280e-01*G0_1_0 - 4.514991181657850e-01*G0_1_1 - 2.257495590828927e-01*G0_1_2 - 2.031746031746033e-01*G0_2_0 - 2.257495590828925e-01*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[903] = -6.772486772486767e-02*G0_0_1 - 2.257495590828913e-02*G0_0_2 - 6.772486772486766e-02*G0_1_0 - 4.514991181657827e-02*G0_1_2 - 2.257495590828898e-02*G0_2_0 - 4.514991181657871e-02*G0_2_1 - 4.514991181657844e-02*G0_2_2;
    block[904] = -4.514991181657804e-02*G0_0_1 - 2.257495590828905e-02*G0_0_2 - 4.514991181657826e-02*G0_1_0 - 2.257495590828910e-02*G0_1_2 - 2.257495590828918e-02*G0_2_0 - 2.257495590828879e-02*G0_2_1 - 4.514991181657829e-02*G0_2_2;
    block[905] = -4.514991181657881e-02*G0_0_1 - 2.257495590828959e-02*G0_0_2 - 4.514991181657869e-02*G0_1_0 + 4.514991181657821e-02*G0_1_1 - 2.257495590828941e-02*G0_2_0 - 4.514991181657867e-02*G0_2_2;
    block[906] = -4.514991181657883e-02*G0_0_1 - 6.772486772486802e-02*G0_0_2 - 4.514991181657840e-02*G0_1_0 - 2.257495590828927e-01*G0_1_1 - 1.805996472663139e-01*G0_1_2 - 6.772486772486740e-02*G0_2_0 - 1.805996472663139e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[907] = -4.514991181657841e-02*G0_0_1 - 6.772486772486738e-02*G0_0_2 - 4.514991181657860e-02*G0_1_0 - 4.514991181657863e-02*G0_1_1 - 2.257495590828933e-02*G0_1_2 - 6.772486772486795e-02*G0_2_0 - 2.257495590828924e-02*G0_2_1;
    block[908] = 1.354497354497355e-01*G0_0_1 + 2.708994708994704e-01*G0_0_2 + 1.354497354497354e-01*G0_1_0 + 3.160493827160497e-01*G0_1_1 + 1.354497354497350e-01*G0_1_2 + 2.708994708994705e-01*G0_2_0 + 1.354497354497354e-01*G0_2_1;
    block[909] = 3.160493827160494e-01*G0_0_1 + 1.354497354497357e-01*G0_0_2 + 3.160493827160491e-01*G0_1_0 - 9.029982363315742e-02*G0_1_1 + 1.354497354497352e-01*G0_1_2 + 1.354497354497361e-01*G0_2_0 + 1.354497354497356e-01*G0_2_1 + 2.708994708994704e-01*G0_2_2;
    block[910] = -1.834215167548502e-02*G0_0_0 - 1.834215167548504e-02*G0_0_1 - 1.834215167548503e-02*G0_0_2 - 2.539682539682539e-02*G0_1_0 - 2.539682539682540e-02*G0_1_1 - 2.539682539682540e-02*G0_1_2 - 2.539682539682538e-02*G0_2_0 - 2.539682539682539e-02*G0_2_1 - 2.539682539682538e-02*G0_2_2;
    block[911] = 1.834215167548493e-02*G0_0_0;
    block[912] = -7.054673721340362e-03*G0_0_1 - 2.539682539682534e-02*G0_1_1;
    block[913] = -7.054673721340427e-03*G0_0_2 + 4.232804232804221e-02*G0_2_2;
    block[914] = -2.257495590828920e-02*G0_0_0 - 1.128747795414460e-02*G0_0_1 - 1.128747795414464e-02*G0_1_0;
    block[915] = 1.693121693121692e-02*G0_0_0 + 1.975308641975311e-02*G0_0_1 + 1.975308641975300e-02*G0_1_0 + 2.257495590828913e-02*G0_1_1;
    block[916] = 2.257495590828916e-02*G0_0_0 + 3.386243386243373e-02*G0_0_1 + 3.386243386243400e-02*G0_1_0 + 4.514991181657863e-02*G0_1_1;
    block[917] = -2.257495590828914e-02*G0_0_0 + 1.128747795414450e-02*G0_0_1 - 2.257495590828915e-02*G0_0_2 - 3.386243386243394e-02*G0_1_0 + 2.257495590828911e-02*G0_1_1 - 3.386243386243393e-02*G0_1_2 - 3.386243386243400e-02*G0_2_1;
    block[918] = -1.693121693121670e-02*G0_0_0 + 2.821869488536276e-03*G0_0_1 - 1.693121693121673e-02*G0_0_2 + 2.821869488536282e-03*G0_1_0 + 5.643738977072454e-03*G0_1_1 + 2.821869488536263e-03*G0_1_2 + 6.772486772486766e-02*G0_2_0 + 2.821869488536315e-03*G0_2_1 + 6.772486772486762e-02*G0_2_2;
    block[919] = 2.257495590828922e-02*G0_0_0 + 1.128747795414461e-02*G0_0_1 + 2.257495590828929e-02*G0_0_2 + 5.643738977072303e-02*G0_1_0 + 2.257495590828920e-02*G0_1_1 + 5.643738977072305e-02*G0_1_2 + 9.029982363315693e-02*G0_2_0 + 5.643738977072303e-02*G0_2_1 + 9.029982363315696e-02*G0_2_2;
    block[920] = 1.128747795414474e-02*G0_0_1 + 1.128747795414475e-02*G0_0_2 + 1.128747795414454e-02*G0_1_0 + 4.514991181657840e-02*G0_1_1 + 4.514991181657842e-02*G0_1_2 + 1.128747795414460e-02*G0_2_0 + 4.514991181657852e-02*G0_2_1 + 4.514991181657860e-02*G0_2_2;
    block[921] = 2.821869488536094e-03*G0_0_1 + 2.821869488536112e-03*G0_0_2 + 2.821869488536317e-03*G0_1_0 + 2.257495590828924e-02*G0_1_1 + 2.257495590828925e-02*G0_1_2 + 2.821869488536209e-03*G0_2_0 + 2.257495590828918e-02*G0_2_1 + 2.257495590828913e-02*G0_2_2;
    block[922] = 1.128747795414461e-02*G0_0_1 + 1.128747795414460e-02*G0_0_2 + 1.128747795414450e-02*G0_1_0 + 1.128747795414451e-02*G0_2_0;
    block[923] = 6.772486772486781e-02*G0_0_0 + 6.772486772486780e-02*G0_0_1 + 5.643738977072318e-02*G0_0_2 + 1.354497354497354e-01*G0_1_0 + 1.354497354497353e-01*G0_1_1 + 1.015873015873016e-01*G0_1_2 + 1.015873015873016e-01*G0_2_0 + 1.015873015873016e-01*G0_2_1 + 6.772486772486770e-02*G0_2_2;
    block[924] = -8.465608465608479e-02*G0_0_0 - 8.465608465608476e-02*G0_0_1 - 4.232804232804240e-02*G0_0_2 - 2.708994708994705e-01*G0_1_0 - 2.708994708994705e-01*G0_1_1 - 1.777777777777777e-01*G0_1_2 - 1.777777777777777e-01*G0_2_0 - 1.777777777777778e-01*G0_2_1 - 1.693121693121697e-02*G0_2_2;
    block[925] = 1.128747795414461e-01*G0_0_0 + 1.128747795414461e-01*G0_0_1 + 1.128747795414464e-02*G0_0_2 + 1.015873015873014e-01*G0_1_2 + 1.015873015873018e-01*G0_2_0 + 1.015873015873018e-01*G0_2_1 - 6.772486772486766e-02*G0_2_2;
    block[926] = -6.772486772486767e-02*G0_0_0 - 1.128747795414457e-02*G0_0_2 - 1.128747795414491e-02*G0_2_0;
    block[927] = 8.465608465608425e-02*G0_0_0 + 4.232804232804192e-02*G0_0_2 + 4.232804232804267e-02*G0_2_0 + 2.257495590828943e-02*G0_2_2;
    block[928] = -1.128747795414460e-01*G0_0_0 - 1.015873015873014e-01*G0_0_2 - 1.015873015873018e-01*G0_2_0 - 1.354497354497355e-01*G0_2_2;
    block[929] = 6.772486772486755e-02*G0_0_1 + 2.257495590828912e-02*G0_0_2 + 1.354497354497355e-01*G0_1_1 + 3.386243386243397e-02*G0_1_2 + 3.386243386243360e-02*G0_2_1;
    block[930] = -1.862433862433857e-01*G0_0_1 - 5.079365079365052e-02*G0_0_2 - 2.708994708994710e-01*G0_1_1 - 9.312169312169333e-02*G0_1_2 - 9.312169312169286e-02*G0_2_1 + 6.772486772486751e-02*G0_2_2;
    block[931] = -1.128747795414461e-01*G0_0_1 - 2.031746031746030e-01*G0_0_2 - 1.015873015873012e-01*G0_1_2 - 1.015873015873018e-01*G0_2_1 - 2.708994708994709e-01*G0_2_2;
    block[932] = 1.354497354497347e-01*G0_0_0 + 6.772486772486710e-02*G0_0_1 + 4.514991181657828e-02*G0_0_2 + 6.772486772486733e-02*G0_1_0 + 2.257495590828900e-02*G0_1_2 + 4.514991181657902e-02*G0_2_0 + 2.257495590828943e-02*G0_2_1;
    block[933] = -5.417989417989407e-01*G0_0_0 - 2.708994708994706e-01*G0_0_1 - 2.708994708994704e-01*G0_0_2 - 2.708994708994703e-01*G0_1_0 - 1.354497354497354e-01*G0_1_2 - 2.708994708994708e-01*G0_2_0 - 1.354497354497352e-01*G0_2_1 + 4.514991181657889e-02*G0_2_2;
    block[934] = -6.772486772486745e-02*G0_0_1 + 6.772486772486772e-02*G0_0_2 - 6.772486772486784e-02*G0_1_0 - 1.354497354497359e-01*G0_1_1 + 4.514991181657850e-02*G0_1_2 + 6.772486772486759e-02*G0_2_0 + 4.514991181657868e-02*G0_2_1;
    block[935] = -6.772486772486755e-02*G0_0_1 + 6.772486772486727e-02*G0_0_2 + 6.772486772486783e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 + 9.029982363315699e-02*G0_1_2 - 6.772486772486759e-02*G0_2_0 + 9.029982363315724e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[936] = 5.417989417989407e-01*G0_0_0 + 2.708994708994703e-01*G0_0_1 + 2.708994708994708e-01*G0_0_2 + 2.708994708994703e-01*G0_1_0 + 5.417989417989417e-01*G0_1_1 + 2.708994708994705e-01*G0_1_2 + 2.708994708994708e-01*G0_2_0 + 2.708994708994705e-01*G0_2_1 + 6.320987654320982e-01*G0_2_2;
    block[937] = -1.354497354497353e-01*G0_0_0 - 6.772486772486770e-02*G0_0_1 - 9.029982363315718e-02*G0_0_2 - 2.031746031746031e-01*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 2.257495590828923e-01*G0_1_2 - 3.611992945326277e-01*G0_2_0 - 2.257495590828923e-01*G0_2_1 - 4.514991181657845e-01*G0_2_2;
    block[938] = 2.708994708994707e-01*G0_0_1 + 1.354497354497355e-01*G0_0_2 + 2.708994708994707e-01*G0_1_0 + 1.354497354497351e-01*G0_1_2 + 1.354497354497350e-01*G0_2_0 + 1.354497354497352e-01*G0_2_1 + 3.160493827160495e-01*G0_2_2;
    block[939] = -6.772486772486690e-02*G0_0_1 - 4.514991181657794e-02*G0_0_2 - 6.772486772486729e-02*G0_1_0 - 2.257495590828905e-02*G0_1_2 - 4.514991181657788e-02*G0_2_0 - 2.257495590828932e-02*G0_2_1 - 4.514991181657853e-02*G0_2_2;
    block[940] = -6.772486772486795e-02*G0_0_1 - 4.514991181657888e-02*G0_0_2 - 6.772486772486792e-02*G0_1_0 - 1.354497354497357e-01*G0_1_1 - 1.805996472663138e-01*G0_1_2 - 4.514991181657873e-02*G0_2_0 - 1.805996472663141e-01*G0_2_1 - 2.257495590828926e-01*G0_2_2;
    block[941] = -2.257495590828922e-02*G0_0_1 - 4.514991181657832e-02*G0_0_2 - 2.257495590828928e-02*G0_1_0 - 4.514991181657842e-02*G0_1_1 - 4.514991181657863e-02*G0_2_0 + 4.514991181657820e-02*G0_2_2;
    block[942] = -2.257495590828914e-02*G0_0_1 - 4.514991181657824e-02*G0_0_2 - 2.257495590828914e-02*G0_1_0 - 4.514991181657837e-02*G0_1_1 - 2.257495590828904e-02*G0_1_2 - 4.514991181657810e-02*G0_2_0 - 2.257495590828917e-02*G0_2_1;
    block[943] = -2.257495590828940e-02*G0_0_1 - 6.772486772486765e-02*G0_0_2 - 2.257495590828931e-02*G0_1_0 - 4.514991181657869e-02*G0_1_1 - 4.514991181657844e-02*G0_1_2 - 6.772486772486778e-02*G0_2_0 - 4.514991181657835e-02*G0_2_1;
    block[944] = 1.354497354497354e-01*G0_0_1 + 3.160493827160489e-01*G0_0_2 + 1.354497354497360e-01*G0_1_0 + 2.708994708994714e-01*G0_1_1 + 1.354497354497357e-01*G0_1_2 + 3.160493827160489e-01*G0_2_0 + 1.354497354497353e-01*G0_2_1 - 9.029982363315690e-02*G0_2_2;
    block[945] = 4.938271604938265e-02*G0_0_0 + 4.938271604938264e-02*G0_0_1 + 4.938271604938262e-02*G0_0_2 + 4.232804232804229e-02*G0_1_0 + 4.232804232804232e-02*G0_1_1 + 4.232804232804232e-02*G0_1_2 + 4.232804232804228e-02*G0_2_0 + 4.232804232804230e-02*G0_2_1 + 4.232804232804230e-02*G0_2_2;
    block[946] = 1.834215167548489e-02*G0_0_0;
    block[947] = -7.054673721340389e-03*G0_0_1 - 2.539682539682542e-02*G0_1_1;
    block[948] = -7.054673721340374e-03*G0_0_2 - 2.539682539682530e-02*G0_2_2;
    block[949] = -2.257495590828911e-02*G0_0_0 - 1.128747795414457e-02*G0_0_1 - 1.128747795414471e-02*G0_1_0;
    block[950] = 1.693121693121682e-02*G0_0_0 + 1.975308641975301e-02*G0_0_1 + 1.975308641975287e-02*G0_1_0 + 2.257495590828907e-02*G0_1_1;
    block[951] = 2.257495590828932e-02*G0_0_0 + 3.386243386243390e-02*G0_0_1 + 3.386243386243400e-02*G0_1_0 + 4.514991181657858e-02*G0_1_1;
    block[952] = -2.257495590828941e-02*G0_0_0 + 1.128747795414464e-02*G0_0_1 - 2.257495590828944e-02*G0_0_2 - 3.386243386243409e-02*G0_1_0 + 6.772486772486763e-02*G0_1_1 - 3.386243386243416e-02*G0_1_2 - 3.386243386243372e-02*G0_2_1;
    block[953] = 1.185185185185186e-01*G0_0_0 + 2.539682539682521e-02*G0_0_1 + 1.185185185185186e-01*G0_0_2 + 1.608465608465608e-01*G0_1_0 - 1.693121693121704e-02*G0_1_1 + 1.608465608465609e-01*G0_1_2 + 6.772486772486772e-02*G0_2_0 + 1.608465608465604e-01*G0_2_1 + 6.772486772486776e-02*G0_2_2;
    block[954] = -6.772486772486785e-02*G0_0_0 - 7.901234567901222e-02*G0_0_1 - 6.772486772486785e-02*G0_0_2 - 1.693121693121692e-01*G0_1_0 - 6.772486772486766e-02*G0_1_1 - 1.693121693121692e-01*G0_1_2 - 2.708994708994706e-01*G0_2_0 - 1.693121693121690e-01*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[955] = -4.514991181657831e-02*G0_0_0 - 3.386243386243402e-02*G0_0_1 - 3.386243386243405e-02*G0_0_2 - 3.386243386243368e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 1.354497354497354e-01*G0_1_2 - 3.386243386243371e-02*G0_2_0 - 1.354497354497353e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[956] = 2.257495590828914e-02*G0_0_0 - 1.975308641975314e-02*G0_0_1 - 1.975308641975309e-02*G0_0_2 - 1.975308641975306e-02*G0_1_0 + 2.257495590828933e-02*G0_1_1 + 2.257495590828932e-02*G0_1_2 - 1.975308641975306e-02*G0_2_0 + 2.257495590828917e-02*G0_2_1 + 2.257495590828918e-02*G0_2_2;
    block[957] = -4.514991181657842e-02*G0_0_0 + 1.128747795414452e-02*G0_0_1 + 1.128747795414450e-02*G0_0_2 + 1.128747795414450e-02*G0_1_0 + 1.128747795414459e-02*G0_2_0;
    block[958] = -6.772486772486783e-02*G0_0_0 - 6.772486772486788e-02*G0_0_1 - 7.901234567901222e-02*G0_0_2 - 2.708994708994708e-01*G0_1_0 - 2.708994708994707e-01*G0_1_1 - 1.693121693121692e-01*G0_1_2 - 1.693121693121693e-01*G0_2_0 - 1.693121693121693e-01*G0_2_1 - 6.772486772486776e-02*G0_2_2;
    block[959] = 1.185185185185184e-01*G0_0_0 + 1.185185185185184e-01*G0_0_1 + 2.539682539682525e-02*G0_0_2 + 6.772486772486763e-02*G0_1_0 + 6.772486772486758e-02*G0_1_1 + 1.608465608465606e-01*G0_1_2 + 1.608465608465607e-01*G0_2_0 + 1.608465608465607e-01*G0_2_1 - 1.693121693121687e-02*G0_2_2;
    block[960] = -2.257495590828931e-02*G0_0_0 - 2.257495590828927e-02*G0_0_1 + 1.128747795414474e-02*G0_0_2 - 3.386243386243381e-02*G0_1_2 - 3.386243386243400e-02*G0_2_0 - 3.386243386243398e-02*G0_2_1 + 6.772486772486758e-02*G0_2_2;
    block[961] = -2.257495590828902e-02*G0_0_0 - 1.128747795414454e-02*G0_0_2 - 1.128747795414440e-02*G0_2_0;
    block[962] = 1.693121693121662e-02*G0_0_0 + 1.975308641975282e-02*G0_0_2 + 1.975308641975267e-02*G0_2_0 + 2.257495590828901e-02*G0_2_2;
    block[963] = 2.257495590828933e-02*G0_0_0 + 3.386243386243387e-02*G0_0_2 + 3.386243386243410e-02*G0_2_0 + 4.514991181657854e-02*G0_2_2;
    block[964] = 6.772486772486781e-02*G0_0_1 + 2.257495590828938e-02*G0_0_2 + 9.029982363315717e-02*G0_1_1 + 3.386243386243403e-02*G0_1_2 + 3.386243386243411e-02*G0_2_1;
    block[965] = 8.465608465608476e-02*G0_0_1 + 8.465608465608485e-02*G0_0_2 + 6.772486772486769e-02*G0_1_1 + 6.490299823633169e-02*G0_1_2 + 6.490299823633160e-02*G0_2_1 + 6.772486772486802e-02*G0_2_2;
    block[966] = 2.257495590828933e-02*G0_0_1 + 6.772486772486777e-02*G0_0_2 + 3.386243386243382e-02*G0_1_2 + 3.386243386243409e-02*G0_2_1 + 9.029982363315706e-02*G0_2_2;
    block[967] = 9.029982363315603e-02*G0_0_0 + 4.514991181657804e-02*G0_0_1 + 4.514991181657826e-02*G0_0_2 + 4.514991181657812e-02*G0_1_0 + 2.257495590828891e-02*G0_1_2 + 4.514991181657775e-02*G0_2_0 + 2.257495590828880e-02*G0_2_1;
    block[968] = 1.354497354497352e-01*G0_0_0 + 6.772486772486701e-02*G0_0_1 + 9.029982363315621e-02*G0_0_2 + 6.772486772486755e-02*G0_1_0 + 4.514991181657836e-02*G0_1_2 + 9.029982363315708e-02*G0_2_0 + 4.514991181657813e-02*G0_2_1 + 4.514991181657814e-02*G0_2_2;
    block[969] = 1.354497354497359e-01*G0_0_0 + 9.029982363315706e-02*G0_0_1 + 6.772486772486784e-02*G0_0_2 + 9.029982363315732e-02*G0_1_0 + 4.514991181657842e-02*G0_1_1 + 4.514991181657856e-02*G0_1_2 + 6.772486772486820e-02*G0_2_0 + 4.514991181657867e-02*G0_2_1;
    block[970] = -1.354497354497358e-01*G0_0_0 - 3.611992945326280e-01*G0_0_1 - 2.031746031746033e-01*G0_0_2 - 9.029982363315724e-02*G0_1_0 - 4.514991181657850e-01*G0_1_1 - 2.257495590828925e-01*G0_1_2 - 6.772486772486816e-02*G0_2_0 - 2.257495590828927e-01*G0_2_1 - 1.354497354497356e-01*G0_2_2;
    block[971] = -1.354497354497353e-01*G0_0_0 - 2.031746031746031e-01*G0_0_1 - 3.611992945326278e-01*G0_0_2 - 6.772486772486769e-02*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 2.257495590828923e-01*G0_1_2 - 9.029982363315717e-02*G0_2_0 - 2.257495590828923e-01*G0_2_1 - 4.514991181657845e-01*G0_2_2;
    block[972] = 6.320987654320984e-01*G0_0_0 + 3.611992945326279e-01*G0_0_1 + 3.611992945326278e-01*G0_0_2 + 3.611992945326279e-01*G0_1_0 + 6.320987654320985e-01*G0_1_1 + 3.611992945326277e-01*G0_1_2 + 3.611992945326278e-01*G0_2_0 + 3.611992945326277e-01*G0_2_1 + 6.320987654320979e-01*G0_2_2;
    block[973] = -1.354497354497349e-01*G0_0_0 - 6.772486772486710e-02*G0_0_1 - 1.805996472663139e-01*G0_0_2 - 6.772486772486762e-02*G0_1_0 - 4.514991181657826e-02*G0_1_2 - 1.805996472663133e-01*G0_2_0 - 4.514991181657815e-02*G0_2_1 - 2.257495590828923e-01*G0_2_2;
    block[974] = 4.514991181657808e-02*G0_0_0 - 4.514991181657816e-02*G0_0_1 - 4.514991181657850e-02*G0_1_0 - 2.257495590828949e-02*G0_1_2 - 2.257495590828894e-02*G0_2_1 - 4.514991181657815e-02*G0_2_2;
    block[975] = 4.514991181657863e-02*G0_0_0 + 3.160493827160489e-01*G0_0_1 + 1.805996472663141e-01*G0_0_2 + 3.160493827160492e-01*G0_1_0 + 4.514991181657854e-02*G0_1_1 + 1.805996472663138e-01*G0_1_2 + 1.805996472663139e-01*G0_2_0 + 1.805996472663138e-01*G0_2_1 + 3.160493827160493e-01*G0_2_2;
    block[976] = 4.514991181657826e-02*G0_0_0 + 1.805996472663140e-01*G0_0_1 + 3.160493827160487e-01*G0_0_2 + 1.805996472663135e-01*G0_1_0 + 3.160493827160491e-01*G0_1_1 + 1.805996472663138e-01*G0_1_2 + 3.160493827160487e-01*G0_2_0 + 1.805996472663138e-01*G0_2_1 + 4.514991181657840e-02*G0_2_2;
    block[977] = 4.514991181657854e-02*G0_0_0 - 4.514991181657828e-02*G0_0_2 - 4.514991181657831e-02*G0_1_1 - 2.257495590828892e-02*G0_1_2 - 4.514991181657816e-02*G0_2_0 - 2.257495590828896e-02*G0_2_1;
    block[978] = -1.354497354497352e-01*G0_0_0 - 1.805996472663139e-01*G0_0_1 - 6.772486772486780e-02*G0_0_2 - 1.805996472663136e-01*G0_1_0 - 2.257495590828924e-01*G0_1_1 - 4.514991181657843e-02*G0_1_2 - 6.772486772486754e-02*G0_2_0 - 4.514991181657855e-02*G0_2_1;
    block[979] = -7.223985890652541e-01*G0_0_0 - 4.063492063492058e-01*G0_0_1 - 4.063492063492051e-01*G0_0_2 - 4.063492063492061e-01*G0_1_0 - 9.029982363315657e-02*G0_1_1 - 2.257495590828922e-01*G0_1_2 - 4.063492063492055e-01*G0_2_0 - 2.257495590828923e-01*G0_2_1 - 9.029982363315668e-02*G0_2_2;
    block[980] = -2.539682539682540e-02*G0_0_0 - 2.539682539682540e-02*G0_0_1 - 2.539682539682541e-02*G0_0_2 - 1.834215167548503e-02*G0_1_0 - 1.834215167548504e-02*G0_1_1 - 1.834215167548505e-02*G0_1_2 - 2.539682539682538e-02*G0_2_0 - 2.539682539682540e-02*G0_2_1 - 2.539682539682539e-02*G0_2_2;
    block[981] = -2.539682539682542e-02*G0_0_0 - 7.054673721340480e-03*G0_1_0;
    block[982] = 1.834215167548498e-02*G0_1_1;
    block[983] = -7.054673721340478e-03*G0_1_2 + 4.232804232804216e-02*G0_2_2;
    block[984] = 4.514991181657826e-02*G0_0_0 + 3.386243386243368e-02*G0_0_1 + 3.386243386243373e-02*G0_1_0 + 2.257495590828911e-02*G0_1_1;
    block[985] = 2.257495590828914e-02*G0_0_0 + 1.975308641975293e-02*G0_0_1 + 1.975308641975312e-02*G0_1_0 + 1.693121693121694e-02*G0_1_1;
    block[986] = -1.128747795414452e-02*G0_0_1 - 1.128747795414480e-02*G0_1_0 - 2.257495590828940e-02*G0_1_1;
    block[987] = 1.128747795414460e-02*G0_0_1 + 1.128747795414478e-02*G0_1_0 + 1.128747795414473e-02*G0_1_2 + 1.128747795414440e-02*G0_2_1;
    block[988] = 2.257495590828910e-02*G0_0_0 + 2.821869488536178e-03*G0_0_1 + 2.257495590828912e-02*G0_0_2 + 2.821869488536167e-03*G0_1_0 + 2.821869488536188e-03*G0_1_2 + 2.257495590828933e-02*G0_2_0 + 2.821869488536307e-03*G0_2_1 + 2.257495590828928e-02*G0_2_2;
    block[989] = 4.514991181657838e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 + 4.514991181657832e-02*G0_0_2 + 1.128747795414454e-02*G0_1_0 + 1.128747795414456e-02*G0_1_2 + 4.514991181657844e-02*G0_2_0 + 1.128747795414463e-02*G0_2_1 + 4.514991181657848e-02*G0_2_2;
    block[990] = 2.257495590828924e-02*G0_0_0 + 5.643738977072307e-02*G0_0_1 + 5.643738977072302e-02*G0_0_2 + 1.128747795414477e-02*G0_1_0 + 2.257495590828933e-02*G0_1_1 + 2.257495590828930e-02*G0_1_2 + 5.643738977072302e-02*G0_2_0 + 9.029982363315690e-02*G0_2_1 + 9.029982363315697e-02*G0_2_2;
    block[991] = 5.643738977072247e-03*G0_0_0 + 2.821869488536039e-03*G0_0_1 + 2.821869488536053e-03*G0_0_2 + 2.821869488535939e-03*G0_1_0 - 1.693121693121710e-02*G0_1_1 - 1.693121693121705e-02*G0_1_2 + 2.821869488536121e-03*G0_2_0 + 6.772486772486758e-02*G0_2_1 + 6.772486772486749e-02*G0_2_2;
    block[992] = 2.257495590828927e-02*G0_0_0 - 3.386243386243361e-02*G0_0_1 - 3.386243386243361e-02*G0_0_2 + 1.128747795414477e-02*G0_1_0 - 2.257495590828907e-02*G0_1_1 - 2.257495590828907e-02*G0_1_2 - 3.386243386243383e-02*G0_2_0;
    block[993] = 1.354497354497353e-01*G0_0_0 + 1.354497354497353e-01*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 6.772486772486763e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 + 5.643738977072313e-02*G0_1_2 + 1.015873015873015e-01*G0_2_0 + 1.015873015873015e-01*G0_2_1 + 6.772486772486766e-02*G0_2_2;
    block[994] = -2.708994708994704e-01*G0_0_0 - 2.708994708994705e-01*G0_0_1 - 1.777777777777776e-01*G0_0_2 - 8.465608465608447e-02*G0_1_0 - 8.465608465608451e-02*G0_1_1 - 4.232804232804237e-02*G0_1_2 - 1.777777777777777e-01*G0_2_0 - 1.777777777777778e-01*G0_2_1 - 1.693121693121687e-02*G0_2_2;
    block[995] = 1.015873015873015e-01*G0_0_2 + 1.128747795414463e-01*G0_1_0 + 1.128747795414463e-01*G0_1_1 + 1.128747795414471e-02*G0_1_2 + 1.015873015873020e-01*G0_2_0 + 1.015873015873019e-01*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[996] = 1.354497354497352e-01*G0_0_0 + 3.386243386243361e-02*G0_0_2 + 6.772486772486758e-02*G0_1_0 + 2.257495590828911e-02*G0_1_2 + 3.386243386243353e-02*G0_2_0;
    block[997] = -2.708994708994702e-01*G0_0_0 - 9.312169312169269e-02*G0_0_2 - 1.862433862433859e-01*G0_1_0 - 5.079365079365065e-02*G0_1_2 - 9.312169312169241e-02*G0_2_0 + 6.772486772486809e-02*G0_2_2;
    block[998] = -1.015873015873014e-01*G0_0_2 - 1.128747795414464e-01*G0_1_0 - 2.031746031746031e-01*G0_1_2 - 1.015873015873020e-01*G0_2_0 - 2.708994708994710e-01*G0_2_2;
    block[999] = -6.772486772486787e-02*G0_1_1 - 1.128747795414477e-02*G0_1_2 - 1.128747795414476e-02*G0_2_1;
    block[1000] = 8.465608465608496e-02*G0_1_1 + 4.232804232804253e-02*G0_1_2 + 4.232804232804253e-02*G0_2_1 + 2.257495590828913e-02*G0_2_2;
    block[1001] = -1.128747795414464e-01*G0_1_1 - 1.015873015873016e-01*G0_1_2 - 1.015873015873020e-01*G0_2_1 - 1.354497354497356e-01*G0_2_2;
    block[1002] = -1.354497354497353e-01*G0_0_0 - 6.772486772486758e-02*G0_0_1 + 4.514991181657812e-02*G0_0_2 - 6.772486772486777e-02*G0_1_0 + 6.772486772486756e-02*G0_1_2 + 4.514991181657885e-02*G0_2_0 + 6.772486772486799e-02*G0_2_1;
    block[1003] = -2.708994708994705e-01*G0_0_1 - 1.354497354497356e-01*G0_0_2 - 2.708994708994709e-01*G0_1_0 - 5.417989417989415e-01*G0_1_1 - 2.708994708994707e-01*G0_1_2 - 1.354497354497355e-01*G0_2_0 - 2.708994708994705e-01*G0_2_1 + 4.514991181657892e-02*G0_2_2;
    block[1004] = 6.772486772486710e-02*G0_0_1 + 2.257495590828914e-02*G0_0_2 + 6.772486772486774e-02*G0_1_0 + 1.354497354497355e-01*G0_1_1 + 4.514991181657835e-02*G0_1_2 + 2.257495590828919e-02*G0_2_0 + 4.514991181657837e-02*G0_2_1;
    block[1005] = -6.772486772486766e-02*G0_0_1 - 2.257495590828898e-02*G0_0_2 - 6.772486772486767e-02*G0_1_0 - 4.514991181657869e-02*G0_1_2 - 2.257495590828913e-02*G0_2_0 - 4.514991181657826e-02*G0_2_1 - 4.514991181657844e-02*G0_2_2;
    block[1006] = 2.708994708994708e-01*G0_0_1 + 1.354497354497350e-01*G0_0_2 + 2.708994708994707e-01*G0_1_0 + 1.354497354497352e-01*G0_1_2 + 1.354497354497355e-01*G0_2_0 + 1.354497354497351e-01*G0_2_1 + 3.160493827160495e-01*G0_2_2;
    block[1007] = -1.354497354497349e-01*G0_0_0 - 6.772486772486762e-02*G0_0_1 - 1.805996472663133e-01*G0_0_2 - 6.772486772486710e-02*G0_1_0 - 4.514991181657815e-02*G0_1_2 - 1.805996472663139e-01*G0_2_0 - 4.514991181657827e-02*G0_2_1 - 2.257495590828923e-01*G0_2_2;
    block[1008] = 5.417989417989408e-01*G0_0_0 + 2.708994708994705e-01*G0_0_1 + 2.708994708994701e-01*G0_0_2 + 2.708994708994704e-01*G0_1_0 + 5.417989417989415e-01*G0_1_1 + 2.708994708994705e-01*G0_1_2 + 2.708994708994701e-01*G0_2_0 + 2.708994708994706e-01*G0_2_1 + 6.320987654320986e-01*G0_2_2;
    block[1009] = -1.354497354497352e-01*G0_0_0 + 6.772486772486755e-02*G0_0_1 + 9.029982363315661e-02*G0_0_2 - 6.772486772486766e-02*G0_1_0 + 6.772486772486774e-02*G0_1_2 + 9.029982363315729e-02*G0_2_0 - 6.772486772486791e-02*G0_2_1 - 1.354497354497357e-01*G0_2_2;
    block[1010] = -1.354497354497352e-01*G0_0_0 - 2.031746031746025e-01*G0_0_1 - 2.257495590828916e-01*G0_0_2 - 6.772486772486748e-02*G0_1_0 - 1.354497354497350e-01*G0_1_1 - 9.029982363315671e-02*G0_1_2 - 2.257495590828923e-01*G0_2_0 - 3.611992945326279e-01*G0_2_1 - 4.514991181657845e-01*G0_2_2;
    block[1011] = -4.514991181657832e-02*G0_0_0 - 2.257495590828923e-02*G0_0_1 - 2.257495590828920e-02*G0_1_0 - 4.514991181657814e-02*G0_1_2 - 4.514991181657854e-02*G0_2_1 + 4.514991181657816e-02*G0_2_2;
    block[1012] = -4.514991181657835e-02*G0_0_0 - 2.257495590828908e-02*G0_0_1 - 4.514991181657817e-02*G0_0_2 - 2.257495590828917e-02*G0_1_0 - 6.772486772486752e-02*G0_1_2 - 4.514991181657801e-02*G0_2_0 - 6.772486772486741e-02*G0_2_1;
    block[1013] = -4.514991181657831e-02*G0_0_0 - 2.257495590828926e-02*G0_0_1 - 2.257495590828911e-02*G0_0_2 - 2.257495590828934e-02*G0_1_0 - 4.514991181657833e-02*G0_1_2 - 2.257495590828927e-02*G0_2_0 - 4.514991181657847e-02*G0_2_1;
    block[1014] = 2.708994708994703e-01*G0_0_0 + 1.354497354497354e-01*G0_0_1 + 1.354497354497356e-01*G0_0_2 + 1.354497354497351e-01*G0_1_0 + 3.160493827160489e-01*G0_1_2 + 1.354497354497352e-01*G0_2_0 + 3.160493827160493e-01*G0_2_1 - 9.029982363315690e-02*G0_2_2;
    block[1015] = -2.539682539682527e-02*G0_0_0 - 2.539682539682532e-02*G0_0_1 - 2.539682539682528e-02*G0_0_2 - 1.834215167548492e-02*G0_1_0 - 1.834215167548491e-02*G0_1_1 - 1.834215167548491e-02*G0_1_2 - 2.539682539682536e-02*G0_2_0 - 2.539682539682537e-02*G0_2_1 - 2.539682539682536e-02*G0_2_2;
    block[1016] = 4.232804232804233e-02*G0_0_0 - 7.054673721340371e-03*G0_1_0;
    block[1017] = 1.834215167548505e-02*G0_1_1;
    block[1018] = -7.054673721340275e-03*G0_1_2 - 2.539682539682528e-02*G0_2_2;
    block[1019] = -1.354497354497352e-01*G0_0_0 - 1.015873015873014e-01*G0_0_1 - 1.015873015873012e-01*G0_1_0 - 1.128747795414461e-01*G0_1_1;
    block[1020] = 2.257495590828927e-02*G0_0_0 + 4.232804232804241e-02*G0_0_1 + 4.232804232804219e-02*G0_1_0 + 8.465608465608480e-02*G0_1_1;
    block[1021] = -1.128747795414469e-02*G0_0_1 - 1.128747795414457e-02*G0_1_0 - 6.772486772486784e-02*G0_1_1;
    block[1022] = 1.128747795414451e-02*G0_0_1 + 1.128747795414460e-02*G0_1_0 + 1.128747795414462e-02*G0_1_2 + 1.128747795414477e-02*G0_2_1;
    block[1023] = 2.257495590828931e-02*G0_0_0 + 2.821869488536220e-03*G0_0_1 + 2.257495590828925e-02*G0_0_2 + 2.821869488536014e-03*G0_1_0 + 2.821869488535988e-03*G0_1_2 + 2.257495590828905e-02*G0_2_0 + 2.821869488535945e-03*G0_2_1 + 2.257495590828906e-02*G0_2_2;
    block[1024] = 4.514991181657847e-02*G0_0_0 + 1.128747795414455e-02*G0_0_1 + 4.514991181657848e-02*G0_0_2 + 1.128747795414460e-02*G0_1_0 + 1.128747795414462e-02*G0_1_2 + 4.514991181657844e-02*G0_2_0 + 1.128747795414466e-02*G0_2_1 + 4.514991181657838e-02*G0_2_2;
    block[1025] = 6.772486772486745e-02*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.015873015873014e-01*G0_0_2 + 5.643738977072276e-02*G0_1_0 + 6.772486772486758e-02*G0_1_1 + 6.772486772486749e-02*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 1.354497354497352e-01*G0_2_1 + 1.354497354497350e-01*G0_2_2;
    block[1026] = -1.693121693121677e-02*G0_0_0 - 1.777777777777775e-01*G0_0_1 - 1.777777777777775e-01*G0_0_2 - 4.232804232804203e-02*G0_1_0 - 8.465608465608461e-02*G0_1_1 - 8.465608465608455e-02*G0_1_2 - 1.777777777777775e-01*G0_2_0 - 2.708994708994705e-01*G0_2_1 - 2.708994708994705e-01*G0_2_2;
    block[1027] = -6.772486772486763e-02*G0_0_0 + 1.015873015873016e-01*G0_0_1 + 1.015873015873016e-01*G0_0_2 + 1.128747795414459e-02*G0_1_0 + 1.128747795414462e-01*G0_1_1 + 1.128747795414462e-01*G0_1_2 + 1.015873015873015e-01*G0_2_0;
    block[1028] = 9.029982363315688e-02*G0_0_0 + 9.029982363315685e-02*G0_0_1 + 5.643738977072296e-02*G0_0_2 + 2.257495590828925e-02*G0_1_0 + 2.257495590828922e-02*G0_1_1 + 1.128747795414458e-02*G0_1_2 + 5.643738977072305e-02*G0_2_0 + 5.643738977072306e-02*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[1029] = 6.772486772486756e-02*G0_0_0 + 6.772486772486759e-02*G0_0_1 + 2.821869488536299e-03*G0_0_2 - 1.693121693121678e-02*G0_1_0 - 1.693121693121675e-02*G0_1_1 + 2.821869488536114e-03*G0_1_2 + 2.821869488536448e-03*G0_2_0 + 2.821869488536413e-03*G0_2_1 + 5.643738977072270e-03*G0_2_2;
    block[1030] = -3.386243386243397e-02*G0_0_2 - 2.257495590828939e-02*G0_1_0 - 2.257495590828942e-02*G0_1_1 + 1.128747795414457e-02*G0_1_2 - 3.386243386243402e-02*G0_2_0 - 3.386243386243402e-02*G0_2_1 + 2.257495590828923e-02*G0_2_2;
    block[1031] = -2.708994708994704e-01*G0_0_0 - 1.015873015873015e-01*G0_0_2 - 2.031746031746027e-01*G0_1_0 - 1.128747795414461e-01*G0_1_2 - 1.015873015873012e-01*G0_2_0;
    block[1032] = 6.772486772486770e-02*G0_0_0 - 9.312169312169266e-02*G0_0_2 - 5.079365079365075e-02*G0_1_0 - 1.862433862433856e-01*G0_1_2 - 9.312169312169298e-02*G0_2_0 - 2.708994708994701e-01*G0_2_2;
    block[1033] = 3.386243386243353e-02*G0_0_2 + 2.257495590828928e-02*G0_1_0 + 6.772486772486752e-02*G0_1_2 + 3.386243386243391e-02*G0_2_0 + 1.354497354497352e-01*G0_2_2;
    block[1034] = -2.257495590828920e-02*G0_1_1 - 1.128747795414460e-02*G0_1_2 - 1.128747795414453e-02*G0_2_1;
    block[1035] = 1.693121693121662e-02*G0_1_1 + 1.975308641975285e-02*G0_1_2 + 1.975308641975277e-02*G0_2_1 + 2.257495590828921e-02*G0_2_2;
    block[1036] = 2.257495590828919e-02*G0_1_1 + 3.386243386243371e-02*G0_1_2 + 3.386243386243391e-02*G0_2_1 + 4.514991181657831e-02*G0_2_2;
    block[1037] = 4.514991181657926e-02*G0_0_0 - 2.708994708994699e-01*G0_0_1 - 1.354497354497350e-01*G0_0_2 - 2.708994708994699e-01*G0_1_0 - 5.417989417989402e-01*G0_1_1 - 2.708994708994700e-01*G0_1_2 - 1.354497354497352e-01*G0_2_0 - 2.708994708994701e-01*G0_2_1;
    block[1038] = 6.772486772486765e-02*G0_0_1 + 4.514991181657896e-02*G0_0_2 + 6.772486772486704e-02*G0_1_0 - 6.772486772486799e-02*G0_1_2 + 4.514991181657804e-02*G0_2_0 - 6.772486772486781e-02*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[1039] = 4.514991181657876e-02*G0_0_1 + 2.257495590828929e-02*G0_0_2 + 4.514991181657805e-02*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 6.772486772486748e-02*G0_1_2 + 2.257495590828909e-02*G0_2_0 + 6.772486772486740e-02*G0_2_1;
    block[1040] = -4.514991181657829e-02*G0_0_1 - 2.257495590828918e-02*G0_0_2 - 4.514991181657804e-02*G0_1_0 - 2.257495590828879e-02*G0_1_2 - 2.257495590828905e-02*G0_2_0 - 2.257495590828910e-02*G0_2_1 - 4.514991181657829e-02*G0_2_2;
    block[1041] = -6.772486772486729e-02*G0_0_1 - 4.514991181657790e-02*G0_0_2 - 6.772486772486690e-02*G0_1_0 - 2.257495590828932e-02*G0_1_2 - 4.514991181657795e-02*G0_2_0 - 2.257495590828906e-02*G0_2_1 - 4.514991181657853e-02*G0_2_2;
    block[1042] = 4.514991181657809e-02*G0_0_0 - 4.514991181657847e-02*G0_0_1 - 4.514991181657816e-02*G0_1_0 - 2.257495590828893e-02*G0_1_2 - 2.257495590828949e-02*G0_2_1 - 4.514991181657814e-02*G0_2_2;
    block[1043] = -1.354497354497352e-01*G0_0_0 - 6.772486772486769e-02*G0_0_1 + 9.029982363315732e-02*G0_0_2 + 6.772486772486755e-02*G0_1_0 - 6.772486772486792e-02*G0_1_2 + 9.029982363315661e-02*G0_2_0 + 6.772486772486776e-02*G0_2_1 - 1.354497354497357e-01*G0_2_2;
    block[1044] = 6.320987654320978e-01*G0_0_0 + 2.708994708994701e-01*G0_0_1 + 2.708994708994701e-01*G0_0_2 + 2.708994708994701e-01*G0_1_0 + 5.417989417989404e-01*G0_1_1 + 2.708994708994699e-01*G0_1_2 + 2.708994708994701e-01*G0_2_0 + 2.708994708994699e-01*G0_2_1 + 5.417989417989407e-01*G0_2_2;
    block[1045] = -4.514991181657843e-01*G0_0_0 - 3.611992945326276e-01*G0_0_1 - 2.257495590828923e-01*G0_0_2 - 9.029982363315665e-02*G0_1_0 - 1.354497354497348e-01*G0_1_1 - 6.772486772486719e-02*G0_1_2 - 2.257495590828918e-01*G0_2_0 - 2.031746031746022e-01*G0_2_1 - 1.354497354497347e-01*G0_2_2;
    block[1046] = -2.257495590828922e-01*G0_0_0 - 4.514991181657835e-02*G0_0_1 - 1.805996472663138e-01*G0_0_2 - 4.514991181657828e-02*G0_1_0 - 6.772486772486754e-02*G0_1_2 - 1.805996472663135e-01*G0_2_0 - 6.772486772486740e-02*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[1047] = 3.160493827160490e-01*G0_0_0 + 1.354497354497348e-01*G0_0_1 + 1.354497354497349e-01*G0_0_2 + 1.354497354497349e-01*G0_1_0 + 2.708994708994700e-01*G0_1_2 + 1.354497354497350e-01*G0_2_0 + 2.708994708994701e-01*G0_2_1;
    block[1048] = -4.514991181657858e-02*G0_0_0 - 4.514991181657835e-02*G0_0_1 - 2.257495590828925e-02*G0_0_2 - 4.514991181657826e-02*G0_1_0 - 6.772486772486755e-02*G0_1_2 - 2.257495590828904e-02*G0_2_0 - 6.772486772486755e-02*G0_2_1;
    block[1049] = -9.029982363315760e-02*G0_0_0 + 3.160493827160484e-01*G0_0_1 + 1.354497354497346e-01*G0_0_2 + 3.160493827160480e-01*G0_1_0 + 1.354497354497351e-01*G0_1_2 + 1.354497354497348e-01*G0_2_0 + 1.354497354497349e-01*G0_2_1 + 2.708994708994705e-01*G0_2_2;
    block[1050] = 4.232804232804224e-02*G0_0_0 + 4.232804232804230e-02*G0_0_1 + 4.232804232804226e-02*G0_0_2 + 4.938271604938264e-02*G0_1_0 + 4.938271604938266e-02*G0_1_1 + 4.938271604938263e-02*G0_1_2 + 4.232804232804226e-02*G0_2_0 + 4.232804232804228e-02*G0_2_1 + 4.232804232804228e-02*G0_2_2;
    block[1051] = -2.539682539682530e-02*G0_0_0 - 7.054673721340400e-03*G0_1_0;
    block[1052] = 1.834215167548503e-02*G0_1_1;
    block[1053] = -7.054673721340409e-03*G0_1_2 - 2.539682539682530e-02*G0_2_2;
    block[1054] = 4.514991181657843e-02*G0_0_0 + 3.386243386243382e-02*G0_0_1 + 3.386243386243395e-02*G0_1_0 + 2.257495590828927e-02*G0_1_1;
    block[1055] = 2.257495590828906e-02*G0_0_0 + 1.975308641975295e-02*G0_0_1 + 1.975308641975311e-02*G0_1_0 + 1.693121693121696e-02*G0_1_1;
    block[1056] = -1.128747795414451e-02*G0_0_1 - 1.128747795414464e-02*G0_1_0 - 2.257495590828929e-02*G0_1_1;
    block[1057] = 1.128747795414460e-02*G0_0_1 + 1.128747795414461e-02*G0_1_0 - 4.514991181657842e-02*G0_1_1 + 1.128747795414465e-02*G0_1_2 + 1.128747795414477e-02*G0_2_1;
    block[1058] = 2.257495590828928e-02*G0_0_0 - 1.975308641975308e-02*G0_0_1 + 2.257495590828934e-02*G0_0_2 - 1.975308641975309e-02*G0_1_0 + 2.257495590828919e-02*G0_1_1 - 1.975308641975307e-02*G0_1_2 + 2.257495590828927e-02*G0_2_0 - 1.975308641975323e-02*G0_2_1 + 2.257495590828930e-02*G0_2_2;
    block[1059] = -1.354497354497355e-01*G0_0_0 - 3.386243386243384e-02*G0_0_1 - 1.354497354497354e-01*G0_0_2 - 3.386243386243394e-02*G0_1_0 - 4.514991181657845e-02*G0_1_1 - 3.386243386243389e-02*G0_1_2 - 1.354497354497353e-01*G0_2_0 - 3.386243386243378e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1060] = -6.772486772486754e-02*G0_0_0 - 1.693121693121692e-01*G0_0_1 - 1.693121693121691e-01*G0_0_2 - 7.901234567901218e-02*G0_1_0 - 6.772486772486763e-02*G0_1_1 - 6.772486772486765e-02*G0_1_2 - 1.693121693121689e-01*G0_2_0 - 2.708994708994705e-01*G0_2_1 - 2.708994708994704e-01*G0_2_2;
    block[1061] = -1.693121693121693e-02*G0_0_0 + 1.608465608465607e-01*G0_0_1 + 1.608465608465608e-01*G0_0_2 + 2.539682539682537e-02*G0_1_0 + 1.185185185185183e-01*G0_1_1 + 1.185185185185184e-01*G0_1_2 + 1.608465608465604e-01*G0_2_0 + 6.772486772486767e-02*G0_2_1 + 6.772486772486770e-02*G0_2_2;
    block[1062] = 6.772486772486762e-02*G0_0_0 - 3.386243386243402e-02*G0_0_1 - 3.386243386243401e-02*G0_0_2 + 1.128747795414463e-02*G0_1_0 - 2.257495590828945e-02*G0_1_1 - 2.257495590828949e-02*G0_1_2 - 3.386243386243384e-02*G0_2_0;
    block[1063] = -2.708994708994708e-01*G0_0_0 - 2.708994708994708e-01*G0_0_1 - 1.693121693121692e-01*G0_0_2 - 6.772486772486766e-02*G0_1_0 - 6.772486772486778e-02*G0_1_1 - 7.901234567901216e-02*G0_1_2 - 1.693121693121692e-01*G0_2_0 - 1.693121693121691e-01*G0_2_1 - 6.772486772486766e-02*G0_2_2;
    block[1064] = 6.772486772486765e-02*G0_0_0 + 6.772486772486765e-02*G0_0_1 + 1.608465608465607e-01*G0_0_2 + 1.185185185185184e-01*G0_1_0 + 1.185185185185184e-01*G0_1_1 + 2.539682539682521e-02*G0_1_2 + 1.608465608465607e-01*G0_2_0 + 1.608465608465607e-01*G0_2_1 - 1.693121693121687e-02*G0_2_2;
    block[1065] = -3.386243386243372e-02*G0_0_2 - 2.257495590828938e-02*G0_1_0 - 2.257495590828939e-02*G0_1_1 + 1.128747795414474e-02*G0_1_2 - 3.386243386243407e-02*G0_2_0 - 3.386243386243409e-02*G0_2_1 + 6.772486772486756e-02*G0_2_2;
    block[1066] = 9.029982363315690e-02*G0_0_0 + 3.386243386243397e-02*G0_0_2 + 6.772486772486774e-02*G0_1_0 + 2.257495590828936e-02*G0_1_2 + 3.386243386243397e-02*G0_2_0;
    block[1067] = 6.772486772486748e-02*G0_0_0 + 6.490299823633126e-02*G0_0_2 + 8.465608465608411e-02*G0_1_0 + 8.465608465608397e-02*G0_1_2 + 6.490299823633099e-02*G0_2_0 + 6.772486772486705e-02*G0_2_2;
    block[1068] = 3.386243386243400e-02*G0_0_2 + 2.257495590828946e-02*G0_1_0 + 6.772486772486795e-02*G0_1_2 + 3.386243386243421e-02*G0_2_0 + 9.029982363315717e-02*G0_2_2;
    block[1069] = -2.257495590828927e-02*G0_1_1 - 1.128747795414465e-02*G0_1_2 - 1.128747795414447e-02*G0_2_1;
    block[1070] = 1.693121693121720e-02*G0_1_1 + 1.975308641975334e-02*G0_1_2 + 1.975308641975314e-02*G0_2_1 + 2.257495590828943e-02*G0_2_2;
    block[1071] = 2.257495590828942e-02*G0_1_1 + 3.386243386243411e-02*G0_1_2 + 3.386243386243417e-02*G0_2_1 + 4.514991181657872e-02*G0_2_2;
    block[1072] = 4.514991181657800e-02*G0_0_0 + 9.029982363315647e-02*G0_0_1 + 4.514991181657832e-02*G0_0_2 + 9.029982363315614e-02*G0_1_0 + 1.354497354497347e-01*G0_1_1 + 6.772486772486772e-02*G0_1_2 + 4.514991181657799e-02*G0_2_0 + 6.772486772486705e-02*G0_2_1;
    block[1073] = 6.772486772486749e-02*G0_0_1 + 4.514991181657826e-02*G0_0_2 + 6.772486772486783e-02*G0_1_0 + 1.354497354497349e-01*G0_1_1 + 9.029982363315628e-02*G0_1_2 + 4.514991181657878e-02*G0_2_0 + 9.029982363315671e-02*G0_2_1 + 4.514991181657816e-02*G0_2_2;
    block[1074] = 4.514991181657856e-02*G0_0_1 + 2.257495590828930e-02*G0_0_2 + 4.514991181657877e-02*G0_1_0 + 9.029982363315722e-02*G0_1_1 + 4.514991181657863e-02*G0_1_2 + 2.257495590828954e-02*G0_2_0 + 4.514991181657891e-02*G0_2_1;
    block[1075] = -4.514991181657869e-02*G0_0_1 - 2.257495590828941e-02*G0_0_2 - 4.514991181657882e-02*G0_1_0 + 4.514991181657824e-02*G0_1_1 - 2.257495590828958e-02*G0_2_0 - 4.514991181657868e-02*G0_2_2;
    block[1076] = -6.772486772486791e-02*G0_0_1 - 4.514991181657872e-02*G0_0_2 - 6.772486772486797e-02*G0_1_0 - 1.354497354497357e-01*G0_1_1 - 1.805996472663141e-01*G0_1_2 - 4.514991181657887e-02*G0_2_0 - 1.805996472663138e-01*G0_2_1 - 2.257495590828925e-01*G0_2_2;
    block[1077] = 4.514991181657863e-02*G0_0_0 + 3.160493827160492e-01*G0_0_1 + 1.805996472663139e-01*G0_0_2 + 3.160493827160489e-01*G0_1_0 + 4.514991181657854e-02*G0_1_1 + 1.805996472663138e-01*G0_1_2 + 1.805996472663141e-01*G0_2_0 + 1.805996472663138e-01*G0_2_1 + 3.160493827160492e-01*G0_2_2;
    block[1078] = -1.354497354497351e-01*G0_0_0 - 6.772486772486748e-02*G0_0_1 - 2.257495590828923e-01*G0_0_2 - 2.031746031746025e-01*G0_1_0 - 1.354497354497350e-01*G0_1_1 - 3.611992945326278e-01*G0_1_2 - 2.257495590828916e-01*G0_2_0 - 9.029982363315671e-02*G0_2_1 - 4.514991181657845e-01*G0_2_2;
    block[1079] = -4.514991181657843e-01*G0_0_0 - 9.029982363315665e-02*G0_0_1 - 2.257495590828918e-01*G0_0_2 - 3.611992945326275e-01*G0_1_0 - 1.354497354497348e-01*G0_1_1 - 2.031746031746022e-01*G0_1_2 - 2.257495590828923e-01*G0_2_0 - 6.772486772486717e-02*G0_2_1 - 1.354497354497347e-01*G0_2_2;
    block[1080] = 6.320987654320983e-01*G0_0_0 + 3.611992945326273e-01*G0_0_1 + 3.611992945326275e-01*G0_0_2 + 3.611992945326273e-01*G0_1_0 + 6.320987654320979e-01*G0_1_1 + 3.611992945326277e-01*G0_1_2 + 3.611992945326275e-01*G0_2_0 + 3.611992945326277e-01*G0_2_1 + 6.320987654320980e-01*G0_2_2;
    block[1081] = 3.160493827160489e-01*G0_0_0 + 1.805996472663138e-01*G0_0_1 + 1.805996472663137e-01*G0_0_2 + 1.805996472663137e-01*G0_1_0 + 4.514991181657834e-02*G0_1_1 + 3.160493827160489e-01*G0_1_2 + 1.805996472663137e-01*G0_2_0 + 3.160493827160488e-01*G0_2_1 + 4.514991181657865e-02*G0_2_2;
    block[1082] = -2.257495590828919e-01*G0_0_0 - 1.805996472663135e-01*G0_0_1 - 4.514991181657822e-02*G0_0_2 - 1.805996472663137e-01*G0_1_0 - 1.354497354497351e-01*G0_1_1 - 6.772486772486760e-02*G0_1_2 - 4.514991181657844e-02*G0_2_0 - 6.772486772486742e-02*G0_2_1;
    block[1083] = -4.514991181657835e-02*G0_0_0 - 2.257495590828934e-02*G0_0_2 + 4.514991181657860e-02*G0_1_1 - 4.514991181657872e-02*G0_1_2 - 2.257495590828930e-02*G0_2_0 - 4.514991181657858e-02*G0_2_1;
    block[1084] = -9.029982363315646e-02*G0_0_0 - 4.063492063492057e-01*G0_0_1 - 2.257495590828919e-01*G0_0_2 - 4.063492063492052e-01*G0_1_0 - 7.223985890652551e-01*G0_1_1 - 4.063492063492052e-01*G0_1_2 - 2.257495590828922e-01*G0_2_0 - 4.063492063492063e-01*G0_2_1 - 9.029982363315697e-02*G0_2_2;
    block[1085] = 4.232804232804216e-02*G0_0_0 + 4.232804232804222e-02*G0_0_1 + 4.232804232804220e-02*G0_0_2 + 4.232804232804217e-02*G0_1_0 + 4.232804232804220e-02*G0_1_1 + 4.232804232804221e-02*G0_1_2 + 4.938271604938260e-02*G0_2_0 + 4.938271604938261e-02*G0_2_1 + 4.938271604938258e-02*G0_2_2;
    block[1086] = -2.539682539682520e-02*G0_0_0 - 7.054673721340324e-03*G0_2_0;
    block[1087] = -2.539682539682539e-02*G0_1_1 - 7.054673721340336e-03*G0_2_1;
    block[1088] = 1.834215167548491e-02*G0_2_2;
    block[1089] = 9.029982363315657e-02*G0_0_0 + 3.386243386243387e-02*G0_0_1 + 3.386243386243357e-02*G0_1_0 + 6.772486772486747e-02*G0_2_0 + 2.257495590828925e-02*G0_2_1;
    block[1090] = 6.772486772486734e-02*G0_0_0 + 6.490299823633093e-02*G0_0_1 + 6.490299823633122e-02*G0_1_0 + 6.772486772486709e-02*G0_1_1 + 8.465608465608421e-02*G0_2_0 + 8.465608465608400e-02*G0_2_1;
    block[1091] = 3.386243386243399e-02*G0_0_1 + 3.386243386243414e-02*G0_1_0 + 9.029982363315724e-02*G0_1_1 + 2.257495590828944e-02*G0_2_0 + 6.772486772486783e-02*G0_2_1;
    block[1092] = -3.386243386243384e-02*G0_0_1 - 3.386243386243423e-02*G0_1_0 + 6.772486772486770e-02*G0_1_1 - 3.386243386243424e-02*G0_1_2 - 2.257495590828952e-02*G0_2_0 + 1.128747795414447e-02*G0_2_1 - 2.257495590828948e-02*G0_2_2;
    block[1093] = 6.772486772486747e-02*G0_0_0 + 1.608465608465603e-01*G0_0_1 + 6.772486772486749e-02*G0_0_2 + 1.608465608465608e-01*G0_1_0 - 1.693121693121717e-02*G0_1_1 + 1.608465608465609e-01*G0_1_2 + 1.185185185185183e-01*G0_2_0 + 2.539682539682525e-02*G0_2_1 + 1.185185185185184e-01*G0_2_2;
    block[1094] = -2.708994708994702e-01*G0_0_0 - 1.693121693121688e-01*G0_0_1 - 2.708994708994703e-01*G0_0_2 - 1.693121693121691e-01*G0_1_0 - 6.772486772486738e-02*G0_1_1 - 1.693121693121691e-01*G0_1_2 - 6.772486772486754e-02*G0_2_0 - 7.901234567901214e-02*G0_2_1 - 6.772486772486755e-02*G0_2_2;
    block[1095] = -6.772486772486744e-02*G0_0_0 - 1.693121693121689e-01*G0_0_1 - 1.693121693121690e-01*G0_0_2 - 1.693121693121687e-01*G0_1_0 - 2.708994708994705e-01*G0_1_1 - 2.708994708994705e-01*G0_1_2 - 7.901234567901212e-02*G0_2_0 - 6.772486772486760e-02*G0_2_1 - 6.772486772486756e-02*G0_2_2;
    block[1096] = -1.693121693121684e-02*G0_0_0 + 1.608465608465607e-01*G0_0_1 + 1.608465608465607e-01*G0_0_2 + 1.608465608465603e-01*G0_1_0 + 6.772486772486756e-02*G0_1_1 + 6.772486772486755e-02*G0_1_2 + 2.539682539682543e-02*G0_2_0 + 1.185185185185182e-01*G0_2_1 + 1.185185185185182e-01*G0_2_2;
    block[1097] = 6.772486772486744e-02*G0_0_0 - 3.386243386243405e-02*G0_0_1 - 3.386243386243401e-02*G0_0_2 - 3.386243386243398e-02*G0_1_0 + 1.128747795414445e-02*G0_2_0 - 2.257495590828939e-02*G0_2_1 - 2.257495590828937e-02*G0_2_2;
    block[1098] = -1.354497354497353e-01*G0_0_0 - 1.354497354497353e-01*G0_0_1 - 3.386243386243380e-02*G0_0_2 - 1.354497354497355e-01*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 3.386243386243377e-02*G0_1_2 - 3.386243386243382e-02*G0_2_0 - 3.386243386243389e-02*G0_2_1 - 4.514991181657836e-02*G0_2_2;
    block[1099] = 2.257495590828922e-02*G0_0_0 + 2.257495590828923e-02*G0_0_1 - 1.975308641975310e-02*G0_0_2 + 2.257495590828925e-02*G0_1_0 + 2.257495590828921e-02*G0_1_1 - 1.975308641975309e-02*G0_1_2 - 1.975308641975311e-02*G0_2_0 - 1.975308641975312e-02*G0_2_1 + 2.257495590828908e-02*G0_2_2;
    block[1100] = 1.128747795414461e-02*G0_0_2 + 1.128747795414459e-02*G0_1_2 + 1.128747795414470e-02*G0_2_0 + 1.128747795414472e-02*G0_2_1 - 4.514991181657829e-02*G0_2_2;
    block[1101] = 4.514991181657847e-02*G0_0_0 + 3.386243386243396e-02*G0_0_2 + 3.386243386243382e-02*G0_2_0 + 2.257495590828930e-02*G0_2_2;
    block[1102] = 2.257495590828910e-02*G0_0_0 + 1.975308641975301e-02*G0_0_2 + 1.975308641975310e-02*G0_2_0 + 1.693121693121684e-02*G0_2_2;
    block[1103] = -1.128747795414448e-02*G0_0_2 - 1.128747795414469e-02*G0_2_0 - 2.257495590828917e-02*G0_2_2;
    block[1104] = 4.514991181657869e-02*G0_1_1 + 3.386243386243416e-02*G0_1_2 + 3.386243386243391e-02*G0_2_1 + 2.257495590828944e-02*G0_2_2;
    block[1105] = 2.257495590828918e-02*G0_1_1 + 1.975308641975305e-02*G0_1_2 + 1.975308641975327e-02*G0_2_1 + 1.693121693121699e-02*G0_2_2;
    block[1106] = -1.128747795414453e-02*G0_1_2 - 1.128747795414469e-02*G0_2_1 - 2.257495590828918e-02*G0_2_2;
    block[1107] = 4.514991181657794e-02*G0_0_0 + 4.514991181657824e-02*G0_0_1 + 9.029982363315628e-02*G0_0_2 + 4.514991181657822e-02*G0_1_0 + 6.772486772486713e-02*G0_1_2 + 9.029982363315614e-02*G0_2_0 + 6.772486772486747e-02*G0_2_1 + 1.354497354497347e-01*G0_2_2;
    block[1108] = 2.257495590828919e-02*G0_0_1 + 4.514991181657820e-02*G0_0_2 + 2.257495590828916e-02*G0_1_0 + 4.514991181657835e-02*G0_1_2 + 4.514991181657822e-02*G0_2_0 + 4.514991181657808e-02*G0_2_1 + 9.029982363315647e-02*G0_2_2;
    block[1109] = 4.514991181657816e-02*G0_0_1 + 6.772486772486751e-02*G0_0_2 + 4.514991181657881e-02*G0_1_0 + 4.514991181657851e-02*G0_1_1 + 9.029982363315701e-02*G0_1_2 + 6.772486772486798e-02*G0_2_0 + 9.029982363315663e-02*G0_2_1 + 1.354497354497353e-01*G0_2_2;
    block[1110] = -4.514991181657841e-02*G0_0_1 - 6.772486772486740e-02*G0_0_2 - 4.514991181657884e-02*G0_1_0 - 2.257495590828927e-01*G0_1_1 - 1.805996472663139e-01*G0_1_2 - 6.772486772486802e-02*G0_2_0 - 1.805996472663139e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1111] = -2.257495590828928e-02*G0_0_1 - 4.514991181657863e-02*G0_0_2 - 2.257495590828922e-02*G0_1_0 - 4.514991181657843e-02*G0_1_1 - 4.514991181657832e-02*G0_2_0 + 4.514991181657822e-02*G0_2_2;
    block[1112] = 4.514991181657823e-02*G0_0_0 + 1.805996472663135e-01*G0_0_1 + 3.160493827160487e-01*G0_0_2 + 1.805996472663140e-01*G0_1_0 + 3.160493827160492e-01*G0_1_1 + 1.805996472663138e-01*G0_1_2 + 3.160493827160487e-01*G0_2_0 + 1.805996472663138e-01*G0_2_1 + 4.514991181657841e-02*G0_2_2;
    block[1113] = -4.514991181657831e-02*G0_0_0 - 2.257495590828920e-02*G0_0_1 - 2.257495590828924e-02*G0_1_0 - 4.514991181657854e-02*G0_1_2 - 4.514991181657814e-02*G0_2_1 + 4.514991181657816e-02*G0_2_2;
    block[1114] = -2.257495590828922e-01*G0_0_0 - 4.514991181657827e-02*G0_0_1 - 1.805996472663136e-01*G0_0_2 - 4.514991181657835e-02*G0_1_0 - 6.772486772486740e-02*G0_1_2 - 1.805996472663138e-01*G0_2_0 - 6.772486772486754e-02*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[1115] = 3.160493827160489e-01*G0_0_0 + 1.805996472663137e-01*G0_0_1 + 1.805996472663137e-01*G0_0_2 + 1.805996472663138e-01*G0_1_0 + 4.514991181657838e-02*G0_1_1 + 3.160493827160488e-01*G0_1_2 + 1.805996472663137e-01*G0_2_0 + 3.160493827160489e-01*G0_2_1 + 4.514991181657865e-02*G0_2_2;
    block[1116] = 6.320987654320971e-01*G0_0_0 + 3.611992945326268e-01*G0_0_1 + 3.611992945326267e-01*G0_0_2 + 3.611992945326268e-01*G0_1_0 + 6.320987654320981e-01*G0_1_1 + 3.611992945326271e-01*G0_1_2 + 3.611992945326267e-01*G0_2_0 + 3.611992945326271e-01*G0_2_1 + 6.320987654320972e-01*G0_2_2;
    block[1117] = -4.514991181657833e-01*G0_0_0 - 2.257495590828915e-01*G0_0_1 - 9.029982363315618e-02*G0_0_2 - 2.257495590828913e-01*G0_1_0 - 1.354497354497346e-01*G0_1_1 - 6.772486772486706e-02*G0_1_2 - 3.611992945326268e-01*G0_2_0 - 2.031746031746022e-01*G0_2_1 - 1.354497354497346e-01*G0_2_2;
    block[1118] = -1.354497354497348e-01*G0_0_0 - 2.257495590828917e-01*G0_0_1 - 6.772486772486754e-02*G0_0_2 - 2.257495590828920e-01*G0_1_0 - 4.514991181657843e-01*G0_1_1 - 9.029982363315685e-02*G0_1_2 - 2.031746031746024e-01*G0_2_0 - 3.611992945326273e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1119] = -9.029982363315600e-02*G0_0_0 - 2.257495590828917e-01*G0_0_1 - 4.063492063492049e-01*G0_0_2 - 2.257495590828923e-01*G0_1_0 - 9.029982363315664e-02*G0_1_1 - 4.063492063492055e-01*G0_1_2 - 4.063492063492049e-01*G0_2_0 - 4.063492063492056e-01*G0_2_1 - 7.223985890652539e-01*G0_2_2;
    block[1120] = -2.539682539682519e-02*G0_0_0 - 2.539682539682523e-02*G0_0_1 - 2.539682539682522e-02*G0_0_2 - 2.539682539682529e-02*G0_1_0 - 2.539682539682533e-02*G0_1_1 - 2.539682539682529e-02*G0_1_2 - 1.834215167548484e-02*G0_2_0 - 1.834215167548486e-02*G0_2_1 - 1.834215167548483e-02*G0_2_2;
    block[1121] = 4.232804232804225e-02*G0_0_0 - 7.054673721340395e-03*G0_2_0;
    block[1122] = -2.539682539682547e-02*G0_1_1 - 7.054673721340326e-03*G0_2_1;
    block[1123] = 1.834215167548504e-02*G0_2_2;
    block[1124] = -2.708994708994700e-01*G0_0_0 - 1.015873015873012e-01*G0_0_1 - 1.015873015873010e-01*G0_1_0 - 2.031746031746022e-01*G0_2_0 - 1.128747795414459e-01*G0_2_1;
    block[1125] = 6.772486772486770e-02*G0_0_0 - 9.312169312169240e-02*G0_0_1 - 9.312169312169309e-02*G0_1_0 - 2.708994708994704e-01*G0_1_1 - 5.079365079365080e-02*G0_2_0 - 1.862433862433855e-01*G0_2_1;
    block[1126] = 3.386243386243368e-02*G0_0_1 + 3.386243386243380e-02*G0_1_0 + 1.354497354497353e-01*G0_1_1 + 2.257495590828923e-02*G0_2_0 + 6.772486772486738e-02*G0_2_1;
    block[1127] = -3.386243386243385e-02*G0_0_1 - 3.386243386243377e-02*G0_1_0 + 2.257495590828949e-02*G0_1_1 - 3.386243386243378e-02*G0_1_2 - 2.257495590828918e-02*G0_2_0 + 1.128747795414461e-02*G0_2_1 - 2.257495590828913e-02*G0_2_2;
    block[1128] = 6.772486772486792e-02*G0_0_0 + 2.821869488536346e-03*G0_0_1 + 6.772486772486787e-02*G0_0_2 + 2.821869488536178e-03*G0_1_0 + 5.643738977072064e-03*G0_1_1 + 2.821869488536138e-03*G0_1_2 - 1.693121693121685e-02*G0_2_0 + 2.821869488536232e-03*G0_2_1 - 1.693121693121694e-02*G0_2_2;
    block[1129] = 9.029982363315646e-02*G0_0_0 + 5.643738977072279e-02*G0_0_1 + 9.029982363315650e-02*G0_0_2 + 5.643738977072285e-02*G0_1_0 + 2.257495590828921e-02*G0_1_1 + 5.643738977072275e-02*G0_1_2 + 2.257495590828903e-02*G0_2_0 + 1.128747795414437e-02*G0_2_1 + 2.257495590828903e-02*G0_2_2;
    block[1130] = 6.772486772486733e-02*G0_0_0 + 1.015873015873011e-01*G0_0_1 + 1.015873015873011e-01*G0_0_2 + 1.015873015873012e-01*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 1.354497354497349e-01*G0_1_2 + 5.643738977072264e-02*G0_2_0 + 6.772486772486744e-02*G0_2_1 + 6.772486772486737e-02*G0_2_2;
    block[1131] = -1.693121693121678e-02*G0_0_0 - 1.777777777777773e-01*G0_0_1 - 1.777777777777773e-01*G0_0_2 - 1.777777777777774e-01*G0_1_0 - 2.708994708994703e-01*G0_1_1 - 2.708994708994703e-01*G0_1_2 - 4.232804232804196e-02*G0_2_0 - 8.465608465608437e-02*G0_2_1 - 8.465608465608435e-02*G0_2_2;
    block[1132] = -6.772486772486763e-02*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.015873015873014e-01*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 1.128747795414454e-02*G0_2_0 + 1.128747795414460e-01*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[1133] = 4.514991181657829e-02*G0_0_0 + 4.514991181657827e-02*G0_0_1 + 1.128747795414451e-02*G0_0_2 + 4.514991181657836e-02*G0_1_0 + 4.514991181657844e-02*G0_1_1 + 1.128747795414453e-02*G0_1_2 + 1.128747795414459e-02*G0_2_0 + 1.128747795414462e-02*G0_2_1;
    block[1134] = 2.257495590828919e-02*G0_0_0 + 2.257495590828921e-02*G0_0_1 + 2.821869488536269e-03*G0_0_2 + 2.257495590828914e-02*G0_1_0 + 2.257495590828914e-02*G0_1_1 + 2.821869488536190e-03*G0_1_2 + 2.821869488535975e-03*G0_2_0 + 2.821869488536032e-03*G0_2_1;
    block[1135] = 1.128747795414445e-02*G0_0_2 + 1.128747795414462e-02*G0_1_2 + 1.128747795414467e-02*G0_2_0 + 1.128747795414468e-02*G0_2_1;
    block[1136] = -1.354497354497352e-01*G0_0_0 - 1.015873015873013e-01*G0_0_2 - 1.015873015873013e-01*G0_2_0 - 1.128747795414458e-01*G0_2_2;
    block[1137] = 2.257495590828916e-02*G0_0_0 + 4.232804232804218e-02*G0_0_2 + 4.232804232804220e-02*G0_2_0 + 8.465608465608451e-02*G0_2_2;
    block[1138] = -1.128747795414467e-02*G0_0_2 - 1.128747795414475e-02*G0_2_0 - 6.772486772486773e-02*G0_2_2;
    block[1139] = 4.514991181657847e-02*G0_1_1 + 3.386243386243382e-02*G0_1_2 + 3.386243386243365e-02*G0_2_1 + 2.257495590828919e-02*G0_2_2;
    block[1140] = 2.257495590828920e-02*G0_1_1 + 1.975308641975316e-02*G0_1_2 + 1.975308641975317e-02*G0_2_1 + 1.693121693121696e-02*G0_2_2;
    block[1141] = -1.128747795414474e-02*G0_1_2 - 1.128747795414478e-02*G0_2_1 - 2.257495590828937e-02*G0_2_2;
    block[1142] = 4.514991181657926e-02*G0_0_0 - 1.354497354497348e-01*G0_0_1 - 2.708994708994694e-01*G0_0_2 - 1.354497354497352e-01*G0_1_0 - 2.708994708994700e-01*G0_1_2 - 2.708994708994700e-01*G0_2_0 - 2.708994708994698e-01*G0_2_1 - 5.417989417989398e-01*G0_2_2;
    block[1143] = 2.257495590828915e-02*G0_0_1 + 4.514991181657867e-02*G0_0_2 + 2.257495590828914e-02*G0_1_0 + 6.772486772486751e-02*G0_1_2 + 4.514991181657830e-02*G0_2_0 + 6.772486772486744e-02*G0_2_1 + 1.354497354497350e-01*G0_2_2;
    block[1144] = 4.514991181657918e-02*G0_0_1 + 6.772486772486795e-02*G0_0_2 + 4.514991181657846e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 6.772486772486784e-02*G0_1_2 + 6.772486772486741e-02*G0_2_0 - 6.772486772486759e-02*G0_2_1;
    block[1145] = -4.514991181657860e-02*G0_0_1 - 6.772486772486794e-02*G0_0_2 - 4.514991181657842e-02*G0_1_0 - 4.514991181657863e-02*G0_1_1 - 2.257495590828925e-02*G0_1_2 - 6.772486772486740e-02*G0_2_0 - 2.257495590828933e-02*G0_2_1;
    block[1146] = -2.257495590828915e-02*G0_0_1 - 4.514991181657810e-02*G0_0_2 - 2.257495590828914e-02*G0_1_0 - 4.514991181657837e-02*G0_1_1 - 2.257495590828917e-02*G0_1_2 - 4.514991181657824e-02*G0_2_0 - 2.257495590828904e-02*G0_2_1;
    block[1147] = 4.514991181657856e-02*G0_0_0 - 4.514991181657815e-02*G0_0_2 - 4.514991181657831e-02*G0_1_1 - 2.257495590828896e-02*G0_1_2 - 4.514991181657828e-02*G0_2_0 - 2.257495590828891e-02*G0_2_1;
    block[1148] = -4.514991181657835e-02*G0_0_0 - 2.257495590828917e-02*G0_0_1 - 4.514991181657803e-02*G0_0_2 - 2.257495590828908e-02*G0_1_0 - 6.772486772486741e-02*G0_1_2 - 4.514991181657817e-02*G0_2_0 - 6.772486772486751e-02*G0_2_1;
    block[1149] = 3.160493827160490e-01*G0_0_0 + 1.354497354497350e-01*G0_0_1 + 1.354497354497350e-01*G0_0_2 + 1.354497354497348e-01*G0_1_0 + 2.708994708994701e-01*G0_1_2 + 1.354497354497349e-01*G0_2_0 + 2.708994708994700e-01*G0_2_1;
    block[1150] = -2.257495590828919e-01*G0_0_0 - 1.805996472663138e-01*G0_0_1 - 4.514991181657844e-02*G0_0_2 - 1.805996472663134e-01*G0_1_0 - 1.354497354497351e-01*G0_1_1 - 6.772486772486742e-02*G0_1_2 - 4.514991181657822e-02*G0_2_0 - 6.772486772486760e-02*G0_2_1;
    block[1151] = -4.514991181657834e-01*G0_0_0 - 2.257495590828913e-01*G0_0_1 - 3.611992945326267e-01*G0_0_2 - 2.257495590828915e-01*G0_1_0 - 1.354497354497346e-01*G0_1_1 - 2.031746031746021e-01*G0_1_2 - 9.029982363315617e-02*G0_2_0 - 6.772486772486706e-02*G0_2_1 - 1.354497354497346e-01*G0_2_2;
    block[1152] = 6.320987654320971e-01*G0_0_0 + 2.708994708994695e-01*G0_0_1 + 2.708994708994694e-01*G0_0_2 + 2.708994708994695e-01*G0_1_0 + 5.417989417989406e-01*G0_1_1 + 2.708994708994699e-01*G0_1_2 + 2.708994708994694e-01*G0_2_0 + 2.708994708994698e-01*G0_2_1 + 5.417989417989398e-01*G0_2_2;
    block[1153] = -1.354497354497357e-01*G0_0_0 + 9.029982363315645e-02*G0_0_1 - 6.772486772486791e-02*G0_0_2 + 9.029982363315688e-02*G0_1_0 - 1.354497354497358e-01*G0_1_1 + 6.772486772486802e-02*G0_1_2 + 6.772486772486756e-02*G0_2_0 - 6.772486772486778e-02*G0_2_1;
    block[1154] = -9.029982363315792e-02*G0_0_0 + 1.354497354497345e-01*G0_0_1 + 3.160493827160475e-01*G0_0_2 + 1.354497354497349e-01*G0_1_0 + 2.708994708994708e-01*G0_1_1 + 1.354497354497347e-01*G0_1_2 + 3.160493827160482e-01*G0_2_0 + 1.354497354497349e-01*G0_2_1;
    block[1155] = -2.539682539682536e-02*G0_0_0 - 2.539682539682538e-02*G0_0_1 - 2.539682539682536e-02*G0_0_2 - 2.539682539682531e-02*G0_1_0 - 2.539682539682530e-02*G0_1_1 - 2.539682539682531e-02*G0_1_2 - 1.834215167548503e-02*G0_2_0 - 1.834215167548504e-02*G0_2_1 - 1.834215167548501e-02*G0_2_2;
    block[1156] = -2.539682539682549e-02*G0_0_0 - 7.054673721340517e-03*G0_2_0;
    block[1157] = 4.232804232804237e-02*G0_1_1 - 7.054673721340372e-03*G0_2_1;
    block[1158] = 1.834215167548494e-02*G0_2_2;
    block[1159] = 1.354497354497352e-01*G0_0_0 + 3.386243386243363e-02*G0_0_1 + 3.386243386243384e-02*G0_1_0 + 6.772486772486788e-02*G0_2_0 + 2.257495590828924e-02*G0_2_1;
    block[1160] = -2.708994708994701e-01*G0_0_0 - 9.312169312169279e-02*G0_0_1 - 9.312169312169262e-02*G0_1_0 + 6.772486772486817e-02*G0_1_1 - 1.862433862433862e-01*G0_2_0 - 5.079365079365085e-02*G0_2_1;
    block[1161] = -1.015873015873016e-01*G0_0_1 - 1.015873015873017e-01*G0_1_0 - 2.708994708994710e-01*G0_1_1 - 1.128747795414457e-01*G0_2_0 - 2.031746031746026e-01*G0_2_1;
    block[1162] = 1.015873015873016e-01*G0_0_1 + 1.015873015873019e-01*G0_1_0 - 6.772486772486772e-02*G0_1_1 + 1.015873015873019e-01*G0_1_2 + 1.128747795414458e-01*G0_2_0 + 1.128747795414470e-02*G0_2_1 + 1.128747795414458e-01*G0_2_2;
    block[1163] = -2.708994708994706e-01*G0_0_0 - 1.777777777777775e-01*G0_0_1 - 2.708994708994706e-01*G0_0_2 - 1.777777777777778e-01*G0_1_0 - 1.693121693121656e-02*G0_1_1 - 1.777777777777778e-01*G0_1_2 - 8.465608465608457e-02*G0_2_0 - 4.232804232804228e-02*G0_2_1 - 8.465608465608457e-02*G0_2_2;
    block[1164] = 1.354497354497353e-01*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.354497354497353e-01*G0_0_2 + 1.015873015873015e-01*G0_1_0 + 6.772486772486740e-02*G0_1_1 + 1.015873015873016e-01*G0_1_2 + 6.772486772486759e-02*G0_2_0 + 5.643738977072305e-02*G0_2_1 + 6.772486772486759e-02*G0_2_2;
    block[1165] = 2.257495590828919e-02*G0_0_0 + 5.643738977072317e-02*G0_0_1 + 5.643738977072313e-02*G0_0_2 + 5.643738977072288e-02*G0_1_0 + 9.029982363315700e-02*G0_1_1 + 9.029982363315703e-02*G0_1_2 + 1.128747795414464e-02*G0_2_0 + 2.257495590828922e-02*G0_2_1 + 2.257495590828927e-02*G0_2_2;
    block[1166] = 5.643738977072184e-03*G0_0_0 + 2.821869488536045e-03*G0_0_1 + 2.821869488536042e-03*G0_0_2 + 2.821869488536133e-03*G0_1_0 + 6.772486772486765e-02*G0_1_1 + 6.772486772486765e-02*G0_1_2 + 2.821869488536083e-03*G0_2_0 - 1.693121693121698e-02*G0_2_1 - 1.693121693121705e-02*G0_2_2;
    block[1167] = 2.257495590828945e-02*G0_0_0 - 3.386243386243368e-02*G0_0_1 - 3.386243386243366e-02*G0_0_2 - 3.386243386243364e-02*G0_1_0 + 1.128747795414479e-02*G0_2_0 - 2.257495590828928e-02*G0_2_1 - 2.257495590828924e-02*G0_2_2;
    block[1168] = 4.514991181657850e-02*G0_0_0 + 4.514991181657851e-02*G0_0_1 + 1.128747795414451e-02*G0_0_2 + 4.514991181657859e-02*G0_1_0 + 4.514991181657848e-02*G0_1_1 + 1.128747795414458e-02*G0_1_2 + 1.128747795414468e-02*G0_2_0 + 1.128747795414469e-02*G0_2_1;
    block[1169] = 2.257495590828914e-02*G0_0_0 + 2.257495590828917e-02*G0_0_1 + 2.821869488536259e-03*G0_0_2 + 2.257495590828929e-02*G0_1_0 + 2.257495590828934e-02*G0_1_1 + 2.821869488536243e-03*G0_1_2 + 2.821869488536122e-03*G0_2_0 + 2.821869488536108e-03*G0_2_1;
    block[1170] = 1.128747795414465e-02*G0_0_2 + 1.128747795414454e-02*G0_1_2 + 1.128747795414464e-02*G0_2_0 + 1.128747795414467e-02*G0_2_1;
    block[1171] = 4.514991181657844e-02*G0_0_0 + 3.386243386243365e-02*G0_0_2 + 3.386243386243393e-02*G0_2_0 + 2.257495590828922e-02*G0_2_2;
    block[1172] = 2.257495590828917e-02*G0_0_0 + 1.975308641975304e-02*G0_0_2 + 1.975308641975299e-02*G0_2_0 + 1.693121693121680e-02*G0_2_2;
    block[1173] = -1.128747795414461e-02*G0_0_2 - 1.128747795414466e-02*G0_2_0 - 2.257495590828916e-02*G0_2_2;
    block[1174] = -1.354497354497356e-01*G0_1_1 - 1.015873015873018e-01*G0_1_2 - 1.015873015873012e-01*G0_2_1 - 1.128747795414457e-01*G0_2_2;
    block[1175] = 2.257495590828938e-02*G0_1_1 + 4.232804232804237e-02*G0_1_2 + 4.232804232804226e-02*G0_2_1 + 8.465608465608442e-02*G0_2_2;
    block[1176] = -1.128747795414463e-02*G0_1_2 - 1.128747795414464e-02*G0_2_1 - 6.772486772486751e-02*G0_2_2;
    block[1177] = -1.354497354497354e-01*G0_0_0 + 4.514991181657835e-02*G0_0_1 - 6.772486772486758e-02*G0_0_2 + 4.514991181657872e-02*G0_1_0 + 6.772486772486798e-02*G0_1_2 - 6.772486772486802e-02*G0_2_0 + 6.772486772486783e-02*G0_2_1;
    block[1178] = 2.257495590828941e-02*G0_0_1 + 6.772486772486770e-02*G0_0_2 + 2.257495590828944e-02*G0_1_0 + 4.514991181657874e-02*G0_1_2 + 6.772486772486765e-02*G0_2_0 + 4.514991181657842e-02*G0_2_1 + 1.354497354497350e-01*G0_2_2;
    block[1179] = -1.354497354497355e-01*G0_0_1 - 2.708994708994709e-01*G0_0_2 - 1.354497354497355e-01*G0_1_0 + 4.514991181657891e-02*G0_1_1 - 2.708994708994706e-01*G0_1_2 - 2.708994708994703e-01*G0_2_0 - 2.708994708994710e-01*G0_2_1 - 5.417989417989411e-01*G0_2_2;
    block[1180] = 1.354497354497354e-01*G0_0_1 + 2.708994708994705e-01*G0_0_2 + 1.354497354497354e-01*G0_1_0 + 3.160493827160497e-01*G0_1_1 + 1.354497354497354e-01*G0_1_2 + 2.708994708994704e-01*G0_2_0 + 1.354497354497350e-01*G0_2_1;
    block[1181] = -2.257495590828931e-02*G0_0_1 - 6.772486772486780e-02*G0_0_2 - 2.257495590828940e-02*G0_1_0 - 4.514991181657869e-02*G0_1_1 - 4.514991181657835e-02*G0_1_2 - 6.772486772486763e-02*G0_2_0 - 4.514991181657844e-02*G0_2_1;
    block[1182] = -1.354497354497352e-01*G0_0_0 - 1.805996472663136e-01*G0_0_1 - 6.772486772486754e-02*G0_0_2 - 1.805996472663139e-01*G0_1_0 - 2.257495590828924e-01*G0_1_1 - 4.514991181657853e-02*G0_1_2 - 6.772486772486780e-02*G0_2_0 - 4.514991181657843e-02*G0_2_1;
    block[1183] = -4.514991181657831e-02*G0_0_0 - 2.257495590828934e-02*G0_0_1 - 2.257495590828927e-02*G0_0_2 - 2.257495590828927e-02*G0_1_0 - 4.514991181657847e-02*G0_1_2 - 2.257495590828911e-02*G0_2_0 - 4.514991181657833e-02*G0_2_1;
    block[1184] = -4.514991181657858e-02*G0_0_0 - 4.514991181657826e-02*G0_0_1 - 2.257495590828904e-02*G0_0_2 - 4.514991181657833e-02*G0_1_0 - 6.772486772486755e-02*G0_1_2 - 2.257495590828925e-02*G0_2_0 - 6.772486772486756e-02*G0_2_1;
    block[1185] = -4.514991181657836e-02*G0_0_0 - 2.257495590828930e-02*G0_0_2 + 4.514991181657860e-02*G0_1_1 - 4.514991181657858e-02*G0_1_2 - 2.257495590828934e-02*G0_2_0 - 4.514991181657872e-02*G0_2_1;
    block[1186] = -1.354497354497348e-01*G0_0_0 - 2.257495590828920e-01*G0_0_1 - 2.031746031746024e-01*G0_0_2 - 2.257495590828917e-01*G0_1_0 - 4.514991181657843e-01*G0_1_1 - 3.611992945326273e-01*G0_1_2 - 6.772486772486755e-02*G0_2_0 - 9.029982363315685e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1187] = -1.354497354497357e-01*G0_0_0 + 9.029982363315688e-02*G0_0_1 + 6.772486772486755e-02*G0_0_2 + 9.029982363315647e-02*G0_1_0 - 1.354497354497358e-01*G0_1_1 - 6.772486772486778e-02*G0_1_2 - 6.772486772486791e-02*G0_2_0 + 6.772486772486802e-02*G0_2_1;
    block[1188] = 5.417989417989411e-01*G0_0_0 + 2.708994708994704e-01*G0_0_1 + 2.708994708994709e-01*G0_0_2 + 2.708994708994704e-01*G0_1_0 + 6.320987654320984e-01*G0_1_1 + 2.708994708994701e-01*G0_1_2 + 2.708994708994709e-01*G0_2_0 + 2.708994708994701e-01*G0_2_1 + 5.417989417989407e-01*G0_2_2;
    block[1189] = 2.708994708994706e-01*G0_0_0 + 1.354497354497354e-01*G0_0_1 + 1.354497354497349e-01*G0_0_2 + 1.354497354497352e-01*G0_1_0 - 9.029982363315787e-02*G0_1_1 + 3.160493827160484e-01*G0_1_2 + 1.354497354497358e-01*G0_2_0 + 3.160493827160494e-01*G0_2_1;
    block[1190] = -6.772486772486758e-02*G0_0_0 - 6.772486772486756e-02*G0_0_1 - 6.772486772486755e-02*G0_0_2 - 6.772486772486759e-02*G0_1_0 - 6.772486772486766e-02*G0_1_1 - 6.772486772486759e-02*G0_1_2 - 6.772486772486760e-02*G0_2_0 - 6.772486772486760e-02*G0_2_1 - 6.772486772486760e-02*G0_2_2;
    block[1191] = -6.772486772486767e-02*G0_0_0;
    block[1192] = -6.772486772486780e-02*G0_1_1;
    block[1193] = -6.772486772486759e-02*G0_2_2;
    block[1194] = 9.029982363315717e-02*G0_0_0;
    block[1195] = -1.354497354497352e-01*G0_0_0 - 1.128747795414459e-01*G0_0_1 - 1.128747795414465e-01*G0_1_0 - 1.354497354497357e-01*G0_1_1;
    block[1196] = 9.029982363315750e-02*G0_1_1;
    block[1197] = 9.029982363315700e-02*G0_1_1;
    block[1198] = -1.354497354497356e-01*G0_0_0 - 2.257495590828904e-02*G0_0_1 - 1.354497354497356e-01*G0_0_2 - 2.257495590828905e-02*G0_1_0 - 4.514991181657839e-02*G0_1_1 - 2.257495590828904e-02*G0_1_2 - 1.354497354497352e-01*G0_2_0 - 2.257495590828897e-02*G0_2_1 - 1.354497354497352e-01*G0_2_2;
    block[1199] = 9.029982363315697e-02*G0_0_0 + 9.029982363315663e-02*G0_0_1 + 9.029982363315690e-02*G0_0_2 + 9.029982363315685e-02*G0_1_0 + 9.029982363315688e-02*G0_1_1 + 9.029982363315685e-02*G0_1_2 + 9.029982363315668e-02*G0_2_0 + 9.029982363315667e-02*G0_2_1 + 9.029982363315671e-02*G0_2_2;
    block[1200] = 9.029982363315658e-02*G0_0_0 + 9.029982363315710e-02*G0_0_1 + 9.029982363315703e-02*G0_0_2 + 9.029982363315674e-02*G0_1_0 + 9.029982363315683e-02*G0_1_1 + 9.029982363315681e-02*G0_1_2 + 9.029982363315679e-02*G0_2_0 + 9.029982363315690e-02*G0_2_1 + 9.029982363315681e-02*G0_2_2;
    block[1201] = -4.514991181657838e-02*G0_0_0 - 2.257495590828918e-02*G0_0_1 - 2.257495590828913e-02*G0_0_2 - 2.257495590828913e-02*G0_1_0 - 1.354497354497350e-01*G0_1_1 - 1.354497354497352e-01*G0_1_2 - 2.257495590828932e-02*G0_2_0 - 1.354497354497351e-01*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[1202] = 9.029982363315703e-02*G0_0_0;
    block[1203] = 9.029982363315703e-02*G0_0_0 + 9.029982363315708e-02*G0_0_1 + 9.029982363315663e-02*G0_0_2 + 9.029982363315683e-02*G0_1_0 + 9.029982363315699e-02*G0_1_1 + 9.029982363315665e-02*G0_1_2 + 9.029982363315688e-02*G0_2_0 + 9.029982363315696e-02*G0_2_1 + 9.029982363315688e-02*G0_2_2;
    block[1204] = -1.354497354497353e-01*G0_0_0 - 1.354497354497352e-01*G0_0_1 - 2.257495590828906e-02*G0_0_2 - 1.354497354497355e-01*G0_1_0 - 1.354497354497355e-01*G0_1_1 - 2.257495590828896e-02*G0_1_2 - 2.257495590828907e-02*G0_2_0 - 2.257495590828912e-02*G0_2_1 - 4.514991181657840e-02*G0_2_2;
    block[1205] = 9.029982363315682e-02*G0_2_2;
    block[1206] = 9.029982363315700e-02*G0_0_0;
    block[1207] = -1.354497354497350e-01*G0_0_0 - 1.128747795414457e-01*G0_0_2 - 1.128747795414465e-01*G0_2_0 - 1.354497354497355e-01*G0_2_2;
    block[1208] = 9.029982363315710e-02*G0_2_2;
    block[1209] = 9.029982363315747e-02*G0_1_1;
    block[1210] = -1.354497354497360e-01*G0_1_1 - 1.128747795414467e-01*G0_1_2 - 1.128747795414465e-01*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[1211] = 9.029982363315706e-02*G0_2_2;
    block[1212] = -7.223985890652539e-01*G0_0_0 - 3.160493827160477e-01*G0_0_1 - 3.160493827160482e-01*G0_0_2 - 3.160493827160490e-01*G0_1_0 - 1.354497354497350e-01*G0_1_2 - 3.160493827160489e-01*G0_2_0 - 1.354497354497349e-01*G0_2_1;
    block[1213] = -1.354497354497350e-01*G0_0_1 - 3.160493827160494e-01*G0_0_2 - 1.354497354497353e-01*G0_1_0 - 3.160493827160491e-01*G0_1_2 - 3.160493827160490e-01*G0_2_0 - 3.160493827160488e-01*G0_2_1 - 7.223985890652551e-01*G0_2_2;
    block[1214] = -3.160493827160501e-01*G0_0_1 - 1.354497354497359e-01*G0_0_2 - 3.160493827160493e-01*G0_1_0 - 7.223985890652564e-01*G0_1_1 - 3.160493827160494e-01*G0_1_2 - 1.354497354497356e-01*G0_2_0 - 3.160493827160495e-01*G0_2_1;
    block[1215] = 3.160493827160491e-01*G0_0_1 + 1.354497354497361e-01*G0_0_2 + 3.160493827160494e-01*G0_1_0 - 9.029982363315753e-02*G0_1_1 + 1.354497354497356e-01*G0_1_2 + 1.354497354497357e-01*G0_2_0 + 1.354497354497352e-01*G0_2_1 + 2.708994708994704e-01*G0_2_2;
    block[1216] = 1.354497354497360e-01*G0_0_1 + 3.160493827160489e-01*G0_0_2 + 1.354497354497354e-01*G0_1_0 + 2.708994708994714e-01*G0_1_1 + 1.354497354497354e-01*G0_1_2 + 3.160493827160489e-01*G0_2_0 + 1.354497354497357e-01*G0_2_1 - 9.029982363315690e-02*G0_2_2;
    block[1217] = -7.223985890652541e-01*G0_0_0 - 4.063492063492061e-01*G0_0_1 - 4.063492063492055e-01*G0_0_2 - 4.063492063492058e-01*G0_1_0 - 9.029982363315657e-02*G0_1_1 - 2.257495590828923e-01*G0_1_2 - 4.063492063492051e-01*G0_2_0 - 2.257495590828922e-01*G0_2_1 - 9.029982363315670e-02*G0_2_2;
    block[1218] = 2.708994708994703e-01*G0_0_0 + 1.354497354497351e-01*G0_0_1 + 1.354497354497352e-01*G0_0_2 + 1.354497354497354e-01*G0_1_0 + 3.160493827160493e-01*G0_1_2 + 1.354497354497356e-01*G0_2_0 + 3.160493827160489e-01*G0_2_1 - 9.029982363315689e-02*G0_2_2;
    block[1219] = -9.029982363315761e-02*G0_0_0 + 3.160493827160480e-01*G0_0_1 + 1.354497354497347e-01*G0_0_2 + 3.160493827160484e-01*G0_1_0 + 1.354497354497349e-01*G0_1_2 + 1.354497354497347e-01*G0_2_0 + 1.354497354497351e-01*G0_2_1 + 2.708994708994705e-01*G0_2_2;
    block[1220] = -9.029982363315643e-02*G0_0_0 - 4.063492063492052e-01*G0_0_1 - 2.257495590828922e-01*G0_0_2 - 4.063492063492057e-01*G0_1_0 - 7.223985890652551e-01*G0_1_1 - 4.063492063492063e-01*G0_1_2 - 2.257495590828919e-01*G0_2_0 - 4.063492063492052e-01*G0_2_1 - 9.029982363315696e-02*G0_2_2;
    block[1221] = -9.029982363315596e-02*G0_0_0 - 2.257495590828923e-01*G0_0_1 - 4.063492063492050e-01*G0_0_2 - 2.257495590828917e-01*G0_1_0 - 9.029982363315663e-02*G0_1_1 - 4.063492063492056e-01*G0_1_2 - 4.063492063492049e-01*G0_2_0 - 4.063492063492055e-01*G0_2_1 - 7.223985890652538e-01*G0_2_2;
    block[1222] = -9.029982363315792e-02*G0_0_0 + 1.354497354497349e-01*G0_0_1 + 3.160493827160482e-01*G0_0_2 + 1.354497354497344e-01*G0_1_0 + 2.708994708994708e-01*G0_1_1 + 1.354497354497349e-01*G0_1_2 + 3.160493827160477e-01*G0_2_0 + 1.354497354497347e-01*G0_2_1;
    block[1223] = 2.708994708994706e-01*G0_0_0 + 1.354497354497352e-01*G0_0_1 + 1.354497354497358e-01*G0_0_2 + 1.354497354497354e-01*G0_1_0 - 9.029982363315790e-02*G0_1_1 + 3.160493827160494e-01*G0_1_2 + 1.354497354497349e-01*G0_2_0 + 3.160493827160484e-01*G0_2_1;
    block[1224] = 1.444797178130509e+00*G0_0_0 + 7.223985890652550e-01*G0_0_1 + 7.223985890652542e-01*G0_0_2 + 7.223985890652550e-01*G0_1_0 + 1.444797178130512e+00*G0_1_1 + 7.223985890652548e-01*G0_1_2 + 7.223985890652541e-01*G0_2_0 + 7.223985890652549e-01*G0_2_1 + 1.444797178130508e+00*G0_2_2;
  }

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 35;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 35;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noNodes();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0) : dolfin::LinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0 = map.det*c[0][0];
    real G0_1 = map.det*c[0][1];
    real G0_2 = map.det*c[0][2];
    real G0_3 = map.det*c[0][3];
    real G0_4 = map.det*c[0][4];
    real G0_5 = map.det*c[0][5];
    real G0_6 = map.det*c[0][6];
    real G0_7 = map.det*c[0][7];
    real G0_8 = map.det*c[0][8];
    real G0_9 = map.det*c[0][9];
    real G0_10 = map.det*c[0][10];
    real G0_11 = map.det*c[0][11];
    real G0_12 = map.det*c[0][12];
    real G0_13 = map.det*c[0][13];
    real G0_14 = map.det*c[0][14];
    real G0_15 = map.det*c[0][15];
    real G0_16 = map.det*c[0][16];
    real G0_17 = map.det*c[0][17];
    real G0_18 = map.det*c[0][18];
    real G0_19 = map.det*c[0][19];
    real G0_20 = map.det*c[0][20];
    real G0_21 = map.det*c[0][21];
    real G0_22 = map.det*c[0][22];
    real G0_23 = map.det*c[0][23];
    real G0_24 = map.det*c[0][24];
    real G0_25 = map.det*c[0][25];
    real G0_26 = map.det*c[0][26];
    real G0_27 = map.det*c[0][27];
    real G0_28 = map.det*c[0][28];
    real G0_29 = map.det*c[0][29];
    real G0_30 = map.det*c[0][30];
    real G0_31 = map.det*c[0][31];
    real G0_32 = map.det*c[0][32];
    real G0_33 = map.det*c[0][33];
    real G0_34 = map.det*c[0][34];

    // Compute element tensor
    block[0] = 2.004168670835321e-04*G0_0 + 1.630057185612700e-05*G0_1 + 1.630057185612729e-05*G0_2 + 1.630057185612735e-05*G0_3 - 1.218534551867876e-04*G0_4 + 8.390786168563880e-05*G0_5 - 1.218534551867876e-04*G0_6 - 6.840895729784565e-05*G0_7 + 1.122334455667780e-04*G0_8 - 1.496445940890376e-04*G0_9 - 1.496445940890373e-04*G0_10 + 1.122334455667780e-04*G0_11 - 6.840895729784545e-05*G0_12 - 1.496445940890381e-04*G0_13 + 1.122334455667783e-04*G0_14 - 6.840895729784593e-05*G0_15 - 1.218534551867875e-04*G0_16 + 8.390786168563895e-05*G0_17 - 1.218534551867877e-04*G0_18 - 1.218534551867876e-04*G0_19 + 8.390786168563899e-05*G0_20 - 1.218534551867878e-04*G0_21 - 2.159157714713254e-04*G0_22 - 2.159157714713266e-04*G0_23 - 2.159157714713256e-04*G0_24 - 1.859868526535181e-04*G0_25 - 1.859868526535184e-04*G0_26 + 2.886002886002868e-04*G0_27 - 1.859868526535184e-04*G0_28 - 1.859868526535179e-04*G0_29 + 2.886002886002867e-04*G0_30 + 2.886002886002868e-04*G0_31 - 1.859868526535178e-04*G0_32 - 1.859868526535181e-04*G0_33 - 5.387205387205359e-04*G0_34;
    block[1] = 1.630057185612700e-05*G0_0 + 2.004168670835313e-04*G0_1 + 1.630057185612707e-05*G0_2 + 1.630057185612705e-05*G0_3 - 1.496445940890370e-04*G0_4 + 1.122334455667777e-04*G0_5 - 6.840895729784481e-05*G0_6 - 1.218534551867868e-04*G0_7 + 8.390786168563819e-05*G0_8 - 1.218534551867866e-04*G0_9 - 6.840895729784466e-05*G0_10 + 1.122334455667773e-04*G0_11 - 1.496445940890366e-04*G0_12 - 1.218534551867869e-04*G0_13 + 8.390786168563799e-05*G0_14 - 1.218534551867870e-04*G0_15 - 1.496445940890377e-04*G0_16 + 1.122334455667786e-04*G0_17 - 6.840895729784528e-05*G0_18 - 1.218534551867868e-04*G0_19 + 8.390786168563826e-05*G0_20 - 1.218534551867869e-04*G0_21 + 2.886002886002878e-04*G0_22 - 1.859868526535173e-04*G0_23 - 1.859868526535171e-04*G0_24 - 2.159157714713247e-04*G0_25 - 2.159157714713258e-04*G0_26 - 2.159157714713252e-04*G0_27 - 1.859868526535176e-04*G0_28 + 2.886002886002881e-04*G0_29 - 1.859868526535173e-04*G0_30 - 1.859868526535173e-04*G0_31 + 2.886002886002877e-04*G0_32 - 1.859868526535171e-04*G0_33 - 5.387205387205288e-04*G0_34;
    block[2] = 1.630057185612729e-05*G0_0 + 1.630057185612707e-05*G0_1 + 2.004168670835323e-04*G0_2 + 1.630057185612735e-05*G0_3 - 6.840895729784542e-05*G0_4 + 1.122334455667779e-04*G0_5 - 1.496445940890376e-04*G0_6 - 1.496445940890376e-04*G0_7 + 1.122334455667780e-04*G0_8 - 6.840895729784543e-05*G0_9 - 1.218534551867875e-04*G0_10 + 8.390786168563895e-05*G0_11 - 1.218534551867875e-04*G0_12 - 1.218534551867875e-04*G0_13 + 8.390786168563853e-05*G0_14 - 1.218534551867877e-04*G0_15 - 1.218534551867874e-04*G0_16 + 8.390786168563888e-05*G0_17 - 1.218534551867878e-04*G0_18 - 1.496445940890381e-04*G0_19 + 1.122334455667788e-04*G0_20 - 6.840895729784600e-05*G0_21 - 1.859868526535189e-04*G0_22 - 1.859868526535183e-04*G0_23 + 2.886002886002875e-04*G0_24 + 2.886002886002877e-04*G0_25 - 1.859868526535183e-04*G0_26 - 1.859868526535185e-04*G0_27 - 2.159157714713259e-04*G0_28 - 2.159157714713256e-04*G0_29 - 2.159157714713252e-04*G0_30 - 1.859868526535182e-04*G0_31 - 1.859868526535186e-04*G0_32 + 2.886002886002870e-04*G0_33 - 5.387205387205360e-04*G0_34;
    block[3] = 1.630057185612735e-05*G0_0 + 1.630057185612706e-05*G0_1 + 1.630057185612734e-05*G0_2 + 2.004168670835327e-04*G0_3 - 1.218534551867874e-04*G0_4 + 8.390786168563892e-05*G0_5 - 1.218534551867875e-04*G0_6 - 1.218534551867875e-04*G0_7 + 8.390786168563869e-05*G0_8 - 1.218534551867874e-04*G0_9 - 1.218534551867875e-04*G0_10 + 8.390786168563891e-05*G0_11 - 1.218534551867874e-04*G0_12 - 6.840895729784576e-05*G0_13 + 1.122334455667776e-04*G0_14 - 1.496445940890377e-04*G0_15 - 6.840895729784564e-05*G0_16 + 1.122334455667782e-04*G0_17 - 1.496445940890376e-04*G0_18 - 6.840895729784578e-05*G0_19 + 1.122334455667783e-04*G0_20 - 1.496445940890377e-04*G0_21 - 1.859868526535191e-04*G0_22 + 2.886002886002867e-04*G0_23 - 1.859868526535181e-04*G0_24 - 1.859868526535180e-04*G0_25 + 2.886002886002866e-04*G0_26 - 1.859868526535179e-04*G0_27 + 2.886002886002866e-04*G0_28 - 1.859868526535185e-04*G0_29 - 1.859868526535176e-04*G0_30 - 2.159157714713244e-04*G0_31 - 2.159157714713260e-04*G0_32 - 2.159157714713254e-04*G0_33 - 5.387205387205360e-04*G0_34;
    block[4] = -1.218534551867876e-04*G0_0 - 1.496445940890369e-04*G0_1 - 6.840895729784540e-05*G0_2 - 1.218534551867874e-04*G0_3 + 1.710223932446139e-03*G0_4 - 1.257014590347910e-03*G0_5 + 6.840895729784548e-04*G0_6 + 3.591470258136888e-04*G0_7 - 1.539201539201527e-04*G0_8 + 2.736358291913822e-04*G0_9 + 3.591470258136884e-04*G0_10 - 6.541606541606471e-04*G0_11 + 8.551119662230688e-04*G0_12 + 1.368179145956913e-04*G0_13 - 9.833787611565185e-05*G0_14 + 1.368179145956913e-04*G0_15 + 8.551119662230683e-04*G0_16 - 6.541606541606471e-04*G0_17 + 3.591470258136887e-04*G0_18 + 3.591470258136891e-04*G0_19 - 1.539201539201524e-04*G0_20 + 2.736358291913825e-04*G0_21 + 1.026134359467665e-04*G0_22 - 3.420447864892161e-05*G0_23 + 5.130671797338442e-04*G0_24 + 9.748276414943024e-04*G0_25 + 8.551119662230810e-05*G0_26 + 8.551119662230523e-05*G0_27 - 1.710223932446073e-05*G0_28 + 5.130671797338372e-05*G0_29 - 1.710223932446191e-05*G0_30 - 3.420447864892432e-05*G0_31 + 1.026134359467703e-04*G0_32 + 5.130671797338432e-04*G0_33 + 1.094543316765532e-03*G0_34;
    block[5] = 8.390786168563880e-05*G0_0 + 1.122334455667776e-04*G0_1 + 1.122334455667779e-04*G0_2 + 8.390786168563892e-05*G0_3 - 1.257014590347910e-03*G0_4 + 2.385762385762361e-03*G0_5 - 1.257014590347911e-03*G0_6 - 6.541606541606479e-04*G0_7 + 2.565335898669206e-04*G0_8 - 1.539201539201524e-04*G0_9 - 1.539201539201523e-04*G0_10 + 2.565335898669204e-04*G0_11 - 6.541606541606474e-04*G0_12 - 9.833787611565328e-05*G0_13 + 1.924001924001798e-05*G0_14 - 9.833787611565309e-05*G0_15 - 6.541606541606471e-04*G0_16 + 2.565335898669202e-04*G0_17 - 1.539201539201526e-04*G0_18 - 6.541606541606477e-04*G0_19 + 2.565335898669207e-04*G0_20 - 1.539201539201527e-04*G0_21 - 7.696007696007916e-05*G0_22 - 1.795735129068439e-04*G0_23 - 7.696007696007856e-05*G0_24 - 1.013307679974340e-03*G0_25 + 2.693602693602665e-04*G0_26 + 2.693602693602689e-04*G0_27 + 2.693602693602669e-04*G0_28 - 1.013307679974338e-03*G0_29 + 2.693602693602677e-04*G0_30 - 1.795735129068440e-04*G0_31 - 7.696007696007795e-05*G0_32 - 7.696007696007650e-05*G0_33 - 1.026134359467685e-03*G0_34;
    block[6] = -1.218534551867875e-04*G0_0 - 6.840895729784481e-05*G0_1 - 1.496445940890376e-04*G0_2 - 1.218534551867875e-04*G0_3 + 6.840895729784548e-04*G0_4 - 1.257014590347911e-03*G0_5 + 1.710223932446138e-03*G0_6 + 8.551119662230701e-04*G0_7 - 6.541606541606477e-04*G0_8 + 3.591470258136891e-04*G0_9 + 2.736358291913824e-04*G0_10 - 1.539201539201531e-04*G0_11 + 3.591470258136890e-04*G0_12 + 1.368179145956921e-04*G0_13 - 9.833787611565262e-05*G0_14 + 1.368179145956919e-04*G0_15 + 3.591470258136890e-04*G0_16 - 1.539201539201527e-04*G0_17 + 2.736358291913828e-04*G0_18 + 8.551119662230696e-04*G0_19 - 6.541606541606481e-04*G0_20 + 3.591470258136893e-04*G0_21 + 5.130671797338446e-04*G0_22 - 3.420447864891979e-05*G0_23 + 1.026134359467640e-04*G0_24 + 5.130671797338273e-05*G0_25 - 1.710223932445956e-05*G0_26 - 1.710223932446097e-05*G0_27 + 8.551119662230882e-05*G0_28 + 9.748276414943014e-04*G0_29 + 8.551119662230744e-05*G0_30 - 3.420447864892206e-05*G0_31 + 5.130671797338444e-04*G0_32 + 1.026134359467676e-04*G0_33 + 1.094543316765535e-03*G0_34;
    block[7] = -6.840895729784565e-05*G0_0 - 1.218534551867868e-04*G0_1 - 1.496445940890376e-04*G0_2 - 1.218534551867876e-04*G0_3 + 3.591470258136888e-04*G0_4 - 6.541606541606479e-04*G0_5 + 8.551119662230701e-04*G0_6 + 1.710223932446138e-03*G0_7 - 1.257014590347911e-03*G0_8 + 6.840895729784551e-04*G0_9 + 3.591470258136890e-04*G0_10 - 1.539201539201529e-04*G0_11 + 2.736358291913824e-04*G0_12 + 3.591470258136899e-04*G0_13 - 1.539201539201515e-04*G0_14 + 2.736358291913824e-04*G0_15 + 1.368179145956915e-04*G0_16 - 9.833787611565419e-05*G0_17 + 1.368179145956918e-04*G0_18 + 8.551119662230698e-04*G0_19 - 6.541606541606477e-04*G0_20 + 3.591470258136893e-04*G0_21 - 1.710223932446021e-05*G0_22 - 1.710223932446045e-05*G0_23 + 5.130671797338305e-05*G0_24 + 1.026134359467655e-04*G0_25 - 3.420447864892085e-05*G0_26 + 5.130671797338426e-04*G0_27 + 8.551119662230791e-05*G0_28 + 8.551119662230722e-05*G0_29 + 9.748276414942997e-04*G0_30 + 5.130671797338425e-04*G0_31 - 3.420447864892085e-05*G0_32 + 1.026134359467679e-04*G0_33 + 1.094543316765531e-03*G0_34;
    block[8] = 1.122334455667780e-04*G0_0 + 8.390786168563816e-05*G0_1 + 1.122334455667779e-04*G0_2 + 8.390786168563868e-05*G0_3 - 1.539201539201527e-04*G0_4 + 2.565335898669206e-04*G0_5 - 6.541606541606477e-04*G0_6 - 1.257014590347911e-03*G0_7 + 2.385762385762362e-03*G0_8 - 1.257014590347910e-03*G0_9 - 6.541606541606470e-04*G0_10 + 2.565335898669205e-04*G0_11 - 1.539201539201525e-04*G0_12 - 6.541606541606483e-04*G0_13 + 2.565335898669196e-04*G0_14 - 1.539201539201521e-04*G0_15 - 9.833787611565328e-05*G0_16 + 1.924001924001981e-05*G0_17 - 9.833787611565304e-05*G0_18 - 6.541606541606478e-04*G0_19 + 2.565335898669202e-04*G0_20 - 1.539201539201523e-04*G0_21 + 2.693602693602678e-04*G0_22 + 2.693602693602663e-04*G0_23 - 1.013307679974340e-03*G0_24 - 7.696007696007690e-05*G0_25 - 1.795735129068455e-04*G0_26 - 7.696007696007664e-05*G0_27 + 2.693602693602662e-04*G0_28 + 2.693602693602679e-04*G0_29 - 1.013307679974337e-03*G0_30 - 7.696007696007603e-05*G0_31 - 1.795735129068450e-04*G0_32 - 7.696007696007604e-05*G0_33 - 1.026134359467684e-03*G0_34;
    block[9] = -1.496445940890376e-04*G0_0 - 1.218534551867866e-04*G0_1 - 6.840895729784542e-05*G0_2 - 1.218534551867874e-04*G0_3 + 2.736358291913822e-04*G0_4 - 1.539201539201524e-04*G0_5 + 3.591470258136891e-04*G0_6 + 6.840895729784551e-04*G0_7 - 1.257014590347910e-03*G0_8 + 1.710223932446141e-03*G0_9 + 8.551119662230690e-04*G0_10 - 6.541606541606478e-04*G0_11 + 3.591470258136885e-04*G0_12 + 8.551119662230694e-04*G0_13 - 6.541606541606468e-04*G0_14 + 3.591470258136878e-04*G0_15 + 1.368179145956911e-04*G0_16 - 9.833787611565381e-05*G0_17 + 1.368179145956913e-04*G0_18 + 3.591470258136891e-04*G0_19 - 1.539201539201523e-04*G0_20 + 2.736358291913823e-04*G0_21 + 8.551119662230816e-05*G0_22 + 8.551119662230846e-05*G0_23 + 9.748276414943010e-04*G0_24 + 5.130671797338433e-04*G0_25 - 3.420447864892131e-05*G0_26 + 1.026134359467641e-04*G0_27 - 1.710223932446043e-05*G0_28 - 1.710223932446001e-05*G0_29 + 5.130671797338022e-05*G0_30 + 1.026134359467657e-04*G0_31 - 3.420447864892102e-05*G0_32 + 5.130671797338421e-04*G0_33 + 1.094543316765529e-03*G0_34;
    block[10] = -1.496445940890373e-04*G0_0 - 6.840895729784466e-05*G0_1 - 1.218534551867875e-04*G0_2 - 1.218534551867874e-04*G0_3 + 3.591470258136884e-04*G0_4 - 1.539201539201523e-04*G0_5 + 2.736358291913824e-04*G0_6 + 3.591470258136891e-04*G0_7 - 6.541606541606470e-04*G0_8 + 8.551119662230690e-04*G0_9 + 1.710223932446139e-03*G0_10 - 1.257014590347911e-03*G0_11 + 6.840895729784537e-04*G0_12 + 8.551119662230695e-04*G0_13 - 6.541606541606465e-04*G0_14 + 3.591470258136882e-04*G0_15 + 3.591470258136888e-04*G0_16 - 1.539201539201527e-04*G0_17 + 2.736358291913825e-04*G0_18 + 1.368179145956914e-04*G0_19 - 9.833787611565359e-05*G0_20 + 1.368179145956914e-04*G0_21 + 9.748276414943012e-04*G0_22 + 8.551119662230926e-05*G0_23 + 8.551119662230649e-05*G0_24 - 1.710223932446175e-05*G0_25 - 1.710223932445974e-05*G0_26 + 5.130671797338137e-05*G0_27 - 3.420447864892104e-05*G0_28 + 5.130671797338433e-04*G0_29 + 1.026134359467639e-04*G0_30 + 1.026134359467670e-04*G0_31 + 5.130671797338443e-04*G0_32 - 3.420447864892286e-05*G0_33 + 1.094543316765529e-03*G0_34;
    block[11] = 1.122334455667779e-04*G0_0 + 1.122334455667773e-04*G0_1 + 8.390786168563895e-05*G0_2 + 8.390786168563891e-05*G0_3 - 6.541606541606471e-04*G0_4 + 2.565335898669204e-04*G0_5 - 1.539201539201531e-04*G0_6 - 1.539201539201528e-04*G0_7 + 2.565335898669205e-04*G0_8 - 6.541606541606478e-04*G0_9 - 1.257014590347911e-03*G0_10 + 2.385762385762363e-03*G0_11 - 1.257014590347911e-03*G0_12 - 6.541606541606473e-04*G0_13 + 2.565335898669194e-04*G0_14 - 1.539201539201525e-04*G0_15 - 6.541606541606477e-04*G0_16 + 2.565335898669209e-04*G0_17 - 1.539201539201530e-04*G0_18 - 9.833787611565338e-05*G0_19 + 1.924001924001924e-05*G0_20 - 9.833787611565315e-05*G0_21 - 1.013307679974340e-03*G0_22 + 2.693602693602667e-04*G0_23 + 2.693602693602690e-04*G0_24 + 2.693602693602686e-04*G0_25 + 2.693602693602665e-04*G0_26 - 1.013307679974337e-03*G0_27 - 1.795735129068439e-04*G0_28 - 7.696007696007973e-05*G0_29 - 7.696007696007604e-05*G0_30 - 7.696007696007570e-05*G0_31 - 7.696007696007905e-05*G0_32 - 1.795735129068424e-04*G0_33 - 1.026134359467682e-03*G0_34;
    block[12] = -6.840895729784543e-05*G0_0 - 1.496445940890366e-04*G0_1 - 1.218534551867875e-04*G0_2 - 1.218534551867874e-04*G0_3 + 8.551119662230689e-04*G0_4 - 6.541606541606474e-04*G0_5 + 3.591470258136890e-04*G0_6 + 2.736358291913824e-04*G0_7 - 1.539201539201525e-04*G0_8 + 3.591470258136885e-04*G0_9 + 6.840895729784537e-04*G0_10 - 1.257014590347911e-03*G0_11 + 1.710223932446138e-03*G0_12 + 3.591470258136888e-04*G0_13 - 1.539201539201514e-04*G0_14 + 2.736358291913825e-04*G0_15 + 8.551119662230690e-04*G0_16 - 6.541606541606474e-04*G0_17 + 3.591470258136891e-04*G0_18 + 1.368179145956915e-04*G0_19 - 9.833787611565324e-05*G0_20 + 1.368179145956914e-04*G0_21 + 5.130671797338436e-05*G0_22 - 1.710223932446107e-05*G0_23 - 1.710223932446132e-05*G0_24 + 8.551119662230695e-05*G0_25 + 8.551119662230858e-05*G0_26 + 9.748276414942994e-04*G0_27 - 3.420447864892178e-05*G0_28 + 1.026134359467669e-04*G0_29 + 5.130671797338432e-04*G0_30 + 5.130671797338420e-04*G0_31 + 1.026134359467697e-04*G0_32 - 3.420447864892286e-05*G0_33 + 1.094543316765531e-03*G0_34;
    block[13] = -1.496445940890381e-04*G0_0 - 1.218534551867870e-04*G0_1 - 1.218534551867876e-04*G0_2 - 6.840895729784576e-05*G0_3 + 1.368179145956914e-04*G0_4 - 9.833787611565330e-05*G0_5 + 1.368179145956921e-04*G0_6 + 3.591470258136899e-04*G0_7 - 6.541606541606483e-04*G0_8 + 8.551119662230693e-04*G0_9 + 8.551119662230695e-04*G0_10 - 6.541606541606473e-04*G0_11 + 3.591470258136888e-04*G0_12 + 1.710223932446141e-03*G0_13 - 1.257014590347913e-03*G0_14 + 6.840895729784563e-04*G0_15 + 2.736358291913824e-04*G0_16 - 1.539201539201543e-04*G0_17 + 3.591470258136906e-04*G0_18 + 2.736358291913836e-04*G0_19 - 1.539201539201537e-04*G0_20 + 3.591470258136908e-04*G0_21 + 8.551119662230839e-05*G0_22 + 9.748276414943027e-04*G0_23 + 8.551119662230711e-05*G0_24 - 3.420447864892185e-05*G0_25 + 5.130671797338441e-04*G0_26 + 1.026134359467669e-04*G0_27 + 5.130671797338432e-04*G0_28 - 3.420447864892205e-05*G0_29 + 1.026134359467662e-04*G0_30 + 5.130671797338296e-05*G0_31 - 1.710223932445961e-05*G0_32 - 1.710223932446075e-05*G0_33 + 1.094543316765535e-03*G0_34;
    block[14] = 1.122334455667783e-04*G0_0 + 8.390786168563799e-05*G0_1 + 8.390786168563854e-05*G0_2 + 1.122334455667776e-04*G0_3 - 9.833787611565187e-05*G0_4 + 1.924001924001798e-05*G0_5 - 9.833787611565265e-05*G0_6 - 1.539201539201515e-04*G0_7 + 2.565335898669197e-04*G0_8 - 6.541606541606468e-04*G0_9 - 6.541606541606465e-04*G0_10 + 2.565335898669194e-04*G0_11 - 1.539201539201514e-04*G0_12 - 1.257014590347913e-03*G0_13 + 2.385762385762366e-03*G0_14 - 1.257014590347914e-03*G0_15 - 1.539201539201519e-04*G0_16 + 2.565335898669222e-04*G0_17 - 6.541606541606492e-04*G0_18 - 1.539201539201526e-04*G0_19 + 2.565335898669219e-04*G0_20 - 6.541606541606499e-04*G0_21 + 2.693602693602673e-04*G0_22 - 1.013307679974340e-03*G0_23 + 2.693602693602689e-04*G0_24 - 1.795735129068431e-04*G0_25 - 7.696007696007640e-05*G0_26 - 7.696007696007516e-05*G0_27 - 7.696007696007641e-05*G0_28 - 1.795735129068436e-04*G0_29 - 7.696007696007459e-05*G0_30 - 1.013307679974337e-03*G0_31 + 2.693602693602671e-04*G0_32 + 2.693602693602676e-04*G0_33 - 1.026134359467679e-03*G0_34;
    block[15] = -6.840895729784593e-05*G0_0 - 1.218534551867870e-04*G0_1 - 1.218534551867877e-04*G0_2 - 1.496445940890377e-04*G0_3 + 1.368179145956913e-04*G0_4 - 9.833787611565309e-05*G0_5 + 1.368179145956919e-04*G0_6 + 2.736358291913824e-04*G0_7 - 1.539201539201521e-04*G0_8 + 3.591470258136878e-04*G0_9 + 3.591470258136882e-04*G0_10 - 1.539201539201526e-04*G0_11 + 2.736358291913824e-04*G0_12 + 6.840895729784563e-04*G0_13 - 1.257014590347914e-03*G0_14 + 1.710223932446145e-03*G0_15 + 3.591470258136903e-04*G0_16 - 6.541606541606517e-04*G0_17 + 8.551119662230727e-04*G0_18 + 3.591470258136910e-04*G0_19 - 6.541606541606514e-04*G0_20 + 8.551119662230731e-04*G0_21 - 1.710223932445897e-05*G0_22 + 5.130671797338295e-05*G0_23 - 1.710223932446184e-05*G0_24 - 3.420447864892341e-05*G0_25 + 1.026134359467689e-04*G0_26 + 5.130671797338425e-04*G0_27 + 1.026134359467676e-04*G0_28 - 3.420447864892160e-05*G0_29 + 5.130671797338420e-04*G0_30 + 9.748276414942984e-04*G0_31 + 8.551119662230951e-05*G0_32 + 8.551119662230726e-05*G0_33 + 1.094543316765532e-03*G0_34;
    block[16] = -1.218534551867875e-04*G0_0 - 1.496445940890377e-04*G0_1 - 1.218534551867874e-04*G0_2 - 6.840895729784564e-05*G0_3 + 8.551119662230685e-04*G0_4 - 6.541606541606471e-04*G0_5 + 3.591470258136890e-04*G0_6 + 1.368179145956916e-04*G0_7 - 9.833787611565328e-05*G0_8 + 1.368179145956911e-04*G0_9 + 3.591470258136888e-04*G0_10 - 6.541606541606476e-04*G0_11 + 8.551119662230690e-04*G0_12 + 2.736358291913824e-04*G0_13 - 1.539201539201519e-04*G0_14 + 3.591470258136903e-04*G0_15 + 1.710223932446140e-03*G0_16 - 1.257014590347913e-03*G0_17 + 6.840895729784564e-04*G0_18 + 2.736358291913829e-04*G0_19 - 1.539201539201535e-04*G0_20 + 3.591470258136906e-04*G0_21 + 1.026134359467672e-04*G0_22 + 5.130671797338432e-04*G0_23 - 3.420447864892182e-05*G0_24 + 8.551119662230701e-05*G0_25 + 9.748276414943031e-04*G0_26 + 8.551119662230698e-05*G0_27 + 5.130671797338437e-04*G0_28 + 1.026134359467673e-04*G0_29 - 3.420447864892276e-05*G0_30 - 1.710223932446184e-05*G0_31 + 5.130671797338481e-05*G0_32 - 1.710223932446059e-05*G0_33 + 1.094543316765534e-03*G0_34;
    block[17] = 8.390786168563892e-05*G0_0 + 1.122334455667786e-04*G0_1 + 8.390786168563888e-05*G0_2 + 1.122334455667782e-04*G0_3 - 6.541606541606472e-04*G0_4 + 2.565335898669202e-04*G0_5 - 1.539201539201527e-04*G0_6 - 9.833787611565420e-05*G0_7 + 1.924001924001981e-05*G0_8 - 9.833787611565381e-05*G0_9 - 1.539201539201528e-04*G0_10 + 2.565335898669209e-04*G0_11 - 6.541606541606474e-04*G0_12 - 1.539201539201543e-04*G0_13 + 2.565335898669222e-04*G0_14 - 6.541606541606517e-04*G0_15 - 1.257014590347913e-03*G0_16 + 2.385762385762367e-03*G0_17 - 1.257014590347916e-03*G0_18 - 1.539201539201536e-04*G0_19 + 2.565335898669229e-04*G0_20 - 6.541606541606516e-04*G0_21 - 7.696007696007669e-05*G0_22 - 7.696007696007760e-05*G0_23 - 1.795735129068452e-04*G0_24 + 2.693602693602677e-04*G0_25 - 1.013307679974340e-03*G0_26 + 2.693602693602671e-04*G0_27 - 7.696007696007701e-05*G0_28 - 7.696007696007592e-05*G0_29 - 1.795735129068459e-04*G0_30 + 2.693602693602665e-04*G0_31 - 1.013307679974339e-03*G0_32 + 2.693602693602658e-04*G0_33 - 1.026134359467692e-03*G0_34;
    block[18] = -1.218534551867877e-04*G0_0 - 6.840895729784527e-05*G0_1 - 1.218534551867878e-04*G0_2 - 1.496445940890376e-04*G0_3 + 3.591470258136887e-04*G0_4 - 1.539201539201526e-04*G0_5 + 2.736358291913828e-04*G0_6 + 1.368179145956918e-04*G0_7 - 9.833787611565301e-05*G0_8 + 1.368179145956914e-04*G0_9 + 2.736358291913825e-04*G0_10 - 1.539201539201530e-04*G0_11 + 3.591470258136891e-04*G0_12 + 3.591470258136906e-04*G0_13 - 6.541606541606494e-04*G0_14 + 8.551119662230726e-04*G0_15 + 6.840895729784564e-04*G0_16 - 1.257014590347916e-03*G0_17 + 1.710223932446143e-03*G0_18 + 3.591470258136908e-04*G0_19 - 6.541606541606515e-04*G0_20 + 8.551119662230733e-04*G0_21 + 5.130671797338446e-04*G0_22 + 1.026134359467690e-04*G0_23 - 3.420447864892356e-05*G0_24 - 1.710223932446211e-05*G0_25 + 5.130671797338471e-05*G0_26 - 1.710223932446091e-05*G0_27 + 1.026134359467685e-04*G0_28 + 5.130671797338432e-04*G0_29 - 3.420447864892270e-05*G0_30 + 8.551119662230725e-05*G0_31 + 9.748276414943011e-04*G0_32 + 8.551119662230760e-05*G0_33 + 1.094543316765533e-03*G0_34;
    block[19] = -1.218534551867876e-04*G0_0 - 1.218534551867868e-04*G0_1 - 1.496445940890381e-04*G0_2 - 6.840895729784582e-05*G0_3 + 3.591470258136891e-04*G0_4 - 6.541606541606477e-04*G0_5 + 8.551119662230696e-04*G0_6 + 8.551119662230698e-04*G0_7 - 6.541606541606479e-04*G0_8 + 3.591470258136891e-04*G0_9 + 1.368179145956915e-04*G0_10 - 9.833787611565338e-05*G0_11 + 1.368179145956915e-04*G0_12 + 2.736358291913836e-04*G0_13 - 1.539201539201526e-04*G0_14 + 3.591470258136910e-04*G0_15 + 2.736358291913829e-04*G0_16 - 1.539201539201536e-04*G0_17 + 3.591470258136908e-04*G0_18 + 1.710223932446141e-03*G0_19 - 1.257014590347915e-03*G0_20 + 6.840895729784578e-04*G0_21 - 3.420447864892151e-05*G0_22 + 5.130671797338439e-04*G0_23 + 1.026134359467664e-04*G0_24 + 1.026134359467669e-04*G0_25 + 5.130671797338441e-04*G0_26 - 3.420447864892193e-05*G0_27 + 9.748276414943026e-04*G0_28 + 8.551119662230674e-05*G0_29 + 8.551119662230743e-05*G0_30 - 1.710223932446052e-05*G0_31 - 1.710223932446014e-05*G0_32 + 5.130671797338362e-05*G0_33 + 1.094543316765535e-03*G0_34;
    block[20] = 8.390786168563899e-05*G0_0 + 8.390786168563826e-05*G0_1 + 1.122334455667788e-04*G0_2 + 1.122334455667783e-04*G0_3 - 1.539201539201524e-04*G0_4 + 2.565335898669206e-04*G0_5 - 6.541606541606479e-04*G0_6 - 6.541606541606477e-04*G0_7 + 2.565335898669202e-04*G0_8 - 1.539201539201523e-04*G0_9 - 9.833787611565359e-05*G0_10 + 1.924001924001924e-05*G0_11 - 9.833787611565324e-05*G0_12 - 1.539201539201537e-04*G0_13 + 2.565335898669218e-04*G0_14 - 6.541606541606514e-04*G0_15 - 1.539201539201535e-04*G0_16 + 2.565335898669229e-04*G0_17 - 6.541606541606514e-04*G0_18 - 1.257014590347915e-03*G0_19 + 2.385762385762370e-03*G0_20 - 1.257014590347916e-03*G0_21 - 1.795735129068476e-04*G0_22 - 7.696007696007813e-05*G0_23 - 7.696007696007457e-05*G0_24 - 7.696007696007382e-05*G0_25 - 7.696007696007824e-05*G0_26 - 1.795735129068450e-04*G0_27 - 1.013307679974341e-03*G0_28 + 2.693602693602662e-04*G0_29 + 2.693602693602677e-04*G0_30 + 2.693602693602672e-04*G0_31 + 2.693602693602648e-04*G0_32 - 1.013307679974337e-03*G0_33 - 1.026134359467690e-03*G0_34;
    block[21] = -1.218534551867878e-04*G0_0 - 1.218534551867869e-04*G0_1 - 6.840895729784600e-05*G0_2 - 1.496445940890377e-04*G0_3 + 2.736358291913825e-04*G0_4 - 1.539201539201527e-04*G0_5 + 3.591470258136893e-04*G0_6 + 3.591470258136893e-04*G0_7 - 1.539201539201524e-04*G0_8 + 2.736358291913823e-04*G0_9 + 1.368179145956914e-04*G0_10 - 9.833787611565316e-05*G0_11 + 1.368179145956914e-04*G0_12 + 3.591470258136908e-04*G0_13 - 6.541606541606499e-04*G0_14 + 8.551119662230731e-04*G0_15 + 3.591470258136907e-04*G0_16 - 6.541606541606516e-04*G0_17 + 8.551119662230731e-04*G0_18 + 6.840895729784578e-04*G0_19 - 1.257014590347916e-03*G0_20 + 1.710223932446145e-03*G0_21 - 3.420447864892108e-05*G0_22 + 1.026134359467685e-04*G0_23 + 5.130671797338418e-04*G0_24 + 5.130671797338418e-04*G0_25 + 1.026134359467694e-04*G0_26 - 3.420447864892294e-05*G0_27 + 5.130671797338395e-05*G0_28 - 1.710223932446104e-05*G0_29 - 1.710223932446107e-05*G0_30 + 8.551119662230714e-05*G0_31 + 8.551119662230911e-05*G0_32 + 9.748276414942997e-04*G0_33 + 1.094543316765532e-03*G0_34;
    block[22] = -2.159157714713253e-04*G0_0 + 2.886002886002879e-04*G0_1 - 1.859868526535189e-04*G0_2 - 1.859868526535190e-04*G0_3 + 1.026134359467665e-04*G0_4 - 7.696007696007911e-05*G0_5 + 5.130671797338445e-04*G0_6 - 1.710223932446020e-05*G0_7 + 2.693602693602678e-04*G0_8 + 8.551119662230819e-05*G0_9 + 9.748276414943012e-04*G0_10 - 1.013307679974340e-03*G0_11 + 5.130671797338444e-05*G0_12 + 8.551119662230836e-05*G0_13 + 2.693602693602673e-04*G0_14 - 1.710223932445894e-05*G0_15 + 1.026134359467673e-04*G0_16 - 7.696007696007675e-05*G0_17 + 5.130671797338446e-04*G0_18 - 3.420447864892150e-05*G0_19 - 1.795735129068476e-04*G0_20 - 3.420447864892110e-05*G0_21 + 7.798621131954409e-03*G0_22 - 2.052268718935365e-03*G0_23 - 2.052268718935375e-03*G0_24 - 1.436588103254761e-03*G0_25 - 1.436588103254759e-03*G0_26 - 2.052268718935353e-04*G0_27 - 1.026134359467686e-03*G0_28 + 3.899310565977213e-03*G0_29 - 1.436588103254760e-03*G0_30 - 1.436588103254758e-03*G0_31 + 3.899310565977204e-03*G0_32 - 1.026134359467686e-03*G0_33 + 1.641814975148303e-03*G0_34;
    block[23] = -2.159157714713266e-04*G0_0 - 1.859868526535173e-04*G0_1 - 1.859868526535184e-04*G0_2 + 2.886002886002867e-04*G0_3 - 3.420447864892160e-05*G0_4 - 1.795735129068439e-04*G0_5 - 3.420447864891987e-05*G0_6 - 1.710223932446045e-05*G0_7 + 2.693602693602663e-04*G0_8 + 8.551119662230851e-05*G0_9 + 8.551119662230927e-05*G0_10 + 2.693602693602667e-04*G0_11 - 1.710223932446106e-05*G0_12 + 9.748276414943027e-04*G0_13 - 1.013307679974340e-03*G0_14 + 5.130671797338298e-05*G0_15 + 5.130671797338433e-04*G0_16 - 7.696007696007770e-05*G0_17 + 1.026134359467690e-04*G0_18 + 5.130671797338439e-04*G0_19 - 7.696007696007818e-05*G0_20 + 1.026134359467685e-04*G0_21 - 2.052268718935365e-03*G0_22 + 7.798621131954412e-03*G0_23 - 2.052268718935373e-03*G0_24 - 1.026134359467687e-03*G0_25 + 3.899310565977212e-03*G0_26 - 1.436588103254764e-03*G0_27 + 3.899310565977209e-03*G0_28 - 1.026134359467684e-03*G0_29 - 1.436588103254764e-03*G0_30 - 2.052268718935406e-04*G0_31 - 1.436588103254755e-03*G0_32 - 1.436588103254758e-03*G0_33 + 1.641814975148307e-03*G0_34;
    block[24] = -2.159157714713256e-04*G0_0 - 1.859868526535171e-04*G0_1 + 2.886002886002875e-04*G0_2 - 1.859868526535181e-04*G0_3 + 5.130671797338442e-04*G0_4 - 7.696007696007840e-05*G0_5 + 1.026134359467639e-04*G0_6 + 5.130671797338301e-05*G0_7 - 1.013307679974339e-03*G0_8 + 9.748276414943010e-04*G0_9 + 8.551119662230646e-05*G0_10 + 2.693602693602690e-04*G0_11 - 1.710223932446134e-05*G0_12 + 8.551119662230717e-05*G0_13 + 2.693602693602689e-04*G0_14 - 1.710223932446186e-05*G0_15 - 3.420447864892182e-05*G0_16 - 1.795735129068452e-04*G0_17 - 3.420447864892364e-05*G0_18 + 1.026134359467663e-04*G0_19 - 7.696007696007454e-05*G0_20 + 5.130671797338416e-04*G0_21 - 2.052268718935375e-03*G0_22 - 2.052268718935373e-03*G0_23 + 7.798621131954409e-03*G0_24 + 3.899310565977210e-03*G0_25 - 1.026134359467686e-03*G0_26 - 1.436588103254762e-03*G0_27 - 1.436588103254762e-03*G0_28 - 1.436588103254761e-03*G0_29 - 2.052268718935346e-04*G0_30 - 1.436588103254759e-03*G0_31 - 1.026134359467685e-03*G0_32 + 3.899310565977202e-03*G0_33 + 1.641814975148293e-03*G0_34;
    block[25] = -1.859868526535182e-04*G0_0 - 2.159157714713247e-04*G0_1 + 2.886002886002877e-04*G0_2 - 1.859868526535180e-04*G0_3 + 9.748276414943024e-04*G0_4 - 1.013307679974340e-03*G0_5 + 5.130671797338275e-05*G0_6 + 1.026134359467655e-04*G0_7 - 7.696007696007672e-05*G0_8 + 5.130671797338433e-04*G0_9 - 1.710223932446176e-05*G0_10 + 2.693602693602687e-04*G0_11 + 8.551119662230702e-05*G0_12 - 3.420447864892186e-05*G0_13 - 1.795735129068431e-04*G0_14 - 3.420447864892350e-05*G0_15 + 8.551119662230695e-05*G0_16 + 2.693602693602676e-04*G0_17 - 1.710223932446210e-05*G0_18 + 1.026134359467667e-04*G0_19 - 7.696007696007383e-05*G0_20 + 5.130671797338419e-04*G0_21 - 1.436588103254762e-03*G0_22 - 1.026134359467687e-03*G0_23 + 3.899310565977210e-03*G0_24 + 7.798621131954418e-03*G0_25 - 2.052268718935373e-03*G0_26 - 2.052268718935374e-03*G0_27 - 1.436588103254762e-03*G0_28 - 2.052268718935382e-04*G0_29 - 1.436588103254758e-03*G0_30 - 1.026134359467685e-03*G0_31 - 1.436588103254759e-03*G0_32 + 3.899310565977207e-03*G0_33 + 1.641814975148294e-03*G0_34;
    block[26] = -1.859868526535185e-04*G0_0 - 2.159157714713257e-04*G0_1 - 1.859868526535183e-04*G0_2 + 2.886002886002866e-04*G0_3 + 8.551119662230810e-05*G0_4 + 2.693602693602665e-04*G0_5 - 1.710223932445960e-05*G0_6 - 3.420447864892080e-05*G0_7 - 1.795735129068455e-04*G0_8 - 3.420447864892134e-05*G0_9 - 1.710223932445973e-05*G0_10 + 2.693602693602665e-04*G0_11 + 8.551119662230858e-05*G0_12 + 5.130671797338442e-04*G0_13 - 7.696007696007634e-05*G0_14 + 1.026134359467689e-04*G0_15 + 9.748276414943031e-04*G0_16 - 1.013307679974340e-03*G0_17 + 5.130671797338466e-05*G0_18 + 5.130671797338441e-04*G0_19 - 7.696007696007833e-05*G0_20 + 1.026134359467694e-04*G0_21 - 1.436588103254759e-03*G0_22 + 3.899310565977212e-03*G0_23 - 1.026134359467686e-03*G0_24 - 2.052268718935372e-03*G0_25 + 7.798621131954417e-03*G0_26 - 2.052268718935370e-03*G0_27 + 3.899310565977209e-03*G0_28 - 1.436588103254760e-03*G0_29 - 1.026134359467686e-03*G0_30 - 1.436588103254757e-03*G0_31 - 2.052268718935377e-04*G0_32 - 1.436588103254758e-03*G0_33 + 1.641814975148309e-03*G0_34;
    block[27] = 2.886002886002868e-04*G0_0 - 2.159157714713252e-04*G0_1 - 1.859868526535184e-04*G0_2 - 1.859868526535179e-04*G0_3 + 8.551119662230522e-05*G0_4 + 2.693602693602689e-04*G0_5 - 1.710223932446094e-05*G0_6 + 5.130671797338425e-04*G0_7 - 7.696007696007640e-05*G0_8 + 1.026134359467640e-04*G0_9 + 5.130671797338137e-05*G0_10 - 1.013307679974336e-03*G0_11 + 9.748276414942991e-04*G0_12 + 1.026134359467669e-04*G0_13 - 7.696007696007489e-05*G0_14 + 5.130671797338424e-04*G0_15 + 8.551119662230698e-05*G0_16 + 2.693602693602671e-04*G0_17 - 1.710223932446091e-05*G0_18 - 3.420447864892184e-05*G0_19 - 1.795735129068450e-04*G0_20 - 3.420447864892299e-05*G0_21 - 2.052268718935352e-04*G0_22 - 1.436588103254764e-03*G0_23 - 1.436588103254762e-03*G0_24 - 2.052268718935374e-03*G0_25 - 2.052268718935371e-03*G0_26 + 7.798621131954415e-03*G0_27 - 1.026134359467686e-03*G0_28 - 1.436588103254760e-03*G0_29 + 3.899310565977205e-03*G0_30 + 3.899310565977199e-03*G0_31 - 1.436588103254755e-03*G0_32 - 1.026134359467686e-03*G0_33 + 1.641814975148292e-03*G0_34;
    block[28] = -1.859868526535184e-04*G0_0 - 1.859868526535176e-04*G0_1 - 2.159157714713259e-04*G0_2 + 2.886002886002866e-04*G0_3 - 1.710223932446075e-05*G0_4 + 2.693602693602669e-04*G0_5 + 8.551119662230880e-05*G0_6 + 8.551119662230796e-05*G0_7 + 2.693602693602662e-04*G0_8 - 1.710223932446043e-05*G0_9 - 3.420447864892103e-05*G0_10 - 1.795735129068439e-04*G0_11 - 3.420447864892178e-05*G0_12 + 5.130671797338433e-04*G0_13 - 7.696007696007652e-05*G0_14 + 1.026134359467677e-04*G0_15 + 5.130671797338437e-04*G0_16 - 7.696007696007713e-05*G0_17 + 1.026134359467684e-04*G0_18 + 9.748276414943024e-04*G0_19 - 1.013307679974341e-03*G0_20 + 5.130671797338397e-05*G0_21 - 1.026134359467686e-03*G0_22 + 3.899310565977209e-03*G0_23 - 1.436588103254762e-03*G0_24 - 1.436588103254763e-03*G0_25 + 3.899310565977209e-03*G0_26 - 1.026134359467686e-03*G0_27 + 7.798621131954412e-03*G0_28 - 2.052268718935372e-03*G0_29 - 2.052268718935370e-03*G0_30 - 1.436588103254759e-03*G0_31 - 1.436588103254758e-03*G0_32 - 2.052268718935392e-04*G0_33 + 1.641814975148305e-03*G0_34;
    block[29] = -1.859868526535178e-04*G0_0 + 2.886002886002879e-04*G0_1 - 2.159157714713256e-04*G0_2 - 1.859868526535185e-04*G0_3 + 5.130671797338371e-05*G0_4 - 1.013307679974338e-03*G0_5 + 9.748276414943014e-04*G0_6 + 8.551119662230728e-05*G0_7 + 2.693602693602679e-04*G0_8 - 1.710223932446006e-05*G0_9 + 5.130671797338432e-04*G0_10 - 7.696007696007973e-05*G0_11 + 1.026134359467670e-04*G0_12 - 3.420447864892205e-05*G0_13 - 1.795735129068435e-04*G0_14 - 3.420447864892161e-05*G0_15 + 1.026134359467675e-04*G0_16 - 7.696007696007599e-05*G0_17 + 5.130671797338434e-04*G0_18 + 8.551119662230676e-05*G0_19 + 2.693602693602662e-04*G0_20 - 1.710223932446105e-05*G0_21 + 3.899310565977213e-03*G0_22 - 1.026134359467684e-03*G0_23 - 1.436588103254761e-03*G0_24 - 2.052268718935382e-04*G0_25 - 1.436588103254760e-03*G0_26 - 1.436588103254760e-03*G0_27 - 2.052268718935371e-03*G0_28 + 7.798621131954410e-03*G0_29 - 2.052268718935372e-03*G0_30 - 1.026134359467685e-03*G0_31 + 3.899310565977204e-03*G0_32 - 1.436588103254758e-03*G0_33 + 1.641814975148297e-03*G0_34;
    block[30] = 2.886002886002868e-04*G0_0 - 1.859868526535173e-04*G0_1 - 2.159157714713251e-04*G0_2 - 1.859868526535176e-04*G0_3 - 1.710223932446192e-05*G0_4 + 2.693602693602677e-04*G0_5 + 8.551119662230747e-05*G0_6 + 9.748276414942997e-04*G0_7 - 1.013307679974337e-03*G0_8 + 5.130671797338016e-05*G0_9 + 1.026134359467641e-04*G0_10 - 7.696007696007599e-05*G0_11 + 5.130671797338433e-04*G0_12 + 1.026134359467662e-04*G0_13 - 7.696007696007465e-05*G0_14 + 5.130671797338420e-04*G0_15 - 3.420447864892280e-05*G0_16 - 1.795735129068459e-04*G0_17 - 3.420447864892270e-05*G0_18 + 8.551119662230745e-05*G0_19 + 2.693602693602678e-04*G0_20 - 1.710223932446106e-05*G0_21 - 1.436588103254760e-03*G0_22 - 1.436588103254764e-03*G0_23 - 2.052268718935346e-04*G0_24 - 1.436588103254758e-03*G0_25 - 1.026134359467686e-03*G0_26 + 3.899310565977205e-03*G0_27 - 2.052268718935370e-03*G0_28 - 2.052268718935372e-03*G0_29 + 7.798621131954405e-03*G0_30 + 3.899310565977198e-03*G0_31 - 1.026134359467683e-03*G0_32 - 1.436588103254756e-03*G0_33 + 1.641814975148294e-03*G0_34;
    block[31] = 2.886002886002868e-04*G0_0 - 1.859868526535173e-04*G0_1 - 1.859868526535183e-04*G0_2 - 2.159157714713244e-04*G0_3 - 3.420447864892429e-05*G0_4 - 1.795735129068440e-04*G0_5 - 3.420447864892212e-05*G0_6 + 5.130671797338425e-04*G0_7 - 7.696007696007606e-05*G0_8 + 1.026134359467659e-04*G0_9 + 1.026134359467670e-04*G0_10 - 7.696007696007572e-05*G0_11 + 5.130671797338420e-04*G0_12 + 5.130671797338296e-05*G0_13 - 1.013307679974337e-03*G0_14 + 9.748276414942988e-04*G0_15 - 1.710223932446184e-05*G0_16 + 2.693602693602665e-04*G0_17 + 8.551119662230725e-05*G0_18 - 1.710223932446051e-05*G0_19 + 2.693602693602673e-04*G0_20 + 8.551119662230720e-05*G0_21 - 1.436588103254758e-03*G0_22 - 2.052268718935406e-04*G0_23 - 1.436588103254759e-03*G0_24 - 1.026134359467685e-03*G0_25 - 1.436588103254757e-03*G0_26 + 3.899310565977200e-03*G0_27 - 1.436588103254759e-03*G0_28 - 1.026134359467685e-03*G0_29 + 3.899310565977198e-03*G0_30 + 7.798621131954403e-03*G0_31 - 2.052268718935366e-03*G0_32 - 2.052268718935367e-03*G0_33 + 1.641814975148292e-03*G0_34;
    block[32] = -1.859868526535178e-04*G0_0 + 2.886002886002877e-04*G0_1 - 1.859868526535186e-04*G0_2 - 2.159157714713259e-04*G0_3 + 1.026134359467705e-04*G0_4 - 7.696007696007779e-05*G0_5 + 5.130671797338444e-04*G0_6 - 3.420447864892089e-05*G0_7 - 1.795735129068450e-04*G0_8 - 3.420447864892102e-05*G0_9 + 5.130671797338442e-04*G0_10 - 7.696007696007904e-05*G0_11 + 1.026134359467698e-04*G0_12 - 1.710223932445962e-05*G0_13 + 2.693602693602671e-04*G0_14 + 8.551119662230954e-05*G0_15 + 5.130671797338483e-05*G0_16 - 1.013307679974339e-03*G0_17 + 9.748276414943013e-04*G0_18 - 1.710223932446016e-05*G0_19 + 2.693602693602648e-04*G0_20 + 8.551119662230912e-05*G0_21 + 3.899310565977204e-03*G0_22 - 1.436588103254755e-03*G0_23 - 1.026134359467685e-03*G0_24 - 1.436588103254759e-03*G0_25 - 2.052268718935378e-04*G0_26 - 1.436588103254755e-03*G0_27 - 1.436588103254758e-03*G0_28 + 3.899310565977204e-03*G0_29 - 1.026134359467683e-03*G0_30 - 2.052268718935365e-03*G0_31 + 7.798621131954404e-03*G0_32 - 2.052268718935370e-03*G0_33 + 1.641814975148302e-03*G0_34;
    block[33] = -1.859868526535181e-04*G0_0 - 1.859868526535171e-04*G0_1 + 2.886002886002870e-04*G0_2 - 2.159157714713254e-04*G0_3 + 5.130671797338432e-04*G0_4 - 7.696007696007652e-05*G0_5 + 1.026134359467677e-04*G0_6 + 1.026134359467677e-04*G0_7 - 7.696007696007599e-05*G0_8 + 5.130671797338421e-04*G0_9 - 3.420447864892289e-05*G0_10 - 1.795735129068424e-04*G0_11 - 3.420447864892278e-05*G0_12 - 1.710223932446077e-05*G0_13 + 2.693602693602676e-04*G0_14 + 8.551119662230729e-05*G0_15 - 1.710223932446061e-05*G0_16 + 2.693602693602658e-04*G0_17 + 8.551119662230762e-05*G0_18 + 5.130671797338360e-05*G0_19 - 1.013307679974337e-03*G0_20 + 9.748276414942996e-04*G0_21 - 1.026134359467686e-03*G0_22 - 1.436588103254758e-03*G0_23 + 3.899310565977202e-03*G0_24 + 3.899310565977206e-03*G0_25 - 1.436588103254758e-03*G0_26 - 1.026134359467687e-03*G0_27 - 2.052268718935392e-04*G0_28 - 1.436588103254758e-03*G0_29 - 1.436588103254756e-03*G0_30 - 2.052268718935367e-03*G0_31 - 2.052268718935370e-03*G0_32 + 7.798621131954400e-03*G0_33 + 1.641814975148288e-03*G0_34;
    block[34] = -5.387205387205359e-04*G0_0 - 5.387205387205288e-04*G0_1 - 5.387205387205360e-04*G0_2 - 5.387205387205360e-04*G0_3 + 1.094543316765532e-03*G0_4 - 1.026134359467686e-03*G0_5 + 1.094543316765535e-03*G0_6 + 1.094543316765531e-03*G0_7 - 1.026134359467684e-03*G0_8 + 1.094543316765529e-03*G0_9 + 1.094543316765529e-03*G0_10 - 1.026134359467682e-03*G0_11 + 1.094543316765531e-03*G0_12 + 1.094543316765535e-03*G0_13 - 1.026134359467679e-03*G0_14 + 1.094543316765532e-03*G0_15 + 1.094543316765534e-03*G0_16 - 1.026134359467692e-03*G0_17 + 1.094543316765533e-03*G0_18 + 1.094543316765535e-03*G0_19 - 1.026134359467690e-03*G0_20 + 1.094543316765532e-03*G0_21 + 1.641814975148303e-03*G0_22 + 1.641814975148307e-03*G0_23 + 1.641814975148293e-03*G0_24 + 1.641814975148294e-03*G0_25 + 1.641814975148310e-03*G0_26 + 1.641814975148293e-03*G0_27 + 1.641814975148305e-03*G0_28 + 1.641814975148298e-03*G0_29 + 1.641814975148294e-03*G0_30 + 1.641814975148290e-03*G0_31 + 1.641814975148302e-03*G0_32 + 1.641814975148287e-03*G0_33 + 2.626903960237277e-02*G0_34;
  }

};

} }

#endif
