// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.8.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __NSEMOMENTUM_H
#define __NSEMOMENTUM_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace NSEMomentum {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = 3*cell.id() + 0;
      dofs[1] = 3*cell.id() + 1;
      dofs[2] = 3*cell.id() + 2;
      int offset = 3*mesh.noCells();
      dofs[3] = offset + 3*cell.id() + 0;
      dofs[4] = offset + 3*cell.id() + 1;
      dofs[5] = offset + 3*cell.id() + 2;
      offset = offset + 3*mesh.noCells();
      dofs[6] = offset + 3*cell.id() + 0;
      dofs[7] = offset + 3*cell.id() + 1;
      dofs[8] = offset + 3*cell.id() + 2;
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[1] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[2] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 1;
      components[2] = 2;
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm(Function& w0, const real& c0, const real& c1, const real& c2, const real& c3) : dolfin::BilinearForm(1), c0(c0), c1(c1), c2(c2), c3(c3)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_ = map.det;
    real G1_0_0 = map.det*c0*c1*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G1_0_1 = map.det*c0*c1*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G1_0_2 = map.det*c0*c1*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G1_1_0 = map.det*c0*c1*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G1_1_1 = map.det*c0*c1*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G1_1_2 = map.det*c0*c1*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G1_2_0 = map.det*c0*c1*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G1_2_1 = map.det*c0*c1*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G1_2_2 = map.det*c0*c1*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);
    real G2_0_0_0 = map.det*c0*c[0][0]*map.g00;
    real G2_0_0_1 = map.det*c0*c[0][0]*map.g10;
    real G2_0_0_2 = map.det*c0*c[0][0]*map.g20;
    real G2_1_1_0 = map.det*c0*c[0][1]*map.g01;
    real G2_1_1_1 = map.det*c0*c[0][1]*map.g11;
    real G2_1_1_2 = map.det*c0*c[0][1]*map.g21;
    real G2_2_2_0 = map.det*c0*c[0][2]*map.g02;
    real G2_2_2_1 = map.det*c0*c[0][2]*map.g12;
    real G2_2_2_2 = map.det*c0*c[0][2]*map.g22;
    real G3_0_0_0_0 = map.det*c3*c0*map.g00*map.g00;
    real G3_0_0_0_1 = map.det*c3*c0*map.g00*map.g10;
    real G3_0_0_0_2 = map.det*c3*c0*map.g00*map.g20;
    real G3_0_0_1_0 = map.det*c3*c0*map.g10*map.g00;
    real G3_0_0_1_1 = map.det*c3*c0*map.g10*map.g10;
    real G3_0_0_1_2 = map.det*c3*c0*map.g10*map.g20;
    real G3_0_0_2_0 = map.det*c3*c0*map.g20*map.g00;
    real G3_0_0_2_1 = map.det*c3*c0*map.g20*map.g10;
    real G3_0_0_2_2 = map.det*c3*c0*map.g20*map.g20;
    real G3_0_1_0_0 = map.det*c3*c0*map.g00*map.g01;
    real G3_0_1_0_1 = map.det*c3*c0*map.g00*map.g11;
    real G3_0_1_0_2 = map.det*c3*c0*map.g00*map.g21;
    real G3_0_1_1_0 = map.det*c3*c0*map.g10*map.g01;
    real G3_0_1_1_1 = map.det*c3*c0*map.g10*map.g11;
    real G3_0_1_1_2 = map.det*c3*c0*map.g10*map.g21;
    real G3_0_1_2_0 = map.det*c3*c0*map.g20*map.g01;
    real G3_0_1_2_1 = map.det*c3*c0*map.g20*map.g11;
    real G3_0_1_2_2 = map.det*c3*c0*map.g20*map.g21;
    real G3_0_2_0_0 = map.det*c3*c0*map.g00*map.g02;
    real G3_0_2_0_1 = map.det*c3*c0*map.g00*map.g12;
    real G3_0_2_0_2 = map.det*c3*c0*map.g00*map.g22;
    real G3_0_2_1_0 = map.det*c3*c0*map.g10*map.g02;
    real G3_0_2_1_1 = map.det*c3*c0*map.g10*map.g12;
    real G3_0_2_1_2 = map.det*c3*c0*map.g10*map.g22;
    real G3_0_2_2_0 = map.det*c3*c0*map.g20*map.g02;
    real G3_0_2_2_1 = map.det*c3*c0*map.g20*map.g12;
    real G3_0_2_2_2 = map.det*c3*c0*map.g20*map.g22;
    real G3_1_0_0_0 = map.det*c3*c0*map.g01*map.g00;
    real G3_1_0_0_1 = map.det*c3*c0*map.g01*map.g10;
    real G3_1_0_0_2 = map.det*c3*c0*map.g01*map.g20;
    real G3_1_0_1_0 = map.det*c3*c0*map.g11*map.g00;
    real G3_1_0_1_1 = map.det*c3*c0*map.g11*map.g10;
    real G3_1_0_1_2 = map.det*c3*c0*map.g11*map.g20;
    real G3_1_0_2_0 = map.det*c3*c0*map.g21*map.g00;
    real G3_1_0_2_1 = map.det*c3*c0*map.g21*map.g10;
    real G3_1_0_2_2 = map.det*c3*c0*map.g21*map.g20;
    real G3_1_1_0_0 = map.det*c3*c0*map.g01*map.g01;
    real G3_1_1_0_1 = map.det*c3*c0*map.g01*map.g11;
    real G3_1_1_0_2 = map.det*c3*c0*map.g01*map.g21;
    real G3_1_1_1_0 = map.det*c3*c0*map.g11*map.g01;
    real G3_1_1_1_1 = map.det*c3*c0*map.g11*map.g11;
    real G3_1_1_1_2 = map.det*c3*c0*map.g11*map.g21;
    real G3_1_1_2_0 = map.det*c3*c0*map.g21*map.g01;
    real G3_1_1_2_1 = map.det*c3*c0*map.g21*map.g11;
    real G3_1_1_2_2 = map.det*c3*c0*map.g21*map.g21;
    real G3_1_2_0_0 = map.det*c3*c0*map.g01*map.g02;
    real G3_1_2_0_1 = map.det*c3*c0*map.g01*map.g12;
    real G3_1_2_0_2 = map.det*c3*c0*map.g01*map.g22;
    real G3_1_2_1_0 = map.det*c3*c0*map.g11*map.g02;
    real G3_1_2_1_1 = map.det*c3*c0*map.g11*map.g12;
    real G3_1_2_1_2 = map.det*c3*c0*map.g11*map.g22;
    real G3_1_2_2_0 = map.det*c3*c0*map.g21*map.g02;
    real G3_1_2_2_1 = map.det*c3*c0*map.g21*map.g12;
    real G3_1_2_2_2 = map.det*c3*c0*map.g21*map.g22;
    real G3_2_0_0_0 = map.det*c3*c0*map.g02*map.g00;
    real G3_2_0_0_1 = map.det*c3*c0*map.g02*map.g10;
    real G3_2_0_0_2 = map.det*c3*c0*map.g02*map.g20;
    real G3_2_0_1_0 = map.det*c3*c0*map.g12*map.g00;
    real G3_2_0_1_1 = map.det*c3*c0*map.g12*map.g10;
    real G3_2_0_1_2 = map.det*c3*c0*map.g12*map.g20;
    real G3_2_0_2_0 = map.det*c3*c0*map.g22*map.g00;
    real G3_2_0_2_1 = map.det*c3*c0*map.g22*map.g10;
    real G3_2_0_2_2 = map.det*c3*c0*map.g22*map.g20;
    real G3_2_1_0_0 = map.det*c3*c0*map.g02*map.g01;
    real G3_2_1_0_1 = map.det*c3*c0*map.g02*map.g11;
    real G3_2_1_0_2 = map.det*c3*c0*map.g02*map.g21;
    real G3_2_1_1_0 = map.det*c3*c0*map.g12*map.g01;
    real G3_2_1_1_1 = map.det*c3*c0*map.g12*map.g11;
    real G3_2_1_1_2 = map.det*c3*c0*map.g12*map.g21;
    real G3_2_1_2_0 = map.det*c3*c0*map.g22*map.g01;
    real G3_2_1_2_1 = map.det*c3*c0*map.g22*map.g11;
    real G3_2_1_2_2 = map.det*c3*c0*map.g22*map.g21;
    real G3_2_2_0_0 = map.det*c3*c0*map.g02*map.g02;
    real G3_2_2_0_1 = map.det*c3*c0*map.g02*map.g12;
    real G3_2_2_0_2 = map.det*c3*c0*map.g02*map.g22;
    real G3_2_2_1_0 = map.det*c3*c0*map.g12*map.g02;
    real G3_2_2_1_1 = map.det*c3*c0*map.g12*map.g12;
    real G3_2_2_1_2 = map.det*c3*c0*map.g12*map.g22;
    real G3_2_2_2_0 = map.det*c3*c0*map.g22*map.g02;
    real G3_2_2_2_1 = map.det*c3*c0*map.g22*map.g12;
    real G3_2_2_2_2 = map.det*c3*c0*map.g22*map.g22;
    real G4_0_0_0_0_0_0 = map.det*c2*c0*c[0][0]*c[0][0]*map.g00*map.g00;
    real G4_0_0_0_0_0_1 = map.det*c2*c0*c[0][0]*c[0][0]*map.g00*map.g10;
    real G4_0_0_0_0_0_2 = map.det*c2*c0*c[0][0]*c[0][0]*map.g00*map.g20;
    real G4_0_0_0_1_0_0 = map.det*c2*c0*c[0][0]*c[0][0]*map.g10*map.g00;
    real G4_0_0_0_1_0_1 = map.det*c2*c0*c[0][0]*c[0][0]*map.g10*map.g10;
    real G4_0_0_0_1_0_2 = map.det*c2*c0*c[0][0]*c[0][0]*map.g10*map.g20;
    real G4_0_0_0_2_0_0 = map.det*c2*c0*c[0][0]*c[0][0]*map.g20*map.g00;
    real G4_0_0_0_2_0_1 = map.det*c2*c0*c[0][0]*c[0][0]*map.g20*map.g10;
    real G4_0_0_0_2_0_2 = map.det*c2*c0*c[0][0]*c[0][0]*map.g20*map.g20;
    real G4_0_1_0_0_1_0 = map.det*c2*c0*c[0][0]*c[0][1]*map.g00*map.g01;
    real G4_0_1_0_0_1_1 = map.det*c2*c0*c[0][0]*c[0][1]*map.g00*map.g11;
    real G4_0_1_0_0_1_2 = map.det*c2*c0*c[0][0]*c[0][1]*map.g00*map.g21;
    real G4_0_1_0_1_1_0 = map.det*c2*c0*c[0][0]*c[0][1]*map.g10*map.g01;
    real G4_0_1_0_1_1_1 = map.det*c2*c0*c[0][0]*c[0][1]*map.g10*map.g11;
    real G4_0_1_0_1_1_2 = map.det*c2*c0*c[0][0]*c[0][1]*map.g10*map.g21;
    real G4_0_1_0_2_1_0 = map.det*c2*c0*c[0][0]*c[0][1]*map.g20*map.g01;
    real G4_0_1_0_2_1_1 = map.det*c2*c0*c[0][0]*c[0][1]*map.g20*map.g11;
    real G4_0_1_0_2_1_2 = map.det*c2*c0*c[0][0]*c[0][1]*map.g20*map.g21;
    real G4_0_2_0_0_2_0 = map.det*c2*c0*c[0][0]*c[0][2]*map.g00*map.g02;
    real G4_0_2_0_0_2_1 = map.det*c2*c0*c[0][0]*c[0][2]*map.g00*map.g12;
    real G4_0_2_0_0_2_2 = map.det*c2*c0*c[0][0]*c[0][2]*map.g00*map.g22;
    real G4_0_2_0_1_2_0 = map.det*c2*c0*c[0][0]*c[0][2]*map.g10*map.g02;
    real G4_0_2_0_1_2_1 = map.det*c2*c0*c[0][0]*c[0][2]*map.g10*map.g12;
    real G4_0_2_0_1_2_2 = map.det*c2*c0*c[0][0]*c[0][2]*map.g10*map.g22;
    real G4_0_2_0_2_2_0 = map.det*c2*c0*c[0][0]*c[0][2]*map.g20*map.g02;
    real G4_0_2_0_2_2_1 = map.det*c2*c0*c[0][0]*c[0][2]*map.g20*map.g12;
    real G4_0_2_0_2_2_2 = map.det*c2*c0*c[0][0]*c[0][2]*map.g20*map.g22;
    real G4_1_0_1_0_0_0 = map.det*c2*c0*c[0][1]*c[0][0]*map.g01*map.g00;
    real G4_1_0_1_0_0_1 = map.det*c2*c0*c[0][1]*c[0][0]*map.g01*map.g10;
    real G4_1_0_1_0_0_2 = map.det*c2*c0*c[0][1]*c[0][0]*map.g01*map.g20;
    real G4_1_0_1_1_0_0 = map.det*c2*c0*c[0][1]*c[0][0]*map.g11*map.g00;
    real G4_1_0_1_1_0_1 = map.det*c2*c0*c[0][1]*c[0][0]*map.g11*map.g10;
    real G4_1_0_1_1_0_2 = map.det*c2*c0*c[0][1]*c[0][0]*map.g11*map.g20;
    real G4_1_0_1_2_0_0 = map.det*c2*c0*c[0][1]*c[0][0]*map.g21*map.g00;
    real G4_1_0_1_2_0_1 = map.det*c2*c0*c[0][1]*c[0][0]*map.g21*map.g10;
    real G4_1_0_1_2_0_2 = map.det*c2*c0*c[0][1]*c[0][0]*map.g21*map.g20;
    real G4_1_1_1_0_1_0 = map.det*c2*c0*c[0][1]*c[0][1]*map.g01*map.g01;
    real G4_1_1_1_0_1_1 = map.det*c2*c0*c[0][1]*c[0][1]*map.g01*map.g11;
    real G4_1_1_1_0_1_2 = map.det*c2*c0*c[0][1]*c[0][1]*map.g01*map.g21;
    real G4_1_1_1_1_1_0 = map.det*c2*c0*c[0][1]*c[0][1]*map.g11*map.g01;
    real G4_1_1_1_1_1_1 = map.det*c2*c0*c[0][1]*c[0][1]*map.g11*map.g11;
    real G4_1_1_1_1_1_2 = map.det*c2*c0*c[0][1]*c[0][1]*map.g11*map.g21;
    real G4_1_1_1_2_1_0 = map.det*c2*c0*c[0][1]*c[0][1]*map.g21*map.g01;
    real G4_1_1_1_2_1_1 = map.det*c2*c0*c[0][1]*c[0][1]*map.g21*map.g11;
    real G4_1_1_1_2_1_2 = map.det*c2*c0*c[0][1]*c[0][1]*map.g21*map.g21;
    real G4_1_2_1_0_2_0 = map.det*c2*c0*c[0][1]*c[0][2]*map.g01*map.g02;
    real G4_1_2_1_0_2_1 = map.det*c2*c0*c[0][1]*c[0][2]*map.g01*map.g12;
    real G4_1_2_1_0_2_2 = map.det*c2*c0*c[0][1]*c[0][2]*map.g01*map.g22;
    real G4_1_2_1_1_2_0 = map.det*c2*c0*c[0][1]*c[0][2]*map.g11*map.g02;
    real G4_1_2_1_1_2_1 = map.det*c2*c0*c[0][1]*c[0][2]*map.g11*map.g12;
    real G4_1_2_1_1_2_2 = map.det*c2*c0*c[0][1]*c[0][2]*map.g11*map.g22;
    real G4_1_2_1_2_2_0 = map.det*c2*c0*c[0][1]*c[0][2]*map.g21*map.g02;
    real G4_1_2_1_2_2_1 = map.det*c2*c0*c[0][1]*c[0][2]*map.g21*map.g12;
    real G4_1_2_1_2_2_2 = map.det*c2*c0*c[0][1]*c[0][2]*map.g21*map.g22;
    real G4_2_0_2_0_0_0 = map.det*c2*c0*c[0][2]*c[0][0]*map.g02*map.g00;
    real G4_2_0_2_0_0_1 = map.det*c2*c0*c[0][2]*c[0][0]*map.g02*map.g10;
    real G4_2_0_2_0_0_2 = map.det*c2*c0*c[0][2]*c[0][0]*map.g02*map.g20;
    real G4_2_0_2_1_0_0 = map.det*c2*c0*c[0][2]*c[0][0]*map.g12*map.g00;
    real G4_2_0_2_1_0_1 = map.det*c2*c0*c[0][2]*c[0][0]*map.g12*map.g10;
    real G4_2_0_2_1_0_2 = map.det*c2*c0*c[0][2]*c[0][0]*map.g12*map.g20;
    real G4_2_0_2_2_0_0 = map.det*c2*c0*c[0][2]*c[0][0]*map.g22*map.g00;
    real G4_2_0_2_2_0_1 = map.det*c2*c0*c[0][2]*c[0][0]*map.g22*map.g10;
    real G4_2_0_2_2_0_2 = map.det*c2*c0*c[0][2]*c[0][0]*map.g22*map.g20;
    real G4_2_1_2_0_1_0 = map.det*c2*c0*c[0][2]*c[0][1]*map.g02*map.g01;
    real G4_2_1_2_0_1_1 = map.det*c2*c0*c[0][2]*c[0][1]*map.g02*map.g11;
    real G4_2_1_2_0_1_2 = map.det*c2*c0*c[0][2]*c[0][1]*map.g02*map.g21;
    real G4_2_1_2_1_1_0 = map.det*c2*c0*c[0][2]*c[0][1]*map.g12*map.g01;
    real G4_2_1_2_1_1_1 = map.det*c2*c0*c[0][2]*c[0][1]*map.g12*map.g11;
    real G4_2_1_2_1_1_2 = map.det*c2*c0*c[0][2]*c[0][1]*map.g12*map.g21;
    real G4_2_1_2_2_1_0 = map.det*c2*c0*c[0][2]*c[0][1]*map.g22*map.g01;
    real G4_2_1_2_2_1_1 = map.det*c2*c0*c[0][2]*c[0][1]*map.g22*map.g11;
    real G4_2_1_2_2_1_2 = map.det*c2*c0*c[0][2]*c[0][1]*map.g22*map.g21;
    real G4_2_2_2_0_2_0 = map.det*c2*c0*c[0][2]*c[0][2]*map.g02*map.g02;
    real G4_2_2_2_0_2_1 = map.det*c2*c0*c[0][2]*c[0][2]*map.g02*map.g12;
    real G4_2_2_2_0_2_2 = map.det*c2*c0*c[0][2]*c[0][2]*map.g02*map.g22;
    real G4_2_2_2_1_2_0 = map.det*c2*c0*c[0][2]*c[0][2]*map.g12*map.g02;
    real G4_2_2_2_1_2_1 = map.det*c2*c0*c[0][2]*c[0][2]*map.g12*map.g12;
    real G4_2_2_2_1_2_2 = map.det*c2*c0*c[0][2]*c[0][2]*map.g12*map.g22;
    real G4_2_2_2_2_2_0 = map.det*c2*c0*c[0][2]*c[0][2]*map.g22*map.g02;
    real G4_2_2_2_2_2_1 = map.det*c2*c0*c[0][2]*c[0][2]*map.g22*map.g12;
    real G4_2_2_2_2_2_2 = map.det*c2*c0*c[0][2]*c[0][2]*map.g22*map.g22;

    // Compute element tensor
    block[0] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 8.333333333333322e-02*G1_0_1 + 8.333333333333320e-02*G1_0_2 + 8.333333333333322e-02*G1_1_0 + 8.333333333333323e-02*G1_1_1 + 8.333333333333322e-02*G1_1_2 + 8.333333333333320e-02*G1_2_0 + 8.333333333333322e-02*G1_2_1 + 8.333333333333320e-02*G1_2_2 - 2.083333333333331e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333331e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333331e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 + 8.333333333333320e-02*G3_0_0_0_0 + 8.333333333333322e-02*G3_0_0_0_1 + 8.333333333333320e-02*G3_0_0_0_2 + 8.333333333333322e-02*G3_0_0_1_0 + 8.333333333333323e-02*G3_0_0_1_1 + 8.333333333333322e-02*G3_0_0_1_2 + 8.333333333333320e-02*G3_0_0_2_0 + 8.333333333333322e-02*G3_0_0_2_1 + 8.333333333333320e-02*G3_0_0_2_2 + 8.333333333333320e-02*G4_0_0_0_0_0_0 + 8.333333333333322e-02*G4_0_0_0_0_0_1 + 8.333333333333320e-02*G4_0_0_0_0_0_2 + 8.333333333333322e-02*G4_0_0_0_1_0_0 + 8.333333333333323e-02*G4_0_0_0_1_0_1 + 8.333333333333322e-02*G4_0_0_0_1_0_2 + 8.333333333333320e-02*G4_0_0_0_2_0_0 + 8.333333333333322e-02*G4_0_0_0_2_0_1 + 8.333333333333320e-02*G4_0_0_0_2_0_2 + 8.333333333333320e-02*G4_0_1_0_0_1_0 + 8.333333333333322e-02*G4_0_1_0_0_1_1 + 8.333333333333320e-02*G4_0_1_0_0_1_2 + 8.333333333333322e-02*G4_0_1_0_1_1_0 + 8.333333333333323e-02*G4_0_1_0_1_1_1 + 8.333333333333322e-02*G4_0_1_0_1_1_2 + 8.333333333333320e-02*G4_0_1_0_2_1_0 + 8.333333333333322e-02*G4_0_1_0_2_1_1 + 8.333333333333320e-02*G4_0_1_0_2_1_2 + 8.333333333333320e-02*G4_0_2_0_0_2_0 + 8.333333333333322e-02*G4_0_2_0_0_2_1 + 8.333333333333320e-02*G4_0_2_0_0_2_2 + 8.333333333333322e-02*G4_0_2_0_1_2_0 + 8.333333333333323e-02*G4_0_2_0_1_2_1 + 8.333333333333322e-02*G4_0_2_0_1_2_2 + 8.333333333333320e-02*G4_0_2_0_2_2_0 + 8.333333333333322e-02*G4_0_2_0_2_2_1 + 8.333333333333320e-02*G4_0_2_0_2_2_2 + 8.333333333333320e-02*G4_1_0_1_0_0_0 + 8.333333333333322e-02*G4_1_0_1_0_0_1 + 8.333333333333320e-02*G4_1_0_1_0_0_2 + 8.333333333333322e-02*G4_1_0_1_1_0_0 + 8.333333333333323e-02*G4_1_0_1_1_0_1 + 8.333333333333322e-02*G4_1_0_1_1_0_2 + 8.333333333333320e-02*G4_1_0_1_2_0_0 + 8.333333333333322e-02*G4_1_0_1_2_0_1 + 8.333333333333320e-02*G4_1_0_1_2_0_2 + 8.333333333333320e-02*G4_1_1_1_0_1_0 + 8.333333333333322e-02*G4_1_1_1_0_1_1 + 8.333333333333320e-02*G4_1_1_1_0_1_2 + 8.333333333333322e-02*G4_1_1_1_1_1_0 + 8.333333333333323e-02*G4_1_1_1_1_1_1 + 8.333333333333322e-02*G4_1_1_1_1_1_2 + 8.333333333333320e-02*G4_1_1_1_2_1_0 + 8.333333333333322e-02*G4_1_1_1_2_1_1 + 8.333333333333320e-02*G4_1_1_1_2_1_2 + 8.333333333333320e-02*G4_1_2_1_0_2_0 + 8.333333333333322e-02*G4_1_2_1_0_2_1 + 8.333333333333320e-02*G4_1_2_1_0_2_2 + 8.333333333333322e-02*G4_1_2_1_1_2_0 + 8.333333333333323e-02*G4_1_2_1_1_2_1 + 8.333333333333322e-02*G4_1_2_1_1_2_2 + 8.333333333333320e-02*G4_1_2_1_2_2_0 + 8.333333333333322e-02*G4_1_2_1_2_2_1 + 8.333333333333320e-02*G4_1_2_1_2_2_2 + 8.333333333333320e-02*G4_2_0_2_0_0_0 + 8.333333333333322e-02*G4_2_0_2_0_0_1 + 8.333333333333320e-02*G4_2_0_2_0_0_2 + 8.333333333333322e-02*G4_2_0_2_1_0_0 + 8.333333333333323e-02*G4_2_0_2_1_0_1 + 8.333333333333322e-02*G4_2_0_2_1_0_2 + 8.333333333333320e-02*G4_2_0_2_2_0_0 + 8.333333333333322e-02*G4_2_0_2_2_0_1 + 8.333333333333320e-02*G4_2_0_2_2_0_2 + 8.333333333333320e-02*G4_2_1_2_0_1_0 + 8.333333333333322e-02*G4_2_1_2_0_1_1 + 8.333333333333320e-02*G4_2_1_2_0_1_2 + 8.333333333333322e-02*G4_2_1_2_1_1_0 + 8.333333333333323e-02*G4_2_1_2_1_1_1 + 8.333333333333322e-02*G4_2_1_2_1_1_2 + 8.333333333333320e-02*G4_2_1_2_2_1_0 + 8.333333333333322e-02*G4_2_1_2_2_1_1 + 8.333333333333320e-02*G4_2_1_2_2_1_2 + 8.333333333333320e-02*G4_2_2_2_0_2_0 + 8.333333333333322e-02*G4_2_2_2_0_2_1 + 8.333333333333320e-02*G4_2_2_2_0_2_2 + 8.333333333333322e-02*G4_2_2_2_1_2_0 + 8.333333333333323e-02*G4_2_2_2_1_2_1 + 8.333333333333322e-02*G4_2_2_2_1_2_2 + 8.333333333333320e-02*G4_2_2_2_2_2_0 + 8.333333333333322e-02*G4_2_2_2_2_2_1 + 8.333333333333320e-02*G4_2_2_2_2_2_2;
    block[1] = 8.333333333333311e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_1_0 - 8.333333333333320e-02*G1_2_0 + 2.083333333333331e-02*G2_0_0_0 + 2.083333333333331e-02*G2_1_1_0 + 2.083333333333331e-02*G2_2_2_0 - 8.333333333333320e-02*G3_0_0_0_0 - 8.333333333333322e-02*G3_0_0_1_0 - 8.333333333333320e-02*G3_0_0_2_0 - 8.333333333333320e-02*G4_0_0_0_0_0_0 - 8.333333333333322e-02*G4_0_0_0_1_0_0 - 8.333333333333320e-02*G4_0_0_0_2_0_0 - 8.333333333333320e-02*G4_0_1_0_0_1_0 - 8.333333333333322e-02*G4_0_1_0_1_1_0 - 8.333333333333320e-02*G4_0_1_0_2_1_0 - 8.333333333333320e-02*G4_0_2_0_0_2_0 - 8.333333333333322e-02*G4_0_2_0_1_2_0 - 8.333333333333320e-02*G4_0_2_0_2_2_0 - 8.333333333333320e-02*G4_1_0_1_0_0_0 - 8.333333333333322e-02*G4_1_0_1_1_0_0 - 8.333333333333320e-02*G4_1_0_1_2_0_0 - 8.333333333333320e-02*G4_1_1_1_0_1_0 - 8.333333333333322e-02*G4_1_1_1_1_1_0 - 8.333333333333320e-02*G4_1_1_1_2_1_0 - 8.333333333333320e-02*G4_1_2_1_0_2_0 - 8.333333333333322e-02*G4_1_2_1_1_2_0 - 8.333333333333320e-02*G4_1_2_1_2_2_0 - 8.333333333333320e-02*G4_2_0_2_0_0_0 - 8.333333333333322e-02*G4_2_0_2_1_0_0 - 8.333333333333320e-02*G4_2_0_2_2_0_0 - 8.333333333333320e-02*G4_2_1_2_0_1_0 - 8.333333333333322e-02*G4_2_1_2_1_1_0 - 8.333333333333320e-02*G4_2_1_2_2_1_0 - 8.333333333333320e-02*G4_2_2_2_0_2_0 - 8.333333333333322e-02*G4_2_2_2_1_2_0 - 8.333333333333320e-02*G4_2_2_2_2_2_0;
    block[2] = 8.333333333333312e-03*G0_ - 8.333333333333322e-02*G1_0_1 - 8.333333333333323e-02*G1_1_1 - 8.333333333333322e-02*G1_2_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 - 8.333333333333322e-02*G3_0_0_0_1 - 8.333333333333323e-02*G3_0_0_1_1 - 8.333333333333322e-02*G3_0_0_2_1 - 8.333333333333322e-02*G4_0_0_0_0_0_1 - 8.333333333333323e-02*G4_0_0_0_1_0_1 - 8.333333333333322e-02*G4_0_0_0_2_0_1 - 8.333333333333322e-02*G4_0_1_0_0_1_1 - 8.333333333333323e-02*G4_0_1_0_1_1_1 - 8.333333333333322e-02*G4_0_1_0_2_1_1 - 8.333333333333322e-02*G4_0_2_0_0_2_1 - 8.333333333333323e-02*G4_0_2_0_1_2_1 - 8.333333333333322e-02*G4_0_2_0_2_2_1 - 8.333333333333322e-02*G4_1_0_1_0_0_1 - 8.333333333333323e-02*G4_1_0_1_1_0_1 - 8.333333333333322e-02*G4_1_0_1_2_0_1 - 8.333333333333322e-02*G4_1_1_1_0_1_1 - 8.333333333333323e-02*G4_1_1_1_1_1_1 - 8.333333333333322e-02*G4_1_1_1_2_1_1 - 8.333333333333322e-02*G4_1_2_1_0_2_1 - 8.333333333333323e-02*G4_1_2_1_1_2_1 - 8.333333333333322e-02*G4_1_2_1_2_2_1 - 8.333333333333322e-02*G4_2_0_2_0_0_1 - 8.333333333333323e-02*G4_2_0_2_1_0_1 - 8.333333333333322e-02*G4_2_0_2_2_0_1 - 8.333333333333322e-02*G4_2_1_2_0_1_1 - 8.333333333333323e-02*G4_2_1_2_1_1_1 - 8.333333333333322e-02*G4_2_1_2_2_1_1 - 8.333333333333322e-02*G4_2_2_2_0_2_1 - 8.333333333333323e-02*G4_2_2_2_1_2_1 - 8.333333333333322e-02*G4_2_2_2_2_2_1;
    block[3] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_0_2 - 8.333333333333323e-02*G1_1_2 - 8.333333333333322e-02*G1_2_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 - 8.333333333333322e-02*G3_0_0_0_2 - 8.333333333333323e-02*G3_0_0_1_2 - 8.333333333333322e-02*G3_0_0_2_2 - 8.333333333333322e-02*G4_0_0_0_0_0_2 - 8.333333333333323e-02*G4_0_0_0_1_0_2 - 8.333333333333322e-02*G4_0_0_0_2_0_2 - 8.333333333333322e-02*G4_0_1_0_0_1_2 - 8.333333333333323e-02*G4_0_1_0_1_1_2 - 8.333333333333322e-02*G4_0_1_0_2_1_2 - 8.333333333333322e-02*G4_0_2_0_0_2_2 - 8.333333333333323e-02*G4_0_2_0_1_2_2 - 8.333333333333322e-02*G4_0_2_0_2_2_2 - 8.333333333333322e-02*G4_1_0_1_0_0_2 - 8.333333333333323e-02*G4_1_0_1_1_0_2 - 8.333333333333322e-02*G4_1_0_1_2_0_2 - 8.333333333333322e-02*G4_1_1_1_0_1_2 - 8.333333333333323e-02*G4_1_1_1_1_1_2 - 8.333333333333322e-02*G4_1_1_1_2_1_2 - 8.333333333333322e-02*G4_1_2_1_0_2_2 - 8.333333333333323e-02*G4_1_2_1_1_2_2 - 8.333333333333322e-02*G4_1_2_1_2_2_2 - 8.333333333333322e-02*G4_2_0_2_0_0_2 - 8.333333333333323e-02*G4_2_0_2_1_0_2 - 8.333333333333322e-02*G4_2_0_2_2_0_2 - 8.333333333333322e-02*G4_2_1_2_0_1_2 - 8.333333333333323e-02*G4_2_1_2_1_1_2 - 8.333333333333322e-02*G4_2_1_2_2_1_2 - 8.333333333333322e-02*G4_2_2_2_0_2_2 - 8.333333333333323e-02*G4_2_2_2_1_2_2 - 8.333333333333322e-02*G4_2_2_2_2_2_2;
    block[4] = 8.333333333333320e-02*G3_0_1_0_0 + 8.333333333333322e-02*G3_0_1_0_1 + 8.333333333333322e-02*G3_0_1_0_2 + 8.333333333333322e-02*G3_0_1_1_0 + 8.333333333333323e-02*G3_0_1_1_1 + 8.333333333333323e-02*G3_0_1_1_2 + 8.333333333333320e-02*G3_0_1_2_0 + 8.333333333333322e-02*G3_0_1_2_1 + 8.333333333333322e-02*G3_0_1_2_2;
    block[5] = -8.333333333333320e-02*G3_0_1_0_0 - 8.333333333333322e-02*G3_0_1_1_0 - 8.333333333333320e-02*G3_0_1_2_0;
    block[6] = -8.333333333333322e-02*G3_0_1_0_1 - 8.333333333333323e-02*G3_0_1_1_1 - 8.333333333333322e-02*G3_0_1_2_1;
    block[7] = -8.333333333333322e-02*G3_0_1_0_2 - 8.333333333333323e-02*G3_0_1_1_2 - 8.333333333333322e-02*G3_0_1_2_2;
    block[8] = 8.333333333333320e-02*G3_0_2_0_0 + 8.333333333333322e-02*G3_0_2_0_1 + 8.333333333333322e-02*G3_0_2_0_2 + 8.333333333333322e-02*G3_0_2_1_0 + 8.333333333333323e-02*G3_0_2_1_1 + 8.333333333333323e-02*G3_0_2_1_2 + 8.333333333333320e-02*G3_0_2_2_0 + 8.333333333333322e-02*G3_0_2_2_1 + 8.333333333333322e-02*G3_0_2_2_2;
    block[9] = -8.333333333333320e-02*G3_0_2_0_0 - 8.333333333333322e-02*G3_0_2_1_0 - 8.333333333333320e-02*G3_0_2_2_0;
    block[10] = -8.333333333333322e-02*G3_0_2_0_1 - 8.333333333333323e-02*G3_0_2_1_1 - 8.333333333333322e-02*G3_0_2_2_1;
    block[11] = -8.333333333333322e-02*G3_0_2_0_2 - 8.333333333333323e-02*G3_0_2_1_2 - 8.333333333333322e-02*G3_0_2_2_2;
    block[12] = 8.333333333333311e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_0_1 - 8.333333333333320e-02*G1_0_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333330e-02*G2_0_0_1 - 2.083333333333330e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333330e-02*G2_1_1_1 - 2.083333333333330e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333330e-02*G2_2_2_1 - 2.083333333333330e-02*G2_2_2_2 - 8.333333333333320e-02*G3_0_0_0_0 - 8.333333333333322e-02*G3_0_0_0_1 - 8.333333333333320e-02*G3_0_0_0_2 - 8.333333333333320e-02*G4_0_0_0_0_0_0 - 8.333333333333322e-02*G4_0_0_0_0_0_1 - 8.333333333333320e-02*G4_0_0_0_0_0_2 - 8.333333333333320e-02*G4_0_1_0_0_1_0 - 8.333333333333322e-02*G4_0_1_0_0_1_1 - 8.333333333333320e-02*G4_0_1_0_0_1_2 - 8.333333333333320e-02*G4_0_2_0_0_2_0 - 8.333333333333322e-02*G4_0_2_0_0_2_1 - 8.333333333333320e-02*G4_0_2_0_0_2_2 - 8.333333333333320e-02*G4_1_0_1_0_0_0 - 8.333333333333322e-02*G4_1_0_1_0_0_1 - 8.333333333333320e-02*G4_1_0_1_0_0_2 - 8.333333333333320e-02*G4_1_1_1_0_1_0 - 8.333333333333322e-02*G4_1_1_1_0_1_1 - 8.333333333333320e-02*G4_1_1_1_0_1_2 - 8.333333333333320e-02*G4_1_2_1_0_2_0 - 8.333333333333322e-02*G4_1_2_1_0_2_1 - 8.333333333333320e-02*G4_1_2_1_0_2_2 - 8.333333333333320e-02*G4_2_0_2_0_0_0 - 8.333333333333322e-02*G4_2_0_2_0_0_1 - 8.333333333333320e-02*G4_2_0_2_0_0_2 - 8.333333333333320e-02*G4_2_1_2_0_1_0 - 8.333333333333322e-02*G4_2_1_2_0_1_1 - 8.333333333333320e-02*G4_2_1_2_0_1_2 - 8.333333333333320e-02*G4_2_2_2_0_2_0 - 8.333333333333322e-02*G4_2_2_2_0_2_1 - 8.333333333333320e-02*G4_2_2_2_0_2_2;
    block[13] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333320e-02*G3_0_0_0_0 + 8.333333333333320e-02*G4_0_0_0_0_0_0 + 8.333333333333320e-02*G4_0_1_0_0_1_0 + 8.333333333333320e-02*G4_0_2_0_0_2_0 + 8.333333333333320e-02*G4_1_0_1_0_0_0 + 8.333333333333320e-02*G4_1_1_1_0_1_0 + 8.333333333333320e-02*G4_1_2_1_0_2_0 + 8.333333333333320e-02*G4_2_0_2_0_0_0 + 8.333333333333320e-02*G4_2_1_2_0_1_0 + 8.333333333333320e-02*G4_2_2_2_0_2_0;
    block[14] = 8.333333333333309e-03*G0_ + 8.333333333333322e-02*G1_0_1 + 2.083333333333330e-02*G2_0_0_1 + 2.083333333333330e-02*G2_1_1_1 + 2.083333333333330e-02*G2_2_2_1 + 8.333333333333322e-02*G3_0_0_0_1 + 8.333333333333322e-02*G4_0_0_0_0_0_1 + 8.333333333333322e-02*G4_0_1_0_0_1_1 + 8.333333333333322e-02*G4_0_2_0_0_2_1 + 8.333333333333322e-02*G4_1_0_1_0_0_1 + 8.333333333333322e-02*G4_1_1_1_0_1_1 + 8.333333333333322e-02*G4_1_2_1_0_2_1 + 8.333333333333322e-02*G4_2_0_2_0_0_1 + 8.333333333333322e-02*G4_2_1_2_0_1_1 + 8.333333333333322e-02*G4_2_2_2_0_2_1;
    block[15] = 8.333333333333311e-03*G0_ + 8.333333333333322e-02*G1_0_2 + 2.083333333333330e-02*G2_0_0_2 + 2.083333333333330e-02*G2_1_1_2 + 2.083333333333330e-02*G2_2_2_2 + 8.333333333333322e-02*G3_0_0_0_2 + 8.333333333333322e-02*G4_0_0_0_0_0_2 + 8.333333333333322e-02*G4_0_1_0_0_1_2 + 8.333333333333322e-02*G4_0_2_0_0_2_2 + 8.333333333333322e-02*G4_1_0_1_0_0_2 + 8.333333333333322e-02*G4_1_1_1_0_1_2 + 8.333333333333322e-02*G4_1_2_1_0_2_2 + 8.333333333333322e-02*G4_2_0_2_0_0_2 + 8.333333333333322e-02*G4_2_1_2_0_1_2 + 8.333333333333322e-02*G4_2_2_2_0_2_2;
    block[16] = -8.333333333333320e-02*G3_0_1_0_0 - 8.333333333333322e-02*G3_0_1_0_1 - 8.333333333333322e-02*G3_0_1_0_2;
    block[17] = 8.333333333333320e-02*G3_0_1_0_0;
    block[18] = 8.333333333333322e-02*G3_0_1_0_1;
    block[19] = 8.333333333333322e-02*G3_0_1_0_2;
    block[20] = -8.333333333333320e-02*G3_0_2_0_0 - 8.333333333333322e-02*G3_0_2_0_1 - 8.333333333333322e-02*G3_0_2_0_2;
    block[21] = 8.333333333333320e-02*G3_0_2_0_0;
    block[22] = 8.333333333333322e-02*G3_0_2_0_1;
    block[23] = 8.333333333333322e-02*G3_0_2_0_2;
    block[24] = 8.333333333333312e-03*G0_ - 8.333333333333322e-02*G1_1_0 - 8.333333333333323e-02*G1_1_1 - 8.333333333333322e-02*G1_1_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333330e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333330e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333330e-02*G2_2_2_2 - 8.333333333333322e-02*G3_0_0_1_0 - 8.333333333333323e-02*G3_0_0_1_1 - 8.333333333333322e-02*G3_0_0_1_2 - 8.333333333333322e-02*G4_0_0_0_1_0_0 - 8.333333333333323e-02*G4_0_0_0_1_0_1 - 8.333333333333322e-02*G4_0_0_0_1_0_2 - 8.333333333333322e-02*G4_0_1_0_1_1_0 - 8.333333333333323e-02*G4_0_1_0_1_1_1 - 8.333333333333322e-02*G4_0_1_0_1_1_2 - 8.333333333333322e-02*G4_0_2_0_1_2_0 - 8.333333333333323e-02*G4_0_2_0_1_2_1 - 8.333333333333322e-02*G4_0_2_0_1_2_2 - 8.333333333333322e-02*G4_1_0_1_1_0_0 - 8.333333333333323e-02*G4_1_0_1_1_0_1 - 8.333333333333322e-02*G4_1_0_1_1_0_2 - 8.333333333333322e-02*G4_1_1_1_1_1_0 - 8.333333333333323e-02*G4_1_1_1_1_1_1 - 8.333333333333322e-02*G4_1_1_1_1_1_2 - 8.333333333333322e-02*G4_1_2_1_1_2_0 - 8.333333333333323e-02*G4_1_2_1_1_2_1 - 8.333333333333322e-02*G4_1_2_1_1_2_2 - 8.333333333333322e-02*G4_2_0_2_1_0_0 - 8.333333333333323e-02*G4_2_0_2_1_0_1 - 8.333333333333322e-02*G4_2_0_2_1_0_2 - 8.333333333333322e-02*G4_2_1_2_1_1_0 - 8.333333333333323e-02*G4_2_1_2_1_1_1 - 8.333333333333322e-02*G4_2_1_2_1_1_2 - 8.333333333333322e-02*G4_2_2_2_1_2_0 - 8.333333333333323e-02*G4_2_2_2_1_2_1 - 8.333333333333322e-02*G4_2_2_2_1_2_2;
    block[25] = 8.333333333333309e-03*G0_ + 8.333333333333322e-02*G1_1_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333322e-02*G3_0_0_1_0 + 8.333333333333322e-02*G4_0_0_0_1_0_0 + 8.333333333333322e-02*G4_0_1_0_1_1_0 + 8.333333333333322e-02*G4_0_2_0_1_2_0 + 8.333333333333322e-02*G4_1_0_1_1_0_0 + 8.333333333333322e-02*G4_1_1_1_1_1_0 + 8.333333333333322e-02*G4_1_2_1_1_2_0 + 8.333333333333322e-02*G4_2_0_2_1_0_0 + 8.333333333333322e-02*G4_2_1_2_1_1_0 + 8.333333333333322e-02*G4_2_2_2_1_2_0;
    block[26] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_1_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333323e-02*G3_0_0_1_1 + 8.333333333333323e-02*G4_0_0_0_1_0_1 + 8.333333333333323e-02*G4_0_1_0_1_1_1 + 8.333333333333323e-02*G4_0_2_0_1_2_1 + 8.333333333333323e-02*G4_1_0_1_1_0_1 + 8.333333333333323e-02*G4_1_1_1_1_1_1 + 8.333333333333323e-02*G4_1_2_1_1_2_1 + 8.333333333333323e-02*G4_2_0_2_1_0_1 + 8.333333333333323e-02*G4_2_1_2_1_1_1 + 8.333333333333323e-02*G4_2_2_2_1_2_1;
    block[27] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_1_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333323e-02*G3_0_0_1_2 + 8.333333333333323e-02*G4_0_0_0_1_0_2 + 8.333333333333323e-02*G4_0_1_0_1_1_2 + 8.333333333333323e-02*G4_0_2_0_1_2_2 + 8.333333333333323e-02*G4_1_0_1_1_0_2 + 8.333333333333323e-02*G4_1_1_1_1_1_2 + 8.333333333333323e-02*G4_1_2_1_1_2_2 + 8.333333333333323e-02*G4_2_0_2_1_0_2 + 8.333333333333323e-02*G4_2_1_2_1_1_2 + 8.333333333333323e-02*G4_2_2_2_1_2_2;
    block[28] = -8.333333333333322e-02*G3_0_1_1_0 - 8.333333333333323e-02*G3_0_1_1_1 - 8.333333333333323e-02*G3_0_1_1_2;
    block[29] = 8.333333333333322e-02*G3_0_1_1_0;
    block[30] = 8.333333333333323e-02*G3_0_1_1_1;
    block[31] = 8.333333333333323e-02*G3_0_1_1_2;
    block[32] = -8.333333333333322e-02*G3_0_2_1_0 - 8.333333333333323e-02*G3_0_2_1_1 - 8.333333333333323e-02*G3_0_2_1_2;
    block[33] = 8.333333333333322e-02*G3_0_2_1_0;
    block[34] = 8.333333333333323e-02*G3_0_2_1_1;
    block[35] = 8.333333333333323e-02*G3_0_2_1_2;
    block[36] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_2_0 - 8.333333333333323e-02*G1_2_1 - 8.333333333333322e-02*G1_2_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333330e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333330e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333330e-02*G2_2_2_2 - 8.333333333333322e-02*G3_0_0_2_0 - 8.333333333333323e-02*G3_0_0_2_1 - 8.333333333333322e-02*G3_0_0_2_2 - 8.333333333333322e-02*G4_0_0_0_2_0_0 - 8.333333333333323e-02*G4_0_0_0_2_0_1 - 8.333333333333322e-02*G4_0_0_0_2_0_2 - 8.333333333333322e-02*G4_0_1_0_2_1_0 - 8.333333333333323e-02*G4_0_1_0_2_1_1 - 8.333333333333322e-02*G4_0_1_0_2_1_2 - 8.333333333333322e-02*G4_0_2_0_2_2_0 - 8.333333333333323e-02*G4_0_2_0_2_2_1 - 8.333333333333322e-02*G4_0_2_0_2_2_2 - 8.333333333333322e-02*G4_1_0_1_2_0_0 - 8.333333333333323e-02*G4_1_0_1_2_0_1 - 8.333333333333322e-02*G4_1_0_1_2_0_2 - 8.333333333333322e-02*G4_1_1_1_2_1_0 - 8.333333333333323e-02*G4_1_1_1_2_1_1 - 8.333333333333322e-02*G4_1_1_1_2_1_2 - 8.333333333333322e-02*G4_1_2_1_2_2_0 - 8.333333333333323e-02*G4_1_2_1_2_2_1 - 8.333333333333322e-02*G4_1_2_1_2_2_2 - 8.333333333333322e-02*G4_2_0_2_2_0_0 - 8.333333333333323e-02*G4_2_0_2_2_0_1 - 8.333333333333322e-02*G4_2_0_2_2_0_2 - 8.333333333333322e-02*G4_2_1_2_2_1_0 - 8.333333333333323e-02*G4_2_1_2_2_1_1 - 8.333333333333322e-02*G4_2_1_2_2_1_2 - 8.333333333333322e-02*G4_2_2_2_2_2_0 - 8.333333333333323e-02*G4_2_2_2_2_2_1 - 8.333333333333322e-02*G4_2_2_2_2_2_2;
    block[37] = 8.333333333333311e-03*G0_ + 8.333333333333322e-02*G1_2_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333322e-02*G3_0_0_2_0 + 8.333333333333322e-02*G4_0_0_0_2_0_0 + 8.333333333333322e-02*G4_0_1_0_2_1_0 + 8.333333333333322e-02*G4_0_2_0_2_2_0 + 8.333333333333322e-02*G4_1_0_1_2_0_0 + 8.333333333333322e-02*G4_1_1_1_2_1_0 + 8.333333333333322e-02*G4_1_2_1_2_2_0 + 8.333333333333322e-02*G4_2_0_2_2_0_0 + 8.333333333333322e-02*G4_2_1_2_2_1_0 + 8.333333333333322e-02*G4_2_2_2_2_2_0;
    block[38] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_2_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333323e-02*G3_0_0_2_1 + 8.333333333333323e-02*G4_0_0_0_2_0_1 + 8.333333333333323e-02*G4_0_1_0_2_1_1 + 8.333333333333323e-02*G4_0_2_0_2_2_1 + 8.333333333333323e-02*G4_1_0_1_2_0_1 + 8.333333333333323e-02*G4_1_1_1_2_1_1 + 8.333333333333323e-02*G4_1_2_1_2_2_1 + 8.333333333333323e-02*G4_2_0_2_2_0_1 + 8.333333333333323e-02*G4_2_1_2_2_1_1 + 8.333333333333323e-02*G4_2_2_2_2_2_1;
    block[39] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_2_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333323e-02*G3_0_0_2_2 + 8.333333333333323e-02*G4_0_0_0_2_0_2 + 8.333333333333323e-02*G4_0_1_0_2_1_2 + 8.333333333333323e-02*G4_0_2_0_2_2_2 + 8.333333333333323e-02*G4_1_0_1_2_0_2 + 8.333333333333323e-02*G4_1_1_1_2_1_2 + 8.333333333333323e-02*G4_1_2_1_2_2_2 + 8.333333333333323e-02*G4_2_0_2_2_0_2 + 8.333333333333323e-02*G4_2_1_2_2_1_2 + 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[40] = -8.333333333333322e-02*G3_0_1_2_0 - 8.333333333333323e-02*G3_0_1_2_1 - 8.333333333333323e-02*G3_0_1_2_2;
    block[41] = 8.333333333333322e-02*G3_0_1_2_0;
    block[42] = 8.333333333333323e-02*G3_0_1_2_1;
    block[43] = 8.333333333333323e-02*G3_0_1_2_2;
    block[44] = -8.333333333333322e-02*G3_0_2_2_0 - 8.333333333333323e-02*G3_0_2_2_1 - 8.333333333333323e-02*G3_0_2_2_2;
    block[45] = 8.333333333333322e-02*G3_0_2_2_0;
    block[46] = 8.333333333333323e-02*G3_0_2_2_1;
    block[47] = 8.333333333333323e-02*G3_0_2_2_2;
    block[48] = 8.333333333333320e-02*G3_1_0_0_0 + 8.333333333333322e-02*G3_1_0_0_1 + 8.333333333333320e-02*G3_1_0_0_2 + 8.333333333333322e-02*G3_1_0_1_0 + 8.333333333333323e-02*G3_1_0_1_1 + 8.333333333333322e-02*G3_1_0_1_2 + 8.333333333333322e-02*G3_1_0_2_0 + 8.333333333333323e-02*G3_1_0_2_1 + 8.333333333333322e-02*G3_1_0_2_2;
    block[49] = -8.333333333333320e-02*G3_1_0_0_0 - 8.333333333333322e-02*G3_1_0_1_0 - 8.333333333333322e-02*G3_1_0_2_0;
    block[50] = -8.333333333333322e-02*G3_1_0_0_1 - 8.333333333333323e-02*G3_1_0_1_1 - 8.333333333333323e-02*G3_1_0_2_1;
    block[51] = -8.333333333333322e-02*G3_1_0_0_2 - 8.333333333333323e-02*G3_1_0_1_2 - 8.333333333333323e-02*G3_1_0_2_2;
    block[52] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 8.333333333333322e-02*G1_0_1 + 8.333333333333322e-02*G1_0_2 + 8.333333333333322e-02*G1_1_0 + 8.333333333333323e-02*G1_1_1 + 8.333333333333323e-02*G1_1_2 + 8.333333333333322e-02*G1_2_0 + 8.333333333333323e-02*G1_2_1 + 8.333333333333323e-02*G1_2_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 + 8.333333333333320e-02*G3_1_1_0_0 + 8.333333333333322e-02*G3_1_1_0_1 + 8.333333333333322e-02*G3_1_1_0_2 + 8.333333333333322e-02*G3_1_1_1_0 + 8.333333333333323e-02*G3_1_1_1_1 + 8.333333333333323e-02*G3_1_1_1_2 + 8.333333333333322e-02*G3_1_1_2_0 + 8.333333333333323e-02*G3_1_1_2_1 + 8.333333333333323e-02*G3_1_1_2_2 + 8.333333333333320e-02*G4_0_0_0_0_0_0 + 8.333333333333322e-02*G4_0_0_0_0_0_1 + 8.333333333333322e-02*G4_0_0_0_0_0_2 + 8.333333333333322e-02*G4_0_0_0_1_0_0 + 8.333333333333323e-02*G4_0_0_0_1_0_1 + 8.333333333333323e-02*G4_0_0_0_1_0_2 + 8.333333333333322e-02*G4_0_0_0_2_0_0 + 8.333333333333323e-02*G4_0_0_0_2_0_1 + 8.333333333333323e-02*G4_0_0_0_2_0_2 + 8.333333333333320e-02*G4_0_1_0_0_1_0 + 8.333333333333322e-02*G4_0_1_0_0_1_1 + 8.333333333333322e-02*G4_0_1_0_0_1_2 + 8.333333333333322e-02*G4_0_1_0_1_1_0 + 8.333333333333323e-02*G4_0_1_0_1_1_1 + 8.333333333333323e-02*G4_0_1_0_1_1_2 + 8.333333333333322e-02*G4_0_1_0_2_1_0 + 8.333333333333323e-02*G4_0_1_0_2_1_1 + 8.333333333333323e-02*G4_0_1_0_2_1_2 + 8.333333333333320e-02*G4_0_2_0_0_2_0 + 8.333333333333322e-02*G4_0_2_0_0_2_1 + 8.333333333333322e-02*G4_0_2_0_0_2_2 + 8.333333333333322e-02*G4_0_2_0_1_2_0 + 8.333333333333323e-02*G4_0_2_0_1_2_1 + 8.333333333333323e-02*G4_0_2_0_1_2_2 + 8.333333333333322e-02*G4_0_2_0_2_2_0 + 8.333333333333323e-02*G4_0_2_0_2_2_1 + 8.333333333333323e-02*G4_0_2_0_2_2_2 + 8.333333333333320e-02*G4_1_0_1_0_0_0 + 8.333333333333322e-02*G4_1_0_1_0_0_1 + 8.333333333333322e-02*G4_1_0_1_0_0_2 + 8.333333333333322e-02*G4_1_0_1_1_0_0 + 8.333333333333323e-02*G4_1_0_1_1_0_1 + 8.333333333333323e-02*G4_1_0_1_1_0_2 + 8.333333333333322e-02*G4_1_0_1_2_0_0 + 8.333333333333323e-02*G4_1_0_1_2_0_1 + 8.333333333333323e-02*G4_1_0_1_2_0_2 + 8.333333333333320e-02*G4_1_1_1_0_1_0 + 8.333333333333322e-02*G4_1_1_1_0_1_1 + 8.333333333333322e-02*G4_1_1_1_0_1_2 + 8.333333333333322e-02*G4_1_1_1_1_1_0 + 8.333333333333323e-02*G4_1_1_1_1_1_1 + 8.333333333333323e-02*G4_1_1_1_1_1_2 + 8.333333333333322e-02*G4_1_1_1_2_1_0 + 8.333333333333323e-02*G4_1_1_1_2_1_1 + 8.333333333333323e-02*G4_1_1_1_2_1_2 + 8.333333333333320e-02*G4_1_2_1_0_2_0 + 8.333333333333322e-02*G4_1_2_1_0_2_1 + 8.333333333333322e-02*G4_1_2_1_0_2_2 + 8.333333333333322e-02*G4_1_2_1_1_2_0 + 8.333333333333323e-02*G4_1_2_1_1_2_1 + 8.333333333333323e-02*G4_1_2_1_1_2_2 + 8.333333333333322e-02*G4_1_2_1_2_2_0 + 8.333333333333323e-02*G4_1_2_1_2_2_1 + 8.333333333333323e-02*G4_1_2_1_2_2_2 + 8.333333333333320e-02*G4_2_0_2_0_0_0 + 8.333333333333322e-02*G4_2_0_2_0_0_1 + 8.333333333333322e-02*G4_2_0_2_0_0_2 + 8.333333333333322e-02*G4_2_0_2_1_0_0 + 8.333333333333323e-02*G4_2_0_2_1_0_1 + 8.333333333333323e-02*G4_2_0_2_1_0_2 + 8.333333333333322e-02*G4_2_0_2_2_0_0 + 8.333333333333323e-02*G4_2_0_2_2_0_1 + 8.333333333333323e-02*G4_2_0_2_2_0_2 + 8.333333333333320e-02*G4_2_1_2_0_1_0 + 8.333333333333322e-02*G4_2_1_2_0_1_1 + 8.333333333333322e-02*G4_2_1_2_0_1_2 + 8.333333333333322e-02*G4_2_1_2_1_1_0 + 8.333333333333323e-02*G4_2_1_2_1_1_1 + 8.333333333333323e-02*G4_2_1_2_1_1_2 + 8.333333333333322e-02*G4_2_1_2_2_1_0 + 8.333333333333323e-02*G4_2_1_2_2_1_1 + 8.333333333333323e-02*G4_2_1_2_2_1_2 + 8.333333333333320e-02*G4_2_2_2_0_2_0 + 8.333333333333322e-02*G4_2_2_2_0_2_1 + 8.333333333333322e-02*G4_2_2_2_0_2_2 + 8.333333333333322e-02*G4_2_2_2_1_2_0 + 8.333333333333323e-02*G4_2_2_2_1_2_1 + 8.333333333333323e-02*G4_2_2_2_1_2_2 + 8.333333333333322e-02*G4_2_2_2_2_2_0 + 8.333333333333323e-02*G4_2_2_2_2_2_1 + 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[53] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_1_0 - 8.333333333333322e-02*G1_2_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 - 8.333333333333320e-02*G3_1_1_0_0 - 8.333333333333322e-02*G3_1_1_1_0 - 8.333333333333322e-02*G3_1_1_2_0 - 8.333333333333320e-02*G4_0_0_0_0_0_0 - 8.333333333333322e-02*G4_0_0_0_1_0_0 - 8.333333333333322e-02*G4_0_0_0_2_0_0 - 8.333333333333320e-02*G4_0_1_0_0_1_0 - 8.333333333333322e-02*G4_0_1_0_1_1_0 - 8.333333333333322e-02*G4_0_1_0_2_1_0 - 8.333333333333320e-02*G4_0_2_0_0_2_0 - 8.333333333333322e-02*G4_0_2_0_1_2_0 - 8.333333333333322e-02*G4_0_2_0_2_2_0 - 8.333333333333320e-02*G4_1_0_1_0_0_0 - 8.333333333333322e-02*G4_1_0_1_1_0_0 - 8.333333333333322e-02*G4_1_0_1_2_0_0 - 8.333333333333320e-02*G4_1_1_1_0_1_0 - 8.333333333333322e-02*G4_1_1_1_1_1_0 - 8.333333333333322e-02*G4_1_1_1_2_1_0 - 8.333333333333320e-02*G4_1_2_1_0_2_0 - 8.333333333333322e-02*G4_1_2_1_1_2_0 - 8.333333333333322e-02*G4_1_2_1_2_2_0 - 8.333333333333320e-02*G4_2_0_2_0_0_0 - 8.333333333333322e-02*G4_2_0_2_1_0_0 - 8.333333333333322e-02*G4_2_0_2_2_0_0 - 8.333333333333320e-02*G4_2_1_2_0_1_0 - 8.333333333333322e-02*G4_2_1_2_1_1_0 - 8.333333333333322e-02*G4_2_1_2_2_1_0 - 8.333333333333320e-02*G4_2_2_2_0_2_0 - 8.333333333333322e-02*G4_2_2_2_1_2_0 - 8.333333333333322e-02*G4_2_2_2_2_2_0;
    block[54] = 8.333333333333309e-03*G0_ - 8.333333333333322e-02*G1_0_1 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_2_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 - 8.333333333333322e-02*G3_1_1_0_1 - 8.333333333333323e-02*G3_1_1_1_1 - 8.333333333333323e-02*G3_1_1_2_1 - 8.333333333333322e-02*G4_0_0_0_0_0_1 - 8.333333333333323e-02*G4_0_0_0_1_0_1 - 8.333333333333323e-02*G4_0_0_0_2_0_1 - 8.333333333333322e-02*G4_0_1_0_0_1_1 - 8.333333333333323e-02*G4_0_1_0_1_1_1 - 8.333333333333323e-02*G4_0_1_0_2_1_1 - 8.333333333333322e-02*G4_0_2_0_0_2_1 - 8.333333333333323e-02*G4_0_2_0_1_2_1 - 8.333333333333323e-02*G4_0_2_0_2_2_1 - 8.333333333333322e-02*G4_1_0_1_0_0_1 - 8.333333333333323e-02*G4_1_0_1_1_0_1 - 8.333333333333323e-02*G4_1_0_1_2_0_1 - 8.333333333333322e-02*G4_1_1_1_0_1_1 - 8.333333333333323e-02*G4_1_1_1_1_1_1 - 8.333333333333323e-02*G4_1_1_1_2_1_1 - 8.333333333333322e-02*G4_1_2_1_0_2_1 - 8.333333333333323e-02*G4_1_2_1_1_2_1 - 8.333333333333323e-02*G4_1_2_1_2_2_1 - 8.333333333333322e-02*G4_2_0_2_0_0_1 - 8.333333333333323e-02*G4_2_0_2_1_0_1 - 8.333333333333323e-02*G4_2_0_2_2_0_1 - 8.333333333333322e-02*G4_2_1_2_0_1_1 - 8.333333333333323e-02*G4_2_1_2_1_1_1 - 8.333333333333323e-02*G4_2_1_2_2_1_1 - 8.333333333333322e-02*G4_2_2_2_0_2_1 - 8.333333333333323e-02*G4_2_2_2_1_2_1 - 8.333333333333323e-02*G4_2_2_2_2_2_1;
    block[55] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_0_2 - 8.333333333333323e-02*G1_1_2 - 8.333333333333323e-02*G1_2_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 - 8.333333333333322e-02*G3_1_1_0_2 - 8.333333333333323e-02*G3_1_1_1_2 - 8.333333333333323e-02*G3_1_1_2_2 - 8.333333333333322e-02*G4_0_0_0_0_0_2 - 8.333333333333323e-02*G4_0_0_0_1_0_2 - 8.333333333333323e-02*G4_0_0_0_2_0_2 - 8.333333333333322e-02*G4_0_1_0_0_1_2 - 8.333333333333323e-02*G4_0_1_0_1_1_2 - 8.333333333333323e-02*G4_0_1_0_2_1_2 - 8.333333333333322e-02*G4_0_2_0_0_2_2 - 8.333333333333323e-02*G4_0_2_0_1_2_2 - 8.333333333333323e-02*G4_0_2_0_2_2_2 - 8.333333333333322e-02*G4_1_0_1_0_0_2 - 8.333333333333323e-02*G4_1_0_1_1_0_2 - 8.333333333333323e-02*G4_1_0_1_2_0_2 - 8.333333333333322e-02*G4_1_1_1_0_1_2 - 8.333333333333323e-02*G4_1_1_1_1_1_2 - 8.333333333333323e-02*G4_1_1_1_2_1_2 - 8.333333333333322e-02*G4_1_2_1_0_2_2 - 8.333333333333323e-02*G4_1_2_1_1_2_2 - 8.333333333333323e-02*G4_1_2_1_2_2_2 - 8.333333333333322e-02*G4_2_0_2_0_0_2 - 8.333333333333323e-02*G4_2_0_2_1_0_2 - 8.333333333333323e-02*G4_2_0_2_2_0_2 - 8.333333333333322e-02*G4_2_1_2_0_1_2 - 8.333333333333323e-02*G4_2_1_2_1_1_2 - 8.333333333333323e-02*G4_2_1_2_2_1_2 - 8.333333333333322e-02*G4_2_2_2_0_2_2 - 8.333333333333323e-02*G4_2_2_2_1_2_2 - 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[56] = 8.333333333333320e-02*G3_1_2_0_0 + 8.333333333333322e-02*G3_1_2_0_1 + 8.333333333333322e-02*G3_1_2_0_2 + 8.333333333333322e-02*G3_1_2_1_0 + 8.333333333333323e-02*G3_1_2_1_1 + 8.333333333333323e-02*G3_1_2_1_2 + 8.333333333333322e-02*G3_1_2_2_0 + 8.333333333333323e-02*G3_1_2_2_1 + 8.333333333333323e-02*G3_1_2_2_2;
    block[57] = -8.333333333333320e-02*G3_1_2_0_0 - 8.333333333333322e-02*G3_1_2_1_0 - 8.333333333333322e-02*G3_1_2_2_0;
    block[58] = -8.333333333333322e-02*G3_1_2_0_1 - 8.333333333333323e-02*G3_1_2_1_1 - 8.333333333333323e-02*G3_1_2_2_1;
    block[59] = -8.333333333333322e-02*G3_1_2_0_2 - 8.333333333333323e-02*G3_1_2_1_2 - 8.333333333333323e-02*G3_1_2_2_2;
    block[60] = -8.333333333333320e-02*G3_1_0_0_0 - 8.333333333333322e-02*G3_1_0_0_1 - 8.333333333333320e-02*G3_1_0_0_2;
    block[61] = 8.333333333333320e-02*G3_1_0_0_0;
    block[62] = 8.333333333333322e-02*G3_1_0_0_1;
    block[63] = 8.333333333333322e-02*G3_1_0_0_2;
    block[64] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_0_1 - 8.333333333333322e-02*G1_0_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 - 8.333333333333320e-02*G3_1_1_0_0 - 8.333333333333322e-02*G3_1_1_0_1 - 8.333333333333322e-02*G3_1_1_0_2 - 8.333333333333320e-02*G4_0_0_0_0_0_0 - 8.333333333333322e-02*G4_0_0_0_0_0_1 - 8.333333333333322e-02*G4_0_0_0_0_0_2 - 8.333333333333320e-02*G4_0_1_0_0_1_0 - 8.333333333333322e-02*G4_0_1_0_0_1_1 - 8.333333333333322e-02*G4_0_1_0_0_1_2 - 8.333333333333320e-02*G4_0_2_0_0_2_0 - 8.333333333333322e-02*G4_0_2_0_0_2_1 - 8.333333333333322e-02*G4_0_2_0_0_2_2 - 8.333333333333320e-02*G4_1_0_1_0_0_0 - 8.333333333333322e-02*G4_1_0_1_0_0_1 - 8.333333333333322e-02*G4_1_0_1_0_0_2 - 8.333333333333320e-02*G4_1_1_1_0_1_0 - 8.333333333333322e-02*G4_1_1_1_0_1_1 - 8.333333333333322e-02*G4_1_1_1_0_1_2 - 8.333333333333320e-02*G4_1_2_1_0_2_0 - 8.333333333333322e-02*G4_1_2_1_0_2_1 - 8.333333333333322e-02*G4_1_2_1_0_2_2 - 8.333333333333320e-02*G4_2_0_2_0_0_0 - 8.333333333333322e-02*G4_2_0_2_0_0_1 - 8.333333333333322e-02*G4_2_0_2_0_0_2 - 8.333333333333320e-02*G4_2_1_2_0_1_0 - 8.333333333333322e-02*G4_2_1_2_0_1_1 - 8.333333333333322e-02*G4_2_1_2_0_1_2 - 8.333333333333320e-02*G4_2_2_2_0_2_0 - 8.333333333333322e-02*G4_2_2_2_0_2_1 - 8.333333333333322e-02*G4_2_2_2_0_2_2;
    block[65] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333320e-02*G3_1_1_0_0 + 8.333333333333320e-02*G4_0_0_0_0_0_0 + 8.333333333333320e-02*G4_0_1_0_0_1_0 + 8.333333333333320e-02*G4_0_2_0_0_2_0 + 8.333333333333320e-02*G4_1_0_1_0_0_0 + 8.333333333333320e-02*G4_1_1_1_0_1_0 + 8.333333333333320e-02*G4_1_2_1_0_2_0 + 8.333333333333320e-02*G4_2_0_2_0_0_0 + 8.333333333333320e-02*G4_2_1_2_0_1_0 + 8.333333333333320e-02*G4_2_2_2_0_2_0;
    block[66] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_0_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333322e-02*G3_1_1_0_1 + 8.333333333333322e-02*G4_0_0_0_0_0_1 + 8.333333333333322e-02*G4_0_1_0_0_1_1 + 8.333333333333322e-02*G4_0_2_0_0_2_1 + 8.333333333333322e-02*G4_1_0_1_0_0_1 + 8.333333333333322e-02*G4_1_1_1_0_1_1 + 8.333333333333322e-02*G4_1_2_1_0_2_1 + 8.333333333333322e-02*G4_2_0_2_0_0_1 + 8.333333333333322e-02*G4_2_1_2_0_1_1 + 8.333333333333322e-02*G4_2_2_2_0_2_1;
    block[67] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_0_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333322e-02*G3_1_1_0_2 + 8.333333333333322e-02*G4_0_0_0_0_0_2 + 8.333333333333322e-02*G4_0_1_0_0_1_2 + 8.333333333333322e-02*G4_0_2_0_0_2_2 + 8.333333333333322e-02*G4_1_0_1_0_0_2 + 8.333333333333322e-02*G4_1_1_1_0_1_2 + 8.333333333333322e-02*G4_1_2_1_0_2_2 + 8.333333333333322e-02*G4_2_0_2_0_0_2 + 8.333333333333322e-02*G4_2_1_2_0_1_2 + 8.333333333333322e-02*G4_2_2_2_0_2_2;
    block[68] = -8.333333333333320e-02*G3_1_2_0_0 - 8.333333333333322e-02*G3_1_2_0_1 - 8.333333333333322e-02*G3_1_2_0_2;
    block[69] = 8.333333333333320e-02*G3_1_2_0_0;
    block[70] = 8.333333333333322e-02*G3_1_2_0_1;
    block[71] = 8.333333333333322e-02*G3_1_2_0_2;
    block[72] = -8.333333333333322e-02*G3_1_0_1_0 - 8.333333333333323e-02*G3_1_0_1_1 - 8.333333333333322e-02*G3_1_0_1_2;
    block[73] = 8.333333333333322e-02*G3_1_0_1_0;
    block[74] = 8.333333333333323e-02*G3_1_0_1_1;
    block[75] = 8.333333333333323e-02*G3_1_0_1_2;
    block[76] = 8.333333333333307e-03*G0_ - 8.333333333333322e-02*G1_1_0 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_1_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 - 8.333333333333322e-02*G3_1_1_1_0 - 8.333333333333323e-02*G3_1_1_1_1 - 8.333333333333323e-02*G3_1_1_1_2 - 8.333333333333322e-02*G4_0_0_0_1_0_0 - 8.333333333333323e-02*G4_0_0_0_1_0_1 - 8.333333333333323e-02*G4_0_0_0_1_0_2 - 8.333333333333322e-02*G4_0_1_0_1_1_0 - 8.333333333333323e-02*G4_0_1_0_1_1_1 - 8.333333333333323e-02*G4_0_1_0_1_1_2 - 8.333333333333322e-02*G4_0_2_0_1_2_0 - 8.333333333333323e-02*G4_0_2_0_1_2_1 - 8.333333333333323e-02*G4_0_2_0_1_2_2 - 8.333333333333322e-02*G4_1_0_1_1_0_0 - 8.333333333333323e-02*G4_1_0_1_1_0_1 - 8.333333333333323e-02*G4_1_0_1_1_0_2 - 8.333333333333322e-02*G4_1_1_1_1_1_0 - 8.333333333333323e-02*G4_1_1_1_1_1_1 - 8.333333333333323e-02*G4_1_1_1_1_1_2 - 8.333333333333322e-02*G4_1_2_1_1_2_0 - 8.333333333333323e-02*G4_1_2_1_1_2_1 - 8.333333333333323e-02*G4_1_2_1_1_2_2 - 8.333333333333322e-02*G4_2_0_2_1_0_0 - 8.333333333333323e-02*G4_2_0_2_1_0_1 - 8.333333333333323e-02*G4_2_0_2_1_0_2 - 8.333333333333322e-02*G4_2_1_2_1_1_0 - 8.333333333333323e-02*G4_2_1_2_1_1_1 - 8.333333333333323e-02*G4_2_1_2_1_1_2 - 8.333333333333322e-02*G4_2_2_2_1_2_0 - 8.333333333333323e-02*G4_2_2_2_1_2_1 - 8.333333333333323e-02*G4_2_2_2_1_2_2;
    block[77] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_1_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333322e-02*G3_1_1_1_0 + 8.333333333333322e-02*G4_0_0_0_1_0_0 + 8.333333333333322e-02*G4_0_1_0_1_1_0 + 8.333333333333322e-02*G4_0_2_0_1_2_0 + 8.333333333333322e-02*G4_1_0_1_1_0_0 + 8.333333333333322e-02*G4_1_1_1_1_1_0 + 8.333333333333322e-02*G4_1_2_1_1_2_0 + 8.333333333333322e-02*G4_2_0_2_1_0_0 + 8.333333333333322e-02*G4_2_1_2_1_1_0 + 8.333333333333322e-02*G4_2_2_2_1_2_0;
    block[78] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_1_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333323e-02*G3_1_1_1_1 + 8.333333333333323e-02*G4_0_0_0_1_0_1 + 8.333333333333323e-02*G4_0_1_0_1_1_1 + 8.333333333333323e-02*G4_0_2_0_1_2_1 + 8.333333333333323e-02*G4_1_0_1_1_0_1 + 8.333333333333323e-02*G4_1_1_1_1_1_1 + 8.333333333333323e-02*G4_1_2_1_1_2_1 + 8.333333333333323e-02*G4_2_0_2_1_0_1 + 8.333333333333323e-02*G4_2_1_2_1_1_1 + 8.333333333333323e-02*G4_2_2_2_1_2_1;
    block[79] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_1_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333323e-02*G3_1_1_1_2 + 8.333333333333323e-02*G4_0_0_0_1_0_2 + 8.333333333333323e-02*G4_0_1_0_1_1_2 + 8.333333333333323e-02*G4_0_2_0_1_2_2 + 8.333333333333323e-02*G4_1_0_1_1_0_2 + 8.333333333333323e-02*G4_1_1_1_1_1_2 + 8.333333333333323e-02*G4_1_2_1_1_2_2 + 8.333333333333323e-02*G4_2_0_2_1_0_2 + 8.333333333333323e-02*G4_2_1_2_1_1_2 + 8.333333333333323e-02*G4_2_2_2_1_2_2;
    block[80] = -8.333333333333322e-02*G3_1_2_1_0 - 8.333333333333323e-02*G3_1_2_1_1 - 8.333333333333323e-02*G3_1_2_1_2;
    block[81] = 8.333333333333322e-02*G3_1_2_1_0;
    block[82] = 8.333333333333323e-02*G3_1_2_1_1;
    block[83] = 8.333333333333323e-02*G3_1_2_1_2;
    block[84] = -8.333333333333322e-02*G3_1_0_2_0 - 8.333333333333323e-02*G3_1_0_2_1 - 8.333333333333322e-02*G3_1_0_2_2;
    block[85] = 8.333333333333322e-02*G3_1_0_2_0;
    block[86] = 8.333333333333323e-02*G3_1_0_2_1;
    block[87] = 8.333333333333323e-02*G3_1_0_2_2;
    block[88] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_2_0 - 8.333333333333323e-02*G1_2_1 - 8.333333333333323e-02*G1_2_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 - 8.333333333333322e-02*G3_1_1_2_0 - 8.333333333333323e-02*G3_1_1_2_1 - 8.333333333333323e-02*G3_1_1_2_2 - 8.333333333333322e-02*G4_0_0_0_2_0_0 - 8.333333333333323e-02*G4_0_0_0_2_0_1 - 8.333333333333323e-02*G4_0_0_0_2_0_2 - 8.333333333333322e-02*G4_0_1_0_2_1_0 - 8.333333333333323e-02*G4_0_1_0_2_1_1 - 8.333333333333323e-02*G4_0_1_0_2_1_2 - 8.333333333333322e-02*G4_0_2_0_2_2_0 - 8.333333333333323e-02*G4_0_2_0_2_2_1 - 8.333333333333323e-02*G4_0_2_0_2_2_2 - 8.333333333333322e-02*G4_1_0_1_2_0_0 - 8.333333333333323e-02*G4_1_0_1_2_0_1 - 8.333333333333323e-02*G4_1_0_1_2_0_2 - 8.333333333333322e-02*G4_1_1_1_2_1_0 - 8.333333333333323e-02*G4_1_1_1_2_1_1 - 8.333333333333323e-02*G4_1_1_1_2_1_2 - 8.333333333333322e-02*G4_1_2_1_2_2_0 - 8.333333333333323e-02*G4_1_2_1_2_2_1 - 8.333333333333323e-02*G4_1_2_1_2_2_2 - 8.333333333333322e-02*G4_2_0_2_2_0_0 - 8.333333333333323e-02*G4_2_0_2_2_0_1 - 8.333333333333323e-02*G4_2_0_2_2_0_2 - 8.333333333333322e-02*G4_2_1_2_2_1_0 - 8.333333333333323e-02*G4_2_1_2_2_1_1 - 8.333333333333323e-02*G4_2_1_2_2_1_2 - 8.333333333333322e-02*G4_2_2_2_2_2_0 - 8.333333333333323e-02*G4_2_2_2_2_2_1 - 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[89] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_2_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333322e-02*G3_1_1_2_0 + 8.333333333333322e-02*G4_0_0_0_2_0_0 + 8.333333333333322e-02*G4_0_1_0_2_1_0 + 8.333333333333322e-02*G4_0_2_0_2_2_0 + 8.333333333333322e-02*G4_1_0_1_2_0_0 + 8.333333333333322e-02*G4_1_1_1_2_1_0 + 8.333333333333322e-02*G4_1_2_1_2_2_0 + 8.333333333333322e-02*G4_2_0_2_2_0_0 + 8.333333333333322e-02*G4_2_1_2_2_1_0 + 8.333333333333322e-02*G4_2_2_2_2_2_0;
    block[90] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_2_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333323e-02*G3_1_1_2_1 + 8.333333333333323e-02*G4_0_0_0_2_0_1 + 8.333333333333323e-02*G4_0_1_0_2_1_1 + 8.333333333333323e-02*G4_0_2_0_2_2_1 + 8.333333333333323e-02*G4_1_0_1_2_0_1 + 8.333333333333323e-02*G4_1_1_1_2_1_1 + 8.333333333333323e-02*G4_1_2_1_2_2_1 + 8.333333333333323e-02*G4_2_0_2_2_0_1 + 8.333333333333323e-02*G4_2_1_2_2_1_1 + 8.333333333333323e-02*G4_2_2_2_2_2_1;
    block[91] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_2_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333323e-02*G3_1_1_2_2 + 8.333333333333323e-02*G4_0_0_0_2_0_2 + 8.333333333333323e-02*G4_0_1_0_2_1_2 + 8.333333333333323e-02*G4_0_2_0_2_2_2 + 8.333333333333323e-02*G4_1_0_1_2_0_2 + 8.333333333333323e-02*G4_1_1_1_2_1_2 + 8.333333333333323e-02*G4_1_2_1_2_2_2 + 8.333333333333323e-02*G4_2_0_2_2_0_2 + 8.333333333333323e-02*G4_2_1_2_2_1_2 + 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[92] = -8.333333333333322e-02*G3_1_2_2_0 - 8.333333333333323e-02*G3_1_2_2_1 - 8.333333333333323e-02*G3_1_2_2_2;
    block[93] = 8.333333333333322e-02*G3_1_2_2_0;
    block[94] = 8.333333333333323e-02*G3_1_2_2_1;
    block[95] = 8.333333333333323e-02*G3_1_2_2_2;
    block[96] = 8.333333333333320e-02*G3_2_0_0_0 + 8.333333333333322e-02*G3_2_0_0_1 + 8.333333333333320e-02*G3_2_0_0_2 + 8.333333333333322e-02*G3_2_0_1_0 + 8.333333333333323e-02*G3_2_0_1_1 + 8.333333333333322e-02*G3_2_0_1_2 + 8.333333333333322e-02*G3_2_0_2_0 + 8.333333333333323e-02*G3_2_0_2_1 + 8.333333333333322e-02*G3_2_0_2_2;
    block[97] = -8.333333333333320e-02*G3_2_0_0_0 - 8.333333333333322e-02*G3_2_0_1_0 - 8.333333333333322e-02*G3_2_0_2_0;
    block[98] = -8.333333333333322e-02*G3_2_0_0_1 - 8.333333333333323e-02*G3_2_0_1_1 - 8.333333333333323e-02*G3_2_0_2_1;
    block[99] = -8.333333333333322e-02*G3_2_0_0_2 - 8.333333333333323e-02*G3_2_0_1_2 - 8.333333333333323e-02*G3_2_0_2_2;
    block[100] = 8.333333333333320e-02*G3_2_1_0_0 + 8.333333333333322e-02*G3_2_1_0_1 + 8.333333333333322e-02*G3_2_1_0_2 + 8.333333333333322e-02*G3_2_1_1_0 + 8.333333333333323e-02*G3_2_1_1_1 + 8.333333333333323e-02*G3_2_1_1_2 + 8.333333333333322e-02*G3_2_1_2_0 + 8.333333333333323e-02*G3_2_1_2_1 + 8.333333333333323e-02*G3_2_1_2_2;
    block[101] = -8.333333333333320e-02*G3_2_1_0_0 - 8.333333333333322e-02*G3_2_1_1_0 - 8.333333333333322e-02*G3_2_1_2_0;
    block[102] = -8.333333333333322e-02*G3_2_1_0_1 - 8.333333333333323e-02*G3_2_1_1_1 - 8.333333333333323e-02*G3_2_1_2_1;
    block[103] = -8.333333333333322e-02*G3_2_1_0_2 - 8.333333333333323e-02*G3_2_1_1_2 - 8.333333333333323e-02*G3_2_1_2_2;
    block[104] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 8.333333333333322e-02*G1_0_1 + 8.333333333333322e-02*G1_0_2 + 8.333333333333322e-02*G1_1_0 + 8.333333333333323e-02*G1_1_1 + 8.333333333333323e-02*G1_1_2 + 8.333333333333322e-02*G1_2_0 + 8.333333333333323e-02*G1_2_1 + 8.333333333333323e-02*G1_2_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 + 8.333333333333320e-02*G3_2_2_0_0 + 8.333333333333322e-02*G3_2_2_0_1 + 8.333333333333322e-02*G3_2_2_0_2 + 8.333333333333322e-02*G3_2_2_1_0 + 8.333333333333323e-02*G3_2_2_1_1 + 8.333333333333323e-02*G3_2_2_1_2 + 8.333333333333322e-02*G3_2_2_2_0 + 8.333333333333323e-02*G3_2_2_2_1 + 8.333333333333323e-02*G3_2_2_2_2 + 8.333333333333320e-02*G4_0_0_0_0_0_0 + 8.333333333333322e-02*G4_0_0_0_0_0_1 + 8.333333333333322e-02*G4_0_0_0_0_0_2 + 8.333333333333322e-02*G4_0_0_0_1_0_0 + 8.333333333333323e-02*G4_0_0_0_1_0_1 + 8.333333333333323e-02*G4_0_0_0_1_0_2 + 8.333333333333322e-02*G4_0_0_0_2_0_0 + 8.333333333333323e-02*G4_0_0_0_2_0_1 + 8.333333333333323e-02*G4_0_0_0_2_0_2 + 8.333333333333320e-02*G4_0_1_0_0_1_0 + 8.333333333333322e-02*G4_0_1_0_0_1_1 + 8.333333333333322e-02*G4_0_1_0_0_1_2 + 8.333333333333322e-02*G4_0_1_0_1_1_0 + 8.333333333333323e-02*G4_0_1_0_1_1_1 + 8.333333333333323e-02*G4_0_1_0_1_1_2 + 8.333333333333322e-02*G4_0_1_0_2_1_0 + 8.333333333333323e-02*G4_0_1_0_2_1_1 + 8.333333333333323e-02*G4_0_1_0_2_1_2 + 8.333333333333320e-02*G4_0_2_0_0_2_0 + 8.333333333333322e-02*G4_0_2_0_0_2_1 + 8.333333333333322e-02*G4_0_2_0_0_2_2 + 8.333333333333322e-02*G4_0_2_0_1_2_0 + 8.333333333333323e-02*G4_0_2_0_1_2_1 + 8.333333333333323e-02*G4_0_2_0_1_2_2 + 8.333333333333322e-02*G4_0_2_0_2_2_0 + 8.333333333333323e-02*G4_0_2_0_2_2_1 + 8.333333333333323e-02*G4_0_2_0_2_2_2 + 8.333333333333320e-02*G4_1_0_1_0_0_0 + 8.333333333333322e-02*G4_1_0_1_0_0_1 + 8.333333333333322e-02*G4_1_0_1_0_0_2 + 8.333333333333322e-02*G4_1_0_1_1_0_0 + 8.333333333333323e-02*G4_1_0_1_1_0_1 + 8.333333333333323e-02*G4_1_0_1_1_0_2 + 8.333333333333322e-02*G4_1_0_1_2_0_0 + 8.333333333333323e-02*G4_1_0_1_2_0_1 + 8.333333333333323e-02*G4_1_0_1_2_0_2 + 8.333333333333320e-02*G4_1_1_1_0_1_0 + 8.333333333333322e-02*G4_1_1_1_0_1_1 + 8.333333333333322e-02*G4_1_1_1_0_1_2 + 8.333333333333322e-02*G4_1_1_1_1_1_0 + 8.333333333333323e-02*G4_1_1_1_1_1_1 + 8.333333333333323e-02*G4_1_1_1_1_1_2 + 8.333333333333322e-02*G4_1_1_1_2_1_0 + 8.333333333333323e-02*G4_1_1_1_2_1_1 + 8.333333333333323e-02*G4_1_1_1_2_1_2 + 8.333333333333320e-02*G4_1_2_1_0_2_0 + 8.333333333333322e-02*G4_1_2_1_0_2_1 + 8.333333333333322e-02*G4_1_2_1_0_2_2 + 8.333333333333322e-02*G4_1_2_1_1_2_0 + 8.333333333333323e-02*G4_1_2_1_1_2_1 + 8.333333333333323e-02*G4_1_2_1_1_2_2 + 8.333333333333322e-02*G4_1_2_1_2_2_0 + 8.333333333333323e-02*G4_1_2_1_2_2_1 + 8.333333333333323e-02*G4_1_2_1_2_2_2 + 8.333333333333320e-02*G4_2_0_2_0_0_0 + 8.333333333333322e-02*G4_2_0_2_0_0_1 + 8.333333333333322e-02*G4_2_0_2_0_0_2 + 8.333333333333322e-02*G4_2_0_2_1_0_0 + 8.333333333333323e-02*G4_2_0_2_1_0_1 + 8.333333333333323e-02*G4_2_0_2_1_0_2 + 8.333333333333322e-02*G4_2_0_2_2_0_0 + 8.333333333333323e-02*G4_2_0_2_2_0_1 + 8.333333333333323e-02*G4_2_0_2_2_0_2 + 8.333333333333320e-02*G4_2_1_2_0_1_0 + 8.333333333333322e-02*G4_2_1_2_0_1_1 + 8.333333333333322e-02*G4_2_1_2_0_1_2 + 8.333333333333322e-02*G4_2_1_2_1_1_0 + 8.333333333333323e-02*G4_2_1_2_1_1_1 + 8.333333333333323e-02*G4_2_1_2_1_1_2 + 8.333333333333322e-02*G4_2_1_2_2_1_0 + 8.333333333333323e-02*G4_2_1_2_2_1_1 + 8.333333333333323e-02*G4_2_1_2_2_1_2 + 8.333333333333320e-02*G4_2_2_2_0_2_0 + 8.333333333333322e-02*G4_2_2_2_0_2_1 + 8.333333333333322e-02*G4_2_2_2_0_2_2 + 8.333333333333322e-02*G4_2_2_2_1_2_0 + 8.333333333333323e-02*G4_2_2_2_1_2_1 + 8.333333333333323e-02*G4_2_2_2_1_2_2 + 8.333333333333322e-02*G4_2_2_2_2_2_0 + 8.333333333333323e-02*G4_2_2_2_2_2_1 + 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[105] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_1_0 - 8.333333333333322e-02*G1_2_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 - 8.333333333333320e-02*G3_2_2_0_0 - 8.333333333333322e-02*G3_2_2_1_0 - 8.333333333333322e-02*G3_2_2_2_0 - 8.333333333333320e-02*G4_0_0_0_0_0_0 - 8.333333333333322e-02*G4_0_0_0_1_0_0 - 8.333333333333322e-02*G4_0_0_0_2_0_0 - 8.333333333333320e-02*G4_0_1_0_0_1_0 - 8.333333333333322e-02*G4_0_1_0_1_1_0 - 8.333333333333322e-02*G4_0_1_0_2_1_0 - 8.333333333333320e-02*G4_0_2_0_0_2_0 - 8.333333333333322e-02*G4_0_2_0_1_2_0 - 8.333333333333322e-02*G4_0_2_0_2_2_0 - 8.333333333333320e-02*G4_1_0_1_0_0_0 - 8.333333333333322e-02*G4_1_0_1_1_0_0 - 8.333333333333322e-02*G4_1_0_1_2_0_0 - 8.333333333333320e-02*G4_1_1_1_0_1_0 - 8.333333333333322e-02*G4_1_1_1_1_1_0 - 8.333333333333322e-02*G4_1_1_1_2_1_0 - 8.333333333333320e-02*G4_1_2_1_0_2_0 - 8.333333333333322e-02*G4_1_2_1_1_2_0 - 8.333333333333322e-02*G4_1_2_1_2_2_0 - 8.333333333333320e-02*G4_2_0_2_0_0_0 - 8.333333333333322e-02*G4_2_0_2_1_0_0 - 8.333333333333322e-02*G4_2_0_2_2_0_0 - 8.333333333333320e-02*G4_2_1_2_0_1_0 - 8.333333333333322e-02*G4_2_1_2_1_1_0 - 8.333333333333322e-02*G4_2_1_2_2_1_0 - 8.333333333333320e-02*G4_2_2_2_0_2_0 - 8.333333333333322e-02*G4_2_2_2_1_2_0 - 8.333333333333322e-02*G4_2_2_2_2_2_0;
    block[106] = 8.333333333333309e-03*G0_ - 8.333333333333322e-02*G1_0_1 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_2_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 - 8.333333333333322e-02*G3_2_2_0_1 - 8.333333333333323e-02*G3_2_2_1_1 - 8.333333333333323e-02*G3_2_2_2_1 - 8.333333333333322e-02*G4_0_0_0_0_0_1 - 8.333333333333323e-02*G4_0_0_0_1_0_1 - 8.333333333333323e-02*G4_0_0_0_2_0_1 - 8.333333333333322e-02*G4_0_1_0_0_1_1 - 8.333333333333323e-02*G4_0_1_0_1_1_1 - 8.333333333333323e-02*G4_0_1_0_2_1_1 - 8.333333333333322e-02*G4_0_2_0_0_2_1 - 8.333333333333323e-02*G4_0_2_0_1_2_1 - 8.333333333333323e-02*G4_0_2_0_2_2_1 - 8.333333333333322e-02*G4_1_0_1_0_0_1 - 8.333333333333323e-02*G4_1_0_1_1_0_1 - 8.333333333333323e-02*G4_1_0_1_2_0_1 - 8.333333333333322e-02*G4_1_1_1_0_1_1 - 8.333333333333323e-02*G4_1_1_1_1_1_1 - 8.333333333333323e-02*G4_1_1_1_2_1_1 - 8.333333333333322e-02*G4_1_2_1_0_2_1 - 8.333333333333323e-02*G4_1_2_1_1_2_1 - 8.333333333333323e-02*G4_1_2_1_2_2_1 - 8.333333333333322e-02*G4_2_0_2_0_0_1 - 8.333333333333323e-02*G4_2_0_2_1_0_1 - 8.333333333333323e-02*G4_2_0_2_2_0_1 - 8.333333333333322e-02*G4_2_1_2_0_1_1 - 8.333333333333323e-02*G4_2_1_2_1_1_1 - 8.333333333333323e-02*G4_2_1_2_2_1_1 - 8.333333333333322e-02*G4_2_2_2_0_2_1 - 8.333333333333323e-02*G4_2_2_2_1_2_1 - 8.333333333333323e-02*G4_2_2_2_2_2_1;
    block[107] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_0_2 - 8.333333333333323e-02*G1_1_2 - 8.333333333333323e-02*G1_2_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 - 8.333333333333322e-02*G3_2_2_0_2 - 8.333333333333323e-02*G3_2_2_1_2 - 8.333333333333323e-02*G3_2_2_2_2 - 8.333333333333322e-02*G4_0_0_0_0_0_2 - 8.333333333333323e-02*G4_0_0_0_1_0_2 - 8.333333333333323e-02*G4_0_0_0_2_0_2 - 8.333333333333322e-02*G4_0_1_0_0_1_2 - 8.333333333333323e-02*G4_0_1_0_1_1_2 - 8.333333333333323e-02*G4_0_1_0_2_1_2 - 8.333333333333322e-02*G4_0_2_0_0_2_2 - 8.333333333333323e-02*G4_0_2_0_1_2_2 - 8.333333333333323e-02*G4_0_2_0_2_2_2 - 8.333333333333322e-02*G4_1_0_1_0_0_2 - 8.333333333333323e-02*G4_1_0_1_1_0_2 - 8.333333333333323e-02*G4_1_0_1_2_0_2 - 8.333333333333322e-02*G4_1_1_1_0_1_2 - 8.333333333333323e-02*G4_1_1_1_1_1_2 - 8.333333333333323e-02*G4_1_1_1_2_1_2 - 8.333333333333322e-02*G4_1_2_1_0_2_2 - 8.333333333333323e-02*G4_1_2_1_1_2_2 - 8.333333333333323e-02*G4_1_2_1_2_2_2 - 8.333333333333322e-02*G4_2_0_2_0_0_2 - 8.333333333333323e-02*G4_2_0_2_1_0_2 - 8.333333333333323e-02*G4_2_0_2_2_0_2 - 8.333333333333322e-02*G4_2_1_2_0_1_2 - 8.333333333333323e-02*G4_2_1_2_1_1_2 - 8.333333333333323e-02*G4_2_1_2_2_1_2 - 8.333333333333322e-02*G4_2_2_2_0_2_2 - 8.333333333333323e-02*G4_2_2_2_1_2_2 - 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[108] = -8.333333333333320e-02*G3_2_0_0_0 - 8.333333333333322e-02*G3_2_0_0_1 - 8.333333333333320e-02*G3_2_0_0_2;
    block[109] = 8.333333333333320e-02*G3_2_0_0_0;
    block[110] = 8.333333333333322e-02*G3_2_0_0_1;
    block[111] = 8.333333333333322e-02*G3_2_0_0_2;
    block[112] = -8.333333333333320e-02*G3_2_1_0_0 - 8.333333333333322e-02*G3_2_1_0_1 - 8.333333333333322e-02*G3_2_1_0_2;
    block[113] = 8.333333333333320e-02*G3_2_1_0_0;
    block[114] = 8.333333333333322e-02*G3_2_1_0_1;
    block[115] = 8.333333333333322e-02*G3_2_1_0_2;
    block[116] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_0_1 - 8.333333333333322e-02*G1_0_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 - 8.333333333333320e-02*G3_2_2_0_0 - 8.333333333333322e-02*G3_2_2_0_1 - 8.333333333333322e-02*G3_2_2_0_2 - 8.333333333333320e-02*G4_0_0_0_0_0_0 - 8.333333333333322e-02*G4_0_0_0_0_0_1 - 8.333333333333322e-02*G4_0_0_0_0_0_2 - 8.333333333333320e-02*G4_0_1_0_0_1_0 - 8.333333333333322e-02*G4_0_1_0_0_1_1 - 8.333333333333322e-02*G4_0_1_0_0_1_2 - 8.333333333333320e-02*G4_0_2_0_0_2_0 - 8.333333333333322e-02*G4_0_2_0_0_2_1 - 8.333333333333322e-02*G4_0_2_0_0_2_2 - 8.333333333333320e-02*G4_1_0_1_0_0_0 - 8.333333333333322e-02*G4_1_0_1_0_0_1 - 8.333333333333322e-02*G4_1_0_1_0_0_2 - 8.333333333333320e-02*G4_1_1_1_0_1_0 - 8.333333333333322e-02*G4_1_1_1_0_1_1 - 8.333333333333322e-02*G4_1_1_1_0_1_2 - 8.333333333333320e-02*G4_1_2_1_0_2_0 - 8.333333333333322e-02*G4_1_2_1_0_2_1 - 8.333333333333322e-02*G4_1_2_1_0_2_2 - 8.333333333333320e-02*G4_2_0_2_0_0_0 - 8.333333333333322e-02*G4_2_0_2_0_0_1 - 8.333333333333322e-02*G4_2_0_2_0_0_2 - 8.333333333333320e-02*G4_2_1_2_0_1_0 - 8.333333333333322e-02*G4_2_1_2_0_1_1 - 8.333333333333322e-02*G4_2_1_2_0_1_2 - 8.333333333333320e-02*G4_2_2_2_0_2_0 - 8.333333333333322e-02*G4_2_2_2_0_2_1 - 8.333333333333322e-02*G4_2_2_2_0_2_2;
    block[117] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333320e-02*G3_2_2_0_0 + 8.333333333333320e-02*G4_0_0_0_0_0_0 + 8.333333333333320e-02*G4_0_1_0_0_1_0 + 8.333333333333320e-02*G4_0_2_0_0_2_0 + 8.333333333333320e-02*G4_1_0_1_0_0_0 + 8.333333333333320e-02*G4_1_1_1_0_1_0 + 8.333333333333320e-02*G4_1_2_1_0_2_0 + 8.333333333333320e-02*G4_2_0_2_0_0_0 + 8.333333333333320e-02*G4_2_1_2_0_1_0 + 8.333333333333320e-02*G4_2_2_2_0_2_0;
    block[118] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_0_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333322e-02*G3_2_2_0_1 + 8.333333333333322e-02*G4_0_0_0_0_0_1 + 8.333333333333322e-02*G4_0_1_0_0_1_1 + 8.333333333333322e-02*G4_0_2_0_0_2_1 + 8.333333333333322e-02*G4_1_0_1_0_0_1 + 8.333333333333322e-02*G4_1_1_1_0_1_1 + 8.333333333333322e-02*G4_1_2_1_0_2_1 + 8.333333333333322e-02*G4_2_0_2_0_0_1 + 8.333333333333322e-02*G4_2_1_2_0_1_1 + 8.333333333333322e-02*G4_2_2_2_0_2_1;
    block[119] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_0_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333322e-02*G3_2_2_0_2 + 8.333333333333322e-02*G4_0_0_0_0_0_2 + 8.333333333333322e-02*G4_0_1_0_0_1_2 + 8.333333333333322e-02*G4_0_2_0_0_2_2 + 8.333333333333322e-02*G4_1_0_1_0_0_2 + 8.333333333333322e-02*G4_1_1_1_0_1_2 + 8.333333333333322e-02*G4_1_2_1_0_2_2 + 8.333333333333322e-02*G4_2_0_2_0_0_2 + 8.333333333333322e-02*G4_2_1_2_0_1_2 + 8.333333333333322e-02*G4_2_2_2_0_2_2;
    block[120] = -8.333333333333322e-02*G3_2_0_1_0 - 8.333333333333323e-02*G3_2_0_1_1 - 8.333333333333322e-02*G3_2_0_1_2;
    block[121] = 8.333333333333322e-02*G3_2_0_1_0;
    block[122] = 8.333333333333323e-02*G3_2_0_1_1;
    block[123] = 8.333333333333323e-02*G3_2_0_1_2;
    block[124] = -8.333333333333322e-02*G3_2_1_1_0 - 8.333333333333323e-02*G3_2_1_1_1 - 8.333333333333323e-02*G3_2_1_1_2;
    block[125] = 8.333333333333322e-02*G3_2_1_1_0;
    block[126] = 8.333333333333323e-02*G3_2_1_1_1;
    block[127] = 8.333333333333323e-02*G3_2_1_1_2;
    block[128] = 8.333333333333307e-03*G0_ - 8.333333333333322e-02*G1_1_0 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_1_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 - 8.333333333333322e-02*G3_2_2_1_0 - 8.333333333333323e-02*G3_2_2_1_1 - 8.333333333333323e-02*G3_2_2_1_2 - 8.333333333333322e-02*G4_0_0_0_1_0_0 - 8.333333333333323e-02*G4_0_0_0_1_0_1 - 8.333333333333323e-02*G4_0_0_0_1_0_2 - 8.333333333333322e-02*G4_0_1_0_1_1_0 - 8.333333333333323e-02*G4_0_1_0_1_1_1 - 8.333333333333323e-02*G4_0_1_0_1_1_2 - 8.333333333333322e-02*G4_0_2_0_1_2_0 - 8.333333333333323e-02*G4_0_2_0_1_2_1 - 8.333333333333323e-02*G4_0_2_0_1_2_2 - 8.333333333333322e-02*G4_1_0_1_1_0_0 - 8.333333333333323e-02*G4_1_0_1_1_0_1 - 8.333333333333323e-02*G4_1_0_1_1_0_2 - 8.333333333333322e-02*G4_1_1_1_1_1_0 - 8.333333333333323e-02*G4_1_1_1_1_1_1 - 8.333333333333323e-02*G4_1_1_1_1_1_2 - 8.333333333333322e-02*G4_1_2_1_1_2_0 - 8.333333333333323e-02*G4_1_2_1_1_2_1 - 8.333333333333323e-02*G4_1_2_1_1_2_2 - 8.333333333333322e-02*G4_2_0_2_1_0_0 - 8.333333333333323e-02*G4_2_0_2_1_0_1 - 8.333333333333323e-02*G4_2_0_2_1_0_2 - 8.333333333333322e-02*G4_2_1_2_1_1_0 - 8.333333333333323e-02*G4_2_1_2_1_1_1 - 8.333333333333323e-02*G4_2_1_2_1_1_2 - 8.333333333333322e-02*G4_2_2_2_1_2_0 - 8.333333333333323e-02*G4_2_2_2_1_2_1 - 8.333333333333323e-02*G4_2_2_2_1_2_2;
    block[129] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_1_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333322e-02*G3_2_2_1_0 + 8.333333333333322e-02*G4_0_0_0_1_0_0 + 8.333333333333322e-02*G4_0_1_0_1_1_0 + 8.333333333333322e-02*G4_0_2_0_1_2_0 + 8.333333333333322e-02*G4_1_0_1_1_0_0 + 8.333333333333322e-02*G4_1_1_1_1_1_0 + 8.333333333333322e-02*G4_1_2_1_1_2_0 + 8.333333333333322e-02*G4_2_0_2_1_0_0 + 8.333333333333322e-02*G4_2_1_2_1_1_0 + 8.333333333333322e-02*G4_2_2_2_1_2_0;
    block[130] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_1_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333323e-02*G3_2_2_1_1 + 8.333333333333323e-02*G4_0_0_0_1_0_1 + 8.333333333333323e-02*G4_0_1_0_1_1_1 + 8.333333333333323e-02*G4_0_2_0_1_2_1 + 8.333333333333323e-02*G4_1_0_1_1_0_1 + 8.333333333333323e-02*G4_1_1_1_1_1_1 + 8.333333333333323e-02*G4_1_2_1_1_2_1 + 8.333333333333323e-02*G4_2_0_2_1_0_1 + 8.333333333333323e-02*G4_2_1_2_1_1_1 + 8.333333333333323e-02*G4_2_2_2_1_2_1;
    block[131] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_1_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333323e-02*G3_2_2_1_2 + 8.333333333333323e-02*G4_0_0_0_1_0_2 + 8.333333333333323e-02*G4_0_1_0_1_1_2 + 8.333333333333323e-02*G4_0_2_0_1_2_2 + 8.333333333333323e-02*G4_1_0_1_1_0_2 + 8.333333333333323e-02*G4_1_1_1_1_1_2 + 8.333333333333323e-02*G4_1_2_1_1_2_2 + 8.333333333333323e-02*G4_2_0_2_1_0_2 + 8.333333333333323e-02*G4_2_1_2_1_1_2 + 8.333333333333323e-02*G4_2_2_2_1_2_2;
    block[132] = -8.333333333333322e-02*G3_2_0_2_0 - 8.333333333333323e-02*G3_2_0_2_1 - 8.333333333333322e-02*G3_2_0_2_2;
    block[133] = 8.333333333333322e-02*G3_2_0_2_0;
    block[134] = 8.333333333333323e-02*G3_2_0_2_1;
    block[135] = 8.333333333333323e-02*G3_2_0_2_2;
    block[136] = -8.333333333333322e-02*G3_2_1_2_0 - 8.333333333333323e-02*G3_2_1_2_1 - 8.333333333333323e-02*G3_2_1_2_2;
    block[137] = 8.333333333333322e-02*G3_2_1_2_0;
    block[138] = 8.333333333333323e-02*G3_2_1_2_1;
    block[139] = 8.333333333333323e-02*G3_2_1_2_2;
    block[140] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_2_0 - 8.333333333333323e-02*G1_2_1 - 8.333333333333323e-02*G1_2_2 - 2.083333333333330e-02*G2_0_0_0 - 2.083333333333331e-02*G2_0_0_1 - 2.083333333333331e-02*G2_0_0_2 - 2.083333333333330e-02*G2_1_1_0 - 2.083333333333331e-02*G2_1_1_1 - 2.083333333333331e-02*G2_1_1_2 - 2.083333333333330e-02*G2_2_2_0 - 2.083333333333331e-02*G2_2_2_1 - 2.083333333333331e-02*G2_2_2_2 - 8.333333333333322e-02*G3_2_2_2_0 - 8.333333333333323e-02*G3_2_2_2_1 - 8.333333333333323e-02*G3_2_2_2_2 - 8.333333333333322e-02*G4_0_0_0_2_0_0 - 8.333333333333323e-02*G4_0_0_0_2_0_1 - 8.333333333333323e-02*G4_0_0_0_2_0_2 - 8.333333333333322e-02*G4_0_1_0_2_1_0 - 8.333333333333323e-02*G4_0_1_0_2_1_1 - 8.333333333333323e-02*G4_0_1_0_2_1_2 - 8.333333333333322e-02*G4_0_2_0_2_2_0 - 8.333333333333323e-02*G4_0_2_0_2_2_1 - 8.333333333333323e-02*G4_0_2_0_2_2_2 - 8.333333333333322e-02*G4_1_0_1_2_0_0 - 8.333333333333323e-02*G4_1_0_1_2_0_1 - 8.333333333333323e-02*G4_1_0_1_2_0_2 - 8.333333333333322e-02*G4_1_1_1_2_1_0 - 8.333333333333323e-02*G4_1_1_1_2_1_1 - 8.333333333333323e-02*G4_1_1_1_2_1_2 - 8.333333333333322e-02*G4_1_2_1_2_2_0 - 8.333333333333323e-02*G4_1_2_1_2_2_1 - 8.333333333333323e-02*G4_1_2_1_2_2_2 - 8.333333333333322e-02*G4_2_0_2_2_0_0 - 8.333333333333323e-02*G4_2_0_2_2_0_1 - 8.333333333333323e-02*G4_2_0_2_2_0_2 - 8.333333333333322e-02*G4_2_1_2_2_1_0 - 8.333333333333323e-02*G4_2_1_2_2_1_1 - 8.333333333333323e-02*G4_2_1_2_2_1_2 - 8.333333333333322e-02*G4_2_2_2_2_2_0 - 8.333333333333323e-02*G4_2_2_2_2_2_1 - 8.333333333333323e-02*G4_2_2_2_2_2_2;
    block[141] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_2_0 + 2.083333333333330e-02*G2_0_0_0 + 2.083333333333330e-02*G2_1_1_0 + 2.083333333333330e-02*G2_2_2_0 + 8.333333333333322e-02*G3_2_2_2_0 + 8.333333333333322e-02*G4_0_0_0_2_0_0 + 8.333333333333322e-02*G4_0_1_0_2_1_0 + 8.333333333333322e-02*G4_0_2_0_2_2_0 + 8.333333333333322e-02*G4_1_0_1_2_0_0 + 8.333333333333322e-02*G4_1_1_1_2_1_0 + 8.333333333333322e-02*G4_1_2_1_2_2_0 + 8.333333333333322e-02*G4_2_0_2_2_0_0 + 8.333333333333322e-02*G4_2_1_2_2_1_0 + 8.333333333333322e-02*G4_2_2_2_2_2_0;
    block[142] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_2_1 + 2.083333333333331e-02*G2_0_0_1 + 2.083333333333331e-02*G2_1_1_1 + 2.083333333333331e-02*G2_2_2_1 + 8.333333333333323e-02*G3_2_2_2_1 + 8.333333333333323e-02*G4_0_0_0_2_0_1 + 8.333333333333323e-02*G4_0_1_0_2_1_1 + 8.333333333333323e-02*G4_0_2_0_2_2_1 + 8.333333333333323e-02*G4_1_0_1_2_0_1 + 8.333333333333323e-02*G4_1_1_1_2_1_1 + 8.333333333333323e-02*G4_1_2_1_2_2_1 + 8.333333333333323e-02*G4_2_0_2_2_0_1 + 8.333333333333323e-02*G4_2_1_2_2_1_1 + 8.333333333333323e-02*G4_2_2_2_2_2_1;
    block[143] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_2_2 + 2.083333333333331e-02*G2_0_0_2 + 2.083333333333331e-02*G2_1_1_2 + 2.083333333333331e-02*G2_2_2_2 + 8.333333333333323e-02*G3_2_2_2_2 + 8.333333333333323e-02*G4_0_0_0_2_0_2 + 8.333333333333323e-02*G4_0_1_0_2_1_2 + 8.333333333333323e-02*G4_0_2_0_2_2_2 + 8.333333333333323e-02*G4_1_0_1_2_0_2 + 8.333333333333323e-02*G4_1_1_1_2_1_2 + 8.333333333333323e-02*G4_1_2_1_2_2_2 + 8.333333333333323e-02*G4_2_0_2_2_0_2 + 8.333333333333323e-02*G4_2_1_2_2_1_2 + 8.333333333333323e-02*G4_2_2_2_2_2_2;

  }
        
private:

  const real& c0;  const real& c1;  const real& c2;  const real& c3;

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = 3*cell.id() + 0;
      dofs[1] = 3*cell.id() + 1;
      dofs[2] = 3*cell.id() + 2;
      int offset = 3*mesh.noCells();
      dofs[3] = offset + 3*cell.id() + 0;
      dofs[4] = offset + 3*cell.id() + 1;
      dofs[5] = offset + 3*cell.id() + 2;
      offset = offset + 3*mesh.noCells();
      dofs[6] = offset + 3*cell.id() + 0;
      dofs[7] = offset + 3*cell.id() + 1;
      dofs[8] = offset + 3*cell.id() + 2;
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[1] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[2] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 1;
      components[2] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_1 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_1() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_1()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_2 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_2() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_2()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_3 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_3() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~FunctionElement_3()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0, Function& w1, Function& w2, Function& w3, const real& c0, const real& c1, const real& c2, const real& c3) : dolfin::LinearForm(4), c0(c0), c1(c1), c2(c2), c3(c3)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
    add(w1, new FunctionElement_1());
    add(w2, new FunctionElement_2());
    add(w3, new FunctionElement_3());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0 = map.det*c[1][0];
    real G0_1 = map.det*c[1][1];
    real G0_2 = map.det*c[1][2];
    real G0_3 = map.det*c[1][3];
    real G0_4 = map.det*c[1][4];
    real G0_5 = map.det*c[1][5];
    real G0_6 = map.det*c[1][6];
    real G0_7 = map.det*c[1][7];
    real G0_8 = map.det*c[1][8];
    real G0_9 = map.det*c[1][9];
    real G0_10 = map.det*c[1][10];
    real G0_11 = map.det*c[1][11];
    real G1_0 = map.det*c0*c[2][0];
    real G1_1 = map.det*c0*c[2][1];
    real G1_2 = map.det*c0*c[2][2];
    real G1_3 = map.det*c0*c[2][3];
    real G1_4 = map.det*c0*c[2][4];
    real G1_5 = map.det*c0*c[2][5];
    real G1_6 = map.det*c0*c[2][6];
    real G1_7 = map.det*c0*c[2][7];
    real G1_8 = map.det*c0*c[2][8];
    real G1_9 = map.det*c0*c[2][9];
    real G1_10 = map.det*c0*c[2][10];
    real G1_11 = map.det*c0*c[2][11];
    real G2_0_0_0 = map.det*c0*c[3][0]*map.g00;
    real G2_0_0_1 = map.det*c0*c[3][1]*map.g00;
    real G2_0_0_2 = map.det*c0*c[3][2]*map.g00;
    real G2_0_0_3 = map.det*c0*c[3][3]*map.g00;
    real G2_0_1_0 = map.det*c0*c[3][0]*map.g10;
    real G2_0_1_1 = map.det*c0*c[3][1]*map.g10;
    real G2_0_1_2 = map.det*c0*c[3][2]*map.g10;
    real G2_0_1_3 = map.det*c0*c[3][3]*map.g10;
    real G2_0_2_0 = map.det*c0*c[3][0]*map.g20;
    real G2_0_2_1 = map.det*c0*c[3][1]*map.g20;
    real G2_0_2_2 = map.det*c0*c[3][2]*map.g20;
    real G2_0_2_3 = map.det*c0*c[3][3]*map.g20;
    real G2_1_0_0 = map.det*c0*c[3][0]*map.g01;
    real G2_1_0_1 = map.det*c0*c[3][1]*map.g01;
    real G2_1_0_2 = map.det*c0*c[3][2]*map.g01;
    real G2_1_0_3 = map.det*c0*c[3][3]*map.g01;
    real G2_1_1_0 = map.det*c0*c[3][0]*map.g11;
    real G2_1_1_1 = map.det*c0*c[3][1]*map.g11;
    real G2_1_1_2 = map.det*c0*c[3][2]*map.g11;
    real G2_1_1_3 = map.det*c0*c[3][3]*map.g11;
    real G2_1_2_0 = map.det*c0*c[3][0]*map.g21;
    real G2_1_2_1 = map.det*c0*c[3][1]*map.g21;
    real G2_1_2_2 = map.det*c0*c[3][2]*map.g21;
    real G2_1_2_3 = map.det*c0*c[3][3]*map.g21;
    real G2_2_0_0 = map.det*c0*c[3][0]*map.g02;
    real G2_2_0_1 = map.det*c0*c[3][1]*map.g02;
    real G2_2_0_2 = map.det*c0*c[3][2]*map.g02;
    real G2_2_0_3 = map.det*c0*c[3][3]*map.g02;
    real G2_2_1_0 = map.det*c0*c[3][0]*map.g12;
    real G2_2_1_1 = map.det*c0*c[3][1]*map.g12;
    real G2_2_1_2 = map.det*c0*c[3][2]*map.g12;
    real G2_2_1_3 = map.det*c0*c[3][3]*map.g12;
    real G2_2_2_0 = map.det*c0*c[3][0]*map.g22;
    real G2_2_2_1 = map.det*c0*c[3][1]*map.g22;
    real G2_2_2_2 = map.det*c0*c[3][2]*map.g22;
    real G2_2_2_3 = map.det*c0*c[3][3]*map.g22;
    real G3_0_0_0_0 = map.det*c2*c0*c[0][0]*c[2][0]*map.g00;
    real G3_0_0_0_1 = map.det*c2*c0*c[0][0]*c[2][1]*map.g00;
    real G3_0_0_0_2 = map.det*c2*c0*c[0][0]*c[2][2]*map.g00;
    real G3_0_0_0_3 = map.det*c2*c0*c[0][0]*c[2][3]*map.g00;
    real G3_0_0_0_4 = map.det*c2*c0*c[0][0]*c[2][4]*map.g00;
    real G3_0_0_0_5 = map.det*c2*c0*c[0][0]*c[2][5]*map.g00;
    real G3_0_0_0_6 = map.det*c2*c0*c[0][0]*c[2][6]*map.g00;
    real G3_0_0_0_7 = map.det*c2*c0*c[0][0]*c[2][7]*map.g00;
    real G3_0_0_0_8 = map.det*c2*c0*c[0][0]*c[2][8]*map.g00;
    real G3_0_0_0_9 = map.det*c2*c0*c[0][0]*c[2][9]*map.g00;
    real G3_0_0_0_10 = map.det*c2*c0*c[0][0]*c[2][10]*map.g00;
    real G3_0_0_0_11 = map.det*c2*c0*c[0][0]*c[2][11]*map.g00;
    real G3_0_0_1_0 = map.det*c2*c0*c[0][0]*c[2][0]*map.g10;
    real G3_0_0_1_1 = map.det*c2*c0*c[0][0]*c[2][1]*map.g10;
    real G3_0_0_1_2 = map.det*c2*c0*c[0][0]*c[2][2]*map.g10;
    real G3_0_0_1_3 = map.det*c2*c0*c[0][0]*c[2][3]*map.g10;
    real G3_0_0_1_4 = map.det*c2*c0*c[0][0]*c[2][4]*map.g10;
    real G3_0_0_1_5 = map.det*c2*c0*c[0][0]*c[2][5]*map.g10;
    real G3_0_0_1_6 = map.det*c2*c0*c[0][0]*c[2][6]*map.g10;
    real G3_0_0_1_7 = map.det*c2*c0*c[0][0]*c[2][7]*map.g10;
    real G3_0_0_1_8 = map.det*c2*c0*c[0][0]*c[2][8]*map.g10;
    real G3_0_0_1_9 = map.det*c2*c0*c[0][0]*c[2][9]*map.g10;
    real G3_0_0_1_10 = map.det*c2*c0*c[0][0]*c[2][10]*map.g10;
    real G3_0_0_1_11 = map.det*c2*c0*c[0][0]*c[2][11]*map.g10;
    real G3_0_0_2_0 = map.det*c2*c0*c[0][0]*c[2][0]*map.g20;
    real G3_0_0_2_1 = map.det*c2*c0*c[0][0]*c[2][1]*map.g20;
    real G3_0_0_2_2 = map.det*c2*c0*c[0][0]*c[2][2]*map.g20;
    real G3_0_0_2_3 = map.det*c2*c0*c[0][0]*c[2][3]*map.g20;
    real G3_0_0_2_4 = map.det*c2*c0*c[0][0]*c[2][4]*map.g20;
    real G3_0_0_2_5 = map.det*c2*c0*c[0][0]*c[2][5]*map.g20;
    real G3_0_0_2_6 = map.det*c2*c0*c[0][0]*c[2][6]*map.g20;
    real G3_0_0_2_7 = map.det*c2*c0*c[0][0]*c[2][7]*map.g20;
    real G3_0_0_2_8 = map.det*c2*c0*c[0][0]*c[2][8]*map.g20;
    real G3_0_0_2_9 = map.det*c2*c0*c[0][0]*c[2][9]*map.g20;
    real G3_0_0_2_10 = map.det*c2*c0*c[0][0]*c[2][10]*map.g20;
    real G3_0_0_2_11 = map.det*c2*c0*c[0][0]*c[2][11]*map.g20;
    real G3_1_1_0_0 = map.det*c2*c0*c[0][1]*c[2][0]*map.g01;
    real G3_1_1_0_1 = map.det*c2*c0*c[0][1]*c[2][1]*map.g01;
    real G3_1_1_0_2 = map.det*c2*c0*c[0][1]*c[2][2]*map.g01;
    real G3_1_1_0_3 = map.det*c2*c0*c[0][1]*c[2][3]*map.g01;
    real G3_1_1_0_4 = map.det*c2*c0*c[0][1]*c[2][4]*map.g01;
    real G3_1_1_0_5 = map.det*c2*c0*c[0][1]*c[2][5]*map.g01;
    real G3_1_1_0_6 = map.det*c2*c0*c[0][1]*c[2][6]*map.g01;
    real G3_1_1_0_7 = map.det*c2*c0*c[0][1]*c[2][7]*map.g01;
    real G3_1_1_0_8 = map.det*c2*c0*c[0][1]*c[2][8]*map.g01;
    real G3_1_1_0_9 = map.det*c2*c0*c[0][1]*c[2][9]*map.g01;
    real G3_1_1_0_10 = map.det*c2*c0*c[0][1]*c[2][10]*map.g01;
    real G3_1_1_0_11 = map.det*c2*c0*c[0][1]*c[2][11]*map.g01;
    real G3_1_1_1_0 = map.det*c2*c0*c[0][1]*c[2][0]*map.g11;
    real G3_1_1_1_1 = map.det*c2*c0*c[0][1]*c[2][1]*map.g11;
    real G3_1_1_1_2 = map.det*c2*c0*c[0][1]*c[2][2]*map.g11;
    real G3_1_1_1_3 = map.det*c2*c0*c[0][1]*c[2][3]*map.g11;
    real G3_1_1_1_4 = map.det*c2*c0*c[0][1]*c[2][4]*map.g11;
    real G3_1_1_1_5 = map.det*c2*c0*c[0][1]*c[2][5]*map.g11;
    real G3_1_1_1_6 = map.det*c2*c0*c[0][1]*c[2][6]*map.g11;
    real G3_1_1_1_7 = map.det*c2*c0*c[0][1]*c[2][7]*map.g11;
    real G3_1_1_1_8 = map.det*c2*c0*c[0][1]*c[2][8]*map.g11;
    real G3_1_1_1_9 = map.det*c2*c0*c[0][1]*c[2][9]*map.g11;
    real G3_1_1_1_10 = map.det*c2*c0*c[0][1]*c[2][10]*map.g11;
    real G3_1_1_1_11 = map.det*c2*c0*c[0][1]*c[2][11]*map.g11;
    real G3_1_1_2_0 = map.det*c2*c0*c[0][1]*c[2][0]*map.g21;
    real G3_1_1_2_1 = map.det*c2*c0*c[0][1]*c[2][1]*map.g21;
    real G3_1_1_2_2 = map.det*c2*c0*c[0][1]*c[2][2]*map.g21;
    real G3_1_1_2_3 = map.det*c2*c0*c[0][1]*c[2][3]*map.g21;
    real G3_1_1_2_4 = map.det*c2*c0*c[0][1]*c[2][4]*map.g21;
    real G3_1_1_2_5 = map.det*c2*c0*c[0][1]*c[2][5]*map.g21;
    real G3_1_1_2_6 = map.det*c2*c0*c[0][1]*c[2][6]*map.g21;
    real G3_1_1_2_7 = map.det*c2*c0*c[0][1]*c[2][7]*map.g21;
    real G3_1_1_2_8 = map.det*c2*c0*c[0][1]*c[2][8]*map.g21;
    real G3_1_1_2_9 = map.det*c2*c0*c[0][1]*c[2][9]*map.g21;
    real G3_1_1_2_10 = map.det*c2*c0*c[0][1]*c[2][10]*map.g21;
    real G3_1_1_2_11 = map.det*c2*c0*c[0][1]*c[2][11]*map.g21;
    real G3_2_2_0_0 = map.det*c2*c0*c[0][2]*c[2][0]*map.g02;
    real G3_2_2_0_1 = map.det*c2*c0*c[0][2]*c[2][1]*map.g02;
    real G3_2_2_0_2 = map.det*c2*c0*c[0][2]*c[2][2]*map.g02;
    real G3_2_2_0_3 = map.det*c2*c0*c[0][2]*c[2][3]*map.g02;
    real G3_2_2_0_4 = map.det*c2*c0*c[0][2]*c[2][4]*map.g02;
    real G3_2_2_0_5 = map.det*c2*c0*c[0][2]*c[2][5]*map.g02;
    real G3_2_2_0_6 = map.det*c2*c0*c[0][2]*c[2][6]*map.g02;
    real G3_2_2_0_7 = map.det*c2*c0*c[0][2]*c[2][7]*map.g02;
    real G3_2_2_0_8 = map.det*c2*c0*c[0][2]*c[2][8]*map.g02;
    real G3_2_2_0_9 = map.det*c2*c0*c[0][2]*c[2][9]*map.g02;
    real G3_2_2_0_10 = map.det*c2*c0*c[0][2]*c[2][10]*map.g02;
    real G3_2_2_0_11 = map.det*c2*c0*c[0][2]*c[2][11]*map.g02;
    real G3_2_2_1_0 = map.det*c2*c0*c[0][2]*c[2][0]*map.g12;
    real G3_2_2_1_1 = map.det*c2*c0*c[0][2]*c[2][1]*map.g12;
    real G3_2_2_1_2 = map.det*c2*c0*c[0][2]*c[2][2]*map.g12;
    real G3_2_2_1_3 = map.det*c2*c0*c[0][2]*c[2][3]*map.g12;
    real G3_2_2_1_4 = map.det*c2*c0*c[0][2]*c[2][4]*map.g12;
    real G3_2_2_1_5 = map.det*c2*c0*c[0][2]*c[2][5]*map.g12;
    real G3_2_2_1_6 = map.det*c2*c0*c[0][2]*c[2][6]*map.g12;
    real G3_2_2_1_7 = map.det*c2*c0*c[0][2]*c[2][7]*map.g12;
    real G3_2_2_1_8 = map.det*c2*c0*c[0][2]*c[2][8]*map.g12;
    real G3_2_2_1_9 = map.det*c2*c0*c[0][2]*c[2][9]*map.g12;
    real G3_2_2_1_10 = map.det*c2*c0*c[0][2]*c[2][10]*map.g12;
    real G3_2_2_1_11 = map.det*c2*c0*c[0][2]*c[2][11]*map.g12;
    real G3_2_2_2_0 = map.det*c2*c0*c[0][2]*c[2][0]*map.g22;
    real G3_2_2_2_1 = map.det*c2*c0*c[0][2]*c[2][1]*map.g22;
    real G3_2_2_2_2 = map.det*c2*c0*c[0][2]*c[2][2]*map.g22;
    real G3_2_2_2_3 = map.det*c2*c0*c[0][2]*c[2][3]*map.g22;
    real G3_2_2_2_4 = map.det*c2*c0*c[0][2]*c[2][4]*map.g22;
    real G3_2_2_2_5 = map.det*c2*c0*c[0][2]*c[2][5]*map.g22;
    real G3_2_2_2_6 = map.det*c2*c0*c[0][2]*c[2][6]*map.g22;
    real G3_2_2_2_7 = map.det*c2*c0*c[0][2]*c[2][7]*map.g22;
    real G3_2_2_2_8 = map.det*c2*c0*c[0][2]*c[2][8]*map.g22;
    real G3_2_2_2_9 = map.det*c2*c0*c[0][2]*c[2][9]*map.g22;
    real G3_2_2_2_10 = map.det*c2*c0*c[0][2]*c[2][10]*map.g22;
    real G3_2_2_2_11 = map.det*c2*c0*c[0][2]*c[2][11]*map.g22;
    real G4_0_0_0 = map.det*c0*c1*c[1][0]*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G4_0_0_1 = map.det*c0*c1*c[1][0]*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G4_0_0_2 = map.det*c0*c1*c[1][0]*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G4_0_1_0 = map.det*c0*c1*c[1][1]*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G4_0_2_1 = map.det*c0*c1*c[1][2]*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G4_0_3_2 = map.det*c0*c1*c[1][3]*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G4_0_4_0 = map.det*c0*c1*c[1][4]*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G4_0_4_1 = map.det*c0*c1*c[1][4]*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G4_0_4_2 = map.det*c0*c1*c[1][4]*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G4_0_5_0 = map.det*c0*c1*c[1][5]*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G4_0_6_1 = map.det*c0*c1*c[1][6]*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G4_0_7_2 = map.det*c0*c1*c[1][7]*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G4_0_8_0 = map.det*c0*c1*c[1][8]*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G4_0_8_1 = map.det*c0*c1*c[1][8]*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G4_0_8_2 = map.det*c0*c1*c[1][8]*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G4_0_9_0 = map.det*c0*c1*c[1][9]*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    real G4_0_10_1 = map.det*c0*c1*c[1][10]*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    real G4_0_11_2 = map.det*c0*c1*c[1][11]*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    real G4_1_0_0 = map.det*c0*c1*c[1][0]*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G4_1_0_1 = map.det*c0*c1*c[1][0]*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G4_1_0_2 = map.det*c0*c1*c[1][0]*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G4_1_1_0 = map.det*c0*c1*c[1][1]*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G4_1_2_1 = map.det*c0*c1*c[1][2]*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G4_1_3_2 = map.det*c0*c1*c[1][3]*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G4_1_4_0 = map.det*c0*c1*c[1][4]*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G4_1_4_1 = map.det*c0*c1*c[1][4]*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G4_1_4_2 = map.det*c0*c1*c[1][4]*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G4_1_5_0 = map.det*c0*c1*c[1][5]*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G4_1_6_1 = map.det*c0*c1*c[1][6]*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G4_1_7_2 = map.det*c0*c1*c[1][7]*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G4_1_8_0 = map.det*c0*c1*c[1][8]*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G4_1_8_1 = map.det*c0*c1*c[1][8]*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G4_1_8_2 = map.det*c0*c1*c[1][8]*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G4_1_9_0 = map.det*c0*c1*c[1][9]*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    real G4_1_10_1 = map.det*c0*c1*c[1][10]*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    real G4_1_11_2 = map.det*c0*c1*c[1][11]*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    real G4_2_0_0 = map.det*c0*c1*c[1][0]*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G4_2_0_1 = map.det*c0*c1*c[1][0]*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G4_2_0_2 = map.det*c0*c1*c[1][0]*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);
    real G4_2_1_0 = map.det*c0*c1*c[1][1]*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G4_2_2_1 = map.det*c0*c1*c[1][2]*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G4_2_3_2 = map.det*c0*c1*c[1][3]*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);
    real G4_2_4_0 = map.det*c0*c1*c[1][4]*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G4_2_4_1 = map.det*c0*c1*c[1][4]*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G4_2_4_2 = map.det*c0*c1*c[1][4]*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);
    real G4_2_5_0 = map.det*c0*c1*c[1][5]*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G4_2_6_1 = map.det*c0*c1*c[1][6]*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G4_2_7_2 = map.det*c0*c1*c[1][7]*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);
    real G4_2_8_0 = map.det*c0*c1*c[1][8]*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G4_2_8_1 = map.det*c0*c1*c[1][8]*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G4_2_8_2 = map.det*c0*c1*c[1][8]*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);
    real G4_2_9_0 = map.det*c0*c1*c[1][9]*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    real G4_2_10_1 = map.det*c0*c1*c[1][10]*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    real G4_2_11_2 = map.det*c0*c1*c[1][11]*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);
    real G5_0_0_0_0 = map.det*c0*c[0][0]*c[1][0]*map.g00;
    real G5_0_0_0_1 = map.det*c0*c[0][0]*c[1][0]*map.g10;
    real G5_0_0_0_2 = map.det*c0*c[0][0]*c[1][0]*map.g20;
    real G5_0_0_1_0 = map.det*c0*c[0][0]*c[1][1]*map.g00;
    real G5_0_0_2_1 = map.det*c0*c[0][0]*c[1][2]*map.g10;
    real G5_0_0_3_2 = map.det*c0*c[0][0]*c[1][3]*map.g20;
    real G5_0_0_4_0 = map.det*c0*c[0][0]*c[1][4]*map.g00;
    real G5_0_0_4_1 = map.det*c0*c[0][0]*c[1][4]*map.g10;
    real G5_0_0_4_2 = map.det*c0*c[0][0]*c[1][4]*map.g20;
    real G5_0_0_5_0 = map.det*c0*c[0][0]*c[1][5]*map.g00;
    real G5_0_0_6_1 = map.det*c0*c[0][0]*c[1][6]*map.g10;
    real G5_0_0_7_2 = map.det*c0*c[0][0]*c[1][7]*map.g20;
    real G5_0_0_8_0 = map.det*c0*c[0][0]*c[1][8]*map.g00;
    real G5_0_0_8_1 = map.det*c0*c[0][0]*c[1][8]*map.g10;
    real G5_0_0_8_2 = map.det*c0*c[0][0]*c[1][8]*map.g20;
    real G5_0_0_9_0 = map.det*c0*c[0][0]*c[1][9]*map.g00;
    real G5_0_0_10_1 = map.det*c0*c[0][0]*c[1][10]*map.g10;
    real G5_0_0_11_2 = map.det*c0*c[0][0]*c[1][11]*map.g20;
    real G5_1_1_0_0 = map.det*c0*c[0][1]*c[1][0]*map.g01;
    real G5_1_1_0_1 = map.det*c0*c[0][1]*c[1][0]*map.g11;
    real G5_1_1_0_2 = map.det*c0*c[0][1]*c[1][0]*map.g21;
    real G5_1_1_1_0 = map.det*c0*c[0][1]*c[1][1]*map.g01;
    real G5_1_1_2_1 = map.det*c0*c[0][1]*c[1][2]*map.g11;
    real G5_1_1_3_2 = map.det*c0*c[0][1]*c[1][3]*map.g21;
    real G5_1_1_4_0 = map.det*c0*c[0][1]*c[1][4]*map.g01;
    real G5_1_1_4_1 = map.det*c0*c[0][1]*c[1][4]*map.g11;
    real G5_1_1_4_2 = map.det*c0*c[0][1]*c[1][4]*map.g21;
    real G5_1_1_5_0 = map.det*c0*c[0][1]*c[1][5]*map.g01;
    real G5_1_1_6_1 = map.det*c0*c[0][1]*c[1][6]*map.g11;
    real G5_1_1_7_2 = map.det*c0*c[0][1]*c[1][7]*map.g21;
    real G5_1_1_8_0 = map.det*c0*c[0][1]*c[1][8]*map.g01;
    real G5_1_1_8_1 = map.det*c0*c[0][1]*c[1][8]*map.g11;
    real G5_1_1_8_2 = map.det*c0*c[0][1]*c[1][8]*map.g21;
    real G5_1_1_9_0 = map.det*c0*c[0][1]*c[1][9]*map.g01;
    real G5_1_1_10_1 = map.det*c0*c[0][1]*c[1][10]*map.g11;
    real G5_1_1_11_2 = map.det*c0*c[0][1]*c[1][11]*map.g21;
    real G5_2_2_0_0 = map.det*c0*c[0][2]*c[1][0]*map.g02;
    real G5_2_2_0_1 = map.det*c0*c[0][2]*c[1][0]*map.g12;
    real G5_2_2_0_2 = map.det*c0*c[0][2]*c[1][0]*map.g22;
    real G5_2_2_1_0 = map.det*c0*c[0][2]*c[1][1]*map.g02;
    real G5_2_2_2_1 = map.det*c0*c[0][2]*c[1][2]*map.g12;
    real G5_2_2_3_2 = map.det*c0*c[0][2]*c[1][3]*map.g22;
    real G5_2_2_4_0 = map.det*c0*c[0][2]*c[1][4]*map.g02;
    real G5_2_2_4_1 = map.det*c0*c[0][2]*c[1][4]*map.g12;
    real G5_2_2_4_2 = map.det*c0*c[0][2]*c[1][4]*map.g22;
    real G5_2_2_5_0 = map.det*c0*c[0][2]*c[1][5]*map.g02;
    real G5_2_2_6_1 = map.det*c0*c[0][2]*c[1][6]*map.g12;
    real G5_2_2_7_2 = map.det*c0*c[0][2]*c[1][7]*map.g22;
    real G5_2_2_8_0 = map.det*c0*c[0][2]*c[1][8]*map.g02;
    real G5_2_2_8_1 = map.det*c0*c[0][2]*c[1][8]*map.g12;
    real G5_2_2_8_2 = map.det*c0*c[0][2]*c[1][8]*map.g22;
    real G5_2_2_9_0 = map.det*c0*c[0][2]*c[1][9]*map.g02;
    real G5_2_2_10_1 = map.det*c0*c[0][2]*c[1][10]*map.g12;
    real G5_2_2_11_2 = map.det*c0*c[0][2]*c[1][11]*map.g22;
    real G6_0_0_0_0_0_0_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g00*map.g00;
    real G6_0_0_0_0_0_0_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g00*map.g10;
    real G6_0_0_0_0_0_0_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g00*map.g20;
    real G6_0_0_0_0_0_1_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][1]*map.g00*map.g00;
    real G6_0_0_0_0_0_2_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][2]*map.g00*map.g10;
    real G6_0_0_0_0_0_3_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][3]*map.g00*map.g20;
    real G6_0_0_0_0_0_4_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g00*map.g00;
    real G6_0_0_0_0_0_4_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g00*map.g10;
    real G6_0_0_0_0_0_4_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g00*map.g20;
    real G6_0_0_0_0_0_5_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][5]*map.g00*map.g00;
    real G6_0_0_0_0_0_6_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][6]*map.g00*map.g10;
    real G6_0_0_0_0_0_7_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][7]*map.g00*map.g20;
    real G6_0_0_0_0_0_8_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g00*map.g00;
    real G6_0_0_0_0_0_8_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g00*map.g10;
    real G6_0_0_0_0_0_8_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g00*map.g20;
    real G6_0_0_0_0_0_9_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][9]*map.g00*map.g00;
    real G6_0_0_0_0_0_10_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][10]*map.g00*map.g10;
    real G6_0_0_0_0_0_11_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][11]*map.g00*map.g20;
    real G6_0_0_0_1_0_0_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g10*map.g00;
    real G6_0_0_0_1_0_0_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g10*map.g10;
    real G6_0_0_0_1_0_0_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g10*map.g20;
    real G6_0_0_0_1_0_1_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][1]*map.g10*map.g00;
    real G6_0_0_0_1_0_2_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][2]*map.g10*map.g10;
    real G6_0_0_0_1_0_3_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][3]*map.g10*map.g20;
    real G6_0_0_0_1_0_4_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g10*map.g00;
    real G6_0_0_0_1_0_4_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g10*map.g10;
    real G6_0_0_0_1_0_4_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g10*map.g20;
    real G6_0_0_0_1_0_5_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][5]*map.g10*map.g00;
    real G6_0_0_0_1_0_6_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][6]*map.g10*map.g10;
    real G6_0_0_0_1_0_7_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][7]*map.g10*map.g20;
    real G6_0_0_0_1_0_8_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g10*map.g00;
    real G6_0_0_0_1_0_8_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g10*map.g10;
    real G6_0_0_0_1_0_8_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g10*map.g20;
    real G6_0_0_0_1_0_9_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][9]*map.g10*map.g00;
    real G6_0_0_0_1_0_10_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][10]*map.g10*map.g10;
    real G6_0_0_0_1_0_11_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][11]*map.g10*map.g20;
    real G6_0_0_0_2_0_0_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g20*map.g00;
    real G6_0_0_0_2_0_0_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g20*map.g10;
    real G6_0_0_0_2_0_0_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][0]*map.g20*map.g20;
    real G6_0_0_0_2_0_1_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][1]*map.g20*map.g00;
    real G6_0_0_0_2_0_2_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][2]*map.g20*map.g10;
    real G6_0_0_0_2_0_3_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][3]*map.g20*map.g20;
    real G6_0_0_0_2_0_4_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g20*map.g00;
    real G6_0_0_0_2_0_4_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g20*map.g10;
    real G6_0_0_0_2_0_4_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][4]*map.g20*map.g20;
    real G6_0_0_0_2_0_5_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][5]*map.g20*map.g00;
    real G6_0_0_0_2_0_6_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][6]*map.g20*map.g10;
    real G6_0_0_0_2_0_7_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][7]*map.g20*map.g20;
    real G6_0_0_0_2_0_8_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g20*map.g00;
    real G6_0_0_0_2_0_8_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g20*map.g10;
    real G6_0_0_0_2_0_8_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][8]*map.g20*map.g20;
    real G6_0_0_0_2_0_9_0 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][9]*map.g20*map.g00;
    real G6_0_0_0_2_0_10_1 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][10]*map.g20*map.g10;
    real G6_0_0_0_2_0_11_2 = map.det*c2*c0*c[0][0]*c[0][0]*c[1][11]*map.g20*map.g20;
    real G6_0_1_0_0_1_0_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g00*map.g01;
    real G6_0_1_0_0_1_0_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g00*map.g11;
    real G6_0_1_0_0_1_0_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g00*map.g21;
    real G6_0_1_0_0_1_1_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][1]*map.g00*map.g01;
    real G6_0_1_0_0_1_2_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][2]*map.g00*map.g11;
    real G6_0_1_0_0_1_3_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][3]*map.g00*map.g21;
    real G6_0_1_0_0_1_4_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g00*map.g01;
    real G6_0_1_0_0_1_4_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g00*map.g11;
    real G6_0_1_0_0_1_4_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g00*map.g21;
    real G6_0_1_0_0_1_5_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][5]*map.g00*map.g01;
    real G6_0_1_0_0_1_6_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][6]*map.g00*map.g11;
    real G6_0_1_0_0_1_7_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][7]*map.g00*map.g21;
    real G6_0_1_0_0_1_8_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g00*map.g01;
    real G6_0_1_0_0_1_8_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g00*map.g11;
    real G6_0_1_0_0_1_8_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g00*map.g21;
    real G6_0_1_0_0_1_9_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][9]*map.g00*map.g01;
    real G6_0_1_0_0_1_10_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][10]*map.g00*map.g11;
    real G6_0_1_0_0_1_11_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][11]*map.g00*map.g21;
    real G6_0_1_0_1_1_0_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g10*map.g01;
    real G6_0_1_0_1_1_0_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g10*map.g11;
    real G6_0_1_0_1_1_0_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g10*map.g21;
    real G6_0_1_0_1_1_1_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][1]*map.g10*map.g01;
    real G6_0_1_0_1_1_2_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][2]*map.g10*map.g11;
    real G6_0_1_0_1_1_3_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][3]*map.g10*map.g21;
    real G6_0_1_0_1_1_4_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g10*map.g01;
    real G6_0_1_0_1_1_4_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g10*map.g11;
    real G6_0_1_0_1_1_4_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g10*map.g21;
    real G6_0_1_0_1_1_5_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][5]*map.g10*map.g01;
    real G6_0_1_0_1_1_6_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][6]*map.g10*map.g11;
    real G6_0_1_0_1_1_7_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][7]*map.g10*map.g21;
    real G6_0_1_0_1_1_8_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g10*map.g01;
    real G6_0_1_0_1_1_8_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g10*map.g11;
    real G6_0_1_0_1_1_8_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g10*map.g21;
    real G6_0_1_0_1_1_9_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][9]*map.g10*map.g01;
    real G6_0_1_0_1_1_10_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][10]*map.g10*map.g11;
    real G6_0_1_0_1_1_11_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][11]*map.g10*map.g21;
    real G6_0_1_0_2_1_0_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g20*map.g01;
    real G6_0_1_0_2_1_0_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g20*map.g11;
    real G6_0_1_0_2_1_0_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][0]*map.g20*map.g21;
    real G6_0_1_0_2_1_1_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][1]*map.g20*map.g01;
    real G6_0_1_0_2_1_2_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][2]*map.g20*map.g11;
    real G6_0_1_0_2_1_3_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][3]*map.g20*map.g21;
    real G6_0_1_0_2_1_4_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g20*map.g01;
    real G6_0_1_0_2_1_4_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g20*map.g11;
    real G6_0_1_0_2_1_4_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][4]*map.g20*map.g21;
    real G6_0_1_0_2_1_5_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][5]*map.g20*map.g01;
    real G6_0_1_0_2_1_6_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][6]*map.g20*map.g11;
    real G6_0_1_0_2_1_7_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][7]*map.g20*map.g21;
    real G6_0_1_0_2_1_8_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g20*map.g01;
    real G6_0_1_0_2_1_8_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g20*map.g11;
    real G6_0_1_0_2_1_8_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][8]*map.g20*map.g21;
    real G6_0_1_0_2_1_9_0 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][9]*map.g20*map.g01;
    real G6_0_1_0_2_1_10_1 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][10]*map.g20*map.g11;
    real G6_0_1_0_2_1_11_2 = map.det*c2*c0*c[0][0]*c[0][1]*c[1][11]*map.g20*map.g21;
    real G6_0_2_0_0_2_0_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g00*map.g02;
    real G6_0_2_0_0_2_0_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g00*map.g12;
    real G6_0_2_0_0_2_0_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g00*map.g22;
    real G6_0_2_0_0_2_1_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][1]*map.g00*map.g02;
    real G6_0_2_0_0_2_2_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][2]*map.g00*map.g12;
    real G6_0_2_0_0_2_3_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][3]*map.g00*map.g22;
    real G6_0_2_0_0_2_4_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g00*map.g02;
    real G6_0_2_0_0_2_4_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g00*map.g12;
    real G6_0_2_0_0_2_4_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g00*map.g22;
    real G6_0_2_0_0_2_5_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][5]*map.g00*map.g02;
    real G6_0_2_0_0_2_6_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][6]*map.g00*map.g12;
    real G6_0_2_0_0_2_7_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][7]*map.g00*map.g22;
    real G6_0_2_0_0_2_8_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g00*map.g02;
    real G6_0_2_0_0_2_8_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g00*map.g12;
    real G6_0_2_0_0_2_8_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g00*map.g22;
    real G6_0_2_0_0_2_9_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][9]*map.g00*map.g02;
    real G6_0_2_0_0_2_10_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][10]*map.g00*map.g12;
    real G6_0_2_0_0_2_11_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][11]*map.g00*map.g22;
    real G6_0_2_0_1_2_0_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g10*map.g02;
    real G6_0_2_0_1_2_0_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g10*map.g12;
    real G6_0_2_0_1_2_0_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g10*map.g22;
    real G6_0_2_0_1_2_1_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][1]*map.g10*map.g02;
    real G6_0_2_0_1_2_2_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][2]*map.g10*map.g12;
    real G6_0_2_0_1_2_3_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][3]*map.g10*map.g22;
    real G6_0_2_0_1_2_4_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g10*map.g02;
    real G6_0_2_0_1_2_4_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g10*map.g12;
    real G6_0_2_0_1_2_4_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g10*map.g22;
    real G6_0_2_0_1_2_5_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][5]*map.g10*map.g02;
    real G6_0_2_0_1_2_6_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][6]*map.g10*map.g12;
    real G6_0_2_0_1_2_7_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][7]*map.g10*map.g22;
    real G6_0_2_0_1_2_8_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g10*map.g02;
    real G6_0_2_0_1_2_8_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g10*map.g12;
    real G6_0_2_0_1_2_8_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g10*map.g22;
    real G6_0_2_0_1_2_9_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][9]*map.g10*map.g02;
    real G6_0_2_0_1_2_10_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][10]*map.g10*map.g12;
    real G6_0_2_0_1_2_11_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][11]*map.g10*map.g22;
    real G6_0_2_0_2_2_0_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g20*map.g02;
    real G6_0_2_0_2_2_0_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g20*map.g12;
    real G6_0_2_0_2_2_0_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][0]*map.g20*map.g22;
    real G6_0_2_0_2_2_1_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][1]*map.g20*map.g02;
    real G6_0_2_0_2_2_2_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][2]*map.g20*map.g12;
    real G6_0_2_0_2_2_3_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][3]*map.g20*map.g22;
    real G6_0_2_0_2_2_4_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g20*map.g02;
    real G6_0_2_0_2_2_4_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g20*map.g12;
    real G6_0_2_0_2_2_4_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][4]*map.g20*map.g22;
    real G6_0_2_0_2_2_5_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][5]*map.g20*map.g02;
    real G6_0_2_0_2_2_6_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][6]*map.g20*map.g12;
    real G6_0_2_0_2_2_7_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][7]*map.g20*map.g22;
    real G6_0_2_0_2_2_8_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g20*map.g02;
    real G6_0_2_0_2_2_8_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g20*map.g12;
    real G6_0_2_0_2_2_8_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][8]*map.g20*map.g22;
    real G6_0_2_0_2_2_9_0 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][9]*map.g20*map.g02;
    real G6_0_2_0_2_2_10_1 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][10]*map.g20*map.g12;
    real G6_0_2_0_2_2_11_2 = map.det*c2*c0*c[0][0]*c[0][2]*c[1][11]*map.g20*map.g22;
    real G6_1_0_1_0_0_0_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g01*map.g00;
    real G6_1_0_1_0_0_0_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g01*map.g10;
    real G6_1_0_1_0_0_0_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g01*map.g20;
    real G6_1_0_1_0_0_1_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][1]*map.g01*map.g00;
    real G6_1_0_1_0_0_2_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][2]*map.g01*map.g10;
    real G6_1_0_1_0_0_3_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][3]*map.g01*map.g20;
    real G6_1_0_1_0_0_4_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g01*map.g00;
    real G6_1_0_1_0_0_4_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g01*map.g10;
    real G6_1_0_1_0_0_4_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g01*map.g20;
    real G6_1_0_1_0_0_5_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][5]*map.g01*map.g00;
    real G6_1_0_1_0_0_6_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][6]*map.g01*map.g10;
    real G6_1_0_1_0_0_7_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][7]*map.g01*map.g20;
    real G6_1_0_1_0_0_8_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g01*map.g00;
    real G6_1_0_1_0_0_8_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g01*map.g10;
    real G6_1_0_1_0_0_8_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g01*map.g20;
    real G6_1_0_1_0_0_9_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][9]*map.g01*map.g00;
    real G6_1_0_1_0_0_10_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][10]*map.g01*map.g10;
    real G6_1_0_1_0_0_11_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][11]*map.g01*map.g20;
    real G6_1_0_1_1_0_0_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g11*map.g00;
    real G6_1_0_1_1_0_0_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g11*map.g10;
    real G6_1_0_1_1_0_0_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g11*map.g20;
    real G6_1_0_1_1_0_1_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][1]*map.g11*map.g00;
    real G6_1_0_1_1_0_2_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][2]*map.g11*map.g10;
    real G6_1_0_1_1_0_3_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][3]*map.g11*map.g20;
    real G6_1_0_1_1_0_4_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g11*map.g00;
    real G6_1_0_1_1_0_4_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g11*map.g10;
    real G6_1_0_1_1_0_4_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g11*map.g20;
    real G6_1_0_1_1_0_5_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][5]*map.g11*map.g00;
    real G6_1_0_1_1_0_6_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][6]*map.g11*map.g10;
    real G6_1_0_1_1_0_7_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][7]*map.g11*map.g20;
    real G6_1_0_1_1_0_8_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g11*map.g00;
    real G6_1_0_1_1_0_8_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g11*map.g10;
    real G6_1_0_1_1_0_8_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g11*map.g20;
    real G6_1_0_1_1_0_9_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][9]*map.g11*map.g00;
    real G6_1_0_1_1_0_10_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][10]*map.g11*map.g10;
    real G6_1_0_1_1_0_11_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][11]*map.g11*map.g20;
    real G6_1_0_1_2_0_0_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g21*map.g00;
    real G6_1_0_1_2_0_0_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g21*map.g10;
    real G6_1_0_1_2_0_0_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][0]*map.g21*map.g20;
    real G6_1_0_1_2_0_1_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][1]*map.g21*map.g00;
    real G6_1_0_1_2_0_2_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][2]*map.g21*map.g10;
    real G6_1_0_1_2_0_3_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][3]*map.g21*map.g20;
    real G6_1_0_1_2_0_4_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g21*map.g00;
    real G6_1_0_1_2_0_4_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g21*map.g10;
    real G6_1_0_1_2_0_4_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][4]*map.g21*map.g20;
    real G6_1_0_1_2_0_5_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][5]*map.g21*map.g00;
    real G6_1_0_1_2_0_6_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][6]*map.g21*map.g10;
    real G6_1_0_1_2_0_7_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][7]*map.g21*map.g20;
    real G6_1_0_1_2_0_8_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g21*map.g00;
    real G6_1_0_1_2_0_8_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g21*map.g10;
    real G6_1_0_1_2_0_8_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][8]*map.g21*map.g20;
    real G6_1_0_1_2_0_9_0 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][9]*map.g21*map.g00;
    real G6_1_0_1_2_0_10_1 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][10]*map.g21*map.g10;
    real G6_1_0_1_2_0_11_2 = map.det*c2*c0*c[0][1]*c[0][0]*c[1][11]*map.g21*map.g20;
    real G6_1_1_1_0_1_0_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g01*map.g01;
    real G6_1_1_1_0_1_0_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g01*map.g11;
    real G6_1_1_1_0_1_0_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g01*map.g21;
    real G6_1_1_1_0_1_1_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][1]*map.g01*map.g01;
    real G6_1_1_1_0_1_2_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][2]*map.g01*map.g11;
    real G6_1_1_1_0_1_3_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][3]*map.g01*map.g21;
    real G6_1_1_1_0_1_4_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g01*map.g01;
    real G6_1_1_1_0_1_4_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g01*map.g11;
    real G6_1_1_1_0_1_4_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g01*map.g21;
    real G6_1_1_1_0_1_5_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][5]*map.g01*map.g01;
    real G6_1_1_1_0_1_6_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][6]*map.g01*map.g11;
    real G6_1_1_1_0_1_7_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][7]*map.g01*map.g21;
    real G6_1_1_1_0_1_8_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g01*map.g01;
    real G6_1_1_1_0_1_8_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g01*map.g11;
    real G6_1_1_1_0_1_8_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g01*map.g21;
    real G6_1_1_1_0_1_9_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][9]*map.g01*map.g01;
    real G6_1_1_1_0_1_10_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][10]*map.g01*map.g11;
    real G6_1_1_1_0_1_11_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][11]*map.g01*map.g21;
    real G6_1_1_1_1_1_0_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g11*map.g01;
    real G6_1_1_1_1_1_0_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g11*map.g11;
    real G6_1_1_1_1_1_0_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g11*map.g21;
    real G6_1_1_1_1_1_1_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][1]*map.g11*map.g01;
    real G6_1_1_1_1_1_2_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][2]*map.g11*map.g11;
    real G6_1_1_1_1_1_3_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][3]*map.g11*map.g21;
    real G6_1_1_1_1_1_4_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g11*map.g01;
    real G6_1_1_1_1_1_4_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g11*map.g11;
    real G6_1_1_1_1_1_4_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g11*map.g21;
    real G6_1_1_1_1_1_5_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][5]*map.g11*map.g01;
    real G6_1_1_1_1_1_6_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][6]*map.g11*map.g11;
    real G6_1_1_1_1_1_7_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][7]*map.g11*map.g21;
    real G6_1_1_1_1_1_8_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g11*map.g01;
    real G6_1_1_1_1_1_8_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g11*map.g11;
    real G6_1_1_1_1_1_8_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g11*map.g21;
    real G6_1_1_1_1_1_9_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][9]*map.g11*map.g01;
    real G6_1_1_1_1_1_10_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][10]*map.g11*map.g11;
    real G6_1_1_1_1_1_11_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][11]*map.g11*map.g21;
    real G6_1_1_1_2_1_0_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g21*map.g01;
    real G6_1_1_1_2_1_0_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g21*map.g11;
    real G6_1_1_1_2_1_0_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][0]*map.g21*map.g21;
    real G6_1_1_1_2_1_1_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][1]*map.g21*map.g01;
    real G6_1_1_1_2_1_2_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][2]*map.g21*map.g11;
    real G6_1_1_1_2_1_3_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][3]*map.g21*map.g21;
    real G6_1_1_1_2_1_4_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g21*map.g01;
    real G6_1_1_1_2_1_4_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g21*map.g11;
    real G6_1_1_1_2_1_4_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][4]*map.g21*map.g21;
    real G6_1_1_1_2_1_5_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][5]*map.g21*map.g01;
    real G6_1_1_1_2_1_6_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][6]*map.g21*map.g11;
    real G6_1_1_1_2_1_7_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][7]*map.g21*map.g21;
    real G6_1_1_1_2_1_8_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g21*map.g01;
    real G6_1_1_1_2_1_8_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g21*map.g11;
    real G6_1_1_1_2_1_8_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][8]*map.g21*map.g21;
    real G6_1_1_1_2_1_9_0 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][9]*map.g21*map.g01;
    real G6_1_1_1_2_1_10_1 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][10]*map.g21*map.g11;
    real G6_1_1_1_2_1_11_2 = map.det*c2*c0*c[0][1]*c[0][1]*c[1][11]*map.g21*map.g21;
    real G6_1_2_1_0_2_0_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g01*map.g02;
    real G6_1_2_1_0_2_0_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g01*map.g12;
    real G6_1_2_1_0_2_0_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g01*map.g22;
    real G6_1_2_1_0_2_1_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][1]*map.g01*map.g02;
    real G6_1_2_1_0_2_2_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][2]*map.g01*map.g12;
    real G6_1_2_1_0_2_3_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][3]*map.g01*map.g22;
    real G6_1_2_1_0_2_4_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g01*map.g02;
    real G6_1_2_1_0_2_4_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g01*map.g12;
    real G6_1_2_1_0_2_4_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g01*map.g22;
    real G6_1_2_1_0_2_5_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][5]*map.g01*map.g02;
    real G6_1_2_1_0_2_6_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][6]*map.g01*map.g12;
    real G6_1_2_1_0_2_7_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][7]*map.g01*map.g22;
    real G6_1_2_1_0_2_8_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g01*map.g02;
    real G6_1_2_1_0_2_8_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g01*map.g12;
    real G6_1_2_1_0_2_8_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g01*map.g22;
    real G6_1_2_1_0_2_9_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][9]*map.g01*map.g02;
    real G6_1_2_1_0_2_10_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][10]*map.g01*map.g12;
    real G6_1_2_1_0_2_11_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][11]*map.g01*map.g22;
    real G6_1_2_1_1_2_0_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g11*map.g02;
    real G6_1_2_1_1_2_0_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g11*map.g12;
    real G6_1_2_1_1_2_0_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g11*map.g22;
    real G6_1_2_1_1_2_1_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][1]*map.g11*map.g02;
    real G6_1_2_1_1_2_2_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][2]*map.g11*map.g12;
    real G6_1_2_1_1_2_3_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][3]*map.g11*map.g22;
    real G6_1_2_1_1_2_4_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g11*map.g02;
    real G6_1_2_1_1_2_4_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g11*map.g12;
    real G6_1_2_1_1_2_4_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g11*map.g22;
    real G6_1_2_1_1_2_5_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][5]*map.g11*map.g02;
    real G6_1_2_1_1_2_6_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][6]*map.g11*map.g12;
    real G6_1_2_1_1_2_7_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][7]*map.g11*map.g22;
    real G6_1_2_1_1_2_8_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g11*map.g02;
    real G6_1_2_1_1_2_8_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g11*map.g12;
    real G6_1_2_1_1_2_8_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g11*map.g22;
    real G6_1_2_1_1_2_9_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][9]*map.g11*map.g02;
    real G6_1_2_1_1_2_10_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][10]*map.g11*map.g12;
    real G6_1_2_1_1_2_11_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][11]*map.g11*map.g22;
    real G6_1_2_1_2_2_0_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g21*map.g02;
    real G6_1_2_1_2_2_0_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g21*map.g12;
    real G6_1_2_1_2_2_0_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][0]*map.g21*map.g22;
    real G6_1_2_1_2_2_1_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][1]*map.g21*map.g02;
    real G6_1_2_1_2_2_2_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][2]*map.g21*map.g12;
    real G6_1_2_1_2_2_3_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][3]*map.g21*map.g22;
    real G6_1_2_1_2_2_4_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g21*map.g02;
    real G6_1_2_1_2_2_4_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g21*map.g12;
    real G6_1_2_1_2_2_4_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][4]*map.g21*map.g22;
    real G6_1_2_1_2_2_5_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][5]*map.g21*map.g02;
    real G6_1_2_1_2_2_6_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][6]*map.g21*map.g12;
    real G6_1_2_1_2_2_7_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][7]*map.g21*map.g22;
    real G6_1_2_1_2_2_8_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g21*map.g02;
    real G6_1_2_1_2_2_8_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g21*map.g12;
    real G6_1_2_1_2_2_8_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][8]*map.g21*map.g22;
    real G6_1_2_1_2_2_9_0 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][9]*map.g21*map.g02;
    real G6_1_2_1_2_2_10_1 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][10]*map.g21*map.g12;
    real G6_1_2_1_2_2_11_2 = map.det*c2*c0*c[0][1]*c[0][2]*c[1][11]*map.g21*map.g22;
    real G6_2_0_2_0_0_0_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g02*map.g00;
    real G6_2_0_2_0_0_0_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g02*map.g10;
    real G6_2_0_2_0_0_0_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g02*map.g20;
    real G6_2_0_2_0_0_1_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][1]*map.g02*map.g00;
    real G6_2_0_2_0_0_2_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][2]*map.g02*map.g10;
    real G6_2_0_2_0_0_3_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][3]*map.g02*map.g20;
    real G6_2_0_2_0_0_4_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g02*map.g00;
    real G6_2_0_2_0_0_4_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g02*map.g10;
    real G6_2_0_2_0_0_4_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g02*map.g20;
    real G6_2_0_2_0_0_5_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][5]*map.g02*map.g00;
    real G6_2_0_2_0_0_6_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][6]*map.g02*map.g10;
    real G6_2_0_2_0_0_7_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][7]*map.g02*map.g20;
    real G6_2_0_2_0_0_8_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g02*map.g00;
    real G6_2_0_2_0_0_8_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g02*map.g10;
    real G6_2_0_2_0_0_8_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g02*map.g20;
    real G6_2_0_2_0_0_9_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][9]*map.g02*map.g00;
    real G6_2_0_2_0_0_10_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][10]*map.g02*map.g10;
    real G6_2_0_2_0_0_11_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][11]*map.g02*map.g20;
    real G6_2_0_2_1_0_0_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g12*map.g00;
    real G6_2_0_2_1_0_0_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g12*map.g10;
    real G6_2_0_2_1_0_0_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g12*map.g20;
    real G6_2_0_2_1_0_1_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][1]*map.g12*map.g00;
    real G6_2_0_2_1_0_2_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][2]*map.g12*map.g10;
    real G6_2_0_2_1_0_3_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][3]*map.g12*map.g20;
    real G6_2_0_2_1_0_4_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g12*map.g00;
    real G6_2_0_2_1_0_4_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g12*map.g10;
    real G6_2_0_2_1_0_4_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g12*map.g20;
    real G6_2_0_2_1_0_5_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][5]*map.g12*map.g00;
    real G6_2_0_2_1_0_6_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][6]*map.g12*map.g10;
    real G6_2_0_2_1_0_7_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][7]*map.g12*map.g20;
    real G6_2_0_2_1_0_8_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g12*map.g00;
    real G6_2_0_2_1_0_8_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g12*map.g10;
    real G6_2_0_2_1_0_8_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g12*map.g20;
    real G6_2_0_2_1_0_9_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][9]*map.g12*map.g00;
    real G6_2_0_2_1_0_10_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][10]*map.g12*map.g10;
    real G6_2_0_2_1_0_11_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][11]*map.g12*map.g20;
    real G6_2_0_2_2_0_0_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g22*map.g00;
    real G6_2_0_2_2_0_0_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g22*map.g10;
    real G6_2_0_2_2_0_0_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][0]*map.g22*map.g20;
    real G6_2_0_2_2_0_1_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][1]*map.g22*map.g00;
    real G6_2_0_2_2_0_2_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][2]*map.g22*map.g10;
    real G6_2_0_2_2_0_3_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][3]*map.g22*map.g20;
    real G6_2_0_2_2_0_4_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g22*map.g00;
    real G6_2_0_2_2_0_4_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g22*map.g10;
    real G6_2_0_2_2_0_4_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][4]*map.g22*map.g20;
    real G6_2_0_2_2_0_5_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][5]*map.g22*map.g00;
    real G6_2_0_2_2_0_6_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][6]*map.g22*map.g10;
    real G6_2_0_2_2_0_7_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][7]*map.g22*map.g20;
    real G6_2_0_2_2_0_8_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g22*map.g00;
    real G6_2_0_2_2_0_8_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g22*map.g10;
    real G6_2_0_2_2_0_8_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][8]*map.g22*map.g20;
    real G6_2_0_2_2_0_9_0 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][9]*map.g22*map.g00;
    real G6_2_0_2_2_0_10_1 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][10]*map.g22*map.g10;
    real G6_2_0_2_2_0_11_2 = map.det*c2*c0*c[0][2]*c[0][0]*c[1][11]*map.g22*map.g20;
    real G6_2_1_2_0_1_0_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g02*map.g01;
    real G6_2_1_2_0_1_0_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g02*map.g11;
    real G6_2_1_2_0_1_0_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g02*map.g21;
    real G6_2_1_2_0_1_1_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][1]*map.g02*map.g01;
    real G6_2_1_2_0_1_2_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][2]*map.g02*map.g11;
    real G6_2_1_2_0_1_3_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][3]*map.g02*map.g21;
    real G6_2_1_2_0_1_4_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g02*map.g01;
    real G6_2_1_2_0_1_4_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g02*map.g11;
    real G6_2_1_2_0_1_4_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g02*map.g21;
    real G6_2_1_2_0_1_5_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][5]*map.g02*map.g01;
    real G6_2_1_2_0_1_6_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][6]*map.g02*map.g11;
    real G6_2_1_2_0_1_7_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][7]*map.g02*map.g21;
    real G6_2_1_2_0_1_8_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g02*map.g01;
    real G6_2_1_2_0_1_8_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g02*map.g11;
    real G6_2_1_2_0_1_8_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g02*map.g21;
    real G6_2_1_2_0_1_9_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][9]*map.g02*map.g01;
    real G6_2_1_2_0_1_10_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][10]*map.g02*map.g11;
    real G6_2_1_2_0_1_11_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][11]*map.g02*map.g21;
    real G6_2_1_2_1_1_0_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g12*map.g01;
    real G6_2_1_2_1_1_0_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g12*map.g11;
    real G6_2_1_2_1_1_0_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g12*map.g21;
    real G6_2_1_2_1_1_1_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][1]*map.g12*map.g01;
    real G6_2_1_2_1_1_2_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][2]*map.g12*map.g11;
    real G6_2_1_2_1_1_3_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][3]*map.g12*map.g21;
    real G6_2_1_2_1_1_4_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g12*map.g01;
    real G6_2_1_2_1_1_4_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g12*map.g11;
    real G6_2_1_2_1_1_4_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g12*map.g21;
    real G6_2_1_2_1_1_5_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][5]*map.g12*map.g01;
    real G6_2_1_2_1_1_6_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][6]*map.g12*map.g11;
    real G6_2_1_2_1_1_7_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][7]*map.g12*map.g21;
    real G6_2_1_2_1_1_8_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g12*map.g01;
    real G6_2_1_2_1_1_8_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g12*map.g11;
    real G6_2_1_2_1_1_8_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g12*map.g21;
    real G6_2_1_2_1_1_9_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][9]*map.g12*map.g01;
    real G6_2_1_2_1_1_10_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][10]*map.g12*map.g11;
    real G6_2_1_2_1_1_11_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][11]*map.g12*map.g21;
    real G6_2_1_2_2_1_0_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g22*map.g01;
    real G6_2_1_2_2_1_0_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g22*map.g11;
    real G6_2_1_2_2_1_0_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][0]*map.g22*map.g21;
    real G6_2_1_2_2_1_1_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][1]*map.g22*map.g01;
    real G6_2_1_2_2_1_2_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][2]*map.g22*map.g11;
    real G6_2_1_2_2_1_3_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][3]*map.g22*map.g21;
    real G6_2_1_2_2_1_4_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g22*map.g01;
    real G6_2_1_2_2_1_4_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g22*map.g11;
    real G6_2_1_2_2_1_4_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][4]*map.g22*map.g21;
    real G6_2_1_2_2_1_5_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][5]*map.g22*map.g01;
    real G6_2_1_2_2_1_6_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][6]*map.g22*map.g11;
    real G6_2_1_2_2_1_7_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][7]*map.g22*map.g21;
    real G6_2_1_2_2_1_8_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g22*map.g01;
    real G6_2_1_2_2_1_8_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g22*map.g11;
    real G6_2_1_2_2_1_8_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][8]*map.g22*map.g21;
    real G6_2_1_2_2_1_9_0 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][9]*map.g22*map.g01;
    real G6_2_1_2_2_1_10_1 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][10]*map.g22*map.g11;
    real G6_2_1_2_2_1_11_2 = map.det*c2*c0*c[0][2]*c[0][1]*c[1][11]*map.g22*map.g21;
    real G6_2_2_2_0_2_0_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g02*map.g02;
    real G6_2_2_2_0_2_0_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g02*map.g12;
    real G6_2_2_2_0_2_0_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g02*map.g22;
    real G6_2_2_2_0_2_1_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][1]*map.g02*map.g02;
    real G6_2_2_2_0_2_2_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][2]*map.g02*map.g12;
    real G6_2_2_2_0_2_3_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][3]*map.g02*map.g22;
    real G6_2_2_2_0_2_4_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g02*map.g02;
    real G6_2_2_2_0_2_4_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g02*map.g12;
    real G6_2_2_2_0_2_4_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g02*map.g22;
    real G6_2_2_2_0_2_5_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][5]*map.g02*map.g02;
    real G6_2_2_2_0_2_6_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][6]*map.g02*map.g12;
    real G6_2_2_2_0_2_7_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][7]*map.g02*map.g22;
    real G6_2_2_2_0_2_8_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g02*map.g02;
    real G6_2_2_2_0_2_8_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g02*map.g12;
    real G6_2_2_2_0_2_8_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g02*map.g22;
    real G6_2_2_2_0_2_9_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][9]*map.g02*map.g02;
    real G6_2_2_2_0_2_10_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][10]*map.g02*map.g12;
    real G6_2_2_2_0_2_11_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][11]*map.g02*map.g22;
    real G6_2_2_2_1_2_0_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g12*map.g02;
    real G6_2_2_2_1_2_0_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g12*map.g12;
    real G6_2_2_2_1_2_0_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g12*map.g22;
    real G6_2_2_2_1_2_1_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][1]*map.g12*map.g02;
    real G6_2_2_2_1_2_2_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][2]*map.g12*map.g12;
    real G6_2_2_2_1_2_3_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][3]*map.g12*map.g22;
    real G6_2_2_2_1_2_4_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g12*map.g02;
    real G6_2_2_2_1_2_4_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g12*map.g12;
    real G6_2_2_2_1_2_4_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g12*map.g22;
    real G6_2_2_2_1_2_5_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][5]*map.g12*map.g02;
    real G6_2_2_2_1_2_6_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][6]*map.g12*map.g12;
    real G6_2_2_2_1_2_7_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][7]*map.g12*map.g22;
    real G6_2_2_2_1_2_8_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g12*map.g02;
    real G6_2_2_2_1_2_8_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g12*map.g12;
    real G6_2_2_2_1_2_8_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g12*map.g22;
    real G6_2_2_2_1_2_9_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][9]*map.g12*map.g02;
    real G6_2_2_2_1_2_10_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][10]*map.g12*map.g12;
    real G6_2_2_2_1_2_11_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][11]*map.g12*map.g22;
    real G6_2_2_2_2_2_0_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g22*map.g02;
    real G6_2_2_2_2_2_0_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g22*map.g12;
    real G6_2_2_2_2_2_0_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][0]*map.g22*map.g22;
    real G6_2_2_2_2_2_1_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][1]*map.g22*map.g02;
    real G6_2_2_2_2_2_2_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][2]*map.g22*map.g12;
    real G6_2_2_2_2_2_3_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][3]*map.g22*map.g22;
    real G6_2_2_2_2_2_4_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g22*map.g02;
    real G6_2_2_2_2_2_4_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g22*map.g12;
    real G6_2_2_2_2_2_4_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][4]*map.g22*map.g22;
    real G6_2_2_2_2_2_5_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][5]*map.g22*map.g02;
    real G6_2_2_2_2_2_6_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][6]*map.g22*map.g12;
    real G6_2_2_2_2_2_7_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][7]*map.g22*map.g22;
    real G6_2_2_2_2_2_8_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g22*map.g02;
    real G6_2_2_2_2_2_8_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g22*map.g12;
    real G6_2_2_2_2_2_8_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][8]*map.g22*map.g22;
    real G6_2_2_2_2_2_9_0 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][9]*map.g22*map.g02;
    real G6_2_2_2_2_2_10_1 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][10]*map.g22*map.g12;
    real G6_2_2_2_2_2_11_2 = map.det*c2*c0*c[0][2]*c[0][2]*c[1][11]*map.g22*map.g22;
    real G7_0_0_0_0_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g00;
    real G7_0_0_0_0_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g10;
    real G7_0_0_0_0_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g20;
    real G7_0_0_0_0_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g00*map.g00;
    real G7_0_0_0_0_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g00*map.g10;
    real G7_0_0_0_0_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g00*map.g20;
    real G7_0_0_0_1_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g00;
    real G7_0_0_0_1_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g10;
    real G7_0_0_0_1_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g20;
    real G7_0_0_0_1_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g10*map.g00;
    real G7_0_0_0_1_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g10*map.g10;
    real G7_0_0_0_1_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g10*map.g20;
    real G7_0_0_0_2_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g00;
    real G7_0_0_0_2_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g10;
    real G7_0_0_0_2_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g20;
    real G7_0_0_0_2_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g20*map.g00;
    real G7_0_0_0_2_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g20*map.g10;
    real G7_0_0_0_2_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g20*map.g20;
    real G7_0_1_1_0_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g00;
    real G7_0_1_1_0_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g10;
    real G7_0_1_1_0_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g20;
    real G7_0_1_1_0_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g01*map.g00;
    real G7_0_1_1_0_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g01*map.g10;
    real G7_0_1_1_0_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g01*map.g20;
    real G7_0_1_1_1_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g00;
    real G7_0_1_1_1_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g10;
    real G7_0_1_1_1_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g20;
    real G7_0_1_1_1_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g11*map.g00;
    real G7_0_1_1_1_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g11*map.g10;
    real G7_0_1_1_1_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g11*map.g20;
    real G7_0_1_1_2_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g00;
    real G7_0_1_1_2_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g10;
    real G7_0_1_1_2_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g20;
    real G7_0_1_1_2_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g21*map.g00;
    real G7_0_1_1_2_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g21*map.g10;
    real G7_0_1_1_2_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g21*map.g20;
    real G7_0_2_2_0_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g00;
    real G7_0_2_2_0_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g10;
    real G7_0_2_2_0_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g20;
    real G7_0_2_2_0_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g02*map.g00;
    real G7_0_2_2_0_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g02*map.g10;
    real G7_0_2_2_0_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g02*map.g20;
    real G7_0_2_2_1_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g00;
    real G7_0_2_2_1_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g10;
    real G7_0_2_2_1_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g20;
    real G7_0_2_2_1_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g12*map.g00;
    real G7_0_2_2_1_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g12*map.g10;
    real G7_0_2_2_1_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g12*map.g20;
    real G7_0_2_2_2_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g00;
    real G7_0_2_2_2_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g10;
    real G7_0_2_2_2_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g20;
    real G7_0_2_2_2_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g22*map.g00;
    real G7_0_2_2_2_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g22*map.g10;
    real G7_0_2_2_2_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g22*map.g20;
    real G7_1_0_0_0_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g01;
    real G7_1_0_0_0_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g11;
    real G7_1_0_0_0_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g21;
    real G7_1_0_0_0_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g00*map.g01;
    real G7_1_0_0_0_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g00*map.g11;
    real G7_1_0_0_0_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g00*map.g21;
    real G7_1_0_0_1_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g01;
    real G7_1_0_0_1_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g11;
    real G7_1_0_0_1_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g21;
    real G7_1_0_0_1_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g10*map.g01;
    real G7_1_0_0_1_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g10*map.g11;
    real G7_1_0_0_1_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g10*map.g21;
    real G7_1_0_0_2_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g01;
    real G7_1_0_0_2_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g11;
    real G7_1_0_0_2_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g21;
    real G7_1_0_0_2_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g20*map.g01;
    real G7_1_0_0_2_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g20*map.g11;
    real G7_1_0_0_2_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g20*map.g21;
    real G7_1_1_1_0_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g01;
    real G7_1_1_1_0_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g11;
    real G7_1_1_1_0_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g21;
    real G7_1_1_1_0_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g01*map.g01;
    real G7_1_1_1_0_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g01*map.g11;
    real G7_1_1_1_0_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g01*map.g21;
    real G7_1_1_1_1_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g01;
    real G7_1_1_1_1_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g11;
    real G7_1_1_1_1_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g21;
    real G7_1_1_1_1_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g11*map.g01;
    real G7_1_1_1_1_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g11*map.g11;
    real G7_1_1_1_1_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g11*map.g21;
    real G7_1_1_1_2_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g01;
    real G7_1_1_1_2_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g11;
    real G7_1_1_1_2_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g21;
    real G7_1_1_1_2_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g21*map.g01;
    real G7_1_1_1_2_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g21*map.g11;
    real G7_1_1_1_2_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g21*map.g21;
    real G7_1_2_2_0_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g01;
    real G7_1_2_2_0_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g11;
    real G7_1_2_2_0_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g21;
    real G7_1_2_2_0_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g02*map.g01;
    real G7_1_2_2_0_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g02*map.g11;
    real G7_1_2_2_0_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g02*map.g21;
    real G7_1_2_2_1_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g01;
    real G7_1_2_2_1_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g11;
    real G7_1_2_2_1_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g21;
    real G7_1_2_2_1_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g12*map.g01;
    real G7_1_2_2_1_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g12*map.g11;
    real G7_1_2_2_1_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g12*map.g21;
    real G7_1_2_2_2_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g01;
    real G7_1_2_2_2_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g11;
    real G7_1_2_2_2_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g21;
    real G7_1_2_2_2_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g22*map.g01;
    real G7_1_2_2_2_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g22*map.g11;
    real G7_1_2_2_2_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g22*map.g21;
    real G7_2_0_0_0_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g02;
    real G7_2_0_0_0_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g12;
    real G7_2_0_0_0_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g00*map.g22;
    real G7_2_0_0_0_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g00*map.g02;
    real G7_2_0_0_0_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g00*map.g12;
    real G7_2_0_0_0_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g00*map.g22;
    real G7_2_0_0_1_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g02;
    real G7_2_0_0_1_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g12;
    real G7_2_0_0_1_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g10*map.g22;
    real G7_2_0_0_1_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g10*map.g02;
    real G7_2_0_0_1_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g10*map.g12;
    real G7_2_0_0_1_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g10*map.g22;
    real G7_2_0_0_2_0_0 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g02;
    real G7_2_0_0_2_0_1 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g12;
    real G7_2_0_0_2_0_2 = map.det*c2*c0*c[0][0]*c[3][0]*map.g20*map.g22;
    real G7_2_0_0_2_1_0 = map.det*c2*c0*c[0][0]*c[3][1]*map.g20*map.g02;
    real G7_2_0_0_2_2_1 = map.det*c2*c0*c[0][0]*c[3][2]*map.g20*map.g12;
    real G7_2_0_0_2_3_2 = map.det*c2*c0*c[0][0]*c[3][3]*map.g20*map.g22;
    real G7_2_1_1_0_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g02;
    real G7_2_1_1_0_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g12;
    real G7_2_1_1_0_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g01*map.g22;
    real G7_2_1_1_0_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g01*map.g02;
    real G7_2_1_1_0_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g01*map.g12;
    real G7_2_1_1_0_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g01*map.g22;
    real G7_2_1_1_1_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g02;
    real G7_2_1_1_1_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g12;
    real G7_2_1_1_1_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g11*map.g22;
    real G7_2_1_1_1_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g11*map.g02;
    real G7_2_1_1_1_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g11*map.g12;
    real G7_2_1_1_1_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g11*map.g22;
    real G7_2_1_1_2_0_0 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g02;
    real G7_2_1_1_2_0_1 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g12;
    real G7_2_1_1_2_0_2 = map.det*c2*c0*c[0][1]*c[3][0]*map.g21*map.g22;
    real G7_2_1_1_2_1_0 = map.det*c2*c0*c[0][1]*c[3][1]*map.g21*map.g02;
    real G7_2_1_1_2_2_1 = map.det*c2*c0*c[0][1]*c[3][2]*map.g21*map.g12;
    real G7_2_1_1_2_3_2 = map.det*c2*c0*c[0][1]*c[3][3]*map.g21*map.g22;
    real G7_2_2_2_0_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g02;
    real G7_2_2_2_0_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g12;
    real G7_2_2_2_0_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g02*map.g22;
    real G7_2_2_2_0_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g02*map.g02;
    real G7_2_2_2_0_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g02*map.g12;
    real G7_2_2_2_0_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g02*map.g22;
    real G7_2_2_2_1_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g02;
    real G7_2_2_2_1_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g12;
    real G7_2_2_2_1_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g12*map.g22;
    real G7_2_2_2_1_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g12*map.g02;
    real G7_2_2_2_1_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g12*map.g12;
    real G7_2_2_2_1_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g12*map.g22;
    real G7_2_2_2_2_0_0 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g02;
    real G7_2_2_2_2_0_1 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g12;
    real G7_2_2_2_2_0_2 = map.det*c2*c0*c[0][2]*c[3][0]*map.g22*map.g22;
    real G7_2_2_2_2_1_0 = map.det*c2*c0*c[0][2]*c[3][1]*map.g22*map.g02;
    real G7_2_2_2_2_2_1 = map.det*c2*c0*c[0][2]*c[3][2]*map.g22*map.g12;
    real G7_2_2_2_2_3_2 = map.det*c2*c0*c[0][2]*c[3][3]*map.g22*map.g22;
    real G8_0_0_0_0_0 = map.det*c3*c[1][0]*map.g00*map.g00;
    real G8_0_0_0_0_1 = map.det*c3*c[1][0]*map.g00*map.g10;
    real G8_0_0_0_0_2 = map.det*c3*c[1][0]*map.g00*map.g20;
    real G8_0_0_0_1_0 = map.det*c3*c[1][1]*map.g00*map.g00;
    real G8_0_0_0_2_1 = map.det*c3*c[1][2]*map.g00*map.g10;
    real G8_0_0_0_3_2 = map.det*c3*c[1][3]*map.g00*map.g20;
    real G8_0_0_1_0_0 = map.det*c3*c[1][0]*map.g10*map.g00;
    real G8_0_0_1_0_1 = map.det*c3*c[1][0]*map.g10*map.g10;
    real G8_0_0_1_0_2 = map.det*c3*c[1][0]*map.g10*map.g20;
    real G8_0_0_1_1_0 = map.det*c3*c[1][1]*map.g10*map.g00;
    real G8_0_0_1_2_1 = map.det*c3*c[1][2]*map.g10*map.g10;
    real G8_0_0_1_3_2 = map.det*c3*c[1][3]*map.g10*map.g20;
    real G8_0_0_2_0_0 = map.det*c3*c[1][0]*map.g20*map.g00;
    real G8_0_0_2_0_1 = map.det*c3*c[1][0]*map.g20*map.g10;
    real G8_0_0_2_0_2 = map.det*c3*c[1][0]*map.g20*map.g20;
    real G8_0_0_2_1_0 = map.det*c3*c[1][1]*map.g20*map.g00;
    real G8_0_0_2_2_1 = map.det*c3*c[1][2]*map.g20*map.g10;
    real G8_0_0_2_3_2 = map.det*c3*c[1][3]*map.g20*map.g20;
    real G8_0_1_0_4_0 = map.det*c3*c[1][4]*map.g00*map.g01;
    real G8_0_1_0_4_1 = map.det*c3*c[1][4]*map.g00*map.g11;
    real G8_0_1_0_4_2 = map.det*c3*c[1][4]*map.g00*map.g21;
    real G8_0_1_0_5_0 = map.det*c3*c[1][5]*map.g00*map.g01;
    real G8_0_1_0_6_1 = map.det*c3*c[1][6]*map.g00*map.g11;
    real G8_0_1_0_7_2 = map.det*c3*c[1][7]*map.g00*map.g21;
    real G8_0_1_1_4_0 = map.det*c3*c[1][4]*map.g10*map.g01;
    real G8_0_1_1_4_1 = map.det*c3*c[1][4]*map.g10*map.g11;
    real G8_0_1_1_4_2 = map.det*c3*c[1][4]*map.g10*map.g21;
    real G8_0_1_1_5_0 = map.det*c3*c[1][5]*map.g10*map.g01;
    real G8_0_1_1_6_1 = map.det*c3*c[1][6]*map.g10*map.g11;
    real G8_0_1_1_7_2 = map.det*c3*c[1][7]*map.g10*map.g21;
    real G8_0_1_2_4_0 = map.det*c3*c[1][4]*map.g20*map.g01;
    real G8_0_1_2_4_1 = map.det*c3*c[1][4]*map.g20*map.g11;
    real G8_0_1_2_4_2 = map.det*c3*c[1][4]*map.g20*map.g21;
    real G8_0_1_2_5_0 = map.det*c3*c[1][5]*map.g20*map.g01;
    real G8_0_1_2_6_1 = map.det*c3*c[1][6]*map.g20*map.g11;
    real G8_0_1_2_7_2 = map.det*c3*c[1][7]*map.g20*map.g21;
    real G8_0_2_0_8_0 = map.det*c3*c[1][8]*map.g00*map.g02;
    real G8_0_2_0_8_1 = map.det*c3*c[1][8]*map.g00*map.g12;
    real G8_0_2_0_8_2 = map.det*c3*c[1][8]*map.g00*map.g22;
    real G8_0_2_0_9_0 = map.det*c3*c[1][9]*map.g00*map.g02;
    real G8_0_2_0_10_1 = map.det*c3*c[1][10]*map.g00*map.g12;
    real G8_0_2_0_11_2 = map.det*c3*c[1][11]*map.g00*map.g22;
    real G8_0_2_1_8_0 = map.det*c3*c[1][8]*map.g10*map.g02;
    real G8_0_2_1_8_1 = map.det*c3*c[1][8]*map.g10*map.g12;
    real G8_0_2_1_8_2 = map.det*c3*c[1][8]*map.g10*map.g22;
    real G8_0_2_1_9_0 = map.det*c3*c[1][9]*map.g10*map.g02;
    real G8_0_2_1_10_1 = map.det*c3*c[1][10]*map.g10*map.g12;
    real G8_0_2_1_11_2 = map.det*c3*c[1][11]*map.g10*map.g22;
    real G8_0_2_2_8_0 = map.det*c3*c[1][8]*map.g20*map.g02;
    real G8_0_2_2_8_1 = map.det*c3*c[1][8]*map.g20*map.g12;
    real G8_0_2_2_8_2 = map.det*c3*c[1][8]*map.g20*map.g22;
    real G8_0_2_2_9_0 = map.det*c3*c[1][9]*map.g20*map.g02;
    real G8_0_2_2_10_1 = map.det*c3*c[1][10]*map.g20*map.g12;
    real G8_0_2_2_11_2 = map.det*c3*c[1][11]*map.g20*map.g22;
    real G8_1_0_0_0_0 = map.det*c3*c[1][0]*map.g01*map.g00;
    real G8_1_0_0_0_1 = map.det*c3*c[1][0]*map.g01*map.g10;
    real G8_1_0_0_0_2 = map.det*c3*c[1][0]*map.g01*map.g20;
    real G8_1_0_0_1_0 = map.det*c3*c[1][1]*map.g01*map.g00;
    real G8_1_0_0_2_1 = map.det*c3*c[1][2]*map.g01*map.g10;
    real G8_1_0_0_3_2 = map.det*c3*c[1][3]*map.g01*map.g20;
    real G8_1_0_1_0_0 = map.det*c3*c[1][0]*map.g11*map.g00;
    real G8_1_0_1_0_1 = map.det*c3*c[1][0]*map.g11*map.g10;
    real G8_1_0_1_0_2 = map.det*c3*c[1][0]*map.g11*map.g20;
    real G8_1_0_1_1_0 = map.det*c3*c[1][1]*map.g11*map.g00;
    real G8_1_0_1_2_1 = map.det*c3*c[1][2]*map.g11*map.g10;
    real G8_1_0_1_3_2 = map.det*c3*c[1][3]*map.g11*map.g20;
    real G8_1_0_2_0_0 = map.det*c3*c[1][0]*map.g21*map.g00;
    real G8_1_0_2_0_1 = map.det*c3*c[1][0]*map.g21*map.g10;
    real G8_1_0_2_0_2 = map.det*c3*c[1][0]*map.g21*map.g20;
    real G8_1_0_2_1_0 = map.det*c3*c[1][1]*map.g21*map.g00;
    real G8_1_0_2_2_1 = map.det*c3*c[1][2]*map.g21*map.g10;
    real G8_1_0_2_3_2 = map.det*c3*c[1][3]*map.g21*map.g20;
    real G8_1_1_0_4_0 = map.det*c3*c[1][4]*map.g01*map.g01;
    real G8_1_1_0_4_1 = map.det*c3*c[1][4]*map.g01*map.g11;
    real G8_1_1_0_4_2 = map.det*c3*c[1][4]*map.g01*map.g21;
    real G8_1_1_0_5_0 = map.det*c3*c[1][5]*map.g01*map.g01;
    real G8_1_1_0_6_1 = map.det*c3*c[1][6]*map.g01*map.g11;
    real G8_1_1_0_7_2 = map.det*c3*c[1][7]*map.g01*map.g21;
    real G8_1_1_1_4_0 = map.det*c3*c[1][4]*map.g11*map.g01;
    real G8_1_1_1_4_1 = map.det*c3*c[1][4]*map.g11*map.g11;
    real G8_1_1_1_4_2 = map.det*c3*c[1][4]*map.g11*map.g21;
    real G8_1_1_1_5_0 = map.det*c3*c[1][5]*map.g11*map.g01;
    real G8_1_1_1_6_1 = map.det*c3*c[1][6]*map.g11*map.g11;
    real G8_1_1_1_7_2 = map.det*c3*c[1][7]*map.g11*map.g21;
    real G8_1_1_2_4_0 = map.det*c3*c[1][4]*map.g21*map.g01;
    real G8_1_1_2_4_1 = map.det*c3*c[1][4]*map.g21*map.g11;
    real G8_1_1_2_4_2 = map.det*c3*c[1][4]*map.g21*map.g21;
    real G8_1_1_2_5_0 = map.det*c3*c[1][5]*map.g21*map.g01;
    real G8_1_1_2_6_1 = map.det*c3*c[1][6]*map.g21*map.g11;
    real G8_1_1_2_7_2 = map.det*c3*c[1][7]*map.g21*map.g21;
    real G8_1_2_0_8_0 = map.det*c3*c[1][8]*map.g01*map.g02;
    real G8_1_2_0_8_1 = map.det*c3*c[1][8]*map.g01*map.g12;
    real G8_1_2_0_8_2 = map.det*c3*c[1][8]*map.g01*map.g22;
    real G8_1_2_0_9_0 = map.det*c3*c[1][9]*map.g01*map.g02;
    real G8_1_2_0_10_1 = map.det*c3*c[1][10]*map.g01*map.g12;
    real G8_1_2_0_11_2 = map.det*c3*c[1][11]*map.g01*map.g22;
    real G8_1_2_1_8_0 = map.det*c3*c[1][8]*map.g11*map.g02;
    real G8_1_2_1_8_1 = map.det*c3*c[1][8]*map.g11*map.g12;
    real G8_1_2_1_8_2 = map.det*c3*c[1][8]*map.g11*map.g22;
    real G8_1_2_1_9_0 = map.det*c3*c[1][9]*map.g11*map.g02;
    real G8_1_2_1_10_1 = map.det*c3*c[1][10]*map.g11*map.g12;
    real G8_1_2_1_11_2 = map.det*c3*c[1][11]*map.g11*map.g22;
    real G8_1_2_2_8_0 = map.det*c3*c[1][8]*map.g21*map.g02;
    real G8_1_2_2_8_1 = map.det*c3*c[1][8]*map.g21*map.g12;
    real G8_1_2_2_8_2 = map.det*c3*c[1][8]*map.g21*map.g22;
    real G8_1_2_2_9_0 = map.det*c3*c[1][9]*map.g21*map.g02;
    real G8_1_2_2_10_1 = map.det*c3*c[1][10]*map.g21*map.g12;
    real G8_1_2_2_11_2 = map.det*c3*c[1][11]*map.g21*map.g22;
    real G8_2_0_0_0_0 = map.det*c3*c[1][0]*map.g02*map.g00;
    real G8_2_0_0_0_1 = map.det*c3*c[1][0]*map.g02*map.g10;
    real G8_2_0_0_0_2 = map.det*c3*c[1][0]*map.g02*map.g20;
    real G8_2_0_0_1_0 = map.det*c3*c[1][1]*map.g02*map.g00;
    real G8_2_0_0_2_1 = map.det*c3*c[1][2]*map.g02*map.g10;
    real G8_2_0_0_3_2 = map.det*c3*c[1][3]*map.g02*map.g20;
    real G8_2_0_1_0_0 = map.det*c3*c[1][0]*map.g12*map.g00;
    real G8_2_0_1_0_1 = map.det*c3*c[1][0]*map.g12*map.g10;
    real G8_2_0_1_0_2 = map.det*c3*c[1][0]*map.g12*map.g20;
    real G8_2_0_1_1_0 = map.det*c3*c[1][1]*map.g12*map.g00;
    real G8_2_0_1_2_1 = map.det*c3*c[1][2]*map.g12*map.g10;
    real G8_2_0_1_3_2 = map.det*c3*c[1][3]*map.g12*map.g20;
    real G8_2_0_2_0_0 = map.det*c3*c[1][0]*map.g22*map.g00;
    real G8_2_0_2_0_1 = map.det*c3*c[1][0]*map.g22*map.g10;
    real G8_2_0_2_0_2 = map.det*c3*c[1][0]*map.g22*map.g20;
    real G8_2_0_2_1_0 = map.det*c3*c[1][1]*map.g22*map.g00;
    real G8_2_0_2_2_1 = map.det*c3*c[1][2]*map.g22*map.g10;
    real G8_2_0_2_3_2 = map.det*c3*c[1][3]*map.g22*map.g20;
    real G8_2_1_0_4_0 = map.det*c3*c[1][4]*map.g02*map.g01;
    real G8_2_1_0_4_1 = map.det*c3*c[1][4]*map.g02*map.g11;
    real G8_2_1_0_4_2 = map.det*c3*c[1][4]*map.g02*map.g21;
    real G8_2_1_0_5_0 = map.det*c3*c[1][5]*map.g02*map.g01;
    real G8_2_1_0_6_1 = map.det*c3*c[1][6]*map.g02*map.g11;
    real G8_2_1_0_7_2 = map.det*c3*c[1][7]*map.g02*map.g21;
    real G8_2_1_1_4_0 = map.det*c3*c[1][4]*map.g12*map.g01;
    real G8_2_1_1_4_1 = map.det*c3*c[1][4]*map.g12*map.g11;
    real G8_2_1_1_4_2 = map.det*c3*c[1][4]*map.g12*map.g21;
    real G8_2_1_1_5_0 = map.det*c3*c[1][5]*map.g12*map.g01;
    real G8_2_1_1_6_1 = map.det*c3*c[1][6]*map.g12*map.g11;
    real G8_2_1_1_7_2 = map.det*c3*c[1][7]*map.g12*map.g21;
    real G8_2_1_2_4_0 = map.det*c3*c[1][4]*map.g22*map.g01;
    real G8_2_1_2_4_1 = map.det*c3*c[1][4]*map.g22*map.g11;
    real G8_2_1_2_4_2 = map.det*c3*c[1][4]*map.g22*map.g21;
    real G8_2_1_2_5_0 = map.det*c3*c[1][5]*map.g22*map.g01;
    real G8_2_1_2_6_1 = map.det*c3*c[1][6]*map.g22*map.g11;
    real G8_2_1_2_7_2 = map.det*c3*c[1][7]*map.g22*map.g21;
    real G8_2_2_0_8_0 = map.det*c3*c[1][8]*map.g02*map.g02;
    real G8_2_2_0_8_1 = map.det*c3*c[1][8]*map.g02*map.g12;
    real G8_2_2_0_8_2 = map.det*c3*c[1][8]*map.g02*map.g22;
    real G8_2_2_0_9_0 = map.det*c3*c[1][9]*map.g02*map.g02;
    real G8_2_2_0_10_1 = map.det*c3*c[1][10]*map.g02*map.g12;
    real G8_2_2_0_11_2 = map.det*c3*c[1][11]*map.g02*map.g22;
    real G8_2_2_1_8_0 = map.det*c3*c[1][8]*map.g12*map.g02;
    real G8_2_2_1_8_1 = map.det*c3*c[1][8]*map.g12*map.g12;
    real G8_2_2_1_8_2 = map.det*c3*c[1][8]*map.g12*map.g22;
    real G8_2_2_1_9_0 = map.det*c3*c[1][9]*map.g12*map.g02;
    real G8_2_2_1_10_1 = map.det*c3*c[1][10]*map.g12*map.g12;
    real G8_2_2_1_11_2 = map.det*c3*c[1][11]*map.g12*map.g22;
    real G8_2_2_2_8_0 = map.det*c3*c[1][8]*map.g22*map.g02;
    real G8_2_2_2_8_1 = map.det*c3*c[1][8]*map.g22*map.g12;
    real G8_2_2_2_8_2 = map.det*c3*c[1][8]*map.g22*map.g22;
    real G8_2_2_2_9_0 = map.det*c3*c[1][9]*map.g22*map.g02;
    real G8_2_2_2_10_1 = map.det*c3*c[1][10]*map.g22*map.g12;
    real G8_2_2_2_11_2 = map.det*c3*c[1][11]*map.g22*map.g22;

    // Compute element tensor
    block[0] = 1.666666666666662e-02*G0_0 + 8.333333333333311e-03*G0_1 + 8.333333333333312e-03*G0_2 + 8.333333333333314e-03*G0_3 + 1.666666666666662e-02*G1_0 + 8.333333333333311e-03*G1_1 + 8.333333333333312e-03*G1_2 + 8.333333333333314e-03*G1_3 - 4.166666666666661e-02*G2_0_0_0 - 4.166666666666661e-02*G2_0_0_1 - 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_0_3 - 4.166666666666662e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_1_1 - 4.166666666666662e-02*G2_0_1_2 - 4.166666666666662e-02*G2_0_1_3 - 4.166666666666661e-02*G2_0_2_0 - 4.166666666666661e-02*G2_0_2_1 - 4.166666666666661e-02*G2_0_2_2 - 4.166666666666661e-02*G2_0_2_3 - 4.166666666666662e-02*G3_0_0_0_0 - 4.166666666666660e-02*G3_0_0_0_1 - 4.166666666666661e-02*G3_0_0_0_2 - 4.166666666666661e-02*G3_0_0_0_3 - 4.166666666666662e-02*G3_0_0_1_0 - 4.166666666666661e-02*G3_0_0_1_1 - 4.166666666666662e-02*G3_0_0_1_2 - 4.166666666666662e-02*G3_0_0_1_3 - 4.166666666666662e-02*G3_0_0_2_0 - 4.166666666666660e-02*G3_0_0_2_1 - 4.166666666666661e-02*G3_0_0_2_2 - 4.166666666666661e-02*G3_0_0_2_3 - 4.166666666666662e-02*G3_1_1_0_0 - 4.166666666666660e-02*G3_1_1_0_1 - 4.166666666666661e-02*G3_1_1_0_2 - 4.166666666666661e-02*G3_1_1_0_3 - 4.166666666666662e-02*G3_1_1_1_0 - 4.166666666666661e-02*G3_1_1_1_1 - 4.166666666666662e-02*G3_1_1_1_2 - 4.166666666666662e-02*G3_1_1_1_3 - 4.166666666666662e-02*G3_1_1_2_0 - 4.166666666666660e-02*G3_1_1_2_1 - 4.166666666666661e-02*G3_1_1_2_2 - 4.166666666666661e-02*G3_1_1_2_3 - 4.166666666666662e-02*G3_2_2_0_0 - 4.166666666666660e-02*G3_2_2_0_1 - 4.166666666666661e-02*G3_2_2_0_2 - 4.166666666666661e-02*G3_2_2_0_3 - 4.166666666666662e-02*G3_2_2_1_0 - 4.166666666666661e-02*G3_2_2_1_1 - 4.166666666666662e-02*G3_2_2_1_2 - 4.166666666666662e-02*G3_2_2_1_3 - 4.166666666666662e-02*G3_2_2_2_0 - 4.166666666666660e-02*G3_2_2_2_1 - 4.166666666666661e-02*G3_2_2_2_2 - 4.166666666666661e-02*G3_2_2_2_3 - 8.333333333333320e-02*G4_0_0_0 - 8.333333333333322e-02*G4_0_0_1 - 8.333333333333320e-02*G4_0_0_2 + 8.333333333333320e-02*G4_0_1_0 + 8.333333333333322e-02*G4_0_2_1 + 8.333333333333322e-02*G4_0_3_2 - 8.333333333333322e-02*G4_1_0_0 - 8.333333333333323e-02*G4_1_0_1 - 8.333333333333322e-02*G4_1_0_2 + 8.333333333333322e-02*G4_1_1_0 + 8.333333333333323e-02*G4_1_2_1 + 8.333333333333323e-02*G4_1_3_2 - 8.333333333333320e-02*G4_2_0_0 - 8.333333333333322e-02*G4_2_0_1 - 8.333333333333320e-02*G4_2_0_2 + 8.333333333333320e-02*G4_2_1_0 + 8.333333333333322e-02*G4_2_2_1 + 8.333333333333322e-02*G4_2_3_2 + 2.083333333333331e-02*G5_0_0_0_0 + 2.083333333333331e-02*G5_0_0_0_1 + 2.083333333333331e-02*G5_0_0_0_2 - 2.083333333333331e-02*G5_0_0_1_0 - 2.083333333333331e-02*G5_0_0_2_1 - 2.083333333333331e-02*G5_0_0_3_2 + 2.083333333333331e-02*G5_1_1_0_0 + 2.083333333333331e-02*G5_1_1_0_1 + 2.083333333333331e-02*G5_1_1_0_2 - 2.083333333333331e-02*G5_1_1_1_0 - 2.083333333333331e-02*G5_1_1_2_1 - 2.083333333333331e-02*G5_1_1_3_2 + 2.083333333333331e-02*G5_2_2_0_0 + 2.083333333333331e-02*G5_2_2_0_1 + 2.083333333333331e-02*G5_2_2_0_2 - 2.083333333333331e-02*G5_2_2_1_0 - 2.083333333333331e-02*G5_2_2_2_1 - 2.083333333333331e-02*G5_2_2_3_2 - 8.333333333333320e-02*G6_0_0_0_0_0_0_0 - 8.333333333333322e-02*G6_0_0_0_0_0_0_1 - 8.333333333333320e-02*G6_0_0_0_0_0_0_2 + 8.333333333333320e-02*G6_0_0_0_0_0_1_0 + 8.333333333333322e-02*G6_0_0_0_0_0_2_1 + 8.333333333333322e-02*G6_0_0_0_0_0_3_2 - 8.333333333333322e-02*G6_0_0_0_1_0_0_0 - 8.333333333333323e-02*G6_0_0_0_1_0_0_1 - 8.333333333333322e-02*G6_0_0_0_1_0_0_2 + 8.333333333333322e-02*G6_0_0_0_1_0_1_0 + 8.333333333333323e-02*G6_0_0_0_1_0_2_1 + 8.333333333333323e-02*G6_0_0_0_1_0_3_2 - 8.333333333333320e-02*G6_0_0_0_2_0_0_0 - 8.333333333333322e-02*G6_0_0_0_2_0_0_1 - 8.333333333333320e-02*G6_0_0_0_2_0_0_2 + 8.333333333333320e-02*G6_0_0_0_2_0_1_0 + 8.333333333333322e-02*G6_0_0_0_2_0_2_1 + 8.333333333333322e-02*G6_0_0_0_2_0_3_2 - 8.333333333333320e-02*G6_0_1_0_0_1_0_0 - 8.333333333333322e-02*G6_0_1_0_0_1_0_1 - 8.333333333333320e-02*G6_0_1_0_0_1_0_2 + 8.333333333333320e-02*G6_0_1_0_0_1_1_0 + 8.333333333333322e-02*G6_0_1_0_0_1_2_1 + 8.333333333333322e-02*G6_0_1_0_0_1_3_2 - 8.333333333333322e-02*G6_0_1_0_1_1_0_0 - 8.333333333333323e-02*G6_0_1_0_1_1_0_1 - 8.333333333333322e-02*G6_0_1_0_1_1_0_2 + 8.333333333333322e-02*G6_0_1_0_1_1_1_0 + 8.333333333333323e-02*G6_0_1_0_1_1_2_1 + 8.333333333333323e-02*G6_0_1_0_1_1_3_2 - 8.333333333333320e-02*G6_0_1_0_2_1_0_0 - 8.333333333333322e-02*G6_0_1_0_2_1_0_1 - 8.333333333333320e-02*G6_0_1_0_2_1_0_2 + 8.333333333333320e-02*G6_0_1_0_2_1_1_0 + 8.333333333333322e-02*G6_0_1_0_2_1_2_1 + 8.333333333333322e-02*G6_0_1_0_2_1_3_2 - 8.333333333333320e-02*G6_0_2_0_0_2_0_0 - 8.333333333333322e-02*G6_0_2_0_0_2_0_1 - 8.333333333333320e-02*G6_0_2_0_0_2_0_2 + 8.333333333333320e-02*G6_0_2_0_0_2_1_0 + 8.333333333333322e-02*G6_0_2_0_0_2_2_1 + 8.333333333333322e-02*G6_0_2_0_0_2_3_2 - 8.333333333333322e-02*G6_0_2_0_1_2_0_0 - 8.333333333333323e-02*G6_0_2_0_1_2_0_1 - 8.333333333333322e-02*G6_0_2_0_1_2_0_2 + 8.333333333333322e-02*G6_0_2_0_1_2_1_0 + 8.333333333333323e-02*G6_0_2_0_1_2_2_1 + 8.333333333333323e-02*G6_0_2_0_1_2_3_2 - 8.333333333333320e-02*G6_0_2_0_2_2_0_0 - 8.333333333333322e-02*G6_0_2_0_2_2_0_1 - 8.333333333333320e-02*G6_0_2_0_2_2_0_2 + 8.333333333333320e-02*G6_0_2_0_2_2_1_0 + 8.333333333333322e-02*G6_0_2_0_2_2_2_1 + 8.333333333333322e-02*G6_0_2_0_2_2_3_2 - 8.333333333333320e-02*G6_1_0_1_0_0_0_0 - 8.333333333333322e-02*G6_1_0_1_0_0_0_1 - 8.333333333333320e-02*G6_1_0_1_0_0_0_2 + 8.333333333333320e-02*G6_1_0_1_0_0_1_0 + 8.333333333333322e-02*G6_1_0_1_0_0_2_1 + 8.333333333333322e-02*G6_1_0_1_0_0_3_2 - 8.333333333333322e-02*G6_1_0_1_1_0_0_0 - 8.333333333333323e-02*G6_1_0_1_1_0_0_1 - 8.333333333333322e-02*G6_1_0_1_1_0_0_2 + 8.333333333333322e-02*G6_1_0_1_1_0_1_0 + 8.333333333333323e-02*G6_1_0_1_1_0_2_1 + 8.333333333333323e-02*G6_1_0_1_1_0_3_2 - 8.333333333333320e-02*G6_1_0_1_2_0_0_0 - 8.333333333333322e-02*G6_1_0_1_2_0_0_1 - 8.333333333333320e-02*G6_1_0_1_2_0_0_2 + 8.333333333333320e-02*G6_1_0_1_2_0_1_0 + 8.333333333333322e-02*G6_1_0_1_2_0_2_1 + 8.333333333333322e-02*G6_1_0_1_2_0_3_2 - 8.333333333333320e-02*G6_1_1_1_0_1_0_0 - 8.333333333333322e-02*G6_1_1_1_0_1_0_1 - 8.333333333333320e-02*G6_1_1_1_0_1_0_2 + 8.333333333333320e-02*G6_1_1_1_0_1_1_0 + 8.333333333333322e-02*G6_1_1_1_0_1_2_1 + 8.333333333333322e-02*G6_1_1_1_0_1_3_2 - 8.333333333333322e-02*G6_1_1_1_1_1_0_0 - 8.333333333333323e-02*G6_1_1_1_1_1_0_1 - 8.333333333333322e-02*G6_1_1_1_1_1_0_2 + 8.333333333333322e-02*G6_1_1_1_1_1_1_0 + 8.333333333333323e-02*G6_1_1_1_1_1_2_1 + 8.333333333333323e-02*G6_1_1_1_1_1_3_2 - 8.333333333333320e-02*G6_1_1_1_2_1_0_0 - 8.333333333333322e-02*G6_1_1_1_2_1_0_1 - 8.333333333333320e-02*G6_1_1_1_2_1_0_2 + 8.333333333333320e-02*G6_1_1_1_2_1_1_0 + 8.333333333333322e-02*G6_1_1_1_2_1_2_1 + 8.333333333333322e-02*G6_1_1_1_2_1_3_2 - 8.333333333333320e-02*G6_1_2_1_0_2_0_0 - 8.333333333333322e-02*G6_1_2_1_0_2_0_1 - 8.333333333333320e-02*G6_1_2_1_0_2_0_2 + 8.333333333333320e-02*G6_1_2_1_0_2_1_0 + 8.333333333333322e-02*G6_1_2_1_0_2_2_1 + 8.333333333333322e-02*G6_1_2_1_0_2_3_2 - 8.333333333333322e-02*G6_1_2_1_1_2_0_0 - 8.333333333333323e-02*G6_1_2_1_1_2_0_1 - 8.333333333333322e-02*G6_1_2_1_1_2_0_2 + 8.333333333333322e-02*G6_1_2_1_1_2_1_0 + 8.333333333333323e-02*G6_1_2_1_1_2_2_1 + 8.333333333333323e-02*G6_1_2_1_1_2_3_2 - 8.333333333333320e-02*G6_1_2_1_2_2_0_0 - 8.333333333333322e-02*G6_1_2_1_2_2_0_1 - 8.333333333333320e-02*G6_1_2_1_2_2_0_2 + 8.333333333333320e-02*G6_1_2_1_2_2_1_0 + 8.333333333333322e-02*G6_1_2_1_2_2_2_1 + 8.333333333333322e-02*G6_1_2_1_2_2_3_2 - 8.333333333333320e-02*G6_2_0_2_0_0_0_0 - 8.333333333333322e-02*G6_2_0_2_0_0_0_1 - 8.333333333333320e-02*G6_2_0_2_0_0_0_2 + 8.333333333333320e-02*G6_2_0_2_0_0_1_0 + 8.333333333333322e-02*G6_2_0_2_0_0_2_1 + 8.333333333333322e-02*G6_2_0_2_0_0_3_2 - 8.333333333333322e-02*G6_2_0_2_1_0_0_0 - 8.333333333333323e-02*G6_2_0_2_1_0_0_1 - 8.333333333333322e-02*G6_2_0_2_1_0_0_2 + 8.333333333333322e-02*G6_2_0_2_1_0_1_0 + 8.333333333333323e-02*G6_2_0_2_1_0_2_1 + 8.333333333333323e-02*G6_2_0_2_1_0_3_2 - 8.333333333333320e-02*G6_2_0_2_2_0_0_0 - 8.333333333333322e-02*G6_2_0_2_2_0_0_1 - 8.333333333333320e-02*G6_2_0_2_2_0_0_2 + 8.333333333333320e-02*G6_2_0_2_2_0_1_0 + 8.333333333333322e-02*G6_2_0_2_2_0_2_1 + 8.333333333333322e-02*G6_2_0_2_2_0_3_2 - 8.333333333333320e-02*G6_2_1_2_0_1_0_0 - 8.333333333333322e-02*G6_2_1_2_0_1_0_1 - 8.333333333333320e-02*G6_2_1_2_0_1_0_2 + 8.333333333333320e-02*G6_2_1_2_0_1_1_0 + 8.333333333333322e-02*G6_2_1_2_0_1_2_1 + 8.333333333333322e-02*G6_2_1_2_0_1_3_2 - 8.333333333333322e-02*G6_2_1_2_1_1_0_0 - 8.333333333333323e-02*G6_2_1_2_1_1_0_1 - 8.333333333333322e-02*G6_2_1_2_1_1_0_2 + 8.333333333333322e-02*G6_2_1_2_1_1_1_0 + 8.333333333333323e-02*G6_2_1_2_1_1_2_1 + 8.333333333333323e-02*G6_2_1_2_1_1_3_2 - 8.333333333333320e-02*G6_2_1_2_2_1_0_0 - 8.333333333333322e-02*G6_2_1_2_2_1_0_1 - 8.333333333333320e-02*G6_2_1_2_2_1_0_2 + 8.333333333333320e-02*G6_2_1_2_2_1_1_0 + 8.333333333333322e-02*G6_2_1_2_2_1_2_1 + 8.333333333333322e-02*G6_2_1_2_2_1_3_2 - 8.333333333333320e-02*G6_2_2_2_0_2_0_0 - 8.333333333333322e-02*G6_2_2_2_0_2_0_1 - 8.333333333333320e-02*G6_2_2_2_0_2_0_2 + 8.333333333333320e-02*G6_2_2_2_0_2_1_0 + 8.333333333333322e-02*G6_2_2_2_0_2_2_1 + 8.333333333333322e-02*G6_2_2_2_0_2_3_2 - 8.333333333333322e-02*G6_2_2_2_1_2_0_0 - 8.333333333333323e-02*G6_2_2_2_1_2_0_1 - 8.333333333333322e-02*G6_2_2_2_1_2_0_2 + 8.333333333333322e-02*G6_2_2_2_1_2_1_0 + 8.333333333333323e-02*G6_2_2_2_1_2_2_1 + 8.333333333333323e-02*G6_2_2_2_1_2_3_2 - 8.333333333333320e-02*G6_2_2_2_2_2_0_0 - 8.333333333333322e-02*G6_2_2_2_2_2_0_1 - 8.333333333333320e-02*G6_2_2_2_2_2_0_2 + 8.333333333333320e-02*G6_2_2_2_2_2_1_0 + 8.333333333333322e-02*G6_2_2_2_2_2_2_1 + 8.333333333333322e-02*G6_2_2_2_2_2_3_2 - 1.666666666666664e-01*G7_0_0_0_0_0_0 - 1.666666666666664e-01*G7_0_0_0_0_0_1 - 1.666666666666664e-01*G7_0_0_0_0_0_2 + 1.666666666666664e-01*G7_0_0_0_0_1_0 + 1.666666666666664e-01*G7_0_0_0_0_2_1 + 1.666666666666664e-01*G7_0_0_0_0_3_2 - 1.666666666666664e-01*G7_0_0_0_1_0_0 - 1.666666666666665e-01*G7_0_0_0_1_0_1 - 1.666666666666665e-01*G7_0_0_0_1_0_2 + 1.666666666666664e-01*G7_0_0_0_1_1_0 + 1.666666666666665e-01*G7_0_0_0_1_2_1 + 1.666666666666665e-01*G7_0_0_0_1_3_2 - 1.666666666666664e-01*G7_0_0_0_2_0_0 - 1.666666666666664e-01*G7_0_0_0_2_0_1 - 1.666666666666664e-01*G7_0_0_0_2_0_2 + 1.666666666666664e-01*G7_0_0_0_2_1_0 + 1.666666666666664e-01*G7_0_0_0_2_2_1 + 1.666666666666664e-01*G7_0_0_0_2_3_2 - 1.666666666666664e-01*G7_0_1_1_0_0_0 - 1.666666666666664e-01*G7_0_1_1_0_0_1 - 1.666666666666664e-01*G7_0_1_1_0_0_2 + 1.666666666666664e-01*G7_0_1_1_0_1_0 + 1.666666666666664e-01*G7_0_1_1_0_2_1 + 1.666666666666664e-01*G7_0_1_1_0_3_2 - 1.666666666666664e-01*G7_0_1_1_1_0_0 - 1.666666666666665e-01*G7_0_1_1_1_0_1 - 1.666666666666665e-01*G7_0_1_1_1_0_2 + 1.666666666666664e-01*G7_0_1_1_1_1_0 + 1.666666666666665e-01*G7_0_1_1_1_2_1 + 1.666666666666665e-01*G7_0_1_1_1_3_2 - 1.666666666666664e-01*G7_0_1_1_2_0_0 - 1.666666666666664e-01*G7_0_1_1_2_0_1 - 1.666666666666664e-01*G7_0_1_1_2_0_2 + 1.666666666666664e-01*G7_0_1_1_2_1_0 + 1.666666666666664e-01*G7_0_1_1_2_2_1 + 1.666666666666664e-01*G7_0_1_1_2_3_2 - 1.666666666666664e-01*G7_0_2_2_0_0_0 - 1.666666666666664e-01*G7_0_2_2_0_0_1 - 1.666666666666664e-01*G7_0_2_2_0_0_2 + 1.666666666666664e-01*G7_0_2_2_0_1_0 + 1.666666666666664e-01*G7_0_2_2_0_2_1 + 1.666666666666664e-01*G7_0_2_2_0_3_2 - 1.666666666666664e-01*G7_0_2_2_1_0_0 - 1.666666666666665e-01*G7_0_2_2_1_0_1 - 1.666666666666665e-01*G7_0_2_2_1_0_2 + 1.666666666666664e-01*G7_0_2_2_1_1_0 + 1.666666666666665e-01*G7_0_2_2_1_2_1 + 1.666666666666665e-01*G7_0_2_2_1_3_2 - 1.666666666666664e-01*G7_0_2_2_2_0_0 - 1.666666666666664e-01*G7_0_2_2_2_0_1 - 1.666666666666664e-01*G7_0_2_2_2_0_2 + 1.666666666666664e-01*G7_0_2_2_2_1_0 + 1.666666666666664e-01*G7_0_2_2_2_2_1 + 1.666666666666664e-01*G7_0_2_2_2_3_2 - 8.333333333333320e-02*G8_0_0_0_0_0 - 8.333333333333322e-02*G8_0_0_0_0_1 - 8.333333333333320e-02*G8_0_0_0_0_2 + 8.333333333333320e-02*G8_0_0_0_1_0 + 8.333333333333322e-02*G8_0_0_0_2_1 + 8.333333333333322e-02*G8_0_0_0_3_2 - 8.333333333333322e-02*G8_0_0_1_0_0 - 8.333333333333323e-02*G8_0_0_1_0_1 - 8.333333333333322e-02*G8_0_0_1_0_2 + 8.333333333333322e-02*G8_0_0_1_1_0 + 8.333333333333323e-02*G8_0_0_1_2_1 + 8.333333333333323e-02*G8_0_0_1_3_2 - 8.333333333333320e-02*G8_0_0_2_0_0 - 8.333333333333322e-02*G8_0_0_2_0_1 - 8.333333333333320e-02*G8_0_0_2_0_2 + 8.333333333333320e-02*G8_0_0_2_1_0 + 8.333333333333322e-02*G8_0_0_2_2_1 + 8.333333333333322e-02*G8_0_0_2_3_2 - 8.333333333333320e-02*G8_0_1_0_4_0 - 8.333333333333322e-02*G8_0_1_0_4_1 - 8.333333333333322e-02*G8_0_1_0_4_2 + 8.333333333333320e-02*G8_0_1_0_5_0 + 8.333333333333322e-02*G8_0_1_0_6_1 + 8.333333333333322e-02*G8_0_1_0_7_2 - 8.333333333333322e-02*G8_0_1_1_4_0 - 8.333333333333323e-02*G8_0_1_1_4_1 - 8.333333333333323e-02*G8_0_1_1_4_2 + 8.333333333333322e-02*G8_0_1_1_5_0 + 8.333333333333323e-02*G8_0_1_1_6_1 + 8.333333333333323e-02*G8_0_1_1_7_2 - 8.333333333333320e-02*G8_0_1_2_4_0 - 8.333333333333322e-02*G8_0_1_2_4_1 - 8.333333333333322e-02*G8_0_1_2_4_2 + 8.333333333333320e-02*G8_0_1_2_5_0 + 8.333333333333322e-02*G8_0_1_2_6_1 + 8.333333333333322e-02*G8_0_1_2_7_2 - 8.333333333333320e-02*G8_0_2_0_8_0 - 8.333333333333322e-02*G8_0_2_0_8_1 - 8.333333333333322e-02*G8_0_2_0_8_2 + 8.333333333333320e-02*G8_0_2_0_9_0 + 8.333333333333322e-02*G8_0_2_0_10_1 + 8.333333333333322e-02*G8_0_2_0_11_2 - 8.333333333333322e-02*G8_0_2_1_8_0 - 8.333333333333323e-02*G8_0_2_1_8_1 - 8.333333333333323e-02*G8_0_2_1_8_2 + 8.333333333333322e-02*G8_0_2_1_9_0 + 8.333333333333323e-02*G8_0_2_1_10_1 + 8.333333333333323e-02*G8_0_2_1_11_2 - 8.333333333333320e-02*G8_0_2_2_8_0 - 8.333333333333322e-02*G8_0_2_2_8_1 - 8.333333333333322e-02*G8_0_2_2_8_2 + 8.333333333333320e-02*G8_0_2_2_9_0 + 8.333333333333322e-02*G8_0_2_2_10_1 + 8.333333333333322e-02*G8_0_2_2_11_2;
    block[1] = 8.333333333333311e-03*G0_0 + 1.666666666666662e-02*G0_1 + 8.333333333333309e-03*G0_2 + 8.333333333333311e-03*G0_3 + 8.333333333333311e-03*G1_0 + 1.666666666666662e-02*G1_1 + 8.333333333333309e-03*G1_2 + 8.333333333333311e-03*G1_3 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666661e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 + 4.166666666666661e-02*G2_0_0_3 + 4.166666666666662e-02*G3_0_0_0_0 + 4.166666666666660e-02*G3_0_0_0_1 + 4.166666666666661e-02*G3_0_0_0_2 + 4.166666666666661e-02*G3_0_0_0_3 + 4.166666666666662e-02*G3_1_1_0_0 + 4.166666666666660e-02*G3_1_1_0_1 + 4.166666666666661e-02*G3_1_1_0_2 + 4.166666666666661e-02*G3_1_1_0_3 + 4.166666666666662e-02*G3_2_2_0_0 + 4.166666666666660e-02*G3_2_2_0_1 + 4.166666666666661e-02*G3_2_2_0_2 + 4.166666666666661e-02*G3_2_2_0_3 + 8.333333333333320e-02*G4_0_0_0 + 8.333333333333322e-02*G4_0_0_1 + 8.333333333333320e-02*G4_0_0_2 - 8.333333333333320e-02*G4_0_1_0 - 8.333333333333322e-02*G4_0_2_1 - 8.333333333333322e-02*G4_0_3_2 + 2.083333333333330e-02*G5_0_0_0_0 + 2.083333333333330e-02*G5_0_0_0_1 + 2.083333333333330e-02*G5_0_0_0_2 - 2.083333333333330e-02*G5_0_0_1_0 - 2.083333333333330e-02*G5_0_0_2_1 - 2.083333333333330e-02*G5_0_0_3_2 + 2.083333333333330e-02*G5_1_1_0_0 + 2.083333333333330e-02*G5_1_1_0_1 + 2.083333333333330e-02*G5_1_1_0_2 - 2.083333333333330e-02*G5_1_1_1_0 - 2.083333333333330e-02*G5_1_1_2_1 - 2.083333333333330e-02*G5_1_1_3_2 + 2.083333333333330e-02*G5_2_2_0_0 + 2.083333333333330e-02*G5_2_2_0_1 + 2.083333333333330e-02*G5_2_2_0_2 - 2.083333333333330e-02*G5_2_2_1_0 - 2.083333333333330e-02*G5_2_2_2_1 - 2.083333333333330e-02*G5_2_2_3_2 + 8.333333333333320e-02*G6_0_0_0_0_0_0_0 + 8.333333333333322e-02*G6_0_0_0_0_0_0_1 + 8.333333333333320e-02*G6_0_0_0_0_0_0_2 - 8.333333333333320e-02*G6_0_0_0_0_0_1_0 - 8.333333333333322e-02*G6_0_0_0_0_0_2_1 - 8.333333333333322e-02*G6_0_0_0_0_0_3_2 + 8.333333333333320e-02*G6_0_1_0_0_1_0_0 + 8.333333333333322e-02*G6_0_1_0_0_1_0_1 + 8.333333333333320e-02*G6_0_1_0_0_1_0_2 - 8.333333333333320e-02*G6_0_1_0_0_1_1_0 - 8.333333333333322e-02*G6_0_1_0_0_1_2_1 - 8.333333333333322e-02*G6_0_1_0_0_1_3_2 + 8.333333333333320e-02*G6_0_2_0_0_2_0_0 + 8.333333333333322e-02*G6_0_2_0_0_2_0_1 + 8.333333333333320e-02*G6_0_2_0_0_2_0_2 - 8.333333333333320e-02*G6_0_2_0_0_2_1_0 - 8.333333333333322e-02*G6_0_2_0_0_2_2_1 - 8.333333333333322e-02*G6_0_2_0_0_2_3_2 + 8.333333333333320e-02*G6_1_0_1_0_0_0_0 + 8.333333333333322e-02*G6_1_0_1_0_0_0_1 + 8.333333333333320e-02*G6_1_0_1_0_0_0_2 - 8.333333333333320e-02*G6_1_0_1_0_0_1_0 - 8.333333333333322e-02*G6_1_0_1_0_0_2_1 - 8.333333333333322e-02*G6_1_0_1_0_0_3_2 + 8.333333333333320e-02*G6_1_1_1_0_1_0_0 + 8.333333333333322e-02*G6_1_1_1_0_1_0_1 + 8.333333333333320e-02*G6_1_1_1_0_1_0_2 - 8.333333333333320e-02*G6_1_1_1_0_1_1_0 - 8.333333333333322e-02*G6_1_1_1_0_1_2_1 - 8.333333333333322e-02*G6_1_1_1_0_1_3_2 + 8.333333333333320e-02*G6_1_2_1_0_2_0_0 + 8.333333333333322e-02*G6_1_2_1_0_2_0_1 + 8.333333333333320e-02*G6_1_2_1_0_2_0_2 - 8.333333333333320e-02*G6_1_2_1_0_2_1_0 - 8.333333333333322e-02*G6_1_2_1_0_2_2_1 - 8.333333333333322e-02*G6_1_2_1_0_2_3_2 + 8.333333333333320e-02*G6_2_0_2_0_0_0_0 + 8.333333333333322e-02*G6_2_0_2_0_0_0_1 + 8.333333333333320e-02*G6_2_0_2_0_0_0_2 - 8.333333333333320e-02*G6_2_0_2_0_0_1_0 - 8.333333333333322e-02*G6_2_0_2_0_0_2_1 - 8.333333333333322e-02*G6_2_0_2_0_0_3_2 + 8.333333333333320e-02*G6_2_1_2_0_1_0_0 + 8.333333333333322e-02*G6_2_1_2_0_1_0_1 + 8.333333333333320e-02*G6_2_1_2_0_1_0_2 - 8.333333333333320e-02*G6_2_1_2_0_1_1_0 - 8.333333333333322e-02*G6_2_1_2_0_1_2_1 - 8.333333333333322e-02*G6_2_1_2_0_1_3_2 + 8.333333333333320e-02*G6_2_2_2_0_2_0_0 + 8.333333333333322e-02*G6_2_2_2_0_2_0_1 + 8.333333333333320e-02*G6_2_2_2_0_2_0_2 - 8.333333333333320e-02*G6_2_2_2_0_2_1_0 - 8.333333333333322e-02*G6_2_2_2_0_2_2_1 - 8.333333333333322e-02*G6_2_2_2_0_2_3_2 + 1.666666666666664e-01*G7_0_0_0_0_0_0 + 1.666666666666664e-01*G7_0_0_0_0_0_1 + 1.666666666666664e-01*G7_0_0_0_0_0_2 - 1.666666666666664e-01*G7_0_0_0_0_1_0 - 1.666666666666664e-01*G7_0_0_0_0_2_1 - 1.666666666666664e-01*G7_0_0_0_0_3_2 + 1.666666666666664e-01*G7_0_1_1_0_0_0 + 1.666666666666664e-01*G7_0_1_1_0_0_1 + 1.666666666666664e-01*G7_0_1_1_0_0_2 - 1.666666666666664e-01*G7_0_1_1_0_1_0 - 1.666666666666664e-01*G7_0_1_1_0_2_1 - 1.666666666666664e-01*G7_0_1_1_0_3_2 + 1.666666666666664e-01*G7_0_2_2_0_0_0 + 1.666666666666664e-01*G7_0_2_2_0_0_1 + 1.666666666666664e-01*G7_0_2_2_0_0_2 - 1.666666666666664e-01*G7_0_2_2_0_1_0 - 1.666666666666664e-01*G7_0_2_2_0_2_1 - 1.666666666666664e-01*G7_0_2_2_0_3_2 + 8.333333333333320e-02*G8_0_0_0_0_0 + 8.333333333333322e-02*G8_0_0_0_0_1 + 8.333333333333320e-02*G8_0_0_0_0_2 - 8.333333333333320e-02*G8_0_0_0_1_0 - 8.333333333333322e-02*G8_0_0_0_2_1 - 8.333333333333322e-02*G8_0_0_0_3_2 + 8.333333333333320e-02*G8_0_1_0_4_0 + 8.333333333333322e-02*G8_0_1_0_4_1 + 8.333333333333322e-02*G8_0_1_0_4_2 - 8.333333333333320e-02*G8_0_1_0_5_0 - 8.333333333333322e-02*G8_0_1_0_6_1 - 8.333333333333322e-02*G8_0_1_0_7_2 + 8.333333333333320e-02*G8_0_2_0_8_0 + 8.333333333333322e-02*G8_0_2_0_8_1 + 8.333333333333322e-02*G8_0_2_0_8_2 - 8.333333333333320e-02*G8_0_2_0_9_0 - 8.333333333333322e-02*G8_0_2_0_10_1 - 8.333333333333322e-02*G8_0_2_0_11_2;
    block[2] = 8.333333333333312e-03*G0_0 + 8.333333333333309e-03*G0_1 + 1.666666666666662e-02*G0_2 + 8.333333333333312e-03*G0_3 + 8.333333333333312e-03*G1_0 + 8.333333333333309e-03*G1_1 + 1.666666666666662e-02*G1_2 + 8.333333333333312e-03*G1_3 + 4.166666666666662e-02*G2_0_1_0 + 4.166666666666662e-02*G2_0_1_1 + 4.166666666666662e-02*G2_0_1_2 + 4.166666666666662e-02*G2_0_1_3 + 4.166666666666662e-02*G3_0_0_1_0 + 4.166666666666661e-02*G3_0_0_1_1 + 4.166666666666662e-02*G3_0_0_1_2 + 4.166666666666662e-02*G3_0_0_1_3 + 4.166666666666662e-02*G3_1_1_1_0 + 4.166666666666661e-02*G3_1_1_1_1 + 4.166666666666662e-02*G3_1_1_1_2 + 4.166666666666662e-02*G3_1_1_1_3 + 4.166666666666662e-02*G3_2_2_1_0 + 4.166666666666661e-02*G3_2_2_1_1 + 4.166666666666662e-02*G3_2_2_1_2 + 4.166666666666662e-02*G3_2_2_1_3 + 8.333333333333322e-02*G4_1_0_0 + 8.333333333333323e-02*G4_1_0_1 + 8.333333333333322e-02*G4_1_0_2 - 8.333333333333322e-02*G4_1_1_0 - 8.333333333333323e-02*G4_1_2_1 - 8.333333333333323e-02*G4_1_3_2 + 2.083333333333330e-02*G5_0_0_0_0 + 2.083333333333331e-02*G5_0_0_0_1 + 2.083333333333330e-02*G5_0_0_0_2 - 2.083333333333330e-02*G5_0_0_1_0 - 2.083333333333331e-02*G5_0_0_2_1 - 2.083333333333331e-02*G5_0_0_3_2 + 2.083333333333330e-02*G5_1_1_0_0 + 2.083333333333331e-02*G5_1_1_0_1 + 2.083333333333330e-02*G5_1_1_0_2 - 2.083333333333330e-02*G5_1_1_1_0 - 2.083333333333331e-02*G5_1_1_2_1 - 2.083333333333331e-02*G5_1_1_3_2 + 2.083333333333330e-02*G5_2_2_0_0 + 2.083333333333331e-02*G5_2_2_0_1 + 2.083333333333330e-02*G5_2_2_0_2 - 2.083333333333330e-02*G5_2_2_1_0 - 2.083333333333331e-02*G5_2_2_2_1 - 2.083333333333331e-02*G5_2_2_3_2 + 8.333333333333322e-02*G6_0_0_0_1_0_0_0 + 8.333333333333323e-02*G6_0_0_0_1_0_0_1 + 8.333333333333322e-02*G6_0_0_0_1_0_0_2 - 8.333333333333322e-02*G6_0_0_0_1_0_1_0 - 8.333333333333323e-02*G6_0_0_0_1_0_2_1 - 8.333333333333323e-02*G6_0_0_0_1_0_3_2 + 8.333333333333322e-02*G6_0_1_0_1_1_0_0 + 8.333333333333323e-02*G6_0_1_0_1_1_0_1 + 8.333333333333322e-02*G6_0_1_0_1_1_0_2 - 8.333333333333322e-02*G6_0_1_0_1_1_1_0 - 8.333333333333323e-02*G6_0_1_0_1_1_2_1 - 8.333333333333323e-02*G6_0_1_0_1_1_3_2 + 8.333333333333322e-02*G6_0_2_0_1_2_0_0 + 8.333333333333323e-02*G6_0_2_0_1_2_0_1 + 8.333333333333322e-02*G6_0_2_0_1_2_0_2 - 8.333333333333322e-02*G6_0_2_0_1_2_1_0 - 8.333333333333323e-02*G6_0_2_0_1_2_2_1 - 8.333333333333323e-02*G6_0_2_0_1_2_3_2 + 8.333333333333322e-02*G6_1_0_1_1_0_0_0 + 8.333333333333323e-02*G6_1_0_1_1_0_0_1 + 8.333333333333322e-02*G6_1_0_1_1_0_0_2 - 8.333333333333322e-02*G6_1_0_1_1_0_1_0 - 8.333333333333323e-02*G6_1_0_1_1_0_2_1 - 8.333333333333323e-02*G6_1_0_1_1_0_3_2 + 8.333333333333322e-02*G6_1_1_1_1_1_0_0 + 8.333333333333323e-02*G6_1_1_1_1_1_0_1 + 8.333333333333322e-02*G6_1_1_1_1_1_0_2 - 8.333333333333322e-02*G6_1_1_1_1_1_1_0 - 8.333333333333323e-02*G6_1_1_1_1_1_2_1 - 8.333333333333323e-02*G6_1_1_1_1_1_3_2 + 8.333333333333322e-02*G6_1_2_1_1_2_0_0 + 8.333333333333323e-02*G6_1_2_1_1_2_0_1 + 8.333333333333322e-02*G6_1_2_1_1_2_0_2 - 8.333333333333322e-02*G6_1_2_1_1_2_1_0 - 8.333333333333323e-02*G6_1_2_1_1_2_2_1 - 8.333333333333323e-02*G6_1_2_1_1_2_3_2 + 8.333333333333322e-02*G6_2_0_2_1_0_0_0 + 8.333333333333323e-02*G6_2_0_2_1_0_0_1 + 8.333333333333322e-02*G6_2_0_2_1_0_0_2 - 8.333333333333322e-02*G6_2_0_2_1_0_1_0 - 8.333333333333323e-02*G6_2_0_2_1_0_2_1 - 8.333333333333323e-02*G6_2_0_2_1_0_3_2 + 8.333333333333322e-02*G6_2_1_2_1_1_0_0 + 8.333333333333323e-02*G6_2_1_2_1_1_0_1 + 8.333333333333322e-02*G6_2_1_2_1_1_0_2 - 8.333333333333322e-02*G6_2_1_2_1_1_1_0 - 8.333333333333323e-02*G6_2_1_2_1_1_2_1 - 8.333333333333323e-02*G6_2_1_2_1_1_3_2 + 8.333333333333322e-02*G6_2_2_2_1_2_0_0 + 8.333333333333323e-02*G6_2_2_2_1_2_0_1 + 8.333333333333322e-02*G6_2_2_2_1_2_0_2 - 8.333333333333322e-02*G6_2_2_2_1_2_1_0 - 8.333333333333323e-02*G6_2_2_2_1_2_2_1 - 8.333333333333323e-02*G6_2_2_2_1_2_3_2 + 1.666666666666664e-01*G7_0_0_0_1_0_0 + 1.666666666666665e-01*G7_0_0_0_1_0_1 + 1.666666666666665e-01*G7_0_0_0_1_0_2 - 1.666666666666664e-01*G7_0_0_0_1_1_0 - 1.666666666666665e-01*G7_0_0_0_1_2_1 - 1.666666666666665e-01*G7_0_0_0_1_3_2 + 1.666666666666664e-01*G7_0_1_1_1_0_0 + 1.666666666666665e-01*G7_0_1_1_1_0_1 + 1.666666666666665e-01*G7_0_1_1_1_0_2 - 1.666666666666664e-01*G7_0_1_1_1_1_0 - 1.666666666666665e-01*G7_0_1_1_1_2_1 - 1.666666666666665e-01*G7_0_1_1_1_3_2 + 1.666666666666664e-01*G7_0_2_2_1_0_0 + 1.666666666666665e-01*G7_0_2_2_1_0_1 + 1.666666666666665e-01*G7_0_2_2_1_0_2 - 1.666666666666664e-01*G7_0_2_2_1_1_0 - 1.666666666666665e-01*G7_0_2_2_1_2_1 - 1.666666666666665e-01*G7_0_2_2_1_3_2 + 8.333333333333322e-02*G8_0_0_1_0_0 + 8.333333333333323e-02*G8_0_0_1_0_1 + 8.333333333333322e-02*G8_0_0_1_0_2 - 8.333333333333322e-02*G8_0_0_1_1_0 - 8.333333333333323e-02*G8_0_0_1_2_1 - 8.333333333333323e-02*G8_0_0_1_3_2 + 8.333333333333322e-02*G8_0_1_1_4_0 + 8.333333333333323e-02*G8_0_1_1_4_1 + 8.333333333333323e-02*G8_0_1_1_4_2 - 8.333333333333322e-02*G8_0_1_1_5_0 - 8.333333333333323e-02*G8_0_1_1_6_1 - 8.333333333333323e-02*G8_0_1_1_7_2 + 8.333333333333322e-02*G8_0_2_1_8_0 + 8.333333333333323e-02*G8_0_2_1_8_1 + 8.333333333333323e-02*G8_0_2_1_8_2 - 8.333333333333322e-02*G8_0_2_1_9_0 - 8.333333333333323e-02*G8_0_2_1_10_1 - 8.333333333333323e-02*G8_0_2_1_11_2;
    block[3] = 8.333333333333314e-03*G0_0 + 8.333333333333311e-03*G0_1 + 8.333333333333312e-03*G0_2 + 1.666666666666662e-02*G0_3 + 8.333333333333314e-03*G1_0 + 8.333333333333311e-03*G1_1 + 8.333333333333312e-03*G1_2 + 1.666666666666662e-02*G1_3 + 4.166666666666662e-02*G2_0_2_0 + 4.166666666666662e-02*G2_0_2_1 + 4.166666666666662e-02*G2_0_2_2 + 4.166666666666662e-02*G2_0_2_3 + 4.166666666666662e-02*G3_0_0_2_0 + 4.166666666666661e-02*G3_0_0_2_1 + 4.166666666666662e-02*G3_0_0_2_2 + 4.166666666666662e-02*G3_0_0_2_3 + 4.166666666666662e-02*G3_1_1_2_0 + 4.166666666666661e-02*G3_1_1_2_1 + 4.166666666666662e-02*G3_1_1_2_2 + 4.166666666666662e-02*G3_1_1_2_3 + 4.166666666666662e-02*G3_2_2_2_0 + 4.166666666666661e-02*G3_2_2_2_1 + 4.166666666666662e-02*G3_2_2_2_2 + 4.166666666666662e-02*G3_2_2_2_3 + 8.333333333333322e-02*G4_2_0_0 + 8.333333333333323e-02*G4_2_0_1 + 8.333333333333322e-02*G4_2_0_2 - 8.333333333333322e-02*G4_2_1_0 - 8.333333333333323e-02*G4_2_2_1 - 8.333333333333323e-02*G4_2_3_2 + 2.083333333333330e-02*G5_0_0_0_0 + 2.083333333333331e-02*G5_0_0_0_1 + 2.083333333333330e-02*G5_0_0_0_2 - 2.083333333333330e-02*G5_0_0_1_0 - 2.083333333333331e-02*G5_0_0_2_1 - 2.083333333333331e-02*G5_0_0_3_2 + 2.083333333333330e-02*G5_1_1_0_0 + 2.083333333333331e-02*G5_1_1_0_1 + 2.083333333333330e-02*G5_1_1_0_2 - 2.083333333333330e-02*G5_1_1_1_0 - 2.083333333333331e-02*G5_1_1_2_1 - 2.083333333333331e-02*G5_1_1_3_2 + 2.083333333333330e-02*G5_2_2_0_0 + 2.083333333333331e-02*G5_2_2_0_1 + 2.083333333333330e-02*G5_2_2_0_2 - 2.083333333333330e-02*G5_2_2_1_0 - 2.083333333333331e-02*G5_2_2_2_1 - 2.083333333333331e-02*G5_2_2_3_2 + 8.333333333333322e-02*G6_0_0_0_2_0_0_0 + 8.333333333333323e-02*G6_0_0_0_2_0_0_1 + 8.333333333333322e-02*G6_0_0_0_2_0_0_2 - 8.333333333333322e-02*G6_0_0_0_2_0_1_0 - 8.333333333333323e-02*G6_0_0_0_2_0_2_1 - 8.333333333333323e-02*G6_0_0_0_2_0_3_2 + 8.333333333333322e-02*G6_0_1_0_2_1_0_0 + 8.333333333333323e-02*G6_0_1_0_2_1_0_1 + 8.333333333333322e-02*G6_0_1_0_2_1_0_2 - 8.333333333333322e-02*G6_0_1_0_2_1_1_0 - 8.333333333333323e-02*G6_0_1_0_2_1_2_1 - 8.333333333333323e-02*G6_0_1_0_2_1_3_2 + 8.333333333333322e-02*G6_0_2_0_2_2_0_0 + 8.333333333333323e-02*G6_0_2_0_2_2_0_1 + 8.333333333333322e-02*G6_0_2_0_2_2_0_2 - 8.333333333333322e-02*G6_0_2_0_2_2_1_0 - 8.333333333333323e-02*G6_0_2_0_2_2_2_1 - 8.333333333333323e-02*G6_0_2_0_2_2_3_2 + 8.333333333333322e-02*G6_1_0_1_2_0_0_0 + 8.333333333333323e-02*G6_1_0_1_2_0_0_1 + 8.333333333333322e-02*G6_1_0_1_2_0_0_2 - 8.333333333333322e-02*G6_1_0_1_2_0_1_0 - 8.333333333333323e-02*G6_1_0_1_2_0_2_1 - 8.333333333333323e-02*G6_1_0_1_2_0_3_2 + 8.333333333333322e-02*G6_1_1_1_2_1_0_0 + 8.333333333333323e-02*G6_1_1_1_2_1_0_1 + 8.333333333333322e-02*G6_1_1_1_2_1_0_2 - 8.333333333333322e-02*G6_1_1_1_2_1_1_0 - 8.333333333333323e-02*G6_1_1_1_2_1_2_1 - 8.333333333333323e-02*G6_1_1_1_2_1_3_2 + 8.333333333333322e-02*G6_1_2_1_2_2_0_0 + 8.333333333333323e-02*G6_1_2_1_2_2_0_1 + 8.333333333333322e-02*G6_1_2_1_2_2_0_2 - 8.333333333333322e-02*G6_1_2_1_2_2_1_0 - 8.333333333333323e-02*G6_1_2_1_2_2_2_1 - 8.333333333333323e-02*G6_1_2_1_2_2_3_2 + 8.333333333333322e-02*G6_2_0_2_2_0_0_0 + 8.333333333333323e-02*G6_2_0_2_2_0_0_1 + 8.333333333333322e-02*G6_2_0_2_2_0_0_2 - 8.333333333333322e-02*G6_2_0_2_2_0_1_0 - 8.333333333333323e-02*G6_2_0_2_2_0_2_1 - 8.333333333333323e-02*G6_2_0_2_2_0_3_2 + 8.333333333333322e-02*G6_2_1_2_2_1_0_0 + 8.333333333333323e-02*G6_2_1_2_2_1_0_1 + 8.333333333333322e-02*G6_2_1_2_2_1_0_2 - 8.333333333333322e-02*G6_2_1_2_2_1_1_0 - 8.333333333333323e-02*G6_2_1_2_2_1_2_1 - 8.333333333333323e-02*G6_2_1_2_2_1_3_2 + 8.333333333333322e-02*G6_2_2_2_2_2_0_0 + 8.333333333333323e-02*G6_2_2_2_2_2_0_1 + 8.333333333333322e-02*G6_2_2_2_2_2_0_2 - 8.333333333333322e-02*G6_2_2_2_2_2_1_0 - 8.333333333333323e-02*G6_2_2_2_2_2_2_1 - 8.333333333333323e-02*G6_2_2_2_2_2_3_2 + 1.666666666666664e-01*G7_0_0_0_2_0_0 + 1.666666666666665e-01*G7_0_0_0_2_0_1 + 1.666666666666665e-01*G7_0_0_0_2_0_2 - 1.666666666666664e-01*G7_0_0_0_2_1_0 - 1.666666666666665e-01*G7_0_0_0_2_2_1 - 1.666666666666665e-01*G7_0_0_0_2_3_2 + 1.666666666666664e-01*G7_0_1_1_2_0_0 + 1.666666666666665e-01*G7_0_1_1_2_0_1 + 1.666666666666665e-01*G7_0_1_1_2_0_2 - 1.666666666666664e-01*G7_0_1_1_2_1_0 - 1.666666666666665e-01*G7_0_1_1_2_2_1 - 1.666666666666665e-01*G7_0_1_1_2_3_2 + 1.666666666666664e-01*G7_0_2_2_2_0_0 + 1.666666666666665e-01*G7_0_2_2_2_0_1 + 1.666666666666665e-01*G7_0_2_2_2_0_2 - 1.666666666666664e-01*G7_0_2_2_2_1_0 - 1.666666666666665e-01*G7_0_2_2_2_2_1 - 1.666666666666665e-01*G7_0_2_2_2_3_2 + 8.333333333333322e-02*G8_0_0_2_0_0 + 8.333333333333323e-02*G8_0_0_2_0_1 + 8.333333333333322e-02*G8_0_0_2_0_2 - 8.333333333333322e-02*G8_0_0_2_1_0 - 8.333333333333323e-02*G8_0_0_2_2_1 - 8.333333333333323e-02*G8_0_0_2_3_2 + 8.333333333333322e-02*G8_0_1_2_4_0 + 8.333333333333323e-02*G8_0_1_2_4_1 + 8.333333333333323e-02*G8_0_1_2_4_2 - 8.333333333333322e-02*G8_0_1_2_5_0 - 8.333333333333323e-02*G8_0_1_2_6_1 - 8.333333333333323e-02*G8_0_1_2_7_2 + 8.333333333333322e-02*G8_0_2_2_8_0 + 8.333333333333323e-02*G8_0_2_2_8_1 + 8.333333333333323e-02*G8_0_2_2_8_2 - 8.333333333333322e-02*G8_0_2_2_9_0 - 8.333333333333323e-02*G8_0_2_2_10_1 - 8.333333333333323e-02*G8_0_2_2_11_2;
    block[4] = 1.666666666666662e-02*G0_4 + 8.333333333333309e-03*G0_5 + 8.333333333333309e-03*G0_6 + 8.333333333333314e-03*G0_7 + 1.666666666666662e-02*G1_4 + 8.333333333333309e-03*G1_5 + 8.333333333333309e-03*G1_6 + 8.333333333333314e-03*G1_7 - 4.166666666666661e-02*G2_1_0_0 - 4.166666666666661e-02*G2_1_0_1 - 4.166666666666661e-02*G2_1_0_2 - 4.166666666666661e-02*G2_1_0_3 - 4.166666666666662e-02*G2_1_1_0 - 4.166666666666662e-02*G2_1_1_1 - 4.166666666666662e-02*G2_1_1_2 - 4.166666666666662e-02*G2_1_1_3 - 4.166666666666662e-02*G2_1_2_0 - 4.166666666666662e-02*G2_1_2_1 - 4.166666666666662e-02*G2_1_2_2 - 4.166666666666662e-02*G2_1_2_3 - 4.166666666666661e-02*G3_0_0_0_4 - 4.166666666666661e-02*G3_0_0_0_5 - 4.166666666666661e-02*G3_0_0_0_6 - 4.166666666666661e-02*G3_0_0_0_7 - 4.166666666666662e-02*G3_0_0_1_4 - 4.166666666666662e-02*G3_0_0_1_5 - 4.166666666666662e-02*G3_0_0_1_6 - 4.166666666666662e-02*G3_0_0_1_7 - 4.166666666666662e-02*G3_0_0_2_4 - 4.166666666666662e-02*G3_0_0_2_5 - 4.166666666666662e-02*G3_0_0_2_6 - 4.166666666666662e-02*G3_0_0_2_7 - 4.166666666666661e-02*G3_1_1_0_4 - 4.166666666666661e-02*G3_1_1_0_5 - 4.166666666666661e-02*G3_1_1_0_6 - 4.166666666666661e-02*G3_1_1_0_7 - 4.166666666666662e-02*G3_1_1_1_4 - 4.166666666666662e-02*G3_1_1_1_5 - 4.166666666666662e-02*G3_1_1_1_6 - 4.166666666666662e-02*G3_1_1_1_7 - 4.166666666666662e-02*G3_1_1_2_4 - 4.166666666666662e-02*G3_1_1_2_5 - 4.166666666666662e-02*G3_1_1_2_6 - 4.166666666666662e-02*G3_1_1_2_7 - 4.166666666666661e-02*G3_2_2_0_4 - 4.166666666666661e-02*G3_2_2_0_5 - 4.166666666666661e-02*G3_2_2_0_6 - 4.166666666666661e-02*G3_2_2_0_7 - 4.166666666666662e-02*G3_2_2_1_4 - 4.166666666666662e-02*G3_2_2_1_5 - 4.166666666666662e-02*G3_2_2_1_6 - 4.166666666666662e-02*G3_2_2_1_7 - 4.166666666666662e-02*G3_2_2_2_4 - 4.166666666666662e-02*G3_2_2_2_5 - 4.166666666666662e-02*G3_2_2_2_6 - 4.166666666666662e-02*G3_2_2_2_7 - 8.333333333333320e-02*G4_0_4_0 - 8.333333333333322e-02*G4_0_4_1 - 8.333333333333322e-02*G4_0_4_2 + 8.333333333333320e-02*G4_0_5_0 + 8.333333333333322e-02*G4_0_6_1 + 8.333333333333322e-02*G4_0_7_2 - 8.333333333333322e-02*G4_1_4_0 - 8.333333333333323e-02*G4_1_4_1 - 8.333333333333323e-02*G4_1_4_2 + 8.333333333333322e-02*G4_1_5_0 + 8.333333333333323e-02*G4_1_6_1 + 8.333333333333323e-02*G4_1_7_2 - 8.333333333333322e-02*G4_2_4_0 - 8.333333333333323e-02*G4_2_4_1 - 8.333333333333323e-02*G4_2_4_2 + 8.333333333333322e-02*G4_2_5_0 + 8.333333333333323e-02*G4_2_6_1 + 8.333333333333323e-02*G4_2_7_2 + 2.083333333333330e-02*G5_0_0_4_0 + 2.083333333333331e-02*G5_0_0_4_1 + 2.083333333333331e-02*G5_0_0_4_2 - 2.083333333333330e-02*G5_0_0_5_0 - 2.083333333333331e-02*G5_0_0_6_1 - 2.083333333333331e-02*G5_0_0_7_2 + 2.083333333333330e-02*G5_1_1_4_0 + 2.083333333333331e-02*G5_1_1_4_1 + 2.083333333333331e-02*G5_1_1_4_2 - 2.083333333333330e-02*G5_1_1_5_0 - 2.083333333333331e-02*G5_1_1_6_1 - 2.083333333333331e-02*G5_1_1_7_2 + 2.083333333333330e-02*G5_2_2_4_0 + 2.083333333333331e-02*G5_2_2_4_1 + 2.083333333333331e-02*G5_2_2_4_2 - 2.083333333333330e-02*G5_2_2_5_0 - 2.083333333333331e-02*G5_2_2_6_1 - 2.083333333333331e-02*G5_2_2_7_2 - 8.333333333333320e-02*G6_0_0_0_0_0_4_0 - 8.333333333333322e-02*G6_0_0_0_0_0_4_1 - 8.333333333333322e-02*G6_0_0_0_0_0_4_2 + 8.333333333333320e-02*G6_0_0_0_0_0_5_0 + 8.333333333333322e-02*G6_0_0_0_0_0_6_1 + 8.333333333333322e-02*G6_0_0_0_0_0_7_2 - 8.333333333333322e-02*G6_0_0_0_1_0_4_0 - 8.333333333333323e-02*G6_0_0_0_1_0_4_1 - 8.333333333333323e-02*G6_0_0_0_1_0_4_2 + 8.333333333333322e-02*G6_0_0_0_1_0_5_0 + 8.333333333333323e-02*G6_0_0_0_1_0_6_1 + 8.333333333333323e-02*G6_0_0_0_1_0_7_2 - 8.333333333333322e-02*G6_0_0_0_2_0_4_0 - 8.333333333333323e-02*G6_0_0_0_2_0_4_1 - 8.333333333333323e-02*G6_0_0_0_2_0_4_2 + 8.333333333333322e-02*G6_0_0_0_2_0_5_0 + 8.333333333333323e-02*G6_0_0_0_2_0_6_1 + 8.333333333333323e-02*G6_0_0_0_2_0_7_2 - 8.333333333333320e-02*G6_0_1_0_0_1_4_0 - 8.333333333333322e-02*G6_0_1_0_0_1_4_1 - 8.333333333333322e-02*G6_0_1_0_0_1_4_2 + 8.333333333333320e-02*G6_0_1_0_0_1_5_0 + 8.333333333333322e-02*G6_0_1_0_0_1_6_1 + 8.333333333333322e-02*G6_0_1_0_0_1_7_2 - 8.333333333333322e-02*G6_0_1_0_1_1_4_0 - 8.333333333333323e-02*G6_0_1_0_1_1_4_1 - 8.333333333333323e-02*G6_0_1_0_1_1_4_2 + 8.333333333333322e-02*G6_0_1_0_1_1_5_0 + 8.333333333333323e-02*G6_0_1_0_1_1_6_1 + 8.333333333333323e-02*G6_0_1_0_1_1_7_2 - 8.333333333333322e-02*G6_0_1_0_2_1_4_0 - 8.333333333333323e-02*G6_0_1_0_2_1_4_1 - 8.333333333333323e-02*G6_0_1_0_2_1_4_2 + 8.333333333333322e-02*G6_0_1_0_2_1_5_0 + 8.333333333333323e-02*G6_0_1_0_2_1_6_1 + 8.333333333333323e-02*G6_0_1_0_2_1_7_2 - 8.333333333333320e-02*G6_0_2_0_0_2_4_0 - 8.333333333333322e-02*G6_0_2_0_0_2_4_1 - 8.333333333333322e-02*G6_0_2_0_0_2_4_2 + 8.333333333333320e-02*G6_0_2_0_0_2_5_0 + 8.333333333333322e-02*G6_0_2_0_0_2_6_1 + 8.333333333333322e-02*G6_0_2_0_0_2_7_2 - 8.333333333333322e-02*G6_0_2_0_1_2_4_0 - 8.333333333333323e-02*G6_0_2_0_1_2_4_1 - 8.333333333333323e-02*G6_0_2_0_1_2_4_2 + 8.333333333333322e-02*G6_0_2_0_1_2_5_0 + 8.333333333333323e-02*G6_0_2_0_1_2_6_1 + 8.333333333333323e-02*G6_0_2_0_1_2_7_2 - 8.333333333333322e-02*G6_0_2_0_2_2_4_0 - 8.333333333333323e-02*G6_0_2_0_2_2_4_1 - 8.333333333333323e-02*G6_0_2_0_2_2_4_2 + 8.333333333333322e-02*G6_0_2_0_2_2_5_0 + 8.333333333333323e-02*G6_0_2_0_2_2_6_1 + 8.333333333333323e-02*G6_0_2_0_2_2_7_2 - 8.333333333333320e-02*G6_1_0_1_0_0_4_0 - 8.333333333333322e-02*G6_1_0_1_0_0_4_1 - 8.333333333333322e-02*G6_1_0_1_0_0_4_2 + 8.333333333333320e-02*G6_1_0_1_0_0_5_0 + 8.333333333333322e-02*G6_1_0_1_0_0_6_1 + 8.333333333333322e-02*G6_1_0_1_0_0_7_2 - 8.333333333333322e-02*G6_1_0_1_1_0_4_0 - 8.333333333333323e-02*G6_1_0_1_1_0_4_1 - 8.333333333333323e-02*G6_1_0_1_1_0_4_2 + 8.333333333333322e-02*G6_1_0_1_1_0_5_0 + 8.333333333333323e-02*G6_1_0_1_1_0_6_1 + 8.333333333333323e-02*G6_1_0_1_1_0_7_2 - 8.333333333333322e-02*G6_1_0_1_2_0_4_0 - 8.333333333333323e-02*G6_1_0_1_2_0_4_1 - 8.333333333333323e-02*G6_1_0_1_2_0_4_2 + 8.333333333333322e-02*G6_1_0_1_2_0_5_0 + 8.333333333333323e-02*G6_1_0_1_2_0_6_1 + 8.333333333333323e-02*G6_1_0_1_2_0_7_2 - 8.333333333333320e-02*G6_1_1_1_0_1_4_0 - 8.333333333333322e-02*G6_1_1_1_0_1_4_1 - 8.333333333333322e-02*G6_1_1_1_0_1_4_2 + 8.333333333333320e-02*G6_1_1_1_0_1_5_0 + 8.333333333333322e-02*G6_1_1_1_0_1_6_1 + 8.333333333333322e-02*G6_1_1_1_0_1_7_2 - 8.333333333333322e-02*G6_1_1_1_1_1_4_0 - 8.333333333333323e-02*G6_1_1_1_1_1_4_1 - 8.333333333333323e-02*G6_1_1_1_1_1_4_2 + 8.333333333333322e-02*G6_1_1_1_1_1_5_0 + 8.333333333333323e-02*G6_1_1_1_1_1_6_1 + 8.333333333333323e-02*G6_1_1_1_1_1_7_2 - 8.333333333333322e-02*G6_1_1_1_2_1_4_0 - 8.333333333333323e-02*G6_1_1_1_2_1_4_1 - 8.333333333333323e-02*G6_1_1_1_2_1_4_2 + 8.333333333333322e-02*G6_1_1_1_2_1_5_0 + 8.333333333333323e-02*G6_1_1_1_2_1_6_1 + 8.333333333333323e-02*G6_1_1_1_2_1_7_2 - 8.333333333333320e-02*G6_1_2_1_0_2_4_0 - 8.333333333333322e-02*G6_1_2_1_0_2_4_1 - 8.333333333333322e-02*G6_1_2_1_0_2_4_2 + 8.333333333333320e-02*G6_1_2_1_0_2_5_0 + 8.333333333333322e-02*G6_1_2_1_0_2_6_1 + 8.333333333333322e-02*G6_1_2_1_0_2_7_2 - 8.333333333333322e-02*G6_1_2_1_1_2_4_0 - 8.333333333333323e-02*G6_1_2_1_1_2_4_1 - 8.333333333333323e-02*G6_1_2_1_1_2_4_2 + 8.333333333333322e-02*G6_1_2_1_1_2_5_0 + 8.333333333333323e-02*G6_1_2_1_1_2_6_1 + 8.333333333333323e-02*G6_1_2_1_1_2_7_2 - 8.333333333333322e-02*G6_1_2_1_2_2_4_0 - 8.333333333333323e-02*G6_1_2_1_2_2_4_1 - 8.333333333333323e-02*G6_1_2_1_2_2_4_2 + 8.333333333333322e-02*G6_1_2_1_2_2_5_0 + 8.333333333333323e-02*G6_1_2_1_2_2_6_1 + 8.333333333333323e-02*G6_1_2_1_2_2_7_2 - 8.333333333333320e-02*G6_2_0_2_0_0_4_0 - 8.333333333333322e-02*G6_2_0_2_0_0_4_1 - 8.333333333333322e-02*G6_2_0_2_0_0_4_2 + 8.333333333333320e-02*G6_2_0_2_0_0_5_0 + 8.333333333333322e-02*G6_2_0_2_0_0_6_1 + 8.333333333333322e-02*G6_2_0_2_0_0_7_2 - 8.333333333333322e-02*G6_2_0_2_1_0_4_0 - 8.333333333333323e-02*G6_2_0_2_1_0_4_1 - 8.333333333333323e-02*G6_2_0_2_1_0_4_2 + 8.333333333333322e-02*G6_2_0_2_1_0_5_0 + 8.333333333333323e-02*G6_2_0_2_1_0_6_1 + 8.333333333333323e-02*G6_2_0_2_1_0_7_2 - 8.333333333333322e-02*G6_2_0_2_2_0_4_0 - 8.333333333333323e-02*G6_2_0_2_2_0_4_1 - 8.333333333333323e-02*G6_2_0_2_2_0_4_2 + 8.333333333333322e-02*G6_2_0_2_2_0_5_0 + 8.333333333333323e-02*G6_2_0_2_2_0_6_1 + 8.333333333333323e-02*G6_2_0_2_2_0_7_2 - 8.333333333333320e-02*G6_2_1_2_0_1_4_0 - 8.333333333333322e-02*G6_2_1_2_0_1_4_1 - 8.333333333333322e-02*G6_2_1_2_0_1_4_2 + 8.333333333333320e-02*G6_2_1_2_0_1_5_0 + 8.333333333333322e-02*G6_2_1_2_0_1_6_1 + 8.333333333333322e-02*G6_2_1_2_0_1_7_2 - 8.333333333333322e-02*G6_2_1_2_1_1_4_0 - 8.333333333333323e-02*G6_2_1_2_1_1_4_1 - 8.333333333333323e-02*G6_2_1_2_1_1_4_2 + 8.333333333333322e-02*G6_2_1_2_1_1_5_0 + 8.333333333333323e-02*G6_2_1_2_1_1_6_1 + 8.333333333333323e-02*G6_2_1_2_1_1_7_2 - 8.333333333333322e-02*G6_2_1_2_2_1_4_0 - 8.333333333333323e-02*G6_2_1_2_2_1_4_1 - 8.333333333333323e-02*G6_2_1_2_2_1_4_2 + 8.333333333333322e-02*G6_2_1_2_2_1_5_0 + 8.333333333333323e-02*G6_2_1_2_2_1_6_1 + 8.333333333333323e-02*G6_2_1_2_2_1_7_2 - 8.333333333333320e-02*G6_2_2_2_0_2_4_0 - 8.333333333333322e-02*G6_2_2_2_0_2_4_1 - 8.333333333333322e-02*G6_2_2_2_0_2_4_2 + 8.333333333333320e-02*G6_2_2_2_0_2_5_0 + 8.333333333333322e-02*G6_2_2_2_0_2_6_1 + 8.333333333333322e-02*G6_2_2_2_0_2_7_2 - 8.333333333333322e-02*G6_2_2_2_1_2_4_0 - 8.333333333333323e-02*G6_2_2_2_1_2_4_1 - 8.333333333333323e-02*G6_2_2_2_1_2_4_2 + 8.333333333333322e-02*G6_2_2_2_1_2_5_0 + 8.333333333333323e-02*G6_2_2_2_1_2_6_1 + 8.333333333333323e-02*G6_2_2_2_1_2_7_2 - 8.333333333333322e-02*G6_2_2_2_2_2_4_0 - 8.333333333333323e-02*G6_2_2_2_2_2_4_1 - 8.333333333333323e-02*G6_2_2_2_2_2_4_2 + 8.333333333333322e-02*G6_2_2_2_2_2_5_0 + 8.333333333333323e-02*G6_2_2_2_2_2_6_1 + 8.333333333333323e-02*G6_2_2_2_2_2_7_2 - 1.666666666666664e-01*G7_1_0_0_0_0_0 - 1.666666666666664e-01*G7_1_0_0_0_0_1 - 1.666666666666664e-01*G7_1_0_0_0_0_2 + 1.666666666666664e-01*G7_1_0_0_0_1_0 + 1.666666666666664e-01*G7_1_0_0_0_2_1 + 1.666666666666664e-01*G7_1_0_0_0_3_2 - 1.666666666666664e-01*G7_1_0_0_1_0_0 - 1.666666666666665e-01*G7_1_0_0_1_0_1 - 1.666666666666665e-01*G7_1_0_0_1_0_2 + 1.666666666666664e-01*G7_1_0_0_1_1_0 + 1.666666666666665e-01*G7_1_0_0_1_2_1 + 1.666666666666665e-01*G7_1_0_0_1_3_2 - 1.666666666666664e-01*G7_1_0_0_2_0_0 - 1.666666666666665e-01*G7_1_0_0_2_0_1 - 1.666666666666665e-01*G7_1_0_0_2_0_2 + 1.666666666666664e-01*G7_1_0_0_2_1_0 + 1.666666666666665e-01*G7_1_0_0_2_2_1 + 1.666666666666665e-01*G7_1_0_0_2_3_2 - 1.666666666666664e-01*G7_1_1_1_0_0_0 - 1.666666666666664e-01*G7_1_1_1_0_0_1 - 1.666666666666664e-01*G7_1_1_1_0_0_2 + 1.666666666666664e-01*G7_1_1_1_0_1_0 + 1.666666666666664e-01*G7_1_1_1_0_2_1 + 1.666666666666664e-01*G7_1_1_1_0_3_2 - 1.666666666666664e-01*G7_1_1_1_1_0_0 - 1.666666666666665e-01*G7_1_1_1_1_0_1 - 1.666666666666665e-01*G7_1_1_1_1_0_2 + 1.666666666666664e-01*G7_1_1_1_1_1_0 + 1.666666666666665e-01*G7_1_1_1_1_2_1 + 1.666666666666665e-01*G7_1_1_1_1_3_2 - 1.666666666666664e-01*G7_1_1_1_2_0_0 - 1.666666666666665e-01*G7_1_1_1_2_0_1 - 1.666666666666665e-01*G7_1_1_1_2_0_2 + 1.666666666666664e-01*G7_1_1_1_2_1_0 + 1.666666666666665e-01*G7_1_1_1_2_2_1 + 1.666666666666665e-01*G7_1_1_1_2_3_2 - 1.666666666666664e-01*G7_1_2_2_0_0_0 - 1.666666666666664e-01*G7_1_2_2_0_0_1 - 1.666666666666664e-01*G7_1_2_2_0_0_2 + 1.666666666666664e-01*G7_1_2_2_0_1_0 + 1.666666666666664e-01*G7_1_2_2_0_2_1 + 1.666666666666664e-01*G7_1_2_2_0_3_2 - 1.666666666666664e-01*G7_1_2_2_1_0_0 - 1.666666666666665e-01*G7_1_2_2_1_0_1 - 1.666666666666665e-01*G7_1_2_2_1_0_2 + 1.666666666666664e-01*G7_1_2_2_1_1_0 + 1.666666666666665e-01*G7_1_2_2_1_2_1 + 1.666666666666665e-01*G7_1_2_2_1_3_2 - 1.666666666666664e-01*G7_1_2_2_2_0_0 - 1.666666666666665e-01*G7_1_2_2_2_0_1 - 1.666666666666665e-01*G7_1_2_2_2_0_2 + 1.666666666666664e-01*G7_1_2_2_2_1_0 + 1.666666666666665e-01*G7_1_2_2_2_2_1 + 1.666666666666665e-01*G7_1_2_2_2_3_2 - 8.333333333333320e-02*G8_1_0_0_0_0 - 8.333333333333322e-02*G8_1_0_0_0_1 - 8.333333333333320e-02*G8_1_0_0_0_2 + 8.333333333333320e-02*G8_1_0_0_1_0 + 8.333333333333322e-02*G8_1_0_0_2_1 + 8.333333333333322e-02*G8_1_0_0_3_2 - 8.333333333333322e-02*G8_1_0_1_0_0 - 8.333333333333323e-02*G8_1_0_1_0_1 - 8.333333333333322e-02*G8_1_0_1_0_2 + 8.333333333333322e-02*G8_1_0_1_1_0 + 8.333333333333323e-02*G8_1_0_1_2_1 + 8.333333333333323e-02*G8_1_0_1_3_2 - 8.333333333333322e-02*G8_1_0_2_0_0 - 8.333333333333323e-02*G8_1_0_2_0_1 - 8.333333333333322e-02*G8_1_0_2_0_2 + 8.333333333333322e-02*G8_1_0_2_1_0 + 8.333333333333323e-02*G8_1_0_2_2_1 + 8.333333333333323e-02*G8_1_0_2_3_2 - 8.333333333333320e-02*G8_1_1_0_4_0 - 8.333333333333322e-02*G8_1_1_0_4_1 - 8.333333333333322e-02*G8_1_1_0_4_2 + 8.333333333333320e-02*G8_1_1_0_5_0 + 8.333333333333322e-02*G8_1_1_0_6_1 + 8.333333333333322e-02*G8_1_1_0_7_2 - 8.333333333333322e-02*G8_1_1_1_4_0 - 8.333333333333323e-02*G8_1_1_1_4_1 - 8.333333333333323e-02*G8_1_1_1_4_2 + 8.333333333333322e-02*G8_1_1_1_5_0 + 8.333333333333323e-02*G8_1_1_1_6_1 + 8.333333333333323e-02*G8_1_1_1_7_2 - 8.333333333333322e-02*G8_1_1_2_4_0 - 8.333333333333323e-02*G8_1_1_2_4_1 - 8.333333333333323e-02*G8_1_1_2_4_2 + 8.333333333333322e-02*G8_1_1_2_5_0 + 8.333333333333323e-02*G8_1_1_2_6_1 + 8.333333333333323e-02*G8_1_1_2_7_2 - 8.333333333333320e-02*G8_1_2_0_8_0 - 8.333333333333322e-02*G8_1_2_0_8_1 - 8.333333333333322e-02*G8_1_2_0_8_2 + 8.333333333333320e-02*G8_1_2_0_9_0 + 8.333333333333322e-02*G8_1_2_0_10_1 + 8.333333333333322e-02*G8_1_2_0_11_2 - 8.333333333333322e-02*G8_1_2_1_8_0 - 8.333333333333323e-02*G8_1_2_1_8_1 - 8.333333333333323e-02*G8_1_2_1_8_2 + 8.333333333333322e-02*G8_1_2_1_9_0 + 8.333333333333323e-02*G8_1_2_1_10_1 + 8.333333333333323e-02*G8_1_2_1_11_2 - 8.333333333333322e-02*G8_1_2_2_8_0 - 8.333333333333323e-02*G8_1_2_2_8_1 - 8.333333333333323e-02*G8_1_2_2_8_2 + 8.333333333333322e-02*G8_1_2_2_9_0 + 8.333333333333323e-02*G8_1_2_2_10_1 + 8.333333333333323e-02*G8_1_2_2_11_2;
    block[5] = 8.333333333333309e-03*G0_4 + 1.666666666666662e-02*G0_5 + 8.333333333333312e-03*G0_6 + 8.333333333333314e-03*G0_7 + 8.333333333333309e-03*G1_4 + 1.666666666666662e-02*G1_5 + 8.333333333333312e-03*G1_6 + 8.333333333333314e-03*G1_7 + 4.166666666666661e-02*G2_1_0_0 + 4.166666666666661e-02*G2_1_0_1 + 4.166666666666661e-02*G2_1_0_2 + 4.166666666666661e-02*G2_1_0_3 + 4.166666666666661e-02*G3_0_0_0_4 + 4.166666666666661e-02*G3_0_0_0_5 + 4.166666666666661e-02*G3_0_0_0_6 + 4.166666666666661e-02*G3_0_0_0_7 + 4.166666666666661e-02*G3_1_1_0_4 + 4.166666666666661e-02*G3_1_1_0_5 + 4.166666666666661e-02*G3_1_1_0_6 + 4.166666666666661e-02*G3_1_1_0_7 + 4.166666666666661e-02*G3_2_2_0_4 + 4.166666666666661e-02*G3_2_2_0_5 + 4.166666666666661e-02*G3_2_2_0_6 + 4.166666666666661e-02*G3_2_2_0_7 + 8.333333333333320e-02*G4_0_4_0 + 8.333333333333322e-02*G4_0_4_1 + 8.333333333333322e-02*G4_0_4_2 - 8.333333333333320e-02*G4_0_5_0 - 8.333333333333322e-02*G4_0_6_1 - 8.333333333333322e-02*G4_0_7_2 + 2.083333333333330e-02*G5_0_0_4_0 + 2.083333333333331e-02*G5_0_0_4_1 + 2.083333333333331e-02*G5_0_0_4_2 - 2.083333333333330e-02*G5_0_0_5_0 - 2.083333333333331e-02*G5_0_0_6_1 - 2.083333333333331e-02*G5_0_0_7_2 + 2.083333333333330e-02*G5_1_1_4_0 + 2.083333333333331e-02*G5_1_1_4_1 + 2.083333333333331e-02*G5_1_1_4_2 - 2.083333333333330e-02*G5_1_1_5_0 - 2.083333333333331e-02*G5_1_1_6_1 - 2.083333333333331e-02*G5_1_1_7_2 + 2.083333333333330e-02*G5_2_2_4_0 + 2.083333333333331e-02*G5_2_2_4_1 + 2.083333333333331e-02*G5_2_2_4_2 - 2.083333333333330e-02*G5_2_2_5_0 - 2.083333333333331e-02*G5_2_2_6_1 - 2.083333333333331e-02*G5_2_2_7_2 + 8.333333333333320e-02*G6_0_0_0_0_0_4_0 + 8.333333333333322e-02*G6_0_0_0_0_0_4_1 + 8.333333333333322e-02*G6_0_0_0_0_0_4_2 - 8.333333333333320e-02*G6_0_0_0_0_0_5_0 - 8.333333333333322e-02*G6_0_0_0_0_0_6_1 - 8.333333333333322e-02*G6_0_0_0_0_0_7_2 + 8.333333333333320e-02*G6_0_1_0_0_1_4_0 + 8.333333333333322e-02*G6_0_1_0_0_1_4_1 + 8.333333333333322e-02*G6_0_1_0_0_1_4_2 - 8.333333333333320e-02*G6_0_1_0_0_1_5_0 - 8.333333333333322e-02*G6_0_1_0_0_1_6_1 - 8.333333333333322e-02*G6_0_1_0_0_1_7_2 + 8.333333333333320e-02*G6_0_2_0_0_2_4_0 + 8.333333333333322e-02*G6_0_2_0_0_2_4_1 + 8.333333333333322e-02*G6_0_2_0_0_2_4_2 - 8.333333333333320e-02*G6_0_2_0_0_2_5_0 - 8.333333333333322e-02*G6_0_2_0_0_2_6_1 - 8.333333333333322e-02*G6_0_2_0_0_2_7_2 + 8.333333333333320e-02*G6_1_0_1_0_0_4_0 + 8.333333333333322e-02*G6_1_0_1_0_0_4_1 + 8.333333333333322e-02*G6_1_0_1_0_0_4_2 - 8.333333333333320e-02*G6_1_0_1_0_0_5_0 - 8.333333333333322e-02*G6_1_0_1_0_0_6_1 - 8.333333333333322e-02*G6_1_0_1_0_0_7_2 + 8.333333333333320e-02*G6_1_1_1_0_1_4_0 + 8.333333333333322e-02*G6_1_1_1_0_1_4_1 + 8.333333333333322e-02*G6_1_1_1_0_1_4_2 - 8.333333333333320e-02*G6_1_1_1_0_1_5_0 - 8.333333333333322e-02*G6_1_1_1_0_1_6_1 - 8.333333333333322e-02*G6_1_1_1_0_1_7_2 + 8.333333333333320e-02*G6_1_2_1_0_2_4_0 + 8.333333333333322e-02*G6_1_2_1_0_2_4_1 + 8.333333333333322e-02*G6_1_2_1_0_2_4_2 - 8.333333333333320e-02*G6_1_2_1_0_2_5_0 - 8.333333333333322e-02*G6_1_2_1_0_2_6_1 - 8.333333333333322e-02*G6_1_2_1_0_2_7_2 + 8.333333333333320e-02*G6_2_0_2_0_0_4_0 + 8.333333333333322e-02*G6_2_0_2_0_0_4_1 + 8.333333333333322e-02*G6_2_0_2_0_0_4_2 - 8.333333333333320e-02*G6_2_0_2_0_0_5_0 - 8.333333333333322e-02*G6_2_0_2_0_0_6_1 - 8.333333333333322e-02*G6_2_0_2_0_0_7_2 + 8.333333333333320e-02*G6_2_1_2_0_1_4_0 + 8.333333333333322e-02*G6_2_1_2_0_1_4_1 + 8.333333333333322e-02*G6_2_1_2_0_1_4_2 - 8.333333333333320e-02*G6_2_1_2_0_1_5_0 - 8.333333333333322e-02*G6_2_1_2_0_1_6_1 - 8.333333333333322e-02*G6_2_1_2_0_1_7_2 + 8.333333333333320e-02*G6_2_2_2_0_2_4_0 + 8.333333333333322e-02*G6_2_2_2_0_2_4_1 + 8.333333333333322e-02*G6_2_2_2_0_2_4_2 - 8.333333333333320e-02*G6_2_2_2_0_2_5_0 - 8.333333333333322e-02*G6_2_2_2_0_2_6_1 - 8.333333333333322e-02*G6_2_2_2_0_2_7_2 + 1.666666666666664e-01*G7_1_0_0_0_0_0 + 1.666666666666664e-01*G7_1_0_0_0_0_1 + 1.666666666666664e-01*G7_1_0_0_0_0_2 - 1.666666666666664e-01*G7_1_0_0_0_1_0 - 1.666666666666664e-01*G7_1_0_0_0_2_1 - 1.666666666666664e-01*G7_1_0_0_0_3_2 + 1.666666666666664e-01*G7_1_1_1_0_0_0 + 1.666666666666664e-01*G7_1_1_1_0_0_1 + 1.666666666666664e-01*G7_1_1_1_0_0_2 - 1.666666666666664e-01*G7_1_1_1_0_1_0 - 1.666666666666664e-01*G7_1_1_1_0_2_1 - 1.666666666666664e-01*G7_1_1_1_0_3_2 + 1.666666666666664e-01*G7_1_2_2_0_0_0 + 1.666666666666664e-01*G7_1_2_2_0_0_1 + 1.666666666666664e-01*G7_1_2_2_0_0_2 - 1.666666666666664e-01*G7_1_2_2_0_1_0 - 1.666666666666664e-01*G7_1_2_2_0_2_1 - 1.666666666666664e-01*G7_1_2_2_0_3_2 + 8.333333333333320e-02*G8_1_0_0_0_0 + 8.333333333333322e-02*G8_1_0_0_0_1 + 8.333333333333320e-02*G8_1_0_0_0_2 - 8.333333333333320e-02*G8_1_0_0_1_0 - 8.333333333333322e-02*G8_1_0_0_2_1 - 8.333333333333322e-02*G8_1_0_0_3_2 + 8.333333333333320e-02*G8_1_1_0_4_0 + 8.333333333333322e-02*G8_1_1_0_4_1 + 8.333333333333322e-02*G8_1_1_0_4_2 - 8.333333333333320e-02*G8_1_1_0_5_0 - 8.333333333333322e-02*G8_1_1_0_6_1 - 8.333333333333322e-02*G8_1_1_0_7_2 + 8.333333333333320e-02*G8_1_2_0_8_0 + 8.333333333333322e-02*G8_1_2_0_8_1 + 8.333333333333322e-02*G8_1_2_0_8_2 - 8.333333333333320e-02*G8_1_2_0_9_0 - 8.333333333333322e-02*G8_1_2_0_10_1 - 8.333333333333322e-02*G8_1_2_0_11_2;
    block[6] = 8.333333333333307e-03*G0_4 + 8.333333333333312e-03*G0_5 + 1.666666666666662e-02*G0_6 + 8.333333333333312e-03*G0_7 + 8.333333333333307e-03*G1_4 + 8.333333333333312e-03*G1_5 + 1.666666666666662e-02*G1_6 + 8.333333333333312e-03*G1_7 + 4.166666666666662e-02*G2_1_1_0 + 4.166666666666662e-02*G2_1_1_1 + 4.166666666666662e-02*G2_1_1_2 + 4.166666666666662e-02*G2_1_1_3 + 4.166666666666662e-02*G3_0_0_1_4 + 4.166666666666662e-02*G3_0_0_1_5 + 4.166666666666662e-02*G3_0_0_1_6 + 4.166666666666662e-02*G3_0_0_1_7 + 4.166666666666662e-02*G3_1_1_1_4 + 4.166666666666662e-02*G3_1_1_1_5 + 4.166666666666662e-02*G3_1_1_1_6 + 4.166666666666662e-02*G3_1_1_1_7 + 4.166666666666662e-02*G3_2_2_1_4 + 4.166666666666662e-02*G3_2_2_1_5 + 4.166666666666662e-02*G3_2_2_1_6 + 4.166666666666662e-02*G3_2_2_1_7 + 8.333333333333322e-02*G4_1_4_0 + 8.333333333333323e-02*G4_1_4_1 + 8.333333333333323e-02*G4_1_4_2 - 8.333333333333322e-02*G4_1_5_0 - 8.333333333333323e-02*G4_1_6_1 - 8.333333333333323e-02*G4_1_7_2 + 2.083333333333330e-02*G5_0_0_4_0 + 2.083333333333331e-02*G5_0_0_4_1 + 2.083333333333331e-02*G5_0_0_4_2 - 2.083333333333330e-02*G5_0_0_5_0 - 2.083333333333331e-02*G5_0_0_6_1 - 2.083333333333331e-02*G5_0_0_7_2 + 2.083333333333330e-02*G5_1_1_4_0 + 2.083333333333331e-02*G5_1_1_4_1 + 2.083333333333331e-02*G5_1_1_4_2 - 2.083333333333330e-02*G5_1_1_5_0 - 2.083333333333331e-02*G5_1_1_6_1 - 2.083333333333331e-02*G5_1_1_7_2 + 2.083333333333330e-02*G5_2_2_4_0 + 2.083333333333331e-02*G5_2_2_4_1 + 2.083333333333331e-02*G5_2_2_4_2 - 2.083333333333330e-02*G5_2_2_5_0 - 2.083333333333331e-02*G5_2_2_6_1 - 2.083333333333331e-02*G5_2_2_7_2 + 8.333333333333322e-02*G6_0_0_0_1_0_4_0 + 8.333333333333323e-02*G6_0_0_0_1_0_4_1 + 8.333333333333323e-02*G6_0_0_0_1_0_4_2 - 8.333333333333322e-02*G6_0_0_0_1_0_5_0 - 8.333333333333323e-02*G6_0_0_0_1_0_6_1 - 8.333333333333323e-02*G6_0_0_0_1_0_7_2 + 8.333333333333322e-02*G6_0_1_0_1_1_4_0 + 8.333333333333323e-02*G6_0_1_0_1_1_4_1 + 8.333333333333323e-02*G6_0_1_0_1_1_4_2 - 8.333333333333322e-02*G6_0_1_0_1_1_5_0 - 8.333333333333323e-02*G6_0_1_0_1_1_6_1 - 8.333333333333323e-02*G6_0_1_0_1_1_7_2 + 8.333333333333322e-02*G6_0_2_0_1_2_4_0 + 8.333333333333323e-02*G6_0_2_0_1_2_4_1 + 8.333333333333323e-02*G6_0_2_0_1_2_4_2 - 8.333333333333322e-02*G6_0_2_0_1_2_5_0 - 8.333333333333323e-02*G6_0_2_0_1_2_6_1 - 8.333333333333323e-02*G6_0_2_0_1_2_7_2 + 8.333333333333322e-02*G6_1_0_1_1_0_4_0 + 8.333333333333323e-02*G6_1_0_1_1_0_4_1 + 8.333333333333323e-02*G6_1_0_1_1_0_4_2 - 8.333333333333322e-02*G6_1_0_1_1_0_5_0 - 8.333333333333323e-02*G6_1_0_1_1_0_6_1 - 8.333333333333323e-02*G6_1_0_1_1_0_7_2 + 8.333333333333322e-02*G6_1_1_1_1_1_4_0 + 8.333333333333323e-02*G6_1_1_1_1_1_4_1 + 8.333333333333323e-02*G6_1_1_1_1_1_4_2 - 8.333333333333322e-02*G6_1_1_1_1_1_5_0 - 8.333333333333323e-02*G6_1_1_1_1_1_6_1 - 8.333333333333323e-02*G6_1_1_1_1_1_7_2 + 8.333333333333322e-02*G6_1_2_1_1_2_4_0 + 8.333333333333323e-02*G6_1_2_1_1_2_4_1 + 8.333333333333323e-02*G6_1_2_1_1_2_4_2 - 8.333333333333322e-02*G6_1_2_1_1_2_5_0 - 8.333333333333323e-02*G6_1_2_1_1_2_6_1 - 8.333333333333323e-02*G6_1_2_1_1_2_7_2 + 8.333333333333322e-02*G6_2_0_2_1_0_4_0 + 8.333333333333323e-02*G6_2_0_2_1_0_4_1 + 8.333333333333323e-02*G6_2_0_2_1_0_4_2 - 8.333333333333322e-02*G6_2_0_2_1_0_5_0 - 8.333333333333323e-02*G6_2_0_2_1_0_6_1 - 8.333333333333323e-02*G6_2_0_2_1_0_7_2 + 8.333333333333322e-02*G6_2_1_2_1_1_4_0 + 8.333333333333323e-02*G6_2_1_2_1_1_4_1 + 8.333333333333323e-02*G6_2_1_2_1_1_4_2 - 8.333333333333322e-02*G6_2_1_2_1_1_5_0 - 8.333333333333323e-02*G6_2_1_2_1_1_6_1 - 8.333333333333323e-02*G6_2_1_2_1_1_7_2 + 8.333333333333322e-02*G6_2_2_2_1_2_4_0 + 8.333333333333323e-02*G6_2_2_2_1_2_4_1 + 8.333333333333323e-02*G6_2_2_2_1_2_4_2 - 8.333333333333322e-02*G6_2_2_2_1_2_5_0 - 8.333333333333323e-02*G6_2_2_2_1_2_6_1 - 8.333333333333323e-02*G6_2_2_2_1_2_7_2 + 1.666666666666664e-01*G7_1_0_0_1_0_0 + 1.666666666666665e-01*G7_1_0_0_1_0_1 + 1.666666666666665e-01*G7_1_0_0_1_0_2 - 1.666666666666664e-01*G7_1_0_0_1_1_0 - 1.666666666666665e-01*G7_1_0_0_1_2_1 - 1.666666666666665e-01*G7_1_0_0_1_3_2 + 1.666666666666664e-01*G7_1_1_1_1_0_0 + 1.666666666666665e-01*G7_1_1_1_1_0_1 + 1.666666666666665e-01*G7_1_1_1_1_0_2 - 1.666666666666664e-01*G7_1_1_1_1_1_0 - 1.666666666666665e-01*G7_1_1_1_1_2_1 - 1.666666666666665e-01*G7_1_1_1_1_3_2 + 1.666666666666664e-01*G7_1_2_2_1_0_0 + 1.666666666666665e-01*G7_1_2_2_1_0_1 + 1.666666666666665e-01*G7_1_2_2_1_0_2 - 1.666666666666664e-01*G7_1_2_2_1_1_0 - 1.666666666666665e-01*G7_1_2_2_1_2_1 - 1.666666666666665e-01*G7_1_2_2_1_3_2 + 8.333333333333322e-02*G8_1_0_1_0_0 + 8.333333333333323e-02*G8_1_0_1_0_1 + 8.333333333333322e-02*G8_1_0_1_0_2 - 8.333333333333322e-02*G8_1_0_1_1_0 - 8.333333333333323e-02*G8_1_0_1_2_1 - 8.333333333333323e-02*G8_1_0_1_3_2 + 8.333333333333322e-02*G8_1_1_1_4_0 + 8.333333333333323e-02*G8_1_1_1_4_1 + 8.333333333333323e-02*G8_1_1_1_4_2 - 8.333333333333322e-02*G8_1_1_1_5_0 - 8.333333333333323e-02*G8_1_1_1_6_1 - 8.333333333333323e-02*G8_1_1_1_7_2 + 8.333333333333322e-02*G8_1_2_1_8_0 + 8.333333333333323e-02*G8_1_2_1_8_1 + 8.333333333333323e-02*G8_1_2_1_8_2 - 8.333333333333322e-02*G8_1_2_1_9_0 - 8.333333333333323e-02*G8_1_2_1_10_1 - 8.333333333333323e-02*G8_1_2_1_11_2;
    block[7] = 8.333333333333314e-03*G0_4 + 8.333333333333314e-03*G0_5 + 8.333333333333312e-03*G0_6 + 1.666666666666662e-02*G0_7 + 8.333333333333314e-03*G1_4 + 8.333333333333314e-03*G1_5 + 8.333333333333312e-03*G1_6 + 1.666666666666662e-02*G1_7 + 4.166666666666662e-02*G2_1_2_0 + 4.166666666666662e-02*G2_1_2_1 + 4.166666666666662e-02*G2_1_2_2 + 4.166666666666662e-02*G2_1_2_3 + 4.166666666666662e-02*G3_0_0_2_4 + 4.166666666666662e-02*G3_0_0_2_5 + 4.166666666666662e-02*G3_0_0_2_6 + 4.166666666666662e-02*G3_0_0_2_7 + 4.166666666666662e-02*G3_1_1_2_4 + 4.166666666666662e-02*G3_1_1_2_5 + 4.166666666666662e-02*G3_1_1_2_6 + 4.166666666666662e-02*G3_1_1_2_7 + 4.166666666666662e-02*G3_2_2_2_4 + 4.166666666666662e-02*G3_2_2_2_5 + 4.166666666666662e-02*G3_2_2_2_6 + 4.166666666666662e-02*G3_2_2_2_7 + 8.333333333333322e-02*G4_2_4_0 + 8.333333333333323e-02*G4_2_4_1 + 8.333333333333323e-02*G4_2_4_2 - 8.333333333333322e-02*G4_2_5_0 - 8.333333333333323e-02*G4_2_6_1 - 8.333333333333323e-02*G4_2_7_2 + 2.083333333333330e-02*G5_0_0_4_0 + 2.083333333333331e-02*G5_0_0_4_1 + 2.083333333333331e-02*G5_0_0_4_2 - 2.083333333333330e-02*G5_0_0_5_0 - 2.083333333333331e-02*G5_0_0_6_1 - 2.083333333333331e-02*G5_0_0_7_2 + 2.083333333333330e-02*G5_1_1_4_0 + 2.083333333333331e-02*G5_1_1_4_1 + 2.083333333333331e-02*G5_1_1_4_2 - 2.083333333333330e-02*G5_1_1_5_0 - 2.083333333333331e-02*G5_1_1_6_1 - 2.083333333333331e-02*G5_1_1_7_2 + 2.083333333333330e-02*G5_2_2_4_0 + 2.083333333333331e-02*G5_2_2_4_1 + 2.083333333333331e-02*G5_2_2_4_2 - 2.083333333333330e-02*G5_2_2_5_0 - 2.083333333333331e-02*G5_2_2_6_1 - 2.083333333333331e-02*G5_2_2_7_2 + 8.333333333333322e-02*G6_0_0_0_2_0_4_0 + 8.333333333333323e-02*G6_0_0_0_2_0_4_1 + 8.333333333333323e-02*G6_0_0_0_2_0_4_2 - 8.333333333333322e-02*G6_0_0_0_2_0_5_0 - 8.333333333333323e-02*G6_0_0_0_2_0_6_1 - 8.333333333333323e-02*G6_0_0_0_2_0_7_2 + 8.333333333333322e-02*G6_0_1_0_2_1_4_0 + 8.333333333333323e-02*G6_0_1_0_2_1_4_1 + 8.333333333333323e-02*G6_0_1_0_2_1_4_2 - 8.333333333333322e-02*G6_0_1_0_2_1_5_0 - 8.333333333333323e-02*G6_0_1_0_2_1_6_1 - 8.333333333333323e-02*G6_0_1_0_2_1_7_2 + 8.333333333333322e-02*G6_0_2_0_2_2_4_0 + 8.333333333333323e-02*G6_0_2_0_2_2_4_1 + 8.333333333333323e-02*G6_0_2_0_2_2_4_2 - 8.333333333333322e-02*G6_0_2_0_2_2_5_0 - 8.333333333333323e-02*G6_0_2_0_2_2_6_1 - 8.333333333333323e-02*G6_0_2_0_2_2_7_2 + 8.333333333333322e-02*G6_1_0_1_2_0_4_0 + 8.333333333333323e-02*G6_1_0_1_2_0_4_1 + 8.333333333333323e-02*G6_1_0_1_2_0_4_2 - 8.333333333333322e-02*G6_1_0_1_2_0_5_0 - 8.333333333333323e-02*G6_1_0_1_2_0_6_1 - 8.333333333333323e-02*G6_1_0_1_2_0_7_2 + 8.333333333333322e-02*G6_1_1_1_2_1_4_0 + 8.333333333333323e-02*G6_1_1_1_2_1_4_1 + 8.333333333333323e-02*G6_1_1_1_2_1_4_2 - 8.333333333333322e-02*G6_1_1_1_2_1_5_0 - 8.333333333333323e-02*G6_1_1_1_2_1_6_1 - 8.333333333333323e-02*G6_1_1_1_2_1_7_2 + 8.333333333333322e-02*G6_1_2_1_2_2_4_0 + 8.333333333333323e-02*G6_1_2_1_2_2_4_1 + 8.333333333333323e-02*G6_1_2_1_2_2_4_2 - 8.333333333333322e-02*G6_1_2_1_2_2_5_0 - 8.333333333333323e-02*G6_1_2_1_2_2_6_1 - 8.333333333333323e-02*G6_1_2_1_2_2_7_2 + 8.333333333333322e-02*G6_2_0_2_2_0_4_0 + 8.333333333333323e-02*G6_2_0_2_2_0_4_1 + 8.333333333333323e-02*G6_2_0_2_2_0_4_2 - 8.333333333333322e-02*G6_2_0_2_2_0_5_0 - 8.333333333333323e-02*G6_2_0_2_2_0_6_1 - 8.333333333333323e-02*G6_2_0_2_2_0_7_2 + 8.333333333333322e-02*G6_2_1_2_2_1_4_0 + 8.333333333333323e-02*G6_2_1_2_2_1_4_1 + 8.333333333333323e-02*G6_2_1_2_2_1_4_2 - 8.333333333333322e-02*G6_2_1_2_2_1_5_0 - 8.333333333333323e-02*G6_2_1_2_2_1_6_1 - 8.333333333333323e-02*G6_2_1_2_2_1_7_2 + 8.333333333333322e-02*G6_2_2_2_2_2_4_0 + 8.333333333333323e-02*G6_2_2_2_2_2_4_1 + 8.333333333333323e-02*G6_2_2_2_2_2_4_2 - 8.333333333333322e-02*G6_2_2_2_2_2_5_0 - 8.333333333333323e-02*G6_2_2_2_2_2_6_1 - 8.333333333333323e-02*G6_2_2_2_2_2_7_2 + 1.666666666666664e-01*G7_1_0_0_2_0_0 + 1.666666666666665e-01*G7_1_0_0_2_0_1 + 1.666666666666665e-01*G7_1_0_0_2_0_2 - 1.666666666666664e-01*G7_1_0_0_2_1_0 - 1.666666666666665e-01*G7_1_0_0_2_2_1 - 1.666666666666665e-01*G7_1_0_0_2_3_2 + 1.666666666666664e-01*G7_1_1_1_2_0_0 + 1.666666666666665e-01*G7_1_1_1_2_0_1 + 1.666666666666665e-01*G7_1_1_1_2_0_2 - 1.666666666666664e-01*G7_1_1_1_2_1_0 - 1.666666666666665e-01*G7_1_1_1_2_2_1 - 1.666666666666665e-01*G7_1_1_1_2_3_2 + 1.666666666666664e-01*G7_1_2_2_2_0_0 + 1.666666666666665e-01*G7_1_2_2_2_0_1 + 1.666666666666665e-01*G7_1_2_2_2_0_2 - 1.666666666666664e-01*G7_1_2_2_2_1_0 - 1.666666666666665e-01*G7_1_2_2_2_2_1 - 1.666666666666665e-01*G7_1_2_2_2_3_2 + 8.333333333333322e-02*G8_1_0_2_0_0 + 8.333333333333323e-02*G8_1_0_2_0_1 + 8.333333333333322e-02*G8_1_0_2_0_2 - 8.333333333333322e-02*G8_1_0_2_1_0 - 8.333333333333323e-02*G8_1_0_2_2_1 - 8.333333333333323e-02*G8_1_0_2_3_2 + 8.333333333333322e-02*G8_1_1_2_4_0 + 8.333333333333323e-02*G8_1_1_2_4_1 + 8.333333333333323e-02*G8_1_1_2_4_2 - 8.333333333333322e-02*G8_1_1_2_5_0 - 8.333333333333323e-02*G8_1_1_2_6_1 - 8.333333333333323e-02*G8_1_1_2_7_2 + 8.333333333333322e-02*G8_1_2_2_8_0 + 8.333333333333323e-02*G8_1_2_2_8_1 + 8.333333333333323e-02*G8_1_2_2_8_2 - 8.333333333333322e-02*G8_1_2_2_9_0 - 8.333333333333323e-02*G8_1_2_2_10_1 - 8.333333333333323e-02*G8_1_2_2_11_2;
    block[8] = 1.666666666666662e-02*G0_8 + 8.333333333333309e-03*G0_9 + 8.333333333333309e-03*G0_10 + 8.333333333333314e-03*G0_11 + 1.666666666666662e-02*G1_8 + 8.333333333333309e-03*G1_9 + 8.333333333333309e-03*G1_10 + 8.333333333333314e-03*G1_11 - 4.166666666666661e-02*G2_2_0_0 - 4.166666666666661e-02*G2_2_0_1 - 4.166666666666661e-02*G2_2_0_2 - 4.166666666666661e-02*G2_2_0_3 - 4.166666666666662e-02*G2_2_1_0 - 4.166666666666662e-02*G2_2_1_1 - 4.166666666666662e-02*G2_2_1_2 - 4.166666666666662e-02*G2_2_1_3 - 4.166666666666662e-02*G2_2_2_0 - 4.166666666666662e-02*G2_2_2_1 - 4.166666666666662e-02*G2_2_2_2 - 4.166666666666662e-02*G2_2_2_3 - 4.166666666666661e-02*G3_0_0_0_8 - 4.166666666666661e-02*G3_0_0_0_9 - 4.166666666666661e-02*G3_0_0_0_10 - 4.166666666666661e-02*G3_0_0_0_11 - 4.166666666666662e-02*G3_0_0_1_8 - 4.166666666666662e-02*G3_0_0_1_9 - 4.166666666666662e-02*G3_0_0_1_10 - 4.166666666666662e-02*G3_0_0_1_11 - 4.166666666666662e-02*G3_0_0_2_8 - 4.166666666666662e-02*G3_0_0_2_9 - 4.166666666666662e-02*G3_0_0_2_10 - 4.166666666666662e-02*G3_0_0_2_11 - 4.166666666666661e-02*G3_1_1_0_8 - 4.166666666666661e-02*G3_1_1_0_9 - 4.166666666666661e-02*G3_1_1_0_10 - 4.166666666666661e-02*G3_1_1_0_11 - 4.166666666666662e-02*G3_1_1_1_8 - 4.166666666666662e-02*G3_1_1_1_9 - 4.166666666666662e-02*G3_1_1_1_10 - 4.166666666666662e-02*G3_1_1_1_11 - 4.166666666666662e-02*G3_1_1_2_8 - 4.166666666666662e-02*G3_1_1_2_9 - 4.166666666666662e-02*G3_1_1_2_10 - 4.166666666666662e-02*G3_1_1_2_11 - 4.166666666666661e-02*G3_2_2_0_8 - 4.166666666666661e-02*G3_2_2_0_9 - 4.166666666666661e-02*G3_2_2_0_10 - 4.166666666666661e-02*G3_2_2_0_11 - 4.166666666666662e-02*G3_2_2_1_8 - 4.166666666666662e-02*G3_2_2_1_9 - 4.166666666666662e-02*G3_2_2_1_10 - 4.166666666666662e-02*G3_2_2_1_11 - 4.166666666666662e-02*G3_2_2_2_8 - 4.166666666666662e-02*G3_2_2_2_9 - 4.166666666666662e-02*G3_2_2_2_10 - 4.166666666666662e-02*G3_2_2_2_11 - 8.333333333333320e-02*G4_0_8_0 - 8.333333333333322e-02*G4_0_8_1 - 8.333333333333322e-02*G4_0_8_2 + 8.333333333333320e-02*G4_0_9_0 + 8.333333333333322e-02*G4_0_10_1 + 8.333333333333322e-02*G4_0_11_2 - 8.333333333333322e-02*G4_1_8_0 - 8.333333333333323e-02*G4_1_8_1 - 8.333333333333323e-02*G4_1_8_2 + 8.333333333333322e-02*G4_1_9_0 + 8.333333333333323e-02*G4_1_10_1 + 8.333333333333323e-02*G4_1_11_2 - 8.333333333333322e-02*G4_2_8_0 - 8.333333333333323e-02*G4_2_8_1 - 8.333333333333323e-02*G4_2_8_2 + 8.333333333333322e-02*G4_2_9_0 + 8.333333333333323e-02*G4_2_10_1 + 8.333333333333323e-02*G4_2_11_2 + 2.083333333333330e-02*G5_0_0_8_0 + 2.083333333333331e-02*G5_0_0_8_1 + 2.083333333333331e-02*G5_0_0_8_2 - 2.083333333333330e-02*G5_0_0_9_0 - 2.083333333333331e-02*G5_0_0_10_1 - 2.083333333333331e-02*G5_0_0_11_2 + 2.083333333333330e-02*G5_1_1_8_0 + 2.083333333333331e-02*G5_1_1_8_1 + 2.083333333333331e-02*G5_1_1_8_2 - 2.083333333333330e-02*G5_1_1_9_0 - 2.083333333333331e-02*G5_1_1_10_1 - 2.083333333333331e-02*G5_1_1_11_2 + 2.083333333333330e-02*G5_2_2_8_0 + 2.083333333333331e-02*G5_2_2_8_1 + 2.083333333333331e-02*G5_2_2_8_2 - 2.083333333333330e-02*G5_2_2_9_0 - 2.083333333333331e-02*G5_2_2_10_1 - 2.083333333333331e-02*G5_2_2_11_2 - 8.333333333333320e-02*G6_0_0_0_0_0_8_0 - 8.333333333333322e-02*G6_0_0_0_0_0_8_1 - 8.333333333333322e-02*G6_0_0_0_0_0_8_2 + 8.333333333333320e-02*G6_0_0_0_0_0_9_0 + 8.333333333333322e-02*G6_0_0_0_0_0_10_1 + 8.333333333333322e-02*G6_0_0_0_0_0_11_2 - 8.333333333333322e-02*G6_0_0_0_1_0_8_0 - 8.333333333333323e-02*G6_0_0_0_1_0_8_1 - 8.333333333333323e-02*G6_0_0_0_1_0_8_2 + 8.333333333333322e-02*G6_0_0_0_1_0_9_0 + 8.333333333333323e-02*G6_0_0_0_1_0_10_1 + 8.333333333333323e-02*G6_0_0_0_1_0_11_2 - 8.333333333333322e-02*G6_0_0_0_2_0_8_0 - 8.333333333333323e-02*G6_0_0_0_2_0_8_1 - 8.333333333333323e-02*G6_0_0_0_2_0_8_2 + 8.333333333333322e-02*G6_0_0_0_2_0_9_0 + 8.333333333333323e-02*G6_0_0_0_2_0_10_1 + 8.333333333333323e-02*G6_0_0_0_2_0_11_2 - 8.333333333333320e-02*G6_0_1_0_0_1_8_0 - 8.333333333333322e-02*G6_0_1_0_0_1_8_1 - 8.333333333333322e-02*G6_0_1_0_0_1_8_2 + 8.333333333333320e-02*G6_0_1_0_0_1_9_0 + 8.333333333333322e-02*G6_0_1_0_0_1_10_1 + 8.333333333333322e-02*G6_0_1_0_0_1_11_2 - 8.333333333333322e-02*G6_0_1_0_1_1_8_0 - 8.333333333333323e-02*G6_0_1_0_1_1_8_1 - 8.333333333333323e-02*G6_0_1_0_1_1_8_2 + 8.333333333333322e-02*G6_0_1_0_1_1_9_0 + 8.333333333333323e-02*G6_0_1_0_1_1_10_1 + 8.333333333333323e-02*G6_0_1_0_1_1_11_2 - 8.333333333333322e-02*G6_0_1_0_2_1_8_0 - 8.333333333333323e-02*G6_0_1_0_2_1_8_1 - 8.333333333333323e-02*G6_0_1_0_2_1_8_2 + 8.333333333333322e-02*G6_0_1_0_2_1_9_0 + 8.333333333333323e-02*G6_0_1_0_2_1_10_1 + 8.333333333333323e-02*G6_0_1_0_2_1_11_2 - 8.333333333333320e-02*G6_0_2_0_0_2_8_0 - 8.333333333333322e-02*G6_0_2_0_0_2_8_1 - 8.333333333333322e-02*G6_0_2_0_0_2_8_2 + 8.333333333333320e-02*G6_0_2_0_0_2_9_0 + 8.333333333333322e-02*G6_0_2_0_0_2_10_1 + 8.333333333333322e-02*G6_0_2_0_0_2_11_2 - 8.333333333333322e-02*G6_0_2_0_1_2_8_0 - 8.333333333333323e-02*G6_0_2_0_1_2_8_1 - 8.333333333333323e-02*G6_0_2_0_1_2_8_2 + 8.333333333333322e-02*G6_0_2_0_1_2_9_0 + 8.333333333333323e-02*G6_0_2_0_1_2_10_1 + 8.333333333333323e-02*G6_0_2_0_1_2_11_2 - 8.333333333333322e-02*G6_0_2_0_2_2_8_0 - 8.333333333333323e-02*G6_0_2_0_2_2_8_1 - 8.333333333333323e-02*G6_0_2_0_2_2_8_2 + 8.333333333333322e-02*G6_0_2_0_2_2_9_0 + 8.333333333333323e-02*G6_0_2_0_2_2_10_1 + 8.333333333333323e-02*G6_0_2_0_2_2_11_2 - 8.333333333333320e-02*G6_1_0_1_0_0_8_0 - 8.333333333333322e-02*G6_1_0_1_0_0_8_1 - 8.333333333333322e-02*G6_1_0_1_0_0_8_2 + 8.333333333333320e-02*G6_1_0_1_0_0_9_0 + 8.333333333333322e-02*G6_1_0_1_0_0_10_1 + 8.333333333333322e-02*G6_1_0_1_0_0_11_2 - 8.333333333333322e-02*G6_1_0_1_1_0_8_0 - 8.333333333333323e-02*G6_1_0_1_1_0_8_1 - 8.333333333333323e-02*G6_1_0_1_1_0_8_2 + 8.333333333333322e-02*G6_1_0_1_1_0_9_0 + 8.333333333333323e-02*G6_1_0_1_1_0_10_1 + 8.333333333333323e-02*G6_1_0_1_1_0_11_2 - 8.333333333333322e-02*G6_1_0_1_2_0_8_0 - 8.333333333333323e-02*G6_1_0_1_2_0_8_1 - 8.333333333333323e-02*G6_1_0_1_2_0_8_2 + 8.333333333333322e-02*G6_1_0_1_2_0_9_0 + 8.333333333333323e-02*G6_1_0_1_2_0_10_1 + 8.333333333333323e-02*G6_1_0_1_2_0_11_2 - 8.333333333333320e-02*G6_1_1_1_0_1_8_0 - 8.333333333333322e-02*G6_1_1_1_0_1_8_1 - 8.333333333333322e-02*G6_1_1_1_0_1_8_2 + 8.333333333333320e-02*G6_1_1_1_0_1_9_0 + 8.333333333333322e-02*G6_1_1_1_0_1_10_1 + 8.333333333333322e-02*G6_1_1_1_0_1_11_2 - 8.333333333333322e-02*G6_1_1_1_1_1_8_0 - 8.333333333333323e-02*G6_1_1_1_1_1_8_1 - 8.333333333333323e-02*G6_1_1_1_1_1_8_2 + 8.333333333333322e-02*G6_1_1_1_1_1_9_0 + 8.333333333333323e-02*G6_1_1_1_1_1_10_1 + 8.333333333333323e-02*G6_1_1_1_1_1_11_2 - 8.333333333333322e-02*G6_1_1_1_2_1_8_0 - 8.333333333333323e-02*G6_1_1_1_2_1_8_1 - 8.333333333333323e-02*G6_1_1_1_2_1_8_2 + 8.333333333333322e-02*G6_1_1_1_2_1_9_0 + 8.333333333333323e-02*G6_1_1_1_2_1_10_1 + 8.333333333333323e-02*G6_1_1_1_2_1_11_2 - 8.333333333333320e-02*G6_1_2_1_0_2_8_0 - 8.333333333333322e-02*G6_1_2_1_0_2_8_1 - 8.333333333333322e-02*G6_1_2_1_0_2_8_2 + 8.333333333333320e-02*G6_1_2_1_0_2_9_0 + 8.333333333333322e-02*G6_1_2_1_0_2_10_1 + 8.333333333333322e-02*G6_1_2_1_0_2_11_2 - 8.333333333333322e-02*G6_1_2_1_1_2_8_0 - 8.333333333333323e-02*G6_1_2_1_1_2_8_1 - 8.333333333333323e-02*G6_1_2_1_1_2_8_2 + 8.333333333333322e-02*G6_1_2_1_1_2_9_0 + 8.333333333333323e-02*G6_1_2_1_1_2_10_1 + 8.333333333333323e-02*G6_1_2_1_1_2_11_2 - 8.333333333333322e-02*G6_1_2_1_2_2_8_0 - 8.333333333333323e-02*G6_1_2_1_2_2_8_1 - 8.333333333333323e-02*G6_1_2_1_2_2_8_2 + 8.333333333333322e-02*G6_1_2_1_2_2_9_0 + 8.333333333333323e-02*G6_1_2_1_2_2_10_1 + 8.333333333333323e-02*G6_1_2_1_2_2_11_2 - 8.333333333333320e-02*G6_2_0_2_0_0_8_0 - 8.333333333333322e-02*G6_2_0_2_0_0_8_1 - 8.333333333333322e-02*G6_2_0_2_0_0_8_2 + 8.333333333333320e-02*G6_2_0_2_0_0_9_0 + 8.333333333333322e-02*G6_2_0_2_0_0_10_1 + 8.333333333333322e-02*G6_2_0_2_0_0_11_2 - 8.333333333333322e-02*G6_2_0_2_1_0_8_0 - 8.333333333333323e-02*G6_2_0_2_1_0_8_1 - 8.333333333333323e-02*G6_2_0_2_1_0_8_2 + 8.333333333333322e-02*G6_2_0_2_1_0_9_0 + 8.333333333333323e-02*G6_2_0_2_1_0_10_1 + 8.333333333333323e-02*G6_2_0_2_1_0_11_2 - 8.333333333333322e-02*G6_2_0_2_2_0_8_0 - 8.333333333333323e-02*G6_2_0_2_2_0_8_1 - 8.333333333333323e-02*G6_2_0_2_2_0_8_2 + 8.333333333333322e-02*G6_2_0_2_2_0_9_0 + 8.333333333333323e-02*G6_2_0_2_2_0_10_1 + 8.333333333333323e-02*G6_2_0_2_2_0_11_2 - 8.333333333333320e-02*G6_2_1_2_0_1_8_0 - 8.333333333333322e-02*G6_2_1_2_0_1_8_1 - 8.333333333333322e-02*G6_2_1_2_0_1_8_2 + 8.333333333333320e-02*G6_2_1_2_0_1_9_0 + 8.333333333333322e-02*G6_2_1_2_0_1_10_1 + 8.333333333333322e-02*G6_2_1_2_0_1_11_2 - 8.333333333333322e-02*G6_2_1_2_1_1_8_0 - 8.333333333333323e-02*G6_2_1_2_1_1_8_1 - 8.333333333333323e-02*G6_2_1_2_1_1_8_2 + 8.333333333333322e-02*G6_2_1_2_1_1_9_0 + 8.333333333333323e-02*G6_2_1_2_1_1_10_1 + 8.333333333333323e-02*G6_2_1_2_1_1_11_2 - 8.333333333333322e-02*G6_2_1_2_2_1_8_0 - 8.333333333333323e-02*G6_2_1_2_2_1_8_1 - 8.333333333333323e-02*G6_2_1_2_2_1_8_2 + 8.333333333333322e-02*G6_2_1_2_2_1_9_0 + 8.333333333333323e-02*G6_2_1_2_2_1_10_1 + 8.333333333333323e-02*G6_2_1_2_2_1_11_2 - 8.333333333333320e-02*G6_2_2_2_0_2_8_0 - 8.333333333333322e-02*G6_2_2_2_0_2_8_1 - 8.333333333333322e-02*G6_2_2_2_0_2_8_2 + 8.333333333333320e-02*G6_2_2_2_0_2_9_0 + 8.333333333333322e-02*G6_2_2_2_0_2_10_1 + 8.333333333333322e-02*G6_2_2_2_0_2_11_2 - 8.333333333333322e-02*G6_2_2_2_1_2_8_0 - 8.333333333333323e-02*G6_2_2_2_1_2_8_1 - 8.333333333333323e-02*G6_2_2_2_1_2_8_2 + 8.333333333333322e-02*G6_2_2_2_1_2_9_0 + 8.333333333333323e-02*G6_2_2_2_1_2_10_1 + 8.333333333333323e-02*G6_2_2_2_1_2_11_2 - 8.333333333333322e-02*G6_2_2_2_2_2_8_0 - 8.333333333333323e-02*G6_2_2_2_2_2_8_1 - 8.333333333333323e-02*G6_2_2_2_2_2_8_2 + 8.333333333333322e-02*G6_2_2_2_2_2_9_0 + 8.333333333333323e-02*G6_2_2_2_2_2_10_1 + 8.333333333333323e-02*G6_2_2_2_2_2_11_2 - 1.666666666666664e-01*G7_2_0_0_0_0_0 - 1.666666666666664e-01*G7_2_0_0_0_0_1 - 1.666666666666664e-01*G7_2_0_0_0_0_2 + 1.666666666666664e-01*G7_2_0_0_0_1_0 + 1.666666666666664e-01*G7_2_0_0_0_2_1 + 1.666666666666664e-01*G7_2_0_0_0_3_2 - 1.666666666666664e-01*G7_2_0_0_1_0_0 - 1.666666666666665e-01*G7_2_0_0_1_0_1 - 1.666666666666665e-01*G7_2_0_0_1_0_2 + 1.666666666666664e-01*G7_2_0_0_1_1_0 + 1.666666666666665e-01*G7_2_0_0_1_2_1 + 1.666666666666665e-01*G7_2_0_0_1_3_2 - 1.666666666666664e-01*G7_2_0_0_2_0_0 - 1.666666666666665e-01*G7_2_0_0_2_0_1 - 1.666666666666665e-01*G7_2_0_0_2_0_2 + 1.666666666666664e-01*G7_2_0_0_2_1_0 + 1.666666666666665e-01*G7_2_0_0_2_2_1 + 1.666666666666665e-01*G7_2_0_0_2_3_2 - 1.666666666666664e-01*G7_2_1_1_0_0_0 - 1.666666666666664e-01*G7_2_1_1_0_0_1 - 1.666666666666664e-01*G7_2_1_1_0_0_2 + 1.666666666666664e-01*G7_2_1_1_0_1_0 + 1.666666666666664e-01*G7_2_1_1_0_2_1 + 1.666666666666664e-01*G7_2_1_1_0_3_2 - 1.666666666666664e-01*G7_2_1_1_1_0_0 - 1.666666666666665e-01*G7_2_1_1_1_0_1 - 1.666666666666665e-01*G7_2_1_1_1_0_2 + 1.666666666666664e-01*G7_2_1_1_1_1_0 + 1.666666666666665e-01*G7_2_1_1_1_2_1 + 1.666666666666665e-01*G7_2_1_1_1_3_2 - 1.666666666666664e-01*G7_2_1_1_2_0_0 - 1.666666666666665e-01*G7_2_1_1_2_0_1 - 1.666666666666665e-01*G7_2_1_1_2_0_2 + 1.666666666666664e-01*G7_2_1_1_2_1_0 + 1.666666666666665e-01*G7_2_1_1_2_2_1 + 1.666666666666665e-01*G7_2_1_1_2_3_2 - 1.666666666666664e-01*G7_2_2_2_0_0_0 - 1.666666666666664e-01*G7_2_2_2_0_0_1 - 1.666666666666664e-01*G7_2_2_2_0_0_2 + 1.666666666666664e-01*G7_2_2_2_0_1_0 + 1.666666666666664e-01*G7_2_2_2_0_2_1 + 1.666666666666664e-01*G7_2_2_2_0_3_2 - 1.666666666666664e-01*G7_2_2_2_1_0_0 - 1.666666666666665e-01*G7_2_2_2_1_0_1 - 1.666666666666665e-01*G7_2_2_2_1_0_2 + 1.666666666666664e-01*G7_2_2_2_1_1_0 + 1.666666666666665e-01*G7_2_2_2_1_2_1 + 1.666666666666665e-01*G7_2_2_2_1_3_2 - 1.666666666666664e-01*G7_2_2_2_2_0_0 - 1.666666666666665e-01*G7_2_2_2_2_0_1 - 1.666666666666665e-01*G7_2_2_2_2_0_2 + 1.666666666666664e-01*G7_2_2_2_2_1_0 + 1.666666666666665e-01*G7_2_2_2_2_2_1 + 1.666666666666665e-01*G7_2_2_2_2_3_2 - 8.333333333333320e-02*G8_2_0_0_0_0 - 8.333333333333322e-02*G8_2_0_0_0_1 - 8.333333333333320e-02*G8_2_0_0_0_2 + 8.333333333333320e-02*G8_2_0_0_1_0 + 8.333333333333322e-02*G8_2_0_0_2_1 + 8.333333333333322e-02*G8_2_0_0_3_2 - 8.333333333333322e-02*G8_2_0_1_0_0 - 8.333333333333323e-02*G8_2_0_1_0_1 - 8.333333333333322e-02*G8_2_0_1_0_2 + 8.333333333333322e-02*G8_2_0_1_1_0 + 8.333333333333323e-02*G8_2_0_1_2_1 + 8.333333333333323e-02*G8_2_0_1_3_2 - 8.333333333333322e-02*G8_2_0_2_0_0 - 8.333333333333323e-02*G8_2_0_2_0_1 - 8.333333333333322e-02*G8_2_0_2_0_2 + 8.333333333333322e-02*G8_2_0_2_1_0 + 8.333333333333323e-02*G8_2_0_2_2_1 + 8.333333333333323e-02*G8_2_0_2_3_2 - 8.333333333333320e-02*G8_2_1_0_4_0 - 8.333333333333322e-02*G8_2_1_0_4_1 - 8.333333333333322e-02*G8_2_1_0_4_2 + 8.333333333333320e-02*G8_2_1_0_5_0 + 8.333333333333322e-02*G8_2_1_0_6_1 + 8.333333333333322e-02*G8_2_1_0_7_2 - 8.333333333333322e-02*G8_2_1_1_4_0 - 8.333333333333323e-02*G8_2_1_1_4_1 - 8.333333333333323e-02*G8_2_1_1_4_2 + 8.333333333333322e-02*G8_2_1_1_5_0 + 8.333333333333323e-02*G8_2_1_1_6_1 + 8.333333333333323e-02*G8_2_1_1_7_2 - 8.333333333333322e-02*G8_2_1_2_4_0 - 8.333333333333323e-02*G8_2_1_2_4_1 - 8.333333333333323e-02*G8_2_1_2_4_2 + 8.333333333333322e-02*G8_2_1_2_5_0 + 8.333333333333323e-02*G8_2_1_2_6_1 + 8.333333333333323e-02*G8_2_1_2_7_2 - 8.333333333333320e-02*G8_2_2_0_8_0 - 8.333333333333322e-02*G8_2_2_0_8_1 - 8.333333333333322e-02*G8_2_2_0_8_2 + 8.333333333333320e-02*G8_2_2_0_9_0 + 8.333333333333322e-02*G8_2_2_0_10_1 + 8.333333333333322e-02*G8_2_2_0_11_2 - 8.333333333333322e-02*G8_2_2_1_8_0 - 8.333333333333323e-02*G8_2_2_1_8_1 - 8.333333333333323e-02*G8_2_2_1_8_2 + 8.333333333333322e-02*G8_2_2_1_9_0 + 8.333333333333323e-02*G8_2_2_1_10_1 + 8.333333333333323e-02*G8_2_2_1_11_2 - 8.333333333333322e-02*G8_2_2_2_8_0 - 8.333333333333323e-02*G8_2_2_2_8_1 - 8.333333333333323e-02*G8_2_2_2_8_2 + 8.333333333333322e-02*G8_2_2_2_9_0 + 8.333333333333323e-02*G8_2_2_2_10_1 + 8.333333333333323e-02*G8_2_2_2_11_2;
    block[9] = 8.333333333333309e-03*G0_8 + 1.666666666666662e-02*G0_9 + 8.333333333333312e-03*G0_10 + 8.333333333333314e-03*G0_11 + 8.333333333333309e-03*G1_8 + 1.666666666666662e-02*G1_9 + 8.333333333333312e-03*G1_10 + 8.333333333333314e-03*G1_11 + 4.166666666666661e-02*G2_2_0_0 + 4.166666666666661e-02*G2_2_0_1 + 4.166666666666661e-02*G2_2_0_2 + 4.166666666666661e-02*G2_2_0_3 + 4.166666666666661e-02*G3_0_0_0_8 + 4.166666666666661e-02*G3_0_0_0_9 + 4.166666666666661e-02*G3_0_0_0_10 + 4.166666666666661e-02*G3_0_0_0_11 + 4.166666666666661e-02*G3_1_1_0_8 + 4.166666666666661e-02*G3_1_1_0_9 + 4.166666666666661e-02*G3_1_1_0_10 + 4.166666666666661e-02*G3_1_1_0_11 + 4.166666666666661e-02*G3_2_2_0_8 + 4.166666666666661e-02*G3_2_2_0_9 + 4.166666666666661e-02*G3_2_2_0_10 + 4.166666666666661e-02*G3_2_2_0_11 + 8.333333333333320e-02*G4_0_8_0 + 8.333333333333322e-02*G4_0_8_1 + 8.333333333333322e-02*G4_0_8_2 - 8.333333333333320e-02*G4_0_9_0 - 8.333333333333322e-02*G4_0_10_1 - 8.333333333333322e-02*G4_0_11_2 + 2.083333333333330e-02*G5_0_0_8_0 + 2.083333333333331e-02*G5_0_0_8_1 + 2.083333333333331e-02*G5_0_0_8_2 - 2.083333333333330e-02*G5_0_0_9_0 - 2.083333333333331e-02*G5_0_0_10_1 - 2.083333333333331e-02*G5_0_0_11_2 + 2.083333333333330e-02*G5_1_1_8_0 + 2.083333333333331e-02*G5_1_1_8_1 + 2.083333333333331e-02*G5_1_1_8_2 - 2.083333333333330e-02*G5_1_1_9_0 - 2.083333333333331e-02*G5_1_1_10_1 - 2.083333333333331e-02*G5_1_1_11_2 + 2.083333333333330e-02*G5_2_2_8_0 + 2.083333333333331e-02*G5_2_2_8_1 + 2.083333333333331e-02*G5_2_2_8_2 - 2.083333333333330e-02*G5_2_2_9_0 - 2.083333333333331e-02*G5_2_2_10_1 - 2.083333333333331e-02*G5_2_2_11_2 + 8.333333333333320e-02*G6_0_0_0_0_0_8_0 + 8.333333333333322e-02*G6_0_0_0_0_0_8_1 + 8.333333333333322e-02*G6_0_0_0_0_0_8_2 - 8.333333333333320e-02*G6_0_0_0_0_0_9_0 - 8.333333333333322e-02*G6_0_0_0_0_0_10_1 - 8.333333333333322e-02*G6_0_0_0_0_0_11_2 + 8.333333333333320e-02*G6_0_1_0_0_1_8_0 + 8.333333333333322e-02*G6_0_1_0_0_1_8_1 + 8.333333333333322e-02*G6_0_1_0_0_1_8_2 - 8.333333333333320e-02*G6_0_1_0_0_1_9_0 - 8.333333333333322e-02*G6_0_1_0_0_1_10_1 - 8.333333333333322e-02*G6_0_1_0_0_1_11_2 + 8.333333333333320e-02*G6_0_2_0_0_2_8_0 + 8.333333333333322e-02*G6_0_2_0_0_2_8_1 + 8.333333333333322e-02*G6_0_2_0_0_2_8_2 - 8.333333333333320e-02*G6_0_2_0_0_2_9_0 - 8.333333333333322e-02*G6_0_2_0_0_2_10_1 - 8.333333333333322e-02*G6_0_2_0_0_2_11_2 + 8.333333333333320e-02*G6_1_0_1_0_0_8_0 + 8.333333333333322e-02*G6_1_0_1_0_0_8_1 + 8.333333333333322e-02*G6_1_0_1_0_0_8_2 - 8.333333333333320e-02*G6_1_0_1_0_0_9_0 - 8.333333333333322e-02*G6_1_0_1_0_0_10_1 - 8.333333333333322e-02*G6_1_0_1_0_0_11_2 + 8.333333333333320e-02*G6_1_1_1_0_1_8_0 + 8.333333333333322e-02*G6_1_1_1_0_1_8_1 + 8.333333333333322e-02*G6_1_1_1_0_1_8_2 - 8.333333333333320e-02*G6_1_1_1_0_1_9_0 - 8.333333333333322e-02*G6_1_1_1_0_1_10_1 - 8.333333333333322e-02*G6_1_1_1_0_1_11_2 + 8.333333333333320e-02*G6_1_2_1_0_2_8_0 + 8.333333333333322e-02*G6_1_2_1_0_2_8_1 + 8.333333333333322e-02*G6_1_2_1_0_2_8_2 - 8.333333333333320e-02*G6_1_2_1_0_2_9_0 - 8.333333333333322e-02*G6_1_2_1_0_2_10_1 - 8.333333333333322e-02*G6_1_2_1_0_2_11_2 + 8.333333333333320e-02*G6_2_0_2_0_0_8_0 + 8.333333333333322e-02*G6_2_0_2_0_0_8_1 + 8.333333333333322e-02*G6_2_0_2_0_0_8_2 - 8.333333333333320e-02*G6_2_0_2_0_0_9_0 - 8.333333333333322e-02*G6_2_0_2_0_0_10_1 - 8.333333333333322e-02*G6_2_0_2_0_0_11_2 + 8.333333333333320e-02*G6_2_1_2_0_1_8_0 + 8.333333333333322e-02*G6_2_1_2_0_1_8_1 + 8.333333333333322e-02*G6_2_1_2_0_1_8_2 - 8.333333333333320e-02*G6_2_1_2_0_1_9_0 - 8.333333333333322e-02*G6_2_1_2_0_1_10_1 - 8.333333333333322e-02*G6_2_1_2_0_1_11_2 + 8.333333333333320e-02*G6_2_2_2_0_2_8_0 + 8.333333333333322e-02*G6_2_2_2_0_2_8_1 + 8.333333333333322e-02*G6_2_2_2_0_2_8_2 - 8.333333333333320e-02*G6_2_2_2_0_2_9_0 - 8.333333333333322e-02*G6_2_2_2_0_2_10_1 - 8.333333333333322e-02*G6_2_2_2_0_2_11_2 + 1.666666666666664e-01*G7_2_0_0_0_0_0 + 1.666666666666664e-01*G7_2_0_0_0_0_1 + 1.666666666666664e-01*G7_2_0_0_0_0_2 - 1.666666666666664e-01*G7_2_0_0_0_1_0 - 1.666666666666664e-01*G7_2_0_0_0_2_1 - 1.666666666666664e-01*G7_2_0_0_0_3_2 + 1.666666666666664e-01*G7_2_1_1_0_0_0 + 1.666666666666664e-01*G7_2_1_1_0_0_1 + 1.666666666666664e-01*G7_2_1_1_0_0_2 - 1.666666666666664e-01*G7_2_1_1_0_1_0 - 1.666666666666664e-01*G7_2_1_1_0_2_1 - 1.666666666666664e-01*G7_2_1_1_0_3_2 + 1.666666666666664e-01*G7_2_2_2_0_0_0 + 1.666666666666664e-01*G7_2_2_2_0_0_1 + 1.666666666666664e-01*G7_2_2_2_0_0_2 - 1.666666666666664e-01*G7_2_2_2_0_1_0 - 1.666666666666664e-01*G7_2_2_2_0_2_1 - 1.666666666666664e-01*G7_2_2_2_0_3_2 + 8.333333333333320e-02*G8_2_0_0_0_0 + 8.333333333333322e-02*G8_2_0_0_0_1 + 8.333333333333320e-02*G8_2_0_0_0_2 - 8.333333333333320e-02*G8_2_0_0_1_0 - 8.333333333333322e-02*G8_2_0_0_2_1 - 8.333333333333322e-02*G8_2_0_0_3_2 + 8.333333333333320e-02*G8_2_1_0_4_0 + 8.333333333333322e-02*G8_2_1_0_4_1 + 8.333333333333322e-02*G8_2_1_0_4_2 - 8.333333333333320e-02*G8_2_1_0_5_0 - 8.333333333333322e-02*G8_2_1_0_6_1 - 8.333333333333322e-02*G8_2_1_0_7_2 + 8.333333333333320e-02*G8_2_2_0_8_0 + 8.333333333333322e-02*G8_2_2_0_8_1 + 8.333333333333322e-02*G8_2_2_0_8_2 - 8.333333333333320e-02*G8_2_2_0_9_0 - 8.333333333333322e-02*G8_2_2_0_10_1 - 8.333333333333322e-02*G8_2_2_0_11_2;
    block[10] = 8.333333333333307e-03*G0_8 + 8.333333333333312e-03*G0_9 + 1.666666666666662e-02*G0_10 + 8.333333333333312e-03*G0_11 + 8.333333333333307e-03*G1_8 + 8.333333333333312e-03*G1_9 + 1.666666666666662e-02*G1_10 + 8.333333333333312e-03*G1_11 + 4.166666666666662e-02*G2_2_1_0 + 4.166666666666662e-02*G2_2_1_1 + 4.166666666666662e-02*G2_2_1_2 + 4.166666666666662e-02*G2_2_1_3 + 4.166666666666662e-02*G3_0_0_1_8 + 4.166666666666662e-02*G3_0_0_1_9 + 4.166666666666662e-02*G3_0_0_1_10 + 4.166666666666662e-02*G3_0_0_1_11 + 4.166666666666662e-02*G3_1_1_1_8 + 4.166666666666662e-02*G3_1_1_1_9 + 4.166666666666662e-02*G3_1_1_1_10 + 4.166666666666662e-02*G3_1_1_1_11 + 4.166666666666662e-02*G3_2_2_1_8 + 4.166666666666662e-02*G3_2_2_1_9 + 4.166666666666662e-02*G3_2_2_1_10 + 4.166666666666662e-02*G3_2_2_1_11 + 8.333333333333322e-02*G4_1_8_0 + 8.333333333333323e-02*G4_1_8_1 + 8.333333333333323e-02*G4_1_8_2 - 8.333333333333322e-02*G4_1_9_0 - 8.333333333333323e-02*G4_1_10_1 - 8.333333333333323e-02*G4_1_11_2 + 2.083333333333330e-02*G5_0_0_8_0 + 2.083333333333331e-02*G5_0_0_8_1 + 2.083333333333331e-02*G5_0_0_8_2 - 2.083333333333330e-02*G5_0_0_9_0 - 2.083333333333331e-02*G5_0_0_10_1 - 2.083333333333331e-02*G5_0_0_11_2 + 2.083333333333330e-02*G5_1_1_8_0 + 2.083333333333331e-02*G5_1_1_8_1 + 2.083333333333331e-02*G5_1_1_8_2 - 2.083333333333330e-02*G5_1_1_9_0 - 2.083333333333331e-02*G5_1_1_10_1 - 2.083333333333331e-02*G5_1_1_11_2 + 2.083333333333330e-02*G5_2_2_8_0 + 2.083333333333331e-02*G5_2_2_8_1 + 2.083333333333331e-02*G5_2_2_8_2 - 2.083333333333330e-02*G5_2_2_9_0 - 2.083333333333331e-02*G5_2_2_10_1 - 2.083333333333331e-02*G5_2_2_11_2 + 8.333333333333322e-02*G6_0_0_0_1_0_8_0 + 8.333333333333323e-02*G6_0_0_0_1_0_8_1 + 8.333333333333323e-02*G6_0_0_0_1_0_8_2 - 8.333333333333322e-02*G6_0_0_0_1_0_9_0 - 8.333333333333323e-02*G6_0_0_0_1_0_10_1 - 8.333333333333323e-02*G6_0_0_0_1_0_11_2 + 8.333333333333322e-02*G6_0_1_0_1_1_8_0 + 8.333333333333323e-02*G6_0_1_0_1_1_8_1 + 8.333333333333323e-02*G6_0_1_0_1_1_8_2 - 8.333333333333322e-02*G6_0_1_0_1_1_9_0 - 8.333333333333323e-02*G6_0_1_0_1_1_10_1 - 8.333333333333323e-02*G6_0_1_0_1_1_11_2 + 8.333333333333322e-02*G6_0_2_0_1_2_8_0 + 8.333333333333323e-02*G6_0_2_0_1_2_8_1 + 8.333333333333323e-02*G6_0_2_0_1_2_8_2 - 8.333333333333322e-02*G6_0_2_0_1_2_9_0 - 8.333333333333323e-02*G6_0_2_0_1_2_10_1 - 8.333333333333323e-02*G6_0_2_0_1_2_11_2 + 8.333333333333322e-02*G6_1_0_1_1_0_8_0 + 8.333333333333323e-02*G6_1_0_1_1_0_8_1 + 8.333333333333323e-02*G6_1_0_1_1_0_8_2 - 8.333333333333322e-02*G6_1_0_1_1_0_9_0 - 8.333333333333323e-02*G6_1_0_1_1_0_10_1 - 8.333333333333323e-02*G6_1_0_1_1_0_11_2 + 8.333333333333322e-02*G6_1_1_1_1_1_8_0 + 8.333333333333323e-02*G6_1_1_1_1_1_8_1 + 8.333333333333323e-02*G6_1_1_1_1_1_8_2 - 8.333333333333322e-02*G6_1_1_1_1_1_9_0 - 8.333333333333323e-02*G6_1_1_1_1_1_10_1 - 8.333333333333323e-02*G6_1_1_1_1_1_11_2 + 8.333333333333322e-02*G6_1_2_1_1_2_8_0 + 8.333333333333323e-02*G6_1_2_1_1_2_8_1 + 8.333333333333323e-02*G6_1_2_1_1_2_8_2 - 8.333333333333322e-02*G6_1_2_1_1_2_9_0 - 8.333333333333323e-02*G6_1_2_1_1_2_10_1 - 8.333333333333323e-02*G6_1_2_1_1_2_11_2 + 8.333333333333322e-02*G6_2_0_2_1_0_8_0 + 8.333333333333323e-02*G6_2_0_2_1_0_8_1 + 8.333333333333323e-02*G6_2_0_2_1_0_8_2 - 8.333333333333322e-02*G6_2_0_2_1_0_9_0 - 8.333333333333323e-02*G6_2_0_2_1_0_10_1 - 8.333333333333323e-02*G6_2_0_2_1_0_11_2 + 8.333333333333322e-02*G6_2_1_2_1_1_8_0 + 8.333333333333323e-02*G6_2_1_2_1_1_8_1 + 8.333333333333323e-02*G6_2_1_2_1_1_8_2 - 8.333333333333322e-02*G6_2_1_2_1_1_9_0 - 8.333333333333323e-02*G6_2_1_2_1_1_10_1 - 8.333333333333323e-02*G6_2_1_2_1_1_11_2 + 8.333333333333322e-02*G6_2_2_2_1_2_8_0 + 8.333333333333323e-02*G6_2_2_2_1_2_8_1 + 8.333333333333323e-02*G6_2_2_2_1_2_8_2 - 8.333333333333322e-02*G6_2_2_2_1_2_9_0 - 8.333333333333323e-02*G6_2_2_2_1_2_10_1 - 8.333333333333323e-02*G6_2_2_2_1_2_11_2 + 1.666666666666664e-01*G7_2_0_0_1_0_0 + 1.666666666666665e-01*G7_2_0_0_1_0_1 + 1.666666666666665e-01*G7_2_0_0_1_0_2 - 1.666666666666664e-01*G7_2_0_0_1_1_0 - 1.666666666666665e-01*G7_2_0_0_1_2_1 - 1.666666666666665e-01*G7_2_0_0_1_3_2 + 1.666666666666664e-01*G7_2_1_1_1_0_0 + 1.666666666666665e-01*G7_2_1_1_1_0_1 + 1.666666666666665e-01*G7_2_1_1_1_0_2 - 1.666666666666664e-01*G7_2_1_1_1_1_0 - 1.666666666666665e-01*G7_2_1_1_1_2_1 - 1.666666666666665e-01*G7_2_1_1_1_3_2 + 1.666666666666664e-01*G7_2_2_2_1_0_0 + 1.666666666666665e-01*G7_2_2_2_1_0_1 + 1.666666666666665e-01*G7_2_2_2_1_0_2 - 1.666666666666664e-01*G7_2_2_2_1_1_0 - 1.666666666666665e-01*G7_2_2_2_1_2_1 - 1.666666666666665e-01*G7_2_2_2_1_3_2 + 8.333333333333322e-02*G8_2_0_1_0_0 + 8.333333333333323e-02*G8_2_0_1_0_1 + 8.333333333333322e-02*G8_2_0_1_0_2 - 8.333333333333322e-02*G8_2_0_1_1_0 - 8.333333333333323e-02*G8_2_0_1_2_1 - 8.333333333333323e-02*G8_2_0_1_3_2 + 8.333333333333322e-02*G8_2_1_1_4_0 + 8.333333333333323e-02*G8_2_1_1_4_1 + 8.333333333333323e-02*G8_2_1_1_4_2 - 8.333333333333322e-02*G8_2_1_1_5_0 - 8.333333333333323e-02*G8_2_1_1_6_1 - 8.333333333333323e-02*G8_2_1_1_7_2 + 8.333333333333322e-02*G8_2_2_1_8_0 + 8.333333333333323e-02*G8_2_2_1_8_1 + 8.333333333333323e-02*G8_2_2_1_8_2 - 8.333333333333322e-02*G8_2_2_1_9_0 - 8.333333333333323e-02*G8_2_2_1_10_1 - 8.333333333333323e-02*G8_2_2_1_11_2;
    block[11] = 8.333333333333314e-03*G0_8 + 8.333333333333314e-03*G0_9 + 8.333333333333312e-03*G0_10 + 1.666666666666662e-02*G0_11 + 8.333333333333314e-03*G1_8 + 8.333333333333314e-03*G1_9 + 8.333333333333312e-03*G1_10 + 1.666666666666662e-02*G1_11 + 4.166666666666662e-02*G2_2_2_0 + 4.166666666666662e-02*G2_2_2_1 + 4.166666666666662e-02*G2_2_2_2 + 4.166666666666662e-02*G2_2_2_3 + 4.166666666666662e-02*G3_0_0_2_8 + 4.166666666666662e-02*G3_0_0_2_9 + 4.166666666666662e-02*G3_0_0_2_10 + 4.166666666666662e-02*G3_0_0_2_11 + 4.166666666666662e-02*G3_1_1_2_8 + 4.166666666666662e-02*G3_1_1_2_9 + 4.166666666666662e-02*G3_1_1_2_10 + 4.166666666666662e-02*G3_1_1_2_11 + 4.166666666666662e-02*G3_2_2_2_8 + 4.166666666666662e-02*G3_2_2_2_9 + 4.166666666666662e-02*G3_2_2_2_10 + 4.166666666666662e-02*G3_2_2_2_11 + 8.333333333333322e-02*G4_2_8_0 + 8.333333333333323e-02*G4_2_8_1 + 8.333333333333323e-02*G4_2_8_2 - 8.333333333333322e-02*G4_2_9_0 - 8.333333333333323e-02*G4_2_10_1 - 8.333333333333323e-02*G4_2_11_2 + 2.083333333333330e-02*G5_0_0_8_0 + 2.083333333333331e-02*G5_0_0_8_1 + 2.083333333333331e-02*G5_0_0_8_2 - 2.083333333333330e-02*G5_0_0_9_0 - 2.083333333333331e-02*G5_0_0_10_1 - 2.083333333333331e-02*G5_0_0_11_2 + 2.083333333333330e-02*G5_1_1_8_0 + 2.083333333333331e-02*G5_1_1_8_1 + 2.083333333333331e-02*G5_1_1_8_2 - 2.083333333333330e-02*G5_1_1_9_0 - 2.083333333333331e-02*G5_1_1_10_1 - 2.083333333333331e-02*G5_1_1_11_2 + 2.083333333333330e-02*G5_2_2_8_0 + 2.083333333333331e-02*G5_2_2_8_1 + 2.083333333333331e-02*G5_2_2_8_2 - 2.083333333333330e-02*G5_2_2_9_0 - 2.083333333333331e-02*G5_2_2_10_1 - 2.083333333333331e-02*G5_2_2_11_2 + 8.333333333333322e-02*G6_0_0_0_2_0_8_0 + 8.333333333333323e-02*G6_0_0_0_2_0_8_1 + 8.333333333333323e-02*G6_0_0_0_2_0_8_2 - 8.333333333333322e-02*G6_0_0_0_2_0_9_0 - 8.333333333333323e-02*G6_0_0_0_2_0_10_1 - 8.333333333333323e-02*G6_0_0_0_2_0_11_2 + 8.333333333333322e-02*G6_0_1_0_2_1_8_0 + 8.333333333333323e-02*G6_0_1_0_2_1_8_1 + 8.333333333333323e-02*G6_0_1_0_2_1_8_2 - 8.333333333333322e-02*G6_0_1_0_2_1_9_0 - 8.333333333333323e-02*G6_0_1_0_2_1_10_1 - 8.333333333333323e-02*G6_0_1_0_2_1_11_2 + 8.333333333333322e-02*G6_0_2_0_2_2_8_0 + 8.333333333333323e-02*G6_0_2_0_2_2_8_1 + 8.333333333333323e-02*G6_0_2_0_2_2_8_2 - 8.333333333333322e-02*G6_0_2_0_2_2_9_0 - 8.333333333333323e-02*G6_0_2_0_2_2_10_1 - 8.333333333333323e-02*G6_0_2_0_2_2_11_2 + 8.333333333333322e-02*G6_1_0_1_2_0_8_0 + 8.333333333333323e-02*G6_1_0_1_2_0_8_1 + 8.333333333333323e-02*G6_1_0_1_2_0_8_2 - 8.333333333333322e-02*G6_1_0_1_2_0_9_0 - 8.333333333333323e-02*G6_1_0_1_2_0_10_1 - 8.333333333333323e-02*G6_1_0_1_2_0_11_2 + 8.333333333333322e-02*G6_1_1_1_2_1_8_0 + 8.333333333333323e-02*G6_1_1_1_2_1_8_1 + 8.333333333333323e-02*G6_1_1_1_2_1_8_2 - 8.333333333333322e-02*G6_1_1_1_2_1_9_0 - 8.333333333333323e-02*G6_1_1_1_2_1_10_1 - 8.333333333333323e-02*G6_1_1_1_2_1_11_2 + 8.333333333333322e-02*G6_1_2_1_2_2_8_0 + 8.333333333333323e-02*G6_1_2_1_2_2_8_1 + 8.333333333333323e-02*G6_1_2_1_2_2_8_2 - 8.333333333333322e-02*G6_1_2_1_2_2_9_0 - 8.333333333333323e-02*G6_1_2_1_2_2_10_1 - 8.333333333333323e-02*G6_1_2_1_2_2_11_2 + 8.333333333333322e-02*G6_2_0_2_2_0_8_0 + 8.333333333333323e-02*G6_2_0_2_2_0_8_1 + 8.333333333333323e-02*G6_2_0_2_2_0_8_2 - 8.333333333333322e-02*G6_2_0_2_2_0_9_0 - 8.333333333333323e-02*G6_2_0_2_2_0_10_1 - 8.333333333333323e-02*G6_2_0_2_2_0_11_2 + 8.333333333333322e-02*G6_2_1_2_2_1_8_0 + 8.333333333333323e-02*G6_2_1_2_2_1_8_1 + 8.333333333333323e-02*G6_2_1_2_2_1_8_2 - 8.333333333333322e-02*G6_2_1_2_2_1_9_0 - 8.333333333333323e-02*G6_2_1_2_2_1_10_1 - 8.333333333333323e-02*G6_2_1_2_2_1_11_2 + 8.333333333333322e-02*G6_2_2_2_2_2_8_0 + 8.333333333333323e-02*G6_2_2_2_2_2_8_1 + 8.333333333333323e-02*G6_2_2_2_2_2_8_2 - 8.333333333333322e-02*G6_2_2_2_2_2_9_0 - 8.333333333333323e-02*G6_2_2_2_2_2_10_1 - 8.333333333333323e-02*G6_2_2_2_2_2_11_2 + 1.666666666666664e-01*G7_2_0_0_2_0_0 + 1.666666666666665e-01*G7_2_0_0_2_0_1 + 1.666666666666665e-01*G7_2_0_0_2_0_2 - 1.666666666666664e-01*G7_2_0_0_2_1_0 - 1.666666666666665e-01*G7_2_0_0_2_2_1 - 1.666666666666665e-01*G7_2_0_0_2_3_2 + 1.666666666666664e-01*G7_2_1_1_2_0_0 + 1.666666666666665e-01*G7_2_1_1_2_0_1 + 1.666666666666665e-01*G7_2_1_1_2_0_2 - 1.666666666666664e-01*G7_2_1_1_2_1_0 - 1.666666666666665e-01*G7_2_1_1_2_2_1 - 1.666666666666665e-01*G7_2_1_1_2_3_2 + 1.666666666666664e-01*G7_2_2_2_2_0_0 + 1.666666666666665e-01*G7_2_2_2_2_0_1 + 1.666666666666665e-01*G7_2_2_2_2_0_2 - 1.666666666666664e-01*G7_2_2_2_2_1_0 - 1.666666666666665e-01*G7_2_2_2_2_2_1 - 1.666666666666665e-01*G7_2_2_2_2_3_2 + 8.333333333333322e-02*G8_2_0_2_0_0 + 8.333333333333323e-02*G8_2_0_2_0_1 + 8.333333333333322e-02*G8_2_0_2_0_2 - 8.333333333333322e-02*G8_2_0_2_1_0 - 8.333333333333323e-02*G8_2_0_2_2_1 - 8.333333333333323e-02*G8_2_0_2_3_2 + 8.333333333333322e-02*G8_2_1_2_4_0 + 8.333333333333323e-02*G8_2_1_2_4_1 + 8.333333333333323e-02*G8_2_1_2_4_2 - 8.333333333333322e-02*G8_2_1_2_5_0 - 8.333333333333323e-02*G8_2_1_2_6_1 - 8.333333333333323e-02*G8_2_1_2_7_2 + 8.333333333333322e-02*G8_2_2_2_8_0 + 8.333333333333323e-02*G8_2_2_2_8_1 + 8.333333333333323e-02*G8_2_2_2_8_2 - 8.333333333333322e-02*G8_2_2_2_9_0 - 8.333333333333323e-02*G8_2_2_2_10_1 - 8.333333333333323e-02*G8_2_2_2_11_2;

  }
        
private:

  const real& c0;  const real& c1;  const real& c2;  const real& c3;

};

} }

#endif
